# tca.system_management.ActiveDirectoryConfigurationApi

All URIs are relative to **

Method | HTTP request | Description
------------- | ------------- | -------------
[**api_admin_global_config_appliance_mgmt_ad_get**](ActiveDirectoryConfigurationApi.md#api_admin_global_config_appliance_mgmt_ad_get) | **GET** /api/admin/global/config/applianceMgmtAD | Get Active Directory Configuration for TCA Appliance Management.
[**api_admin_global_config_appliance_mgmt_ad_post**](ActiveDirectoryConfigurationApi.md#api_admin_global_config_appliance_mgmt_ad_post) | **POST** /api/admin/global/config/applianceMgmtAD | Create Active Directory Configuration for TCA Appliance Management.
[**api_admin_global_config_appliance_mgmt_ad_uuid_put**](ActiveDirectoryConfigurationApi.md#api_admin_global_config_appliance_mgmt_ad_uuid_put) | **PUT** /api/admin/global/config/applianceMgmtAD/{uuid} | Modify Active Directory Configuration for TCA Appliance Management.
[**api_admin_global_config_orchestration_ad_get**](ActiveDirectoryConfigurationApi.md#api_admin_global_config_orchestration_ad_get) | **GET** /api/admin/global/config/orchestrationAD | Get Active Directory Configuration for TCA.
[**api_admin_global_config_orchestration_ad_post**](ActiveDirectoryConfigurationApi.md#api_admin_global_config_orchestration_ad_post) | **POST** /api/admin/global/config/orchestrationAD | Create Active Directory Configuration for TCA.
[**api_admin_global_config_orchestration_ad_uuid_put**](ActiveDirectoryConfigurationApi.md#api_admin_global_config_orchestration_ad_uuid_put) | **PUT** /api/admin/global/config/orchestrationAD/{uuid} | Modify Active Directory Configuration for TCA.

# **api_admin_global_config_appliance_mgmt_ad_get**
> ADDetailsResponse api_admin_global_config_appliance_mgmt_ad_get(accept)

Get Active Directory Configuration for TCA Appliance Management.

API to get Active Directory Configuration for TCA Appliance Management. This Active Directory configuration will be used to authentication users for configuring TCA Manager Appliance.

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.ActiveDirectoryConfigurationApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | The only supported Accept type is 'application/json' (default to application/json)

try:
    # Get Active Directory Configuration for TCA Appliance Management.
    api_response = api_instance.api_admin_global_config_appliance_mgmt_ad_get(accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ActiveDirectoryConfigurationApi->api_admin_global_config_appliance_mgmt_ad_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| The only supported Accept type is &#x27;application/json&#x27; | [default to application/json]

### Return type

[**ADDetailsResponse**](ADDetailsResponse.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_global_config_appliance_mgmt_ad_post**
> ADDetailsResponse api_admin_global_config_appliance_mgmt_ad_post(body, accept, content_type)

Create Active Directory Configuration for TCA Appliance Management.

API to add Active Directory Configuration for TCA Appliance Management. This Active Directory configuration will be used to authentication users for configuring TCA Manager Appliance.

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.ActiveDirectoryConfigurationApi(tca.system_management.ApiClient(configuration))
body = tca.system_management.ADDetailsRequest() # ADDetailsRequest | 
accept = 'application/json' # str | The only supported Accept type is 'application/json' (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Create Active Directory Configuration for TCA Appliance Management.
    api_response = api_instance.api_admin_global_config_appliance_mgmt_ad_post(body, accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ActiveDirectoryConfigurationApi->api_admin_global_config_appliance_mgmt_ad_post: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ADDetailsRequest**](ADDetailsRequest.md)|  | 
 **accept** | **str**| The only supported Accept type is &#x27;application/json&#x27; | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

[**ADDetailsResponse**](ADDetailsResponse.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_global_config_appliance_mgmt_ad_uuid_put**
> ADDetailsResponse api_admin_global_config_appliance_mgmt_ad_uuid_put(body, accept, content_type, uuid)

Modify Active Directory Configuration for TCA Appliance Management.

API to modify Active Directory Configuration for TCA Appliance Management. This Active Directory configuration will be used to authentication users for configuring TCA Manager Appliance.

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.system_management.ActiveDirectoryConfigurationApi()
body = tca.system_management.ADDetailsUpdateRequest() # ADDetailsUpdateRequest | 
accept = 'application/json' # str | The only supported Accept type is 'application/json' (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)
uuid = 'uuid_example' # str | 

try:
    # Modify Active Directory Configuration for TCA Appliance Management.
    api_response = api_instance.api_admin_global_config_appliance_mgmt_ad_uuid_put(body, accept, content_type, uuid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ActiveDirectoryConfigurationApi->api_admin_global_config_appliance_mgmt_ad_uuid_put: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ADDetailsUpdateRequest**](ADDetailsUpdateRequest.md)|  | 
 **accept** | **str**| The only supported Accept type is &#x27;application/json&#x27; | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]
 **uuid** | **str**|  | 

### Return type

[**ADDetailsResponse**](ADDetailsResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_global_config_orchestration_ad_get**
> ADDetailsResponse api_admin_global_config_orchestration_ad_get(accept)

Get Active Directory Configuration for TCA.

API to get Active Directory configuration for TCA. This Active Directory configuration will be used to authentication users for performing NFV related operations.

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.ActiveDirectoryConfigurationApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | The only supported Accept type is 'application/json' (default to application/json)

try:
    # Get Active Directory Configuration for TCA.
    api_response = api_instance.api_admin_global_config_orchestration_ad_get(accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ActiveDirectoryConfigurationApi->api_admin_global_config_orchestration_ad_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| The only supported Accept type is &#x27;application/json&#x27; | [default to application/json]

### Return type

[**ADDetailsResponse**](ADDetailsResponse.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_global_config_orchestration_ad_post**
> ADDetailsResponse api_admin_global_config_orchestration_ad_post(body, accept, content_type)

Create Active Directory Configuration for TCA.

API to add Active Directory Configuration for TCA. This Active Directory configuration will be used to authentication users for performing NFV related operations.

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.ActiveDirectoryConfigurationApi(tca.system_management.ApiClient(configuration))
body = tca.system_management.ADDetailsRequest() # ADDetailsRequest | 
accept = 'application/json' # str | The only supported Accept type is 'application/json' (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Create Active Directory Configuration for TCA.
    api_response = api_instance.api_admin_global_config_orchestration_ad_post(body, accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ActiveDirectoryConfigurationApi->api_admin_global_config_orchestration_ad_post: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ADDetailsRequest**](ADDetailsRequest.md)|  | 
 **accept** | **str**| The only supported Accept type is &#x27;application/json&#x27; | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

[**ADDetailsResponse**](ADDetailsResponse.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_global_config_orchestration_ad_uuid_put**
> ADDetailsResponse api_admin_global_config_orchestration_ad_uuid_put(body, accept, content_type, uuid)

Modify Active Directory Configuration for TCA.

API to modify Active Directory Configuration for TCA. This Active Directory configuration will be used to authentication users for performing NFV related operations.

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.ActiveDirectoryConfigurationApi(tca.system_management.ApiClient(configuration))
body = tca.system_management.ADDetailsUpdateRequest() # ADDetailsUpdateRequest | 
accept = 'application/json' # str | The only supported Accept type is 'application/json' (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)
uuid = 'uuid_example' # str | 

try:
    # Modify Active Directory Configuration for TCA.
    api_response = api_instance.api_admin_global_config_orchestration_ad_uuid_put(body, accept, content_type, uuid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ActiveDirectoryConfigurationApi->api_admin_global_config_orchestration_ad_uuid_put: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ADDetailsUpdateRequest**](ADDetailsUpdateRequest.md)|  | 
 **accept** | **str**| The only supported Accept type is &#x27;application/json&#x27; | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]
 **uuid** | **str**|  | 

### Return type

[**ADDetailsResponse**](ADDetailsResponse.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

