# tca.system_management.BackupAndRestoreApi

All URIs are relative to **

Method | HTTP request | Description
------------- | ------------- | -------------
[**backup_job_status_job_id_get**](BackupAndRestoreApi.md#backup_job_status_job_id_get) | **GET** /backup/jobStatus/{jobId} | Get backup job status
[**backup_tca_post**](BackupAndRestoreApi.md#backup_tca_post) | **POST** /backup/tca | Backup Appliance
[**restore_job_status_job_id_get**](BackupAndRestoreApi.md#restore_job_status_job_id_get) | **GET** /restore/jobStatus/{jobId} | Get restore job status
[**restore_tca_post**](BackupAndRestoreApi.md#restore_tca_post) | **POST** /restore/tca | Restore appliance
[**restore_uploadbundle_info_get**](BackupAndRestoreApi.md#restore_uploadbundle_info_get) | **GET** /restore/uploadbundle/info | Get upload bundle info
[**restore_uploadbundle_post**](BackupAndRestoreApi.md#restore_uploadbundle_post) | **POST** /restore/uploadbundle | Upload Bundle

# **backup_job_status_job_id_get**
> BackupJobDetails backup_job_status_job_id_get(job_id, accept)

Get backup job status

API to get backup job status

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.BackupAndRestoreApi(tca.system_management.ApiClient(configuration))
job_id = 'job_id_example' # str | 
accept = 'application/json' # str | application/json (default to application/json)

try:
    # Get backup job status
    api_response = api_instance.backup_job_status_job_id_get(job_id, accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling BackupAndRestoreApi->backup_job_status_job_id_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **job_id** | **str**|  | 
 **accept** | **str**| application/json | [default to application/json]

### Return type

[**BackupJobDetails**](BackupJobDetails.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **backup_tca_post**
> TcaJob backup_tca_post(accept, content_type, body=body)

Backup Appliance

API to backup Appliance

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.BackupAndRestoreApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)
body = tca.system_management.BackupRequest() # BackupRequest |  (optional)

try:
    # Backup Appliance
    api_response = api_instance.backup_tca_post(accept, content_type, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling BackupAndRestoreApi->backup_tca_post: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]
 **body** | [**BackupRequest**](BackupRequest.md)|  | [optional] 

### Return type

[**TcaJob**](TcaJob.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **restore_job_status_job_id_get**
> InlineResponse20010 restore_job_status_job_id_get(job_id, accept)

Get restore job status

API to get restore job status

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.BackupAndRestoreApi(tca.system_management.ApiClient(configuration))
job_id = 'job_id_example' # str | 
accept = 'application/json' # str | application/json (default to application/json)

try:
    # Get restore job status
    api_response = api_instance.restore_job_status_job_id_get(job_id, accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling BackupAndRestoreApi->restore_job_status_job_id_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **job_id** | **str**|  | 
 **accept** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse20010**](InlineResponse20010.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **restore_tca_post**
> InlineResponse2009 restore_tca_post(accept, content_type, body=body)

Restore appliance

API to restore appliance

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.BackupAndRestoreApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)
body = tca.system_management.RestoreTcaBody() # RestoreTcaBody |  (optional)

try:
    # Restore appliance
    api_response = api_instance.restore_tca_post(accept, content_type, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling BackupAndRestoreApi->restore_tca_post: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]
 **body** | [**RestoreTcaBody**](RestoreTcaBody.md)|  | [optional] 

### Return type

[**InlineResponse2009**](InlineResponse2009.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **restore_uploadbundle_info_get**
> InlineResponse2008 restore_uploadbundle_info_get(accept)

Get upload bundle info

API to get upload bundle info

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.BackupAndRestoreApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)

try:
    # Get upload bundle info
    api_response = api_instance.restore_uploadbundle_info_get(accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling BackupAndRestoreApi->restore_uploadbundle_info_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse2008**](InlineResponse2008.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **restore_uploadbundle_post**
> restore_uploadbundle_post(accept, content_type, file=file)

Upload Bundle

API to upload bundle

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.BackupAndRestoreApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'multipart/form-data' # str | multipart/form-data (default to multipart/form-data)
file = 'file_example' # str |  (optional)

try:
    # Upload Bundle
    api_instance.restore_uploadbundle_post(accept, content_type, file=file)
except ApiException as e:
    print("Exception when calling BackupAndRestoreApi->restore_uploadbundle_post: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| multipart/form-data | [default to multipart/form-data]
 **file** | **str**|  | [optional] 

### Return type

void (empty response body)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

