# tca.tcfm.CertificateManagementApi

All URIs are relative to */hybridity/api/*

Method | HTTP request | Description
------------- | ------------- | -------------
[**create_signing_authority**](CertificateManagementApi.md#create_signing_authority) | **POST** /ztp/security/signingAuthorities | Create Certificate Signing Authority
[**download_csrs**](CertificateManagementApi.md#download_csrs) | **GET** /ztp/domains/{domainName}/security/csr | Download CSR for appliances
[**get_appliances**](CertificateManagementApi.md#get_appliances) | **GET** /ztp/domains/{domainName}/security/appliances | Get Certificate Management Appliances
[**get_signing_authorities**](CertificateManagementApi.md#get_signing_authorities) | **GET** /ztp/security/signingAuthorities | Get all Certificate Signing Authorities
[**get_signing_authority**](CertificateManagementApi.md#get_signing_authority) | **GET** /ztp/security/signingAuthorities/{name} | Get Certificate Signing Authorities of type
[**manage_certificates**](CertificateManagementApi.md#manage_certificates) | **POST** /ztp/domains/{domainName}/security/manage | Certificate Management Input
[**retry_failed_certificate_operation**](CertificateManagementApi.md#retry_failed_certificate_operation) | **POST** /ztp/domains/{domainName}/security/retry | Retry failed certificate management task/s
[**upload_certificates**](CertificateManagementApi.md#upload_certificates) | **POST** /ztp/domains/{domainName}/security/certificates | upload certificate to appliance
[**upload_server_certificate**](CertificateManagementApi.md#upload_server_certificate) | **POST** /ztp/domains/{domainName}/security/certificates/serverCertificate | upload server certificate for Cloud Native TCA and TCA-CP

# **create_signing_authority**
> Response create_signing_authority(body)

Create Certificate Signing Authority

selfsign: TCF manager will host a root CA and it will be self-signed. intermediate: TCF manager will host an intermediate CA and this CA's certificate will be signed by some external CA. 

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.CertificateManagementApi()
body = tca.tcfm.SigningAuthority() # SigningAuthority | 

try:
    # Create Certificate Signing Authority
    api_response = api_instance.create_signing_authority(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CertificateManagementApi->create_signing_authority: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**SigningAuthority**](SigningAuthority.md)|  | 

### Return type

[**Response**](Response.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **download_csrs**
> Response download_csrs(domain_name)

Download CSR for appliances

Download CSR for appliances

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.CertificateManagementApi()
domain_name = 'domain_name_example' # str | Domain Name

try:
    # Download CSR for appliances
    api_response = api_instance.download_csrs(domain_name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CertificateManagementApi->download_csrs: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **domain_name** | **str**| Domain Name | 

### Return type

[**Response**](Response.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/octet-stream, application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_appliances**
> CertificateManagementAppliancesResponse get_appliances(domain_name)

Get Certificate Management Appliances

Get Certificate Management Appliances

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.CertificateManagementApi()
domain_name = 'domain_name_example' # str | domainName

try:
    # Get Certificate Management Appliances
    api_response = api_instance.get_appliances(domain_name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CertificateManagementApi->get_appliances: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **domain_name** | **str**| domainName | 

### Return type

[**CertificateManagementAppliancesResponse**](CertificateManagementAppliancesResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_signing_authorities**
> SigningAuthoritiesResponse get_signing_authorities()

Get all Certificate Signing Authorities

Get all Certificate Signing Authorities

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.CertificateManagementApi()

try:
    # Get all Certificate Signing Authorities
    api_response = api_instance.get_signing_authorities()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CertificateManagementApi->get_signing_authorities: %s\n" % e)
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**SigningAuthoritiesResponse**](SigningAuthoritiesResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_signing_authority**
> SigningAuthority get_signing_authority(name)

Get Certificate Signing Authorities of type

Get Certificate Signing Authorities of type

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.CertificateManagementApi()
name = 'name_example' # str | name of signing authority

try:
    # Get Certificate Signing Authorities of type
    api_response = api_instance.get_signing_authority(name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CertificateManagementApi->get_signing_authority: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **str**| name of signing authority | 

### Return type

[**SigningAuthority**](SigningAuthority.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **manage_certificates**
> Response manage_certificates(body, domain_name)

Certificate Management Input

Certificate Management Input

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.CertificateManagementApi()
body = tca.tcfm.ManageCertificatesRequest() # ManageCertificatesRequest | 
domain_name = 'domain_name_example' # str | Domain Name

try:
    # Certificate Management Input
    api_response = api_instance.manage_certificates(body, domain_name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CertificateManagementApi->manage_certificates: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ManageCertificatesRequest**](ManageCertificatesRequest.md)|  | 
 **domain_name** | **str**| Domain Name | 

### Return type

[**Response**](Response.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **retry_failed_certificate_operation**
> Response retry_failed_certificate_operation(domain_name, body=body)

Retry failed certificate management task/s

Retry failed certificate management task/s

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.CertificateManagementApi()
domain_name = 'domain_name_example' # str | Domain Name
body = tca.tcfm.CertRetryAppliances() # CertRetryAppliances |  (optional)

try:
    # Retry failed certificate management task/s
    api_response = api_instance.retry_failed_certificate_operation(domain_name, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CertificateManagementApi->retry_failed_certificate_operation: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **domain_name** | **str**| Domain Name | 
 **body** | [**CertRetryAppliances**](CertRetryAppliances.md)|  | [optional] 

### Return type

[**Response**](Response.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **upload_certificates**
> Response upload_certificates(domain_name, file_name=file_name)

upload certificate to appliance

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.CertificateManagementApi()
domain_name = 'domain_name_example' # str | Domain Name
file_name = 'file_name_example' # str |  (optional)

try:
    # upload certificate to appliance
    api_response = api_instance.upload_certificates(domain_name, file_name=file_name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CertificateManagementApi->upload_certificates: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **domain_name** | **str**| Domain Name | 
 **file_name** | **str**|  | [optional] 

### Return type

[**Response**](Response.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **upload_server_certificate**
> Response upload_server_certificate(body, domain_name)

upload server certificate for Cloud Native TCA and TCA-CP

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.CertificateManagementApi()
body = tca.tcfm.UploadServerCertRequest() # UploadServerCertRequest | 
domain_name = 'domain_name_example' # str | Name of the domain

try:
    # upload server certificate for Cloud Native TCA and TCA-CP
    api_response = api_instance.upload_server_certificate(body, domain_name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CertificateManagementApi->upload_server_certificate: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**UploadServerCertRequest**](UploadServerCertRequest.md)|  | 
 **domain_name** | **str**| Name of the domain | 

### Return type

[**Response**](Response.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

