# tca.system_management.CertificatesApi

All URIs are relative to **

Method | HTTP request | Description
------------- | ------------- | -------------
[**api_admin_certificates_get**](CertificatesApi.md#api_admin_certificates_get) | **GET** /api/admin/certificates | Get list of trusted certificates
[**api_admin_certificates_post**](CertificatesApi.md#api_admin_certificates_post) | **POST** /api/admin/certificates | Import trusted certificate
[**api_admin_certificates_server_certificate_appliance_manager_put**](CertificatesApi.md#api_admin_certificates_server_certificate_appliance_manager_put) | **PUT** /api/admin/certificates/serverCertificate/appliance-manager | To change the appliance management certificate
[**api_admin_certificates_server_certificate_httpd_put**](CertificatesApi.md#api_admin_certificates_server_certificate_httpd_put) | **PUT** /api/admin/certificates/serverCertificate/httpd | Import Server certificate
[**api_admin_certificates_sha256_delete**](CertificatesApi.md#api_admin_certificates_sha256_delete) | **DELETE** /api/admin/certificates/{sha256} | Delete trusted certificate

# **api_admin_certificates_get**
> InlineResponse2007 api_admin_certificates_get(accept)

Get list of trusted certificates

API to get list of trusted certificates

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.CertificatesApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)

try:
    # Get list of trusted certificates
    api_response = api_instance.api_admin_certificates_get(accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CertificatesApi->api_admin_certificates_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse2007**](InlineResponse2007.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_certificates_post**
> InlineResponse2007 api_admin_certificates_post(body, accept, content_type)

Import trusted certificate

API to import trusted certificate

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.CertificatesApi(tca.system_management.ApiClient(configuration))
body = tca.system_management.AdminCertificatesBody() # AdminCertificatesBody | X509 certificate in PEM format
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Import trusted certificate
    api_response = api_instance.api_admin_certificates_post(body, accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CertificatesApi->api_admin_certificates_post: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AdminCertificatesBody**](AdminCertificatesBody.md)| X509 certificate in PEM format | 
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse2007**](InlineResponse2007.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_certificates_server_certificate_appliance_manager_put**
> object api_admin_certificates_server_certificate_appliance_manager_put(body, accept, content_type)

To change the appliance management certificate

API to change the appliance management certificate

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.CertificatesApi(tca.system_management.ApiClient(configuration))
body = tca.system_management.Object() # Object | 
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # To change the appliance management certificate
    api_response = api_instance.api_admin_certificates_server_certificate_appliance_manager_put(body, accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CertificatesApi->api_admin_certificates_server_certificate_appliance_manager_put: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | **Object**|  | 
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

**object**

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_certificates_server_certificate_httpd_put**
> InlineResponse2007 api_admin_certificates_server_certificate_httpd_put(body, accept, content_type)

Import Server certificate

Api to Import Server certificate

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.CertificatesApi(tca.system_management.ApiClient(configuration))
body = tca.system_management.ServerCertificateHttpdBody() # ServerCertificateHttpdBody | To specify the certificate in a JSON payload, use the following UNIX command to convert each .pem file to a value: 
  <pre> awk 'NF {sub(/\r/, ""); printf "%s\\n",$0;}' cert-name.pem </pre> 
 In this example, cert-name.pem is the name of the certificate file. The new format places all the certificate information on a single line with embedded newline characters. If you have an intermediate certificate, that certificate must also be in one-line format and add to the first certificate so that both certificates are on the same line.
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Import Server certificate
    api_response = api_instance.api_admin_certificates_server_certificate_httpd_put(body, accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CertificatesApi->api_admin_certificates_server_certificate_httpd_put: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ServerCertificateHttpdBody**](ServerCertificateHttpdBody.md)| To specify the certificate in a JSON payload, use the following UNIX command to convert each .pem file to a value: 
  &lt;pre&gt; awk &#x27;NF {sub(/\r/, &quot;&quot;); printf &quot;%s\\n&quot;,$0;}&#x27; cert-name.pem &lt;/pre&gt; 
 In this example, cert-name.pem is the name of the certificate file. The new format places all the certificate information on a single line with embedded newline characters. If you have an intermediate certificate, that certificate must also be in one-line format and add to the first certificate so that both certificates are on the same line. | 
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse2007**](InlineResponse2007.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_certificates_sha256_delete**
> InlineResponse2007 api_admin_certificates_sha256_delete(accept, content_type, sha256)

Delete trusted certificate

API to delete trusted certificate

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.CertificatesApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)
sha256 = 'sha256_example' # str | 

try:
    # Delete trusted certificate
    api_response = api_instance.api_admin_certificates_sha256_delete(accept, content_type, sha256)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CertificatesApi->api_admin_certificates_sha256_delete: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]
 **sha256** | **str**|  | 

### Return type

[**InlineResponse2007**](InlineResponse2007.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

