# tca.tcfm.CloudSpecificationApi

All URIs are relative to */hybridity/api/*

Method | HTTP request | Description
------------- | ------------- | -------------
[**create_spec**](CloudSpecificationApi.md#create_spec) | **POST** /ztp/scheme1/config | Create Telco Cloud Definition (TCD)
[**get_cloud_spec**](CloudSpecificationApi.md#get_cloud_spec) | **GET** /ztp/scheme1/config | Get Telco Cloud Definition (TCD)
[**get_cloud_spec_template**](CloudSpecificationApi.md#get_cloud_spec_template) | **GET** /ztp/scheme1/template | Get Cloud Specification Template
[**modify_spec**](CloudSpecificationApi.md#modify_spec) | **PUT** /ztp/scheme1/config | Create/Update Telco Cloud Definition (TCD)

# **create_spec**
> Response create_spec(body)

Create Telco Cloud Definition (TCD)

Create Telco Cloud Definition (TCD)

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.CloudSpecificationApi()
body = tca.tcfm.CloudSpec() # CloudSpec | 

try:
    # Create Telco Cloud Definition (TCD)
    api_response = api_instance.create_spec(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CloudSpecificationApi->create_spec: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**CloudSpec**](CloudSpec.md)|  | 

### Return type

[**Response**](Response.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_cloud_spec**
> CloudSpec get_cloud_spec()

Get Telco Cloud Definition (TCD)

Get Telco Cloud Definition (TCD)

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.CloudSpecificationApi()

try:
    # Get Telco Cloud Definition (TCD)
    api_response = api_instance.get_cloud_spec()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CloudSpecificationApi->get_cloud_spec: %s\n" % e)
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**CloudSpec**](CloudSpec.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_cloud_spec_template**
> CloudSpec get_cloud_spec_template()

Get Cloud Specification Template

Get Cloud Specification Template

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.CloudSpecificationApi()

try:
    # Get Cloud Specification Template
    api_response = api_instance.get_cloud_spec_template()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CloudSpecificationApi->get_cloud_spec_template: %s\n" % e)
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**CloudSpec**](CloudSpec.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **modify_spec**
> Response modify_spec(body)

Create/Update Telco Cloud Definition (TCD)

Create/Update Telco Cloud Definition (TCD)

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.CloudSpecificationApi()
body = tca.tcfm.CloudSpec() # CloudSpec | 

try:
    # Create/Update Telco Cloud Definition (TCD)
    api_response = api_instance.modify_spec(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CloudSpecificationApi->modify_spec: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**CloudSpec**](CloudSpec.md)|  | 

### Return type

[**Response**](Response.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

