# Cluster

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | **str** |  | [optional] 
**cluster_name** | **str** |  | [optional] 
**is_imported** | **bool** | Flag to indicate if this cluster is imported. Clusters created outside TCA and imported to TCA will have this flag set to True. | [optional] 
**ip_families** | **str** |  | [optional] 
**cluster_type** | **str** | Type of cluster. Can be Workload/Management. | [optional] 
**vsphere_cluster_name** | **str** | Name of the vsphere cluster on which the k8s cluster is deployed. | [optional] 
**management_cluster_id** | **str** | Id of the management cluster, only relevant for workload clusters. | [optional] 
**hcx_uuid** | **str** | Endpoint id of the tca cp which is managing the cluster. | [optional] 
**resource_provider_hcx_uuid** | **str** | Endpoint id of the tca cp on which the cluster resources are deployed. | [optional] 
**status** | **str** | Current status of the cluster. | [optional] 
**active_tasks_count** | **int** | Number of operations in processing or queued state on the cluster | [optional] 
**cluster_template** | [**ClusterClusterTemplate**](ClusterClusterTemplate.md) |  | [optional] 
**cluster_config** | [**ClusterConfigurations**](ClusterConfigurations.md) |  | [optional] 
**airgap_config** | [**ClusterRequestAirgapConfig**](ClusterRequestAirgapConfig.md) |  | [optional] 
**proxy_config** | [**ProxyConfig**](ProxyConfig.md) |  | [optional] 
**cluster_id** | **str** |  | [optional] 
**cluster_url** | **str** |  | [optional] 
**kube_config** | **str** |  | [optional] 
**endpoint_ip** | **str** | API server load balancer IP. This address is used by Kube-vip pod that runs in the control plane nodes and provides load balancing services for the cluster API server. Make sure that this Ip Address is not in the DHCP range,but its in the same subnet as the DHCP range of master node&#x27;s management network. | [optional] 
**master_nodes** | [**list[ClusterMasterNodes]**](ClusterMasterNodes.md) | Pool of nodes on which Kubernetes control plane can run. | [optional] 
**worker_nodes** | [**list[ClusterWorkerNodes]**](ClusterWorkerNodes.md) | Pool of worker nodes on which Network Functions can run. Each Node Pool can be deployed on a vSphere Resource Pool. All the worker nodes in a node pool contain same Kubelet and Operating System Configuration. It is recommended that a Node Pool should be used by only one Network Function Instance, if it has Infrastructure requirements.  | [optional] 
**vim_id** | **str** |  | [optional] 
**error** | **str** | Any error associated with the cluster. For eg. \&quot;Kubernetes version not supported\&quot;. | [optional] 
**has_supported_kubernetes_version** | **bool** | Flag to indicate if the cluster is on one of the supported kubernetes versions. | [optional] 
**supported_operators_version** | **str** | The supported version for the operators like vmconfig operator and nodeconfig operator. | [optional] 
**cluster_password** | **str** | This password is used to login to the master nodes and worker nodes. The username is \&quot;capv\&quot;. | [optional] 
**links** | **object** |  | [optional] 
**creation_user** | **str** |  | [optional] 
**last_updated** | **str** |  | [optional] 
**creation_date** | **str** |  | [optional] 
**placement_params** | [**list[ClusterPlacementParams]**](ClusterPlacementParams.md) |  | [optional] 
**warnings** | [**list[ClusterWarnings]**](ClusterWarnings.md) |  | [optional] 
**errors** | [**list[ClusterWarnings]**](ClusterWarnings.md) | Errors are for internal use and subject to change. Please use task for monitoring progress of operation. | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

