# tca.cluster.ClusterApi

All URIs are relative to */hybridity/api/*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_k8_cluster**](ClusterApi.md#get_k8_cluster) | **GET** /infra/k8s/clusters/{clusterId} | Api to get cluster for Telco Cloud Automation (Deprecated for workload clusters)
[**infra_cluster_query**](ClusterApi.md#infra_cluster_query) | **POST** /infra/k8s/clusters/query | Api to query Kubernetes Cluster for Telco Cloud Automation (Deprecated for workload clusters)
[**undeploy_infra**](ClusterApi.md#undeploy_infra) | **DELETE** /infra/k8s/clusters/{clusterId} | Api to delete cluster for Telco Cloud Automation (Deprecated for workload clusters)

# **get_k8_cluster**
> Cluster get_k8_cluster(cluster_id, skip_nodes_info=skip_nodes_info)

Api to get cluster for Telco Cloud Automation (Deprecated for workload clusters)

Get K8 cluster

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.ClusterApi()
cluster_id = 'cluster_id_example' # str | 
skip_nodes_info = 'skip_nodes_info_example' # str | Flag to skip nodes information as part of api response. If set to true, response will not have nodes information. Nodes information can be queried directly from Kubernetes cluster API instead. (optional)

try:
    # Api to get cluster for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.get_k8_cluster(cluster_id, skip_nodes_info=skip_nodes_info)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterApi->get_k8_cluster: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_id** | **str**|  | 
 **skip_nodes_info** | **str**| Flag to skip nodes information as part of api response. If set to true, response will not have nodes information. Nodes information can be queried directly from Kubernetes cluster API instead. | [optional] 

### Return type

[**Cluster**](Cluster.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **infra_cluster_query**
> list[Cluster] infra_cluster_query(body)

Api to query Kubernetes Cluster for Telco Cloud Automation (Deprecated for workload clusters)

Api to query Kubernetes Cluster for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.ClusterApi()
body = tca.cluster.ClustersQueryBody() # ClustersQueryBody | query cluster

try:
    # Api to query Kubernetes Cluster for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.infra_cluster_query(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterApi->infra_cluster_query: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ClustersQueryBody**](ClustersQueryBody.md)| query cluster | 

### Return type

[**list[Cluster]**](Cluster.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **undeploy_infra**
> InlineResponse200 undeploy_infra(cluster_id)

Api to delete cluster for Telco Cloud Automation (Deprecated for workload clusters)

Delete K8 cluster

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.ClusterApi()
cluster_id = 'cluster_id_example' # str | 

try:
    # Api to delete cluster for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.undeploy_infra(cluster_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterApi->undeploy_infra: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_id** | **str**|  | 

### Return type

[**InlineResponse200**](InlineResponse200.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

