# tca.caas_v2.ClusterAutomationApi

All URIs are relative to */telco/api/caas/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**create_cluster**](ClusterAutomationApi.md#create_cluster) | **POST** /clusters | Api to deploy Kubernetes Cluster for Telco Cloud Automation
[**delete_cluster**](ClusterAutomationApi.md#delete_cluster) | **DELETE** /clusters/{clusterName} | Api to delete kubernetes Cluster for Telco Cloud Automation
[**edit_cluster**](ClusterAutomationApi.md#edit_cluster) | **PUT** /clusters/{clusterName} | Api to edit kubernetes Cluster for Telco Cloud Automation
[**get_addon_tca_k8s_resources**](ClusterAutomationApi.md#get_addon_tca_k8s_resources) | **GET** /clusters/{clusterName}/addon/{addonName}/tcak8sresources | API to fetch underyling tca k8s CRs (Deployed by cluster lifecycle operator) including TcaNodePool &amp; NodePolicy
[**get_all_clusters**](ClusterAutomationApi.md#get_all_clusters) | **GET** /clusters | API to list all kubernetes clusters for Telco Cloud Automation.
[**get_cluster**](ClusterAutomationApi.md#get_cluster) | **GET** /clusters/{clusterName} | Api to get kubernetes Cluster for Telco Cloud Automation
[**get_cluster_stats**](ClusterAutomationApi.md#get_cluster_stats) | **GET** /clusters/{clusterName}/stats | Api to get kubernetes Cluster Stats for Telco Cloud Automation
[**get_cluster_tca_k8s_resources**](ClusterAutomationApi.md#get_cluster_tca_k8s_resources) | **GET** /clusters/{clusterName}/tcak8sresources | API to fetch underyling tca k8s CRs (Deployed by cluster lifecycle operator) including TCAKubernetesCluster &amp; TCAKubeControlPlane
[**get_node_pool_tca_k8s_resources**](ClusterAutomationApi.md#get_node_pool_tca_k8s_resources) | **GET** /clusters/{clusterName}/nodepools/{nodePoolName}/tcak8sresources | API to fetch underyling tca k8s CRs (Deployed by cluster lifecycle operator) including TcaNodePool &amp; NodePolicy

# **create_cluster**
> Cluster create_cluster(body, mgmt_cluster_name=mgmt_cluster_name, tca_cp_id=tca_cp_id)

Api to deploy Kubernetes Cluster for Telco Cloud Automation

Api to deploy Kubernetes Cluster for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2
from tca.caas_v2.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2.ClusterAutomationApi()
body = tca.caas_v2.Cluster() # Cluster | create cluster
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | Name of the management cluster where the request has to be executed (optional)
tca_cp_id = 'tca_cp_id_example' # str | Id of the TCA CP where the request has to be routed. (optional)

try:
    # Api to deploy Kubernetes Cluster for Telco Cloud Automation
    api_response = api_instance.create_cluster(body, mgmt_cluster_name=mgmt_cluster_name, tca_cp_id=tca_cp_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterAutomationApi->create_cluster: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Cluster**](Cluster.md)| create cluster | 
 **mgmt_cluster_name** | **str**| Name of the management cluster where the request has to be executed | [optional] 
 **tca_cp_id** | **str**| Id of the TCA CP where the request has to be routed. | [optional] 

### Return type

[**Cluster**](Cluster.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-yaml
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_cluster**
> object delete_cluster(cluster_name, mgmt_cluster_name=mgmt_cluster_name, tca_cp_id=tca_cp_id, is_force=is_force)

Api to delete kubernetes Cluster for Telco Cloud Automation

Api to delete kubernetes Cluster for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2
from tca.caas_v2.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2.ClusterAutomationApi()
cluster_name = 'cluster_name_example' # str | Name of the cluster which has to be deleted
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | Name of the management cluster where the request has to be executed (optional)
tca_cp_id = 'tca_cp_id_example' # str | Id of the TCA CP where the request has to be routed. (optional)
is_force = false # bool | Flag to force delete cluster created using v2 apis (optional) (default to false)

try:
    # Api to delete kubernetes Cluster for Telco Cloud Automation
    api_response = api_instance.delete_cluster(cluster_name, mgmt_cluster_name=mgmt_cluster_name, tca_cp_id=tca_cp_id, is_force=is_force)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterAutomationApi->delete_cluster: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_name** | **str**| Name of the cluster which has to be deleted | 
 **mgmt_cluster_name** | **str**| Name of the management cluster where the request has to be executed | [optional] 
 **tca_cp_id** | **str**| Id of the TCA CP where the request has to be routed. | [optional] 
 **is_force** | **bool**| Flag to force delete cluster created using v2 apis | [optional] [default to false]

### Return type

**object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **edit_cluster**
> Cluster edit_cluster(body, cluster_name, mgmt_cluster_name=mgmt_cluster_name, tca_cp_id=tca_cp_id)

Api to edit kubernetes Cluster for Telco Cloud Automation

Api to edit kubernetes Cluster for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2
from tca.caas_v2.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2.ClusterAutomationApi()
body = tca.caas_v2.Cluster() # Cluster | create cluster
cluster_name = 'cluster_name_example' # str | Name of the cluster which has to be deleted
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | Name of the management cluster where the request has to be executed (optional)
tca_cp_id = 'tca_cp_id_example' # str | Id of the TCA CP where the request has to be routed. (optional)

try:
    # Api to edit kubernetes Cluster for Telco Cloud Automation
    api_response = api_instance.edit_cluster(body, cluster_name, mgmt_cluster_name=mgmt_cluster_name, tca_cp_id=tca_cp_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterAutomationApi->edit_cluster: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Cluster**](Cluster.md)| create cluster | 
 **cluster_name** | **str**| Name of the cluster which has to be deleted | 
 **mgmt_cluster_name** | **str**| Name of the management cluster where the request has to be executed | [optional] 
 **tca_cp_id** | **str**| Id of the TCA CP where the request has to be routed. | [optional] 

### Return type

[**Cluster**](Cluster.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-yaml
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_addon_tca_k8s_resources**
> TcaAddonResource get_addon_tca_k8s_resources(cluster_name, addon_name, mgmt_cluster_name, tca_cp_id)

API to fetch underyling tca k8s CRs (Deployed by cluster lifecycle operator) including TcaNodePool & NodePolicy

API to fetch underyling tca k8s NodePool CRs for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2
from tca.caas_v2.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2.ClusterAutomationApi()
cluster_name = 'cluster_name_example' # str | Name of the cluster to which resources need to be fetched
addon_name = 'addon_name_example' # str | 
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | Name of the management cluster of the given cluster
tca_cp_id = 'tca_cp_id_example' # str | Id of the TCA CP of the given cluster

try:
    # API to fetch underyling tca k8s CRs (Deployed by cluster lifecycle operator) including TcaNodePool & NodePolicy
    api_response = api_instance.get_addon_tca_k8s_resources(cluster_name, addon_name, mgmt_cluster_name, tca_cp_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterAutomationApi->get_addon_tca_k8s_resources: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_name** | **str**| Name of the cluster to which resources need to be fetched | 
 **addon_name** | **str**|  | 
 **mgmt_cluster_name** | **str**| Name of the management cluster of the given cluster | 
 **tca_cp_id** | **str**| Id of the TCA CP of the given cluster | 

### Return type

[**TcaAddonResource**](TcaAddonResource.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_all_clusters**
> ClusterList get_all_clusters(sort=sort, nextpage_opaque_marker=nextpage_opaque_marker)

API to list all kubernetes clusters for Telco Cloud Automation.

API to list all kubernetes clusters for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2
from tca.caas_v2.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2.ClusterAutomationApi()
sort = 'sort_example' # str | Attribute based sorting expression. (optional)
nextpage_opaque_marker = 'nextpage_opaque_marker_example' # str | Marker to obtain the next page of a paged response. If not present, API will return first page of response with page size 10. (optional)

try:
    # API to list all kubernetes clusters for Telco Cloud Automation.
    api_response = api_instance.get_all_clusters(sort=sort, nextpage_opaque_marker=nextpage_opaque_marker)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterAutomationApi->get_all_clusters: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sort** | **str**| Attribute based sorting expression. | [optional] 
 **nextpage_opaque_marker** | **str**| Marker to obtain the next page of a paged response. If not present, API will return first page of response with page size 10. | [optional] 

### Return type

[**ClusterList**](ClusterList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_cluster**
> Cluster get_cluster(cluster_name, mgmt_cluster_name=mgmt_cluster_name, tca_cp_id=tca_cp_id)

Api to get kubernetes Cluster for Telco Cloud Automation

Api to get kubernetes Cluster for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2
from tca.caas_v2.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2.ClusterAutomationApi()
cluster_name = 'cluster_name_example' # str | Name of the cluster which has to be retrieved
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | Name of the management cluster which is managing the cluster (optional)
tca_cp_id = 'tca_cp_id_example' # str | Id of the TCA CP where the request has to be routed. (optional)

try:
    # Api to get kubernetes Cluster for Telco Cloud Automation
    api_response = api_instance.get_cluster(cluster_name, mgmt_cluster_name=mgmt_cluster_name, tca_cp_id=tca_cp_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterAutomationApi->get_cluster: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_name** | **str**| Name of the cluster which has to be retrieved | 
 **mgmt_cluster_name** | **str**| Name of the management cluster which is managing the cluster | [optional] 
 **tca_cp_id** | **str**| Id of the TCA CP where the request has to be routed. | [optional] 

### Return type

[**Cluster**](Cluster.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_cluster_stats**
> ClusterStats get_cluster_stats(cluster_name, mgmt_cluster_name=mgmt_cluster_name, tca_cp_id=tca_cp_id)

Api to get kubernetes Cluster Stats for Telco Cloud Automation

Api to get kubernetes Cluster Stats for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2
from tca.caas_v2.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2.ClusterAutomationApi()
cluster_name = 'cluster_name_example' # str | Name of the cluster whose stats has to be retrieved
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | Name of the management cluster which is managing the cluster (optional)
tca_cp_id = 'tca_cp_id_example' # str | Id of the TCA CP where the request has to be routed. (optional)

try:
    # Api to get kubernetes Cluster Stats for Telco Cloud Automation
    api_response = api_instance.get_cluster_stats(cluster_name, mgmt_cluster_name=mgmt_cluster_name, tca_cp_id=tca_cp_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterAutomationApi->get_cluster_stats: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_name** | **str**| Name of the cluster whose stats has to be retrieved | 
 **mgmt_cluster_name** | **str**| Name of the management cluster which is managing the cluster | [optional] 
 **tca_cp_id** | **str**| Id of the TCA CP where the request has to be routed. | [optional] 

### Return type

[**ClusterStats**](ClusterStats.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_cluster_tca_k8s_resources**
> TcaClusterResource get_cluster_tca_k8s_resources(cluster_name, mgmt_cluster_name, tca_cp_id)

API to fetch underyling tca k8s CRs (Deployed by cluster lifecycle operator) including TCAKubernetesCluster & TCAKubeControlPlane

API to fetch underyling tca k8s CRs for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2
from tca.caas_v2.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2.ClusterAutomationApi()
cluster_name = 'cluster_name_example' # str | Name of the cluster to which resources need to be fetched
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | Name of the management cluster of the given cluster
tca_cp_id = 'tca_cp_id_example' # str | Id of the TCA CP of the given cluster

try:
    # API to fetch underyling tca k8s CRs (Deployed by cluster lifecycle operator) including TCAKubernetesCluster & TCAKubeControlPlane
    api_response = api_instance.get_cluster_tca_k8s_resources(cluster_name, mgmt_cluster_name, tca_cp_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterAutomationApi->get_cluster_tca_k8s_resources: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_name** | **str**| Name of the cluster to which resources need to be fetched | 
 **mgmt_cluster_name** | **str**| Name of the management cluster of the given cluster | 
 **tca_cp_id** | **str**| Id of the TCA CP of the given cluster | 

### Return type

[**TcaClusterResource**](TcaClusterResource.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_node_pool_tca_k8s_resources**
> TcaNodePoolResource get_node_pool_tca_k8s_resources(cluster_name, node_pool_name, mgmt_cluster_name, tca_cp_id)

API to fetch underyling tca k8s CRs (Deployed by cluster lifecycle operator) including TcaNodePool & NodePolicy

API to fetch underyling tca k8s NodePool CRs for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2
from tca.caas_v2.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2.ClusterAutomationApi()
cluster_name = 'cluster_name_example' # str | Name of the cluster to which resources need to be fetched
node_pool_name = 'node_pool_name_example' # str | 
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | Name of the management cluster of the given cluster
tca_cp_id = 'tca_cp_id_example' # str | Id of the TCA CP of the given cluster

try:
    # API to fetch underyling tca k8s CRs (Deployed by cluster lifecycle operator) including TcaNodePool & NodePolicy
    api_response = api_instance.get_node_pool_tca_k8s_resources(cluster_name, node_pool_name, mgmt_cluster_name, tca_cp_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterAutomationApi->get_node_pool_tca_k8s_resources: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_name** | **str**| Name of the cluster to which resources need to be fetched | 
 **node_pool_name** | **str**|  | 
 **mgmt_cluster_name** | **str**| Name of the management cluster of the given cluster | 
 **tca_cp_id** | **str**| Id of the TCA CP of the given cluster | 

### Return type

[**TcaNodePoolResource**](TcaNodePoolResource.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

