# tca.caas_api_version.ClusterObjectVersionApi

All URIs are relative to */telco/api/caas*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_cluster_object_version**](ClusterObjectVersionApi.md#get_cluster_object_version) | **GET** /clusters/{clusterName}/objectVersion | Api to get Object Version of cluster

# **get_cluster_object_version**
> ObjectVersion get_cluster_object_version(cluster_name, tca_cp_id=tca_cp_id, mgmt_cluster_name=mgmt_cluster_name)

Api to get Object Version of cluster

Api to get Object Version of cluster

### Example
```python
from __future__ import print_function
import time
import tca.caas_api_version
from tca.caas_api_version.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_api_version.ClusterObjectVersionApi()
cluster_name = 'cluster_name_example' # str | Name of the cluster whose object version is to be fetched
tca_cp_id = 'tca_cp_id_example' # str | endpoint id of the TCA-CP (optional)
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | Name of the management cluster (optional)

try:
    # Api to get Object Version of cluster
    api_response = api_instance.get_cluster_object_version(cluster_name, tca_cp_id=tca_cp_id, mgmt_cluster_name=mgmt_cluster_name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterObjectVersionApi->get_cluster_object_version: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_name** | **str**| Name of the cluster whose object version is to be fetched | 
 **tca_cp_id** | **str**| endpoint id of the TCA-CP | [optional] 
 **mgmt_cluster_name** | **str**| Name of the management cluster | [optional] 

### Return type

[**ObjectVersion**](ObjectVersion.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

