# ClusterSpecControlPlaneSpec

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**clone_mode** | **str** | Deprecated, use cloudMachineTemplate.vSphereMachine.CloneMode instead. CloneMode specifies the type of clone operation. The LinkedClone mode is only support for templates that have at least one snapshot. If the template has no snapshots, then CloneMode defaults to FullClone. When LinkedClone mode is enabled the DiskGiB field is ignored as it is not possible to expand disks of linked clones. Defaults to LinkedClone, but fails gracefully to FullClone if the source of the clone operation has no snapshots. CloneMode is optional (can only be \&quot;linkedClone\&quot; or \&quot;fullClone\&quot;) for creation and is immutable. | [optional] [default to 'fullClone']
**cloud_machine_template** | [**ClusterSpecControlPlaneSpecCloudMachineTemplate**](ClusterSpecControlPlaneSpecCloudMachineTemplate.md) |  | [optional] 
**cluster_name** | **str** | ClusterName is the name of the Tca Kuberneters Cluster this object belongs to. ClusterName is required for creation and is immutable. | 
**datacenter** | **str** | Deprecated, use cloudMachineTemplate.vSphereMachine.Datacenter instead. Datacenter is the name or inventory path of the datacenter in which the node is created/located. Datacenter is required for creation and is immutable. | [optional] 
**datastore** | **str** | Deprecated, use cloudMachineTemplate.vSphereMachine.Datastore instead. Datastore is the name or inventory path of the datastore in which the node is created/located. Datastore is required if storagePolicyName is not set for creation and is immutable. | [optional] 
**disk_gi_b** | **int** | DiskGiB is the size of a node&#x27;s disk, in GiB. DiskGiB is required for creation and is immutable. | [optional] 
**folder** | **str** | Deprecated, use cloudMachineTemplate.vSphereMachine.Folder instead. Folder is the name or inventory path of the folder in which the node is created/located. Folder is required for creation and is immutable. | [optional] 
**kubeadm_config_template** | [**ClusterSpecControlPlaneSpecKubeadmConfigTemplate**](ClusterSpecControlPlaneSpecKubeadmConfigTemplate.md) |  | [optional] 
**labels** | **dict(str, str)** | Map of string keys and values that can be used to organize and categorize (scope and select) objects. Labels is optional for creation and is mutable. | [optional] 
**memory_mi_b** | **int** | MemoryMiB is the size of a node&#x27;s memory, in MiB. MemoryMiB is required for creation and is immutable. | [optional] 
**network** | [**ClusterSpecControlPlaneSpecNetwork**](ClusterSpecControlPlaneSpecNetwork.md) |  | [optional] 
**num_cp_us** | **int** | NumCPUs is the number of virtual processors in the node. NumCPUs is required for creation and is immutable. | [optional] 
**num_cores_per_socket** | **int** | Deprecated, use cloudMachineTemplate.vSphereMachine.NumCoresPerSocket instead. NumCoresPerSocket is the number of cores among which to distribute CPUs in this node. NumCoresPerSocket is optional for creation and is immutable. | [optional] 
**replicas** | **int** | Number of desired node. Defaults to 1. This is a pointer to distinguish between explicit zero and not specified. Replicas  is optional for creation and is mutable; it can only be odd number for quorum purpose. | [optional] [default to 1]
**resource_pool** | **str** | Deprecated, use cloudMachineTemplate.vSphereMachine.ResourcePool instead. ResourcePool is the name or inventory path of the resource pool in which the node is created/located. ResourcePool is required for creation and is immutable. | [optional] 
**storage_policy_name** | **str** | Deprecated, use cloudMachineTemplate.vSphereMachine.StoragePolicyName instead. StoragePolicyName of the storage policy to use with the node StoragePolicyName is required if Datastore is not set for creation and is immutable. | [optional] 
**strategy** | [**ClusterSpecControlPlaneSpecStrategy**](ClusterSpecControlPlaneSpecStrategy.md) |  | [optional] 
**tca_bom_release_ref** | [**ClusterSpecControlPlaneSpecTcaBomReleaseRef**](ClusterSpecControlPlaneSpecTcaBomReleaseRef.md) |  | [optional] 
**template** | **str** | Deprecated, use cloudMachineTemplate.vSphereMachine.Template instead. Template is the name or inventory path of the template used to clone the node. Template is required for creation and is immutable. | [optional] 
**control_plane_name** | **str** | Name to be given to the control plane | [optional] 
**cloud_provider** | [**ClusterSpecControlPlaneSpecCloudProvider**](ClusterSpecControlPlaneSpecCloudProvider.md) |  | 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

