# tca.clustertemplate.ClusterTemplatesApi

All URIs are relative to */hybridity/api/infra*

Method | HTTP request | Description
------------- | ------------- | -------------
[**create_cluster_template**](ClusterTemplatesApi.md#create_cluster_template) | **POST** /cluster-templates | Api to create a cluster template for Telco Cloud Automation (Deprecated for workload clusters)
[**download_cluster_template**](ClusterTemplatesApi.md#download_cluster_template) | **GET** /cluster-templates/{id}/download | Api to download a cluster template for Telco Cloud Automation (Deprecated for workload clusters)
[**update_cluster_template**](ClusterTemplatesApi.md#update_cluster_template) | **PUT** /cluster-templates/{id} | Api to update a cluster template for Telco Cloud Automation (Deprecated for workload clusters)
[**upload_cluster_template**](ClusterTemplatesApi.md#upload_cluster_template) | **POST** /cluster-templates/upload | Api to upload a cluster template for Telco Cloud Automation (Deprecated for workload clusters)

# **create_cluster_template**
> ClusterTemplate create_cluster_template(body)

Api to create a cluster template for Telco Cloud Automation (Deprecated for workload clusters)

Api to create a cluster template for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.clustertemplate
from tca.clustertemplate.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.clustertemplate.ClusterTemplatesApi()
body = tca.clustertemplate.ClusterTemplate() # ClusterTemplate | 

try:
    # Api to create a cluster template for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.create_cluster_template(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterTemplatesApi->create_cluster_template: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ClusterTemplate**](ClusterTemplate.md)|  | 

### Return type

[**ClusterTemplate**](ClusterTemplate.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **download_cluster_template**
> str download_cluster_template(id)

Api to download a cluster template for Telco Cloud Automation (Deprecated for workload clusters)

Api to download a cluster template for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.clustertemplate
from tca.clustertemplate.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.clustertemplate.ClusterTemplatesApi()
id = 'id_example' # str | 

try:
    # Api to download a cluster template for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.download_cluster_template(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterTemplatesApi->download_cluster_template: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**|  | 

### Return type

**str**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/octet-stream, application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_cluster_template**
> ClusterTemplate update_cluster_template(body, id)

Api to update a cluster template for Telco Cloud Automation (Deprecated for workload clusters)

Api to update a cluster template for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.clustertemplate
from tca.clustertemplate.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.clustertemplate.ClusterTemplatesApi()
body = tca.clustertemplate.ClusterTemplate() # ClusterTemplate | 
id = 'id_example' # str | 

try:
    # Api to update a cluster template for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.update_cluster_template(body, id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterTemplatesApi->update_cluster_template: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ClusterTemplate**](ClusterTemplate.md)|  | 
 **id** | **str**|  | 

### Return type

[**ClusterTemplate**](ClusterTemplate.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **upload_cluster_template**
> ClusterTemplate upload_cluster_template(file=file)

Api to upload a cluster template for Telco Cloud Automation (Deprecated for workload clusters)

Api to upload a cluster template for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.clustertemplate
from tca.clustertemplate.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.clustertemplate.ClusterTemplatesApi()
file = 'file_example' # str |  (optional)

try:
    # Api to upload a cluster template for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.upload_cluster_template(file=file)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterTemplatesApi->upload_cluster_template: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **file** | **str**|  | [optional] 

### Return type

[**ClusterTemplate**](ClusterTemplate.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

