# tca.caas_v2_templates.ClusterV2TemplatesApi

All URIs are relative to */telco/api/caas/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**create_cluster_template**](ClusterV2TemplatesApi.md#create_cluster_template) | **POST** /templates | API to create the cluster template
[**delete_cluster_template**](ClusterV2TemplatesApi.md#delete_cluster_template) | **DELETE** /templates/{templateName} | API to delete the cluster templates based on the template name
[**get_all_cluster_templates**](ClusterV2TemplatesApi.md#get_all_cluster_templates) | **GET** /templates | API to fetch all cluster templates
[**get_cluster_template**](ClusterV2TemplatesApi.md#get_cluster_template) | **GET** /templates/{templateName} | API to fetch the cluster templates based on the template name
[**transform_cluster_template**](ClusterV2TemplatesApi.md#transform_cluster_template) | **POST** /templates/clone | API to transform v1 cluster template to v2 cluster template
[**update_cluster_template**](ClusterV2TemplatesApi.md#update_cluster_template) | **PUT** /templates/{templateName} | API to edit cluster templates based on the template name

# **create_cluster_template**
> ClusterTemplate create_cluster_template(body)

API to create the cluster template

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2_templates
from tca.caas_v2_templates.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2_templates.ClusterV2TemplatesApi()
body = tca.caas_v2_templates.ClusterTemplate() # ClusterTemplate | Cluster template payload

try:
    # API to create the cluster template
    api_response = api_instance.create_cluster_template(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterV2TemplatesApi->create_cluster_template: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ClusterTemplate**](ClusterTemplate.md)| Cluster template payload | 

### Return type

[**ClusterTemplate**](ClusterTemplate.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-yaml
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_cluster_template**
> object delete_cluster_template(template_name)

API to delete the cluster templates based on the template name

API to delete cluster templates based on the template name

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2_templates
from tca.caas_v2_templates.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2_templates.ClusterV2TemplatesApi()
template_name = 'template_name_example' # str | Name of the cluster to be deleted

try:
    # API to delete the cluster templates based on the template name
    api_response = api_instance.delete_cluster_template(template_name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterV2TemplatesApi->delete_cluster_template: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **template_name** | **str**| Name of the cluster to be deleted | 

### Return type

**object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_all_cluster_templates**
> ClusterTemplateList get_all_cluster_templates(x_tca_anymatch=x_tca_anymatch, sort=sort, filter=filter, nextpage_opaque_marker=nextpage_opaque_marker)

API to fetch all cluster templates

API to fetch all cluster templates

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2_templates
from tca.caas_v2_templates.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2_templates.ClusterV2TemplatesApi()
x_tca_anymatch = 'x_tca_anymatch_example' # str | If false, then the filter expressions are taken in logical AND relation, otherwise OR (optional)
sort = 'sort_example' # str | Attribute based sorting expression. Attributes which are supported in sort expression is name,asc. Defaults to creationDate,desc (optional)
filter = 'filter_example' # str | Attribute-based filtering expression. Attributes which are supported in filter expression are Name and labels. (optional)
nextpage_opaque_marker = 'nextpage_opaque_marker_example' # str | Marker to obtain the next page of a paged response. If not present, API will return first page of response with page size 10. (optional)

try:
    # API to fetch all cluster templates
    api_response = api_instance.get_all_cluster_templates(x_tca_anymatch=x_tca_anymatch, sort=sort, filter=filter, nextpage_opaque_marker=nextpage_opaque_marker)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterV2TemplatesApi->get_all_cluster_templates: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **x_tca_anymatch** | **str**| If false, then the filter expressions are taken in logical AND relation, otherwise OR | [optional] 
 **sort** | **str**| Attribute based sorting expression. Attributes which are supported in sort expression is name,asc. Defaults to creationDate,desc | [optional] 
 **filter** | **str**| Attribute-based filtering expression. Attributes which are supported in filter expression are Name and labels. | [optional] 
 **nextpage_opaque_marker** | **str**| Marker to obtain the next page of a paged response. If not present, API will return first page of response with page size 10. | [optional] 

### Return type

[**ClusterTemplateList**](ClusterTemplateList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_cluster_template**
> ClusterTemplate get_cluster_template(template_name)

API to fetch the cluster templates based on the template name

API to fetch cluster templates based on the template name

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2_templates
from tca.caas_v2_templates.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2_templates.ClusterV2TemplatesApi()
template_name = 'template_name_example' # str | Name of the cluster template to be fetched

try:
    # API to fetch the cluster templates based on the template name
    api_response = api_instance.get_cluster_template(template_name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterV2TemplatesApi->get_cluster_template: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **template_name** | **str**| Name of the cluster template to be fetched | 

### Return type

[**ClusterTemplate**](ClusterTemplate.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **transform_cluster_template**
> ClusterTemplate transform_cluster_template(body, cluster_template_id)

API to transform v1 cluster template to v2 cluster template

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2_templates
from tca.caas_v2_templates.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2_templates.ClusterV2TemplatesApi()
body = tca.caas_v2_templates.TemplatesCloneBody() # TemplatesCloneBody | Cluster template transformation payload
cluster_template_id = 'cluster_template_id_example' # str | v1 cluster templateId which needs to be transformed to v2 cluster template format

try:
    # API to transform v1 cluster template to v2 cluster template
    api_response = api_instance.transform_cluster_template(body, cluster_template_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterV2TemplatesApi->transform_cluster_template: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**TemplatesCloneBody**](TemplatesCloneBody.md)| Cluster template transformation payload | 
 **cluster_template_id** | **str**| v1 cluster templateId which needs to be transformed to v2 cluster template format | 

### Return type

[**ClusterTemplate**](ClusterTemplate.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-yaml
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_cluster_template**
> ClusterTemplate update_cluster_template(body, template_name)

API to edit cluster templates based on the template name

API to edit cluster templates based on the template name

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2_templates
from tca.caas_v2_templates.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2_templates.ClusterV2TemplatesApi()
body = tca.caas_v2_templates.ClusterTemplate() # ClusterTemplate | edit cluster templates
template_name = 'template_name_example' # str | Name of the cluster template to be edited

try:
    # API to edit cluster templates based on the template name
    api_response = api_instance.update_cluster_template(body, template_name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ClusterV2TemplatesApi->update_cluster_template: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ClusterTemplate**](ClusterTemplate.md)| edit cluster templates | 
 **template_name** | **str**| Name of the cluster template to be edited | 

### Return type

[**ClusterTemplate**](ClusterTemplate.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-yaml
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

