# tca.infra.CnfCatalogInfraRequirementsApi

All URIs are relative to */hybridity/api/catalog/infra*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_infra_requirement_params**](CnfCatalogInfraRequirementsApi.md#get_infra_requirement_params) | **POST** /params/query | 
[**get_infra_requirement_supported_kernel_versions**](CnfCatalogInfraRequirementsApi.md#get_infra_requirement_supported_kernel_versions) | **GET** /params/supportedKernelVersions | 
[**update_infra_requirement_supported_kernel_versions**](CnfCatalogInfraRequirementsApi.md#update_infra_requirement_supported_kernel_versions) | **PUT** /params/supportedKernelVersions | 

# **get_infra_requirement_params**
> InfraRequirementParams get_infra_requirement_params(body)



Get Infrastructure Requirements Parameters

### Example
```python
from __future__ import print_function
import time
import tca.infra
from tca.infra.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.infra.CnfCatalogInfraRequirementsApi()
body = tca.infra.InfraRequirementsFilter() # InfraRequirementsFilter | 

try:
    api_response = api_instance.get_infra_requirement_params(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CnfCatalogInfraRequirementsApi->get_infra_requirement_params: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**InfraRequirementsFilter**](InfraRequirementsFilter.md)|  | 

### Return type

[**InfraRequirementParams**](InfraRequirementParams.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_infra_requirement_supported_kernel_versions**
> InfraRequirementSupportedKernelVersions get_infra_requirement_supported_kernel_versions()



Get Infrastructure Requirements Supported kernel versions

### Example
```python
from __future__ import print_function
import time
import tca.infra
from tca.infra.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.infra.CnfCatalogInfraRequirementsApi()

try:
    api_response = api_instance.get_infra_requirement_supported_kernel_versions()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CnfCatalogInfraRequirementsApi->get_infra_requirement_supported_kernel_versions: %s\n" % e)
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**InfraRequirementSupportedKernelVersions**](InfraRequirementSupportedKernelVersions.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_infra_requirement_supported_kernel_versions**
> InfraRequirementSupportedKernelVersions update_infra_requirement_supported_kernel_versions(body=body)



Update Infrastructure Requirements Supported kernel versions

### Example
```python
from __future__ import print_function
import time
import tca.infra
from tca.infra.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.infra.CnfCatalogInfraRequirementsApi()
body = tca.infra.InfraRequirementSupportedKernelVersions() # InfraRequirementSupportedKernelVersions |  (optional)

try:
    api_response = api_instance.update_infra_requirement_supported_kernel_versions(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CnfCatalogInfraRequirementsApi->update_infra_requirement_supported_kernel_versions: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**InfraRequirementSupportedKernelVersions**](InfraRequirementSupportedKernelVersions.md)|  | [optional] 

### Return type

[**InfraRequirementSupportedKernelVersions**](InfraRequirementSupportedKernelVersions.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

