# tca.cnf_lcm_v1.CnfLcmApi

All URIs are relative to */hybridity/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**configure_instantiate_vnf_instance**](CnfLcmApi.md#configure_instantiate_vnf_instance) | **POST** /hybridity/api/vnflcm/v1/vnf_instances/{instanceId}/configure_and_instantiate | 
[**scale_cnf_instance**](CnfLcmApi.md#scale_cnf_instance) | **POST** /vnflcm/v1/cnf_instances/{instanceId}/scale | 
[**upgrade_c_nf_instance**](CnfLcmApi.md#upgrade_c_nf_instance) | **POST** /vnflcm/v1/cnf_instances/{instanceId}/upgrade | 

# **configure_instantiate_vnf_instance**
> CnfResponse configure_instantiate_vnf_instance(body, instance_id)



Configure and Instantiate Network Function instance.

### Example
```python
from __future__ import print_function
import time
import tca.cnf_lcm_v1
from tca.cnf_lcm_v1.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cnf_lcm_v1.CnfLcmApi()
body = tca.cnf_lcm_v1.ConfigureInstantiatePayload() # ConfigureInstantiatePayload | 
instance_id = 'instance_id_example' # str | 

try:
    api_response = api_instance.configure_instantiate_vnf_instance(body, instance_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CnfLcmApi->configure_instantiate_vnf_instance: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ConfigureInstantiatePayload**](ConfigureInstantiatePayload.md)|  | 
 **instance_id** | **str**|  | 

### Return type

[**CnfResponse**](CnfResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **scale_cnf_instance**
> CnfResponse scale_cnf_instance(body, instance_id)



Scale CNF Instance

### Example
```python
from __future__ import print_function
import time
import tca.cnf_lcm_v1
from tca.cnf_lcm_v1.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cnf_lcm_v1.CnfLcmApi()
body = tca.cnf_lcm_v1.InstanceIdScaleBody() # InstanceIdScaleBody | 
instance_id = 'instance_id_example' # str | 

try:
    api_response = api_instance.scale_cnf_instance(body, instance_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CnfLcmApi->scale_cnf_instance: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**InstanceIdScaleBody**](InstanceIdScaleBody.md)|  | 
 **instance_id** | **str**|  | 

### Return type

[**CnfResponse**](CnfResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **upgrade_c_nf_instance**
> CnfResponse upgrade_c_nf_instance(body, instance_id)



Upgrade CNF Instance

### Example
```python
from __future__ import print_function
import time
import tca.cnf_lcm_v1
from tca.cnf_lcm_v1.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cnf_lcm_v1.CnfLcmApi()
body = tca.cnf_lcm_v1.CnfUpgradeRequest() # CnfUpgradeRequest | 
instance_id = 'instance_id_example' # str | 

try:
    api_response = api_instance.upgrade_c_nf_instance(body, instance_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CnfLcmApi->upgrade_c_nf_instance: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**CnfUpgradeRequest**](CnfUpgradeRequest.md)|  | 
 **instance_id** | **str**|  | 

### Return type

[**CnfResponse**](CnfResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

