# tca.system_management.DatacenterLocationApi

All URIs are relative to **

Method | HTTP request | Description
------------- | ------------- | -------------
[**api_admin_global_config_location_get**](DatacenterLocationApi.md#api_admin_global_config_location_get) | **GET** /api/admin/global/config/location | Get Location
[**api_admin_global_config_location_put**](DatacenterLocationApi.md#api_admin_global_config_location_put) | **PUT** /api/admin/global/config/location | Configure Location
[**api_admin_global_config_search_cities_get**](DatacenterLocationApi.md#api_admin_global_config_search_cities_get) | **GET** /api/admin/global/config/searchCities | Search Cities

# **api_admin_global_config_location_get**
> GeoLocation api_admin_global_config_location_get(accept, content_type)

Get Location

Api to get the datacenter location

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.DatacenterLocationApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Get Location
    api_response = api_instance.api_admin_global_config_location_get(accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DatacenterLocationApi->api_admin_global_config_location_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

[**GeoLocation**](GeoLocation.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_global_config_location_put**
> api_admin_global_config_location_put(body, accept, content_type)

Configure Location

Api to configure the datacenter location

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.DatacenterLocationApi(tca.system_management.ApiClient(configuration))
body = tca.system_management.GeoLocation() # GeoLocation | 
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Configure Location
    api_instance.api_admin_global_config_location_put(body, accept, content_type)
except ApiException as e:
    print("Exception when calling DatacenterLocationApi->api_admin_global_config_location_put: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**GeoLocation**](GeoLocation.md)|  | 
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

void (empty response body)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_global_config_search_cities_get**
> InlineResponse200 api_admin_global_config_search_cities_get(search_string, accept)

Search Cities

Api to search cities

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.DatacenterLocationApi(tca.system_management.ApiClient(configuration))
search_string = 'search_string_example' # str | 
accept = 'application/json' # str | application/json (default to application/json)

try:
    # Search Cities
    api_response = api_instance.api_admin_global_config_search_cities_get(search_string, accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DatacenterLocationApi->api_admin_global_config_search_cities_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **search_string** | **str**|  | 
 **accept** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse200**](InlineResponse200.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

