# tca.caas_v2_events.EventsApi

All URIs are relative to */telco/api/caas/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_events**](EventsApi.md#get_events) | **GET** /clusters/{clusterName}/events | API to get events for given workload cluster from TCA and K8s

# **get_events**
> EventList get_events(cluster_name, node_pool_name=node_pool_name, mgmt_cluster_name=mgmt_cluster_name, tca_cp_id=tca_cp_id, nextpage_opaque_marker=nextpage_opaque_marker, sort=sort, filter=filter)

API to get events for given workload cluster from TCA and K8s

API to get events for given workload cluster from TCA and K8s

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2_events
from tca.caas_v2_events.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2_events.EventsApi()
cluster_name = 'cluster_name_example' # str | Name of cluster for which events should be listed
node_pool_name = 'node_pool_name_example' # str | Name of the nodepool (optional)
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | Name of management cluster of the given cluster.  (optional)
tca_cp_id = 'tca_cp_id_example' # str | TCA-CP id of the given cluster (optional)
nextpage_opaque_marker = 'nextpage_opaque_marker_example' # str |  (optional)
sort = 'sort_example' # str |  (optional)
filter = 'filter_example' # str |  (optional)

try:
    # API to get events for given workload cluster from TCA and K8s
    api_response = api_instance.get_events(cluster_name, node_pool_name=node_pool_name, mgmt_cluster_name=mgmt_cluster_name, tca_cp_id=tca_cp_id, nextpage_opaque_marker=nextpage_opaque_marker, sort=sort, filter=filter)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EventsApi->get_events: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_name** | **str**| Name of cluster for which events should be listed | 
 **node_pool_name** | **str**| Name of the nodepool | [optional] 
 **mgmt_cluster_name** | **str**| Name of management cluster of the given cluster.  | [optional] 
 **tca_cp_id** | **str**| TCA-CP id of the given cluster | [optional] 
 **nextpage_opaque_marker** | **str**|  | [optional] 
 **sort** | **str**|  | [optional] 
 **filter** | **str**|  | [optional] 

### Return type

[**EventList**](EventList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

