# tca.svnfm.ExtensionApi

All URIs are relative to */hybridity/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**create_extension**](ExtensionApi.md#create_extension) | **POST** /extensions | 
[**create_svnfm_extension**](ExtensionApi.md#create_svnfm_extension) | **POST** /extensions/svnfms | 
[**delete_extension**](ExtensionApi.md#delete_extension) | **DELETE** /extensions/{extensionId} | 
[**edit_extension**](ExtensionApi.md#edit_extension) | **POST** /extensions/{extensionId} | 
[**edit_svnfm_extension**](ExtensionApi.md#edit_svnfm_extension) | **POST** /extensions/svnfms/{extensionId} | 
[**get_extension**](ExtensionApi.md#get_extension) | **GET** /extensions/{extensionId} | 
[**get_extension_subtype**](ExtensionApi.md#get_extension_subtype) | **GET** /extensions/svnfms | 
[**get_extensions**](ExtensionApi.md#get_extensions) | **GET** /extensions | 
[**get_extensions_type**](ExtensionApi.md#get_extensions_type) | **GET** /extensions/types | 
[**get_svnfm_packages**](ExtensionApi.md#get_svnfm_packages) | **GET** /extensions/svnfms/{extensionId}/packages | 
[**get_svnfm_vnf_instances**](ExtensionApi.md#get_svnfm_vnf_instances) | **GET** /extensions/svnfms/{extensionId}/vnfInstances | 
[**register_svnfm_packages**](ExtensionApi.md#register_svnfm_packages) | **POST** /extensions/svnfms/{extensionId}/packages | 

# **create_extension**
> CreateSvnfmExtensionResponse create_extension(body=body)



To create Extension

### Example
```python
from __future__ import print_function
import time
import tca.svnfm
from tca.svnfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.svnfm.ExtensionApi()
body = tca.svnfm.Extension() # Extension |  (optional)

try:
    api_response = api_instance.create_extension(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ExtensionApi->create_extension: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Extension**](Extension.md)|  | [optional] 

### Return type

[**CreateSvnfmExtensionResponse**](CreateSvnfmExtensionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **create_svnfm_extension**
> CreateSvnfmExtensionResponse create_svnfm_extension(body=body)



To create SVNFM Extension

### Example
```python
from __future__ import print_function
import time
import tca.svnfm
from tca.svnfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.svnfm.ExtensionApi()
body = tca.svnfm.CreateSvnfmExtension() # CreateSvnfmExtension |  (optional)

try:
    api_response = api_instance.create_svnfm_extension(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ExtensionApi->create_svnfm_extension: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**CreateSvnfmExtension**](CreateSvnfmExtension.md)|  | [optional] 

### Return type

[**CreateSvnfmExtensionResponse**](CreateSvnfmExtensionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_extension**
> CreateSvnfmExtensionResponse delete_extension(extension_id)



Deletes the Extension based on the extensionId provided

### Example
```python
from __future__ import print_function
import time
import tca.svnfm
from tca.svnfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.svnfm.ExtensionApi()
extension_id = 'extension_id_example' # str | 

try:
    api_response = api_instance.delete_extension(extension_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ExtensionApi->delete_extension: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **extension_id** | **str**|  | 

### Return type

[**CreateSvnfmExtensionResponse**](CreateSvnfmExtensionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **edit_extension**
> CreateSvnfmExtensionResponse edit_extension(body, extension_id)



Modifies Extension with the details provided for the specified extensionId

### Example
```python
from __future__ import print_function
import time
import tca.svnfm
from tca.svnfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.svnfm.ExtensionApi()
body = tca.svnfm.CreateSvnfmExtension() # CreateSvnfmExtension | 
extension_id = 'extension_id_example' # str | 

try:
    api_response = api_instance.edit_extension(body, extension_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ExtensionApi->edit_extension: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**CreateSvnfmExtension**](CreateSvnfmExtension.md)|  | 
 **extension_id** | **str**|  | 

### Return type

[**CreateSvnfmExtensionResponse**](CreateSvnfmExtensionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **edit_svnfm_extension**
> CreateSvnfmExtensionResponse edit_svnfm_extension(body, extension_id)



Modifies or Create SVNFM Extension with the details provided for the specified extensionId

### Example
```python
from __future__ import print_function
import time
import tca.svnfm
from tca.svnfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.svnfm.ExtensionApi()
body = tca.svnfm.CreateSvnfmExtension() # CreateSvnfmExtension | 
extension_id = 'extension_id_example' # str | 

try:
    api_response = api_instance.edit_svnfm_extension(body, extension_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ExtensionApi->edit_svnfm_extension: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**CreateSvnfmExtension**](CreateSvnfmExtension.md)|  | 
 **extension_id** | **str**|  | 

### Return type

[**CreateSvnfmExtensionResponse**](CreateSvnfmExtensionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_extension**
> Extensions get_extension(extension_id)



Lists the Extension details with given extensionId

### Example
```python
from __future__ import print_function
import time
import tca.svnfm
from tca.svnfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.svnfm.ExtensionApi()
extension_id = 'extension_id_example' # str | 

try:
    api_response = api_instance.get_extension(extension_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ExtensionApi->get_extension: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **extension_id** | **str**|  | 

### Return type

[**Extensions**](Extensions.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_extension_subtype**
> InlineResponse200 get_extension_subtype(extension_subtype)



Get SVNFM extensionSubtype

### Example
```python
from __future__ import print_function
import time
import tca.svnfm
from tca.svnfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.svnfm.ExtensionApi()
extension_subtype = 'extension_subtype_example' # str | 

try:
    api_response = api_instance.get_extension_subtype(extension_subtype)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ExtensionApi->get_extension_subtype: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **extension_subtype** | **str**|  | 

### Return type

[**InlineResponse200**](InlineResponse200.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_extensions**
> Extensions get_extensions()



Get all Extension

### Example
```python
from __future__ import print_function
import time
import tca.svnfm
from tca.svnfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.svnfm.ExtensionApi()

try:
    api_response = api_instance.get_extensions()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ExtensionApi->get_extensions: %s\n" % e)
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**Extensions**](Extensions.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_extensions_type**
> InlineResponse2002 get_extensions_type()



Lists Extension types

### Example
```python
from __future__ import print_function
import time
import tca.svnfm
from tca.svnfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.svnfm.ExtensionApi()

try:
    api_response = api_instance.get_extensions_type()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ExtensionApi->get_extensions_type: %s\n" % e)
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**InlineResponse2002**](InlineResponse2002.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_svnfm_packages**
> SvnfmPackages get_svnfm_packages(extension_id)



Get packages for specified SVNFM Extension

### Example
```python
from __future__ import print_function
import time
import tca.svnfm
from tca.svnfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.svnfm.ExtensionApi()
extension_id = 'extension_id_example' # str | 

try:
    api_response = api_instance.get_svnfm_packages(extension_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ExtensionApi->get_svnfm_packages: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **extension_id** | **str**|  | 

### Return type

[**SvnfmPackages**](SvnfmPackages.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_svnfm_vnf_instances**
> InlineResponse2001 get_svnfm_vnf_instances(extension_id)



Get vnfInstances for specified SVNFM Extension

### Example
```python
from __future__ import print_function
import time
import tca.svnfm
from tca.svnfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.svnfm.ExtensionApi()
extension_id = 'extension_id_example' # str | 

try:
    api_response = api_instance.get_svnfm_vnf_instances(extension_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ExtensionApi->get_svnfm_vnf_instances: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **extension_id** | **str**|  | 

### Return type

[**InlineResponse2001**](InlineResponse2001.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **register_svnfm_packages**
> RegisterSvnfmPackagesResponse register_svnfm_packages(body, extension_id)



Register package for SVNFM Extension

### Example
```python
from __future__ import print_function
import time
import tca.svnfm
from tca.svnfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.svnfm.ExtensionApi()
body = [tca.svnfm.SvnfmPackagesInner()] # list[SvnfmPackagesInner] | 
extension_id = 'extension_id_example' # str | 

try:
    api_response = api_instance.register_svnfm_packages(body, extension_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ExtensionApi->register_svnfm_packages: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**list[SvnfmPackagesInner]**](SvnfmPackagesInner.md)|  | 
 **extension_id** | **str**|  | 

### Return type

[**RegisterSvnfmPackagesResponse**](RegisterSvnfmPackagesResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

