# tca.caas_k8s_generic_cr.GenericCrApi

All URIs are relative to */telco/api/caas/v2/k8sresources*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_tca_bom_release**](GenericCrApi.md#get_tca_bom_release) | **GET** /telco.vmware.com/v1alpha1/namespaces/tca-system/tcabomreleases/{name} | Api to get a TCA BOM release with a given name
[**get_workload_cluster_kube_config**](GenericCrApi.md#get_workload_cluster_kube_config) | **GET** /secrets/{workload-cluster-name}/{secret-name} | Api to fetch kubeconfig for workload cluster
[**list_tca_bom_releases**](GenericCrApi.md#list_tca_bom_releases) | **GET** /telco.vmware.com/v1alpha1/namespaces/tca-system/tcabomreleases | Api to fetch TCA BOM releases

# **get_tca_bom_release**
> str get_tca_bom_release(name, tca_cp_id=tca_cp_id, mgmt_cluster_name=mgmt_cluster_name, tca_cluster=tca_cluster)

Api to get a TCA BOM release with a given name

Api to get a TCA BOM release with a given name

### Example
```python
from __future__ import print_function
import time
import tca.caas_k8s_generic_cr
from tca.caas_k8s_generic_cr.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_k8s_generic_cr.GenericCrApi()
name = 'name_example' # str | name of the TCA bom release resource
tca_cp_id = 'tca_cp_id_example' # str | tcaCpId where the management cluster is deployed. tcaCpId is the hcxUUID in the response of get cluster by Id API call for management cluster. (optional)
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | name of the management cluster where the request needs to be executed (optional)
tca_cluster = true # bool | If the request has to be executed on the tcaCluster (optional)

try:
    # Api to get a TCA BOM release with a given name
    api_response = api_instance.get_tca_bom_release(name, tca_cp_id=tca_cp_id, mgmt_cluster_name=mgmt_cluster_name, tca_cluster=tca_cluster)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling GenericCrApi->get_tca_bom_release: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **str**| name of the TCA bom release resource | 
 **tca_cp_id** | **str**| tcaCpId where the management cluster is deployed. tcaCpId is the hcxUUID in the response of get cluster by Id API call for management cluster. | [optional] 
 **mgmt_cluster_name** | **str**| name of the management cluster where the request needs to be executed | [optional] 
 **tca_cluster** | **bool**| If the request has to be executed on the tcaCluster | [optional] 

### Return type

**str**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_workload_cluster_kube_config**
> str get_workload_cluster_kube_config(workload_cluster_name, secret_name, tca_cp_id=tca_cp_id, mgmt_cluster_name=mgmt_cluster_name, tca_cluster=tca_cluster)

Api to fetch kubeconfig for workload cluster

Api to fetch kubeconfig for workload cluster

### Example
```python
from __future__ import print_function
import time
import tca.caas_k8s_generic_cr
from tca.caas_k8s_generic_cr.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_k8s_generic_cr.GenericCrApi()
workload_cluster_name = 'workload_cluster_name_example' # str | name of the workload cluster
secret_name = 'secret_name_example' # str | name of the workload cluster followed by \"-kubeconfig\"
tca_cp_id = 'tca_cp_id_example' # str | tcaCpId where the management cluster is deployed. tcaCpId is the hcxUUID in the response of get cluster by Id API call for management cluster. (optional)
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | name of the management cluster where the request needs to be executed (optional)
tca_cluster = true # bool | If the request has to be executed on the tcaCluster (optional)

try:
    # Api to fetch kubeconfig for workload cluster
    api_response = api_instance.get_workload_cluster_kube_config(workload_cluster_name, secret_name, tca_cp_id=tca_cp_id, mgmt_cluster_name=mgmt_cluster_name, tca_cluster=tca_cluster)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling GenericCrApi->get_workload_cluster_kube_config: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **workload_cluster_name** | **str**| name of the workload cluster | 
 **secret_name** | **str**| name of the workload cluster followed by \&quot;-kubeconfig\&quot; | 
 **tca_cp_id** | **str**| tcaCpId where the management cluster is deployed. tcaCpId is the hcxUUID in the response of get cluster by Id API call for management cluster. | [optional] 
 **mgmt_cluster_name** | **str**| name of the management cluster where the request needs to be executed | [optional] 
 **tca_cluster** | **bool**| If the request has to be executed on the tcaCluster | [optional] 

### Return type

**str**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **list_tca_bom_releases**
> str list_tca_bom_releases(tca_cp_id=tca_cp_id, mgmt_cluster_name=mgmt_cluster_name, tca_cluster=tca_cluster, _continue=_continue)

Api to fetch TCA BOM releases

Api to fetch TCA BOM releases

### Example
```python
from __future__ import print_function
import time
import tca.caas_k8s_generic_cr
from tca.caas_k8s_generic_cr.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_k8s_generic_cr.GenericCrApi()
tca_cp_id = 'tca_cp_id_example' # str | tcaCpId where the management cluster is deployed. tcaCpId is the hcxUUID in the response of get cluster by Id API call for management cluster. (optional)
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | name of the management cluster where the request needs to be executed (optional)
tca_cluster = true # bool | If the request has to be executed on the tcaCluster (minikube) (optional)
_continue = '_continue_example' # str | Used to fetch the next set of resources if the list is large (optional)

try:
    # Api to fetch TCA BOM releases
    api_response = api_instance.list_tca_bom_releases(tca_cp_id=tca_cp_id, mgmt_cluster_name=mgmt_cluster_name, tca_cluster=tca_cluster, _continue=_continue)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling GenericCrApi->list_tca_bom_releases: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tca_cp_id** | **str**| tcaCpId where the management cluster is deployed. tcaCpId is the hcxUUID in the response of get cluster by Id API call for management cluster. | [optional] 
 **mgmt_cluster_name** | **str**| name of the management cluster where the request needs to be executed | [optional] 
 **tca_cluster** | **bool**| If the request has to be executed on the tcaCluster (minikube) | [optional] 
 **_continue** | **str**| Used to fetch the next set of resources if the list is large | [optional] 

### Return type

**str**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

