# tca.tcfm.HostProfileApi

All URIs are relative to */hybridity/api/*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_host_profile_associations_by_vc**](HostProfileApi.md#get_host_profile_associations_by_vc) | **POST** /ztp/hostprofile/domains/vc | Get Host Profile domain associations linked to specified VC
[**get_host_profile_domains_by_host_profile_names**](HostProfileApi.md#get_host_profile_domains_by_host_profile_names) | **POST** /ztp/hostprofile/domains/hcp | Get Host Profile domains linked to specified host profile names
[**get_host_profile_filters_by_section**](HostProfileApi.md#get_host_profile_filters_by_section) | **GET** /ztp/hostprofile/filters/{section} | Get supported filter names in specified section of Host Profile spec

# **get_host_profile_associations_by_vc**
> HostProfileAssociationsByVcResponse get_host_profile_associations_by_vc(body)

Get Host Profile domain associations linked to specified VC

Get Host Profile domain asociations linked to VC with provided IP/FQDN. The domains will also include any any child Compute Cluster and Cell Site Group domains that are managed by this VC. 

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.HostProfileApi()
body = tca.tcfm.HostProfileAssociationsByVcRequest() # HostProfileAssociationsByVcRequest | 

try:
    # Get Host Profile domain associations linked to specified VC
    api_response = api_instance.get_host_profile_associations_by_vc(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling HostProfileApi->get_host_profile_associations_by_vc: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**HostProfileAssociationsByVcRequest**](HostProfileAssociationsByVcRequest.md)|  | 

### Return type

[**HostProfileAssociationsByVcResponse**](HostProfileAssociationsByVcResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_host_profile_domains_by_host_profile_names**
> HostProfileDomainsByHcpResponse get_host_profile_domains_by_host_profile_names(body)

Get Host Profile domains linked to specified host profile names

Get Host Profile domains linked to specified host profile names

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.HostProfileApi()
body = tca.tcfm.HostProfileDomainsByHcpRequest() # HostProfileDomainsByHcpRequest | 

try:
    # Get Host Profile domains linked to specified host profile names
    api_response = api_instance.get_host_profile_domains_by_host_profile_names(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling HostProfileApi->get_host_profile_domains_by_host_profile_names: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**HostProfileDomainsByHcpRequest**](HostProfileDomainsByHcpRequest.md)|  | 

### Return type

[**HostProfileDomainsByHcpResponse**](HostProfileDomainsByHcpResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_host_profile_filters_by_section**
> HostProfilePciFilters get_host_profile_filters_by_section(section)

Get supported filter names in specified section of Host Profile spec

Get supported filter names in specified section of Host Profile spec

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.HostProfileApi()
section = 'section_example' # str | Section

try:
    # Get supported filter names in specified section of Host Profile spec
    api_response = api_instance.get_host_profile_filters_by_section(section)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling HostProfileApi->get_host_profile_filters_by_section: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **section** | **str**| Section | 

### Return type

[**HostProfilePciFilters**](HostProfilePciFilters.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

