# tca.tcfm.HostsApi

All URIs are relative to */hybridity/api/*

Method | HTTP request | Description
------------- | ------------- | -------------
[**add_hosts**](HostsApi.md#add_hosts) | **POST** /ztp/hosts | Add hosts
[**delete_hosts**](HostsApi.md#delete_hosts) | **POST** /ztp/domains/{domain_name}/deletehosts | Delete hosts
[**edit_hosts**](HostsApi.md#edit_hosts) | **PUT** /ztp/hosts | Edit hosts

# **add_hosts**
> Response add_hosts(body, api_key=api_key)

Add hosts

Add hosts

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.HostsApi()
body = tca.tcfm.HostsAddRequest() # HostsAddRequest | 
api_key = 'api_key_example' # str | api key header parameter (optional)

try:
    # Add hosts
    api_response = api_instance.add_hosts(body, api_key=api_key)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling HostsApi->add_hosts: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**HostsAddRequest**](HostsAddRequest.md)|  | 
 **api_key** | **str**| api key header parameter | [optional] 

### Return type

[**Response**](Response.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_hosts**
> Response delete_hosts(body, domain_name)

Delete hosts

Delete hosts

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.HostsApi()
body = tca.tcfm.HostsDeleteRequest() # HostsDeleteRequest | 
domain_name = 'domain_name_example' # str | Domain Name

try:
    # Delete hosts
    api_response = api_instance.delete_hosts(body, domain_name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling HostsApi->delete_hosts: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**HostsDeleteRequest**](HostsDeleteRequest.md)|  | 
 **domain_name** | **str**| Domain Name | 

### Return type

[**Response**](Response.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **edit_hosts**
> Response edit_hosts(body, api_key=api_key)

Edit hosts

Add hosts

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.HostsApi()
body = tca.tcfm.HostsAddRequest() # HostsAddRequest | 
api_key = 'api_key_example' # str | api key header parameter (optional)

try:
    # Edit hosts
    api_response = api_instance.edit_hosts(body, api_key=api_key)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling HostsApi->edit_hosts: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**HostsAddRequest**](HostsAddRequest.md)|  | 
 **api_key** | **str**| api key header parameter | [optional] 

### Return type

[**Response**](Response.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

