# tca.cluster.InfraApi

All URIs are relative to */hybridity/api/*

Method | HTTP request | Description
------------- | ------------- | -------------
[**abort_cluster_operation**](InfraApi.md#abort_cluster_operation) | **POST** /infra/k8s/operations/{operationId}/abort | Api to abort K8s cluster operation (Deprecated for workload clusters)
[**change_cluster_password**](InfraApi.md#change_cluster_password) | **PUT** /infra/k8s/clusters/{id}/changePassword | Api to edit Cluster password (Deprecated for workload clusters)
[**create_cluster_node_pool**](InfraApi.md#create_cluster_node_pool) | **POST** /infra/k8s/cluster/{clusterId}/nodepool | Api to create k8s cluster ndoe pools (Deprecated for workload clusters)
[**delete_node_pool**](InfraApi.md#delete_node_pool) | **DELETE** /infra/k8s/cluster/{clusterId}/nodepool/{nodePoolId} | Api to delete K8 cluster node pool for Telco Cloud Automation (Deprecated for workload clusters)
[**deploy_cluster**](InfraApi.md#deploy_cluster) | **POST** /infra/k8s/clusters | Api to deploy Kubernetes Cluster for Telco Cloud Automation (Deprecated for workload clusters)
[**edit_cluster**](InfraApi.md#edit_cluster) | **PUT** /infra/k8s/clusters/{clusterId} | Api to edit a cluster for Telco Cloud Automation (Deprecated for workload clusters)
[**edit_cluster_config**](InfraApi.md#edit_cluster_config) | **PUT** /infra/k8s/cluster/{clusterId}/configurations | Api to edit cluster config (Deprecated for workload clusters)
[**edit_node_pool**](InfraApi.md#edit_node_pool) | **PUT** /infra/k8s/cluster/{clusterId}/nodepool/{nodePoolId} | Api to edit a node pool (Deprecated for workload clusters)
[**genereate_spec**](InfraApi.md#genereate_spec) | **POST** /infra/k8s/clusters/{clusterId} | Api to collect the specifications of the cluster (Deprecated for workload clusters)
[**get_cluster_config**](InfraApi.md#get_cluster_config) | **GET** /infra/k8s/cluster/{clusterId}/configurations | Api to get cluster configurations (Deprecated for workload clusters)
[**get_clusters**](InfraApi.md#get_clusters) | **GET** /infra/k8s/clusters | Api to get clusters for Telco Cloud Automation (Deprecated for workload clusters)
[**get_clusters_node_pools**](InfraApi.md#get_clusters_node_pools) | **GET** /infra/k8s/cluster/{clusterId}/nodepools | Api to get node pools for Telco Cloud Automation (Deprecated for workload clusters)
[**get_k8_cluster_node_pool**](InfraApi.md#get_k8_cluster_node_pool) | **GET** /infra/k8s/cluster/{clusterId}/nodepool/{nodePoolId} | Api to get K8 cluster node pool for Telco Cloud Automation (Deprecated for workload clusters)
[**get_node_pool_customization**](InfraApi.md#get_node_pool_customization) | **GET** /infra/k8s/cluster/{clusterId}/nodepool/{nodePoolId}/customization | Api to get nodepool customizations (Deprecated for workload clusters)
[**kuberenetes_version_upgrade_matrix**](InfraApi.md#kuberenetes_version_upgrade_matrix) | **POST** /infra/k8s/k8sVersionUpgradeMatrix/query | Api to get the K8s versions upgrade matrix for Telco Cloud Automation (Deprecated for workload clusters)
[**pause_node_pool**](InfraApi.md#pause_node_pool) | **PUT** /infra/k8s/cluster/{clusterId}/nodepool/{nodePoolId}/pause | Pause a Nodepool in a cluster (Deprecated for workload clusters)
[**retry_cluster_operation**](InfraApi.md#retry_cluster_operation) | **POST** /infra/k8s/operations/{operationId}/retry | Api to retry K8s cluster operation (Deprecated for workload clusters)
[**supported_kubernetes_versions**](InfraApi.md#supported_kubernetes_versions) | **GET** /infra/k8s/supportedK8sVersions | Api to get all the supported  K8s versions of cluster for Telco Cloud Automation (Deprecated for workload clusters)
[**sync_esx_info**](InfraApi.md#sync_esx_info) | **PUT** /infra/k8s/clusters/{id}/esxinfo | Api to sync Esx Info for Workload Clusters on demand
[**transform_cluster**](InfraApi.md#transform_cluster) | **PUT** /infra/k8s/clusters/{id}/transform | Api to transform cluster from v1 to v2.
[**unpause_node_pool**](InfraApi.md#unpause_node_pool) | **PUT** /infra/k8s/cluster/{clusterId}/nodepool/{nodePoolId}/unpause | Unpause a Nodepool in a cluster (Deprecated for workload clusters)
[**upgrade_cluster**](InfraApi.md#upgrade_cluster) | **PUT** /infra/k8s/clusters/{id}/k8sUpgrade | Api to upgrade K8s version of Cluster for Telco Cloud Automation (Deprecated for workload clusters)
[**upgrade_cluster_addon**](InfraApi.md#upgrade_cluster_addon) | **PUT** /infra/k8s/clusters/{id}/upgradeAddon | Api to upgrade addons on the cluster (Deprecated for workload clusters)
[**upgrade_history**](InfraApi.md#upgrade_history) | **GET** /infra/k8s/clusters/{id}/k8sUpgradeHistory | Api to get the K8s versions upgrade history of cluster for Telco Cloud Automation (Deprecated for workload clusters)
[**upgrade_node_pool**](InfraApi.md#upgrade_node_pool) | **POST** /infra/k8s/cluster/{clusterId}/nodepool/{nodePoolId}/upgrade | Api to upgrade K8 cluster node pool for Telco Cloud Automation (Deprecated for workload clusters)
[**validate_upgrade_cluster**](InfraApi.md#validate_upgrade_cluster) | **GET** /infra/k8s/clusters/{id}/k8sUpgradeValidationResponse | Api to validate  K8s version upgrade of Cluster for Telco Cloud Automation (Deprecated for workload clusters)
[**vsphere_csi_zone_support**](InfraApi.md#vsphere_csi_zone_support) | **GET** /infra/k8s/clusters/{id}/vSphereCsiZoneSupport | Api to verify whether vsphere csi zone support is present. (Deprecated for workload clusters)

# **abort_cluster_operation**
> ClusterAPIResponse abort_cluster_operation(operation_id)

Api to abort K8s cluster operation (Deprecated for workload clusters)

Abort K8s Cluster Operation

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
operation_id = 'operation_id_example' # str | 

try:
    # Api to abort K8s cluster operation (Deprecated for workload clusters)
    api_response = api_instance.abort_cluster_operation(operation_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->abort_cluster_operation: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **operation_id** | **str**|  | 

### Return type

[**ClusterAPIResponse**](ClusterAPIResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **change_cluster_password**
> ClusterAPIResponse change_cluster_password(body, id)

Api to edit Cluster password (Deprecated for workload clusters)

Api to edit Cluster password

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
body = tca.cluster.IdChangePasswordBody() # IdChangePasswordBody | Edit Cluster Password
id = 'id_example' # str | 

try:
    # Api to edit Cluster password (Deprecated for workload clusters)
    api_response = api_instance.change_cluster_password(body, id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->change_cluster_password: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**IdChangePasswordBody**](IdChangePasswordBody.md)| Edit Cluster Password | 
 **id** | **str**|  | 

### Return type

[**ClusterAPIResponse**](ClusterAPIResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **create_cluster_node_pool**
> ClusterAPIResponse create_cluster_node_pool(body, cluster_id)

Api to create k8s cluster ndoe pools (Deprecated for workload clusters)

Create K8 cluster Node Pools

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
body = tca.cluster.NodePool() # NodePool | create cluster node pool
cluster_id = 'cluster_id_example' # str | 

try:
    # Api to create k8s cluster ndoe pools (Deprecated for workload clusters)
    api_response = api_instance.create_cluster_node_pool(body, cluster_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->create_cluster_node_pool: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**NodePool**](NodePool.md)| create cluster node pool | 
 **cluster_id** | **str**|  | 

### Return type

[**ClusterAPIResponse**](ClusterAPIResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_node_pool**
> ClusterAPIResponse delete_node_pool(cluster_id, node_pool_id, is_force=is_force)

Api to delete K8 cluster node pool for Telco Cloud Automation (Deprecated for workload clusters)

Delete K8 cluster node pool

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
cluster_id = 'cluster_id_example' # str | 
node_pool_id = 'node_pool_id_example' # str | 
is_force = false # bool | Flag to force delete node pool related info from bootstrapper (optional) (default to false)

try:
    # Api to delete K8 cluster node pool for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.delete_node_pool(cluster_id, node_pool_id, is_force=is_force)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->delete_node_pool: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_id** | **str**|  | 
 **node_pool_id** | **str**|  | 
 **is_force** | **bool**| Flag to force delete node pool related info from bootstrapper | [optional] [default to false]

### Return type

[**ClusterAPIResponse**](ClusterAPIResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **deploy_cluster**
> ClusterAPIResponse deploy_cluster(body)

Api to deploy Kubernetes Cluster for Telco Cloud Automation (Deprecated for workload clusters)

Api to deploy Kubernetes Cluster for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
body = tca.cluster.ClusterRequest() # ClusterRequest | create cluster

try:
    # Api to deploy Kubernetes Cluster for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.deploy_cluster(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->deploy_cluster: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ClusterRequest**](ClusterRequest.md)| create cluster | 

### Return type

[**ClusterAPIResponse**](ClusterAPIResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **edit_cluster**
> ClusterAPIResponse edit_cluster(body, cluster_id)

Api to edit a cluster for Telco Cloud Automation (Deprecated for workload clusters)

Api to edit a cluster for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
body = tca.cluster.Cluster() # Cluster | Edit cluster
cluster_id = 'cluster_id_example' # str | 

try:
    # Api to edit a cluster for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.edit_cluster(body, cluster_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->edit_cluster: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Cluster**](Cluster.md)| Edit cluster | 
 **cluster_id** | **str**|  | 

### Return type

[**ClusterAPIResponse**](ClusterAPIResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **edit_cluster_config**
> ClusterAPIResponse edit_cluster_config(body, cluster_id)

Api to edit cluster config (Deprecated for workload clusters)

Api to edit cluster config

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
body = tca.cluster.ClusterConfigurations() # ClusterConfigurations | Edit Cluster Config
cluster_id = 'cluster_id_example' # str | 

try:
    # Api to edit cluster config (Deprecated for workload clusters)
    api_response = api_instance.edit_cluster_config(body, cluster_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->edit_cluster_config: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ClusterConfigurations**](ClusterConfigurations.md)| Edit Cluster Config | 
 **cluster_id** | **str**|  | 

### Return type

[**ClusterAPIResponse**](ClusterAPIResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **edit_node_pool**
> ClusterAPIResponse edit_node_pool(body, cluster_id, node_pool_id)

Api to edit a node pool (Deprecated for workload clusters)

Api to edit a nodepool

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
body = tca.cluster.NodePool() # NodePool | edit cluster node pool
cluster_id = 'cluster_id_example' # str | 
node_pool_id = 'node_pool_id_example' # str | 

try:
    # Api to edit a node pool (Deprecated for workload clusters)
    api_response = api_instance.edit_node_pool(body, cluster_id, node_pool_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->edit_node_pool: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**NodePool**](NodePool.md)| edit cluster node pool | 
 **cluster_id** | **str**|  | 
 **node_pool_id** | **str**|  | 

### Return type

[**ClusterAPIResponse**](ClusterAPIResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **genereate_spec**
> ClusterSpec genereate_spec(cluster_id, action)

Api to collect the specifications of the cluster (Deprecated for workload clusters)

Collects the specifications of the cluster and returns back the payload which can be used to deploy cluster of the same configuration. It may result in creation of new cluster template as well.

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
cluster_id = 'cluster_id_example' # str | 
action = 'action_example' # str | 

try:
    # Api to collect the specifications of the cluster (Deprecated for workload clusters)
    api_response = api_instance.genereate_spec(cluster_id, action)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->genereate_spec: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_id** | **str**|  | 
 **action** | **str**|  | 

### Return type

[**ClusterSpec**](ClusterSpec.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_cluster_config**
> ClusterConfigurations get_cluster_config(cluster_id)

Api to get cluster configurations (Deprecated for workload clusters)

Get K8 cluster configurations

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
cluster_id = 'cluster_id_example' # str | 

try:
    # Api to get cluster configurations (Deprecated for workload clusters)
    api_response = api_instance.get_cluster_config(cluster_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->get_cluster_config: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_id** | **str**|  | 

### Return type

[**ClusterConfigurations**](ClusterConfigurations.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_clusters**
> list[Cluster] get_clusters(x_tca_anymatch=x_tca_anymatch, skip_nodes_info=skip_nodes_info, filter=filter, fields=fields, sort=sort, nextpage_opaque_marker=nextpage_opaque_marker)

Api to get clusters for Telco Cloud Automation (Deprecated for workload clusters)

Api to get clusters for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
x_tca_anymatch = 'x_tca_anymatch_example' # str | Flag to indicate OR match is requested for filter sub-expressions. If set to true, response based on OR match is returned. (optional)
skip_nodes_info = 'skip_nodes_info_example' # str | Flag to skip nodes information as part of api response. If set to true, response will not have nodes information. Nodes information can be queried directly from Kubernetes cluster API instead. (optional)
filter = 'filter_example' # str | Attribute-based filtering expression. Attributes which are supported in filter expression are clusterName, clusterType, vsphereClusterName, managementClusterId, status, clusterConfig.kubernetesVersion, lastUpdated (optional)
fields = 'fields_example' # str | Attributes which should be included in the response (optional)
sort = 'sort_example' # str | Attribute based sorting expression. Same attributes as filter expression are supported for sort expression. (optional)
nextpage_opaque_marker = 'nextpage_opaque_marker_example' # str | Marker to obtain the next page of a paged response. If not present, API will return first page of response with page size 10. (optional)

try:
    # Api to get clusters for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.get_clusters(x_tca_anymatch=x_tca_anymatch, skip_nodes_info=skip_nodes_info, filter=filter, fields=fields, sort=sort, nextpage_opaque_marker=nextpage_opaque_marker)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->get_clusters: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **x_tca_anymatch** | **str**| Flag to indicate OR match is requested for filter sub-expressions. If set to true, response based on OR match is returned. | [optional] 
 **skip_nodes_info** | **str**| Flag to skip nodes information as part of api response. If set to true, response will not have nodes information. Nodes information can be queried directly from Kubernetes cluster API instead. | [optional] 
 **filter** | **str**| Attribute-based filtering expression. Attributes which are supported in filter expression are clusterName, clusterType, vsphereClusterName, managementClusterId, status, clusterConfig.kubernetesVersion, lastUpdated | [optional] 
 **fields** | **str**| Attributes which should be included in the response | [optional] 
 **sort** | **str**| Attribute based sorting expression. Same attributes as filter expression are supported for sort expression. | [optional] 
 **nextpage_opaque_marker** | **str**| Marker to obtain the next page of a paged response. If not present, API will return first page of response with page size 10. | [optional] 

### Return type

[**list[Cluster]**](Cluster.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_clusters_node_pools**
> NodePoolList get_clusters_node_pools(cluster_id, skip_nodes_info=skip_nodes_info)

Api to get node pools for Telco Cloud Automation (Deprecated for workload clusters)

Api to get node pools for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
cluster_id = 'cluster_id_example' # str | 
skip_nodes_info = 'skip_nodes_info_example' # str | Flag to skip nodes information as part of api response. If set to true, response will not have nodes information. Nodes information can be queried directly from Kubernetes cluster API instead. Nodes belonging to a nodepool can be filtered by label with key telco.vmware.com/nodepool and value clustername-nodepoolname (optional)

try:
    # Api to get node pools for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.get_clusters_node_pools(cluster_id, skip_nodes_info=skip_nodes_info)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->get_clusters_node_pools: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_id** | **str**|  | 
 **skip_nodes_info** | **str**| Flag to skip nodes information as part of api response. If set to true, response will not have nodes information. Nodes information can be queried directly from Kubernetes cluster API instead. Nodes belonging to a nodepool can be filtered by label with key telco.vmware.com/nodepool and value clustername-nodepoolname | [optional] 

### Return type

[**NodePoolList**](NodePoolList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_k8_cluster_node_pool**
> NodePool get_k8_cluster_node_pool(cluster_id, node_pool_id, skip_nodes_info=skip_nodes_info)

Api to get K8 cluster node pool for Telco Cloud Automation (Deprecated for workload clusters)

Get K8 cluster node pool

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
cluster_id = 'cluster_id_example' # str | 
node_pool_id = 'node_pool_id_example' # str | 
skip_nodes_info = 'skip_nodes_info_example' # str | Flag to skip nodes information as part of api response. If set to true, response will not have nodes information. Nodes information can be queried directly from Kubernetes cluster API instead. Nodes belonging to a nodepool can be filtered by label with key telco.vmware.com/nodepool and value clustername-nodepoolname. (optional)

try:
    # Api to get K8 cluster node pool for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.get_k8_cluster_node_pool(cluster_id, node_pool_id, skip_nodes_info=skip_nodes_info)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->get_k8_cluster_node_pool: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_id** | **str**|  | 
 **node_pool_id** | **str**|  | 
 **skip_nodes_info** | **str**| Flag to skip nodes information as part of api response. If set to true, response will not have nodes information. Nodes information can be queried directly from Kubernetes cluster API instead. Nodes belonging to a nodepool can be filtered by label with key telco.vmware.com/nodepool and value clustername-nodepoolname. | [optional] 

### Return type

[**NodePool**](NodePool.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_node_pool_customization**
> object get_node_pool_customization(cluster_id, node_pool_id)

Api to get nodepool customizations (Deprecated for workload clusters)

Get nodepool customizations

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
cluster_id = 'cluster_id_example' # str | 
node_pool_id = 'node_pool_id_example' # str | 

try:
    # Api to get nodepool customizations (Deprecated for workload clusters)
    api_response = api_instance.get_node_pool_customization(cluster_id, node_pool_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->get_node_pool_customization: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_id** | **str**|  | 
 **node_pool_id** | **str**|  | 

### Return type

**object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **kuberenetes_version_upgrade_matrix**
> UpgradeMatrixList kuberenetes_version_upgrade_matrix(body)

Api to get the K8s versions upgrade matrix for Telco Cloud Automation (Deprecated for workload clusters)

Api to get the K8s versions upgrade matrix for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
body = tca.cluster.Filter() # Filter | Filter object.

try:
    # Api to get the K8s versions upgrade matrix for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.kuberenetes_version_upgrade_matrix(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->kuberenetes_version_upgrade_matrix: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Filter**](Filter.md)| Filter object. | 

### Return type

[**UpgradeMatrixList**](UpgradeMatrixList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **pause_node_pool**
> ClusterAPIResponse pause_node_pool(cluster_id, node_pool_id)

Pause a Nodepool in a cluster (Deprecated for workload clusters)

Pause a Nodepool in a cluster

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
cluster_id = 'cluster_id_example' # str | 
node_pool_id = 'node_pool_id_example' # str | 

try:
    # Pause a Nodepool in a cluster (Deprecated for workload clusters)
    api_response = api_instance.pause_node_pool(cluster_id, node_pool_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->pause_node_pool: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_id** | **str**|  | 
 **node_pool_id** | **str**|  | 

### Return type

[**ClusterAPIResponse**](ClusterAPIResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **retry_cluster_operation**
> ClusterAPIResponse retry_cluster_operation(operation_id)

Api to retry K8s cluster operation (Deprecated for workload clusters)

Retry K8s Cluster Operation

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
operation_id = 'operation_id_example' # str | 

try:
    # Api to retry K8s cluster operation (Deprecated for workload clusters)
    api_response = api_instance.retry_cluster_operation(operation_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->retry_cluster_operation: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **operation_id** | **str**|  | 

### Return type

[**ClusterAPIResponse**](ClusterAPIResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **supported_kubernetes_versions**
> SupportedVersionsList supported_kubernetes_versions()

Api to get all the supported  K8s versions of cluster for Telco Cloud Automation (Deprecated for workload clusters)

Api to get all the supported  K8s versions of cluster for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()

try:
    # Api to get all the supported  K8s versions of cluster for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.supported_kubernetes_versions()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->supported_kubernetes_versions: %s\n" % e)
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**SupportedVersionsList**](SupportedVersionsList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **sync_esx_info**
> InlineResponse2001 sync_esx_info(id)

Api to sync Esx Info for Workload Clusters on demand

Api to sync Esx Info for Workload Clusters on demand. TCA automatically syncs required ESX Info for the workload clusters but if for some reason there is a notifcation miss, then this API can be called to forcefully trigger the ESX Info Sync

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
id = 'id_example' # str | 

try:
    # Api to sync Esx Info for Workload Clusters on demand
    api_response = api_instance.sync_esx_info(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->sync_esx_info: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**|  | 

### Return type

[**InlineResponse2001**](InlineResponse2001.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **transform_cluster**
> ClusterAPIResponse transform_cluster(id)

Api to transform cluster from v1 to v2.

Api to transform cluster from v1 to v2. `Once the cluster is transformed, v1 APIs will no longer work for it. LCM operations for such clusters will then be handled by v2 APIs only.` 

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
id = 'id_example' # str | id of the cluster that is to be transformed

try:
    # Api to transform cluster from v1 to v2.
    api_response = api_instance.transform_cluster(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->transform_cluster: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**| id of the cluster that is to be transformed | 

### Return type

[**ClusterAPIResponse**](ClusterAPIResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **unpause_node_pool**
> ClusterAPIResponse unpause_node_pool(cluster_id, node_pool_id)

Unpause a Nodepool in a cluster (Deprecated for workload clusters)

Unpause a Nodepool in a cluster

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
cluster_id = 'cluster_id_example' # str | 
node_pool_id = 'node_pool_id_example' # str | 

try:
    # Unpause a Nodepool in a cluster (Deprecated for workload clusters)
    api_response = api_instance.unpause_node_pool(cluster_id, node_pool_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->unpause_node_pool: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_id** | **str**|  | 
 **node_pool_id** | **str**|  | 

### Return type

[**ClusterAPIResponse**](ClusterAPIResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **upgrade_cluster**
> ClusterAPIResponse upgrade_cluster(body, id)

Api to upgrade K8s version of Cluster for Telco Cloud Automation (Deprecated for workload clusters)

Api to upgrade K8s version of Cluster for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
body = tca.cluster.ClusterUpgradeRequest() # ClusterUpgradeRequest | upgrade kubernetes version
id = 'id_example' # str | 

try:
    # Api to upgrade K8s version of Cluster for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.upgrade_cluster(body, id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->upgrade_cluster: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ClusterUpgradeRequest**](ClusterUpgradeRequest.md)| upgrade kubernetes version | 
 **id** | **str**|  | 

### Return type

[**ClusterAPIResponse**](ClusterAPIResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **upgrade_cluster_addon**
> ClusterAPIResponse upgrade_cluster_addon(id)

Api to upgrade addons on the cluster (Deprecated for workload clusters)

Api to upgrade addons on the cluster

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
id = 'id_example' # str | 

try:
    # Api to upgrade addons on the cluster (Deprecated for workload clusters)
    api_response = api_instance.upgrade_cluster_addon(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->upgrade_cluster_addon: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**|  | 

### Return type

[**ClusterAPIResponse**](ClusterAPIResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **upgrade_history**
> UpgradeHistory upgrade_history(id)

Api to get the K8s versions upgrade history of cluster for Telco Cloud Automation (Deprecated for workload clusters)

Api to get the K8s versions upgrade history of cluster for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
id = 'id_example' # str | 

try:
    # Api to get the K8s versions upgrade history of cluster for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.upgrade_history(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->upgrade_history: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**|  | 

### Return type

[**UpgradeHistory**](UpgradeHistory.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **upgrade_node_pool**
> ClusterAPIResponse upgrade_node_pool(cluster_id, node_pool_id)

Api to upgrade K8 cluster node pool for Telco Cloud Automation (Deprecated for workload clusters)

Upgrade Nodepool. This Upgrades the nodepools to use latest features of Cluster Automation. This is mandatory to be done on all nodepools created in TCA 1.7. This is one time operation on upgrading TCA to 1.8 and once successfully upgraded all the operations on nodepool will be enabled. Upgrade can be repeated on nodepool incase of any failure.

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
cluster_id = 'cluster_id_example' # str | 
node_pool_id = 'node_pool_id_example' # str | 

try:
    # Api to upgrade K8 cluster node pool for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.upgrade_node_pool(cluster_id, node_pool_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->upgrade_node_pool: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_id** | **str**|  | 
 **node_pool_id** | **str**|  | 

### Return type

[**ClusterAPIResponse**](ClusterAPIResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **validate_upgrade_cluster**
> ValidateResponse validate_upgrade_cluster(id)

Api to validate  K8s version upgrade of Cluster for Telco Cloud Automation (Deprecated for workload clusters)

Api to validate  K8s version upgrade of Cluster for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
id = 'id_example' # str | 

try:
    # Api to validate  K8s version upgrade of Cluster for Telco Cloud Automation (Deprecated for workload clusters)
    api_response = api_instance.validate_upgrade_cluster(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->validate_upgrade_cluster: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**|  | 

### Return type

[**ValidateResponse**](ValidateResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **vsphere_csi_zone_support**
> VSphereCSIZoneSupportResponse vsphere_csi_zone_support(id)

Api to verify whether vsphere csi zone support is present. (Deprecated for workload clusters)

Api to verify whether vsphere csi zone support is present. Both workload clusters and management clusters should be created in TCA >= 1.9.5 version. 

### Example
```python
from __future__ import print_function
import time
import tca.cluster
from tca.cluster.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.cluster.InfraApi()
id = 'id_example' # str | If Management cluster id is provided, checks whether mgmt cluster is created in TCA >= 1.9.5 version If workload cluster id is provided, checks whether its mgmt cluster is created in TCA >= 1.9.5 and the workload cluster is created in TCA >= 1.9.5 version. 

try:
    # Api to verify whether vsphere csi zone support is present. (Deprecated for workload clusters)
    api_response = api_instance.vsphere_csi_zone_support(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling InfraApi->vsphere_csi_zone_support: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**| If Management cluster id is provided, checks whether mgmt cluster is created in TCA &gt;&#x3D; 1.9.5 version If workload cluster id is provided, checks whether its mgmt cluster is created in TCA &gt;&#x3D; 1.9.5 and the workload cluster is created in TCA &gt;&#x3D; 1.9.5 version.  | 

### Return type

[**VSphereCSIZoneSupportResponse**](VSphereCSIZoneSupportResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

