# InstantiateNsRequest

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**ns_flavour_id** | [**IdentifierInNsd**](IdentifierInNsd.md) |  | 
**sap_data** | [**list[SapData]**](SapData.md) | Create data concerning the SAPs of this NS.  | [optional] 
**addpnf_data** | [**list[AddPnfData]**](AddPnfData.md) | Information on the PNF(s) that are part of this NS.  | [optional] 
**vnf_instance_data** | [**list[VnfInstanceData]**](VnfInstanceData.md) | Specify an existing VNF instance to be used in the NS. If needed, the VNF Profile to be used for this VNF instance is also provided. The DF of the VNF instance shall match the VNF DF  present in the associated VNF Profile.  | [optional] 
**nested_ns_instance_data** | [**list[NestedNsInstanceData]**](NestedNsInstanceData.md) | Specify an existing NS instance to be used as a nested NS within the NS. If needed, the NS Profile to be used for this nested NS  instance is also provided. NOTE 2: The NS DF of each nested NS shall be one of the  allowed flavours in the associated NSD (as referenced in the nestedNsd attribute of the NSD of the NS to be instantiated). NOTE 3: The NSD of each referenced NSs (i.e. each  nestedInstanceId) shall match the one of the nested NSD in  the composite NSD.  | [optional] 
**location_constraints** | [**list[VnfLocationConstraint]**](VnfLocationConstraint.md) | Defines the location constraints for the VNF to be instantiated as part of the NS instantiation. An example can be a constraint for the VNF to be in a specific geographic location..  | [optional] 
**additional_params_for_ns** | **AllOfInstantiateNsRequestAdditionalParamsForNs** | Allows the OSS/BSS to provide additional parameter(s) at the composite NS level (as opposed to the VNF level,  which is covered in additionalParamsForVnf), and as  opposed to the nested NS level, which is covered in additionalParamForNestedNs.  | [optional] 
**additional_param_for_nested_ns** | [**list[ParamsForNestedNs]**](ParamsForNestedNs.md) | Allows the OSS/BSS to provide additional parameter(s) per nested NS instance (as opposed to the composite NS level, which is covered in additionalParamForNs, and as opposed to the VNF level, which is covered in additionalParamForVnf). This is for nested NS instances that are to be created by the NFVO as part of the NS instantiation and not for existing nested NS instances that are referenced for reuse.  | [optional] 
**additional_params_for_vnf** | [**list[ParamsForVnf]**](ParamsForVnf.md) | Allows the OSS/BSS to provide additional parameter(s) per VNF instance (as opposed to the composite NS level,  which is covered in additionalParamsForNs and as opposed  to the nested NS level, which is covered in  additionalParamForNestedNs). This is for VNFs that are  to be created by the NFVO as part of the NS instantiation  and not for existing VNF that are referenced for reuse.  | [optional] 
**start_time** | **datetime** |  | [optional] 
**ns_instantiation_level_id** | [**IdentifierInNsd**](IdentifierInNsd.md) |  | [optional] 
**additional_affinity_or_anti_affinity_rule** | [**list[AffinityOrAntiAffinityRule]**](AffinityOrAntiAffinityRule.md) | Specifies additional affinity or anti-affinity constraint for the VNF instances to be instantiated as part of the NS instantiation. Shall not conflict with rules already specified in the NSD.  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

