# tca.system_management.LicensingApi

All URIs are relative to **

Method | HTTP request | Description
------------- | ------------- | -------------
[**api_admin_licenses_activation_server_put**](LicensingApi.md#api_admin_licenses_activation_server_put) | **PUT** /api/admin/licenses/activationServer | Activate Server
[**api_admin_licenses_get**](LicensingApi.md#api_admin_licenses_get) | **GET** /api/admin/licenses | Get licenses
[**api_admin_licenses_status_job_id_get**](LicensingApi.md#api_admin_licenses_status_job_id_get) | **GET** /api/admin/licenses/status/{jobId} | Get job status

# **api_admin_licenses_activation_server_put**
> TcaJob api_admin_licenses_activation_server_put(body, accept, content_type)

Activate Server

Api to activate Server

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.LicensingApi(tca.system_management.ApiClient(configuration))
body = tca.system_management.LicensesActivationServerBody() # LicensesActivationServerBody | 
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Activate Server
    api_response = api_instance.api_admin_licenses_activation_server_put(body, accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LicensingApi->api_admin_licenses_activation_server_put: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**LicensesActivationServerBody**](LicensesActivationServerBody.md)|  | 
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

[**TcaJob**](TcaJob.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_licenses_get**
> TcaLicense api_admin_licenses_get(accept, content_type)

Get licenses

Api to get licenses

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.LicensingApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Get licenses
    api_response = api_instance.api_admin_licenses_get(accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LicensingApi->api_admin_licenses_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

[**TcaLicense**](TcaLicense.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_licenses_status_job_id_get**
> TcaJobDetails api_admin_licenses_status_job_id_get(job_id, accept)

Get job status

Api to get job status

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.LicensingApi(tca.system_management.ApiClient(configuration))
job_id = 'job_id_example' # str | 
accept = 'application/json' # str | application/json (default to application/json)

try:
    # Get job status
    api_response = api_instance.api_admin_licenses_status_job_id_get(job_id, accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling LicensingApi->api_admin_licenses_status_job_id_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **job_id** | **str**|  | 
 **accept** | **str**| application/json | [default to application/json]

### Return type

[**TcaJobDetails**](TcaJobDetails.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

