# tca.system_management.NetworkingApi

All URIs are relative to **

Method | HTTP request | Description
------------- | ------------- | -------------
[**api_admin_global_config_proxy_get**](NetworkingApi.md#api_admin_global_config_proxy_get) | **GET** /api/admin/global/config/proxy | Get Proxy Settings
[**api_admin_global_config_proxy_post**](NetworkingApi.md#api_admin_global_config_proxy_post) | **POST** /api/admin/global/config/proxy | Configure Proxy Settings
[**api_admin_global_config_proxy_uuid_delete**](NetworkingApi.md#api_admin_global_config_proxy_uuid_delete) | **DELETE** /api/admin/global/config/proxy/{uuid} | Remove Proxy Settings
[**system_network_dns_delete**](NetworkingApi.md#system_network_dns_delete) | **DELETE** /system/network/dns | Remove DNS Settings
[**system_network_dns_put**](NetworkingApi.md#system_network_dns_put) | **PUT** /system/network/dns | Configure DNS Settings
[**system_network_get**](NetworkingApi.md#system_network_get) | **GET** /system/network | Get Network Settings (General Network &amp; DNS)
[**system_network_staticroutes_get**](NetworkingApi.md#system_network_staticroutes_get) | **GET** /system/network/staticroutes | Get Static Routes
[**system_network_staticroutes_put**](NetworkingApi.md#system_network_staticroutes_put) | **PUT** /system/network/staticroutes | Configure Static Routes

# **api_admin_global_config_proxy_get**
> InlineResponse2006 api_admin_global_config_proxy_get(accept)

Get Proxy Settings

Api to get proxy settings

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.NetworkingApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)

try:
    # Get Proxy Settings
    api_response = api_instance.api_admin_global_config_proxy_get(accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NetworkingApi->api_admin_global_config_proxy_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse2006**](InlineResponse2006.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_global_config_proxy_post**
> InlineResponse2006 api_admin_global_config_proxy_post(body, accept, content_type)

Configure Proxy Settings

Api to add proxy settings

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.NetworkingApi(tca.system_management.ApiClient(configuration))
body = tca.system_management.ConfigProxyBody() # ConfigProxyBody | 
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Configure Proxy Settings
    api_response = api_instance.api_admin_global_config_proxy_post(body, accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NetworkingApi->api_admin_global_config_proxy_post: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ConfigProxyBody**](ConfigProxyBody.md)|  | 
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse2006**](InlineResponse2006.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_global_config_proxy_uuid_delete**
> api_admin_global_config_proxy_uuid_delete(uuid)

Remove Proxy Settings

Api to remove proxy settings

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.NetworkingApi(tca.system_management.ApiClient(configuration))
uuid = 'uuid_example' # str | 

try:
    # Remove Proxy Settings
    api_instance.api_admin_global_config_proxy_uuid_delete(uuid)
except ApiException as e:
    print("Exception when calling NetworkingApi->api_admin_global_config_proxy_uuid_delete: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **uuid** | **str**|  | 

### Return type

void (empty response body)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **system_network_dns_delete**
> system_network_dns_delete()

Remove DNS Settings

Api to Remove DNS Settings

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.NetworkingApi(tca.system_management.ApiClient(configuration))

try:
    # Remove DNS Settings
    api_instance.system_network_dns_delete()
except ApiException as e:
    print("Exception when calling NetworkingApi->system_network_dns_delete: %s\n" % e)
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **system_network_dns_put**
> NetworkDnsBody system_network_dns_put(body, accept, content_type)

Configure DNS Settings

Api to Configure DNS Settings. You need to restart the Application Service and Web Service for your changes to take effect!.

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.NetworkingApi(tca.system_management.ApiClient(configuration))
body = tca.system_management.NetworkDnsBody() # NetworkDnsBody | 
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Configure DNS Settings
    api_response = api_instance.system_network_dns_put(body, accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NetworkingApi->system_network_dns_put: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**NetworkDnsBody**](NetworkDnsBody.md)|  | 
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

[**NetworkDnsBody**](NetworkDnsBody.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **system_network_get**
> InlineResponse2004 system_network_get(accept)

Get Network Settings (General Network & DNS)

Api to get Network Settings (General Network & DNS)

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.NetworkingApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)

try:
    # Get Network Settings (General Network & DNS)
    api_response = api_instance.system_network_get(accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NetworkingApi->system_network_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse2004**](InlineResponse2004.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **system_network_staticroutes_get**
> list[InlineResponse2003] system_network_staticroutes_get(accept)

Get Static Routes

Api to Get Static Routes

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.NetworkingApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)

try:
    # Get Static Routes
    api_response = api_instance.system_network_staticroutes_get(accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NetworkingApi->system_network_staticroutes_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]

### Return type

[**list[InlineResponse2003]**](InlineResponse2003.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **system_network_staticroutes_put**
> NetworkStaticroutesBody system_network_staticroutes_put(body, accept, content_type)

Configure Static Routes

Api to Configure Static Routes

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.NetworkingApi(tca.system_management.ApiClient(configuration))
body = tca.system_management.NetworkStaticroutesBody() # NetworkStaticroutesBody | 
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Configure Static Routes
    api_response = api_instance.system_network_staticroutes_put(body, accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NetworkingApi->system_network_staticroutes_put: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**NetworkStaticroutesBody**](NetworkStaticroutesBody.md)|  | 
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

[**NetworkStaticroutesBody**](NetworkStaticroutesBody.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

