# tca.caas_v2_nodepool.NodePoolApi

All URIs are relative to */telco/api/caas/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**create_node_pool**](NodePoolApi.md#create_node_pool) | **POST** /clusters/{clusterName}/nodepools | Api to deploy Kubernetes Nodepool for Telco Cloud Automation
[**delete_node_pool**](NodePoolApi.md#delete_node_pool) | **DELETE** /clusters/{clusterName}/nodepools/{nodepoolName} | Api to delete Kubernetes Nodepool for Telco Cloud Automation
[**edit_node_pool**](NodePoolApi.md#edit_node_pool) | **PUT** /clusters/{clusterName}/nodepools/{nodepoolName} | Api to modify Kubernetes Nodepool for Telco Cloud Automation
[**get_all_node_pools**](NodePoolApi.md#get_all_node_pools) | **GET** /clusters/{clusterName}/nodepools | API to fetch all node pools created on Kubernetes Cluster
[**get_node_pool**](NodePoolApi.md#get_node_pool) | **GET** /clusters/{clusterName}/nodepools/{nodepoolName} | API to get Node Pool created on a Kubernetes Cluster
[**get_node_pool_customization**](NodePoolApi.md#get_node_pool_customization) | **GET** /clusters/{clusterName}/nodepools/{nodepoolName}/customization | API to get Node Pool Customization

# **create_node_pool**
> Nodepool create_node_pool(body, cluster_name, mgmt_cluster_name=mgmt_cluster_name, tca_cp_id=tca_cp_id)

Api to deploy Kubernetes Nodepool for Telco Cloud Automation

Api to deploy Kubernetes Nodepool for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2_nodepool
from tca.caas_v2_nodepool.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2_nodepool.NodePoolApi()
body = tca.caas_v2_nodepool.Nodepool() # Nodepool | create nodepool payload
cluster_name = 'cluster_name_example' # str | Name of cluster on which nodepool needs to be created
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | Name of the management cluster where the request has to be executed (optional)
tca_cp_id = 'tca_cp_id_example' # str | Id of the TCA CP where the request has to be routed. (optional)

try:
    # Api to deploy Kubernetes Nodepool for Telco Cloud Automation
    api_response = api_instance.create_node_pool(body, cluster_name, mgmt_cluster_name=mgmt_cluster_name, tca_cp_id=tca_cp_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NodePoolApi->create_node_pool: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Nodepool**](Nodepool.md)| create nodepool payload | 
 **cluster_name** | **str**| Name of cluster on which nodepool needs to be created | 
 **mgmt_cluster_name** | **str**| Name of the management cluster where the request has to be executed | [optional] 
 **tca_cp_id** | **str**| Id of the TCA CP where the request has to be routed. | [optional] 

### Return type

[**Nodepool**](Nodepool.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-yaml
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_node_pool**
> Nodepool delete_node_pool(cluster_name, nodepool_name, mgmt_cluster_name=mgmt_cluster_name, tca_cp_id=tca_cp_id)

Api to delete Kubernetes Nodepool for Telco Cloud Automation

Api to delete Kubernetes Nodepool for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2_nodepool
from tca.caas_v2_nodepool.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2_nodepool.NodePoolApi()
cluster_name = 'cluster_name_example' # str | Name of cluster on which nodepool needs to be deleted
nodepool_name = 'nodepool_name_example' # str | Name of the nodepool which has to be deleted
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | Name of the management cluster where the request has to be executed (optional)
tca_cp_id = 'tca_cp_id_example' # str | Id of the TCA CP where the request has to be routed. (optional)

try:
    # Api to delete Kubernetes Nodepool for Telco Cloud Automation
    api_response = api_instance.delete_node_pool(cluster_name, nodepool_name, mgmt_cluster_name=mgmt_cluster_name, tca_cp_id=tca_cp_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NodePoolApi->delete_node_pool: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_name** | **str**| Name of cluster on which nodepool needs to be deleted | 
 **nodepool_name** | **str**| Name of the nodepool which has to be deleted | 
 **mgmt_cluster_name** | **str**| Name of the management cluster where the request has to be executed | [optional] 
 **tca_cp_id** | **str**| Id of the TCA CP where the request has to be routed. | [optional] 

### Return type

[**Nodepool**](Nodepool.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **edit_node_pool**
> Nodepool edit_node_pool(body, cluster_name, nodepool_name, mgmt_cluster_name=mgmt_cluster_name, tca_cp_id=tca_cp_id)

Api to modify Kubernetes Nodepool for Telco Cloud Automation

Api to modify Kubernetes Nodepool for Telco Cloud Automation

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2_nodepool
from tca.caas_v2_nodepool.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2_nodepool.NodePoolApi()
body = tca.caas_v2_nodepool.Nodepool() # Nodepool | modify nodepool payload
cluster_name = 'cluster_name_example' # str | Name of cluster on which nodepool needs to be modified
nodepool_name = 'nodepool_name_example' # str | Name of the nodepool which has to be modified
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | Name of the management cluster where the request has to be executed (optional)
tca_cp_id = 'tca_cp_id_example' # str | Id of the TCA CP where the request has to be routed. (optional)

try:
    # Api to modify Kubernetes Nodepool for Telco Cloud Automation
    api_response = api_instance.edit_node_pool(body, cluster_name, nodepool_name, mgmt_cluster_name=mgmt_cluster_name, tca_cp_id=tca_cp_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NodePoolApi->edit_node_pool: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Nodepool**](Nodepool.md)| modify nodepool payload | 
 **cluster_name** | **str**| Name of cluster on which nodepool needs to be modified | 
 **nodepool_name** | **str**| Name of the nodepool which has to be modified | 
 **mgmt_cluster_name** | **str**| Name of the management cluster where the request has to be executed | [optional] 
 **tca_cp_id** | **str**| Id of the TCA CP where the request has to be routed. | [optional] 

### Return type

[**Nodepool**](Nodepool.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-yaml
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_all_node_pools**
> NodepoolList get_all_node_pools(cluster_name, tca_cp_id, mgmt_cluster_name=mgmt_cluster_name, sort=sort, nextpage_opaque_marker=nextpage_opaque_marker)

API to fetch all node pools created on Kubernetes Cluster

API to fetch all node pools of as Kubernetes Cluster

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2_nodepool
from tca.caas_v2_nodepool.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2_nodepool.NodePoolApi()
cluster_name = 'cluster_name_example' # str | Name of cluster where node pools are created
tca_cp_id = 'tca_cp_id_example' # str | TCA-CP id of management cluster managing given cluster
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | Name of management cluster of the given cluster. If given cluster is management cluster, this is not required  (optional)
sort = 'sort_example' # str | Attribute based sorting expression. (optional)
nextpage_opaque_marker = 'nextpage_opaque_marker_example' # str | Marker to obtain the next page of a paged response. If not present, API will return first page of response with page size 10. (optional)

try:
    # API to fetch all node pools created on Kubernetes Cluster
    api_response = api_instance.get_all_node_pools(cluster_name, tca_cp_id, mgmt_cluster_name=mgmt_cluster_name, sort=sort, nextpage_opaque_marker=nextpage_opaque_marker)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NodePoolApi->get_all_node_pools: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_name** | **str**| Name of cluster where node pools are created | 
 **tca_cp_id** | **str**| TCA-CP id of management cluster managing given cluster | 
 **mgmt_cluster_name** | **str**| Name of management cluster of the given cluster. If given cluster is management cluster, this is not required  | [optional] 
 **sort** | **str**| Attribute based sorting expression. | [optional] 
 **nextpage_opaque_marker** | **str**| Marker to obtain the next page of a paged response. If not present, API will return first page of response with page size 10. | [optional] 

### Return type

[**NodepoolList**](NodepoolList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_node_pool**
> Nodepool get_node_pool(cluster_name, nodepool_name, tca_cp_id, mgmt_cluster_name=mgmt_cluster_name)

API to get Node Pool created on a Kubernetes Cluster

API to get Node Pool of a Kubernetes Cluster

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2_nodepool
from tca.caas_v2_nodepool.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2_nodepool.NodePoolApi()
cluster_name = 'cluster_name_example' # str | Name of cluster where node pool is created
nodepool_name = 'nodepool_name_example' # str | Name of node pool
tca_cp_id = 'tca_cp_id_example' # str | TCA-CP id of management cluster managing given cluster
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | Name of management cluster of the given cluster. If given cluster is management cluster, this is not required  (optional)

try:
    # API to get Node Pool created on a Kubernetes Cluster
    api_response = api_instance.get_node_pool(cluster_name, nodepool_name, tca_cp_id, mgmt_cluster_name=mgmt_cluster_name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NodePoolApi->get_node_pool: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_name** | **str**| Name of cluster where node pool is created | 
 **nodepool_name** | **str**| Name of node pool | 
 **tca_cp_id** | **str**| TCA-CP id of management cluster managing given cluster | 
 **mgmt_cluster_name** | **str**| Name of management cluster of the given cluster. If given cluster is management cluster, this is not required  | [optional] 

### Return type

[**Nodepool**](Nodepool.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_node_pool_customization**
> object get_node_pool_customization(cluster_name, nodepool_name, tca_cp_id, mgmt_cluster_name=mgmt_cluster_name)

API to get Node Pool Customization

API to get Node Pool Customization

### Example
```python
from __future__ import print_function
import time
import tca.caas_v2_nodepool
from tca.caas_v2_nodepool.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.caas_v2_nodepool.NodePoolApi()
cluster_name = 'cluster_name_example' # str | Name of cluster where node pool is created
nodepool_name = 'nodepool_name_example' # str | Name of node pool
tca_cp_id = 'tca_cp_id_example' # str | TCA-CP id of management cluster managing given cluster
mgmt_cluster_name = 'mgmt_cluster_name_example' # str | Name of management cluster of the given cluster. If given cluster is management cluster, this is not required  (optional)

try:
    # API to get Node Pool Customization
    api_response = api_instance.get_node_pool_customization(cluster_name, nodepool_name, tca_cp_id, mgmt_cluster_name=mgmt_cluster_name)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NodePoolApi->get_node_pool_customization: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **cluster_name** | **str**| Name of cluster where node pool is created | 
 **nodepool_name** | **str**| Name of node pool | 
 **tca_cp_id** | **str**| TCA-CP id of management cluster managing given cluster | 
 **mgmt_cluster_name** | **str**| Name of management cluster of the given cluster. If given cluster is management cluster, this is not required  | [optional] 

### Return type

**object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, application/x-yaml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

