# NodepoolSpec

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**clone_mode** | **str** | Deprecated, use cloudMachineTemplate.vSphereMachine.CloneMode instead CloneMode specifies the type of clone operation. The LinkedClone mode is only support for templates that have at least one snapshot. If the template has no snapshots, then CloneMode defaults to FullClone. When LinkedClone mode is enabled the DiskGiB field is ignored as it is not possible to expand disks of linked clones. Defaults to LinkedClone, but fails gracefully to FullClone if the source of the clone operation has no snapshots. | [optional] [default to 'fullClone']
**cloud_machine_template** | [**NodepoolSpecCloudMachineTemplate**](NodepoolSpecCloudMachineTemplate.md) |  | [optional] 
**cluster_name** | **str** | ClusterName is the name of the Tca Kuberneters Cluster this object belongs to. | 
**datacenter** | **str** | Deprecated, use cloudMachineTemplate.vSphereMachine.Datacenter instead. Datacenter is the name or inventory path of the datacenter in which the node is created/located. | [optional] 
**datastore** | **str** | Deprecated, use cloudMachineTemplate.vSphereMachine.Datastore instead. Datastore is the name or inventory path of the datastore in which the node is created/located. | [optional] 
**disk_gi_b** | **int** | DiskGiB is the size of a node&#x27;s disk, in GiB. | [optional] 
**folder** | **str** | Deprecated, use cloudMachineTemplate.vSphereMachine.Folder instead. Folder is the name or inventory path of the folder in which the node is created/located. | [optional] 
**health_check** | [**NodepoolSpecHealthCheck**](NodepoolSpecHealthCheck.md) |  | [optional] 
**kubeadm_config_template** | [**NodepoolSpecKubeadmConfigTemplate**](NodepoolSpecKubeadmConfigTemplate.md) |  | [optional] 
**labels** | **dict(str, str)** | Map of string keys and values that can be used to organize and categorize (scope and select) objects. | [optional] 
**memory_mi_b** | **int** | MemoryMiB is the size of a node&#x27;s memory, in MiB. | [optional] 
**network** | [**NodepoolSpecNetwork**](NodepoolSpecNetwork.md) |  | [optional] 
**num_cp_us** | **int** | NumCPUs is the number of virtual processors in the node. | [optional] 
**num_cores_per_socket** | **int** | Deprecated, use cloudMachineTemplate.vSphereMachine.NumCoresPerSocket instead NumCoresPerSocket is the number of cores among which to distribute CPUs in this node. | [optional] 
**pause** | **bool** | Pause represents to pause the node pool | [optional] 
**replicas** | **int** | Number of desired node. Defaults to 1. This is a pointer to distinguish between explicit zero and not specified. | [optional] [default to 1]
**resource_pool** | **str** | Deprecated, use cloudMachineTemplate.vSphereMachine.ResourcePool instead. ResourcePool is the name or inventory path of the resource pool in which the node is created/located. | [optional] 
**storage_policy_name** | **str** | Deprecated, use cloudMachineTemplate.vSphereMachine.StoragePolicyName instead. StoragePolicyName of the storage policy to use with the node | [optional] 
**strategy** | [**NodepoolSpecStrategy**](NodepoolSpecStrategy.md) |  | [optional] 
**tca_bom_release_ref** | [**NodepoolSpecTcaBomReleaseRef**](NodepoolSpecTcaBomReleaseRef.md) |  | [optional] 
**template** | **str** | Deprecated, use cloudMachineTemplate.vSphereMachine.Template instead. Template is the name or inventory path of the template used to clone the node. | [optional] 
**cloud_provider** | [**NodepoolSpecCloudProvider**](NodepoolSpecCloudProvider.md) |  | 
**customisations** | [**NodepoolSpecCustomisations**](NodepoolSpecCustomisations.md) |  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

