# tca.nsdm_extn.NsCatalogApi

All URIs are relative to *https://{server}/telco/api/*

Method | HTTP request | Description
------------- | ------------- | -------------
[**delete_ns_descriptor_view**](NsCatalogApi.md#delete_ns_descriptor_view) | **DELETE** /nsd/v2/ns_descriptors/{packageId}/nsd_content/view/{viewId} | 
[**get_ns_descriptor_view**](NsCatalogApi.md#get_ns_descriptor_view) | **GET** /nsd/v2/ns_descriptors/{packageId}/nsd_content/view | 
[**get_nsd_interfaces**](NsCatalogApi.md#get_nsd_interfaces) | **GET** /nsd/v2/ns_descriptors/{nsdId}/interfaces | 
[**update_ns_descriptor**](NsCatalogApi.md#update_ns_descriptor) | **PUT** /nsd/v2/ns_descriptors/{packageId}/nsd_content/view/{viewId}/update | 
[**update_ns_descriptor_content**](NsCatalogApi.md#update_ns_descriptor_content) | **PUT** /nsd/v2/ns_descriptors/{packageId}/nsd_content/view/{viewId} | 
[**view_ns_descriptor**](NsCatalogApi.md#view_ns_descriptor) | **GET** /nsd/v2/ns_descriptors/{packageId}/nsd_content/view/{viewId} | 

# **delete_ns_descriptor_view**
> delete_ns_descriptor_view(package_id, view_id)



Delete NSD descriptor view

### Example
```python
from __future__ import print_function
import time
import tca.nsdm_extn
from tca.nsdm_extn.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.nsdm_extn.NsCatalogApi()
package_id = 'package_id_example' # str | 
view_id = 'view_id_example' # str | 

try:
    api_instance.delete_ns_descriptor_view(package_id, view_id)
except ApiException as e:
    print("Exception when calling NsCatalogApi->delete_ns_descriptor_view: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **package_id** | **str**|  | 
 **view_id** | **str**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_ns_descriptor_view**
> list[PackageContentView] get_ns_descriptor_view(package_id)



Get NSD content view

### Example
```python
from __future__ import print_function
import time
import tca.nsdm_extn
from tca.nsdm_extn.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.nsdm_extn.NsCatalogApi()
package_id = 'package_id_example' # str | 

try:
    api_response = api_instance.get_ns_descriptor_view(package_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NsCatalogApi->get_ns_descriptor_view: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **package_id** | **str**|  | 

### Return type

[**list[PackageContentView]**](PackageContentView.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_nsd_interfaces**
> object get_nsd_interfaces(nsd_id)



Get NSD Interfaces

### Example
```python
from __future__ import print_function
import time
import tca.nsdm_extn
from tca.nsdm_extn.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.nsdm_extn.NsCatalogApi()
nsd_id = 'nsd_id_example' # str | 

try:
    api_response = api_instance.get_nsd_interfaces(nsd_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NsCatalogApi->get_nsd_interfaces: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **nsd_id** | **str**|  | 

### Return type

**object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: text/plain

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_ns_descriptor**
> object update_ns_descriptor(package_id, view_id)



Update NS Descriptor

### Example
```python
from __future__ import print_function
import time
import tca.nsdm_extn
from tca.nsdm_extn.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.nsdm_extn.NsCatalogApi()
package_id = 'package_id_example' # str | 
view_id = 'view_id_example' # str | 

try:
    api_response = api_instance.update_ns_descriptor(package_id, view_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NsCatalogApi->update_ns_descriptor: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **package_id** | **str**|  | 
 **view_id** | **str**|  | 

### Return type

**object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_ns_descriptor_content**
> object update_ns_descriptor_content(package_id, view_id, file)



Update NS descriptor view

### Example
```python
from __future__ import print_function
import time
import tca.nsdm_extn
from tca.nsdm_extn.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.nsdm_extn.NsCatalogApi()
package_id = 'package_id_example' # str | 
view_id = 'view_id_example' # str | 
file = 'file_example' # str | 

try:
    api_response = api_instance.update_ns_descriptor_content(package_id, view_id, file)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NsCatalogApi->update_ns_descriptor_content: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **package_id** | **str**|  | 
 **view_id** | **str**|  | 
 **file** | **str**|  | 

### Return type

**object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **view_ns_descriptor**
> str view_ns_descriptor(package_id, view_id, file)



View NSD Descriptor

### Example
```python
from __future__ import print_function
import time
import tca.nsdm_extn
from tca.nsdm_extn.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.nsdm_extn.NsCatalogApi()
package_id = 'package_id_example' # str | 
view_id = 'view_id_example' # str | 
file = 'file_example' # str | 

try:
    api_response = api_instance.view_ns_descriptor(package_id, view_id, file)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NsCatalogApi->view_ns_descriptor: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **package_id** | **str**|  | 
 **view_id** | **str**|  | 
 **file** | **str**|  | 

### Return type

**str**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: text/plain

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

