# tca.vnffm_v1.NsFmAlarmsApi

All URIs are relative to */hybridity/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**acknowledge_alarm**](NsFmAlarmsApi.md#acknowledge_alarm) | **PATCH** /nsfm/v1/alarms/{alarmId} | Acknowledge an Alarm of Network Services in the vCenter
[**acknowledge_alarms**](NsFmAlarmsApi.md#acknowledge_alarms) | **PATCH** /nsfm/v1/alarms | Acknowledge multiple alarms of Network Services
[**create_subscription**](NsFmAlarmsApi.md#create_subscription) | **POST** /vnffm/v1/subscriptions | Creates a new subscription.
[**get_alarm_for_alarm_id**](NsFmAlarmsApi.md#get_alarm_for_alarm_id) | **GET** /nsfm/v1/alarms/{alarmId} | Get Alarm of the Network Services given the alarmId
[**get_alarms**](NsFmAlarmsApi.md#get_alarms) | **GET** /nsfm/v1/alarms | Get Alarms of all the Network Services
[**get_nfv_alarm_by_action**](NsFmAlarmsApi.md#get_nfv_alarm_by_action) | **POST** /nsfm/v1/alarms | Get Telco Cloud Automation Alarms For Network Services By Action Param
[**get_subscription**](NsFmAlarmsApi.md#get_subscription) | **GET** /vnffm/v1/subscriptions/{subscriptionId} | Get subscription.
[**get_subscriptions**](NsFmAlarmsApi.md#get_subscriptions) | **GET** /vnffm/v1/subscriptions | List all subscriptions.
[**remove_subscription**](NsFmAlarmsApi.md#remove_subscription) | **DELETE** /vnffm/v1/subscriptions/{subscriptionId} | Remove subscription.

# **acknowledge_alarm**
> JobIdResponse acknowledge_alarm(alarm_id)

Acknowledge an Alarm of Network Services in the vCenter

Acknowledge an Alarm of Network Services in the vCenter

### Example
```python
from __future__ import print_function
import time
import tca.vnffm_v1
from tca.vnffm_v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: x-hm-authorization
configuration = tca.vnffm_v1.Configuration()
configuration.api_key['x-hm-authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-hm-authorization'] = 'Bearer'

# create an instance of the API class
api_instance = tca.vnffm_v1.NsFmAlarmsApi(tca.vnffm_v1.ApiClient(configuration))
alarm_id = 'alarm_id_example' # str | alarmId

try:
    # Acknowledge an Alarm of Network Services in the vCenter
    api_response = api_instance.acknowledge_alarm(alarm_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NsFmAlarmsApi->acknowledge_alarm: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **alarm_id** | **str**| alarmId | 

### Return type

[**JobIdResponse**](JobIdResponse.md)

### Authorization

[x-hm-authorization](../README.md#x-hm-authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **acknowledge_alarms**
> JobIdsResponse acknowledge_alarms(body)

Acknowledge multiple alarms of Network Services

Acknowledge multiple alarms of Network Services

### Example
```python
from __future__ import print_function
import time
import tca.vnffm_v1
from tca.vnffm_v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: x-hm-authorization
configuration = tca.vnffm_v1.Configuration()
configuration.api_key['x-hm-authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-hm-authorization'] = 'Bearer'

# create an instance of the API class
api_instance = tca.vnffm_v1.NsFmAlarmsApi(tca.vnffm_v1.ApiClient(configuration))
body = tca.vnffm_v1.AcknowledgeFilter() # AcknowledgeFilter | 

try:
    # Acknowledge multiple alarms of Network Services
    api_response = api_instance.acknowledge_alarms(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NsFmAlarmsApi->acknowledge_alarms: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AcknowledgeFilter**](AcknowledgeFilter.md)|  | 

### Return type

[**JobIdsResponse**](JobIdsResponse.md)

### Authorization

[x-hm-authorization](../README.md#x-hm-authorization)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **create_subscription**
> FmSubscription create_subscription(body)

Creates a new subscription.

Creates a new subscription.

### Example
```python
from __future__ import print_function
import time
import tca.vnffm_v1
from tca.vnffm_v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: x-hm-authorization
configuration = tca.vnffm_v1.Configuration()
configuration.api_key['x-hm-authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-hm-authorization'] = 'Bearer'

# create an instance of the API class
api_instance = tca.vnffm_v1.NsFmAlarmsApi(tca.vnffm_v1.ApiClient(configuration))
body = tca.vnffm_v1.FmSubscriptionRequest() # FmSubscriptionRequest | 

try:
    # Creates a new subscription.
    api_response = api_instance.create_subscription(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NsFmAlarmsApi->create_subscription: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**FmSubscriptionRequest**](FmSubscriptionRequest.md)|  | 

### Return type

[**FmSubscription**](FmSubscription.md)

### Authorization

[x-hm-authorization](../README.md#x-hm-authorization)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_alarm_for_alarm_id**
> VduAlarmResponse get_alarm_for_alarm_id(alarm_id)

Get Alarm of the Network Services given the alarmId

Get Alarm of the Network Services given the alarmId

### Example
```python
from __future__ import print_function
import time
import tca.vnffm_v1
from tca.vnffm_v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: x-hm-authorization
configuration = tca.vnffm_v1.Configuration()
configuration.api_key['x-hm-authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-hm-authorization'] = 'Bearer'

# create an instance of the API class
api_instance = tca.vnffm_v1.NsFmAlarmsApi(tca.vnffm_v1.ApiClient(configuration))
alarm_id = 'alarm_id_example' # str | alarmId

try:
    # Get Alarm of the Network Services given the alarmId
    api_response = api_instance.get_alarm_for_alarm_id(alarm_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NsFmAlarmsApi->get_alarm_for_alarm_id: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **alarm_id** | **str**| alarmId | 

### Return type

[**VduAlarmResponse**](VduAlarmResponse.md)

### Authorization

[x-hm-authorization](../README.md#x-hm-authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_alarms**
> VduAlarmsResponse get_alarms(filter=filter, nextpage_opaque_marker=nextpage_opaque_marker, page_size=page_size, sort_order=sort_order, sort_column=sort_column)

Get Alarms of all the Network Services

Get Alarms of all the Network Services

### Example
```python
from __future__ import print_function
import time
import tca.vnffm_v1
from tca.vnffm_v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: x-hm-authorization
configuration = tca.vnffm_v1.Configuration()
configuration.api_key['x-hm-authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-hm-authorization'] = 'Bearer'

# create an instance of the API class
api_instance = tca.vnffm_v1.NsFmAlarmsApi(tca.vnffm_v1.ApiClient(configuration))
filter = '' # str |  (optional)
nextpage_opaque_marker = tca.vnffm_v1.ModelInt() # ModelInt |  (optional)
page_size = tca.vnffm_v1.ModelInt() # ModelInt |  (optional)
sort_order = 'asc' # str |  (optional) (default to asc)
sort_column = 'perceivedSeverity' # str |  (optional) (default to perceivedSeverity)

try:
    # Get Alarms of all the Network Services
    api_response = api_instance.get_alarms(filter=filter, nextpage_opaque_marker=nextpage_opaque_marker, page_size=page_size, sort_order=sort_order, sort_column=sort_column)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NsFmAlarmsApi->get_alarms: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **filter** | **str**|  | [optional] 
 **nextpage_opaque_marker** | [**ModelInt**](.md)|  | [optional] 
 **page_size** | [**ModelInt**](.md)|  | [optional] 
 **sort_order** | **str**|  | [optional] [default to asc]
 **sort_column** | **str**|  | [optional] [default to perceivedSeverity]

### Return type

[**VduAlarmsResponse**](VduAlarmsResponse.md)

### Authorization

[x-hm-authorization](../README.md#x-hm-authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_nfv_alarm_by_action**
> AlarmCountForNsResponse get_nfv_alarm_by_action(body, action)

Get Telco Cloud Automation Alarms For Network Services By Action Param

Get Telco Cloud Automation Alarms For Network Services By Action Param

### Example
```python
from __future__ import print_function
import time
import tca.vnffm_v1
from tca.vnffm_v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: x-hm-authorization
configuration = tca.vnffm_v1.Configuration()
configuration.api_key['x-hm-authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-hm-authorization'] = 'Bearer'

# create an instance of the API class
api_instance = tca.vnffm_v1.NsFmAlarmsApi(tca.vnffm_v1.ApiClient(configuration))
body = tca.vnffm_v1.AlarmQueryFilterForNs() # AlarmQueryFilterForNs | 
action = 'action_example' # str | 

try:
    # Get Telco Cloud Automation Alarms For Network Services By Action Param
    api_response = api_instance.get_nfv_alarm_by_action(body, action)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NsFmAlarmsApi->get_nfv_alarm_by_action: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AlarmQueryFilterForNs**](AlarmQueryFilterForNs.md)|  | 
 **action** | **str**|  | 

### Return type

[**AlarmCountForNsResponse**](AlarmCountForNsResponse.md)

### Authorization

[x-hm-authorization](../README.md#x-hm-authorization)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_subscription**
> FmSubscription get_subscription(subscription_id)

Get subscription.

Get subscription.

### Example
```python
from __future__ import print_function
import time
import tca.vnffm_v1
from tca.vnffm_v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: x-hm-authorization
configuration = tca.vnffm_v1.Configuration()
configuration.api_key['x-hm-authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-hm-authorization'] = 'Bearer'

# create an instance of the API class
api_instance = tca.vnffm_v1.NsFmAlarmsApi(tca.vnffm_v1.ApiClient(configuration))
subscription_id = 'subscription_id_example' # str | subscription Id

try:
    # Get subscription.
    api_response = api_instance.get_subscription(subscription_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NsFmAlarmsApi->get_subscription: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **subscription_id** | **str**| subscription Id | 

### Return type

[**FmSubscription**](FmSubscription.md)

### Authorization

[x-hm-authorization](../README.md#x-hm-authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_subscriptions**
> InlineResponse200 get_subscriptions()

List all subscriptions.

List all subscriptions.

### Example
```python
from __future__ import print_function
import time
import tca.vnffm_v1
from tca.vnffm_v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: x-hm-authorization
configuration = tca.vnffm_v1.Configuration()
configuration.api_key['x-hm-authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-hm-authorization'] = 'Bearer'

# create an instance of the API class
api_instance = tca.vnffm_v1.NsFmAlarmsApi(tca.vnffm_v1.ApiClient(configuration))

try:
    # List all subscriptions.
    api_response = api_instance.get_subscriptions()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NsFmAlarmsApi->get_subscriptions: %s\n" % e)
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**InlineResponse200**](InlineResponse200.md)

### Authorization

[x-hm-authorization](../README.md#x-hm-authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **remove_subscription**
> RemoveFmSubscription remove_subscription(subscription_id)

Remove subscription.

Remove subscription.

### Example
```python
from __future__ import print_function
import time
import tca.vnffm_v1
from tca.vnffm_v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: x-hm-authorization
configuration = tca.vnffm_v1.Configuration()
configuration.api_key['x-hm-authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-hm-authorization'] = 'Bearer'

# create an instance of the API class
api_instance = tca.vnffm_v1.NsFmAlarmsApi(tca.vnffm_v1.ApiClient(configuration))
subscription_id = 'subscription_id_example' # str | subscription Id

try:
    # Remove subscription.
    api_response = api_instance.remove_subscription(subscription_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NsFmAlarmsApi->remove_subscription: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **subscription_id** | **str**| subscription Id | 

### Return type

[**RemoveFmSubscription**](RemoveFmSubscription.md)

### Authorization

[x-hm-authorization](../README.md#x-hm-authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

