# NsInstance

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | [**Identifier**](Identifier.md) |  | 
**ns_instance_name** | **str** | Human readable name of the NS instance.  | 
**ns_instance_description** | **str** | Human readable description of the NS instance.  | 
**nsd_id** | [**Identifier**](Identifier.md) |  | 
**nsd_info_id** | [**Identifier**](Identifier.md) |  | 
**flavour_id** | [**IdentifierInNsd**](IdentifierInNsd.md) |  | [optional] 
**vnf_instance** | [**list[VnfInstance]**](VnfInstance.md) | Information on constituent VNF(s) of the NS instance.  | [optional] 
**pnf_info** | [**list[PnfInfo]**](PnfInfo.md) | Information on the PNF(s) that are part of the NS instance.  | [optional] 
**virtual_link_info** | [**list[NsVirtualLinkInfo]**](NsVirtualLinkInfo.md) | Information on the VL(s) of the NS instance. This attribute shall be present if the nsState attribute value is INSTANTIATED and if the NS instance has specified connectivity.  | [optional] 
**vnffg_info** | [**list[VnffgInfo]**](VnffgInfo.md) | Information on the VNFFG(s) of the NS instance.  | [optional] 
**sap_info** | [**list[SapInfo]**](SapInfo.md) | Information on the SAP(s) of the NS instance.  | [optional] 
**nested_ns_instance_id** | [**list[Identifier]**](Identifier.md) | Identifier of the nested NS(s) of the NS instance.  | [optional] 
**ns_state** | **str** | The state of the NS instance. Permitted values: NOT_INSTANTIATED: The NS instance is terminated or not instantiated. INSTANTIATED: The NS instance is instantiated.  | 
**monitoring_parameter** | [**list[NsMonitoringParameter]**](NsMonitoringParameter.md) | Performance metrics tracked by the NFVO (e.g. for auto-scaling purposes) as identified by the NS designer in the NSD.  | [optional] 
**ns_scale_status** | [**list[NsScaleInfo]**](NsScaleInfo.md) | Status of each NS scaling aspect declared in the applicable DF, how \&quot;big\&quot; the NS instance has been scaled w.r.t. that aspect. This attribute shall be present if the nsState attribute value is INSTANTIATED.  | [optional] 
**additional_affinity_or_anti_affinity_rule** | [**list[AffinityOrAntiAffinityRule]**](AffinityOrAntiAffinityRule.md) | Information on the additional affinity or anti-affinity rule from NS instantiation operation. Shall not conflict with rules already specified in the NSD.  | [optional] 
**links** | [**NsInstanceLinks**](NsInstanceLinks.md) |  | 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

