# tca.nslcm_extn.NsLcmApi

All URIs are relative to */*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_ns_instance_model**](NsLcmApi.md#get_ns_instance_model) | **GET** /telco/api/nslcm/v2/ns_instances/{instanceId}/model | 
[**query_ns_lcm_operation_jobs**](NsLcmApi.md#query_ns_lcm_operation_jobs) | **GET** /telco/api/nslcm/v2/ns_instances/{nsId}/ns_lcm_op_occs | 
[**telco_api_nslcm_v2_ns_instances_ns_id_upgrade_package_post**](NsLcmApi.md#telco_api_nslcm_v2_ns_instances_ns_id_upgrade_package_post) | **POST** /telco/api/nslcm/v2/ns_instances/{nsId}/upgradePackage | 
[**telco_api_nslcm_v2_ns_lcm_op_occs_ns_id_update_state_post**](NsLcmApi.md#telco_api_nslcm_v2_ns_lcm_op_occs_ns_id_update_state_post) | **POST** /telco/api/nslcm/v2/ns_lcm_op_occs/{nsId}/update_state | 

# **get_ns_instance_model**
> NsInstanceModel get_ns_instance_model(instance_id)



Get Network Service Instance Model

### Example
```python
from __future__ import print_function
import time
import tca.nslcm_extn
from tca.nslcm_extn.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.nslcm_extn.NsLcmApi()
instance_id = 'instance_id_example' # str | 

try:
    api_response = api_instance.get_ns_instance_model(instance_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NsLcmApi->get_ns_instance_model: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **instance_id** | **str**|  | 

### Return type

[**NsInstanceModel**](NsInstanceModel.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **query_ns_lcm_operation_jobs**
> InlineResponse200 query_ns_lcm_operation_jobs(ns_id)



Query Network Service LCM Operation Jobs

### Example
```python
from __future__ import print_function
import time
import tca.nslcm_extn
from tca.nslcm_extn.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.nslcm_extn.NsLcmApi()
ns_id = 'ns_id_example' # str | 

try:
    api_response = api_instance.query_ns_lcm_operation_jobs(ns_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NsLcmApi->query_ns_lcm_operation_jobs: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ns_id** | **str**|  | 

### Return type

[**InlineResponse200**](InlineResponse200.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **telco_api_nslcm_v2_ns_instances_ns_id_upgrade_package_post**
> NetworkService telco_api_nslcm_v2_ns_instances_ns_id_upgrade_package_post(body, ns_id)



### Example
```python
from __future__ import print_function
import time
import tca.nslcm_extn
from tca.nslcm_extn.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.nslcm_extn.NsLcmApi()
body = tca.nslcm_extn.NsIdUpgradePackageBody() # NsIdUpgradePackageBody | 
ns_id = 'ns_id_example' # str | 

try:
    api_response = api_instance.telco_api_nslcm_v2_ns_instances_ns_id_upgrade_package_post(body, ns_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NsLcmApi->telco_api_nslcm_v2_ns_instances_ns_id_upgrade_package_post: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**NsIdUpgradePackageBody**](NsIdUpgradePackageBody.md)|  | 
 **ns_id** | **str**|  | 

### Return type

[**NetworkService**](NetworkService.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **telco_api_nslcm_v2_ns_lcm_op_occs_ns_id_update_state_post**
> NsLcmOpOcc telco_api_nslcm_v2_ns_lcm_op_occs_ns_id_update_state_post(body, ns_id)



### Example
```python
from __future__ import print_function
import time
import tca.nslcm_extn
from tca.nslcm_extn.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.nslcm_extn.NsLcmApi()
body = NULL # object | 
ns_id = 'ns_id_example' # str | 

try:
    api_response = api_instance.telco_api_nslcm_v2_ns_lcm_op_occs_ns_id_update_state_post(body, ns_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling NsLcmApi->telco_api_nslcm_v2_ns_lcm_op_occs_ns_id_update_state_post: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**object**](object.md)|  | 
 **ns_id** | **str**|  | 

### Return type

[**NsLcmOpOcc**](NsLcmOpOcc.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

