# NsdInfo

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | [**Identifier**](Identifier.md) |  | 
**nsd_id** | [**Identifier**](Identifier.md) |  | [optional] 
**nsd_name** | **str** | Name of the on boarded NSD. This information is copied from the NSD content and shall be present after the NSD content is on-boarded.  | [optional] 
**nsd_version** | [**Version**](Version.md) |  | [optional] 
**nsd_designer** | **str** | Designer of the on-boarded NSD. This information is copied from the NSD content and shall be present after the NSD content is on-boarded.  | [optional] 
**nsd_invariant_id** | [**Identifier**](Identifier.md) |  | [optional] 
**vnf_pkg_ids** | [**list[Identifier]**](Identifier.md) | Identifies the VNF package for the VNFD referenced by the on-boarded NS descriptor resource.  | [optional] 
**pnfd_info_ids** | [**list[Identifier]**](Identifier.md) | Identifies the PnfdInfo element for the PNFD referenced by the on-boarded NS descriptor resource.  | [optional] 
**nested_nsd_info_ids** | [**list[Identifier]**](Identifier.md) | Identifies the NsdInfo element for the nested NSD referenced by the on-boarded NS descriptor resource.  | [optional] 
**archive_security_option** | **str** | Signals the security option used by the NSD archive as defined in clause 5.1 of ETSI GS NFV SOL 007. Valid values: OPTION_1, OPTION_2  | [optional] 
**signing_certificate** | [**String**](String.md) |  | [optional] 
**artifacts** | [**list[NsdArchiveArtifactInfo]**](NsdArchiveArtifactInfo.md) | Information about NSD archive artifacts contained in the NSD archive. This attribute shall not be present before the NSD archive content is on-boarded. Otherwise, this attribute shall be present if the NSD archive contains artifacts.  | [optional] 
**nsd_onboarding_state** | [**NsdOnboardingStateType**](NsdOnboardingStateType.md) |  | 
**onboarding_failure_details** | [**ProblemDetails**](ProblemDetails.md) |  | [optional] 
**nsd_operational_state** | [**NsdOperationalStateType**](NsdOperationalStateType.md) |  | 
**nsd_usage_state** | [**NsdUsageStateType**](NsdUsageStateType.md) |  | 
**user_defined_data** | [**UserDefinedDataType**](UserDefinedDataType.md) |  | [optional] 
**links** | [**NsdInfoLinks**](NsdInfoLinks.md) |  | 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

