# NsdmNotificationsFilter

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**notification_types** | [**list[NotificationEnumTypes]**](NotificationEnumTypes.md) | Match particular notification types. Permitted values: NsdOnBoardingNotification, NsdOnboardingFailureNotification, NsdChangeNotification, NsdDeletionNotification PnfdOnBoardingNotification, PnfdOnBoardingFailureNotification, PnfdDeletionNotification. The permitted values of the \&quot;notificationTypes\&quot; ] attribute are spelled exactly as the names of the notification types to facilitate automated code generation systems.  | [optional] 
**nsd_info_id** | [**list[Identifier]**](Identifier.md) | Match the NsdInfo identifier which is allocated by the NFVO.  | [optional] 
**nsd_id** | [**list[Identifier]**](Identifier.md) | Match the NSD identifier, which is allocated by the NSD designer.  | [optional] 
**nsd_name** | [**list[String]**](String.md) | Match the name of the on boarded NSD.  | [optional] 
**nsd_version** | [**list[Version]**](Version.md) | Match the NSD version listed as part of this attribute.  | [optional] 
**nsd_designer** | [**list[String]**](String.md) | Match the NSD designer of the on-boarded NSD.  | [optional] 
**nsd_invariant_id** | [**list[Identifier]**](Identifier.md) | Match the NSD invariant identifier which is allocated by the NSD designer and identifies an NSD in a version independent manner.  | [optional] 
**vnf_pkg_ids** | [**list[Identifier]**](Identifier.md) | Match VNF packages with a package identifier listed in the attribute.  | [optional] 
**pnfd_info_ids** | [**list[Identifier]**](Identifier.md) | Match the PnfdInfo identifier for the PNFD referenced by the on-boarded NSD.  | [optional] 
**nested_nsd_info_ids** | [**list[Identifier]**](Identifier.md) | Match the NsdInfo identifier for the nested NSD referenced by the on-boarded NSD.  | [optional] 
**nsd_onboarding_state** | [**list[NsdOnboardingStateType]**](NsdOnboardingStateType.md) | Match particular on-boarding state of the NSD.  | [optional] 
**nsd_operational_state** | [**list[NsdOperationalStateType]**](NsdOperationalStateType.md) | Match particular operational state of the on-boarded NSD.  | [optional] 
**nsd_usage_state** | [**list[NsdUsageStateType]**](NsdUsageStateType.md) | Match particular usage state of the on-boarded NSD.  | [optional] 
**pnfd_id** | [**list[Identifier]**](Identifier.md) | Match the PNFD identifier which is copied from the PNFD content.  | [optional] 
**pnfd_name** | [**list[String]**](String.md) | Match the name of the on-boarded PNFD.  | [optional] 
**pnfd_version** | [**list[Version]**](Version.md) | Match the PNFD designer of the on-boarded PNFD.  | [optional] 
**pnfd_provider** | [**list[String]**](String.md) | Match the provider of the on-boarded PNFD.  | [optional] 
**pnfd_invariant_id** | [**list[Identifier]**](Identifier.md) | Match the PNFD in a version independent manner.  | [optional] 
**pnfd_onboarding_state** | [**list[PnfdOnboardingStateType]**](PnfdOnboardingStateType.md) | Match particular on-boarding state of the PNFD.  | [optional] 
**pnfd_usage_state** | [**list[PnfdUsageStateType]**](PnfdUsageStateType.md) | Match the usage state of the individual PNF descriptor resource.  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

