# tca.vnfpm_extn.PerformanceManagementApi

All URIs are relative to */telco/api/vnfpm/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**download_report_file**](PerformanceManagementApi.md#download_report_file) | **GET** /pm_jobs/{pmJobId}/reports/{reportId}/download | Download available Performance Management Job report file
[**query_inventory_stats**](PerformanceManagementApi.md#query_inventory_stats) | **POST** /{vnfInstanceId}/stats | Get Stats from Vms given the vdu Id

# **download_report_file**
> download_report_file(pm_job_id, report_id)

Download available Performance Management Job report file

Download available Performance Management Job report file

### Example
```python
from __future__ import print_function
import time
import tca.vnfpm_extn
from tca.vnfpm_extn.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.vnfpm_extn.PerformanceManagementApi()
pm_job_id = NULL # object | Performance Management Job Id
report_id = NULL # object | Performance Management Job Report Id

try:
    # Download available Performance Management Job report file
    api_instance.download_report_file(pm_job_id, report_id)
except ApiException as e:
    print("Exception when calling PerformanceManagementApi->download_report_file: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **pm_job_id** | [**object**](.md)| Performance Management Job Id | 
 **report_id** | [**object**](.md)| Performance Management Job Report Id | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **query_inventory_stats**
> VduStatsResponse query_inventory_stats(body, vnf_instance_id, accept_language=accept_language)

Get Stats from Vms given the vdu Id

Get Stats from Vms given the vdu Id

### Example
```python
from __future__ import print_function
import time
import tca.vnfpm_extn
from tca.vnfpm_extn.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.vnfpm_extn.PerformanceManagementApi()
body = tca.vnfpm_extn.StatsFilter() # StatsFilter | Stats filter
vnf_instance_id = 'vnf_instance_id_example' # str | Network Function Instance Id
accept_language = 'en-US' # str | Specify which languages the client is able to understand. Default value 'en-US' Reference: IETF RFC 3282  (optional) (default to en-US)

try:
    # Get Stats from Vms given the vdu Id
    api_response = api_instance.query_inventory_stats(body, vnf_instance_id, accept_language=accept_language)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling PerformanceManagementApi->query_inventory_stats: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**StatsFilter**](StatsFilter.md)| Stats filter | 
 **vnf_instance_id** | **str**| Network Function Instance Id | 
 **accept_language** | **str**| Specify which languages the client is able to understand. Default value &#x27;en-US&#x27; Reference: IETF RFC 3282  | [optional] [default to en-US]

### Return type

[**VduStatsResponse**](VduStatsResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: */*
 - **Accept**: */*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

