# PnfdInfo

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | [**Identifier**](Identifier.md) |  | 
**pnfd_id** | [**Identifier**](Identifier.md) |  | [optional] 
**pnfd_name** | **str** | Name of the on-boarded PNFD. This information is copied from the PNFD content and shall be present after the PNFD content is on-boarded.  | [optional] 
**pnfd_version** | [**Version**](Version.md) |  | [optional] 
**pnfd_provider** | **str** | Provider of the on-boarded PNFD. This information is copied from the PNFD content and shall be present after the PNFD content is on-boarded.  | [optional] 
**pnfd_invariant_id** | [**Identifier**](Identifier.md) |  | [optional] 
**archive_security_option** | **str** | Signals the security option used by the PNFD archive as defined in clause 5.1 of ETSI GS NFV SOL 004. Valid values: OPTION_1, OPTION_2  | [optional] 
**signing_certificate** | [**String**](String.md) |  | [optional] 
**artifacts** | [**list[PnfdArchiveArtifactInfo]**](PnfdArchiveArtifactInfo.md) | Information about PNFD archive artifacts contained in the PNFD archive. This attribute shall not be present before the PNFD archive content is on-boarded. Otherwise, this attribute shall be present if the PNFD archive contains artifacts.  | [optional] 
**pnfd_onboarding_state** | [**PnfdOnboardingStateType**](PnfdOnboardingStateType.md) |  | 
**onboarding_failure_details** | [**ProblemDetails**](ProblemDetails.md) |  | [optional] 
**pnfd_usage_state** | [**PnfdUsageStateType**](PnfdUsageStateType.md) |  | 
**user_defined_data** | [**KeyValuePairs**](KeyValuePairs.md) |  | [optional] 
**links** | [**PnfdInfoLinks**](PnfdInfoLinks.md) |  | 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

