# RegisterVimResponse

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**tenant_id** | **str** | The TCA generated identifier for the tenant associated with the VIM. | [optional] 
**vim_name** | **str** | The user-friendly name to be given to the VIM registered in TCA. | [optional] 
**tenant_name** | **str** | The name of tenant, who owns the VIM (or a share of the VIM, in case of multi-tenant VIM, e.g. VMware vCloud Director, VIO). | [optional] 
**state** | **str** | The state of the VIM registration operation. | [optional] 
**hcx_cloud_url** | **str** | The Control-Plane server URL, e.g. &#x27;https://cp-server/&#x27;, that manages the VIM. | [optional] 
**username** | **str** | The username associated with the tenants ownership in the VIM. | [optional] 
**password** | **str** | The password associated with the username. Mandatory if the &#x27;username&#x27; is specified. | [optional] 
**tags** | [**list[Tag]**](Tag.md) | A container for the list of tags to be associated with the VIM. | [optional] 
**vim_type** | **str** | The type of VIM. Allowed values include &#x27;VC&#x27;, &#x27;VCD&#x27;, &#x27;VIO&#x27;, &#x27;KUBERNETES&#x27;, &#x27;VMC&#x27;, &#x27;AZURE&#x27;, &#x27;GOOGLECLOUD&#x27;, &#x27;IBMCLOUD&#x27;. The &#x27;VC&#x27; stands for VMware vCenter™; &#x27;VCD&#x27; for VMware vCloud-Director™, and &#x27;VIO&#x27; for VMware-Integrated-Openstack™. | [optional] 
**vim_url** | **str** | The URL to externally access the VIM. This corresponds to the API-service URL in case of Kubernetes VIM. | [optional] 
**hcx_uuid** | **str** | An internal Unique identifier of the VIM, managed by the TCA Control-Plane. | [optional] 
**hcx_tenant_id** | **str** | An internal Unique identifier of the tenant, managed by the TCA Control-Plane. | [optional] 
**organization** | **str** | The tenancy name of the tenant, managed internally by the VIM. | [optional] 
**enterprise** | **str** | The tenancy enterprise (if any) of the tenant, managed internally by the VIM. | [optional] 
**location** | [**VimLocation**](VimLocation.md) |  | [optional] 
**vim_id** | **str** | The unique identifier to be used for referencing the VIM when using other APIs or Operations. | [optional] 
**audit** | [**RegisterVimResponseAudit**](RegisterVimResponseAudit.md) |  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

