# tca.system_management.ServicesApi

All URIs are relative to **

Method | HTTP request | Description
------------- | ------------- | -------------
[**components_appengine_post**](ServicesApi.md#components_appengine_post) | **POST** /components/appengine | Stopping a App Engine
[**components_appengine_status_get**](ServicesApi.md#components_appengine_status_get) | **GET** /components/appengine/status | App Engine Status
[**components_ssh_post**](ServicesApi.md#components_ssh_post) | **POST** /components/ssh | Stopping a SSH
[**components_ssh_status_get**](ServicesApi.md#components_ssh_status_get) | **GET** /components/ssh/status | SSH Status
[**components_web_post**](ServicesApi.md#components_web_post) | **POST** /components/web | Stopping a Web Service
[**components_web_status_get**](ServicesApi.md#components_web_status_get) | **GET** /components/web/status | Web Engine Status

# **components_appengine_post**
> InlineResponse2001 components_appengine_post(action, accept, content_type)

Stopping a App Engine

Api to stop the App Engine

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.ServicesApi(tca.system_management.ApiClient(configuration))
action = 'action_example' # str | 
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Stopping a App Engine
    api_response = api_instance.components_appengine_post(action, accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ServicesApi->components_appengine_post: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **action** | **str**|  | 
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse2001**](InlineResponse2001.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **components_appengine_status_get**
> InlineResponse2001 components_appengine_status_get(accept)

App Engine Status

Api to get the status of App Engine

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.ServicesApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)

try:
    # App Engine Status
    api_response = api_instance.components_appengine_status_get(accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ServicesApi->components_appengine_status_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse2001**](InlineResponse2001.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **components_ssh_post**
> InlineResponse2001 components_ssh_post(action, accept, content_type)

Stopping a SSH

Api to stop the ssh

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.ServicesApi(tca.system_management.ApiClient(configuration))
action = 'action_example' # str | 
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Stopping a SSH
    api_response = api_instance.components_ssh_post(action, accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ServicesApi->components_ssh_post: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **action** | **str**|  | 
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse2001**](InlineResponse2001.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **components_ssh_status_get**
> InlineResponse2001 components_ssh_status_get(accept)

SSH Status

Api to get the status of SSH

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.ServicesApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)

try:
    # SSH Status
    api_response = api_instance.components_ssh_status_get(accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ServicesApi->components_ssh_status_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse2001**](InlineResponse2001.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **components_web_post**
> InlineResponse2001 components_web_post(action, accept, content_type)

Stopping a Web Service

Api to stop the web service

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.ServicesApi(tca.system_management.ApiClient(configuration))
action = 'action_example' # str | 
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Stopping a Web Service
    api_response = api_instance.components_web_post(action, accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ServicesApi->components_web_post: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **action** | **str**|  | 
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse2001**](InlineResponse2001.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **components_web_status_get**
> InlineResponse2002 components_web_status_get(accept, content_type)

Web Engine Status

Api to get the status of web service

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.ServicesApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Web Engine Status
    api_response = api_instance.components_web_status_get(accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ServicesApi->components_web_status_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse2002**](InlineResponse2002.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

