# tca.tcfm.StatusApi

All URIs are relative to */hybridity/api/*

Method | HTTP request | Description
------------- | ------------- | -------------
[**domain_hosts_status**](StatusApi.md#domain_hosts_status) | **POST** /ztp/status | Get status of domains and hosts of type cell site
[**get_status**](StatusApi.md#get_status) | **GET** /ztp/status | Get Status

# **domain_hosts_status**
> DomainHostsStatusResponse domain_hosts_status(body)

Get status of domains and hosts of type cell site

Get status of domains and hosts with task details. Domains or Hosts provided should belong to cell sites. 

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.StatusApi()
body = tca.tcfm.DomainHostsStatusRequest() # DomainHostsStatusRequest | For filterType as HOST give list of host's FQDNs and for DOMAIN give List of domains.

try:
    # Get status of domains and hosts of type cell site
    api_response = api_instance.domain_hosts_status(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling StatusApi->domain_hosts_status: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**DomainHostsStatusRequest**](DomainHostsStatusRequest.md)| For filterType as HOST give list of host&#x27;s FQDNs and for DOMAIN give List of domains. | 

### Return type

[**DomainHostsStatusResponse**](DomainHostsStatusResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_status**
> ConfigStatus get_status()

Get Status

Get Status

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.StatusApi()

try:
    # Get Status
    api_response = api_instance.get_status()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling StatusApi->get_status: %s\n" % e)
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**ConfigStatus**](ConfigStatus.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

