# tca.tcfm.TasksApi

All URIs are relative to */hybridity/api/*

Method | HTTP request | Description
------------- | ------------- | -------------
[**failed_hosts_tasks**](TasksApi.md#failed_hosts_tasks) | **POST** /ztp/tasks/hosts/failure-status | Get tasks details for failed hosts
[**get_tasks**](TasksApi.md#get_tasks) | **GET** /ztp/tasks | Get Tasks

# **failed_hosts_tasks**
> FailedHostsTasksResponse failed_hosts_tasks(body)

Get tasks details for failed hosts

Get tasks details for hosts which failed while adding, deleting, configuring host config profile

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.TasksApi()
body = tca.tcfm.FailedHostsTasksRequest() # FailedHostsTasksRequest | List of hosts FQDN

try:
    # Get tasks details for failed hosts
    api_response = api_instance.failed_hosts_tasks(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling TasksApi->failed_hosts_tasks: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**FailedHostsTasksRequest**](FailedHostsTasksRequest.md)| List of hosts FQDN | 

### Return type

[**FailedHostsTasksResponse**](FailedHostsTasksResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_tasks**
> TasksResponse get_tasks()

Get Tasks

Get Tasks

### Example
```python
from __future__ import print_function
import time
import tca.tcfm
from tca.tcfm.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.tcfm.TasksApi()

try:
    # Get Tasks
    api_response = api_instance.get_tasks()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling TasksApi->get_tasks: %s\n" % e)
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**TasksResponse**](TasksResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

