# tca.system_management.TechSupportLogsApi

All URIs are relative to **

Method | HTTP request | Description
------------- | ------------- | -------------
[**api_admin_tech_support_logs_file_name_get**](TechSupportLogsApi.md#api_admin_tech_support_logs_file_name_get) | **GET** /api/admin/techSupportLogs/{fileName} | Download the Tech Support Bundle
[**api_admin_tech_support_logs_generate_post**](TechSupportLogsApi.md#api_admin_tech_support_logs_generate_post) | **POST** /api/admin/techSupportLogs/generate | Generate Tech Support Logs
[**api_admin_tech_support_logs_job_status_job_id_get**](TechSupportLogsApi.md#api_admin_tech_support_logs_job_status_job_id_get) | **GET** /api/admin/techSupportLogs/jobStatus/{jobId} | Query for tech support job status
[**api_admin_tech_support_logs_retrieve_components_get**](TechSupportLogsApi.md#api_admin_tech_support_logs_retrieve_components_get) | **GET** /api/admin/techSupportLogs/retrieveComponents | Fetch Fleet Components
[**api_admin_tech_support_logs_retrieve_sentinel_inventory_get**](TechSupportLogsApi.md#api_admin_tech_support_logs_retrieve_sentinel_inventory_get) | **GET** /api/admin/techSupportLogs/retrieveSentinelInventory | Fetch Sentinel Inventory

# **api_admin_tech_support_logs_file_name_get**
> api_admin_tech_support_logs_file_name_get(file_name, accept)

Download the Tech Support Bundle

This Api will download the tech support bundle

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.TechSupportLogsApi(tca.system_management.ApiClient(configuration))
file_name = 'file_name_example' # str | 
accept = 'application/octet-stream' # str | application/octet-stream (default to application/octet-stream)

try:
    # Download the Tech Support Bundle
    api_instance.api_admin_tech_support_logs_file_name_get(file_name, accept)
except ApiException as e:
    print("Exception when calling TechSupportLogsApi->api_admin_tech_support_logs_file_name_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **file_name** | **str**|  | 
 **accept** | **str**| application/octet-stream | [default to application/octet-stream]

### Return type

void (empty response body)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_tech_support_logs_generate_post**
> InlineResponse2009 api_admin_tech_support_logs_generate_post(body, accept, content_type)

Generate Tech Support Logs

This Api will generate the tech support logs

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.TechSupportLogsApi(tca.system_management.ApiClient(configuration))
body = tca.system_management.TechSupportLogsGenerateBody() # TechSupportLogsGenerateBody | 
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Generate Tech Support Logs
    api_response = api_instance.api_admin_tech_support_logs_generate_post(body, accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling TechSupportLogsApi->api_admin_tech_support_logs_generate_post: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**TechSupportLogsGenerateBody**](TechSupportLogsGenerateBody.md)|  | 
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse2009**](InlineResponse2009.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_tech_support_logs_job_status_job_id_get**
> InlineResponse20013 api_admin_tech_support_logs_job_status_job_id_get(job_id, accept)

Query for tech support job status

This Api will Query for tech support job status

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.TechSupportLogsApi(tca.system_management.ApiClient(configuration))
job_id = 'job_id_example' # str | 
accept = 'application/json' # str | application/json (default to application/json)

try:
    # Query for tech support job status
    api_response = api_instance.api_admin_tech_support_logs_job_status_job_id_get(job_id, accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling TechSupportLogsApi->api_admin_tech_support_logs_job_status_job_id_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **job_id** | **str**|  | 
 **accept** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse20013**](InlineResponse20013.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_tech_support_logs_retrieve_components_get**
> list[InlineResponse20011] api_admin_tech_support_logs_retrieve_components_get(accept)

Fetch Fleet Components

This Api will fetch the list of fleet components

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.TechSupportLogsApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)

try:
    # Fetch Fleet Components
    api_response = api_instance.api_admin_tech_support_logs_retrieve_components_get(accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling TechSupportLogsApi->api_admin_tech_support_logs_retrieve_components_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]

### Return type

[**list[InlineResponse20011]**](InlineResponse20011.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_tech_support_logs_retrieve_sentinel_inventory_get**
> list[InlineResponse20012] api_admin_tech_support_logs_retrieve_sentinel_inventory_get(accept)

Fetch Sentinel Inventory

This Api will fetch the list of sentinels

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.TechSupportLogsApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)

try:
    # Fetch Sentinel Inventory
    api_response = api_instance.api_admin_tech_support_logs_retrieve_sentinel_inventory_get(accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling TechSupportLogsApi->api_admin_tech_support_logs_retrieve_sentinel_inventory_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]

### Return type

[**list[InlineResponse20012]**](InlineResponse20012.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

