# tca.system_management.TimeApi

All URIs are relative to **

Method | HTTP request | Description
------------- | ------------- | -------------
[**system_timesettings_get**](TimeApi.md#system_timesettings_get) | **GET** /system/timesettings | Get Time Settings (NTP, Date &amp; Timezone)
[**system_timesettings_ntp_delete**](TimeApi.md#system_timesettings_ntp_delete) | **DELETE** /system/timesettings/ntp | Remove NTP Settings
[**system_timesettings_put**](TimeApi.md#system_timesettings_put) | **PUT** /system/timesettings | Configure Time Settings (NTP, Date &amp; Timezone)

# **system_timesettings_get**
> InlineResponse2005 system_timesettings_get(accept)

Get Time Settings (NTP, Date & Timezone)

Api to get Time Settings (NTP, Date & Timezone)

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.TimeApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)

try:
    # Get Time Settings (NTP, Date & Timezone)
    api_response = api_instance.system_timesettings_get(accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling TimeApi->system_timesettings_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse2005**](InlineResponse2005.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **system_timesettings_ntp_delete**
> system_timesettings_ntp_delete()

Remove NTP Settings

Api to Remove NTP Settings

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.TimeApi(tca.system_management.ApiClient(configuration))

try:
    # Remove NTP Settings
    api_instance.system_timesettings_ntp_delete()
except ApiException as e:
    print("Exception when calling TimeApi->system_timesettings_ntp_delete: %s\n" % e)
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **system_timesettings_put**
> InlineResponse2005 system_timesettings_put(body, accept, content_type)

Configure Time Settings (NTP, Date & Timezone)

Api to Configure Time Settings (NTP, Date & Timezone). Individual Component Management Services may have to be restarted for NTP server settings to take effect.

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.TimeApi(tca.system_management.ApiClient(configuration))
body = tca.system_management.SystemTimesettingsBody() # SystemTimesettingsBody | 
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Configure Time Settings (NTP, Date & Timezone)
    api_response = api_instance.system_timesettings_put(body, accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling TimeApi->system_timesettings_put: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**SystemTimesettingsBody**](SystemTimesettingsBody.md)|  | 
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

[**InlineResponse2005**](InlineResponse2005.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

