# tca.troubleshooting.TroubleshootingApi

All URIs are relative to */hybridity/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_settings**](TroubleshootingApi.md#get_settings) | **GET** /techsupport/settings | 
[**get_task_details**](TroubleshootingApi.md#get_task_details) | **GET** /techsupport/task/{taskId} | 
[**request_tech_support_logs**](TroubleshootingApi.md#request_tech_support_logs) | **POST** /techsupport | 
[**update_settings**](TroubleshootingApi.md#update_settings) | **PUT** /techsupport/settings | 

# **get_settings**
> TechSupportGlobalSettings get_settings()



Get the global Tech-Support settings.

### Example
```python
from __future__ import print_function
import time
import tca.troubleshooting
from tca.troubleshooting.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.troubleshooting.TroubleshootingApi()

try:
    api_response = api_instance.get_settings()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling TroubleshootingApi->get_settings: %s\n" % e)
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**TechSupportGlobalSettings**](TechSupportGlobalSettings.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_task_details**
> TroubleshootingAsyncTask get_task_details(task_id)



Get Tech Support Task details.

### Example
```python
from __future__ import print_function
import time
import tca.troubleshooting
from tca.troubleshooting.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.troubleshooting.TroubleshootingApi()
task_id = 'task_id_example' # str | 

try:
    api_response = api_instance.get_task_details(task_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling TroubleshootingApi->get_task_details: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **task_id** | **str**|  | 

### Return type

[**TroubleshootingAsyncTask**](TroubleshootingAsyncTask.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **request_tech_support_logs**
> TcaJob request_tech_support_logs(body, action)



Request for asynch Tech-Support action. The supported action includes 'collectTechSupportBundle'. After the request is made, TCA carry out an asynchronous job to carry out the action, and responds with the TCA-JobId.

### Example
```python
from __future__ import print_function
import time
import tca.troubleshooting
from tca.troubleshooting.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.troubleshooting.TroubleshootingApi()
body = tca.troubleshooting.TechSupportConfig() # TechSupportConfig | 
action = 'action_example' # str | The Tech-Support action to be taken. The supported action includes 'collectTechSupportBundle'.

try:
    api_response = api_instance.request_tech_support_logs(body, action)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling TroubleshootingApi->request_tech_support_logs: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**TechSupportConfig**](TechSupportConfig.md)|  | 
 **action** | **str**| The Tech-Support action to be taken. The supported action includes &#x27;collectTechSupportBundle&#x27;. | 

### Return type

[**TcaJob**](TcaJob.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_settings**
> update_settings(body)



Update the global Tech-Support Settings.

### Example
```python
from __future__ import print_function
import time
import tca.troubleshooting
from tca.troubleshooting.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.troubleshooting.TroubleshootingApi()
body = tca.troubleshooting.TechSupportGlobalSettings() # TechSupportGlobalSettings | 

try:
    api_instance.update_settings(body)
except ApiException as e:
    print("Exception when calling TroubleshootingApi->update_settings: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**TechSupportGlobalSettings**](TechSupportGlobalSettings.md)|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

