# UpdateNsRequest

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**update_type** | **str** | The type of update. It determines also which one of the following parameters is present in the operation. Possible values include: * ADD_VNF: Adding existing VNF instance(s) * REMOVE_VNF: Removing VNF instance(s) * INSTANTIATE_VNF: Instantiating new VNF(s) * CHANGE_VNF_DF: Changing VNF DF * OPERATE_VNF: Changing VNF state, * MODIFY_VNF_INFORMATION: Modifying VNF information and/or the configurable properties of VNF instance(s) * CHANGE_EXTERNAL_VNF_CONNECTIVITY: Changing the external connectivity of VNF instance(s) * ADD_SAP: Adding SAP(s) * REMOVE_SAP: Removing SAP(s) * ADD_NESTED_NS: Adding existing NS instance(s) as nested NS(s) * REMOVE_NESTED_NS: Removing existing nested NS instance(s) * ASSOC_NEW_NSD_VERSION: Associating a new NSD version to the NS instance * MOVE_VNF: Moving VNF instance(s) from one origin NS instance to another target NS instance * ADD_VNFFG: Adding VNFFG(s) * REMOVE_VNFFG: Removing VNFFG(s) * UPDATE_VNFFG: Updating VNFFG(s) * CHANGE_NS_DF: Changing NS DF * ADD_PNF: Adding PNF * MODIFY_PNF: Modifying PNF * REMOVE_PNF: Removing PNF  | 
**add_vnf_istance** | [**list[VnfInstanceData]**](VnfInstanceData.md) | Identifies an existing VNF instance to be added to the NS instance. It shall be present only if updateType &#x3D; \&quot;ADD_VNF\&quot;.           | [optional] 
**remove_vnf_instance_id** | [**list[Identifier]**](Identifier.md) | Identifies an existing VNF instance to be removed from the NS instance. It contains the identifier(s) of the VNF instances to be removed. It shall be present only if updateType &#x3D; \&quot;REMOVE_VNF.\&quot; Note: If a VNF instance is removed from a NS and this NS was the last one for which this VNF instance was a part, the VNF instance is terminated by the NFVO.  | [optional] 
**instantiate_vnf_data** | [**list[InstantiateVnfData]**](InstantiateVnfData.md) | Identifies the new VNF to be instantiated. It can be used e.g. for the bottom-up NS creation. It shall be present only if updateType &#x3D; \&quot;INSTANTIATE_VNF\&quot;.  | [optional] 
**change_vnf_flavour_data** | [**list[ChangeVnfFlavourData]**](ChangeVnfFlavourData.md) | Identifies the new DF of the VNF instance to be changed to. It shall be present only if updateType &#x3D; \&quot;CHANGE_VNF_DF\&quot;.  | [optional] 
**operate_vnf_data** | [**list[OperateVnfData]**](OperateVnfData.md) | Identifies the state of the VNF instance to be changed.  It shall be present only if updateType &#x3D; \&quot;OPERATE_VNF\&quot;.  | [optional] 
**modify_vnf_info_data** | [**list[ModifyVnfInfoData]**](ModifyVnfInfoData.md) | Identifies the VNF information parameters and/or the configurable properties of VNF instance to be modified. It shall be present only if updateType &#x3D; \&quot;MODIFY_VNF_INFORMATION\&quot;.  | [optional] 
**change_ext_vnf_connectivity_data** | [**list[ChangeExtVnfConnectivityData]**](ChangeExtVnfConnectivityData.md) | Specifies the new external connectivity data of the VNF instance to be changed. It shall be present only if updateType &#x3D; \&quot;CHANGE_EXTERNAL_VNF_CONNECTIVITY\&quot;.  | [optional] 
**add_sap** | [**list[SapData]**](SapData.md) | Identifies a new SAP to be added to the NS instance. It shall be present only if updateType &#x3D; \&quot;ADD_SAP.\&quot;  | [optional] 
**remove_sap_id** | [**list[Identifier]**](Identifier.md) | The identifier an existing SAP to be removed from the NS instance. It shall be present only if updateType &#x3D; \&quot;REMOVE_SAP.\&quot;  | [optional] 
**add_nested_ns_data** | [**list[NestedNsInstanceData]**](NestedNsInstanceData.md) | The identifier of an existing nested NS instance to be added to (nested within) the NS instance. It shall be present only if updateType &#x3D; \&quot;ADD_NESTED_NS\&quot;.  | [optional] 
**remove_nested_ns_id** | [**list[IdentifierInNs]**](IdentifierInNs.md) | The identifier of an existing nested NS instance to be removed from the NS instance. It shall be present only if updateType &#x3D; \&quot;REMOVE_NESTED_NS\&quot;.  | [optional] 
**assoc_new_nsd_version_data** | [**AssocNewNsdVersionData**](AssocNewNsdVersionData.md) |  | [optional] 
**move_vnf_instance_data** | [**list[MoveVnfInstanceData]**](MoveVnfInstanceData.md) | Specify existing VNF instance to be moved from one NS instance to another NS instance. It shall be present only if updateType &#x3D; MOVE_VNF\&quot;.  | [optional] 
**add_vnffg** | [**list[AddVnffgData]**](AddVnffgData.md) | Specify the new VNFFG to be created to the NS Instance. It shall be present only if updateType &#x3D; \&quot;ADD_VNFFG\&quot;.  | [optional] 
**remove_vnffg_id** | [**list[Identifier]**](Identifier.md) | Identifier of an existing VNFFG to be removed from the NS Instance. It shall be present only if updateType &#x3D; \&quot;REMOVE_VNFFG\&quot;.  | [optional] 
**update_vnffg** | [**list[UpdateVnffgData]**](UpdateVnffgData.md) | Specify the new VNFFG Information data to be updated for a VNFFG of the NS Instance. It shall be present only if updateType &#x3D; \&quot;UPDATE_VNFFG\&quot;.  | [optional] 
**change_ns_flavour_data** | [**ChangeNsFlavourData**](ChangeNsFlavourData.md) |  | [optional] 
**add_pnf_data** | [**list[AddPnfData]**](AddPnfData.md) | specifies the PNF to be added into the NS instance.  It shall be present only if updateType &#x3D; \&quot;ADD_PNF\&quot;.  | [optional] 
**modify_pnf_data** | [**list[ModifyPnfData]**](ModifyPnfData.md) | Specifies the PNF to be modified in the NS instance.  It shall be present only if updateType &#x3D; \&quot;MODIFY_PNF\&quot;.  | [optional] 
**remove_pnf_id** | [**list[Identifier]**](Identifier.md) | Identifier of the PNF to be deleted from the NS instance. It shall be present only if updateType &#x3D; \&quot;REMOVE_PNF\&quot;.  | [optional] 
**update_time** | **datetime** |  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

