# tca.system_management.VCenterAndSSOApi

All URIs are relative to **

Method | HTTP request | Description
------------- | ------------- | -------------
[**api_admin_global_config_lookupservice_get**](VCenterAndSSOApi.md#api_admin_global_config_lookupservice_get) | **GET** /api/admin/global/config/lookupservice | Get LookupService
[**api_admin_global_config_lookupservice_post**](VCenterAndSSOApi.md#api_admin_global_config_lookupservice_post) | **POST** /api/admin/global/config/lookupservice | Configure LookupService
[**api_admin_global_config_lookupservice_uuid_put**](VCenterAndSSOApi.md#api_admin_global_config_lookupservice_uuid_put) | **PUT** /api/admin/global/config/lookupservice/{uuid} | Configure LookupService
[**api_admin_global_config_vcenter_get**](VCenterAndSSOApi.md#api_admin_global_config_vcenter_get) | **GET** /api/admin/global/config/vcenter | Get vCenter
[**api_admin_global_config_vcenter_post**](VCenterAndSSOApi.md#api_admin_global_config_vcenter_post) | **POST** /api/admin/global/config/vcenter | Create Vcenter
[**api_admin_global_config_vcenter_uuid_put**](VCenterAndSSOApi.md#api_admin_global_config_vcenter_uuid_put) | **PUT** /api/admin/global/config/vcenter/{uuid} | Modify Vcenter

# **api_admin_global_config_lookupservice_get**
> LookupServiceDetailsResponse api_admin_global_config_lookupservice_get(accept)

Get LookupService

Api to get LookupService configuration

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.VCenterAndSSOApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)

try:
    # Get LookupService
    api_response = api_instance.api_admin_global_config_lookupservice_get(accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling VCenterAndSSOApi->api_admin_global_config_lookupservice_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]

### Return type

[**LookupServiceDetailsResponse**](LookupServiceDetailsResponse.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_global_config_lookupservice_post**
> LookupServiceDetailsResponse api_admin_global_config_lookupservice_post(body, accept, content_type)

Configure LookupService

Api to add LookupService configuration

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.VCenterAndSSOApi(tca.system_management.ApiClient(configuration))
body = tca.system_management.LookupServiceDetailsRequest() # LookupServiceDetailsRequest | 
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Configure LookupService
    api_response = api_instance.api_admin_global_config_lookupservice_post(body, accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling VCenterAndSSOApi->api_admin_global_config_lookupservice_post: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**LookupServiceDetailsRequest**](LookupServiceDetailsRequest.md)|  | 
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

[**LookupServiceDetailsResponse**](LookupServiceDetailsResponse.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_global_config_lookupservice_uuid_put**
> LookupServiceDetailsResponse api_admin_global_config_lookupservice_uuid_put(body, accept, content_type, uuid)

Configure LookupService

Api to modify LookupService configuration

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.VCenterAndSSOApi(tca.system_management.ApiClient(configuration))
body = tca.system_management.LookupServiceDetailsUpdateRequest() # LookupServiceDetailsUpdateRequest | 
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)
uuid = 'uuid_example' # str | 

try:
    # Configure LookupService
    api_response = api_instance.api_admin_global_config_lookupservice_uuid_put(body, accept, content_type, uuid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling VCenterAndSSOApi->api_admin_global_config_lookupservice_uuid_put: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**LookupServiceDetailsUpdateRequest**](LookupServiceDetailsUpdateRequest.md)|  | 
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]
 **uuid** | **str**|  | 

### Return type

[**LookupServiceDetailsResponse**](LookupServiceDetailsResponse.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_global_config_vcenter_get**
> VcenterDetailsResponse api_admin_global_config_vcenter_get(accept)

Get vCenter

Api to get vCenter configuration

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.VCenterAndSSOApi(tca.system_management.ApiClient(configuration))
accept = 'application/json' # str | application/json (default to application/json)

try:
    # Get vCenter
    api_response = api_instance.api_admin_global_config_vcenter_get(accept)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling VCenterAndSSOApi->api_admin_global_config_vcenter_get: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accept** | **str**| application/json | [default to application/json]

### Return type

[**VcenterDetailsResponse**](VcenterDetailsResponse.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_global_config_vcenter_post**
> VcenterDetailsResponse api_admin_global_config_vcenter_post(body, accept, content_type)

Create Vcenter

Api to add vcenter configuration

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.VCenterAndSSOApi(tca.system_management.ApiClient(configuration))
body = tca.system_management.VcenterDetailsRequest() # VcenterDetailsRequest | 
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)

try:
    # Create Vcenter
    api_response = api_instance.api_admin_global_config_vcenter_post(body, accept, content_type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling VCenterAndSSOApi->api_admin_global_config_vcenter_post: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**VcenterDetailsRequest**](VcenterDetailsRequest.md)|  | 
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]

### Return type

[**VcenterDetailsResponse**](VcenterDetailsResponse.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **api_admin_global_config_vcenter_uuid_put**
> VcenterDetailsResponse api_admin_global_config_vcenter_uuid_put(body, accept, content_type, uuid)

Modify Vcenter

Api to modify vcenter configuration

### Example
```python
from __future__ import print_function
import time
import tca.system_management
from tca.system_management.rest import ApiException
from pprint import pprint
# Configure HTTP basic authorization: BASIC_AUTH
configuration = tca.system_management.Configuration()
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# create an instance of the API class
api_instance = tca.system_management.VCenterAndSSOApi(tca.system_management.ApiClient(configuration))
body = tca.system_management.VcenterDetailsUpdateRequest() # VcenterDetailsUpdateRequest | 
accept = 'application/json' # str | application/json (default to application/json)
content_type = 'application/json' # str | application/json (default to application/json)
uuid = 'uuid_example' # str | 

try:
    # Modify Vcenter
    api_response = api_instance.api_admin_global_config_vcenter_uuid_put(body, accept, content_type, uuid)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling VCenterAndSSOApi->api_admin_global_config_vcenter_uuid_put: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**VcenterDetailsUpdateRequest**](VcenterDetailsUpdateRequest.md)|  | 
 **accept** | **str**| application/json | [default to application/json]
 **content_type** | **str**| application/json | [default to application/json]
 **uuid** | **str**|  | 

### Return type

[**VcenterDetailsResponse**](VcenterDetailsResponse.md)

### Authorization

[BASIC_AUTH](../README.md#BASIC_AUTH)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

