# tca.nfv_vim_v1.VIMApi

All URIs are relative to */hybridity/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_tenants**](VIMApi.md#get_tenants) | **GET** /vims/v1/{vimId}/tenants | 
[**get_vims**](VIMApi.md#get_vims) | **GET** /vims/v1/tenants | 
[**modify_vim**](VIMApi.md#modify_vim) | **PUT** /vims/v1/tenants/{tenantId} | 
[**register_vim**](VIMApi.md#register_vim) | **POST** /vims/v1/tenants | 
[**remove_vim**](VIMApi.md#remove_vim) | **DELETE** /vims/v1/tenants/{tenantId} | 
[**validate_vim**](VIMApi.md#validate_vim) | **PUT** /vims/v1/tenants | 

# **get_tenants**
> Tenant get_tenants(vim_id)



Get tenants for the VIM specified by the path parameter vimId

### Example
```python
from __future__ import print_function
import time
import tca.nfv_vim_v1
from tca.nfv_vim_v1.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.nfv_vim_v1.VIMApi()
vim_id = 'vim_id_example' # str | The identifier for the VIM. For TCA the vimId usually starts with the prefix 'vmware_'

try:
    api_response = api_instance.get_tenants(vim_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling VIMApi->get_tenants: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **vim_id** | **str**| The identifier for the VIM. For TCA the vimId usually starts with the prefix &#x27;vmware_&#x27; | 

### Return type

[**Tenant**](Tenant.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_vims**
> VimList get_vims(view=view)



Lists the VIMs registered with the TCA MANO. VIM is an acronym for Virtual Infrastructure Manager, in the NFV parlance.

### Example
```python
from __future__ import print_function
import time
import tca.nfv_vim_v1
from tca.nfv_vim_v1.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.nfv_vim_v1.VIMApi()
view = 'view_example' # str | The view type e.g. 'extended'. This is especially used for UI clients. (optional)

try:
    api_response = api_instance.get_vims(view=view)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling VIMApi->get_vims: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **view** | **str**| The view type e.g. &#x27;extended&#x27;. This is especially used for UI clients. | [optional] 

### Return type

[**VimList**](VimList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **modify_vim**
> RegisterVimResponse modify_vim(tenant_id, body=body)



Modifies the registered VIM, given the path parameter tenantId.

### Example
```python
from __future__ import print_function
import time
import tca.nfv_vim_v1
from tca.nfv_vim_v1.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.nfv_vim_v1.VIMApi()
tenant_id = 'tenant_id_example' # str | 
body = tca.nfv_vim_v1.RegisterVim() # RegisterVim |  (optional)

try:
    api_response = api_instance.modify_vim(tenant_id, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling VIMApi->modify_vim: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenant_id** | **str**|  | 
 **body** | [**RegisterVim**](RegisterVim.md)|  | [optional] 

### Return type

[**RegisterVimResponse**](RegisterVimResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **register_vim**
> RegisterVimResponse register_vim(body=body)



Register a new VIM with the TCA. VIM is an acronym for Virtual Infrastructure Manager, in the NFV parlance.

### Example
```python
from __future__ import print_function
import time
import tca.nfv_vim_v1
from tca.nfv_vim_v1.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.nfv_vim_v1.VIMApi()
body = tca.nfv_vim_v1.RegisterVim() # RegisterVim |  (optional)

try:
    api_response = api_instance.register_vim(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling VIMApi->register_vim: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**RegisterVim**](RegisterVim.md)|  | [optional] 

### Return type

[**RegisterVimResponse**](RegisterVimResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **remove_vim**
> TcaJob remove_vim(tenant_id)



Deletes the registered VIM instance.

### Example
```python
from __future__ import print_function
import time
import tca.nfv_vim_v1
from tca.nfv_vim_v1.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.nfv_vim_v1.VIMApi()
tenant_id = 'tenant_id_example' # str | The identifier corresponding to the VIM instance (or the tenant instance?) to be deleted.

try:
    api_response = api_instance.remove_vim(tenant_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling VIMApi->remove_vim: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tenant_id** | **str**| The identifier corresponding to the VIM instance (or the tenant instance?) to be deleted. | 

### Return type

[**TcaJob**](TcaJob.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **validate_vim**
> ValidateVimResponse validate_vim(action, body=body)



Validates a VIM.

### Example
```python
from __future__ import print_function
import time
import tca.nfv_vim_v1
from tca.nfv_vim_v1.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = tca.nfv_vim_v1.VIMApi()
action = 'action_example' # str | action type e.g. 'validate'.
body = tca.nfv_vim_v1.RegisterVim() # RegisterVim |  (optional)

try:
    api_response = api_instance.validate_vim(action, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling VIMApi->validate_vim: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **action** | **str**| action type e.g. &#x27;validate&#x27;. | 
 **body** | [**RegisterVim**](RegisterVim.md)|  | [optional] 

### Return type

[**ValidateVimResponse**](ValidateVimResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

