# Vim

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**tenant_id** | **str** | The identifier used to reference the tenant of the VIM. | [optional] 
**vim_name** | **str** | The user-friendly name associated with the VIM to be registered with the TCA. | [optional] 
**tenant_name** | **str** | The name of the tenant, who owns the VIM (or a share of the VIM, in case of multi-tenant VIM, e.g. VMware vCloud Director, VIO). Defaults to &#x27;DEFAULT&#x27;. | [optional] 
**hcx_uuid** | **str** | Identifier for the TCA Control-Plane instance, that is associated with the VIM. | [optional] 
**hcx_cloud_url** | **str** | The Control-Plane server URL, e.g. &#x27;https://cp-server/&#x27;, that manages the VIM. | [optional] 
**username** | **str** | The username associated with the tenants ownership in the VIM. This is a mandatory field, if the authentication mode (‘authType’ or ‘auth_type’) specified is ‘password’. | [optional] 
**tags** | [**list[Tag]**](Tag.md) | A container for the list of tags to be associated with the VIM. | [optional] 
**vim_type** | **str** | The type of VIM. Allowed values include &#x27;VC&#x27;, &#x27;VCD&#x27;, &#x27;VIO&#x27;, &#x27;KUBERNETES&#x27;, &#x27;VMC&#x27;, &#x27;AZURE&#x27;, &#x27;GOOGLECLOUD&#x27;, &#x27;IBMCLOUD&#x27;. The &#x27;VC&#x27; stands for VMware vCenter™; &#x27;VCD&#x27; for VMware vCloud-Director™, and &#x27;VIO&#x27; for VMware-Integrated-Openstack™. | [optional] 
**vim_url** | **str** | The URL to externally access the VIM. This corresponds to the API-service URL in case of Kubernetes VIM. | [optional] 
**location** | [**VimLocation**](VimLocation.md) |  | [optional] 
**vim_id** | **str** | The unique identifier to be used for referencing the VIM when using other APIs or Operations. | [optional] 
**audit** | [**VimAudit**](VimAudit.md) |  | [optional] 
**connection** | [**VimConnection**](VimConnection.md) |  | [optional] 
**compatible** | **bool** |  | [optional] 
**vnf_instances_counts** | [**list[VimVnfInstancesCounts]**](VimVnfInstancesCounts.md) | The list of VNF/CNF counts, that are instantiated, and non-instantiated (or otherwise) on the VIM. | [optional] 
**stats** | [**VimStats**](VimStats.md) |  | [optional] 
**id** | **str** |  | [optional] 
**name** | **str** |  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

