# tca.vnffm_v1.VnfFmAlarmsApi

All URIs are relative to */hybridity/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**acknowledge_alarm**](VnfFmAlarmsApi.md#acknowledge_alarm) | **PATCH** /vnffm/v1/alarms/{alarmId} | Acknowledge an Alarm in the vCenter
[**acknowledge_alarms**](VnfFmAlarmsApi.md#acknowledge_alarms) | **PATCH** /vnffm/v1/alarms | Acknowledge multiple alarms
[**get_alarm_for_alarm_id**](VnfFmAlarmsApi.md#get_alarm_for_alarm_id) | **GET** /vnffm/v1/alarms/{alarmId} | Get Alarm of the Network Function given the alarmId
[**get_alarms**](VnfFmAlarmsApi.md#get_alarms) | **GET** /vnffm/v1/alarms | Get Alarms of all the Network Functions
[**get_nfv_alarm_by_action**](VnfFmAlarmsApi.md#get_nfv_alarm_by_action) | **POST** /vnffm/v1/alarms | Get Telco Cloud Automation Alarms For Network Function By Action Param
[**query_alarms**](VnfFmAlarmsApi.md#query_alarms) | **POST** /vnffm/v1/{vnfInstanceId}/alarms | Get Alarms from Vms given the vdu Id

# **acknowledge_alarm**
> JobIdResponse acknowledge_alarm(alarm_id)

Acknowledge an Alarm in the vCenter

Acknowledge an Alarm in the vCenter

### Example
```python
from __future__ import print_function
import time
import tca.vnffm_v1
from tca.vnffm_v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: x-hm-authorization
configuration = tca.vnffm_v1.Configuration()
configuration.api_key['x-hm-authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-hm-authorization'] = 'Bearer'

# create an instance of the API class
api_instance = tca.vnffm_v1.VnfFmAlarmsApi(tca.vnffm_v1.ApiClient(configuration))
alarm_id = 'alarm_id_example' # str | alarmId

try:
    # Acknowledge an Alarm in the vCenter
    api_response = api_instance.acknowledge_alarm(alarm_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling VnfFmAlarmsApi->acknowledge_alarm: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **alarm_id** | **str**| alarmId | 

### Return type

[**JobIdResponse**](JobIdResponse.md)

### Authorization

[x-hm-authorization](../README.md#x-hm-authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **acknowledge_alarms**
> JobIdsResponse acknowledge_alarms(body)

Acknowledge multiple alarms

Acknowledge multiple alarms

### Example
```python
from __future__ import print_function
import time
import tca.vnffm_v1
from tca.vnffm_v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: x-hm-authorization
configuration = tca.vnffm_v1.Configuration()
configuration.api_key['x-hm-authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-hm-authorization'] = 'Bearer'

# create an instance of the API class
api_instance = tca.vnffm_v1.VnfFmAlarmsApi(tca.vnffm_v1.ApiClient(configuration))
body = tca.vnffm_v1.AcknowledgeFilter() # AcknowledgeFilter | 

try:
    # Acknowledge multiple alarms
    api_response = api_instance.acknowledge_alarms(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling VnfFmAlarmsApi->acknowledge_alarms: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AcknowledgeFilter**](AcknowledgeFilter.md)|  | 

### Return type

[**JobIdsResponse**](JobIdsResponse.md)

### Authorization

[x-hm-authorization](../README.md#x-hm-authorization)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_alarm_for_alarm_id**
> VduAlarmResponse get_alarm_for_alarm_id(alarm_id)

Get Alarm of the Network Function given the alarmId

Get Alarm of the Network Function given the alarmId

### Example
```python
from __future__ import print_function
import time
import tca.vnffm_v1
from tca.vnffm_v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: x-hm-authorization
configuration = tca.vnffm_v1.Configuration()
configuration.api_key['x-hm-authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-hm-authorization'] = 'Bearer'

# create an instance of the API class
api_instance = tca.vnffm_v1.VnfFmAlarmsApi(tca.vnffm_v1.ApiClient(configuration))
alarm_id = 'alarm_id_example' # str | alarmId

try:
    # Get Alarm of the Network Function given the alarmId
    api_response = api_instance.get_alarm_for_alarm_id(alarm_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling VnfFmAlarmsApi->get_alarm_for_alarm_id: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **alarm_id** | **str**| alarmId | 

### Return type

[**VduAlarmResponse**](VduAlarmResponse.md)

### Authorization

[x-hm-authorization](../README.md#x-hm-authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_alarms**
> VduAlarmsResponse get_alarms(filter=filter, nextpage_opaque_marker=nextpage_opaque_marker, page_size=page_size, sort_order=sort_order, sort_column=sort_column)

Get Alarms of all the Network Functions

Get Alarms of all the Network Functions

### Example
```python
from __future__ import print_function
import time
import tca.vnffm_v1
from tca.vnffm_v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: x-hm-authorization
configuration = tca.vnffm_v1.Configuration()
configuration.api_key['x-hm-authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-hm-authorization'] = 'Bearer'

# create an instance of the API class
api_instance = tca.vnffm_v1.VnfFmAlarmsApi(tca.vnffm_v1.ApiClient(configuration))
filter = '' # str |  (optional)
nextpage_opaque_marker = tca.vnffm_v1.ModelInt() # ModelInt |  (optional)
page_size = tca.vnffm_v1.ModelInt() # ModelInt |  (optional)
sort_order = 'asc' # str |  (optional) (default to asc)
sort_column = 'perceivedSeverity' # str |  (optional) (default to perceivedSeverity)

try:
    # Get Alarms of all the Network Functions
    api_response = api_instance.get_alarms(filter=filter, nextpage_opaque_marker=nextpage_opaque_marker, page_size=page_size, sort_order=sort_order, sort_column=sort_column)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling VnfFmAlarmsApi->get_alarms: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **filter** | **str**|  | [optional] 
 **nextpage_opaque_marker** | [**ModelInt**](.md)|  | [optional] 
 **page_size** | [**ModelInt**](.md)|  | [optional] 
 **sort_order** | **str**|  | [optional] [default to asc]
 **sort_column** | **str**|  | [optional] [default to perceivedSeverity]

### Return type

[**VduAlarmsResponse**](VduAlarmsResponse.md)

### Authorization

[x-hm-authorization](../README.md#x-hm-authorization)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_nfv_alarm_by_action**
> AlarmCountResponse get_nfv_alarm_by_action(body, action)

Get Telco Cloud Automation Alarms For Network Function By Action Param

Get Telco Cloud Automation Alarms For Network Function By Action Param

### Example
```python
from __future__ import print_function
import time
import tca.vnffm_v1
from tca.vnffm_v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: x-hm-authorization
configuration = tca.vnffm_v1.Configuration()
configuration.api_key['x-hm-authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-hm-authorization'] = 'Bearer'

# create an instance of the API class
api_instance = tca.vnffm_v1.VnfFmAlarmsApi(tca.vnffm_v1.ApiClient(configuration))
body = tca.vnffm_v1.AlarmQueryFilter() # AlarmQueryFilter | 
action = 'action_example' # str | 

try:
    # Get Telco Cloud Automation Alarms For Network Function By Action Param
    api_response = api_instance.get_nfv_alarm_by_action(body, action)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling VnfFmAlarmsApi->get_nfv_alarm_by_action: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AlarmQueryFilter**](AlarmQueryFilter.md)|  | 
 **action** | **str**|  | 

### Return type

[**AlarmCountResponse**](AlarmCountResponse.md)

### Authorization

[x-hm-authorization](../README.md#x-hm-authorization)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **query_alarms**
> VduAlarmsResponse query_alarms(body, vnf_instance_id)

Get Alarms from Vms given the vdu Id

Get Alarms from Vms given the vdu Id

### Example
```python
from __future__ import print_function
import time
import tca.vnffm_v1
from tca.vnffm_v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: x-hm-authorization
configuration = tca.vnffm_v1.Configuration()
configuration.api_key['x-hm-authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-hm-authorization'] = 'Bearer'

# create an instance of the API class
api_instance = tca.vnffm_v1.VnfFmAlarmsApi(tca.vnffm_v1.ApiClient(configuration))
body = tca.vnffm_v1.AlarmFilter() # AlarmFilter | 
vnf_instance_id = 'vnf_instance_id_example' # str | Network Function Instance Id

try:
    # Get Alarms from Vms given the vdu Id
    api_response = api_instance.query_alarms(body, vnf_instance_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling VnfFmAlarmsApi->query_alarms: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**AlarmFilter**](AlarmFilter.md)|  | 
 **vnf_instance_id** | **str**| Network Function Instance Id | 

### Return type

[**VduAlarmsResponse**](VduAlarmsResponse.md)

### Authorization

[x-hm-authorization](../README.md#x-hm-authorization)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

