# VnfInstance

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | [**Identifier**](Identifier.md) |  | 
**vnf_instance_name** | **str** | Name of the VNF instance. This attribute can be modified with the PATCH method.  | [optional] 
**vnf_instance_description** | **str** | Human-readable description of the VNF instance. This attribute can be modified with the PATCH method.  | [optional] 
**vnfd_id** | [**Identifier**](Identifier.md) |  | 
**vnf_provider** | **str** | Provider of the VNF and the VNFD. The value is copied from the VNFD.  | 
**vnf_product_name** | **str** | Name to identify the VNF Product. The value is copied from the VNFD.  | 
**vnf_software_version** | [**Version**](Version.md) |  | 
**vnfd_version** | [**Version**](Version.md) |  | 
**vnf_pkg_id** | [**Identifier**](Identifier.md) |  | 
**vnf_configurable_properties** | [**KeyValuePairs**](KeyValuePairs.md) |  | [optional] 
**vim_id** | [**Identifier**](Identifier.md) |  | [optional] 
**instantiation_state** | **str** | The instantiation state of the VNF.  | 
**instantiated_vnf_info** | [**VnfInstanceInstantiatedVnfInfo**](VnfInstanceInstantiatedVnfInfo.md) |  | [optional] 
**metadata** | [**KeyValuePairs**](KeyValuePairs.md) |  | [optional] 
**extensions** | **AllOfVnfInstanceExtensions** | Additional VNF-specific attributes that affect the lifecycle management of this VNF instance. These attributes represent values that are stored persistently in the VnfInstance structure for consumption by the VNFM, or by the lifecycle management scripts.  during the execution of VNF lifecycle management operations. Modifying the values of these attributes has no direct effect on the VNF instance; however, the modified attribute values can be considered during subsequent VNF lifecycle management operations, which means that the modified values can indirectly affect the configuration of the VNF instance. Extensions that are writeable are declared in the VNFD. This attribute These attributes can be modified with the PATCH method. ETSI GS NFV-SOL 001 specifies the structure and format of the VNFD based on TOSCA specifications.  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

