# VnfPackageSoftwareImageInfo

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | [**IdentifierInVnfd**](IdentifierInVnfd.md) |  | 
**name** | **str** | Name of the software image.  | 
**provider** | **str** | Provider of the software image.  | 
**version** | [**Version**](Version.md) |  | 
**checksum** | [**Checksum**](Checksum.md) |  | 
**is_encrypted** | **bool** | Reflects whether the image is encrypted (true) or not (false).  | 
**container_format** | **str** | Container format indicates whether the software image is in a file format that also contains meta-data about the actual software. Permitted values: - AKI: a kernel image format - AMI: a machine image format - ARI: a ram disk image format - BARE: the image does not have a container or meta-data envelope - DOCKER: docker container format - OVA: OVF package in a tar file - OVF: OVF container format  | 
**disk_format** | **str** | Disk format of a software image is the format of the underlying disk image. Permitted values: - AKI: a kernel image format - AMI: a machine image format - ARI: a ramdisk image format - ISO: an archive format for the data contents of an optical disc, such as CD-ROM - QCOW2: a common disk image format, which can expand dynamically and supports copy on write - RAW: an unstructured disk image format - VDI: a common disk image format - VHD: a common disk image format - VHDX: enhanced version of VHD format - VMDK: a common disk image format  | 
**created_at** | **datetime** |  | 
**min_disk** | **int** | The minimal disk for this software image in bytes.  | 
**min_ram** | **int** | The minimal RAM for this software image in bytes.  | 
**size** | **int** | Size of this software image in bytes.  | 
**user_metadata** | [**KeyValuePairs**](KeyValuePairs.md) |  | [optional] 
**image_path** | **str** | Path in the VNF package, which identifies the image artifact and also allows to access a copy of the image artifact.  | 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

