# VnfPkgInfo

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | [**Identifier**](Identifier.md) |  | 
**vnfd_id** | [**Identifier**](Identifier.md) |  | [optional] 
**vnf_provider** | **str** | Provider of the VNF package and the VNFD. This information is copied from the VNFD.  It shall be present after the VNF package content has been on-boarded and absent otherwise.  | [optional] 
**vnf_product_name** | **str** | Name to identify the VNF product.Invariant for the VNF product lifetime.  This information is copied from the VNFD. It shall be present after the VNF package content has been on-boarded and absent otherwise.  | [optional] 
**vnf_software_version** | [**Version**](Version.md) |  | [optional] 
**vnfd_version** | [**Version**](Version.md) |  | [optional] 
**compatible_specification_versions** | [**Version**](Version.md) |  | [optional] 
**checksum** | [**Checksum**](Checksum.md) |  | [optional] 
**package_security_option** | **str** | Signals the security option used by the package as defined in clause 5.1 of ETSI GS NFV-SOL 004 [5]. Valid values: OPTION_1, OPTION_2  | 
**signing_certificate** | **str** | The singleton signing certificate if it is included as a file in the VNF package.  | [optional] 
**software_images** | [**list[VnfPackageSoftwareImageInfo]**](VnfPackageSoftwareImageInfo.md) | Information about VNF package artifacts that are software images. This attribute shall not be present before the VNF package content is on-boarded. Otherwise, this attribute shall be present unless it has been requested to be excluded per attribute selector.  | [optional] 
**additional_artifacts** | [**list[VnfPackageArtifactInfo]**](VnfPackageArtifactInfo.md) | Information about VNF package artifacts contained in the VNF package that are not software images. This attribute shall not be present before the VNF package content is on-boarded. Otherwise, this attribute shall be present if the VNF package contains additional artifacts.  | [optional] 
**onboarding_state** | [**PackageOnboardingStateType**](PackageOnboardingStateType.md) |  | 
**operational_state** | [**PackageOperationalStateType**](PackageOperationalStateType.md) |  | 
**usage_state** | [**PackageUsageStateType**](PackageUsageStateType.md) |  | 
**vnfm_info** | **list[str]** | Specifies VNFMs compatible with the VNF. This information is copied from the VNFD. See note 4.  | 
**user_defined_data** | [**VnfPkgInfoUserDefinedData**](VnfPkgInfoUserDefinedData.md) |  | [optional] 
**onboarding_failure_details** | [**ProblemDetails**](ProblemDetails.md) |  | [optional] 
**links** | [**VnfPkgInfoLinks**](VnfPkgInfoLinks.md) |  | 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

