# coding: utf-8

"""
# Copyright (c) 2021-2022 VMware, Inc. All rights reserved.
# VMware Confidential
Author: banerjees@vmware.com
"""

"""
    VMware-TCA-SDK-Python - Telco Cloud Automation, SDK for Python3

    Note for SOL APIs: The SOL API specifications and definitions are part of ETSI Group Specification (approved or managed by the ETSI NFV ISG). In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis
"""

from setuptools import setup, find_packages

NAME = "vmware-tca-sdk-python"
VERSION = "2.1.0"
# To install the library, run the following (Python3.8)
#
# python setup.py install
#
# prerequisite: setuptools
# http://pypi.python.org/pypi/setuptools

REQUIRES = ["urllib3 >= 1.15", "six >= 1.10", "certifi", "python-dateutil"]

setup(
    name=NAME,
    version=VERSION,
    description="VMware-TCA-SDK-Python - VMware Telco Cloud Automation, SDK for Python3",
    author='VMware, Inc.',
    url="https://developer.vmware.com/home",
    keywords=["VMware", "TCA", "SDK", "Python"],
    install_requires=REQUIRES,
    packages=find_packages(),
    include_package_data=True,
    license='Other/Proprietary License',
    license_files ='open_source_license_VMware_Telco_Cloud_Automation_SDK_2.1_GA.txt',
    classifiers=[
        'Development Status :: 5 - Production/Stable',
        'License :: Other/Proprietary License',
        'Programming Language :: Python :: 3.8',
        'Programming Language :: Python :: 3.9',
    ],
    long_description="""\
    VMware-TCA-SDK-Python - Telco Cloud Automation, SDK for Python3\
    \
    EULA: The usage of the SDK assumes that the End User License Agreement, specified in the file EULA_SDK_TCA.docx shipped with this distribution, is read, understood and accepted. \
    \
    Note for SOL APIs: The SOL API specifications and definitions are part of ETSI Group Specification (approved or managed by the ETSI NFV ISG). In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis \
    """
)
