"""
# Copyright (c) 2021-2022 VMware, Inc. All rights reserved.
# VMware Confidential
Author: banerjees@vmware.com
"""
from tca.api.client.configuration import Configuration
from tca.api.client.rest import RESTClientObject


class TCAConfiguration(Configuration):
    def __init__(self):
        super().__init__()
        self.session_manager = None
        self.lg().debug("----------[ Loading TCA Configuration ]----------")
        self.server = "https://tca-server"
        self.verify_ssl = True
        self.refresh_api_key_hook = self.__refresh_api_key_hook

    '''
    '''
    def set_username(self, username):
        self.username = username

    '''
    '''
    def set_password(self, password):
        self.password = password

    '''
    '''
    def set_server(self, server):
        self.server = server

    '''
    '''
    def set_verify_ssl(self, verify_ssl):
        self.verify_ssl = verify_ssl

    def set_session_manager(self, session_manager):
        self.session_manager = session_manager
        pass

    '''
    Note the args (*args and **kwargs) need for correct overriding
    '''
    def __refresh_api_key_hook(self, *args, **kwargs):
        self.lg().info("GETTING IN TOUCH WITH YOUR SERVER: %s" % self.server)
        self.lg().debug("Fetching TCA Auth... with User=%s" % self.username)
        if self.session_manager is None:
            raise Exception("SessionManager not set!")
        self.session_manager.login(**kwargs)
        self.lg().debug("DONE Fetching TCA Auth... with User=%s" % self.username)
