# coding: utf-8

"""
    Telco Cloud Automation Generic CR API.

    Telco Cloud Automation Generic CR API.  # noqa: E501

    OpenAPI spec version: 2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from tca.caas_k8s_generic_cr.api_client import ApiClient
from tca.api.tca_api import TCAApi

class GenericCrApi(TCAApi):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_tca_bom_release(self, name, **kwargs):  # noqa: E501
        """Api to get a TCA BOM release with a given name  # noqa: E501

        Api to get a TCA BOM release with a given name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_tca_bom_release(name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str name: name of the TCA bom release resource (required)
        :param str tca_cp_id: tcaCpId where the management cluster is deployed. tcaCpId is the hcxUUID in the response of get cluster by Id API call for management cluster.
        :param str mgmt_cluster_name: name of the management cluster where the request needs to be executed
        :param bool tca_cluster: If the request has to be executed on the tcaCluster


        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_tca_bom_release_with_http_info(name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_tca_bom_release_with_http_info(name, **kwargs)  # noqa: E501
            return data

    def get_tca_bom_release_with_http_info(self, name, **kwargs):  # noqa: E501
        """Api to get a TCA BOM release with a given name  # noqa: E501

        Api to get a TCA BOM release with a given name  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_tca_bom_release_with_http_info(name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str name: name of the TCA bom release resource (required)
        :param str tca_cp_id: tcaCpId where the management cluster is deployed. tcaCpId is the hcxUUID in the response of get cluster by Id API call for management cluster.
        :param str mgmt_cluster_name: name of the management cluster where the request needs to be executed
        :param bool tca_cluster: If the request has to be executed on the tcaCluster


        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['name', 'tca_cp_id', 'mgmt_cluster_name', 'tca_cluster']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_tca_bom_release" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'name' is set
        if ('name' not in params or
                params['name'] is None):
            raise ValueError("Missing the required parameter `name` when calling `get_tca_bom_release`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'name' in params:
            path_params['name'] = params['name']  # noqa: E501

        query_params = []
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cluster' in params:
            query_params.append(('tcaCluster', params['tca_cluster']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/telco.vmware.com/v1alpha1/namespaces/tca-system/tcabomreleases/{name}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='str',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_workload_cluster_kube_config(self, workload_cluster_name, secret_name, **kwargs):  # noqa: E501
        """Api to fetch kubeconfig for workload cluster  # noqa: E501

        Api to fetch kubeconfig for workload cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_workload_cluster_kube_config(workload_cluster_name, secret_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str workload_cluster_name: name of the workload cluster (required)
        :param str secret_name: name of the workload cluster followed by \"-kubeconfig\" (required)
        :param str tca_cp_id: tcaCpId where the management cluster is deployed. tcaCpId is the hcxUUID in the response of get cluster by Id API call for management cluster.
        :param str mgmt_cluster_name: name of the management cluster where the request needs to be executed
        :param bool tca_cluster: If the request has to be executed on the tcaCluster


        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_workload_cluster_kube_config_with_http_info(workload_cluster_name, secret_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_workload_cluster_kube_config_with_http_info(workload_cluster_name, secret_name, **kwargs)  # noqa: E501
            return data

    def get_workload_cluster_kube_config_with_http_info(self, workload_cluster_name, secret_name, **kwargs):  # noqa: E501
        """Api to fetch kubeconfig for workload cluster  # noqa: E501

        Api to fetch kubeconfig for workload cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_workload_cluster_kube_config_with_http_info(workload_cluster_name, secret_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str workload_cluster_name: name of the workload cluster (required)
        :param str secret_name: name of the workload cluster followed by \"-kubeconfig\" (required)
        :param str tca_cp_id: tcaCpId where the management cluster is deployed. tcaCpId is the hcxUUID in the response of get cluster by Id API call for management cluster.
        :param str mgmt_cluster_name: name of the management cluster where the request needs to be executed
        :param bool tca_cluster: If the request has to be executed on the tcaCluster


        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['workload_cluster_name', 'secret_name', 'tca_cp_id', 'mgmt_cluster_name', 'tca_cluster']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_workload_cluster_kube_config" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'workload_cluster_name' is set
        if ('workload_cluster_name' not in params or
                params['workload_cluster_name'] is None):
            raise ValueError("Missing the required parameter `workload_cluster_name` when calling `get_workload_cluster_kube_config`")  # noqa: E501
        # verify the required parameter 'secret_name' is set
        if ('secret_name' not in params or
                params['secret_name'] is None):
            raise ValueError("Missing the required parameter `secret_name` when calling `get_workload_cluster_kube_config`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'workload_cluster_name' in params:
            path_params['workload-cluster-name'] = params['workload_cluster_name']  # noqa: E501
        if 'secret_name' in params:
            path_params['secret-name'] = params['secret_name']  # noqa: E501

        query_params = []
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cluster' in params:
            query_params.append(('tcaCluster', params['tca_cluster']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/secrets/{workload-cluster-name}/{secret-name}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='str',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_tca_bom_releases(self, **kwargs):  # noqa: E501
        """Api to fetch TCA BOM releases  # noqa: E501

        Api to fetch TCA BOM releases  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_tca_bom_releases(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tca_cp_id: tcaCpId where the management cluster is deployed. tcaCpId is the hcxUUID in the response of get cluster by Id API call for management cluster.
        :param str mgmt_cluster_name: name of the management cluster where the request needs to be executed
        :param bool tca_cluster: If the request has to be executed on the tcaCluster (minikube)
        :param str _continue: Used to fetch the next set of resources if the list is large


        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_tca_bom_releases_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.list_tca_bom_releases_with_http_info(**kwargs)  # noqa: E501
            return data

    def list_tca_bom_releases_with_http_info(self, **kwargs):  # noqa: E501
        """Api to fetch TCA BOM releases  # noqa: E501

        Api to fetch TCA BOM releases  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_tca_bom_releases_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tca_cp_id: tcaCpId where the management cluster is deployed. tcaCpId is the hcxUUID in the response of get cluster by Id API call for management cluster.
        :param str mgmt_cluster_name: name of the management cluster where the request needs to be executed
        :param bool tca_cluster: If the request has to be executed on the tcaCluster (minikube)
        :param str _continue: Used to fetch the next set of resources if the list is large


        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['tca_cp_id', 'mgmt_cluster_name', 'tca_cluster', '_continue']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_tca_bom_releases" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cluster' in params:
            query_params.append(('tcaCluster', params['tca_cluster']))  # noqa: E501
        if '_continue' in params:
            query_params.append(('_continue', params['_continue']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/telco.vmware.com/v1alpha1/namespaces/tca-system/tcabomreleases', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='str',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
