# coding: utf-8

"""
    Telco Cloud Automation Cluster API.

    Telco Cloud Automation Cluster API.  # noqa: E501

    OpenAPI spec version: 2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from tca.caas_v2.api_client import ApiClient
from tca.api.tca_api import TCAApi

class ClusterAutomationApi(TCAApi):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_cluster(self, body, **kwargs):  # noqa: E501
        """Api to deploy Kubernetes Cluster for Telco Cloud Automation  # noqa: E501

        Api to deploy Kubernetes Cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_cluster(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Cluster body: create cluster (required)
        :param str mgmt_cluster_name: Name of the management cluster where the request has to be executed
        :param str tca_cp_id: Id of the TCA CP where the request has to be routed.

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: Cluster
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_cluster_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.create_cluster_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def create_cluster_with_http_info(self, body, **kwargs):  # noqa: E501
        """Api to deploy Kubernetes Cluster for Telco Cloud Automation  # noqa: E501

        Api to deploy Kubernetes Cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_cluster_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Cluster body: create cluster (required)
        :param str mgmt_cluster_name: Name of the management cluster where the request has to be executed
        :param str tca_cp_id: Id of the TCA CP where the request has to be routed.

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: Cluster
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'mgmt_cluster_name', 'tca_cp_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_cluster" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_cluster`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Cluster',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_cluster(self, cluster_name, **kwargs):  # noqa: E501
        """Api to delete kubernetes Cluster for Telco Cloud Automation  # noqa: E501

        Api to delete kubernetes Cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_cluster(cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of the cluster which has to be deleted (required)
        :param str mgmt_cluster_name: Name of the management cluster where the request has to be executed
        :param str tca_cp_id: Id of the TCA CP where the request has to be routed.
        :param bool is_force: Flag to force delete cluster created using v2 apis


        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_cluster_with_http_info(cluster_name, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_cluster_with_http_info(cluster_name, **kwargs)  # noqa: E501
            return data

    def delete_cluster_with_http_info(self, cluster_name, **kwargs):  # noqa: E501
        """Api to delete kubernetes Cluster for Telco Cloud Automation  # noqa: E501

        Api to delete kubernetes Cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_cluster_with_http_info(cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of the cluster which has to be deleted (required)
        :param str mgmt_cluster_name: Name of the management cluster where the request has to be executed
        :param str tca_cp_id: Id of the TCA CP where the request has to be routed.
        :param bool is_force: Flag to force delete cluster created using v2 apis


        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'mgmt_cluster_name', 'tca_cp_id', 'is_force']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_cluster" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `delete_cluster`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501
        if 'is_force' in params:
            query_params.append(('isForce', params['is_force']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='object',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def edit_cluster(self, body, cluster_name, **kwargs):  # noqa: E501
        """Api to edit kubernetes Cluster for Telco Cloud Automation  # noqa: E501

        Api to edit kubernetes Cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_cluster(body, cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Cluster body: create cluster (required)
        :param str cluster_name: Name of the cluster which has to be deleted (required)
        :param str mgmt_cluster_name: Name of the management cluster where the request has to be executed
        :param str tca_cp_id: Id of the TCA CP where the request has to be routed.

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: Cluster
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.edit_cluster_with_http_info(body, cluster_name, **kwargs)  # noqa: E501
        else:
            (data) = self.edit_cluster_with_http_info(body, cluster_name, **kwargs)  # noqa: E501
            return data

    def edit_cluster_with_http_info(self, body, cluster_name, **kwargs):  # noqa: E501
        """Api to edit kubernetes Cluster for Telco Cloud Automation  # noqa: E501

        Api to edit kubernetes Cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_cluster_with_http_info(body, cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Cluster body: create cluster (required)
        :param str cluster_name: Name of the cluster which has to be deleted (required)
        :param str mgmt_cluster_name: Name of the management cluster where the request has to be executed
        :param str tca_cp_id: Id of the TCA CP where the request has to be routed.

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: Cluster
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'cluster_name', 'mgmt_cluster_name', 'tca_cp_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method edit_cluster" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `edit_cluster`")  # noqa: E501
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `edit_cluster`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Cluster',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_addon_tca_k8s_resources(self, cluster_name, addon_name, mgmt_cluster_name, tca_cp_id, **kwargs):  # noqa: E501
        """API to fetch underyling tca k8s CRs (Deployed by cluster lifecycle operator) including TcaNodePool & NodePolicy  # noqa: E501

        API to fetch underyling tca k8s NodePool CRs for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_addon_tca_k8s_resources(cluster_name, addon_name, mgmt_cluster_name, tca_cp_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of the cluster to which resources need to be fetched (required)
        :param str addon_name: (required)
        :param str mgmt_cluster_name: Name of the management cluster of the given cluster (required)
        :param str tca_cp_id: Id of the TCA CP of the given cluster (required)


        :return: TcaAddonResource
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_addon_tca_k8s_resources_with_http_info(cluster_name, addon_name, mgmt_cluster_name, tca_cp_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_addon_tca_k8s_resources_with_http_info(cluster_name, addon_name, mgmt_cluster_name, tca_cp_id, **kwargs)  # noqa: E501
            return data

    def get_addon_tca_k8s_resources_with_http_info(self, cluster_name, addon_name, mgmt_cluster_name, tca_cp_id, **kwargs):  # noqa: E501
        """API to fetch underyling tca k8s CRs (Deployed by cluster lifecycle operator) including TcaNodePool & NodePolicy  # noqa: E501

        API to fetch underyling tca k8s NodePool CRs for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_addon_tca_k8s_resources_with_http_info(cluster_name, addon_name, mgmt_cluster_name, tca_cp_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of the cluster to which resources need to be fetched (required)
        :param str addon_name: (required)
        :param str mgmt_cluster_name: Name of the management cluster of the given cluster (required)
        :param str tca_cp_id: Id of the TCA CP of the given cluster (required)


        :return: TcaAddonResource
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'addon_name', 'mgmt_cluster_name', 'tca_cp_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_addon_tca_k8s_resources" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `get_addon_tca_k8s_resources`")  # noqa: E501
        # verify the required parameter 'addon_name' is set
        if ('addon_name' not in params or
                params['addon_name'] is None):
            raise ValueError("Missing the required parameter `addon_name` when calling `get_addon_tca_k8s_resources`")  # noqa: E501
        # verify the required parameter 'mgmt_cluster_name' is set
        if ('mgmt_cluster_name' not in params or
                params['mgmt_cluster_name'] is None):
            raise ValueError("Missing the required parameter `mgmt_cluster_name` when calling `get_addon_tca_k8s_resources`")  # noqa: E501
        # verify the required parameter 'tca_cp_id' is set
        if ('tca_cp_id' not in params or
                params['tca_cp_id'] is None):
            raise ValueError("Missing the required parameter `tca_cp_id` when calling `get_addon_tca_k8s_resources`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'addon_name' in params:
            path_params['addonName'] = params['addon_name']  # noqa: E501

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}/addon/{addonName}/tcak8sresources', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='TcaAddonResource',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_all_clusters(self, **kwargs):  # noqa: E501
        """API to list all kubernetes clusters for Telco Cloud Automation.  # noqa: E501

        API to list all kubernetes clusters for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_all_clusters(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sort: Attribute based sorting expression.
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. If not present, API will return first page of response with page size 10.


        :return: ClusterList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_all_clusters_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_all_clusters_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_all_clusters_with_http_info(self, **kwargs):  # noqa: E501
        """API to list all kubernetes clusters for Telco Cloud Automation.  # noqa: E501

        API to list all kubernetes clusters for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_all_clusters_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sort: Attribute based sorting expression.
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. If not present, API will return first page of response with page size 10.


        :return: ClusterList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['sort', 'nextpage_opaque_marker']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_all_clusters" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'nextpage_opaque_marker' in params:
            query_params.append(('nextpage_opaque_marker', params['nextpage_opaque_marker']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_cluster(self, cluster_name, **kwargs):  # noqa: E501
        """Api to get kubernetes Cluster for Telco Cloud Automation  # noqa: E501

        Api to get kubernetes Cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_cluster(cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of the cluster which has to be retrieved (required)
        :param str mgmt_cluster_name: Name of the management cluster which is managing the cluster
        :param str tca_cp_id: Id of the TCA CP where the request has to be routed.


        :return: Cluster
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_cluster_with_http_info(cluster_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_cluster_with_http_info(cluster_name, **kwargs)  # noqa: E501
            return data

    def get_cluster_with_http_info(self, cluster_name, **kwargs):  # noqa: E501
        """Api to get kubernetes Cluster for Telco Cloud Automation  # noqa: E501

        Api to get kubernetes Cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_cluster_with_http_info(cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of the cluster which has to be retrieved (required)
        :param str mgmt_cluster_name: Name of the management cluster which is managing the cluster
        :param str tca_cp_id: Id of the TCA CP where the request has to be routed.


        :return: Cluster
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'mgmt_cluster_name', 'tca_cp_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cluster" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `get_cluster`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Cluster',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_cluster_stats(self, cluster_name, **kwargs):  # noqa: E501
        """Api to get kubernetes Cluster Stats for Telco Cloud Automation  # noqa: E501

        Api to get kubernetes Cluster Stats for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_cluster_stats(cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of the cluster whose stats has to be retrieved (required)
        :param str mgmt_cluster_name: Name of the management cluster which is managing the cluster
        :param str tca_cp_id: Id of the TCA CP where the request has to be routed.


        :return: ClusterStats
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_cluster_stats_with_http_info(cluster_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_cluster_stats_with_http_info(cluster_name, **kwargs)  # noqa: E501
            return data

    def get_cluster_stats_with_http_info(self, cluster_name, **kwargs):  # noqa: E501
        """Api to get kubernetes Cluster Stats for Telco Cloud Automation  # noqa: E501

        Api to get kubernetes Cluster Stats for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_cluster_stats_with_http_info(cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of the cluster whose stats has to be retrieved (required)
        :param str mgmt_cluster_name: Name of the management cluster which is managing the cluster
        :param str tca_cp_id: Id of the TCA CP where the request has to be routed.


        :return: ClusterStats
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'mgmt_cluster_name', 'tca_cp_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cluster_stats" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `get_cluster_stats`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}/stats', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterStats',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_cluster_tca_k8s_resources(self, cluster_name, mgmt_cluster_name, tca_cp_id, **kwargs):  # noqa: E501
        """API to fetch underyling tca k8s CRs (Deployed by cluster lifecycle operator) including TCAKubernetesCluster & TCAKubeControlPlane  # noqa: E501

        API to fetch underyling tca k8s CRs for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_cluster_tca_k8s_resources(cluster_name, mgmt_cluster_name, tca_cp_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of the cluster to which resources need to be fetched (required)
        :param str mgmt_cluster_name: Name of the management cluster of the given cluster (required)
        :param str tca_cp_id: Id of the TCA CP of the given cluster (required)


        :return: TcaClusterResource
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_cluster_tca_k8s_resources_with_http_info(cluster_name, mgmt_cluster_name, tca_cp_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_cluster_tca_k8s_resources_with_http_info(cluster_name, mgmt_cluster_name, tca_cp_id, **kwargs)  # noqa: E501
            return data

    def get_cluster_tca_k8s_resources_with_http_info(self, cluster_name, mgmt_cluster_name, tca_cp_id, **kwargs):  # noqa: E501
        """API to fetch underyling tca k8s CRs (Deployed by cluster lifecycle operator) including TCAKubernetesCluster & TCAKubeControlPlane  # noqa: E501

        API to fetch underyling tca k8s CRs for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_cluster_tca_k8s_resources_with_http_info(cluster_name, mgmt_cluster_name, tca_cp_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of the cluster to which resources need to be fetched (required)
        :param str mgmt_cluster_name: Name of the management cluster of the given cluster (required)
        :param str tca_cp_id: Id of the TCA CP of the given cluster (required)


        :return: TcaClusterResource
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'mgmt_cluster_name', 'tca_cp_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cluster_tca_k8s_resources" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `get_cluster_tca_k8s_resources`")  # noqa: E501
        # verify the required parameter 'mgmt_cluster_name' is set
        if ('mgmt_cluster_name' not in params or
                params['mgmt_cluster_name'] is None):
            raise ValueError("Missing the required parameter `mgmt_cluster_name` when calling `get_cluster_tca_k8s_resources`")  # noqa: E501
        # verify the required parameter 'tca_cp_id' is set
        if ('tca_cp_id' not in params or
                params['tca_cp_id'] is None):
            raise ValueError("Missing the required parameter `tca_cp_id` when calling `get_cluster_tca_k8s_resources`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}/tcak8sresources', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='TcaClusterResource',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_node_pool_tca_k8s_resources(self, cluster_name, node_pool_name, mgmt_cluster_name, tca_cp_id, **kwargs):  # noqa: E501
        """API to fetch underyling tca k8s CRs (Deployed by cluster lifecycle operator) including TcaNodePool & NodePolicy  # noqa: E501

        API to fetch underyling tca k8s NodePool CRs for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_node_pool_tca_k8s_resources(cluster_name, node_pool_name, mgmt_cluster_name, tca_cp_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of the cluster to which resources need to be fetched (required)
        :param str node_pool_name: (required)
        :param str mgmt_cluster_name: Name of the management cluster of the given cluster (required)
        :param str tca_cp_id: Id of the TCA CP of the given cluster (required)


        :return: TcaNodePoolResource
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_node_pool_tca_k8s_resources_with_http_info(cluster_name, node_pool_name, mgmt_cluster_name, tca_cp_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_node_pool_tca_k8s_resources_with_http_info(cluster_name, node_pool_name, mgmt_cluster_name, tca_cp_id, **kwargs)  # noqa: E501
            return data

    def get_node_pool_tca_k8s_resources_with_http_info(self, cluster_name, node_pool_name, mgmt_cluster_name, tca_cp_id, **kwargs):  # noqa: E501
        """API to fetch underyling tca k8s CRs (Deployed by cluster lifecycle operator) including TcaNodePool & NodePolicy  # noqa: E501

        API to fetch underyling tca k8s NodePool CRs for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_node_pool_tca_k8s_resources_with_http_info(cluster_name, node_pool_name, mgmt_cluster_name, tca_cp_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of the cluster to which resources need to be fetched (required)
        :param str node_pool_name: (required)
        :param str mgmt_cluster_name: Name of the management cluster of the given cluster (required)
        :param str tca_cp_id: Id of the TCA CP of the given cluster (required)


        :return: TcaNodePoolResource
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'node_pool_name', 'mgmt_cluster_name', 'tca_cp_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_node_pool_tca_k8s_resources" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `get_node_pool_tca_k8s_resources`")  # noqa: E501
        # verify the required parameter 'node_pool_name' is set
        if ('node_pool_name' not in params or
                params['node_pool_name'] is None):
            raise ValueError("Missing the required parameter `node_pool_name` when calling `get_node_pool_tca_k8s_resources`")  # noqa: E501
        # verify the required parameter 'mgmt_cluster_name' is set
        if ('mgmt_cluster_name' not in params or
                params['mgmt_cluster_name'] is None):
            raise ValueError("Missing the required parameter `mgmt_cluster_name` when calling `get_node_pool_tca_k8s_resources`")  # noqa: E501
        # verify the required parameter 'tca_cp_id' is set
        if ('tca_cp_id' not in params or
                params['tca_cp_id'] is None):
            raise ValueError("Missing the required parameter `tca_cp_id` when calling `get_node_pool_tca_k8s_resources`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'node_pool_name' in params:
            path_params['nodePoolName'] = params['node_pool_name']  # noqa: E501

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}/nodepools/{nodePoolName}/tcak8sresources', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='TcaNodePoolResource',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
