# coding: utf-8

"""
    Telco Cloud Automation Cluster API.

    Telco Cloud Automation Cluster API.  # noqa: E501

    OpenAPI spec version: 2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ClusterStatus(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cluster_url': 'str',
        'kubernetes_version': 'str',
        'resource_version': 'float',
        'opstatus': 'str',
        'delete_accepted': 'bool',
        'vim_id': 'str',
        'stats': 'ClusterStatusStats',
        'conditions': 'list[ClusterStatusConditions]'
    }

    attribute_map = {
        'cluster_url': 'clusterUrl',
        'kubernetes_version': 'kubernetesVersion',
        'resource_version': 'resourceVersion',
        'opstatus': 'opstatus',
        'delete_accepted': 'deleteAccepted',
        'vim_id': 'vimId',
        'stats': 'stats',
        'conditions': 'conditions'
    }

    def __init__(self, cluster_url=None, kubernetes_version=None, resource_version=None, opstatus=None, delete_accepted=None, vim_id=None, stats=None, conditions=None):  # noqa: E501
        """ClusterStatus - a model defined in Swagger"""  # noqa: E501
        self._cluster_url = None
        self._kubernetes_version = None
        self._resource_version = None
        self._opstatus = None
        self._delete_accepted = None
        self._vim_id = None
        self._stats = None
        self._conditions = None
        self.discriminator = None
        if cluster_url is not None:
            self.cluster_url = cluster_url
        if kubernetes_version is not None:
            self.kubernetes_version = kubernetes_version
        if resource_version is not None:
            self.resource_version = resource_version
        if opstatus is not None:
            self.opstatus = opstatus
        if delete_accepted is not None:
            self.delete_accepted = delete_accepted
        if vim_id is not None:
            self.vim_id = vim_id
        if stats is not None:
            self.stats = stats
        if conditions is not None:
            self.conditions = conditions

    @property
    def cluster_url(self):
        """Gets the cluster_url of this ClusterStatus.  # noqa: E501

        URL of the cluster  # noqa: E501

        :return: The cluster_url of this ClusterStatus.  # noqa: E501
        :rtype: str
        """
        return self._cluster_url

    @cluster_url.setter
    def cluster_url(self, cluster_url):
        """Sets the cluster_url of this ClusterStatus.

        URL of the cluster  # noqa: E501

        :param cluster_url: The cluster_url of this ClusterStatus.  # noqa: E501
        :type: str
        """

        self._cluster_url = cluster_url

    @property
    def kubernetes_version(self):
        """Gets the kubernetes_version of this ClusterStatus.  # noqa: E501

        kubernetes version of the cluster  # noqa: E501

        :return: The kubernetes_version of this ClusterStatus.  # noqa: E501
        :rtype: str
        """
        return self._kubernetes_version

    @kubernetes_version.setter
    def kubernetes_version(self, kubernetes_version):
        """Sets the kubernetes_version of this ClusterStatus.

        kubernetes version of the cluster  # noqa: E501

        :param kubernetes_version: The kubernetes_version of this ClusterStatus.  # noqa: E501
        :type: str
        """

        self._kubernetes_version = kubernetes_version

    @property
    def resource_version(self):
        """Gets the resource_version of this ClusterStatus.  # noqa: E501

        object version for which status of desired state is being shown  # noqa: E501

        :return: The resource_version of this ClusterStatus.  # noqa: E501
        :rtype: float
        """
        return self._resource_version

    @resource_version.setter
    def resource_version(self, resource_version):
        """Sets the resource_version of this ClusterStatus.

        object version for which status of desired state is being shown  # noqa: E501

        :param resource_version: The resource_version of this ClusterStatus.  # noqa: E501
        :type: float
        """

        self._resource_version = resource_version

    @property
    def opstatus(self):
        """Gets the opstatus of this ClusterStatus.  # noqa: E501

        only tells whether the given desired state is being processed or complete. > To get the status of object, refer to conditions and get internal custom resource status.  # noqa: E501

        :return: The opstatus of this ClusterStatus.  # noqa: E501
        :rtype: str
        """
        return self._opstatus

    @opstatus.setter
    def opstatus(self, opstatus):
        """Sets the opstatus of this ClusterStatus.

        only tells whether the given desired state is being processed or complete. > To get the status of object, refer to conditions and get internal custom resource status.  # noqa: E501

        :param opstatus: The opstatus of this ClusterStatus.  # noqa: E501
        :type: str
        """
        allowed_values = ["processing", "complete"]  # noqa: E501
        if opstatus is not None and opstatus not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `opstatus` ({0}), must be one of {1}"  # noqa: E501
                .format(opstatus, allowed_values)
            )

        self._opstatus = opstatus

    @property
    def delete_accepted(self):
        """Gets the delete_accepted of this ClusterStatus.  # noqa: E501


        :return: The delete_accepted of this ClusterStatus.  # noqa: E501
        :rtype: bool
        """
        return self._delete_accepted

    @delete_accepted.setter
    def delete_accepted(self, delete_accepted):
        """Sets the delete_accepted of this ClusterStatus.


        :param delete_accepted: The delete_accepted of this ClusterStatus.  # noqa: E501
        :type: bool
        """

        self._delete_accepted = delete_accepted

    @property
    def vim_id(self):
        """Gets the vim_id of this ClusterStatus.  # noqa: E501

        kubernetes VIM id which has been realized as part of cluster creation  # noqa: E501

        :return: The vim_id of this ClusterStatus.  # noqa: E501
        :rtype: str
        """
        return self._vim_id

    @vim_id.setter
    def vim_id(self, vim_id):
        """Sets the vim_id of this ClusterStatus.

        kubernetes VIM id which has been realized as part of cluster creation  # noqa: E501

        :param vim_id: The vim_id of this ClusterStatus.  # noqa: E501
        :type: str
        """

        self._vim_id = vim_id

    @property
    def stats(self):
        """Gets the stats of this ClusterStatus.  # noqa: E501


        :return: The stats of this ClusterStatus.  # noqa: E501
        :rtype: ClusterStatusStats
        """
        return self._stats

    @stats.setter
    def stats(self, stats):
        """Sets the stats of this ClusterStatus.


        :param stats: The stats of this ClusterStatus.  # noqa: E501
        :type: ClusterStatusStats
        """

        self._stats = stats

    @property
    def conditions(self):
        """Gets the conditions of this ClusterStatus.  # noqa: E501


        :return: The conditions of this ClusterStatus.  # noqa: E501
        :rtype: list[ClusterStatusConditions]
        """
        return self._conditions

    @conditions.setter
    def conditions(self, conditions):
        """Sets the conditions of this ClusterStatus.


        :param conditions: The conditions of this ClusterStatus.  # noqa: E501
        :type: list[ClusterStatusConditions]
        """

        self._conditions = conditions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ClusterStatus, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ClusterStatus):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
