# coding: utf-8

"""
    Telco Cloud Automation Addon API.

    Telco Cloud Automation Addon API.  # noqa: E501

    OpenAPI spec version: 2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from tca.caas_v2_addon.api_client import ApiClient
from tca.api.tca_api import TCAApi

class AddonApi(TCAApi):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_addon(self, body, tca_cp_id, cluster_name, **kwargs):  # noqa: E501
        """API to create Addon like multus, vsphere-csi etc. on Kubernetes Cluster  # noqa: E501

        API to create Addon on Kubernetes Cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_addon(body, tca_cp_id, cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Addon body: Create Addon payload (required)
        :param str tca_cp_id: TCA-CP id of management cluster managing given cluster (required)
        :param str cluster_name: Name of cluster on which addon needs to be created (required)
        :param str mgmt_cluster_name: Name of management cluster of the given cluster. If given cluster is management cluster, this is not required 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: Addon
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_addon_with_http_info(body, tca_cp_id, cluster_name, **kwargs)  # noqa: E501
        else:
            (data) = self.create_addon_with_http_info(body, tca_cp_id, cluster_name, **kwargs)  # noqa: E501
            return data

    def create_addon_with_http_info(self, body, tca_cp_id, cluster_name, **kwargs):  # noqa: E501
        """API to create Addon like multus, vsphere-csi etc. on Kubernetes Cluster  # noqa: E501

        API to create Addon on Kubernetes Cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_addon_with_http_info(body, tca_cp_id, cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Addon body: Create Addon payload (required)
        :param str tca_cp_id: TCA-CP id of management cluster managing given cluster (required)
        :param str cluster_name: Name of cluster on which addon needs to be created (required)
        :param str mgmt_cluster_name: Name of management cluster of the given cluster. If given cluster is management cluster, this is not required 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: Addon
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'tca_cp_id', 'cluster_name', 'mgmt_cluster_name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_addon" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_addon`")  # noqa: E501
        # verify the required parameter 'tca_cp_id' is set
        if ('tca_cp_id' not in params or
                params['tca_cp_id'] is None):
            raise ValueError("Missing the required parameter `tca_cp_id` when calling `create_addon`")  # noqa: E501
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `create_addon`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}/addons', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Addon',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_addon(self, cluster_name, addon_name, tca_cp_id, **kwargs):  # noqa: E501
        """API to delete Addon like multus, vsphere-csi etc. on Kubernetes Cluster  # noqa: E501

        API to delete Addon on Kubernetes Cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_addon(cluster_name, addon_name, tca_cp_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of cluster where addon is created (required)
        :param str addon_name: Name of addon (required)
        :param str tca_cp_id: TCA-CP id of management cluster managing given cluster (required)
        :param str mgmt_cluster_name: Name of management cluster of the given cluster. If given cluster is management cluster, this is not required 


        :return: Addon
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_addon_with_http_info(cluster_name, addon_name, tca_cp_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_addon_with_http_info(cluster_name, addon_name, tca_cp_id, **kwargs)  # noqa: E501
            return data

    def delete_addon_with_http_info(self, cluster_name, addon_name, tca_cp_id, **kwargs):  # noqa: E501
        """API to delete Addon like multus, vsphere-csi etc. on Kubernetes Cluster  # noqa: E501

        API to delete Addon on Kubernetes Cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_addon_with_http_info(cluster_name, addon_name, tca_cp_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of cluster where addon is created (required)
        :param str addon_name: Name of addon (required)
        :param str tca_cp_id: TCA-CP id of management cluster managing given cluster (required)
        :param str mgmt_cluster_name: Name of management cluster of the given cluster. If given cluster is management cluster, this is not required 


        :return: Addon
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'addon_name', 'tca_cp_id', 'mgmt_cluster_name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_addon" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `delete_addon`")  # noqa: E501
        # verify the required parameter 'addon_name' is set
        if ('addon_name' not in params or
                params['addon_name'] is None):
            raise ValueError("Missing the required parameter `addon_name` when calling `delete_addon`")  # noqa: E501
        # verify the required parameter 'tca_cp_id' is set
        if ('tca_cp_id' not in params or
                params['tca_cp_id'] is None):
            raise ValueError("Missing the required parameter `tca_cp_id` when calling `delete_addon`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'addon_name' in params:
            path_params['addonName'] = params['addon_name']  # noqa: E501

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}/addons/{addonName}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Addon',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_addon(self, cluster_name, addon_name, tca_cp_id, **kwargs):  # noqa: E501
        """API to get Addon like multus, vsphere-csi etc. created on Kubernetes Cluster  # noqa: E501

        API to get Addon on Kubernetes Cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_addon(cluster_name, addon_name, tca_cp_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of cluster where addon is created (required)
        :param str addon_name: Name of addon (required)
        :param str tca_cp_id: TCA-CP id of management cluster managing given cluster (required)
        :param str mgmt_cluster_name: Name of management cluster of the given cluster. If given cluster is management cluster, this is not required 


        :return: Addon
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_addon_with_http_info(cluster_name, addon_name, tca_cp_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_addon_with_http_info(cluster_name, addon_name, tca_cp_id, **kwargs)  # noqa: E501
            return data

    def get_addon_with_http_info(self, cluster_name, addon_name, tca_cp_id, **kwargs):  # noqa: E501
        """API to get Addon like multus, vsphere-csi etc. created on Kubernetes Cluster  # noqa: E501

        API to get Addon on Kubernetes Cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_addon_with_http_info(cluster_name, addon_name, tca_cp_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of cluster where addon is created (required)
        :param str addon_name: Name of addon (required)
        :param str tca_cp_id: TCA-CP id of management cluster managing given cluster (required)
        :param str mgmt_cluster_name: Name of management cluster of the given cluster. If given cluster is management cluster, this is not required 


        :return: Addon
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'addon_name', 'tca_cp_id', 'mgmt_cluster_name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_addon" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `get_addon`")  # noqa: E501
        # verify the required parameter 'addon_name' is set
        if ('addon_name' not in params or
                params['addon_name'] is None):
            raise ValueError("Missing the required parameter `addon_name` when calling `get_addon`")  # noqa: E501
        # verify the required parameter 'tca_cp_id' is set
        if ('tca_cp_id' not in params or
                params['tca_cp_id'] is None):
            raise ValueError("Missing the required parameter `tca_cp_id` when calling `get_addon`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'addon_name' in params:
            path_params['addonName'] = params['addon_name']  # noqa: E501

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}/addons/{addonName}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Addon',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_addons(self, cluster_name, tca_cp_id, **kwargs):  # noqa: E501
        """API to fetch all Addons like multus, vsphere-csi etc. created on Kubernetes Cluster  # noqa: E501

        API to fetch all Addons on Kubernetes Cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_addons(cluster_name, tca_cp_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of cluster where addons are created (required)
        :param str tca_cp_id: TCA-CP id of management cluster managing given cluster (required)
        :param str mgmt_cluster_name: Name of management cluster of the given cluster. If given cluster is management cluster, this is not required 
        :param str sort: Attribute based sorting expression.
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. If not present, API will return first page of response with page size 10.


        :return: AddonList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_addons_with_http_info(cluster_name, tca_cp_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_addons_with_http_info(cluster_name, tca_cp_id, **kwargs)  # noqa: E501
            return data

    def get_addons_with_http_info(self, cluster_name, tca_cp_id, **kwargs):  # noqa: E501
        """API to fetch all Addons like multus, vsphere-csi etc. created on Kubernetes Cluster  # noqa: E501

        API to fetch all Addons on Kubernetes Cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_addons_with_http_info(cluster_name, tca_cp_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of cluster where addons are created (required)
        :param str tca_cp_id: TCA-CP id of management cluster managing given cluster (required)
        :param str mgmt_cluster_name: Name of management cluster of the given cluster. If given cluster is management cluster, this is not required 
        :param str sort: Attribute based sorting expression.
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. If not present, API will return first page of response with page size 10.


        :return: AddonList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'tca_cp_id', 'mgmt_cluster_name', 'sort', 'nextpage_opaque_marker']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_addons" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `get_addons`")  # noqa: E501
        # verify the required parameter 'tca_cp_id' is set
        if ('tca_cp_id' not in params or
                params['tca_cp_id'] is None):
            raise ValueError("Missing the required parameter `tca_cp_id` when calling `get_addons`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'nextpage_opaque_marker' in params:
            query_params.append(('nextpage_opaque_marker', params['nextpage_opaque_marker']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}/addons', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='AddonList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_addon(self, body, tca_cp_id, cluster_name, addon_name, **kwargs):  # noqa: E501
        """API to update Addon like multus, vsphere-csi etc. on Kubernetes Cluster  # noqa: E501

        API to update Addon on Kubernetes Cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_addon(body, tca_cp_id, cluster_name, addon_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Addon body: Update Addon payload. Only spec can be updated (required)
        :param str tca_cp_id: TCA-CP id of management cluster managing given cluster (required)
        :param str cluster_name: Name of cluster on which addon needs to be updated (required)
        :param str addon_name: Name of addon which needs to be updated (required)
        :param str mgmt_cluster_name: Name of management cluster of the given cluster. If given cluster is management cluster, this is not required 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: Addon
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_addon_with_http_info(body, tca_cp_id, cluster_name, addon_name, **kwargs)  # noqa: E501
        else:
            (data) = self.update_addon_with_http_info(body, tca_cp_id, cluster_name, addon_name, **kwargs)  # noqa: E501
            return data

    def update_addon_with_http_info(self, body, tca_cp_id, cluster_name, addon_name, **kwargs):  # noqa: E501
        """API to update Addon like multus, vsphere-csi etc. on Kubernetes Cluster  # noqa: E501

        API to update Addon on Kubernetes Cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_addon_with_http_info(body, tca_cp_id, cluster_name, addon_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Addon body: Update Addon payload. Only spec can be updated (required)
        :param str tca_cp_id: TCA-CP id of management cluster managing given cluster (required)
        :param str cluster_name: Name of cluster on which addon needs to be updated (required)
        :param str addon_name: Name of addon which needs to be updated (required)
        :param str mgmt_cluster_name: Name of management cluster of the given cluster. If given cluster is management cluster, this is not required 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: Addon
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'tca_cp_id', 'cluster_name', 'addon_name', 'mgmt_cluster_name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_addon" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `update_addon`")  # noqa: E501
        # verify the required parameter 'tca_cp_id' is set
        if ('tca_cp_id' not in params or
                params['tca_cp_id'] is None):
            raise ValueError("Missing the required parameter `tca_cp_id` when calling `update_addon`")  # noqa: E501
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `update_addon`")  # noqa: E501
        # verify the required parameter 'addon_name' is set
        if ('addon_name' not in params or
                params['addon_name'] is None):
            raise ValueError("Missing the required parameter `addon_name` when calling `update_addon`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'addon_name' in params:
            path_params['addonName'] = params['addon_name']  # noqa: E501

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}/addons/{addonName}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Addon',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
