# coding: utf-8

"""
    Telco Cloud Automation Addon API.

    Telco Cloud Automation Events API.  # noqa: E501

    OpenAPI spec version: 2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from tca.caas_v2_events.api_client import ApiClient
from tca.api.tca_api import TCAApi

class EventsApi(TCAApi):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_events(self, cluster_name, **kwargs):  # noqa: E501
        """API to get events for given workload cluster from TCA and K8s  # noqa: E501

        API to get events for given workload cluster from TCA and K8s  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_events(cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of cluster for which events should be listed (required)
        :param str node_pool_name: Name of the nodepool
        :param str mgmt_cluster_name: Name of management cluster of the given cluster. 
        :param str tca_cp_id: TCA-CP id of the given cluster
        :param str nextpage_opaque_marker:
        :param str sort:
        :param str filter:


        :return: EventList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_events_with_http_info(cluster_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_events_with_http_info(cluster_name, **kwargs)  # noqa: E501
            return data

    def get_events_with_http_info(self, cluster_name, **kwargs):  # noqa: E501
        """API to get events for given workload cluster from TCA and K8s  # noqa: E501

        API to get events for given workload cluster from TCA and K8s  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_events_with_http_info(cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of cluster for which events should be listed (required)
        :param str node_pool_name: Name of the nodepool
        :param str mgmt_cluster_name: Name of management cluster of the given cluster. 
        :param str tca_cp_id: TCA-CP id of the given cluster
        :param str nextpage_opaque_marker:
        :param str sort:
        :param str filter:


        :return: EventList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'node_pool_name', 'mgmt_cluster_name', 'tca_cp_id', 'nextpage_opaque_marker', 'sort', 'filter']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_events" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `get_events`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501

        query_params = []
        if 'node_pool_name' in params:
            query_params.append(('nodePoolName', params['node_pool_name']))  # noqa: E501
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501
        if 'nextpage_opaque_marker' in params:
            query_params.append(('nextpage_opaque_marker', params['nextpage_opaque_marker']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}/events', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='EventList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
