# coding: utf-8

"""
    Telco Cloud Automation Node Pool API.

    Telco Cloud Automation Node Pool API.  # noqa: E501

    OpenAPI spec version: 2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from tca.caas_v2_nodepool.api_client import ApiClient
from tca.api.tca_api import TCAApi

class NodePoolApi(TCAApi):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_node_pool(self, body, cluster_name, **kwargs):  # noqa: E501
        """Api to deploy Kubernetes Nodepool for Telco Cloud Automation  # noqa: E501

        Api to deploy Kubernetes Nodepool for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_node_pool(body, cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Nodepool body: create nodepool payload (required)
        :param str cluster_name: Name of cluster on which nodepool needs to be created (required)
        :param str mgmt_cluster_name: Name of the management cluster where the request has to be executed
        :param str tca_cp_id: Id of the TCA CP where the request has to be routed.

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: Nodepool
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_node_pool_with_http_info(body, cluster_name, **kwargs)  # noqa: E501
        else:
            (data) = self.create_node_pool_with_http_info(body, cluster_name, **kwargs)  # noqa: E501
            return data

    def create_node_pool_with_http_info(self, body, cluster_name, **kwargs):  # noqa: E501
        """Api to deploy Kubernetes Nodepool for Telco Cloud Automation  # noqa: E501

        Api to deploy Kubernetes Nodepool for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_node_pool_with_http_info(body, cluster_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Nodepool body: create nodepool payload (required)
        :param str cluster_name: Name of cluster on which nodepool needs to be created (required)
        :param str mgmt_cluster_name: Name of the management cluster where the request has to be executed
        :param str tca_cp_id: Id of the TCA CP where the request has to be routed.

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: Nodepool
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'cluster_name', 'mgmt_cluster_name', 'tca_cp_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_node_pool" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_node_pool`")  # noqa: E501
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `create_node_pool`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}/nodepools', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Nodepool',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_node_pool(self, cluster_name, nodepool_name, **kwargs):  # noqa: E501
        """Api to delete Kubernetes Nodepool for Telco Cloud Automation  # noqa: E501

        Api to delete Kubernetes Nodepool for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_node_pool(cluster_name, nodepool_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of cluster on which nodepool needs to be deleted (required)
        :param str nodepool_name: Name of the nodepool which has to be deleted (required)
        :param str mgmt_cluster_name: Name of the management cluster where the request has to be executed
        :param str tca_cp_id: Id of the TCA CP where the request has to be routed.


        :return: Nodepool
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_node_pool_with_http_info(cluster_name, nodepool_name, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_node_pool_with_http_info(cluster_name, nodepool_name, **kwargs)  # noqa: E501
            return data

    def delete_node_pool_with_http_info(self, cluster_name, nodepool_name, **kwargs):  # noqa: E501
        """Api to delete Kubernetes Nodepool for Telco Cloud Automation  # noqa: E501

        Api to delete Kubernetes Nodepool for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_node_pool_with_http_info(cluster_name, nodepool_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of cluster on which nodepool needs to be deleted (required)
        :param str nodepool_name: Name of the nodepool which has to be deleted (required)
        :param str mgmt_cluster_name: Name of the management cluster where the request has to be executed
        :param str tca_cp_id: Id of the TCA CP where the request has to be routed.


        :return: Nodepool
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'nodepool_name', 'mgmt_cluster_name', 'tca_cp_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_node_pool" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `delete_node_pool`")  # noqa: E501
        # verify the required parameter 'nodepool_name' is set
        if ('nodepool_name' not in params or
                params['nodepool_name'] is None):
            raise ValueError("Missing the required parameter `nodepool_name` when calling `delete_node_pool`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'nodepool_name' in params:
            path_params['nodepoolName'] = params['nodepool_name']  # noqa: E501

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}/nodepools/{nodepoolName}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Nodepool',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def edit_node_pool(self, body, cluster_name, nodepool_name, **kwargs):  # noqa: E501
        """Api to modify Kubernetes Nodepool for Telco Cloud Automation  # noqa: E501

        Api to modify Kubernetes Nodepool for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_node_pool(body, cluster_name, nodepool_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Nodepool body: modify nodepool payload (required)
        :param str cluster_name: Name of cluster on which nodepool needs to be modified (required)
        :param str nodepool_name: Name of the nodepool which has to be modified (required)
        :param str mgmt_cluster_name: Name of the management cluster where the request has to be executed
        :param str tca_cp_id: Id of the TCA CP where the request has to be routed.

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: Nodepool
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.edit_node_pool_with_http_info(body, cluster_name, nodepool_name, **kwargs)  # noqa: E501
        else:
            (data) = self.edit_node_pool_with_http_info(body, cluster_name, nodepool_name, **kwargs)  # noqa: E501
            return data

    def edit_node_pool_with_http_info(self, body, cluster_name, nodepool_name, **kwargs):  # noqa: E501
        """Api to modify Kubernetes Nodepool for Telco Cloud Automation  # noqa: E501

        Api to modify Kubernetes Nodepool for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_node_pool_with_http_info(body, cluster_name, nodepool_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Nodepool body: modify nodepool payload (required)
        :param str cluster_name: Name of cluster on which nodepool needs to be modified (required)
        :param str nodepool_name: Name of the nodepool which has to be modified (required)
        :param str mgmt_cluster_name: Name of the management cluster where the request has to be executed
        :param str tca_cp_id: Id of the TCA CP where the request has to be routed.

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: Nodepool
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'cluster_name', 'nodepool_name', 'mgmt_cluster_name', 'tca_cp_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method edit_node_pool" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `edit_node_pool`")  # noqa: E501
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `edit_node_pool`")  # noqa: E501
        # verify the required parameter 'nodepool_name' is set
        if ('nodepool_name' not in params or
                params['nodepool_name'] is None):
            raise ValueError("Missing the required parameter `nodepool_name` when calling `edit_node_pool`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'nodepool_name' in params:
            path_params['nodepoolName'] = params['nodepool_name']  # noqa: E501

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}/nodepools/{nodepoolName}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Nodepool',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_all_node_pools(self, cluster_name, tca_cp_id, **kwargs):  # noqa: E501
        """API to fetch all node pools created on Kubernetes Cluster  # noqa: E501

        API to fetch all node pools of as Kubernetes Cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_all_node_pools(cluster_name, tca_cp_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of cluster where node pools are created (required)
        :param str tca_cp_id: TCA-CP id of management cluster managing given cluster (required)
        :param str mgmt_cluster_name: Name of management cluster of the given cluster. If given cluster is management cluster, this is not required 
        :param str sort: Attribute based sorting expression.
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. If not present, API will return first page of response with page size 10.


        :return: NodepoolList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_all_node_pools_with_http_info(cluster_name, tca_cp_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_all_node_pools_with_http_info(cluster_name, tca_cp_id, **kwargs)  # noqa: E501
            return data

    def get_all_node_pools_with_http_info(self, cluster_name, tca_cp_id, **kwargs):  # noqa: E501
        """API to fetch all node pools created on Kubernetes Cluster  # noqa: E501

        API to fetch all node pools of as Kubernetes Cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_all_node_pools_with_http_info(cluster_name, tca_cp_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of cluster where node pools are created (required)
        :param str tca_cp_id: TCA-CP id of management cluster managing given cluster (required)
        :param str mgmt_cluster_name: Name of management cluster of the given cluster. If given cluster is management cluster, this is not required 
        :param str sort: Attribute based sorting expression.
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. If not present, API will return first page of response with page size 10.


        :return: NodepoolList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'tca_cp_id', 'mgmt_cluster_name', 'sort', 'nextpage_opaque_marker']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_all_node_pools" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `get_all_node_pools`")  # noqa: E501
        # verify the required parameter 'tca_cp_id' is set
        if ('tca_cp_id' not in params or
                params['tca_cp_id'] is None):
            raise ValueError("Missing the required parameter `tca_cp_id` when calling `get_all_node_pools`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'nextpage_opaque_marker' in params:
            query_params.append(('nextpage_opaque_marker', params['nextpage_opaque_marker']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}/nodepools', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NodepoolList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_node_pool(self, cluster_name, nodepool_name, tca_cp_id, **kwargs):  # noqa: E501
        """API to get Node Pool created on a Kubernetes Cluster  # noqa: E501

        API to get Node Pool of a Kubernetes Cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_node_pool(cluster_name, nodepool_name, tca_cp_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of cluster where node pool is created (required)
        :param str nodepool_name: Name of node pool (required)
        :param str tca_cp_id: TCA-CP id of management cluster managing given cluster (required)
        :param str mgmt_cluster_name: Name of management cluster of the given cluster. If given cluster is management cluster, this is not required 


        :return: Nodepool
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_node_pool_with_http_info(cluster_name, nodepool_name, tca_cp_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_node_pool_with_http_info(cluster_name, nodepool_name, tca_cp_id, **kwargs)  # noqa: E501
            return data

    def get_node_pool_with_http_info(self, cluster_name, nodepool_name, tca_cp_id, **kwargs):  # noqa: E501
        """API to get Node Pool created on a Kubernetes Cluster  # noqa: E501

        API to get Node Pool of a Kubernetes Cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_node_pool_with_http_info(cluster_name, nodepool_name, tca_cp_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of cluster where node pool is created (required)
        :param str nodepool_name: Name of node pool (required)
        :param str tca_cp_id: TCA-CP id of management cluster managing given cluster (required)
        :param str mgmt_cluster_name: Name of management cluster of the given cluster. If given cluster is management cluster, this is not required 


        :return: Nodepool
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'nodepool_name', 'tca_cp_id', 'mgmt_cluster_name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_node_pool" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `get_node_pool`")  # noqa: E501
        # verify the required parameter 'nodepool_name' is set
        if ('nodepool_name' not in params or
                params['nodepool_name'] is None):
            raise ValueError("Missing the required parameter `nodepool_name` when calling `get_node_pool`")  # noqa: E501
        # verify the required parameter 'tca_cp_id' is set
        if ('tca_cp_id' not in params or
                params['tca_cp_id'] is None):
            raise ValueError("Missing the required parameter `tca_cp_id` when calling `get_node_pool`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'nodepool_name' in params:
            path_params['nodepoolName'] = params['nodepool_name']  # noqa: E501

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}/nodepools/{nodepoolName}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Nodepool',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_node_pool_customization(self, cluster_name, nodepool_name, tca_cp_id, **kwargs):  # noqa: E501
        """API to get Node Pool Customization  # noqa: E501

        API to get Node Pool Customization  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_node_pool_customization(cluster_name, nodepool_name, tca_cp_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of cluster where node pool is created (required)
        :param str nodepool_name: Name of node pool (required)
        :param str tca_cp_id: TCA-CP id of management cluster managing given cluster (required)
        :param str mgmt_cluster_name: Name of management cluster of the given cluster. If given cluster is management cluster, this is not required 


        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_node_pool_customization_with_http_info(cluster_name, nodepool_name, tca_cp_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_node_pool_customization_with_http_info(cluster_name, nodepool_name, tca_cp_id, **kwargs)  # noqa: E501
            return data

    def get_node_pool_customization_with_http_info(self, cluster_name, nodepool_name, tca_cp_id, **kwargs):  # noqa: E501
        """API to get Node Pool Customization  # noqa: E501

        API to get Node Pool Customization  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_node_pool_customization_with_http_info(cluster_name, nodepool_name, tca_cp_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_name: Name of cluster where node pool is created (required)
        :param str nodepool_name: Name of node pool (required)
        :param str tca_cp_id: TCA-CP id of management cluster managing given cluster (required)
        :param str mgmt_cluster_name: Name of management cluster of the given cluster. If given cluster is management cluster, this is not required 


        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_name', 'nodepool_name', 'tca_cp_id', 'mgmt_cluster_name']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_node_pool_customization" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_name' is set
        if ('cluster_name' not in params or
                params['cluster_name'] is None):
            raise ValueError("Missing the required parameter `cluster_name` when calling `get_node_pool_customization`")  # noqa: E501
        # verify the required parameter 'nodepool_name' is set
        if ('nodepool_name' not in params or
                params['nodepool_name'] is None):
            raise ValueError("Missing the required parameter `nodepool_name` when calling `get_node_pool_customization`")  # noqa: E501
        # verify the required parameter 'tca_cp_id' is set
        if ('tca_cp_id' not in params or
                params['tca_cp_id'] is None):
            raise ValueError("Missing the required parameter `tca_cp_id` when calling `get_node_pool_customization`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_name' in params:
            path_params['clusterName'] = params['cluster_name']  # noqa: E501
        if 'nodepool_name' in params:
            path_params['nodepoolName'] = params['nodepool_name']  # noqa: E501

        query_params = []
        if 'mgmt_cluster_name' in params:
            query_params.append(('mgmtClusterName', params['mgmt_cluster_name']))  # noqa: E501
        if 'tca_cp_id' in params:
            query_params.append(('tcaCpId', params['tca_cp_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json', 'application/x-yaml'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/clusters/{clusterName}/nodepools/{nodepoolName}/customization', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='object',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
