# coding: utf-8

"""
    Telco Cloud Automation Cluster API.

    Telco Cloud Automation Cluster API.  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from tca.cluster.api_client import ApiClient
from tca.api.tca_api import TCAApi

class InfraApi(TCAApi):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def abort_cluster_operation(self, operation_id, **kwargs):  # noqa: E501
        """Api to abort K8s cluster operation (Deprecated for workload clusters)  # noqa: E501

        Abort K8s Cluster Operation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.abort_cluster_operation(operation_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str operation_id: (required)


        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.abort_cluster_operation_with_http_info(operation_id, **kwargs)  # noqa: E501
        else:
            (data) = self.abort_cluster_operation_with_http_info(operation_id, **kwargs)  # noqa: E501
            return data

    def abort_cluster_operation_with_http_info(self, operation_id, **kwargs):  # noqa: E501
        """Api to abort K8s cluster operation (Deprecated for workload clusters)  # noqa: E501

        Abort K8s Cluster Operation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.abort_cluster_operation_with_http_info(operation_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str operation_id: (required)


        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['operation_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method abort_cluster_operation" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'operation_id' is set
        if ('operation_id' not in params or
                params['operation_id'] is None):
            raise ValueError("Missing the required parameter `operation_id` when calling `abort_cluster_operation`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'operation_id' in params:
            path_params['operationId'] = params['operation_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/operations/{operationId}/abort', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterAPIResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def change_cluster_password(self, body, id, **kwargs):  # noqa: E501
        """Api to edit Cluster password (Deprecated for workload clusters)  # noqa: E501

        Api to edit Cluster password  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.change_cluster_password(body, id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param IdChangePasswordBody body: Edit Cluster Password (required)
        :param str id: (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.change_cluster_password_with_http_info(body, id, **kwargs)  # noqa: E501
        else:
            (data) = self.change_cluster_password_with_http_info(body, id, **kwargs)  # noqa: E501
            return data

    def change_cluster_password_with_http_info(self, body, id, **kwargs):  # noqa: E501
        """Api to edit Cluster password (Deprecated for workload clusters)  # noqa: E501

        Api to edit Cluster password  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.change_cluster_password_with_http_info(body, id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param IdChangePasswordBody body: Edit Cluster Password (required)
        :param str id: (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method change_cluster_password" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `change_cluster_password`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `change_cluster_password`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/clusters/{id}/changePassword', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterAPIResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_cluster_node_pool(self, body, cluster_id, **kwargs):  # noqa: E501
        """Api to create k8s cluster ndoe pools (Deprecated for workload clusters)  # noqa: E501

        Create K8 cluster Node Pools  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_cluster_node_pool(body, cluster_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NodePool body: create cluster node pool (required)
        :param str cluster_id: (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_cluster_node_pool_with_http_info(body, cluster_id, **kwargs)  # noqa: E501
        else:
            (data) = self.create_cluster_node_pool_with_http_info(body, cluster_id, **kwargs)  # noqa: E501
            return data

    def create_cluster_node_pool_with_http_info(self, body, cluster_id, **kwargs):  # noqa: E501
        """Api to create k8s cluster ndoe pools (Deprecated for workload clusters)  # noqa: E501

        Create K8 cluster Node Pools  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_cluster_node_pool_with_http_info(body, cluster_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NodePool body: create cluster node pool (required)
        :param str cluster_id: (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'cluster_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_cluster_node_pool" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_cluster_node_pool`")  # noqa: E501
        # verify the required parameter 'cluster_id' is set
        if ('cluster_id' not in params or
                params['cluster_id'] is None):
            raise ValueError("Missing the required parameter `cluster_id` when calling `create_cluster_node_pool`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_id' in params:
            path_params['clusterId'] = params['cluster_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/cluster/{clusterId}/nodepool', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterAPIResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_node_pool(self, cluster_id, node_pool_id, **kwargs):  # noqa: E501
        """Api to delete K8 cluster node pool for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Delete K8 cluster node pool  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_node_pool(cluster_id, node_pool_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_id: (required)
        :param str node_pool_id: (required)
        :param bool is_force: Flag to force delete node pool related info from bootstrapper


        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_node_pool_with_http_info(cluster_id, node_pool_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_node_pool_with_http_info(cluster_id, node_pool_id, **kwargs)  # noqa: E501
            return data

    def delete_node_pool_with_http_info(self, cluster_id, node_pool_id, **kwargs):  # noqa: E501
        """Api to delete K8 cluster node pool for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Delete K8 cluster node pool  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_node_pool_with_http_info(cluster_id, node_pool_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_id: (required)
        :param str node_pool_id: (required)
        :param bool is_force: Flag to force delete node pool related info from bootstrapper


        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_id', 'node_pool_id', 'is_force']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_node_pool" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_id' is set
        if ('cluster_id' not in params or
                params['cluster_id'] is None):
            raise ValueError("Missing the required parameter `cluster_id` when calling `delete_node_pool`")  # noqa: E501
        # verify the required parameter 'node_pool_id' is set
        if ('node_pool_id' not in params or
                params['node_pool_id'] is None):
            raise ValueError("Missing the required parameter `node_pool_id` when calling `delete_node_pool`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_id' in params:
            path_params['clusterId'] = params['cluster_id']  # noqa: E501
        if 'node_pool_id' in params:
            path_params['nodePoolId'] = params['node_pool_id']  # noqa: E501

        query_params = []
        if 'is_force' in params:
            query_params.append(('isForce', params['is_force']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/cluster/{clusterId}/nodepool/{nodePoolId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterAPIResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def deploy_cluster(self, body, **kwargs):  # noqa: E501
        """Api to deploy Kubernetes Cluster for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Api to deploy Kubernetes Cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.deploy_cluster(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ClusterRequest body: create cluster (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.deploy_cluster_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.deploy_cluster_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def deploy_cluster_with_http_info(self, body, **kwargs):  # noqa: E501
        """Api to deploy Kubernetes Cluster for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Api to deploy Kubernetes Cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.deploy_cluster_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ClusterRequest body: create cluster (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method deploy_cluster" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `deploy_cluster`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/clusters', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterAPIResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def edit_cluster(self, body, cluster_id, **kwargs):  # noqa: E501
        """Api to edit a cluster for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Api to edit a cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_cluster(body, cluster_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Cluster body: Edit cluster (required)
        :param str cluster_id: (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.edit_cluster_with_http_info(body, cluster_id, **kwargs)  # noqa: E501
        else:
            (data) = self.edit_cluster_with_http_info(body, cluster_id, **kwargs)  # noqa: E501
            return data

    def edit_cluster_with_http_info(self, body, cluster_id, **kwargs):  # noqa: E501
        """Api to edit a cluster for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Api to edit a cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_cluster_with_http_info(body, cluster_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Cluster body: Edit cluster (required)
        :param str cluster_id: (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'cluster_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method edit_cluster" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `edit_cluster`")  # noqa: E501
        # verify the required parameter 'cluster_id' is set
        if ('cluster_id' not in params or
                params['cluster_id'] is None):
            raise ValueError("Missing the required parameter `cluster_id` when calling `edit_cluster`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_id' in params:
            path_params['clusterId'] = params['cluster_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/clusters/{clusterId}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterAPIResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def edit_cluster_config(self, body, cluster_id, **kwargs):  # noqa: E501
        """Api to edit cluster config (Deprecated for workload clusters)  # noqa: E501

        Api to edit cluster config  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_cluster_config(body, cluster_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ClusterConfigurations body: Edit Cluster Config (required)
        :param str cluster_id: (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.edit_cluster_config_with_http_info(body, cluster_id, **kwargs)  # noqa: E501
        else:
            (data) = self.edit_cluster_config_with_http_info(body, cluster_id, **kwargs)  # noqa: E501
            return data

    def edit_cluster_config_with_http_info(self, body, cluster_id, **kwargs):  # noqa: E501
        """Api to edit cluster config (Deprecated for workload clusters)  # noqa: E501

        Api to edit cluster config  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_cluster_config_with_http_info(body, cluster_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ClusterConfigurations body: Edit Cluster Config (required)
        :param str cluster_id: (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'cluster_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method edit_cluster_config" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `edit_cluster_config`")  # noqa: E501
        # verify the required parameter 'cluster_id' is set
        if ('cluster_id' not in params or
                params['cluster_id'] is None):
            raise ValueError("Missing the required parameter `cluster_id` when calling `edit_cluster_config`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_id' in params:
            path_params['clusterId'] = params['cluster_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/cluster/{clusterId}/configurations', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterAPIResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def edit_node_pool(self, body, cluster_id, node_pool_id, **kwargs):  # noqa: E501
        """Api to edit a node pool (Deprecated for workload clusters)  # noqa: E501

        Api to edit a nodepool  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_node_pool(body, cluster_id, node_pool_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NodePool body: edit cluster node pool (required)
        :param str cluster_id: (required)
        :param str node_pool_id: (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.edit_node_pool_with_http_info(body, cluster_id, node_pool_id, **kwargs)  # noqa: E501
        else:
            (data) = self.edit_node_pool_with_http_info(body, cluster_id, node_pool_id, **kwargs)  # noqa: E501
            return data

    def edit_node_pool_with_http_info(self, body, cluster_id, node_pool_id, **kwargs):  # noqa: E501
        """Api to edit a node pool (Deprecated for workload clusters)  # noqa: E501

        Api to edit a nodepool  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_node_pool_with_http_info(body, cluster_id, node_pool_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NodePool body: edit cluster node pool (required)
        :param str cluster_id: (required)
        :param str node_pool_id: (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'cluster_id', 'node_pool_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method edit_node_pool" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `edit_node_pool`")  # noqa: E501
        # verify the required parameter 'cluster_id' is set
        if ('cluster_id' not in params or
                params['cluster_id'] is None):
            raise ValueError("Missing the required parameter `cluster_id` when calling `edit_node_pool`")  # noqa: E501
        # verify the required parameter 'node_pool_id' is set
        if ('node_pool_id' not in params or
                params['node_pool_id'] is None):
            raise ValueError("Missing the required parameter `node_pool_id` when calling `edit_node_pool`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_id' in params:
            path_params['clusterId'] = params['cluster_id']  # noqa: E501
        if 'node_pool_id' in params:
            path_params['nodePoolId'] = params['node_pool_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/cluster/{clusterId}/nodepool/{nodePoolId}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterAPIResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def genereate_spec(self, cluster_id, action, **kwargs):  # noqa: E501
        """Api to collect the specifications of the cluster (Deprecated for workload clusters)  # noqa: E501

        Collects the specifications of the cluster and returns back the payload which can be used to deploy cluster of the same configuration. It may result in creation of new cluster template as well.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.genereate_spec(cluster_id, action, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_id: (required)
        :param str action: (required)


        :return: ClusterSpec
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.genereate_spec_with_http_info(cluster_id, action, **kwargs)  # noqa: E501
        else:
            (data) = self.genereate_spec_with_http_info(cluster_id, action, **kwargs)  # noqa: E501
            return data

    def genereate_spec_with_http_info(self, cluster_id, action, **kwargs):  # noqa: E501
        """Api to collect the specifications of the cluster (Deprecated for workload clusters)  # noqa: E501

        Collects the specifications of the cluster and returns back the payload which can be used to deploy cluster of the same configuration. It may result in creation of new cluster template as well.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.genereate_spec_with_http_info(cluster_id, action, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_id: (required)
        :param str action: (required)


        :return: ClusterSpec
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_id', 'action']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method genereate_spec" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_id' is set
        if ('cluster_id' not in params or
                params['cluster_id'] is None):
            raise ValueError("Missing the required parameter `cluster_id` when calling `genereate_spec`")  # noqa: E501
        # verify the required parameter 'action' is set
        if ('action' not in params or
                params['action'] is None):
            raise ValueError("Missing the required parameter `action` when calling `genereate_spec`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_id' in params:
            path_params['clusterId'] = params['cluster_id']  # noqa: E501

        query_params = []
        if 'action' in params:
            query_params.append(('action', params['action']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/clusters/{clusterId}', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterSpec',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_cluster_config(self, cluster_id, **kwargs):  # noqa: E501
        """Api to get cluster configurations (Deprecated for workload clusters)  # noqa: E501

        Get K8 cluster configurations  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_cluster_config(cluster_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_id: (required)


        :return: ClusterConfigurations
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_cluster_config_with_http_info(cluster_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_cluster_config_with_http_info(cluster_id, **kwargs)  # noqa: E501
            return data

    def get_cluster_config_with_http_info(self, cluster_id, **kwargs):  # noqa: E501
        """Api to get cluster configurations (Deprecated for workload clusters)  # noqa: E501

        Get K8 cluster configurations  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_cluster_config_with_http_info(cluster_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_id: (required)


        :return: ClusterConfigurations
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_cluster_config" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_id' is set
        if ('cluster_id' not in params or
                params['cluster_id'] is None):
            raise ValueError("Missing the required parameter `cluster_id` when calling `get_cluster_config`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_id' in params:
            path_params['clusterId'] = params['cluster_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/cluster/{clusterId}/configurations', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterConfigurations',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_clusters(self, **kwargs):  # noqa: E501
        """Api to get clusters for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Api to get clusters for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_clusters(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str x_tca_anymatch: Flag to indicate OR match is requested for filter sub-expressions. If set to true, response based on OR match is returned.
        :param str skip_nodes_info: Flag to skip nodes information as part of api response. If set to true, response will not have nodes information. Nodes information can be queried directly from Kubernetes cluster API instead.
        :param str filter: Attribute-based filtering expression. Attributes which are supported in filter expression are clusterName, clusterType, vsphereClusterName, managementClusterId, status, clusterConfig.kubernetesVersion, lastUpdated
        :param str fields: Attributes which should be included in the response
        :param str sort: Attribute based sorting expression. Same attributes as filter expression are supported for sort expression.
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. If not present, API will return first page of response with page size 10.


        :return: list[Cluster]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_clusters_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_clusters_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_clusters_with_http_info(self, **kwargs):  # noqa: E501
        """Api to get clusters for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Api to get clusters for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_clusters_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str x_tca_anymatch: Flag to indicate OR match is requested for filter sub-expressions. If set to true, response based on OR match is returned.
        :param str skip_nodes_info: Flag to skip nodes information as part of api response. If set to true, response will not have nodes information. Nodes information can be queried directly from Kubernetes cluster API instead.
        :param str filter: Attribute-based filtering expression. Attributes which are supported in filter expression are clusterName, clusterType, vsphereClusterName, managementClusterId, status, clusterConfig.kubernetesVersion, lastUpdated
        :param str fields: Attributes which should be included in the response
        :param str sort: Attribute based sorting expression. Same attributes as filter expression are supported for sort expression.
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. If not present, API will return first page of response with page size 10.


        :return: list[Cluster]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['x_tca_anymatch', 'skip_nodes_info', 'filter', 'fields', 'sort', 'nextpage_opaque_marker']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_clusters" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'nextpage_opaque_marker' in params:
            query_params.append(('nextpage_opaque_marker', params['nextpage_opaque_marker']))  # noqa: E501

        header_params = {}
        if 'x_tca_anymatch' in params:
            header_params['x-tca-anymatch'] = params['x_tca_anymatch']  # noqa: E501
        if 'skip_nodes_info' in params:
            header_params['skip-nodes-info'] = params['skip_nodes_info']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/clusters', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[Cluster]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_clusters_node_pools(self, cluster_id, **kwargs):  # noqa: E501
        """Api to get node pools for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Api to get node pools for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_clusters_node_pools(cluster_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_id: (required)
        :param str skip_nodes_info: Flag to skip nodes information as part of api response. If set to true, response will not have nodes information. Nodes information can be queried directly from Kubernetes cluster API instead. Nodes belonging to a nodepool can be filtered by label with key telco.vmware.com/nodepool and value clustername-nodepoolname


        :return: NodePoolList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_clusters_node_pools_with_http_info(cluster_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_clusters_node_pools_with_http_info(cluster_id, **kwargs)  # noqa: E501
            return data

    def get_clusters_node_pools_with_http_info(self, cluster_id, **kwargs):  # noqa: E501
        """Api to get node pools for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Api to get node pools for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_clusters_node_pools_with_http_info(cluster_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_id: (required)
        :param str skip_nodes_info: Flag to skip nodes information as part of api response. If set to true, response will not have nodes information. Nodes information can be queried directly from Kubernetes cluster API instead. Nodes belonging to a nodepool can be filtered by label with key telco.vmware.com/nodepool and value clustername-nodepoolname


        :return: NodePoolList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_id', 'skip_nodes_info']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_clusters_node_pools" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_id' is set
        if ('cluster_id' not in params or
                params['cluster_id'] is None):
            raise ValueError("Missing the required parameter `cluster_id` when calling `get_clusters_node_pools`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_id' in params:
            path_params['clusterId'] = params['cluster_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'skip_nodes_info' in params:
            header_params['skip-nodes-info'] = params['skip_nodes_info']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/cluster/{clusterId}/nodepools', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NodePoolList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_k8_cluster_node_pool(self, cluster_id, node_pool_id, **kwargs):  # noqa: E501
        """Api to get K8 cluster node pool for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Get K8 cluster node pool  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_k8_cluster_node_pool(cluster_id, node_pool_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_id: (required)
        :param str node_pool_id: (required)
        :param str skip_nodes_info: Flag to skip nodes information as part of api response. If set to true, response will not have nodes information. Nodes information can be queried directly from Kubernetes cluster API instead. Nodes belonging to a nodepool can be filtered by label with key telco.vmware.com/nodepool and value clustername-nodepoolname.


        :return: NodePool
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_k8_cluster_node_pool_with_http_info(cluster_id, node_pool_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_k8_cluster_node_pool_with_http_info(cluster_id, node_pool_id, **kwargs)  # noqa: E501
            return data

    def get_k8_cluster_node_pool_with_http_info(self, cluster_id, node_pool_id, **kwargs):  # noqa: E501
        """Api to get K8 cluster node pool for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Get K8 cluster node pool  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_k8_cluster_node_pool_with_http_info(cluster_id, node_pool_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_id: (required)
        :param str node_pool_id: (required)
        :param str skip_nodes_info: Flag to skip nodes information as part of api response. If set to true, response will not have nodes information. Nodes information can be queried directly from Kubernetes cluster API instead. Nodes belonging to a nodepool can be filtered by label with key telco.vmware.com/nodepool and value clustername-nodepoolname.


        :return: NodePool
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_id', 'node_pool_id', 'skip_nodes_info']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_k8_cluster_node_pool" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_id' is set
        if ('cluster_id' not in params or
                params['cluster_id'] is None):
            raise ValueError("Missing the required parameter `cluster_id` when calling `get_k8_cluster_node_pool`")  # noqa: E501
        # verify the required parameter 'node_pool_id' is set
        if ('node_pool_id' not in params or
                params['node_pool_id'] is None):
            raise ValueError("Missing the required parameter `node_pool_id` when calling `get_k8_cluster_node_pool`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_id' in params:
            path_params['clusterId'] = params['cluster_id']  # noqa: E501
        if 'node_pool_id' in params:
            path_params['nodePoolId'] = params['node_pool_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'skip_nodes_info' in params:
            header_params['skip-nodes-info'] = params['skip_nodes_info']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/cluster/{clusterId}/nodepool/{nodePoolId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NodePool',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_node_pool_customization(self, cluster_id, node_pool_id, **kwargs):  # noqa: E501
        """Api to get nodepool customizations (Deprecated for workload clusters)  # noqa: E501

        Get nodepool customizations  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_node_pool_customization(cluster_id, node_pool_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_id: (required)
        :param str node_pool_id: (required)


        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_node_pool_customization_with_http_info(cluster_id, node_pool_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_node_pool_customization_with_http_info(cluster_id, node_pool_id, **kwargs)  # noqa: E501
            return data

    def get_node_pool_customization_with_http_info(self, cluster_id, node_pool_id, **kwargs):  # noqa: E501
        """Api to get nodepool customizations (Deprecated for workload clusters)  # noqa: E501

        Get nodepool customizations  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_node_pool_customization_with_http_info(cluster_id, node_pool_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_id: (required)
        :param str node_pool_id: (required)


        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_id', 'node_pool_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_node_pool_customization" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_id' is set
        if ('cluster_id' not in params or
                params['cluster_id'] is None):
            raise ValueError("Missing the required parameter `cluster_id` when calling `get_node_pool_customization`")  # noqa: E501
        # verify the required parameter 'node_pool_id' is set
        if ('node_pool_id' not in params or
                params['node_pool_id'] is None):
            raise ValueError("Missing the required parameter `node_pool_id` when calling `get_node_pool_customization`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_id' in params:
            path_params['clusterId'] = params['cluster_id']  # noqa: E501
        if 'node_pool_id' in params:
            path_params['nodePoolId'] = params['node_pool_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/cluster/{clusterId}/nodepool/{nodePoolId}/customization', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='object',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def kuberenetes_version_upgrade_matrix(self, body, **kwargs):  # noqa: E501
        """Api to get the K8s versions upgrade matrix for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Api to get the K8s versions upgrade matrix for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.kuberenetes_version_upgrade_matrix(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Filter body: Filter object. (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: UpgradeMatrixList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.kuberenetes_version_upgrade_matrix_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.kuberenetes_version_upgrade_matrix_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def kuberenetes_version_upgrade_matrix_with_http_info(self, body, **kwargs):  # noqa: E501
        """Api to get the K8s versions upgrade matrix for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Api to get the K8s versions upgrade matrix for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.kuberenetes_version_upgrade_matrix_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Filter body: Filter object. (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: UpgradeMatrixList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method kuberenetes_version_upgrade_matrix" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `kuberenetes_version_upgrade_matrix`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/k8sVersionUpgradeMatrix/query', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='UpgradeMatrixList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def pause_node_pool(self, cluster_id, node_pool_id, **kwargs):  # noqa: E501
        """Pause a Nodepool in a cluster (Deprecated for workload clusters)  # noqa: E501

        Pause a Nodepool in a cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pause_node_pool(cluster_id, node_pool_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_id: (required)
        :param str node_pool_id: (required)


        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.pause_node_pool_with_http_info(cluster_id, node_pool_id, **kwargs)  # noqa: E501
        else:
            (data) = self.pause_node_pool_with_http_info(cluster_id, node_pool_id, **kwargs)  # noqa: E501
            return data

    def pause_node_pool_with_http_info(self, cluster_id, node_pool_id, **kwargs):  # noqa: E501
        """Pause a Nodepool in a cluster (Deprecated for workload clusters)  # noqa: E501

        Pause a Nodepool in a cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pause_node_pool_with_http_info(cluster_id, node_pool_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_id: (required)
        :param str node_pool_id: (required)


        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_id', 'node_pool_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method pause_node_pool" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_id' is set
        if ('cluster_id' not in params or
                params['cluster_id'] is None):
            raise ValueError("Missing the required parameter `cluster_id` when calling `pause_node_pool`")  # noqa: E501
        # verify the required parameter 'node_pool_id' is set
        if ('node_pool_id' not in params or
                params['node_pool_id'] is None):
            raise ValueError("Missing the required parameter `node_pool_id` when calling `pause_node_pool`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_id' in params:
            path_params['clusterId'] = params['cluster_id']  # noqa: E501
        if 'node_pool_id' in params:
            path_params['nodePoolId'] = params['node_pool_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/cluster/{clusterId}/nodepool/{nodePoolId}/pause', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterAPIResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def retry_cluster_operation(self, operation_id, **kwargs):  # noqa: E501
        """Api to retry K8s cluster operation (Deprecated for workload clusters)  # noqa: E501

        Retry K8s Cluster Operation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.retry_cluster_operation(operation_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str operation_id: (required)


        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.retry_cluster_operation_with_http_info(operation_id, **kwargs)  # noqa: E501
        else:
            (data) = self.retry_cluster_operation_with_http_info(operation_id, **kwargs)  # noqa: E501
            return data

    def retry_cluster_operation_with_http_info(self, operation_id, **kwargs):  # noqa: E501
        """Api to retry K8s cluster operation (Deprecated for workload clusters)  # noqa: E501

        Retry K8s Cluster Operation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.retry_cluster_operation_with_http_info(operation_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str operation_id: (required)


        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['operation_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method retry_cluster_operation" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'operation_id' is set
        if ('operation_id' not in params or
                params['operation_id'] is None):
            raise ValueError("Missing the required parameter `operation_id` when calling `retry_cluster_operation`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'operation_id' in params:
            path_params['operationId'] = params['operation_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/operations/{operationId}/retry', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterAPIResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def supported_kubernetes_versions(self, **kwargs):  # noqa: E501
        """Api to get all the supported  K8s versions of cluster for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Api to get all the supported  K8s versions of cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.supported_kubernetes_versions(async_req=True)
        >>> result = thread.get()

        :param async_req bool


        :return: SupportedVersionsList
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.supported_kubernetes_versions_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.supported_kubernetes_versions_with_http_info(**kwargs)  # noqa: E501
            return data

    def supported_kubernetes_versions_with_http_info(self, **kwargs):  # noqa: E501
        """Api to get all the supported  K8s versions of cluster for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Api to get all the supported  K8s versions of cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.supported_kubernetes_versions_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool


        :return: SupportedVersionsList
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method supported_kubernetes_versions" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/supportedK8sVersions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SupportedVersionsList',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def sync_esx_info(self, id, **kwargs):  # noqa: E501
        """Api to sync Esx Info for Workload Clusters on demand  # noqa: E501

        Api to sync Esx Info for Workload Clusters on demand. TCA automatically syncs required ESX Info for the workload clusters but if for some reason there is a notifcation miss, then this API can be called to forcefully trigger the ESX Info Sync  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.sync_esx_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: (required)


        :return: InlineResponse2001
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.sync_esx_info_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.sync_esx_info_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def sync_esx_info_with_http_info(self, id, **kwargs):  # noqa: E501
        """Api to sync Esx Info for Workload Clusters on demand  # noqa: E501

        Api to sync Esx Info for Workload Clusters on demand. TCA automatically syncs required ESX Info for the workload clusters but if for some reason there is a notifcation miss, then this API can be called to forcefully trigger the ESX Info Sync  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.sync_esx_info_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: (required)


        :return: InlineResponse2001
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method sync_esx_info" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `sync_esx_info`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/clusters/{id}/esxinfo', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2001',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def transform_cluster(self, id, **kwargs):  # noqa: E501
        """Api to transform cluster from v1 to v2.  # noqa: E501

        Api to transform cluster from v1 to v2. `Once the cluster is transformed, v1 APIs will no longer work for it. LCM operations for such clusters will then be handled by v2 APIs only.`   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.transform_cluster(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: id of the cluster that is to be transformed (required)


        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.transform_cluster_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.transform_cluster_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def transform_cluster_with_http_info(self, id, **kwargs):  # noqa: E501
        """Api to transform cluster from v1 to v2.  # noqa: E501

        Api to transform cluster from v1 to v2. `Once the cluster is transformed, v1 APIs will no longer work for it. LCM operations for such clusters will then be handled by v2 APIs only.`   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.transform_cluster_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: id of the cluster that is to be transformed (required)


        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method transform_cluster" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `transform_cluster`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/clusters/{id}/transform', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterAPIResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def unpause_node_pool(self, cluster_id, node_pool_id, **kwargs):  # noqa: E501
        """Unpause a Nodepool in a cluster (Deprecated for workload clusters)  # noqa: E501

        Unpause a Nodepool in a cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.unpause_node_pool(cluster_id, node_pool_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_id: (required)
        :param str node_pool_id: (required)


        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.unpause_node_pool_with_http_info(cluster_id, node_pool_id, **kwargs)  # noqa: E501
        else:
            (data) = self.unpause_node_pool_with_http_info(cluster_id, node_pool_id, **kwargs)  # noqa: E501
            return data

    def unpause_node_pool_with_http_info(self, cluster_id, node_pool_id, **kwargs):  # noqa: E501
        """Unpause a Nodepool in a cluster (Deprecated for workload clusters)  # noqa: E501

        Unpause a Nodepool in a cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.unpause_node_pool_with_http_info(cluster_id, node_pool_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_id: (required)
        :param str node_pool_id: (required)


        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_id', 'node_pool_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method unpause_node_pool" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_id' is set
        if ('cluster_id' not in params or
                params['cluster_id'] is None):
            raise ValueError("Missing the required parameter `cluster_id` when calling `unpause_node_pool`")  # noqa: E501
        # verify the required parameter 'node_pool_id' is set
        if ('node_pool_id' not in params or
                params['node_pool_id'] is None):
            raise ValueError("Missing the required parameter `node_pool_id` when calling `unpause_node_pool`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_id' in params:
            path_params['clusterId'] = params['cluster_id']  # noqa: E501
        if 'node_pool_id' in params:
            path_params['nodePoolId'] = params['node_pool_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/cluster/{clusterId}/nodepool/{nodePoolId}/unpause', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterAPIResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def upgrade_cluster(self, body, id, **kwargs):  # noqa: E501
        """Api to upgrade K8s version of Cluster for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Api to upgrade K8s version of Cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.upgrade_cluster(body, id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ClusterUpgradeRequest body: upgrade kubernetes version (required)
        :param str id: (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.upgrade_cluster_with_http_info(body, id, **kwargs)  # noqa: E501
        else:
            (data) = self.upgrade_cluster_with_http_info(body, id, **kwargs)  # noqa: E501
            return data

    def upgrade_cluster_with_http_info(self, body, id, **kwargs):  # noqa: E501
        """Api to upgrade K8s version of Cluster for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Api to upgrade K8s version of Cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.upgrade_cluster_with_http_info(body, id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ClusterUpgradeRequest body: upgrade kubernetes version (required)
        :param str id: (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method upgrade_cluster" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `upgrade_cluster`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `upgrade_cluster`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/clusters/{id}/k8sUpgrade', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterAPIResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def upgrade_cluster_addon(self, id, **kwargs):  # noqa: E501
        """Api to upgrade addons on the cluster (Deprecated for workload clusters)  # noqa: E501

        Api to upgrade addons on the cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.upgrade_cluster_addon(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: (required)


        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.upgrade_cluster_addon_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.upgrade_cluster_addon_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def upgrade_cluster_addon_with_http_info(self, id, **kwargs):  # noqa: E501
        """Api to upgrade addons on the cluster (Deprecated for workload clusters)  # noqa: E501

        Api to upgrade addons on the cluster  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.upgrade_cluster_addon_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: (required)


        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method upgrade_cluster_addon" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `upgrade_cluster_addon`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/clusters/{id}/upgradeAddon', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterAPIResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def upgrade_history(self, id, **kwargs):  # noqa: E501
        """Api to get the K8s versions upgrade history of cluster for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Api to get the K8s versions upgrade history of cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.upgrade_history(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: (required)


        :return: UpgradeHistory
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.upgrade_history_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.upgrade_history_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def upgrade_history_with_http_info(self, id, **kwargs):  # noqa: E501
        """Api to get the K8s versions upgrade history of cluster for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Api to get the K8s versions upgrade history of cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.upgrade_history_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: (required)


        :return: UpgradeHistory
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method upgrade_history" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `upgrade_history`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/clusters/{id}/k8sUpgradeHistory', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='UpgradeHistory',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def upgrade_node_pool(self, cluster_id, node_pool_id, **kwargs):  # noqa: E501
        """Api to upgrade K8 cluster node pool for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Upgrade Nodepool. This Upgrades the nodepools to use latest features of Cluster Automation. This is mandatory to be done on all nodepools created in TCA 1.7. This is one time operation on upgrading TCA to 1.8 and once successfully upgraded all the operations on nodepool will be enabled. Upgrade can be repeated on nodepool incase of any failure.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.upgrade_node_pool(cluster_id, node_pool_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_id: (required)
        :param str node_pool_id: (required)


        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.upgrade_node_pool_with_http_info(cluster_id, node_pool_id, **kwargs)  # noqa: E501
        else:
            (data) = self.upgrade_node_pool_with_http_info(cluster_id, node_pool_id, **kwargs)  # noqa: E501
            return data

    def upgrade_node_pool_with_http_info(self, cluster_id, node_pool_id, **kwargs):  # noqa: E501
        """Api to upgrade K8 cluster node pool for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Upgrade Nodepool. This Upgrades the nodepools to use latest features of Cluster Automation. This is mandatory to be done on all nodepools created in TCA 1.7. This is one time operation on upgrading TCA to 1.8 and once successfully upgraded all the operations on nodepool will be enabled. Upgrade can be repeated on nodepool incase of any failure.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.upgrade_node_pool_with_http_info(cluster_id, node_pool_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cluster_id: (required)
        :param str node_pool_id: (required)


        :return: ClusterAPIResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cluster_id', 'node_pool_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method upgrade_node_pool" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cluster_id' is set
        if ('cluster_id' not in params or
                params['cluster_id'] is None):
            raise ValueError("Missing the required parameter `cluster_id` when calling `upgrade_node_pool`")  # noqa: E501
        # verify the required parameter 'node_pool_id' is set
        if ('node_pool_id' not in params or
                params['node_pool_id'] is None):
            raise ValueError("Missing the required parameter `node_pool_id` when calling `upgrade_node_pool`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cluster_id' in params:
            path_params['clusterId'] = params['cluster_id']  # noqa: E501
        if 'node_pool_id' in params:
            path_params['nodePoolId'] = params['node_pool_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/cluster/{clusterId}/nodepool/{nodePoolId}/upgrade', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClusterAPIResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def validate_upgrade_cluster(self, id, **kwargs):  # noqa: E501
        """Api to validate  K8s version upgrade of Cluster for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Api to validate  K8s version upgrade of Cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.validate_upgrade_cluster(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: (required)


        :return: ValidateResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.validate_upgrade_cluster_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.validate_upgrade_cluster_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def validate_upgrade_cluster_with_http_info(self, id, **kwargs):  # noqa: E501
        """Api to validate  K8s version upgrade of Cluster for Telco Cloud Automation (Deprecated for workload clusters)  # noqa: E501

        Api to validate  K8s version upgrade of Cluster for Telco Cloud Automation  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.validate_upgrade_cluster_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: (required)


        :return: ValidateResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method validate_upgrade_cluster" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `validate_upgrade_cluster`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/clusters/{id}/k8sUpgradeValidationResponse', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ValidateResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def vsphere_csi_zone_support(self, id, **kwargs):  # noqa: E501
        """Api to verify whether vsphere csi zone support is present. (Deprecated for workload clusters)  # noqa: E501

        Api to verify whether vsphere csi zone support is present. Both workload clusters and management clusters should be created in TCA >= 1.9.5 version.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vsphere_csi_zone_support(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: If Management cluster id is provided, checks whether mgmt cluster is created in TCA >= 1.9.5 version If workload cluster id is provided, checks whether its mgmt cluster is created in TCA >= 1.9.5 and the workload cluster is created in TCA >= 1.9.5 version.  (required)


        :return: VSphereCSIZoneSupportResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.vsphere_csi_zone_support_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.vsphere_csi_zone_support_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def vsphere_csi_zone_support_with_http_info(self, id, **kwargs):  # noqa: E501
        """Api to verify whether vsphere csi zone support is present. (Deprecated for workload clusters)  # noqa: E501

        Api to verify whether vsphere csi zone support is present. Both workload clusters and management clusters should be created in TCA >= 1.9.5 version.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vsphere_csi_zone_support_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: If Management cluster id is provided, checks whether mgmt cluster is created in TCA >= 1.9.5 version If workload cluster id is provided, checks whether its mgmt cluster is created in TCA >= 1.9.5 and the workload cluster is created in TCA >= 1.9.5 version.  (required)


        :return: VSphereCSIZoneSupportResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method vsphere_csi_zone_support" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `vsphere_csi_zone_support`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/infra/k8s/clusters/{id}/vSphereCsiZoneSupport', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='VSphereCSIZoneSupportResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
