# coding: utf-8

"""
    Telco Cloud Automation Cluster API.

    Telco Cloud Automation Cluster API.  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ClusterConfigurations(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cni_editable': 'bool',
        'csi_editable': 'bool',
        'cni': 'list[ClusterConfigurationsCni]',
        'networking': 'list[ClusterConfigurationsNetworking]',
        'csi': 'list[ClusterConfigurationsCsi]',
        'kubernetes_version': 'str',
        'tools': 'list[OneOfclusterConfigurationsToolsItems]',
        'system_settings': 'list[ClusterRequestClusterConfigSystemSettings]'
    }

    attribute_map = {
        'cni_editable': 'cniEditable',
        'csi_editable': 'csiEditable',
        'cni': 'cni',
        'networking': 'networking',
        'csi': 'csi',
        'kubernetes_version': 'kubernetesVersion',
        'tools': 'tools',
        'system_settings': 'systemSettings'
    }

    def __init__(self, cni_editable=True, csi_editable=True, cni=None, networking=None, csi=None, kubernetes_version=None, tools=None, system_settings=None):  # noqa: E501
        """ClusterConfigurations - a model defined in Swagger"""  # noqa: E501
        self._cni_editable = None
        self._csi_editable = None
        self._cni = None
        self._networking = None
        self._csi = None
        self._kubernetes_version = None
        self._tools = None
        self._system_settings = None
        self.discriminator = None
        if cni_editable is not None:
            self.cni_editable = cni_editable
        if csi_editable is not None:
            self.csi_editable = csi_editable
        if cni is not None:
            self.cni = cni
        if networking is not None:
            self.networking = networking
        if csi is not None:
            self.csi = csi
        if kubernetes_version is not None:
            self.kubernetes_version = kubernetes_version
        if tools is not None:
            self.tools = tools
        if system_settings is not None:
            self.system_settings = system_settings

    @property
    def cni_editable(self):
        """Gets the cni_editable of this ClusterConfigurations.  # noqa: E501

        Internal flag to indicate if add/edit on CNIs are allowed.  # noqa: E501

        :return: The cni_editable of this ClusterConfigurations.  # noqa: E501
        :rtype: bool
        """
        return self._cni_editable

    @cni_editable.setter
    def cni_editable(self, cni_editable):
        """Sets the cni_editable of this ClusterConfigurations.

        Internal flag to indicate if add/edit on CNIs are allowed.  # noqa: E501

        :param cni_editable: The cni_editable of this ClusterConfigurations.  # noqa: E501
        :type: bool
        """

        self._cni_editable = cni_editable

    @property
    def csi_editable(self):
        """Gets the csi_editable of this ClusterConfigurations.  # noqa: E501

        Internal flag to indicate if add/edit on CSIs are allowed.  # noqa: E501

        :return: The csi_editable of this ClusterConfigurations.  # noqa: E501
        :rtype: bool
        """
        return self._csi_editable

    @csi_editable.setter
    def csi_editable(self, csi_editable):
        """Sets the csi_editable of this ClusterConfigurations.

        Internal flag to indicate if add/edit on CSIs are allowed.  # noqa: E501

        :param csi_editable: The csi_editable of this ClusterConfigurations.  # noqa: E501
        :type: bool
        """

        self._csi_editable = csi_editable

    @property
    def cni(self):
        """Gets the cni of this ClusterConfigurations.  # noqa: E501

        Container Network Interfaces configured to the cluster.  # noqa: E501

        :return: The cni of this ClusterConfigurations.  # noqa: E501
        :rtype: list[ClusterConfigurationsCni]
        """
        return self._cni

    @cni.setter
    def cni(self, cni):
        """Sets the cni of this ClusterConfigurations.

        Container Network Interfaces configured to the cluster.  # noqa: E501

        :param cni: The cni of this ClusterConfigurations.  # noqa: E501
        :type: list[ClusterConfigurationsCni]
        """

        self._cni = cni

    @property
    def networking(self):
        """Gets the networking of this ClusterConfigurations.  # noqa: E501

        List of networking addon on the cluster.  # noqa: E501

        :return: The networking of this ClusterConfigurations.  # noqa: E501
        :rtype: list[ClusterConfigurationsNetworking]
        """
        return self._networking

    @networking.setter
    def networking(self, networking):
        """Sets the networking of this ClusterConfigurations.

        List of networking addon on the cluster.  # noqa: E501

        :param networking: The networking of this ClusterConfigurations.  # noqa: E501
        :type: list[ClusterConfigurationsNetworking]
        """

        self._networking = networking

    @property
    def csi(self):
        """Gets the csi of this ClusterConfigurations.  # noqa: E501

        Container Storage Interfaces configured to the cluster.  # noqa: E501

        :return: The csi of this ClusterConfigurations.  # noqa: E501
        :rtype: list[ClusterConfigurationsCsi]
        """
        return self._csi

    @csi.setter
    def csi(self, csi):
        """Sets the csi of this ClusterConfigurations.

        Container Storage Interfaces configured to the cluster.  # noqa: E501

        :param csi: The csi of this ClusterConfigurations.  # noqa: E501
        :type: list[ClusterConfigurationsCsi]
        """

        self._csi = csi

    @property
    def kubernetes_version(self):
        """Gets the kubernetes_version of this ClusterConfigurations.  # noqa: E501

        Kubernetes version of the cluster.  # noqa: E501

        :return: The kubernetes_version of this ClusterConfigurations.  # noqa: E501
        :rtype: str
        """
        return self._kubernetes_version

    @kubernetes_version.setter
    def kubernetes_version(self, kubernetes_version):
        """Sets the kubernetes_version of this ClusterConfigurations.

        Kubernetes version of the cluster.  # noqa: E501

        :param kubernetes_version: The kubernetes_version of this ClusterConfigurations.  # noqa: E501
        :type: str
        """

        self._kubernetes_version = kubernetes_version

    @property
    def tools(self):
        """Gets the tools of this ClusterConfigurations.  # noqa: E501

        List of operators and addons on the cluster.  # noqa: E501

        :return: The tools of this ClusterConfigurations.  # noqa: E501
        :rtype: list[OneOfclusterConfigurationsToolsItems]
        """
        return self._tools

    @tools.setter
    def tools(self, tools):
        """Sets the tools of this ClusterConfigurations.

        List of operators and addons on the cluster.  # noqa: E501

        :param tools: The tools of this ClusterConfigurations.  # noqa: E501
        :type: list[OneOfclusterConfigurationsToolsItems]
        """

        self._tools = tools

    @property
    def system_settings(self):
        """Gets the system_settings of this ClusterConfigurations.  # noqa: E501

        List of syslog servers added to the cluster.  # noqa: E501

        :return: The system_settings of this ClusterConfigurations.  # noqa: E501
        :rtype: list[ClusterRequestClusterConfigSystemSettings]
        """
        return self._system_settings

    @system_settings.setter
    def system_settings(self, system_settings):
        """Sets the system_settings of this ClusterConfigurations.

        List of syslog servers added to the cluster.  # noqa: E501

        :param system_settings: The system_settings of this ClusterConfigurations.  # noqa: E501
        :type: list[ClusterRequestClusterConfigSystemSettings]
        """

        self._system_settings = system_settings

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ClusterConfigurations, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ClusterConfigurations):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
