# coding: utf-8

"""
    Telco Cloud Automation Cluster API.

    Telco Cloud Automation Cluster API.  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class NodePool(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'clone_mode': 'str',
        'cpu': 'int',
        'id': 'str',
        'labels': 'list[str]',
        'memory': 'int',
        'name': 'str',
        'networks': 'list[NodePoolNetworks]',
        'placement_params': 'list[ClusterRequestPlacementParams]',
        'replica': 'int',
        'storage': 'int',
        'config': 'NodePoolConfig',
        'status': 'str',
        'active_tasks_count': 'int',
        'nodes': 'list[ClusterNodes]',
        'is_node_customization_deprecated': 'bool',
        'warnings': 'list[ClusterWarnings]',
        'errors': 'list[ClusterWarnings]'
    }

    attribute_map = {
        'clone_mode': 'cloneMode',
        'cpu': 'cpu',
        'id': 'id',
        'labels': 'labels',
        'memory': 'memory',
        'name': 'name',
        'networks': 'networks',
        'placement_params': 'placementParams',
        'replica': 'replica',
        'storage': 'storage',
        'config': 'config',
        'status': 'status',
        'active_tasks_count': 'activeTasksCount',
        'nodes': 'nodes',
        'is_node_customization_deprecated': 'isNodeCustomizationDeprecated',
        'warnings': 'warnings',
        'errors': 'errors'
    }

    def __init__(self, clone_mode=None, cpu=None, id=None, labels=None, memory=None, name=None, networks=None, placement_params=None, replica=None, storage=None, config=None, status=None, active_tasks_count=None, nodes=None, is_node_customization_deprecated=None, warnings=None, errors=None):  # noqa: E501
        """NodePool - a model defined in Swagger"""  # noqa: E501
        self._clone_mode = None
        self._cpu = None
        self._id = None
        self._labels = None
        self._memory = None
        self._name = None
        self._networks = None
        self._placement_params = None
        self._replica = None
        self._storage = None
        self._config = None
        self._status = None
        self._active_tasks_count = None
        self._nodes = None
        self._is_node_customization_deprecated = None
        self._warnings = None
        self._errors = None
        self.discriminator = None
        if clone_mode is not None:
            self.clone_mode = clone_mode
        self.cpu = cpu
        if id is not None:
            self.id = id
        self.labels = labels
        self.memory = memory
        self.name = name
        self.networks = networks
        self.placement_params = placement_params
        self.replica = replica
        self.storage = storage
        if config is not None:
            self.config = config
        if status is not None:
            self.status = status
        if active_tasks_count is not None:
            self.active_tasks_count = active_tasks_count
        if nodes is not None:
            self.nodes = nodes
        if is_node_customization_deprecated is not None:
            self.is_node_customization_deprecated = is_node_customization_deprecated
        if warnings is not None:
            self.warnings = warnings
        if errors is not None:
            self.errors = errors

    @property
    def clone_mode(self):
        """Gets the clone_mode of this NodePool.  # noqa: E501

        Key to indicate the use of linked cloning feature for cloning the VMs. If set to linkedClone, then linked cloning will be used.  # noqa: E501

        :return: The clone_mode of this NodePool.  # noqa: E501
        :rtype: str
        """
        return self._clone_mode

    @clone_mode.setter
    def clone_mode(self, clone_mode):
        """Sets the clone_mode of this NodePool.

        Key to indicate the use of linked cloning feature for cloning the VMs. If set to linkedClone, then linked cloning will be used.  # noqa: E501

        :param clone_mode: The clone_mode of this NodePool.  # noqa: E501
        :type: str
        """
        allowed_values = ["fullClone", "linkedClone"]  # noqa: E501
        if clone_mode is not None and clone_mode not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `clone_mode` ({0}), must be one of {1}"  # noqa: E501
                .format(clone_mode, allowed_values)
            )

        self._clone_mode = clone_mode

    @property
    def cpu(self):
        """Gets the cpu of this NodePool.  # noqa: E501

        Number of virtual CPUs for worker nodes.  # noqa: E501

        :return: The cpu of this NodePool.  # noqa: E501
        :rtype: int
        """
        return self._cpu

    @cpu.setter
    def cpu(self, cpu):
        """Sets the cpu of this NodePool.

        Number of virtual CPUs for worker nodes.  # noqa: E501

        :param cpu: The cpu of this NodePool.  # noqa: E501
        :type: int
        """
        if cpu is None:
            print("WARNING: Invalid value for the required field `cpu`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `cpu`, must not be `None`")  # noqa: E501

        self._cpu = cpu

    @property
    def id(self):
        """Gets the id of this NodePool.  # noqa: E501


        :return: The id of this NodePool.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this NodePool.


        :param id: The id of this NodePool.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def labels(self):
        """Gets the labels of this NodePool.  # noqa: E501

        These labels are attached to the nodes. You can use these labels as node selectors when instantiating a network function.  # noqa: E501

        :return: The labels of this NodePool.  # noqa: E501
        :rtype: list[str]
        """
        return self._labels

    @labels.setter
    def labels(self, labels):
        """Sets the labels of this NodePool.

        These labels are attached to the nodes. You can use these labels as node selectors when instantiating a network function.  # noqa: E501

        :param labels: The labels of this NodePool.  # noqa: E501
        :type: list[str]
        """
        if labels is None:
            print("WARNING: Invalid value for the required field `labels`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `labels`, must not be `None`")  # noqa: E501

        self._labels = labels

    @property
    def memory(self):
        """Gets the memory of this NodePool.  # noqa: E501

        Memory size in MB for worker nodes.  # noqa: E501

        :return: The memory of this NodePool.  # noqa: E501
        :rtype: int
        """
        return self._memory

    @memory.setter
    def memory(self, memory):
        """Sets the memory of this NodePool.

        Memory size in MB for worker nodes.  # noqa: E501

        :param memory: The memory of this NodePool.  # noqa: E501
        :type: int
        """
        if memory is None:
            print("WARNING: Invalid value for the required field `memory`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `memory`, must not be `None`")  # noqa: E501

        self._memory = memory

    @property
    def name(self):
        """Gets the name of this NodePool.  # noqa: E501


        :return: The name of this NodePool.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this NodePool.


        :param name: The name of this NodePool.  # noqa: E501
        :type: str
        """
        if name is None:
            print("WARNING: Invalid value for the required field `name`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def networks(self):
        """Gets the networks of this NodePool.  # noqa: E501

        Network labels for worker nodes. These labels are used for providing network inputs during a cluster deployment. The Management interface label is mandatory.  # noqa: E501

        :return: The networks of this NodePool.  # noqa: E501
        :rtype: list[NodePoolNetworks]
        """
        return self._networks

    @networks.setter
    def networks(self, networks):
        """Sets the networks of this NodePool.

        Network labels for worker nodes. These labels are used for providing network inputs during a cluster deployment. The Management interface label is mandatory.  # noqa: E501

        :param networks: The networks of this NodePool.  # noqa: E501
        :type: list[NodePoolNetworks]
        """
        if networks is None:
            print("WARNING: Invalid value for the required field `networks`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `networks`, must not be `None`")  # noqa: E501

        self._networks = networks

    @property
    def placement_params(self):
        """Gets the placement_params of this NodePool.  # noqa: E501


        :return: The placement_params of this NodePool.  # noqa: E501
        :rtype: list[ClusterRequestPlacementParams]
        """
        return self._placement_params

    @placement_params.setter
    def placement_params(self, placement_params):
        """Sets the placement_params of this NodePool.


        :param placement_params: The placement_params of this NodePool.  # noqa: E501
        :type: list[ClusterRequestPlacementParams]
        """
        if placement_params is None:
            print("WARNING: Invalid value for the required field `placement_params`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `placement_params`, must not be `None`")  # noqa: E501

        self._placement_params = placement_params

    @property
    def replica(self):
        """Gets the replica of this NodePool.  # noqa: E501

        Replica count for worker nodes.  # noqa: E501

        :return: The replica of this NodePool.  # noqa: E501
        :rtype: int
        """
        return self._replica

    @replica.setter
    def replica(self, replica):
        """Sets the replica of this NodePool.

        Replica count for worker nodes.  # noqa: E501

        :param replica: The replica of this NodePool.  # noqa: E501
        :type: int
        """
        if replica is None:
            print("WARNING: Invalid value for the required field `replica`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `replica`, must not be `None`")  # noqa: E501

        self._replica = replica

    @property
    def storage(self):
        """Gets the storage of this NodePool.  # noqa: E501

        Disk size in GB for worker nodes.  # noqa: E501

        :return: The storage of this NodePool.  # noqa: E501
        :rtype: int
        """
        return self._storage

    @storage.setter
    def storage(self, storage):
        """Sets the storage of this NodePool.

        Disk size in GB for worker nodes.  # noqa: E501

        :param storage: The storage of this NodePool.  # noqa: E501
        :type: int
        """
        if storage is None:
            print("WARNING: Invalid value for the required field `storage`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `storage`, must not be `None`")  # noqa: E501

        self._storage = storage

    @property
    def config(self):
        """Gets the config of this NodePool.  # noqa: E501


        :return: The config of this NodePool.  # noqa: E501
        :rtype: NodePoolConfig
        """
        return self._config

    @config.setter
    def config(self, config):
        """Sets the config of this NodePool.


        :param config: The config of this NodePool.  # noqa: E501
        :type: NodePoolConfig
        """

        self._config = config

    @property
    def status(self):
        """Gets the status of this NodePool.  # noqa: E501


        :return: The status of this NodePool.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this NodePool.


        :param status: The status of this NodePool.  # noqa: E501
        :type: str
        """

        self._status = status

    @property
    def active_tasks_count(self):
        """Gets the active_tasks_count of this NodePool.  # noqa: E501

        Number of operations in processing or queued state on the node pool  # noqa: E501

        :return: The active_tasks_count of this NodePool.  # noqa: E501
        :rtype: int
        """
        return self._active_tasks_count

    @active_tasks_count.setter
    def active_tasks_count(self, active_tasks_count):
        """Sets the active_tasks_count of this NodePool.

        Number of operations in processing or queued state on the node pool  # noqa: E501

        :param active_tasks_count: The active_tasks_count of this NodePool.  # noqa: E501
        :type: int
        """

        self._active_tasks_count = active_tasks_count

    @property
    def nodes(self):
        """Gets the nodes of this NodePool.  # noqa: E501


        :return: The nodes of this NodePool.  # noqa: E501
        :rtype: list[ClusterNodes]
        """
        return self._nodes

    @nodes.setter
    def nodes(self, nodes):
        """Sets the nodes of this NodePool.


        :param nodes: The nodes of this NodePool.  # noqa: E501
        :type: list[ClusterNodes]
        """

        self._nodes = nodes

    @property
    def is_node_customization_deprecated(self):
        """Gets the is_node_customization_deprecated of this NodePool.  # noqa: E501


        :return: The is_node_customization_deprecated of this NodePool.  # noqa: E501
        :rtype: bool
        """
        return self._is_node_customization_deprecated

    @is_node_customization_deprecated.setter
    def is_node_customization_deprecated(self, is_node_customization_deprecated):
        """Sets the is_node_customization_deprecated of this NodePool.


        :param is_node_customization_deprecated: The is_node_customization_deprecated of this NodePool.  # noqa: E501
        :type: bool
        """

        self._is_node_customization_deprecated = is_node_customization_deprecated

    @property
    def warnings(self):
        """Gets the warnings of this NodePool.  # noqa: E501


        :return: The warnings of this NodePool.  # noqa: E501
        :rtype: list[ClusterWarnings]
        """
        return self._warnings

    @warnings.setter
    def warnings(self, warnings):
        """Sets the warnings of this NodePool.


        :param warnings: The warnings of this NodePool.  # noqa: E501
        :type: list[ClusterWarnings]
        """

        self._warnings = warnings

    @property
    def errors(self):
        """Gets the errors of this NodePool.  # noqa: E501


        :return: The errors of this NodePool.  # noqa: E501
        :rtype: list[ClusterWarnings]
        """
        return self._errors

    @errors.setter
    def errors(self, errors):
        """Sets the errors of this NodePool.


        :param errors: The errors of this NodePool.  # noqa: E501
        :type: list[ClusterWarnings]
        """

        self._errors = errors

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NodePool, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NodePool):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
