# coding: utf-8

"""
    SOL005 - NSD Management Interface

    SOL005 - NSD Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from tca.nsdm.api_client import ApiClient
from tca.api.tca_api import TCAApi

class DefaultApi(TCAApi):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_nsd_version_info(self, version, **kwargs):  # noqa: E501
        """Retrieve API version information  # noqa: E501

        The GET method reads API version information. This method shall follow the provisions specified in table 4.6.3.3.3.2-1 for request and response data structures, and response codes. URI query parameters are not supported.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_nsd_version_info(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)


        :return: ApiVersionInformation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_nsd_version_info_with_http_info(version, **kwargs)  # noqa: E501
        else:
            (data) = self.get_nsd_version_info_with_http_info(version, **kwargs)  # noqa: E501
            return data

    def get_nsd_version_info_with_http_info(self, version, **kwargs):  # noqa: E501
        """Retrieve API version information  # noqa: E501

        The GET method reads API version information. This method shall follow the provisions specified in table 4.6.3.3.3.2-1 for request and response data structures, and response codes. URI query parameters are not supported.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_nsd_version_info_with_http_info(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)


        :return: ApiVersionInformation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_nsd_version_info" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `get_nsd_version_info`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/api_versions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiVersionInformation',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def ns_descriptors_get(self, version, accept, **kwargs):  # noqa: E501
        """Query information about multiple NS descriptor resources.  # noqa: E501

        The GET method queries information about multiple NS descriptor resources.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_descriptors_get(version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV-SOL 013. The NFVO shall support receiving this filtering parameter as part of the URI query string. The OSS/BSS may supply this parameter. All attribute names that appear in the NsdInfo and in data types referenced from it shall be supported by the NFVO in the filter expression. 
        :param str all_fields: Include all complex attributes in the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The NFVO shall support this parameter. 
        :param str fields: Complex attributes to be included into the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The NFVO should support this parameter. 
        :param str exclude_fields: Complex attributes to be excluded from the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The NFVO should support this parameter. 
        :param str exclude_default: Indicates to exclude the following complex attributes from the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The VNFM shall support this parameter. The following attributes shall be excluded from the NsdInfo structure in the response body if this parameter is provided, or none of the parameters \"all_fields,\" \"fields\", \"exclude_fields\", \"exclude_default\" are provided:   - userDefinedData   - onboardingFailureDetails 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the NFVO if the NFVO supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV-SOL 013 for this resource. 


        :return: list[NsdInfo]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.ns_descriptors_get_with_http_info(version, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.ns_descriptors_get_with_http_info(version, accept, **kwargs)  # noqa: E501
            return data

    def ns_descriptors_get_with_http_info(self, version, accept, **kwargs):  # noqa: E501
        """Query information about multiple NS descriptor resources.  # noqa: E501

        The GET method queries information about multiple NS descriptor resources.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_descriptors_get_with_http_info(version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV-SOL 013. The NFVO shall support receiving this filtering parameter as part of the URI query string. The OSS/BSS may supply this parameter. All attribute names that appear in the NsdInfo and in data types referenced from it shall be supported by the NFVO in the filter expression. 
        :param str all_fields: Include all complex attributes in the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The NFVO shall support this parameter. 
        :param str fields: Complex attributes to be included into the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The NFVO should support this parameter. 
        :param str exclude_fields: Complex attributes to be excluded from the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The NFVO should support this parameter. 
        :param str exclude_default: Indicates to exclude the following complex attributes from the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The VNFM shall support this parameter. The following attributes shall be excluded from the NsdInfo structure in the response body if this parameter is provided, or none of the parameters \"all_fields,\" \"fields\", \"exclude_fields\", \"exclude_default\" are provided:   - userDefinedData   - onboardingFailureDetails 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the NFVO if the NFVO supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV-SOL 013 for this resource. 


        :return: list[NsdInfo]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version', 'accept', 'authorization', 'filter', 'all_fields', 'fields', 'exclude_fields', 'exclude_default', 'nextpage_opaque_marker']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ns_descriptors_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `ns_descriptors_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `ns_descriptors_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'all_fields' in params:
            query_params.append(('all_fields', params['all_fields']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
        if 'exclude_fields' in params:
            query_params.append(('exclude_fields', params['exclude_fields']))  # noqa: E501
        if 'exclude_default' in params:
            query_params.append(('exclude_default', params['exclude_default']))  # noqa: E501
        if 'nextpage_opaque_marker' in params:
            query_params.append(('nextpage_opaque_marker', params['nextpage_opaque_marker']))  # noqa: E501

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_descriptors', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[NsdInfo]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def ns_descriptors_nsd_info_id_delete(self, nsd_info_id, version, **kwargs):  # noqa: E501
        """Delete an individual NS descriptor resource.  # noqa: E501

        The DELETE method deletes an individual NS descriptor resource. An individual NS descriptor resource can only be deleted when there is no NS instance using it (i.e. usageState = NOT_IN_USE) and has been disabled already (i.e. operationalState = DISABLED). Otherwise, the DELETE method shall fail.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_descriptors_nsd_info_id_delete(nsd_info_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str nsd_info_id: Identifier of the individual NS descriptor resource.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.ns_descriptors_nsd_info_id_delete_with_http_info(nsd_info_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.ns_descriptors_nsd_info_id_delete_with_http_info(nsd_info_id, version, **kwargs)  # noqa: E501
            return data

    def ns_descriptors_nsd_info_id_delete_with_http_info(self, nsd_info_id, version, **kwargs):  # noqa: E501
        """Delete an individual NS descriptor resource.  # noqa: E501

        The DELETE method deletes an individual NS descriptor resource. An individual NS descriptor resource can only be deleted when there is no NS instance using it (i.e. usageState = NOT_IN_USE) and has been disabled already (i.e. operationalState = DISABLED). Otherwise, the DELETE method shall fail.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_descriptors_nsd_info_id_delete_with_http_info(nsd_info_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str nsd_info_id: Identifier of the individual NS descriptor resource.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['nsd_info_id', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ns_descriptors_nsd_info_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'nsd_info_id' is set
        if ('nsd_info_id' not in params or
                params['nsd_info_id'] is None):
            raise ValueError("Missing the required parameter `nsd_info_id` when calling `ns_descriptors_nsd_info_id_delete`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `ns_descriptors_nsd_info_id_delete`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'nsd_info_id' in params:
            path_params['nsdInfoId'] = params['nsd_info_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_descriptors/{nsdInfoId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def ns_descriptors_nsd_info_id_get(self, nsd_info_id, version, accept, **kwargs):  # noqa: E501
        """Read information about an individual NS descriptor resource.  # noqa: E501

        The GET method reads information about an individual NS descriptor.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_descriptors_nsd_info_id_get(nsd_info_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str nsd_info_id: Identifier of the individual NS descriptor resource.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: NsdInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.ns_descriptors_nsd_info_id_get_with_http_info(nsd_info_id, version, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.ns_descriptors_nsd_info_id_get_with_http_info(nsd_info_id, version, accept, **kwargs)  # noqa: E501
            return data

    def ns_descriptors_nsd_info_id_get_with_http_info(self, nsd_info_id, version, accept, **kwargs):  # noqa: E501
        """Read information about an individual NS descriptor resource.  # noqa: E501

        The GET method reads information about an individual NS descriptor.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_descriptors_nsd_info_id_get_with_http_info(nsd_info_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str nsd_info_id: Identifier of the individual NS descriptor resource.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: NsdInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['nsd_info_id', 'version', 'accept', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ns_descriptors_nsd_info_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'nsd_info_id' is set
        if ('nsd_info_id' not in params or
                params['nsd_info_id'] is None):
            raise ValueError("Missing the required parameter `nsd_info_id` when calling `ns_descriptors_nsd_info_id_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `ns_descriptors_nsd_info_id_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `ns_descriptors_nsd_info_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'nsd_info_id' in params:
            path_params['nsdInfoId'] = params['nsd_info_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_descriptors/{nsdInfoId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NsdInfo',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def ns_descriptors_nsd_info_id_manifest_get(self, nsd_info_id, version, accept, **kwargs):  # noqa: E501
        """Fetch the content of the manifest in an NSD archive.  # noqa: E501

        The GET method reads the content of the manifest file within an NSD archive. This method shall follow the provisions specified in the Tables 5.4.4b.3.2-1 and 5.4.4b.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_descriptors_nsd_info_id_manifest_get(nsd_info_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str nsd_info_id: Identifier of the individual NS descriptor. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new NS descriptor resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str include_signatures: If this parameter is provided, the NFVO shall return the manifest and related security information (signature and certificate) either in a single text file if the signature and certificate are included in the manifest file, or in a zip file containing the manifest and the certificate file, if this is provided as a separate file in the NSD archive. If this parameter is not given, the NFVO shall provide only a copy of the manifest file, as onboarded. If the security information is included in the onboarded manifest, it shall also be included in the returned copy. This URI query parameter is a flag, i.e. it shall have no value. The NFVO shall support this parameter. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.ns_descriptors_nsd_info_id_manifest_get_with_http_info(nsd_info_id, version, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.ns_descriptors_nsd_info_id_manifest_get_with_http_info(nsd_info_id, version, accept, **kwargs)  # noqa: E501
            return data

    def ns_descriptors_nsd_info_id_manifest_get_with_http_info(self, nsd_info_id, version, accept, **kwargs):  # noqa: E501
        """Fetch the content of the manifest in an NSD archive.  # noqa: E501

        The GET method reads the content of the manifest file within an NSD archive. This method shall follow the provisions specified in the Tables 5.4.4b.3.2-1 and 5.4.4b.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_descriptors_nsd_info_id_manifest_get_with_http_info(nsd_info_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str nsd_info_id: Identifier of the individual NS descriptor. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new NS descriptor resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str include_signatures: If this parameter is provided, the NFVO shall return the manifest and related security information (signature and certificate) either in a single text file if the signature and certificate are included in the manifest file, or in a zip file containing the manifest and the certificate file, if this is provided as a separate file in the NSD archive. If this parameter is not given, the NFVO shall provide only a copy of the manifest file, as onboarded. If the security information is included in the onboarded manifest, it shall also be included in the returned copy. This URI query parameter is a flag, i.e. it shall have no value. The NFVO shall support this parameter. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['nsd_info_id', 'version', 'accept', 'authorization', 'include_signatures']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ns_descriptors_nsd_info_id_manifest_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'nsd_info_id' is set
        if ('nsd_info_id' not in params or
                params['nsd_info_id'] is None):
            raise ValueError("Missing the required parameter `nsd_info_id` when calling `ns_descriptors_nsd_info_id_manifest_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `ns_descriptors_nsd_info_id_manifest_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `ns_descriptors_nsd_info_id_manifest_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'nsd_info_id' in params:
            path_params['nsdInfoId'] = params['nsd_info_id']  # noqa: E501

        query_params = []
        if 'include_signatures' in params:
            query_params.append(('include_signatures', params['include_signatures']))  # noqa: E501

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_descriptors/{nsdInfoId}/manifest', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def ns_descriptors_nsd_info_id_nsd_content_get(self, nsd_info_id, version, accept, **kwargs):  # noqa: E501
        """Fetch the content of a NSD.  # noqa: E501

        The GET method fetches the content of the NSD archive. The NSD archive is implemented as a single zip file. The content of the NSD archive is provided as onboarded, i.e. depending on the security option used, the CSAR wrapped in a ZIP archive together with an external signature is returned, as defined in clause 5.1 of ETSI GS NFV-SOL 007. NOTE: Information about the applicable security option can be         obtained by evaluating the \"archiveSecurityOption\"         attribute in the \"nsdInfo\" structure.  This method shall follow the provisions specified in the T ables 5.4.4.3.2-1 and 5.4.4.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_descriptors_nsd_info_id_nsd_content_get(nsd_info_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str nsd_info_id: (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str content_type: Content-Types that are supplied in the request. 
        :param str range: The request may contain a \"Range\" HTTP header to obtain single range of bytes from the NSD archive. This can be used to continue an aborted transmission. If the Range header is present in the request and the NFVO does not support responding to range requests with a 206 response, it shall return a 200 OK response instead as defined below. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.ns_descriptors_nsd_info_id_nsd_content_get_with_http_info(nsd_info_id, version, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.ns_descriptors_nsd_info_id_nsd_content_get_with_http_info(nsd_info_id, version, accept, **kwargs)  # noqa: E501
            return data

    def ns_descriptors_nsd_info_id_nsd_content_get_with_http_info(self, nsd_info_id, version, accept, **kwargs):  # noqa: E501
        """Fetch the content of a NSD.  # noqa: E501

        The GET method fetches the content of the NSD archive. The NSD archive is implemented as a single zip file. The content of the NSD archive is provided as onboarded, i.e. depending on the security option used, the CSAR wrapped in a ZIP archive together with an external signature is returned, as defined in clause 5.1 of ETSI GS NFV-SOL 007. NOTE: Information about the applicable security option can be         obtained by evaluating the \"archiveSecurityOption\"         attribute in the \"nsdInfo\" structure.  This method shall follow the provisions specified in the T ables 5.4.4.3.2-1 and 5.4.4.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_descriptors_nsd_info_id_nsd_content_get_with_http_info(nsd_info_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str nsd_info_id: (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str content_type: Content-Types that are supplied in the request. 
        :param str range: The request may contain a \"Range\" HTTP header to obtain single range of bytes from the NSD archive. This can be used to continue an aborted transmission. If the Range header is present in the request and the NFVO does not support responding to range requests with a 206 response, it shall return a 200 OK response instead as defined below. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['nsd_info_id', 'version', 'accept', 'authorization', 'content_type', 'range']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ns_descriptors_nsd_info_id_nsd_content_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'nsd_info_id' is set
        if ('nsd_info_id' not in params or
                params['nsd_info_id'] is None):
            raise ValueError("Missing the required parameter `nsd_info_id` when calling `ns_descriptors_nsd_info_id_nsd_content_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `ns_descriptors_nsd_info_id_nsd_content_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `ns_descriptors_nsd_info_id_nsd_content_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'nsd_info_id' in params:
            path_params['nsdInfoId'] = params['nsd_info_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501
        if 'range' in params:
            header_params['Range'] = params['range']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_descriptors/{nsdInfoId}/nsd_content', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def ns_descriptors_nsd_info_id_nsd_content_put(self, version, content_type, nsd_info_id, **kwargs):  # noqa: E501
        """Upload the content of a NSD.  # noqa: E501

        The PUT method is used to upload the content of an NSD archive. The NSD to be uploaded is implemented as a single ZIP file as defined in clause 5.4.4.3.2. The \"Content-Type\" HTTP header in the PUT request shall be set to \"application/zip\". This method shall follow the provisions specified in the Tables 5.4.4.3.3-1 and 5.4.4.3.3-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_descriptors_nsd_info_id_nsd_content_put(version, content_type, nsd_info_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str content_type: The payload body contains a ZIP file that represents the NSD archive, as specified above. The request shall set the \"Content-Type\" HTTP header to \"application/zip\".  (required)
        :param str nsd_info_id: (required)
        :param str file:
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.ns_descriptors_nsd_info_id_nsd_content_put_with_http_info(version, content_type, nsd_info_id, **kwargs)  # noqa: E501
        else:
            (data) = self.ns_descriptors_nsd_info_id_nsd_content_put_with_http_info(version, content_type, nsd_info_id, **kwargs)  # noqa: E501
            return data

    def ns_descriptors_nsd_info_id_nsd_content_put_with_http_info(self, version, content_type, nsd_info_id, **kwargs):  # noqa: E501
        """Upload the content of a NSD.  # noqa: E501

        The PUT method is used to upload the content of an NSD archive. The NSD to be uploaded is implemented as a single ZIP file as defined in clause 5.4.4.3.2. The \"Content-Type\" HTTP header in the PUT request shall be set to \"application/zip\". This method shall follow the provisions specified in the Tables 5.4.4.3.3-1 and 5.4.4.3.3-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_descriptors_nsd_info_id_nsd_content_put_with_http_info(version, content_type, nsd_info_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str content_type: The payload body contains a ZIP file that represents the NSD archive, as specified above. The request shall set the \"Content-Type\" HTTP header to \"application/zip\".  (required)
        :param str nsd_info_id: (required)
        :param str file:
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version', 'content_type', 'nsd_info_id', 'file', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ns_descriptors_nsd_info_id_nsd_content_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `ns_descriptors_nsd_info_id_nsd_content_put`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `ns_descriptors_nsd_info_id_nsd_content_put`")  # noqa: E501
        # verify the required parameter 'nsd_info_id' is set
        if ('nsd_info_id' not in params or
                params['nsd_info_id'] is None):
            raise ValueError("Missing the required parameter `nsd_info_id` when calling `ns_descriptors_nsd_info_id_nsd_content_put`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'nsd_info_id' in params:
            path_params['nsdInfoId'] = params['nsd_info_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}
        if 'file' in params:
            local_var_files['file'] = params['file']  # noqa: E501

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['multipart/form-data'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_descriptors/{nsdInfoId}/nsd_content', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def ns_descriptors_nsd_info_id_nsd_get(self, nsd_info_id, version, accept, **kwargs):  # noqa: E501
        """ns_descriptors_nsd_info_id_nsd_get  # noqa: E501

        The GET method reads the content of the NSD within an NSD archive. The NSD can be implemented as a single file or as a collection of multiple files. If the NSD is implemented in the form of multiple files, a ZIP file embedding these files shall be returned. If the NSD is implemented as a single file, either that file or a ZIP file embedding that file shall be returned. The selection of the format is controlled by the \"Accept\" HTTP header passed in the GET request:  * If the \"Accept\" header contains only \"text/plain\" and the NSD is implemented as a single file,     the file shall be returned; otherwise, an error message shall be returned.  * If the \"Accept\" header contains only \"application/zip\", the single file or     the multiple files that make up the NSD shall be returned embedded in a ZIP file.  * If the \"Accept\" header contains both \"text/plain\" and \"application/zip\", it is up     to the NFVO to choose the format to return for a single-file NSD; for a multi-file NSD,     a ZIP file shall be returned. The default format of the ZIP file shall be the one specified in ETSI GS NFV-SOL 007 where only the YAML files representing the NSD, and information necessary to navigate the ZIP file and to identify the file that is the entry point for parsing the NSD and (if requested) further security information are included. This means that the content of the ZIP archive shall contain the following files from the NSD archive:  * TOSCA.meta (if available in the NSD archive);  * the main service template (either as referenced from TOSCA.meta or available as a     file with the extension \".yml\" or \".yaml\" from the root of the archive);  * every component of the NSD referenced (recursively) from the main service template;  * the related security information, if the \"include_signatures\" URI parameter is provided, as follows: - the manifest file; - the singleton certificate file in the root of the NSD archive (if available in the NSD archive); - the signing certificates of the individual files included in the ZIP archive     (if available in the NSD archive); - the signatures of the individual files (if available in the NSD archive). This method shall follow the provisions specified in the Tables 5.4.4a.3.2-1 and 5.4.4a.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_descriptors_nsd_info_id_nsd_get(nsd_info_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str nsd_info_id: (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: The request shall contain the appropriate entries in the \"Accept\" HTTP header as defined above.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str include_signatures: If this parameter is provided, the NFVO shall include in the ZIP file the security information as specified above. This URI query parameter is a flag, i.e. it shall have no value. The NFVO shall support this parameter. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.ns_descriptors_nsd_info_id_nsd_get_with_http_info(nsd_info_id, version, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.ns_descriptors_nsd_info_id_nsd_get_with_http_info(nsd_info_id, version, accept, **kwargs)  # noqa: E501
            return data

    def ns_descriptors_nsd_info_id_nsd_get_with_http_info(self, nsd_info_id, version, accept, **kwargs):  # noqa: E501
        """ns_descriptors_nsd_info_id_nsd_get  # noqa: E501

        The GET method reads the content of the NSD within an NSD archive. The NSD can be implemented as a single file or as a collection of multiple files. If the NSD is implemented in the form of multiple files, a ZIP file embedding these files shall be returned. If the NSD is implemented as a single file, either that file or a ZIP file embedding that file shall be returned. The selection of the format is controlled by the \"Accept\" HTTP header passed in the GET request:  * If the \"Accept\" header contains only \"text/plain\" and the NSD is implemented as a single file,     the file shall be returned; otherwise, an error message shall be returned.  * If the \"Accept\" header contains only \"application/zip\", the single file or     the multiple files that make up the NSD shall be returned embedded in a ZIP file.  * If the \"Accept\" header contains both \"text/plain\" and \"application/zip\", it is up     to the NFVO to choose the format to return for a single-file NSD; for a multi-file NSD,     a ZIP file shall be returned. The default format of the ZIP file shall be the one specified in ETSI GS NFV-SOL 007 where only the YAML files representing the NSD, and information necessary to navigate the ZIP file and to identify the file that is the entry point for parsing the NSD and (if requested) further security information are included. This means that the content of the ZIP archive shall contain the following files from the NSD archive:  * TOSCA.meta (if available in the NSD archive);  * the main service template (either as referenced from TOSCA.meta or available as a     file with the extension \".yml\" or \".yaml\" from the root of the archive);  * every component of the NSD referenced (recursively) from the main service template;  * the related security information, if the \"include_signatures\" URI parameter is provided, as follows: - the manifest file; - the singleton certificate file in the root of the NSD archive (if available in the NSD archive); - the signing certificates of the individual files included in the ZIP archive     (if available in the NSD archive); - the signatures of the individual files (if available in the NSD archive). This method shall follow the provisions specified in the Tables 5.4.4a.3.2-1 and 5.4.4a.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_descriptors_nsd_info_id_nsd_get_with_http_info(nsd_info_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str nsd_info_id: (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: The request shall contain the appropriate entries in the \"Accept\" HTTP header as defined above.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str include_signatures: If this parameter is provided, the NFVO shall include in the ZIP file the security information as specified above. This URI query parameter is a flag, i.e. it shall have no value. The NFVO shall support this parameter. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['nsd_info_id', 'version', 'accept', 'authorization', 'include_signatures']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ns_descriptors_nsd_info_id_nsd_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'nsd_info_id' is set
        if ('nsd_info_id' not in params or
                params['nsd_info_id'] is None):
            raise ValueError("Missing the required parameter `nsd_info_id` when calling `ns_descriptors_nsd_info_id_nsd_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `ns_descriptors_nsd_info_id_nsd_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `ns_descriptors_nsd_info_id_nsd_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'nsd_info_id' in params:
            path_params['nsdInfoId'] = params['nsd_info_id']  # noqa: E501

        query_params = []
        if 'include_signatures' in params:
            query_params.append(('include_signatures', params['include_signatures']))  # noqa: E501

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_descriptors/{nsdInfoId}/nsd', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def ns_descriptors_nsd_info_id_patch(self, body, version, content_type, nsd_info_id, **kwargs):  # noqa: E501
        """Modify the operational state and/or the user defined data of an individual NS descriptor resource.  # noqa: E501

        The PATCH method modifies the operational state and/or user defined data of an individual NS descriptor resource. This method can be used to: 1) Enable a previously disabled individual NS descriptor resource, allowing again its use for instantiation of new network service with this descriptor. The usage state (i.e. \"IN_USE/NOT_IN_USE\") shall not change as a result. 2) Disable a previously enabled individual NS descriptor resource, preventing any further use for instantiation of new network service(s) with this descriptor. The usage state (i.e. \"IN_USE/NOT_IN_USE\") shall not change as a result. 3) Modify the user defined data of an individual NS descriptor resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_descriptors_nsd_info_id_patch(body, version, content_type, nsd_info_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NsdInfoModifications body: (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231.  (required)
        :param str nsd_info_id: Identifier of the individual NS descriptor resource.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: NsdInfoModifications
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.ns_descriptors_nsd_info_id_patch_with_http_info(body, version, content_type, nsd_info_id, **kwargs)  # noqa: E501
        else:
            (data) = self.ns_descriptors_nsd_info_id_patch_with_http_info(body, version, content_type, nsd_info_id, **kwargs)  # noqa: E501
            return data

    def ns_descriptors_nsd_info_id_patch_with_http_info(self, body, version, content_type, nsd_info_id, **kwargs):  # noqa: E501
        """Modify the operational state and/or the user defined data of an individual NS descriptor resource.  # noqa: E501

        The PATCH method modifies the operational state and/or user defined data of an individual NS descriptor resource. This method can be used to: 1) Enable a previously disabled individual NS descriptor resource, allowing again its use for instantiation of new network service with this descriptor. The usage state (i.e. \"IN_USE/NOT_IN_USE\") shall not change as a result. 2) Disable a previously enabled individual NS descriptor resource, preventing any further use for instantiation of new network service(s) with this descriptor. The usage state (i.e. \"IN_USE/NOT_IN_USE\") shall not change as a result. 3) Modify the user defined data of an individual NS descriptor resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_descriptors_nsd_info_id_patch_with_http_info(body, version, content_type, nsd_info_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NsdInfoModifications body: (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231.  (required)
        :param str nsd_info_id: Identifier of the individual NS descriptor resource.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: NsdInfoModifications
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'version', 'content_type', 'nsd_info_id', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ns_descriptors_nsd_info_id_patch" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `ns_descriptors_nsd_info_id_patch`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `ns_descriptors_nsd_info_id_patch`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `ns_descriptors_nsd_info_id_patch`")  # noqa: E501
        # verify the required parameter 'nsd_info_id' is set
        if ('nsd_info_id' not in params or
                params['nsd_info_id'] is None):
            raise ValueError("Missing the required parameter `nsd_info_id` when calling `ns_descriptors_nsd_info_id_patch`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'nsd_info_id' in params:
            path_params['nsdInfoId'] = params['nsd_info_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_descriptors/{nsdInfoId}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NsdInfoModifications',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def ns_descriptors_post(self, body, version, accept, content_type, **kwargs):  # noqa: E501
        """Create a new NS descriptor resource.  # noqa: E501

        The POST method is used to create a new NS descriptor resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_descriptors_post(body, version, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateNsdInfoRequest body: (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231.  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: NsdInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.ns_descriptors_post_with_http_info(body, version, accept, content_type, **kwargs)  # noqa: E501
        else:
            (data) = self.ns_descriptors_post_with_http_info(body, version, accept, content_type, **kwargs)  # noqa: E501
            return data

    def ns_descriptors_post_with_http_info(self, body, version, accept, content_type, **kwargs):  # noqa: E501
        """Create a new NS descriptor resource.  # noqa: E501

        The POST method is used to create a new NS descriptor resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_descriptors_post_with_http_info(body, version, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateNsdInfoRequest body: (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231.  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: NsdInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'version', 'accept', 'content_type', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ns_descriptors_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `ns_descriptors_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `ns_descriptors_post`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `ns_descriptors_post`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `ns_descriptors_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_descriptors', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NsdInfo',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def pnf_descriptors_get(self, version, **kwargs):  # noqa: E501
        """Query information about multiple PNF descriptor resources.  # noqa: E501

        \"The GET method queries information about multiple PNF descriptor resources.\"   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pnf_descriptors_get(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV-SOL 013. The NFVO shall support receiving this filtering parameter as part of the URI query string. The OSS/BSS may supply this parameter. All attribute names that appear in the PnfdInfo and in data types referenced from it shall be supported by the NFVO in the filter expression. 
        :param str all_fields: Include all complex attributes in the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The NFVO shall support this parameter. 
        :param str fields: Complex attributes to be included into the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The NFVO should support this parameter. 
        :param str exclude_fields: Complex attributes to be excluded from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The NFVO should support this parameter. 
        :param str exclude_default: Indicates to exclude the following complex attributes from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The NFVO shall support this parameter. The following attributes shall be excluded from the PnfdInfo structure in the response body if this parameter is provided, or none of the parameters \"all_fields,\" \"fields\", \"exclude_fields\", \"exclude_default\" are provided: - userDefinedData - onboardingFailureDetails 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the NFVO if the NFVO supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV SOL 013 for this resource. 


        :return: list[PnfdInfo]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.pnf_descriptors_get_with_http_info(version, **kwargs)  # noqa: E501
        else:
            (data) = self.pnf_descriptors_get_with_http_info(version, **kwargs)  # noqa: E501
            return data

    def pnf_descriptors_get_with_http_info(self, version, **kwargs):  # noqa: E501
        """Query information about multiple PNF descriptor resources.  # noqa: E501

        \"The GET method queries information about multiple PNF descriptor resources.\"   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pnf_descriptors_get_with_http_info(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV-SOL 013. The NFVO shall support receiving this filtering parameter as part of the URI query string. The OSS/BSS may supply this parameter. All attribute names that appear in the PnfdInfo and in data types referenced from it shall be supported by the NFVO in the filter expression. 
        :param str all_fields: Include all complex attributes in the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The NFVO shall support this parameter. 
        :param str fields: Complex attributes to be included into the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The NFVO should support this parameter. 
        :param str exclude_fields: Complex attributes to be excluded from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The NFVO should support this parameter. 
        :param str exclude_default: Indicates to exclude the following complex attributes from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The NFVO shall support this parameter. The following attributes shall be excluded from the PnfdInfo structure in the response body if this parameter is provided, or none of the parameters \"all_fields,\" \"fields\", \"exclude_fields\", \"exclude_default\" are provided: - userDefinedData - onboardingFailureDetails 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the NFVO if the NFVO supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV SOL 013 for this resource. 


        :return: list[PnfdInfo]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version', 'authorization', 'filter', 'all_fields', 'fields', 'exclude_fields', 'exclude_default', 'nextpage_opaque_marker']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method pnf_descriptors_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `pnf_descriptors_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'all_fields' in params:
            query_params.append(('all_fields', params['all_fields']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
        if 'exclude_fields' in params:
            query_params.append(('exclude_fields', params['exclude_fields']))  # noqa: E501
        if 'exclude_default' in params:
            query_params.append(('exclude_default', params['exclude_default']))  # noqa: E501
        if 'nextpage_opaque_marker' in params:
            query_params.append(('nextpage_opaque_marker', params['nextpage_opaque_marker']))  # noqa: E501

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/pnf_descriptors', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[PnfdInfo]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def pnf_descriptors_pnfd_info_id_delete(self, pnfd_info_id, **kwargs):  # noqa: E501
        """Delete an individual PNF descriptor resource.  # noqa: E501

        The DELETE method deletes an individual PNF descriptor resource. An individual PNF descriptor resource can only be deleted when t here is no NS instance using it or there is NSD referencing it. To delete all PNFD versions identified by a particular value of the \"pnfdInvariantId\" attribute, the procedure is to first use t he GET method with filter \"pnfdInvariantId\" towards the PNF descriptors resource to find all versions of the PNFD. Then, he API consumer uses the DELETE method described in this clause to delete each PNFD version individually. This method shall follow the provisions specified in the Tables 5.4.6.3.5-1 and 5.4.6.3.5-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pnf_descriptors_pnfd_info_id_delete(pnfd_info_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str pnfd_info_id: Identifier of the individual PNF descriptor resource.  (required)


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.pnf_descriptors_pnfd_info_id_delete_with_http_info(pnfd_info_id, **kwargs)  # noqa: E501
        else:
            (data) = self.pnf_descriptors_pnfd_info_id_delete_with_http_info(pnfd_info_id, **kwargs)  # noqa: E501
            return data

    def pnf_descriptors_pnfd_info_id_delete_with_http_info(self, pnfd_info_id, **kwargs):  # noqa: E501
        """Delete an individual PNF descriptor resource.  # noqa: E501

        The DELETE method deletes an individual PNF descriptor resource. An individual PNF descriptor resource can only be deleted when t here is no NS instance using it or there is NSD referencing it. To delete all PNFD versions identified by a particular value of the \"pnfdInvariantId\" attribute, the procedure is to first use t he GET method with filter \"pnfdInvariantId\" towards the PNF descriptors resource to find all versions of the PNFD. Then, he API consumer uses the DELETE method described in this clause to delete each PNFD version individually. This method shall follow the provisions specified in the Tables 5.4.6.3.5-1 and 5.4.6.3.5-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pnf_descriptors_pnfd_info_id_delete_with_http_info(pnfd_info_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str pnfd_info_id: Identifier of the individual PNF descriptor resource.  (required)


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['pnfd_info_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method pnf_descriptors_pnfd_info_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'pnfd_info_id' is set
        if ('pnfd_info_id' not in params or
                params['pnfd_info_id'] is None):
            raise ValueError("Missing the required parameter `pnfd_info_id` when calling `pnf_descriptors_pnfd_info_id_delete`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'pnfd_info_id' in params:
            path_params['pnfdInfoId'] = params['pnfd_info_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/pnf_descriptors/{pnfdInfoId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def pnf_descriptors_pnfd_info_id_get(self, pnfd_info_id, accept, version, **kwargs):  # noqa: E501
        """Read an individual PNFD resource.  # noqa: E501

        The GET method reads information about an individual PNF descriptor.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pnf_descriptors_pnfd_info_id_get(pnfd_info_id, accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str pnfd_info_id: Identifier of the individual PNF descriptor resource.  (required)
        :param str accept: Content-Types that are acceptable for the response. This header field shall be present if the response is expected to have a non-empty message body.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Details are specified in clause 4.5.3 of GS NFV-SOL 005. 


        :return: PnfdInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.pnf_descriptors_pnfd_info_id_get_with_http_info(pnfd_info_id, accept, version, **kwargs)  # noqa: E501
        else:
            (data) = self.pnf_descriptors_pnfd_info_id_get_with_http_info(pnfd_info_id, accept, version, **kwargs)  # noqa: E501
            return data

    def pnf_descriptors_pnfd_info_id_get_with_http_info(self, pnfd_info_id, accept, version, **kwargs):  # noqa: E501
        """Read an individual PNFD resource.  # noqa: E501

        The GET method reads information about an individual PNF descriptor.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pnf_descriptors_pnfd_info_id_get_with_http_info(pnfd_info_id, accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str pnfd_info_id: Identifier of the individual PNF descriptor resource.  (required)
        :param str accept: Content-Types that are acceptable for the response. This header field shall be present if the response is expected to have a non-empty message body.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Details are specified in clause 4.5.3 of GS NFV-SOL 005. 


        :return: PnfdInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['pnfd_info_id', 'accept', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method pnf_descriptors_pnfd_info_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'pnfd_info_id' is set
        if ('pnfd_info_id' not in params or
                params['pnfd_info_id'] is None):
            raise ValueError("Missing the required parameter `pnfd_info_id` when calling `pnf_descriptors_pnfd_info_id_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `pnf_descriptors_pnfd_info_id_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `pnf_descriptors_pnfd_info_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'pnfd_info_id' in params:
            path_params['pnfdInfoId'] = params['pnfd_info_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/pnf_descriptors/{pnfdInfoId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PnfdInfo',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def pnf_descriptors_pnfd_info_id_manifest_get(self, pnfd_info_id, version, accept, **kwargs):  # noqa: E501
        """pnf_descriptors_pnfd_info_id_manifest_get  # noqa: E501

        The GET method reads the content of the manifest file within a PNFD archive. This method shall follow the provisions specified in the Tables 5.4.7b.3.2-1 and 5.4.7b.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pnf_descriptors_pnfd_info_id_manifest_get(pnfd_info_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str pnfd_info_id: Identifier of the individual PNF descriptor. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new PNF descriptor resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param str include_signatures: If this parameter is provided, the NFVO shall return the manifest and related security information (signature and certificate) either in a single text file if the signature and certificate are included in the manifest file, or in a zip file containing the manifest and the certificate file, if this is provided as a separate file in the PNFD archive. If this parameter is not given, the NFVO shall provide only a copy of the manifest file, as onboarded. If the security information is included in the onboarded manifest, it shall also be included in the returned copy. This URI query parameter is a flag, i.e. it shall have no value. The NFVO shall support this parameter. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.pnf_descriptors_pnfd_info_id_manifest_get_with_http_info(pnfd_info_id, version, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.pnf_descriptors_pnfd_info_id_manifest_get_with_http_info(pnfd_info_id, version, accept, **kwargs)  # noqa: E501
            return data

    def pnf_descriptors_pnfd_info_id_manifest_get_with_http_info(self, pnfd_info_id, version, accept, **kwargs):  # noqa: E501
        """pnf_descriptors_pnfd_info_id_manifest_get  # noqa: E501

        The GET method reads the content of the manifest file within a PNFD archive. This method shall follow the provisions specified in the Tables 5.4.7b.3.2-1 and 5.4.7b.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pnf_descriptors_pnfd_info_id_manifest_get_with_http_info(pnfd_info_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str pnfd_info_id: Identifier of the individual PNF descriptor. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new PNF descriptor resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param str include_signatures: If this parameter is provided, the NFVO shall return the manifest and related security information (signature and certificate) either in a single text file if the signature and certificate are included in the manifest file, or in a zip file containing the manifest and the certificate file, if this is provided as a separate file in the PNFD archive. If this parameter is not given, the NFVO shall provide only a copy of the manifest file, as onboarded. If the security information is included in the onboarded manifest, it shall also be included in the returned copy. This URI query parameter is a flag, i.e. it shall have no value. The NFVO shall support this parameter. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['pnfd_info_id', 'version', 'accept', 'authorization', 'include_signatures']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method pnf_descriptors_pnfd_info_id_manifest_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'pnfd_info_id' is set
        if ('pnfd_info_id' not in params or
                params['pnfd_info_id'] is None):
            raise ValueError("Missing the required parameter `pnfd_info_id` when calling `pnf_descriptors_pnfd_info_id_manifest_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `pnf_descriptors_pnfd_info_id_manifest_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `pnf_descriptors_pnfd_info_id_manifest_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'pnfd_info_id' in params:
            path_params['pnfdInfoId'] = params['pnfd_info_id']  # noqa: E501

        query_params = []
        if 'include_signatures' in params:
            query_params.append(('include_signatures', params['include_signatures']))  # noqa: E501

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/pnf_descriptors/{pnfdInfoId}/manifest', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def pnf_descriptors_pnfd_info_id_patch(self, body, accept, content_type, pnfd_info_id, **kwargs):  # noqa: E501
        """Modify the user defined data of an individual PNF descriptor resource.  # noqa: E501

        The PATCH method modifies the user defined data of an individual PNF descriptor resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pnf_descriptors_pnfd_info_id_patch(body, accept, content_type, pnfd_info_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param PnfdInfoModifications body: (required)
        :param str accept: Content-Types that are acceptable for the response. This header field shall be present if the response is expected to have a non-empty message body.  (required)
        :param str content_type: The MIME type of the body of the request. This header field shall be present if the request has a non-empty message body.  (required)
        :param str pnfd_info_id: Identifier of the individual PNF descriptor resource.  (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: PnfdInfoModifications
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.pnf_descriptors_pnfd_info_id_patch_with_http_info(body, accept, content_type, pnfd_info_id, **kwargs)  # noqa: E501
        else:
            (data) = self.pnf_descriptors_pnfd_info_id_patch_with_http_info(body, accept, content_type, pnfd_info_id, **kwargs)  # noqa: E501
            return data

    def pnf_descriptors_pnfd_info_id_patch_with_http_info(self, body, accept, content_type, pnfd_info_id, **kwargs):  # noqa: E501
        """Modify the user defined data of an individual PNF descriptor resource.  # noqa: E501

        The PATCH method modifies the user defined data of an individual PNF descriptor resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pnf_descriptors_pnfd_info_id_patch_with_http_info(body, accept, content_type, pnfd_info_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param PnfdInfoModifications body: (required)
        :param str accept: Content-Types that are acceptable for the response. This header field shall be present if the response is expected to have a non-empty message body.  (required)
        :param str content_type: The MIME type of the body of the request. This header field shall be present if the request has a non-empty message body.  (required)
        :param str pnfd_info_id: Identifier of the individual PNF descriptor resource.  (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: PnfdInfoModifications
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type', 'pnfd_info_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method pnf_descriptors_pnfd_info_id_patch" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `pnf_descriptors_pnfd_info_id_patch`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `pnf_descriptors_pnfd_info_id_patch`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `pnf_descriptors_pnfd_info_id_patch`")  # noqa: E501
        # verify the required parameter 'pnfd_info_id' is set
        if ('pnfd_info_id' not in params or
                params['pnfd_info_id'] is None):
            raise ValueError("Missing the required parameter `pnfd_info_id` when calling `pnf_descriptors_pnfd_info_id_patch`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'pnfd_info_id' in params:
            path_params['pnfdInfoId'] = params['pnfd_info_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/pnf_descriptors/{pnfdInfoId}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PnfdInfoModifications',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def pnf_descriptors_pnfd_info_id_pnfd_content_get(self, pnfd_info_id, version, accept, **kwargs):  # noqa: E501
        """Fetch the content of a PNFD.  # noqa: E501

        The GET method fetches the content of the PNFD archive. The content of the PNFD archive is provided as onboarded, i.e. depending on the security option used, the CSAR or the CSAR wrapped in a ZIP archive together with an external signature is returned, as defined in clause 5.1 of ETSI GS NFV-SOL 004. NOTE: Information about the applicable security option can be obtained by evaluating the \"archiveSecurityOption\" attribute in the \"pnfdInfo\" structure. This method shall follow the provisions specified in the Tables 5.4.7.3.2-1 and 5.4.7.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pnf_descriptors_pnfd_info_id_pnfd_content_get(pnfd_info_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str pnfd_info_id: Identifier of the individual PNF descriptor. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new PNF descriptor resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param str range: The request may contain a \"Range\" HTTP header to obtain single range of bytes from the PNFD archive. This can be used to continue an aborted transmission. If the NFVO does not support range requests, the NFVO shall ignore the \"Range\" header, process the GET request, and return the whole PNFD archive with a 200 OK response (rather than returning a 4xx error status code). 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.pnf_descriptors_pnfd_info_id_pnfd_content_get_with_http_info(pnfd_info_id, version, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.pnf_descriptors_pnfd_info_id_pnfd_content_get_with_http_info(pnfd_info_id, version, accept, **kwargs)  # noqa: E501
            return data

    def pnf_descriptors_pnfd_info_id_pnfd_content_get_with_http_info(self, pnfd_info_id, version, accept, **kwargs):  # noqa: E501
        """Fetch the content of a PNFD.  # noqa: E501

        The GET method fetches the content of the PNFD archive. The content of the PNFD archive is provided as onboarded, i.e. depending on the security option used, the CSAR or the CSAR wrapped in a ZIP archive together with an external signature is returned, as defined in clause 5.1 of ETSI GS NFV-SOL 004. NOTE: Information about the applicable security option can be obtained by evaluating the \"archiveSecurityOption\" attribute in the \"pnfdInfo\" structure. This method shall follow the provisions specified in the Tables 5.4.7.3.2-1 and 5.4.7.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pnf_descriptors_pnfd_info_id_pnfd_content_get_with_http_info(pnfd_info_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str pnfd_info_id: Identifier of the individual PNF descriptor. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new PNF descriptor resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param str range: The request may contain a \"Range\" HTTP header to obtain single range of bytes from the PNFD archive. This can be used to continue an aborted transmission. If the NFVO does not support range requests, the NFVO shall ignore the \"Range\" header, process the GET request, and return the whole PNFD archive with a 200 OK response (rather than returning a 4xx error status code). 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['pnfd_info_id', 'version', 'accept', 'authorization', 'range']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method pnf_descriptors_pnfd_info_id_pnfd_content_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'pnfd_info_id' is set
        if ('pnfd_info_id' not in params or
                params['pnfd_info_id'] is None):
            raise ValueError("Missing the required parameter `pnfd_info_id` when calling `pnf_descriptors_pnfd_info_id_pnfd_content_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `pnf_descriptors_pnfd_info_id_pnfd_content_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `pnf_descriptors_pnfd_info_id_pnfd_content_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'pnfd_info_id' in params:
            path_params['pnfdInfoId'] = params['pnfd_info_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'range' in params:
            header_params['Range'] = params['range']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/pnf_descriptors/{pnfdInfoId}/pnfd_content', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def pnf_descriptors_pnfd_info_id_pnfd_content_put(self, version, content_type, pnfd_info_id, **kwargs):  # noqa: E501
        """Upload the content of a PNFD.  # noqa: E501

        The PUT method is used to upload the content of a PNFD archive. This resource represents the content of the individual PNF descriptor, i.e. PNFD content. The client can use this resource to upload and download the content of the PNFD.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pnf_descriptors_pnfd_info_id_pnfd_content_put(version, content_type, pnfd_info_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str content_type: The payload body contains a ZIP file that represents the NSD archive, as specified above. The request shall set the \"Content-Type\" HTTP header to \"application/zip\".  (required)
        :param str pnfd_info_id: Identifier of the individual PNF descriptor. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new PNF descriptor resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str file:
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.pnf_descriptors_pnfd_info_id_pnfd_content_put_with_http_info(version, content_type, pnfd_info_id, **kwargs)  # noqa: E501
        else:
            (data) = self.pnf_descriptors_pnfd_info_id_pnfd_content_put_with_http_info(version, content_type, pnfd_info_id, **kwargs)  # noqa: E501
            return data

    def pnf_descriptors_pnfd_info_id_pnfd_content_put_with_http_info(self, version, content_type, pnfd_info_id, **kwargs):  # noqa: E501
        """Upload the content of a PNFD.  # noqa: E501

        The PUT method is used to upload the content of a PNFD archive. This resource represents the content of the individual PNF descriptor, i.e. PNFD content. The client can use this resource to upload and download the content of the PNFD.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pnf_descriptors_pnfd_info_id_pnfd_content_put_with_http_info(version, content_type, pnfd_info_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str content_type: The payload body contains a ZIP file that represents the NSD archive, as specified above. The request shall set the \"Content-Type\" HTTP header to \"application/zip\".  (required)
        :param str pnfd_info_id: Identifier of the individual PNF descriptor. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new PNF descriptor resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str file:
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version', 'content_type', 'pnfd_info_id', 'file', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method pnf_descriptors_pnfd_info_id_pnfd_content_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `pnf_descriptors_pnfd_info_id_pnfd_content_put`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `pnf_descriptors_pnfd_info_id_pnfd_content_put`")  # noqa: E501
        # verify the required parameter 'pnfd_info_id' is set
        if ('pnfd_info_id' not in params or
                params['pnfd_info_id'] is None):
            raise ValueError("Missing the required parameter `pnfd_info_id` when calling `pnf_descriptors_pnfd_info_id_pnfd_content_put`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'pnfd_info_id' in params:
            path_params['pnfdInfoId'] = params['pnfd_info_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}
        if 'file' in params:
            local_var_files['file'] = params['file']  # noqa: E501

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['multipart/form-data'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/pnf_descriptors/{pnfdInfoId}/pnfd_content', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def pnf_descriptors_pnfd_info_id_pnfd_get(self, pnfd_info_id, version, accept, **kwargs):  # noqa: E501
        """pnf_descriptors_pnfd_info_id_pnfd_get  # noqa: E501

        The GET method reads the content of the PNFD within a PNFD archive. The PNFD can be implemented as a single file or as a collection of multiple files. If the PNFD is implemented in the form of multiple files, a ZIP file embedding these files shall be returned. If the PNFD is implemented as a single file, either that file or a ZIP file embedding that file shall be returned. The selection of the format is controlled by the \"Accept\" HTTP header passed in the GET request:  * If the \"Accept\" header contains only \"text/plain\" and the PNFD is     implemented as a single file, the file shall be returned; otherwise,     an error message shall be returned.  * If the \"Accept\" header contains only \"application/zip\", the single     file or the multiple files that make up the PNFD shall be returned     embedded in a ZIP file.  * If the \"Accept\" header contains both \"text/plain\" and \"application/zip\",     it is up to the NFVO to choose the format to return for a single-file PNFD;     for a multi-file PNFD, a ZIP file shall be returned. The default format of the ZIP file shall be the one specified in ETSI GS NFV-SOL 004 where only the YAML files representing the PNFD, and information necessary to navigate the ZIP file and to identify the file that is the entry point for parsing the PNFD and (if requested) further security information are included. This means that the content of the ZIP archive shall contain the following files from the PNFD archive:  * TOSCA.meta (if available in the PNFD archive);  * the main service template (either as referenced from TOSCA.meta or     available as a file with the extension \".yml\" or \".yaml\" from the     root of the archive);  * every component of the PNFD referenced (recursively) from the main     service template;  * the related security information, if the \"include_signatures\" URI     parameter is provided, as follows:     - the manifest file;     - the singleton certificate file in the root of the PNFD archive         (if available in the PNFD archive);     - the signing certificates of the individual files included in the         ZIP archive (if available in the PNFD archive);     - the signatures of the individual files (if available in the PNFD archive). This method shall follow the provisions specified in the Tables 5.4.7a.3.2-1 and 5.4.7a.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pnf_descriptors_pnfd_info_id_pnfd_get(pnfd_info_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str pnfd_info_id: Identifier of the individual PNF descriptor. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new PNF descriptor resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param str range: The request may contain a \"Range\" HTTP header to obtain single range of bytes from the PNFD archive. This can be used to continue an aborted transmission. If the NFVO does not support range requests, the NFVO shall ignore the \"Range\" header, process the GET request, and return the whole PNFD archive with a 200 OK response (rather than returning a 4xx error status code). 
        :param str include_signatures: If this parameter is provided, the NFVO shall include in the ZIP file the security information as specified above. This URI query parameter is a flag, i.e. it shall have no value. The NFVO shall support this parameter. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.pnf_descriptors_pnfd_info_id_pnfd_get_with_http_info(pnfd_info_id, version, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.pnf_descriptors_pnfd_info_id_pnfd_get_with_http_info(pnfd_info_id, version, accept, **kwargs)  # noqa: E501
            return data

    def pnf_descriptors_pnfd_info_id_pnfd_get_with_http_info(self, pnfd_info_id, version, accept, **kwargs):  # noqa: E501
        """pnf_descriptors_pnfd_info_id_pnfd_get  # noqa: E501

        The GET method reads the content of the PNFD within a PNFD archive. The PNFD can be implemented as a single file or as a collection of multiple files. If the PNFD is implemented in the form of multiple files, a ZIP file embedding these files shall be returned. If the PNFD is implemented as a single file, either that file or a ZIP file embedding that file shall be returned. The selection of the format is controlled by the \"Accept\" HTTP header passed in the GET request:  * If the \"Accept\" header contains only \"text/plain\" and the PNFD is     implemented as a single file, the file shall be returned; otherwise,     an error message shall be returned.  * If the \"Accept\" header contains only \"application/zip\", the single     file or the multiple files that make up the PNFD shall be returned     embedded in a ZIP file.  * If the \"Accept\" header contains both \"text/plain\" and \"application/zip\",     it is up to the NFVO to choose the format to return for a single-file PNFD;     for a multi-file PNFD, a ZIP file shall be returned. The default format of the ZIP file shall be the one specified in ETSI GS NFV-SOL 004 where only the YAML files representing the PNFD, and information necessary to navigate the ZIP file and to identify the file that is the entry point for parsing the PNFD and (if requested) further security information are included. This means that the content of the ZIP archive shall contain the following files from the PNFD archive:  * TOSCA.meta (if available in the PNFD archive);  * the main service template (either as referenced from TOSCA.meta or     available as a file with the extension \".yml\" or \".yaml\" from the     root of the archive);  * every component of the PNFD referenced (recursively) from the main     service template;  * the related security information, if the \"include_signatures\" URI     parameter is provided, as follows:     - the manifest file;     - the singleton certificate file in the root of the PNFD archive         (if available in the PNFD archive);     - the signing certificates of the individual files included in the         ZIP archive (if available in the PNFD archive);     - the signatures of the individual files (if available in the PNFD archive). This method shall follow the provisions specified in the Tables 5.4.7a.3.2-1 and 5.4.7a.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pnf_descriptors_pnfd_info_id_pnfd_get_with_http_info(pnfd_info_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str pnfd_info_id: Identifier of the individual PNF descriptor. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new PNF descriptor resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param str range: The request may contain a \"Range\" HTTP header to obtain single range of bytes from the PNFD archive. This can be used to continue an aborted transmission. If the NFVO does not support range requests, the NFVO shall ignore the \"Range\" header, process the GET request, and return the whole PNFD archive with a 200 OK response (rather than returning a 4xx error status code). 
        :param str include_signatures: If this parameter is provided, the NFVO shall include in the ZIP file the security information as specified above. This URI query parameter is a flag, i.e. it shall have no value. The NFVO shall support this parameter. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['pnfd_info_id', 'version', 'accept', 'authorization', 'range', 'include_signatures']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method pnf_descriptors_pnfd_info_id_pnfd_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'pnfd_info_id' is set
        if ('pnfd_info_id' not in params or
                params['pnfd_info_id'] is None):
            raise ValueError("Missing the required parameter `pnfd_info_id` when calling `pnf_descriptors_pnfd_info_id_pnfd_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `pnf_descriptors_pnfd_info_id_pnfd_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `pnf_descriptors_pnfd_info_id_pnfd_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'pnfd_info_id' in params:
            path_params['pnfdInfoId'] = params['pnfd_info_id']  # noqa: E501

        query_params = []
        if 'include_signatures' in params:
            query_params.append(('include_signatures', params['include_signatures']))  # noqa: E501

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'range' in params:
            header_params['Range'] = params['range']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/pnf_descriptors/{pnfdInfoId}/pnfd', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def pnf_descriptors_post(self, body, version, accept, content_type, **kwargs):  # noqa: E501
        """Create a new PNF descriptor resource.  # noqa: E501

        The POST method is used to create a new PNF descriptor resource   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pnf_descriptors_post(body, version, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreatePnfdInfoRequest body: (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231.  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: PnfdInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.pnf_descriptors_post_with_http_info(body, version, accept, content_type, **kwargs)  # noqa: E501
        else:
            (data) = self.pnf_descriptors_post_with_http_info(body, version, accept, content_type, **kwargs)  # noqa: E501
            return data

    def pnf_descriptors_post_with_http_info(self, body, version, accept, content_type, **kwargs):  # noqa: E501
        """Create a new PNF descriptor resource.  # noqa: E501

        The POST method is used to create a new PNF descriptor resource   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pnf_descriptors_post_with_http_info(body, version, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreatePnfdInfoRequest body: (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231.  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: PnfdInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'version', 'accept', 'content_type', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method pnf_descriptors_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `pnf_descriptors_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `pnf_descriptors_post`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `pnf_descriptors_post`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `pnf_descriptors_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/pnf_descriptors', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PnfdInfo',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def subscriptions_get(self, version, accept, **kwargs):  # noqa: E501
        """Query multiple subscriptions.  # noqa: E501

        TThe GET method queries the list of active subscriptions of the functional block that invokes the method. It can be used e.g. for resynchronization after error situations. This method shall support the URI query parameters, request and response data structures, and response codes, as specified in the Tables 5.4.8.3.2-1 and 5.4.8.3.2-2.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_get(version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str filter: AAttribute filtering expression according to clause 5.2 of ETSI GS NFV SOL 013. The NFVO shall support receiving this parameter as part of the URI query string. the OSS/BSS may supply this parameter. All attribute names that appear in the NsdmSubscription and in data types referenced from it shall be supported by the NFVO in the filter expression. 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the NFVO if the NFVO supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV-SOL 013 for this resource. 


        :return: list[NsdmSubscription]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.subscriptions_get_with_http_info(version, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.subscriptions_get_with_http_info(version, accept, **kwargs)  # noqa: E501
            return data

    def subscriptions_get_with_http_info(self, version, accept, **kwargs):  # noqa: E501
        """Query multiple subscriptions.  # noqa: E501

        TThe GET method queries the list of active subscriptions of the functional block that invokes the method. It can be used e.g. for resynchronization after error situations. This method shall support the URI query parameters, request and response data structures, and response codes, as specified in the Tables 5.4.8.3.2-1 and 5.4.8.3.2-2.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_get_with_http_info(version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str filter: AAttribute filtering expression according to clause 5.2 of ETSI GS NFV SOL 013. The NFVO shall support receiving this parameter as part of the URI query string. the OSS/BSS may supply this parameter. All attribute names that appear in the NsdmSubscription and in data types referenced from it shall be supported by the NFVO in the filter expression. 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the NFVO if the NFVO supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV-SOL 013 for this resource. 


        :return: list[NsdmSubscription]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version', 'accept', 'authorization', 'filter', 'nextpage_opaque_marker']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method subscriptions_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `subscriptions_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `subscriptions_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'nextpage_opaque_marker' in params:
            query_params.append(('nextpage_opaque_marker', params['nextpage_opaque_marker']))  # noqa: E501

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/subscriptions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[NsdmSubscription]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def subscriptions_post(self, body, version, accept, content_type, **kwargs):  # noqa: E501
        """Subscribe to NSD and PNFD change notifications.  # noqa: E501

        The POST method creates a new subscription. This method shall support the URI query parameters, request and response data structures, and response codes, as specified in the Tables 5.4.8.3.1-1 and 5.4.8.3.1-2. Creation of two subscription resources with the same callback URI and the same filter can result in performance degradation and will provide duplicates of notifications to the OSS, and might make sense only in very rare use cases. Consequently, the NFVO may either allow creating a subscription resource if another subscription resource with the same filter and callback URI already exists (in which case it shall return the \"201 Created\" response code), or may decide to not create a duplicate subscription resource (in which case it shall return a \"303 See Other\" response code referencing the existing subscription resource with the same filter and callbackUricallback URI).   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_post(body, version, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NsdmSubscriptionRequest body: (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231.  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: NsdmSubscription
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.subscriptions_post_with_http_info(body, version, accept, content_type, **kwargs)  # noqa: E501
        else:
            (data) = self.subscriptions_post_with_http_info(body, version, accept, content_type, **kwargs)  # noqa: E501
            return data

    def subscriptions_post_with_http_info(self, body, version, accept, content_type, **kwargs):  # noqa: E501
        """Subscribe to NSD and PNFD change notifications.  # noqa: E501

        The POST method creates a new subscription. This method shall support the URI query parameters, request and response data structures, and response codes, as specified in the Tables 5.4.8.3.1-1 and 5.4.8.3.1-2. Creation of two subscription resources with the same callback URI and the same filter can result in performance degradation and will provide duplicates of notifications to the OSS, and might make sense only in very rare use cases. Consequently, the NFVO may either allow creating a subscription resource if another subscription resource with the same filter and callback URI already exists (in which case it shall return the \"201 Created\" response code), or may decide to not create a duplicate subscription resource (in which case it shall return a \"303 See Other\" response code referencing the existing subscription resource with the same filter and callbackUricallback URI).   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_post_with_http_info(body, version, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NsdmSubscriptionRequest body: (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231.  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: NsdmSubscription
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'version', 'accept', 'content_type', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method subscriptions_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `subscriptions_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `subscriptions_post`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `subscriptions_post`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `subscriptions_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/subscriptions', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NsdmSubscription',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def subscriptions_subscription_id_delete(self, subscription_id, version, **kwargs):  # noqa: E501
        """Terminate Subscription  # noqa: E501

        This resource represents an individual subscription.  It can be used by the client to read and to terminate a subscription to notifications related to NSD management. The DELETE method terminates an individual subscription. This method shall support the URI query parameters, request and  response data structures, and response codes, as specified in the Table 5.4.9.3.3-2.         # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_subscription_id_delete(subscription_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str subscription_id: Identifier of this subscription. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new subscription resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Details are specified in clause 4.5.3 of GS NFV-SOL 005. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.subscriptions_subscription_id_delete_with_http_info(subscription_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.subscriptions_subscription_id_delete_with_http_info(subscription_id, version, **kwargs)  # noqa: E501
            return data

    def subscriptions_subscription_id_delete_with_http_info(self, subscription_id, version, **kwargs):  # noqa: E501
        """Terminate Subscription  # noqa: E501

        This resource represents an individual subscription.  It can be used by the client to read and to terminate a subscription to notifications related to NSD management. The DELETE method terminates an individual subscription. This method shall support the URI query parameters, request and  response data structures, and response codes, as specified in the Table 5.4.9.3.3-2.         # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_subscription_id_delete_with_http_info(subscription_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str subscription_id: Identifier of this subscription. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new subscription resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Details are specified in clause 4.5.3 of GS NFV-SOL 005. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['subscription_id', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method subscriptions_subscription_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'subscription_id' is set
        if ('subscription_id' not in params or
                params['subscription_id'] is None):
            raise ValueError("Missing the required parameter `subscription_id` when calling `subscriptions_subscription_id_delete`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `subscriptions_subscription_id_delete`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'subscription_id' in params:
            path_params['subscriptionId'] = params['subscription_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/subscriptions/{subscriptionId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def subscriptions_subscription_id_get(self, subscription_id, version, accept, **kwargs):  # noqa: E501
        """Read an individual subscription resource.  # noqa: E501

        This resource represents an individual subscription.  It can be used by the client to read and to terminate a subscription to notifications related to NSD management. The GET method retrieves information about a subscription by reading an individual subscription resource.  This resource represents an individual subscription.  It can be used by the client to read and to terminate a subscription to notifications related to NSD management.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_subscription_id_get(subscription_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str subscription_id: Identifier of this subscription. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new subscription resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. This header field shall be present if the response is expected to have a non-empty message body.  (required)
        :param str authorization: The authorization token for the request. Details are specified in clause 4.5.3 of GS NFV-SOL 005. 


        :return: NsdmSubscription
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.subscriptions_subscription_id_get_with_http_info(subscription_id, version, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.subscriptions_subscription_id_get_with_http_info(subscription_id, version, accept, **kwargs)  # noqa: E501
            return data

    def subscriptions_subscription_id_get_with_http_info(self, subscription_id, version, accept, **kwargs):  # noqa: E501
        """Read an individual subscription resource.  # noqa: E501

        This resource represents an individual subscription.  It can be used by the client to read and to terminate a subscription to notifications related to NSD management. The GET method retrieves information about a subscription by reading an individual subscription resource.  This resource represents an individual subscription.  It can be used by the client to read and to terminate a subscription to notifications related to NSD management.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_subscription_id_get_with_http_info(subscription_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str subscription_id: Identifier of this subscription. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new subscription resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. This header field shall be present if the response is expected to have a non-empty message body.  (required)
        :param str authorization: The authorization token for the request. Details are specified in clause 4.5.3 of GS NFV-SOL 005. 


        :return: NsdmSubscription
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['subscription_id', 'version', 'accept', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method subscriptions_subscription_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'subscription_id' is set
        if ('subscription_id' not in params or
                params['subscription_id'] is None):
            raise ValueError("Missing the required parameter `subscription_id` when calling `subscriptions_subscription_id_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `subscriptions_subscription_id_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `subscriptions_subscription_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'subscription_id' in params:
            path_params['subscriptionId'] = params['subscription_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/subscriptions/{subscriptionId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NsdmSubscription',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
