# coding: utf-8

"""
    SOL005 - NSD Management Interface

    SOL005 - NSD Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class NsdInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'Identifier',
        'nsd_id': 'Identifier',
        'nsd_name': 'str',
        'nsd_version': 'Version',
        'nsd_designer': 'str',
        'nsd_invariant_id': 'Identifier',
        'vnf_pkg_ids': 'list[Identifier]',
        'pnfd_info_ids': 'list[Identifier]',
        'nested_nsd_info_ids': 'list[Identifier]',
        'archive_security_option': 'str',
        'signing_certificate': 'String',
        'artifacts': 'list[NsdArchiveArtifactInfo]',
        'nsd_onboarding_state': 'NsdOnboardingStateType',
        'onboarding_failure_details': 'ProblemDetails',
        'nsd_operational_state': 'NsdOperationalStateType',
        'nsd_usage_state': 'NsdUsageStateType',
        'user_defined_data': 'UserDefinedDataType',
        'links': 'NsdInfoLinks'
    }

    attribute_map = {
        'id': 'id',
        'nsd_id': 'nsdId',
        'nsd_name': 'nsdName',
        'nsd_version': 'nsdVersion',
        'nsd_designer': 'nsdDesigner',
        'nsd_invariant_id': 'nsdInvariantId',
        'vnf_pkg_ids': 'vnfPkgIds',
        'pnfd_info_ids': 'pnfdInfoIds',
        'nested_nsd_info_ids': 'nestedNsdInfoIds',
        'archive_security_option': 'archiveSecurityOption',
        'signing_certificate': 'signingCertificate',
        'artifacts': 'artifacts',
        'nsd_onboarding_state': 'nsdOnboardingState',
        'onboarding_failure_details': 'onboardingFailureDetails',
        'nsd_operational_state': 'nsdOperationalState',
        'nsd_usage_state': 'nsdUsageState',
        'user_defined_data': 'userDefinedData',
        'links': '_links'
    }

    def __init__(self, id=None, nsd_id=None, nsd_name=None, nsd_version=None, nsd_designer=None, nsd_invariant_id=None, vnf_pkg_ids=None, pnfd_info_ids=None, nested_nsd_info_ids=None, archive_security_option=None, signing_certificate=None, artifacts=None, nsd_onboarding_state=None, onboarding_failure_details=None, nsd_operational_state=None, nsd_usage_state=None, user_defined_data=None, links=None):  # noqa: E501
        """NsdInfo - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._nsd_id = None
        self._nsd_name = None
        self._nsd_version = None
        self._nsd_designer = None
        self._nsd_invariant_id = None
        self._vnf_pkg_ids = None
        self._pnfd_info_ids = None
        self._nested_nsd_info_ids = None
        self._archive_security_option = None
        self._signing_certificate = None
        self._artifacts = None
        self._nsd_onboarding_state = None
        self._onboarding_failure_details = None
        self._nsd_operational_state = None
        self._nsd_usage_state = None
        self._user_defined_data = None
        self._links = None
        self.discriminator = None
        self.id = id
        if nsd_id is not None:
            self.nsd_id = nsd_id
        if nsd_name is not None:
            self.nsd_name = nsd_name
        if nsd_version is not None:
            self.nsd_version = nsd_version
        if nsd_designer is not None:
            self.nsd_designer = nsd_designer
        if nsd_invariant_id is not None:
            self.nsd_invariant_id = nsd_invariant_id
        if vnf_pkg_ids is not None:
            self.vnf_pkg_ids = vnf_pkg_ids
        if pnfd_info_ids is not None:
            self.pnfd_info_ids = pnfd_info_ids
        if nested_nsd_info_ids is not None:
            self.nested_nsd_info_ids = nested_nsd_info_ids
        if archive_security_option is not None:
            self.archive_security_option = archive_security_option
        if signing_certificate is not None:
            self.signing_certificate = signing_certificate
        if artifacts is not None:
            self.artifacts = artifacts
        self.nsd_onboarding_state = nsd_onboarding_state
        if onboarding_failure_details is not None:
            self.onboarding_failure_details = onboarding_failure_details
        self.nsd_operational_state = nsd_operational_state
        self.nsd_usage_state = nsd_usage_state
        if user_defined_data is not None:
            self.user_defined_data = user_defined_data
        self.links = links

    @property
    def id(self):
        """Gets the id of this NsdInfo.  # noqa: E501


        :return: The id of this NsdInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this NsdInfo.


        :param id: The id of this NsdInfo.  # noqa: E501
        :type: Identifier
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def nsd_id(self):
        """Gets the nsd_id of this NsdInfo.  # noqa: E501


        :return: The nsd_id of this NsdInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._nsd_id

    @nsd_id.setter
    def nsd_id(self, nsd_id):
        """Sets the nsd_id of this NsdInfo.


        :param nsd_id: The nsd_id of this NsdInfo.  # noqa: E501
        :type: Identifier
        """

        self._nsd_id = nsd_id

    @property
    def nsd_name(self):
        """Gets the nsd_name of this NsdInfo.  # noqa: E501

        Name of the on boarded NSD. This information is copied from the NSD content and shall be present after the NSD content is on-boarded.   # noqa: E501

        :return: The nsd_name of this NsdInfo.  # noqa: E501
        :rtype: str
        """
        return self._nsd_name

    @nsd_name.setter
    def nsd_name(self, nsd_name):
        """Sets the nsd_name of this NsdInfo.

        Name of the on boarded NSD. This information is copied from the NSD content and shall be present after the NSD content is on-boarded.   # noqa: E501

        :param nsd_name: The nsd_name of this NsdInfo.  # noqa: E501
        :type: str
        """

        self._nsd_name = nsd_name

    @property
    def nsd_version(self):
        """Gets the nsd_version of this NsdInfo.  # noqa: E501


        :return: The nsd_version of this NsdInfo.  # noqa: E501
        :rtype: Version
        """
        return self._nsd_version

    @nsd_version.setter
    def nsd_version(self, nsd_version):
        """Sets the nsd_version of this NsdInfo.


        :param nsd_version: The nsd_version of this NsdInfo.  # noqa: E501
        :type: Version
        """

        self._nsd_version = nsd_version

    @property
    def nsd_designer(self):
        """Gets the nsd_designer of this NsdInfo.  # noqa: E501

        Designer of the on-boarded NSD. This information is copied from the NSD content and shall be present after the NSD content is on-boarded.   # noqa: E501

        :return: The nsd_designer of this NsdInfo.  # noqa: E501
        :rtype: str
        """
        return self._nsd_designer

    @nsd_designer.setter
    def nsd_designer(self, nsd_designer):
        """Sets the nsd_designer of this NsdInfo.

        Designer of the on-boarded NSD. This information is copied from the NSD content and shall be present after the NSD content is on-boarded.   # noqa: E501

        :param nsd_designer: The nsd_designer of this NsdInfo.  # noqa: E501
        :type: str
        """

        self._nsd_designer = nsd_designer

    @property
    def nsd_invariant_id(self):
        """Gets the nsd_invariant_id of this NsdInfo.  # noqa: E501


        :return: The nsd_invariant_id of this NsdInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._nsd_invariant_id

    @nsd_invariant_id.setter
    def nsd_invariant_id(self, nsd_invariant_id):
        """Sets the nsd_invariant_id of this NsdInfo.


        :param nsd_invariant_id: The nsd_invariant_id of this NsdInfo.  # noqa: E501
        :type: Identifier
        """

        self._nsd_invariant_id = nsd_invariant_id

    @property
    def vnf_pkg_ids(self):
        """Gets the vnf_pkg_ids of this NsdInfo.  # noqa: E501

        Identifies the VNF package for the VNFD referenced by the on-boarded NS descriptor resource.   # noqa: E501

        :return: The vnf_pkg_ids of this NsdInfo.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._vnf_pkg_ids

    @vnf_pkg_ids.setter
    def vnf_pkg_ids(self, vnf_pkg_ids):
        """Sets the vnf_pkg_ids of this NsdInfo.

        Identifies the VNF package for the VNFD referenced by the on-boarded NS descriptor resource.   # noqa: E501

        :param vnf_pkg_ids: The vnf_pkg_ids of this NsdInfo.  # noqa: E501
        :type: list[Identifier]
        """

        self._vnf_pkg_ids = vnf_pkg_ids

    @property
    def pnfd_info_ids(self):
        """Gets the pnfd_info_ids of this NsdInfo.  # noqa: E501

        Identifies the PnfdInfo element for the PNFD referenced by the on-boarded NS descriptor resource.   # noqa: E501

        :return: The pnfd_info_ids of this NsdInfo.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._pnfd_info_ids

    @pnfd_info_ids.setter
    def pnfd_info_ids(self, pnfd_info_ids):
        """Sets the pnfd_info_ids of this NsdInfo.

        Identifies the PnfdInfo element for the PNFD referenced by the on-boarded NS descriptor resource.   # noqa: E501

        :param pnfd_info_ids: The pnfd_info_ids of this NsdInfo.  # noqa: E501
        :type: list[Identifier]
        """

        self._pnfd_info_ids = pnfd_info_ids

    @property
    def nested_nsd_info_ids(self):
        """Gets the nested_nsd_info_ids of this NsdInfo.  # noqa: E501

        Identifies the NsdInfo element for the nested NSD referenced by the on-boarded NS descriptor resource.   # noqa: E501

        :return: The nested_nsd_info_ids of this NsdInfo.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._nested_nsd_info_ids

    @nested_nsd_info_ids.setter
    def nested_nsd_info_ids(self, nested_nsd_info_ids):
        """Sets the nested_nsd_info_ids of this NsdInfo.

        Identifies the NsdInfo element for the nested NSD referenced by the on-boarded NS descriptor resource.   # noqa: E501

        :param nested_nsd_info_ids: The nested_nsd_info_ids of this NsdInfo.  # noqa: E501
        :type: list[Identifier]
        """

        self._nested_nsd_info_ids = nested_nsd_info_ids

    @property
    def archive_security_option(self):
        """Gets the archive_security_option of this NsdInfo.  # noqa: E501

        Signals the security option used by the NSD archive as defined in clause 5.1 of ETSI GS NFV SOL 007. Valid values: OPTION_1, OPTION_2   # noqa: E501

        :return: The archive_security_option of this NsdInfo.  # noqa: E501
        :rtype: str
        """
        return self._archive_security_option

    @archive_security_option.setter
    def archive_security_option(self, archive_security_option):
        """Sets the archive_security_option of this NsdInfo.

        Signals the security option used by the NSD archive as defined in clause 5.1 of ETSI GS NFV SOL 007. Valid values: OPTION_1, OPTION_2   # noqa: E501

        :param archive_security_option: The archive_security_option of this NsdInfo.  # noqa: E501
        :type: str
        """
        allowed_values = ["OPTION_1", "OPTION_2"]  # noqa: E501
        if archive_security_option is not None and archive_security_option not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `archive_security_option` ({0}), must be one of {1}"  # noqa: E501
                .format(archive_security_option, allowed_values)
            )

        self._archive_security_option = archive_security_option

    @property
    def signing_certificate(self):
        """Gets the signing_certificate of this NsdInfo.  # noqa: E501


        :return: The signing_certificate of this NsdInfo.  # noqa: E501
        :rtype: String
        """
        return self._signing_certificate

    @signing_certificate.setter
    def signing_certificate(self, signing_certificate):
        """Sets the signing_certificate of this NsdInfo.


        :param signing_certificate: The signing_certificate of this NsdInfo.  # noqa: E501
        :type: String
        """

        self._signing_certificate = signing_certificate

    @property
    def artifacts(self):
        """Gets the artifacts of this NsdInfo.  # noqa: E501

        Information about NSD archive artifacts contained in the NSD archive. This attribute shall not be present before the NSD archive content is on-boarded. Otherwise, this attribute shall be present if the NSD archive contains artifacts.   # noqa: E501

        :return: The artifacts of this NsdInfo.  # noqa: E501
        :rtype: list[NsdArchiveArtifactInfo]
        """
        return self._artifacts

    @artifacts.setter
    def artifacts(self, artifacts):
        """Sets the artifacts of this NsdInfo.

        Information about NSD archive artifacts contained in the NSD archive. This attribute shall not be present before the NSD archive content is on-boarded. Otherwise, this attribute shall be present if the NSD archive contains artifacts.   # noqa: E501

        :param artifacts: The artifacts of this NsdInfo.  # noqa: E501
        :type: list[NsdArchiveArtifactInfo]
        """

        self._artifacts = artifacts

    @property
    def nsd_onboarding_state(self):
        """Gets the nsd_onboarding_state of this NsdInfo.  # noqa: E501


        :return: The nsd_onboarding_state of this NsdInfo.  # noqa: E501
        :rtype: NsdOnboardingStateType
        """
        return self._nsd_onboarding_state

    @nsd_onboarding_state.setter
    def nsd_onboarding_state(self, nsd_onboarding_state):
        """Sets the nsd_onboarding_state of this NsdInfo.


        :param nsd_onboarding_state: The nsd_onboarding_state of this NsdInfo.  # noqa: E501
        :type: NsdOnboardingStateType
        """
        if nsd_onboarding_state is None:
            print("WARNING: Invalid value for the required field `nsd_onboarding_state`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `nsd_onboarding_state`, must not be `None`")  # noqa: E501

        self._nsd_onboarding_state = nsd_onboarding_state

    @property
    def onboarding_failure_details(self):
        """Gets the onboarding_failure_details of this NsdInfo.  # noqa: E501


        :return: The onboarding_failure_details of this NsdInfo.  # noqa: E501
        :rtype: ProblemDetails
        """
        return self._onboarding_failure_details

    @onboarding_failure_details.setter
    def onboarding_failure_details(self, onboarding_failure_details):
        """Sets the onboarding_failure_details of this NsdInfo.


        :param onboarding_failure_details: The onboarding_failure_details of this NsdInfo.  # noqa: E501
        :type: ProblemDetails
        """

        self._onboarding_failure_details = onboarding_failure_details

    @property
    def nsd_operational_state(self):
        """Gets the nsd_operational_state of this NsdInfo.  # noqa: E501


        :return: The nsd_operational_state of this NsdInfo.  # noqa: E501
        :rtype: NsdOperationalStateType
        """
        return self._nsd_operational_state

    @nsd_operational_state.setter
    def nsd_operational_state(self, nsd_operational_state):
        """Sets the nsd_operational_state of this NsdInfo.


        :param nsd_operational_state: The nsd_operational_state of this NsdInfo.  # noqa: E501
        :type: NsdOperationalStateType
        """
        if nsd_operational_state is None:
            print("WARNING: Invalid value for the required field `nsd_operational_state`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `nsd_operational_state`, must not be `None`")  # noqa: E501

        self._nsd_operational_state = nsd_operational_state

    @property
    def nsd_usage_state(self):
        """Gets the nsd_usage_state of this NsdInfo.  # noqa: E501


        :return: The nsd_usage_state of this NsdInfo.  # noqa: E501
        :rtype: NsdUsageStateType
        """
        return self._nsd_usage_state

    @nsd_usage_state.setter
    def nsd_usage_state(self, nsd_usage_state):
        """Sets the nsd_usage_state of this NsdInfo.


        :param nsd_usage_state: The nsd_usage_state of this NsdInfo.  # noqa: E501
        :type: NsdUsageStateType
        """
        if nsd_usage_state is None:
            print("WARNING: Invalid value for the required field `nsd_usage_state`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `nsd_usage_state`, must not be `None`")  # noqa: E501

        self._nsd_usage_state = nsd_usage_state

    @property
    def user_defined_data(self):
        """Gets the user_defined_data of this NsdInfo.  # noqa: E501


        :return: The user_defined_data of this NsdInfo.  # noqa: E501
        :rtype: UserDefinedDataType
        """
        return self._user_defined_data

    @user_defined_data.setter
    def user_defined_data(self, user_defined_data):
        """Sets the user_defined_data of this NsdInfo.


        :param user_defined_data: The user_defined_data of this NsdInfo.  # noqa: E501
        :type: UserDefinedDataType
        """

        self._user_defined_data = user_defined_data

    @property
    def links(self):
        """Gets the links of this NsdInfo.  # noqa: E501


        :return: The links of this NsdInfo.  # noqa: E501
        :rtype: NsdInfoLinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this NsdInfo.


        :param links: The links of this NsdInfo.  # noqa: E501
        :type: NsdInfoLinks
        """
        if links is None:
            print("WARNING: Invalid value for the required field `links`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `links`, must not be `None`")  # noqa: E501

        self._links = links

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NsdInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NsdInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
