# coding: utf-8

"""
    SOL005 - NSD Management Interface

    SOL005 - NSD Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class PnfdArchiveArtifactInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'artifact_path': 'String',
        'checksum': 'Checksum',
        'non_mano_artifact_set_id': 'String',
        'metadata': 'KeyValuePairs'
    }

    attribute_map = {
        'artifact_path': 'artifactPath',
        'checksum': 'checksum',
        'non_mano_artifact_set_id': 'nonManoArtifactSetId',
        'metadata': 'metadata'
    }

    def __init__(self, artifact_path=None, checksum=None, non_mano_artifact_set_id=None, metadata=None):  # noqa: E501
        """PnfdArchiveArtifactInfo - a model defined in Swagger"""  # noqa: E501
        self._artifact_path = None
        self._checksum = None
        self._non_mano_artifact_set_id = None
        self._metadata = None
        self.discriminator = None
        self.artifact_path = artifact_path
        self.checksum = checksum
        if non_mano_artifact_set_id is not None:
            self.non_mano_artifact_set_id = non_mano_artifact_set_id
        if metadata is not None:
            self.metadata = metadata

    @property
    def artifact_path(self):
        """Gets the artifact_path of this PnfdArchiveArtifactInfo.  # noqa: E501


        :return: The artifact_path of this PnfdArchiveArtifactInfo.  # noqa: E501
        :rtype: String
        """
        return self._artifact_path

    @artifact_path.setter
    def artifact_path(self, artifact_path):
        """Sets the artifact_path of this PnfdArchiveArtifactInfo.


        :param artifact_path: The artifact_path of this PnfdArchiveArtifactInfo.  # noqa: E501
        :type: String
        """
        if artifact_path is None:
            print("WARNING: Invalid value for the required field `artifact_path`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `artifact_path`, must not be `None`")  # noqa: E501

        self._artifact_path = artifact_path

    @property
    def checksum(self):
        """Gets the checksum of this PnfdArchiveArtifactInfo.  # noqa: E501


        :return: The checksum of this PnfdArchiveArtifactInfo.  # noqa: E501
        :rtype: Checksum
        """
        return self._checksum

    @checksum.setter
    def checksum(self, checksum):
        """Sets the checksum of this PnfdArchiveArtifactInfo.


        :param checksum: The checksum of this PnfdArchiveArtifactInfo.  # noqa: E501
        :type: Checksum
        """
        if checksum is None:
            print("WARNING: Invalid value for the required field `checksum`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `checksum`, must not be `None`")  # noqa: E501

        self._checksum = checksum

    @property
    def non_mano_artifact_set_id(self):
        """Gets the non_mano_artifact_set_id of this PnfdArchiveArtifactInfo.  # noqa: E501


        :return: The non_mano_artifact_set_id of this PnfdArchiveArtifactInfo.  # noqa: E501
        :rtype: String
        """
        return self._non_mano_artifact_set_id

    @non_mano_artifact_set_id.setter
    def non_mano_artifact_set_id(self, non_mano_artifact_set_id):
        """Sets the non_mano_artifact_set_id of this PnfdArchiveArtifactInfo.


        :param non_mano_artifact_set_id: The non_mano_artifact_set_id of this PnfdArchiveArtifactInfo.  # noqa: E501
        :type: String
        """

        self._non_mano_artifact_set_id = non_mano_artifact_set_id

    @property
    def metadata(self):
        """Gets the metadata of this PnfdArchiveArtifactInfo.  # noqa: E501


        :return: The metadata of this PnfdArchiveArtifactInfo.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this PnfdArchiveArtifactInfo.


        :param metadata: The metadata of this PnfdArchiveArtifactInfo.  # noqa: E501
        :type: KeyValuePairs
        """

        self._metadata = metadata

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PnfdArchiveArtifactInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PnfdArchiveArtifactInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
