# coding: utf-8

"""
    SOL005 - NSD Management Interface

    SOL005 - NSD Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class PnfdInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'Identifier',
        'pnfd_id': 'Identifier',
        'pnfd_name': 'str',
        'pnfd_version': 'Version',
        'pnfd_provider': 'str',
        'pnfd_invariant_id': 'Identifier',
        'archive_security_option': 'str',
        'signing_certificate': 'String',
        'artifacts': 'list[PnfdArchiveArtifactInfo]',
        'pnfd_onboarding_state': 'PnfdOnboardingStateType',
        'onboarding_failure_details': 'ProblemDetails',
        'pnfd_usage_state': 'PnfdUsageStateType',
        'user_defined_data': 'KeyValuePairs',
        'links': 'PnfdInfoLinks'
    }

    attribute_map = {
        'id': 'id',
        'pnfd_id': 'pnfdId',
        'pnfd_name': 'pnfdName',
        'pnfd_version': 'pnfdVersion',
        'pnfd_provider': 'pnfdProvider',
        'pnfd_invariant_id': 'pnfdInvariantId',
        'archive_security_option': 'archiveSecurityOption',
        'signing_certificate': 'signingCertificate',
        'artifacts': 'artifacts',
        'pnfd_onboarding_state': 'pnfdOnboardingState',
        'onboarding_failure_details': 'onboardingFailureDetails',
        'pnfd_usage_state': 'pnfdUsageState',
        'user_defined_data': 'userDefinedData',
        'links': '_links'
    }

    def __init__(self, id=None, pnfd_id=None, pnfd_name=None, pnfd_version=None, pnfd_provider=None, pnfd_invariant_id=None, archive_security_option=None, signing_certificate=None, artifacts=None, pnfd_onboarding_state=None, onboarding_failure_details=None, pnfd_usage_state=None, user_defined_data=None, links=None):  # noqa: E501
        """PnfdInfo - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._pnfd_id = None
        self._pnfd_name = None
        self._pnfd_version = None
        self._pnfd_provider = None
        self._pnfd_invariant_id = None
        self._archive_security_option = None
        self._signing_certificate = None
        self._artifacts = None
        self._pnfd_onboarding_state = None
        self._onboarding_failure_details = None
        self._pnfd_usage_state = None
        self._user_defined_data = None
        self._links = None
        self.discriminator = None
        self.id = id
        if pnfd_id is not None:
            self.pnfd_id = pnfd_id
        if pnfd_name is not None:
            self.pnfd_name = pnfd_name
        if pnfd_version is not None:
            self.pnfd_version = pnfd_version
        if pnfd_provider is not None:
            self.pnfd_provider = pnfd_provider
        if pnfd_invariant_id is not None:
            self.pnfd_invariant_id = pnfd_invariant_id
        if archive_security_option is not None:
            self.archive_security_option = archive_security_option
        if signing_certificate is not None:
            self.signing_certificate = signing_certificate
        if artifacts is not None:
            self.artifacts = artifacts
        self.pnfd_onboarding_state = pnfd_onboarding_state
        if onboarding_failure_details is not None:
            self.onboarding_failure_details = onboarding_failure_details
        self.pnfd_usage_state = pnfd_usage_state
        if user_defined_data is not None:
            self.user_defined_data = user_defined_data
        self.links = links

    @property
    def id(self):
        """Gets the id of this PnfdInfo.  # noqa: E501


        :return: The id of this PnfdInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PnfdInfo.


        :param id: The id of this PnfdInfo.  # noqa: E501
        :type: Identifier
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def pnfd_id(self):
        """Gets the pnfd_id of this PnfdInfo.  # noqa: E501


        :return: The pnfd_id of this PnfdInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._pnfd_id

    @pnfd_id.setter
    def pnfd_id(self, pnfd_id):
        """Sets the pnfd_id of this PnfdInfo.


        :param pnfd_id: The pnfd_id of this PnfdInfo.  # noqa: E501
        :type: Identifier
        """

        self._pnfd_id = pnfd_id

    @property
    def pnfd_name(self):
        """Gets the pnfd_name of this PnfdInfo.  # noqa: E501

        Name of the on-boarded PNFD. This information is copied from the PNFD content and shall be present after the PNFD content is on-boarded.   # noqa: E501

        :return: The pnfd_name of this PnfdInfo.  # noqa: E501
        :rtype: str
        """
        return self._pnfd_name

    @pnfd_name.setter
    def pnfd_name(self, pnfd_name):
        """Sets the pnfd_name of this PnfdInfo.

        Name of the on-boarded PNFD. This information is copied from the PNFD content and shall be present after the PNFD content is on-boarded.   # noqa: E501

        :param pnfd_name: The pnfd_name of this PnfdInfo.  # noqa: E501
        :type: str
        """

        self._pnfd_name = pnfd_name

    @property
    def pnfd_version(self):
        """Gets the pnfd_version of this PnfdInfo.  # noqa: E501


        :return: The pnfd_version of this PnfdInfo.  # noqa: E501
        :rtype: Version
        """
        return self._pnfd_version

    @pnfd_version.setter
    def pnfd_version(self, pnfd_version):
        """Sets the pnfd_version of this PnfdInfo.


        :param pnfd_version: The pnfd_version of this PnfdInfo.  # noqa: E501
        :type: Version
        """

        self._pnfd_version = pnfd_version

    @property
    def pnfd_provider(self):
        """Gets the pnfd_provider of this PnfdInfo.  # noqa: E501

        Provider of the on-boarded PNFD. This information is copied from the PNFD content and shall be present after the PNFD content is on-boarded.   # noqa: E501

        :return: The pnfd_provider of this PnfdInfo.  # noqa: E501
        :rtype: str
        """
        return self._pnfd_provider

    @pnfd_provider.setter
    def pnfd_provider(self, pnfd_provider):
        """Sets the pnfd_provider of this PnfdInfo.

        Provider of the on-boarded PNFD. This information is copied from the PNFD content and shall be present after the PNFD content is on-boarded.   # noqa: E501

        :param pnfd_provider: The pnfd_provider of this PnfdInfo.  # noqa: E501
        :type: str
        """

        self._pnfd_provider = pnfd_provider

    @property
    def pnfd_invariant_id(self):
        """Gets the pnfd_invariant_id of this PnfdInfo.  # noqa: E501


        :return: The pnfd_invariant_id of this PnfdInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._pnfd_invariant_id

    @pnfd_invariant_id.setter
    def pnfd_invariant_id(self, pnfd_invariant_id):
        """Sets the pnfd_invariant_id of this PnfdInfo.


        :param pnfd_invariant_id: The pnfd_invariant_id of this PnfdInfo.  # noqa: E501
        :type: Identifier
        """

        self._pnfd_invariant_id = pnfd_invariant_id

    @property
    def archive_security_option(self):
        """Gets the archive_security_option of this PnfdInfo.  # noqa: E501

        Signals the security option used by the PNFD archive as defined in clause 5.1 of ETSI GS NFV SOL 004. Valid values: OPTION_1, OPTION_2   # noqa: E501

        :return: The archive_security_option of this PnfdInfo.  # noqa: E501
        :rtype: str
        """
        return self._archive_security_option

    @archive_security_option.setter
    def archive_security_option(self, archive_security_option):
        """Sets the archive_security_option of this PnfdInfo.

        Signals the security option used by the PNFD archive as defined in clause 5.1 of ETSI GS NFV SOL 004. Valid values: OPTION_1, OPTION_2   # noqa: E501

        :param archive_security_option: The archive_security_option of this PnfdInfo.  # noqa: E501
        :type: str
        """
        allowed_values = ["OPTION_1", "OPTION_2"]  # noqa: E501
        if archive_security_option is not None and archive_security_option not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `archive_security_option` ({0}), must be one of {1}"  # noqa: E501
                .format(archive_security_option, allowed_values)
            )

        self._archive_security_option = archive_security_option

    @property
    def signing_certificate(self):
        """Gets the signing_certificate of this PnfdInfo.  # noqa: E501


        :return: The signing_certificate of this PnfdInfo.  # noqa: E501
        :rtype: String
        """
        return self._signing_certificate

    @signing_certificate.setter
    def signing_certificate(self, signing_certificate):
        """Sets the signing_certificate of this PnfdInfo.


        :param signing_certificate: The signing_certificate of this PnfdInfo.  # noqa: E501
        :type: String
        """

        self._signing_certificate = signing_certificate

    @property
    def artifacts(self):
        """Gets the artifacts of this PnfdInfo.  # noqa: E501

        Information about PNFD archive artifacts contained in the PNFD archive. This attribute shall not be present before the PNFD archive content is on-boarded. Otherwise, this attribute shall be present if the PNFD archive contains artifacts.   # noqa: E501

        :return: The artifacts of this PnfdInfo.  # noqa: E501
        :rtype: list[PnfdArchiveArtifactInfo]
        """
        return self._artifacts

    @artifacts.setter
    def artifacts(self, artifacts):
        """Sets the artifacts of this PnfdInfo.

        Information about PNFD archive artifacts contained in the PNFD archive. This attribute shall not be present before the PNFD archive content is on-boarded. Otherwise, this attribute shall be present if the PNFD archive contains artifacts.   # noqa: E501

        :param artifacts: The artifacts of this PnfdInfo.  # noqa: E501
        :type: list[PnfdArchiveArtifactInfo]
        """

        self._artifacts = artifacts

    @property
    def pnfd_onboarding_state(self):
        """Gets the pnfd_onboarding_state of this PnfdInfo.  # noqa: E501


        :return: The pnfd_onboarding_state of this PnfdInfo.  # noqa: E501
        :rtype: PnfdOnboardingStateType
        """
        return self._pnfd_onboarding_state

    @pnfd_onboarding_state.setter
    def pnfd_onboarding_state(self, pnfd_onboarding_state):
        """Sets the pnfd_onboarding_state of this PnfdInfo.


        :param pnfd_onboarding_state: The pnfd_onboarding_state of this PnfdInfo.  # noqa: E501
        :type: PnfdOnboardingStateType
        """
        if pnfd_onboarding_state is None:
            print("WARNING: Invalid value for the required field `pnfd_onboarding_state`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `pnfd_onboarding_state`, must not be `None`")  # noqa: E501

        self._pnfd_onboarding_state = pnfd_onboarding_state

    @property
    def onboarding_failure_details(self):
        """Gets the onboarding_failure_details of this PnfdInfo.  # noqa: E501


        :return: The onboarding_failure_details of this PnfdInfo.  # noqa: E501
        :rtype: ProblemDetails
        """
        return self._onboarding_failure_details

    @onboarding_failure_details.setter
    def onboarding_failure_details(self, onboarding_failure_details):
        """Sets the onboarding_failure_details of this PnfdInfo.


        :param onboarding_failure_details: The onboarding_failure_details of this PnfdInfo.  # noqa: E501
        :type: ProblemDetails
        """

        self._onboarding_failure_details = onboarding_failure_details

    @property
    def pnfd_usage_state(self):
        """Gets the pnfd_usage_state of this PnfdInfo.  # noqa: E501


        :return: The pnfd_usage_state of this PnfdInfo.  # noqa: E501
        :rtype: PnfdUsageStateType
        """
        return self._pnfd_usage_state

    @pnfd_usage_state.setter
    def pnfd_usage_state(self, pnfd_usage_state):
        """Sets the pnfd_usage_state of this PnfdInfo.


        :param pnfd_usage_state: The pnfd_usage_state of this PnfdInfo.  # noqa: E501
        :type: PnfdUsageStateType
        """
        if pnfd_usage_state is None:
            print("WARNING: Invalid value for the required field `pnfd_usage_state`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `pnfd_usage_state`, must not be `None`")  # noqa: E501

        self._pnfd_usage_state = pnfd_usage_state

    @property
    def user_defined_data(self):
        """Gets the user_defined_data of this PnfdInfo.  # noqa: E501


        :return: The user_defined_data of this PnfdInfo.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._user_defined_data

    @user_defined_data.setter
    def user_defined_data(self, user_defined_data):
        """Sets the user_defined_data of this PnfdInfo.


        :param user_defined_data: The user_defined_data of this PnfdInfo.  # noqa: E501
        :type: KeyValuePairs
        """

        self._user_defined_data = user_defined_data

    @property
    def links(self):
        """Gets the links of this PnfdInfo.  # noqa: E501


        :return: The links of this PnfdInfo.  # noqa: E501
        :rtype: PnfdInfoLinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this PnfdInfo.


        :param links: The links of this PnfdInfo.  # noqa: E501
        :type: PnfdInfoLinks
        """
        if links is None:
            print("WARNING: Invalid value for the required field `links`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `links`, must not be `None`")  # noqa: E501

        self._links = links

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PnfdInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PnfdInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
