# coding: utf-8

"""
    SOL005 - NSD Management Interface

    SOL005 - NSD Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class SubscriptionAuthenticationParamsOauth2ClientCredentials(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'client_id': 'str',
        'client_password': 'str',
        'token_endpoint': 'Uri'
    }

    attribute_map = {
        'client_id': 'clientId',
        'client_password': 'clientPassword',
        'token_endpoint': 'tokenEndpoint'
    }

    def __init__(self, client_id=None, client_password=None, token_endpoint=None):  # noqa: E501
        """SubscriptionAuthenticationParamsOauth2ClientCredentials - a model defined in Swagger"""  # noqa: E501
        self._client_id = None
        self._client_password = None
        self._token_endpoint = None
        self.discriminator = None
        if client_id is not None:
            self.client_id = client_id
        if client_password is not None:
            self.client_password = client_password
        if token_endpoint is not None:
            self.token_endpoint = token_endpoint

    @property
    def client_id(self):
        """Gets the client_id of this SubscriptionAuthenticationParamsOauth2ClientCredentials.  # noqa: E501

        Client identifier to be used in the access token request of the OAuth 2.0 client credentials grant type. Shall be present if it has not been provisioned out of band. The clientId and clientPassword passed in a subscription shall not be the same as the clientId and clientPassword that are used to obtain authorization for API requests. Client credentials may differ between subscriptions. The value of clientPassword should be generated by a random process.   # noqa: E501

        :return: The client_id of this SubscriptionAuthenticationParamsOauth2ClientCredentials.  # noqa: E501
        :rtype: str
        """
        return self._client_id

    @client_id.setter
    def client_id(self, client_id):
        """Sets the client_id of this SubscriptionAuthenticationParamsOauth2ClientCredentials.

        Client identifier to be used in the access token request of the OAuth 2.0 client credentials grant type. Shall be present if it has not been provisioned out of band. The clientId and clientPassword passed in a subscription shall not be the same as the clientId and clientPassword that are used to obtain authorization for API requests. Client credentials may differ between subscriptions. The value of clientPassword should be generated by a random process.   # noqa: E501

        :param client_id: The client_id of this SubscriptionAuthenticationParamsOauth2ClientCredentials.  # noqa: E501
        :type: str
        """

        self._client_id = client_id

    @property
    def client_password(self):
        """Gets the client_password of this SubscriptionAuthenticationParamsOauth2ClientCredentials.  # noqa: E501

        Client password to be used in the access token request of the OAuth 2.0 client credentials grant type. Shall be present if it has not been provisioned out of band. The clientId and clientPassword passed in a subscription shall not be the same as the clientId and clientPassword that are used to obtain authorization for API requests. Client credentials may differ between subscriptions. The value of clientPassword should be generated by a random process.   # noqa: E501

        :return: The client_password of this SubscriptionAuthenticationParamsOauth2ClientCredentials.  # noqa: E501
        :rtype: str
        """
        return self._client_password

    @client_password.setter
    def client_password(self, client_password):
        """Sets the client_password of this SubscriptionAuthenticationParamsOauth2ClientCredentials.

        Client password to be used in the access token request of the OAuth 2.0 client credentials grant type. Shall be present if it has not been provisioned out of band. The clientId and clientPassword passed in a subscription shall not be the same as the clientId and clientPassword that are used to obtain authorization for API requests. Client credentials may differ between subscriptions. The value of clientPassword should be generated by a random process.   # noqa: E501

        :param client_password: The client_password of this SubscriptionAuthenticationParamsOauth2ClientCredentials.  # noqa: E501
        :type: str
        """

        self._client_password = client_password

    @property
    def token_endpoint(self):
        """Gets the token_endpoint of this SubscriptionAuthenticationParamsOauth2ClientCredentials.  # noqa: E501


        :return: The token_endpoint of this SubscriptionAuthenticationParamsOauth2ClientCredentials.  # noqa: E501
        :rtype: Uri
        """
        return self._token_endpoint

    @token_endpoint.setter
    def token_endpoint(self, token_endpoint):
        """Sets the token_endpoint of this SubscriptionAuthenticationParamsOauth2ClientCredentials.


        :param token_endpoint: The token_endpoint of this SubscriptionAuthenticationParamsOauth2ClientCredentials.  # noqa: E501
        :type: Uri
        """

        self._token_endpoint = token_endpoint

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SubscriptionAuthenticationParamsOauth2ClientCredentials, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SubscriptionAuthenticationParamsOauth2ClientCredentials):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
