# coding: utf-8

"""
    SOL005 - NS Fault Management Interface

    SOL005 - NS Fault Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.2.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class FmNotificationsFilter(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'ns_instance_subscription_filter': 'NsInstanceSubscriptionFilter',
        'notification_types': 'str',
        'faulty_resource_types': 'list[FaultyResourceType]',
        'perceived_severities': 'list[PerceivedSeverityType]',
        'event_types': 'list[EventType]',
        'probable_causes': 'list[str]'
    }

    attribute_map = {
        'ns_instance_subscription_filter': 'nsInstanceSubscriptionFilter',
        'notification_types': 'notificationTypes',
        'faulty_resource_types': 'faultyResourceTypes',
        'perceived_severities': 'perceivedSeverities',
        'event_types': 'eventTypes',
        'probable_causes': 'probableCauses'
    }

    def __init__(self, ns_instance_subscription_filter=None, notification_types=None, faulty_resource_types=None, perceived_severities=None, event_types=None, probable_causes=None):  # noqa: E501
        """FmNotificationsFilter - a model defined in Swagger"""  # noqa: E501
        self._ns_instance_subscription_filter = None
        self._notification_types = None
        self._faulty_resource_types = None
        self._perceived_severities = None
        self._event_types = None
        self._probable_causes = None
        self.discriminator = None
        if ns_instance_subscription_filter is not None:
            self.ns_instance_subscription_filter = ns_instance_subscription_filter
        if notification_types is not None:
            self.notification_types = notification_types
        if faulty_resource_types is not None:
            self.faulty_resource_types = faulty_resource_types
        if perceived_severities is not None:
            self.perceived_severities = perceived_severities
        if event_types is not None:
            self.event_types = event_types
        if probable_causes is not None:
            self.probable_causes = probable_causes

    @property
    def ns_instance_subscription_filter(self):
        """Gets the ns_instance_subscription_filter of this FmNotificationsFilter.  # noqa: E501


        :return: The ns_instance_subscription_filter of this FmNotificationsFilter.  # noqa: E501
        :rtype: NsInstanceSubscriptionFilter
        """
        return self._ns_instance_subscription_filter

    @ns_instance_subscription_filter.setter
    def ns_instance_subscription_filter(self, ns_instance_subscription_filter):
        """Sets the ns_instance_subscription_filter of this FmNotificationsFilter.


        :param ns_instance_subscription_filter: The ns_instance_subscription_filter of this FmNotificationsFilter.  # noqa: E501
        :type: NsInstanceSubscriptionFilter
        """

        self._ns_instance_subscription_filter = ns_instance_subscription_filter

    @property
    def notification_types(self):
        """Gets the notification_types of this FmNotificationsFilter.  # noqa: E501

        Match particular notification types. Permitted values: - AlarmNotification - AlarmClearedNotification - AlarmListRebuiltNotification.   # noqa: E501

        :return: The notification_types of this FmNotificationsFilter.  # noqa: E501
        :rtype: str
        """
        return self._notification_types

    @notification_types.setter
    def notification_types(self, notification_types):
        """Sets the notification_types of this FmNotificationsFilter.

        Match particular notification types. Permitted values: - AlarmNotification - AlarmClearedNotification - AlarmListRebuiltNotification.   # noqa: E501

        :param notification_types: The notification_types of this FmNotificationsFilter.  # noqa: E501
        :type: str
        """
        allowed_values = ["AlarmNotification", "AlarmClearedNotification", "AlarmListRebuiltNotification"]  # noqa: E501
        if notification_types is not None and notification_types not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `notification_types` ({0}), must be one of {1}"  # noqa: E501
                .format(notification_types, allowed_values)
            )

        self._notification_types = notification_types

    @property
    def faulty_resource_types(self):
        """Gets the faulty_resource_types of this FmNotificationsFilter.  # noqa: E501

        Match alarms related to NSs with a faulty resource type listed in this attribute.   # noqa: E501

        :return: The faulty_resource_types of this FmNotificationsFilter.  # noqa: E501
        :rtype: list[FaultyResourceType]
        """
        return self._faulty_resource_types

    @faulty_resource_types.setter
    def faulty_resource_types(self, faulty_resource_types):
        """Sets the faulty_resource_types of this FmNotificationsFilter.

        Match alarms related to NSs with a faulty resource type listed in this attribute.   # noqa: E501

        :param faulty_resource_types: The faulty_resource_types of this FmNotificationsFilter.  # noqa: E501
        :type: list[FaultyResourceType]
        """

        self._faulty_resource_types = faulty_resource_types

    @property
    def perceived_severities(self):
        """Gets the perceived_severities of this FmNotificationsFilter.  # noqa: E501

        Match VNF alarms with a perceived severity listed in this attribute.   # noqa: E501

        :return: The perceived_severities of this FmNotificationsFilter.  # noqa: E501
        :rtype: list[PerceivedSeverityType]
        """
        return self._perceived_severities

    @perceived_severities.setter
    def perceived_severities(self, perceived_severities):
        """Sets the perceived_severities of this FmNotificationsFilter.

        Match VNF alarms with a perceived severity listed in this attribute.   # noqa: E501

        :param perceived_severities: The perceived_severities of this FmNotificationsFilter.  # noqa: E501
        :type: list[PerceivedSeverityType]
        """

        self._perceived_severities = perceived_severities

    @property
    def event_types(self):
        """Gets the event_types of this FmNotificationsFilter.  # noqa: E501

        Match VNF alarms related to NSs with an event type listed in this attribute.   # noqa: E501

        :return: The event_types of this FmNotificationsFilter.  # noqa: E501
        :rtype: list[EventType]
        """
        return self._event_types

    @event_types.setter
    def event_types(self, event_types):
        """Sets the event_types of this FmNotificationsFilter.

        Match VNF alarms related to NSs with an event type listed in this attribute.   # noqa: E501

        :param event_types: The event_types of this FmNotificationsFilter.  # noqa: E501
        :type: list[EventType]
        """

        self._event_types = event_types

    @property
    def probable_causes(self):
        """Gets the probable_causes of this FmNotificationsFilter.  # noqa: E501

        Match VNF alarms with a probable cause listed in this attribute.   # noqa: E501

        :return: The probable_causes of this FmNotificationsFilter.  # noqa: E501
        :rtype: list[str]
        """
        return self._probable_causes

    @probable_causes.setter
    def probable_causes(self, probable_causes):
        """Sets the probable_causes of this FmNotificationsFilter.

        Match VNF alarms with a probable cause listed in this attribute.   # noqa: E501

        :param probable_causes: The probable_causes of this FmNotificationsFilter.  # noqa: E501
        :type: list[str]
        """

        self._probable_causes = probable_causes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FmNotificationsFilter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FmNotificationsFilter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
