# coding: utf-8

"""
    SOL005 - NS Fault Management Interface

    SOL005 - NS Fault Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.2.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class NsInstanceSubscriptionFilter(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'nsd_ids': 'list[Identifier]',
        'vnfd_ids': 'list[Identifier]',
        'pnfd_ids': 'list[Identifier]',
        'ns_instance_ids': 'list[Identifier]',
        'ns_instance_names': 'list[String]'
    }

    attribute_map = {
        'nsd_ids': 'nsdIds',
        'vnfd_ids': 'vnfdIds',
        'pnfd_ids': 'pnfdIds',
        'ns_instance_ids': 'nsInstanceIds',
        'ns_instance_names': 'nsInstanceNames'
    }

    def __init__(self, nsd_ids=None, vnfd_ids=None, pnfd_ids=None, ns_instance_ids=None, ns_instance_names=None):  # noqa: E501
        """NsInstanceSubscriptionFilter - a model defined in Swagger"""  # noqa: E501
        self._nsd_ids = None
        self._vnfd_ids = None
        self._pnfd_ids = None
        self._ns_instance_ids = None
        self._ns_instance_names = None
        self.discriminator = None
        if nsd_ids is not None:
            self.nsd_ids = nsd_ids
        if vnfd_ids is not None:
            self.vnfd_ids = vnfd_ids
        if pnfd_ids is not None:
            self.pnfd_ids = pnfd_ids
        if ns_instance_ids is not None:
            self.ns_instance_ids = ns_instance_ids
        if ns_instance_names is not None:
            self.ns_instance_names = ns_instance_names

    @property
    def nsd_ids(self):
        """Gets the nsd_ids of this NsInstanceSubscriptionFilter.  # noqa: E501

        If present, match NS instances that were created based on a NSD identified by one of the nsdId values listed in this attribute.   # noqa: E501

        :return: The nsd_ids of this NsInstanceSubscriptionFilter.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._nsd_ids

    @nsd_ids.setter
    def nsd_ids(self, nsd_ids):
        """Sets the nsd_ids of this NsInstanceSubscriptionFilter.

        If present, match NS instances that were created based on a NSD identified by one of the nsdId values listed in this attribute.   # noqa: E501

        :param nsd_ids: The nsd_ids of this NsInstanceSubscriptionFilter.  # noqa: E501
        :type: list[Identifier]
        """

        self._nsd_ids = nsd_ids

    @property
    def vnfd_ids(self):
        """Gets the vnfd_ids of this NsInstanceSubscriptionFilter.  # noqa: E501

        If present, match NS instances that contain VNF instances that were created based on a VNFD identified by one of the vnfdId values listed in this attribute.   # noqa: E501

        :return: The vnfd_ids of this NsInstanceSubscriptionFilter.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._vnfd_ids

    @vnfd_ids.setter
    def vnfd_ids(self, vnfd_ids):
        """Sets the vnfd_ids of this NsInstanceSubscriptionFilter.

        If present, match NS instances that contain VNF instances that were created based on a VNFD identified by one of the vnfdId values listed in this attribute.   # noqa: E501

        :param vnfd_ids: The vnfd_ids of this NsInstanceSubscriptionFilter.  # noqa: E501
        :type: list[Identifier]
        """

        self._vnfd_ids = vnfd_ids

    @property
    def pnfd_ids(self):
        """Gets the pnfd_ids of this NsInstanceSubscriptionFilter.  # noqa: E501

        If present, match NS instances that contain PNFs that are represented by a PNFD identified by one of the pnfdId values listed in this attribute.   # noqa: E501

        :return: The pnfd_ids of this NsInstanceSubscriptionFilter.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._pnfd_ids

    @pnfd_ids.setter
    def pnfd_ids(self, pnfd_ids):
        """Sets the pnfd_ids of this NsInstanceSubscriptionFilter.

        If present, match NS instances that contain PNFs that are represented by a PNFD identified by one of the pnfdId values listed in this attribute.   # noqa: E501

        :param pnfd_ids: The pnfd_ids of this NsInstanceSubscriptionFilter.  # noqa: E501
        :type: list[Identifier]
        """

        self._pnfd_ids = pnfd_ids

    @property
    def ns_instance_ids(self):
        """Gets the ns_instance_ids of this NsInstanceSubscriptionFilter.  # noqa: E501

        If present, match NS instances with an instance identifier listed in this attribute.   # noqa: E501

        :return: The ns_instance_ids of this NsInstanceSubscriptionFilter.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._ns_instance_ids

    @ns_instance_ids.setter
    def ns_instance_ids(self, ns_instance_ids):
        """Sets the ns_instance_ids of this NsInstanceSubscriptionFilter.

        If present, match NS instances with an instance identifier listed in this attribute.   # noqa: E501

        :param ns_instance_ids: The ns_instance_ids of this NsInstanceSubscriptionFilter.  # noqa: E501
        :type: list[Identifier]
        """

        self._ns_instance_ids = ns_instance_ids

    @property
    def ns_instance_names(self):
        """Gets the ns_instance_names of this NsInstanceSubscriptionFilter.  # noqa: E501

        If present, match NS instances with a NS Instance Name listed in this attribute.   # noqa: E501

        :return: The ns_instance_names of this NsInstanceSubscriptionFilter.  # noqa: E501
        :rtype: list[String]
        """
        return self._ns_instance_names

    @ns_instance_names.setter
    def ns_instance_names(self, ns_instance_names):
        """Sets the ns_instance_names of this NsInstanceSubscriptionFilter.

        If present, match NS instances with a NS Instance Name listed in this attribute.   # noqa: E501

        :param ns_instance_names: The ns_instance_names of this NsInstanceSubscriptionFilter.  # noqa: E501
        :type: list[String]
        """

        self._ns_instance_names = ns_instance_names

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NsInstanceSubscriptionFilter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NsInstanceSubscriptionFilter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
