# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from tca.nslcm.api_client import ApiClient
from tca.api.tca_api import TCAApi

class DefaultApi(TCAApi):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_ns(self, body, version, accept, content_type, **kwargs):  # noqa: E501
        """Create a NS instance resource.  # noqa: E501

        The POST method creates a new NS instance resource. As the result of successfully executing this method, a new \"Individual NS instance\" resource as defined in clause 6.4.3 shall have been created, and the value of the \"instantiationState\" attribute in the representation of that resource shall be \"NOT_INSTANTIATED\". A notification of type NsIdentifierCreationNotification shall be triggered as part of successfully executing this method as defined in clause 6.5.2.6.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_ns(body, version, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateNsRequest body: The NS creation parameters, as defined in clause 6.5.2.7.
 (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: NsInstance
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_ns_with_http_info(body, version, accept, content_type, **kwargs)  # noqa: E501
        else:
            (data) = self.create_ns_with_http_info(body, version, accept, content_type, **kwargs)  # noqa: E501
            return data

    def create_ns_with_http_info(self, body, version, accept, content_type, **kwargs):  # noqa: E501
        """Create a NS instance resource.  # noqa: E501

        The POST method creates a new NS instance resource. As the result of successfully executing this method, a new \"Individual NS instance\" resource as defined in clause 6.4.3 shall have been created, and the value of the \"instantiationState\" attribute in the representation of that resource shall be \"NOT_INSTANTIATED\". A notification of type NsIdentifierCreationNotification shall be triggered as part of successfully executing this method as defined in clause 6.5.2.6.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_ns_with_http_info(body, version, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateNsRequest body: The NS creation parameters, as defined in clause 6.5.2.7.
 (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: NsInstance
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'version', 'accept', 'content_type', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_ns" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_ns`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `create_ns`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `create_ns`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `create_ns`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_instances', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NsInstance',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_ns(self, ns_instance_id, version, **kwargs):  # noqa: E501
        """Delete NS instance resource.  # noqa: E501

        Delete NS Identifier This method deletes an individual NS instance resource. As the result of successfully executing this method, the \"Individual NS instance\" resource shall not exist any longer. A notification of type \"NsIdentifierDeletionNotification\" shall be triggered as part of successfully executing this method as defined in clause 6.5.2.7.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_ns(ns_instance_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str ns_instance_id: Identifier of the NS instance.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_ns_with_http_info(ns_instance_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_ns_with_http_info(ns_instance_id, version, **kwargs)  # noqa: E501
            return data

    def delete_ns_with_http_info(self, ns_instance_id, version, **kwargs):  # noqa: E501
        """Delete NS instance resource.  # noqa: E501

        Delete NS Identifier This method deletes an individual NS instance resource. As the result of successfully executing this method, the \"Individual NS instance\" resource shall not exist any longer. A notification of type \"NsIdentifierDeletionNotification\" shall be triggered as part of successfully executing this method as defined in clause 6.5.2.7.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_ns_with_http_info(ns_instance_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str ns_instance_id: Identifier of the NS instance.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['ns_instance_id', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_ns" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'ns_instance_id' is set
        if ('ns_instance_id' not in params or
                params['ns_instance_id'] is None):
            raise ValueError("Missing the required parameter `ns_instance_id` when calling `delete_ns`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `delete_ns`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'ns_instance_id' in params:
            path_params['nsInstanceId'] = params['ns_instance_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_instances/{nsInstanceId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_ns_instance(self, ns_instance_id, version, accept, content_type, **kwargs):  # noqa: E501
        """Read an individual NS instance resource.  # noqa: E501

        The GET method retrieves information about a NS instance by reading an individual NS instance resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_ns_instance(ns_instance_id, version, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str ns_instance_id: Identifier of the NS instance.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: NsInstance
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_ns_instance_with_http_info(ns_instance_id, version, accept, content_type, **kwargs)  # noqa: E501
        else:
            (data) = self.get_ns_instance_with_http_info(ns_instance_id, version, accept, content_type, **kwargs)  # noqa: E501
            return data

    def get_ns_instance_with_http_info(self, ns_instance_id, version, accept, content_type, **kwargs):  # noqa: E501
        """Read an individual NS instance resource.  # noqa: E501

        The GET method retrieves information about a NS instance by reading an individual NS instance resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_ns_instance_with_http_info(ns_instance_id, version, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str ns_instance_id: Identifier of the NS instance.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: NsInstance
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['ns_instance_id', 'version', 'accept', 'content_type', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_ns_instance" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'ns_instance_id' is set
        if ('ns_instance_id' not in params or
                params['ns_instance_id'] is None):
            raise ValueError("Missing the required parameter `ns_instance_id` when calling `get_ns_instance`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `get_ns_instance`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `get_ns_instance`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `get_ns_instance`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'ns_instance_id' in params:
            path_params['nsInstanceId'] = params['ns_instance_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_instances/{nsInstanceId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NsInstance',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_ns_instances(self, version, accept, **kwargs):  # noqa: E501
        """Query multiple NS instances.  # noqa: E501

        Query NS Instances. The GET method queries information about multiple NS instances. This method shall support the URI query parameters, request and response data structures, and response codes, as specified in the Tables 6.4.2.3.2-1 and 6.4.2.3.2-2.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_ns_instances(version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV-SOL 013. The NFVO shall support receiving this parameter as part of the URI query string. The OSS/BSS may supply this parameter. All attribute names that appear in the NsInstance and in data types referenced from it shall be supported by the NFVO in the filter expression. 
        :param str all_fields: Include all complex attributes in the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The NFVO shall support this parameter. 
        :param str fields: \"Complex attributes to be included into the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The NFVO should support this parameter.\"           
        :param str exclude_fields: \"Complex attributes to be excluded from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The NFVO should support this parameter.\" 
        :param str exclude_default: \"Indicates to exclude the following complex attributes from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The NFVO shall support this parameter. The following attributes shall be excluded from the NsInstance structure in the response body if this parameter is provided, or none of the parameters \"all_fields,\" \"fields\", \"exclude_fields\", \"exclude_default\" are provided: - vnfInstances - pnfInfo - virtualLinkInfo - vnffgInfo - sapInfo - nsScaleStatus - additionalAffinityOrAntiAffinityRules\" 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the NFVO if the NFVO supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV-SOL 013 for this resource. 


        :return: list[InlineResponse200]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_ns_instances_with_http_info(version, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.get_ns_instances_with_http_info(version, accept, **kwargs)  # noqa: E501
            return data

    def get_ns_instances_with_http_info(self, version, accept, **kwargs):  # noqa: E501
        """Query multiple NS instances.  # noqa: E501

        Query NS Instances. The GET method queries information about multiple NS instances. This method shall support the URI query parameters, request and response data structures, and response codes, as specified in the Tables 6.4.2.3.2-1 and 6.4.2.3.2-2.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_ns_instances_with_http_info(version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV-SOL 013. The NFVO shall support receiving this parameter as part of the URI query string. The OSS/BSS may supply this parameter. All attribute names that appear in the NsInstance and in data types referenced from it shall be supported by the NFVO in the filter expression. 
        :param str all_fields: Include all complex attributes in the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The NFVO shall support this parameter. 
        :param str fields: \"Complex attributes to be included into the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The NFVO should support this parameter.\"           
        :param str exclude_fields: \"Complex attributes to be excluded from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The NFVO should support this parameter.\" 
        :param str exclude_default: \"Indicates to exclude the following complex attributes from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The NFVO shall support this parameter. The following attributes shall be excluded from the NsInstance structure in the response body if this parameter is provided, or none of the parameters \"all_fields,\" \"fields\", \"exclude_fields\", \"exclude_default\" are provided: - vnfInstances - pnfInfo - virtualLinkInfo - vnffgInfo - sapInfo - nsScaleStatus - additionalAffinityOrAntiAffinityRules\" 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the NFVO if the NFVO supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV-SOL 013 for this resource. 


        :return: list[InlineResponse200]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version', 'accept', 'authorization', 'filter', 'all_fields', 'fields', 'exclude_fields', 'exclude_default', 'nextpage_opaque_marker']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_ns_instances" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `get_ns_instances`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `get_ns_instances`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'all_fields' in params:
            query_params.append(('all_fields', params['all_fields']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
        if 'exclude_fields' in params:
            query_params.append(('exclude_fields', params['exclude_fields']))  # noqa: E501
        if 'exclude_default' in params:
            query_params.append(('exclude_default', params['exclude_default']))  # noqa: E501
        if 'nextpage_opaque_marker' in params:
            query_params.append(('nextpage_opaque_marker', params['nextpage_opaque_marker']))  # noqa: E501

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*', 'application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_instances', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[InlineResponse200]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_nslcm_version_info(self, version, **kwargs):  # noqa: E501
        """Retrieve API version information  # noqa: E501

        The GET method reads API version information. This method shall follow the provisions specified in table 4.6.3.3.3.2-1 for request and response data structures, and response codes. URI query parameters are not supported.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_nslcm_version_info(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)


        :return: ApiVersionInformation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_nslcm_version_info_with_http_info(version, **kwargs)  # noqa: E501
        else:
            (data) = self.get_nslcm_version_info_with_http_info(version, **kwargs)  # noqa: E501
            return data

    def get_nslcm_version_info_with_http_info(self, version, **kwargs):  # noqa: E501
        """Retrieve API version information  # noqa: E501

        The GET method reads API version information. This method shall follow the provisions specified in table 4.6.3.3.3.2-1 for request and response data structures, and response codes. URI query parameters are not supported.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_nslcm_version_info_with_http_info(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)


        :return: ApiVersionInformation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_nslcm_version_info" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `get_nslcm_version_info`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/api_versions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiVersionInformation',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def heal_ns(self, body, accept, content_type, version, ns_instance_id, **kwargs):  # noqa: E501
        """Heal a NS instance.  # noqa: E501

        The POST method requests to heal an NS instance. This method shall follow the provisions specified in the Tables 6.4.7.3.1-1 and 6.4.7.3.1-2 for URI query parameters, request and response data structures, and response codes. The steps and conditions that apply as the result of successfully executing this method are specified in clause 6.4.1.2.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.heal_ns(body, accept, content_type, version, ns_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param HealNsRequest body: Parameters for the heal NS operation, as defined in clause 6.5.2.13.
 (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str ns_instance_id: Identifier of the NS instance to be healed.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.heal_ns_with_http_info(body, accept, content_type, version, ns_instance_id, **kwargs)  # noqa: E501
        else:
            (data) = self.heal_ns_with_http_info(body, accept, content_type, version, ns_instance_id, **kwargs)  # noqa: E501
            return data

    def heal_ns_with_http_info(self, body, accept, content_type, version, ns_instance_id, **kwargs):  # noqa: E501
        """Heal a NS instance.  # noqa: E501

        The POST method requests to heal an NS instance. This method shall follow the provisions specified in the Tables 6.4.7.3.1-1 and 6.4.7.3.1-2 for URI query parameters, request and response data structures, and response codes. The steps and conditions that apply as the result of successfully executing this method are specified in clause 6.4.1.2.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.heal_ns_with_http_info(body, accept, content_type, version, ns_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param HealNsRequest body: Parameters for the heal NS operation, as defined in clause 6.5.2.13.
 (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str ns_instance_id: Identifier of the NS instance to be healed.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type', 'version', 'ns_instance_id', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method heal_ns" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `heal_ns`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `heal_ns`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `heal_ns`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `heal_ns`")  # noqa: E501
        # verify the required parameter 'ns_instance_id' is set
        if ('ns_instance_id' not in params or
                params['ns_instance_id'] is None):
            raise ValueError("Missing the required parameter `ns_instance_id` when calling `heal_ns`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'ns_instance_id' in params:
            path_params['nsInstanceId'] = params['ns_instance_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_instances/{nsInstanceId}/heal', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def instantiate_ns(self, body, accept, content_type, version, ns_instance_id, **kwargs):  # noqa: E501
        """Instantiate a NS.  # noqa: E501

        The POST method requests to instantiate a NS instance resource. The steps and conditions that apply as the result of successfully executing this method are specified in clause 6.4.1.2. In addition, once the NFVO has successfully completed the underlying NS LCM operation occurrence, it shall set the \"nsState\" attribute to the value \"INSTANTIATED\" in the representation of the \"Individual NS instance\" resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.instantiate_ns(body, accept, content_type, version, ns_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param InstantiateNsRequest body: Parameters for the instantiate NS operation, as defined in clause 6.5.2.11.
 (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str ns_instance_id: Identifier of the NS instance to be instantiated.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.instantiate_ns_with_http_info(body, accept, content_type, version, ns_instance_id, **kwargs)  # noqa: E501
        else:
            (data) = self.instantiate_ns_with_http_info(body, accept, content_type, version, ns_instance_id, **kwargs)  # noqa: E501
            return data

    def instantiate_ns_with_http_info(self, body, accept, content_type, version, ns_instance_id, **kwargs):  # noqa: E501
        """Instantiate a NS.  # noqa: E501

        The POST method requests to instantiate a NS instance resource. The steps and conditions that apply as the result of successfully executing this method are specified in clause 6.4.1.2. In addition, once the NFVO has successfully completed the underlying NS LCM operation occurrence, it shall set the \"nsState\" attribute to the value \"INSTANTIATED\" in the representation of the \"Individual NS instance\" resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.instantiate_ns_with_http_info(body, accept, content_type, version, ns_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param InstantiateNsRequest body: Parameters for the instantiate NS operation, as defined in clause 6.5.2.11.
 (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str ns_instance_id: Identifier of the NS instance to be instantiated.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type', 'version', 'ns_instance_id', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method instantiate_ns" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `instantiate_ns`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `instantiate_ns`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `instantiate_ns`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `instantiate_ns`")  # noqa: E501
        # verify the required parameter 'ns_instance_id' is set
        if ('ns_instance_id' not in params or
                params['ns_instance_id'] is None):
            raise ValueError("Missing the required parameter `ns_instance_id` when calling `instantiate_ns`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'ns_instance_id' in params:
            path_params['nsInstanceId'] = params['ns_instance_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_instances/{nsInstanceId}/instantiate', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def ns_update(self, body, accept, content_type, version, ns_instance_id, **kwargs):  # noqa: E501
        """Updates a NS instance.  # noqa: E501

        The POST method updates an NS instance.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_update(body, accept, content_type, version, ns_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param UpdateNsRequest body: Parameters for the update NS operation, as defined in clause 6.5.2.12.
 (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str ns_instance_id: Identifier of the NS instance to be updated.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.ns_update_with_http_info(body, accept, content_type, version, ns_instance_id, **kwargs)  # noqa: E501
        else:
            (data) = self.ns_update_with_http_info(body, accept, content_type, version, ns_instance_id, **kwargs)  # noqa: E501
            return data

    def ns_update_with_http_info(self, body, accept, content_type, version, ns_instance_id, **kwargs):  # noqa: E501
        """Updates a NS instance.  # noqa: E501

        The POST method updates an NS instance.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ns_update_with_http_info(body, accept, content_type, version, ns_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param UpdateNsRequest body: Parameters for the update NS operation, as defined in clause 6.5.2.12.
 (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str ns_instance_id: Identifier of the NS instance to be updated.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type', 'version', 'ns_instance_id', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ns_update" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `ns_update`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `ns_update`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `ns_update`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `ns_update`")  # noqa: E501
        # verify the required parameter 'ns_instance_id' is set
        if ('ns_instance_id' not in params or
                params['ns_instance_id'] is None):
            raise ValueError("Missing the required parameter `ns_instance_id` when calling `ns_update`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'ns_instance_id' in params:
            path_params['nsInstanceId'] = params['ns_instance_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_instances/{nsInstanceId}/update', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def query_ns_lcm_operation_job(self, ns_lcm_op_occ_id, accept, version, **kwargs):  # noqa: E501
        """Read an individual NS LCM operation occurrence resource.  # noqa: E501

        The API consumer can use this method to retrieve status information about a NS lifecycle management operation occurrence by reading an individual \"NS LCM operation occurrence\" resource. This method shall follow the provisions specified in the Tables 6.4.10.3.2-1 and 6.4.10.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.query_ns_lcm_operation_job(ns_lcm_op_occ_id, accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str ns_lcm_op_occ_id: Identifier of a NS lifecycle management operation occurrence.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: NsLcmOpOcc
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.query_ns_lcm_operation_job_with_http_info(ns_lcm_op_occ_id, accept, version, **kwargs)  # noqa: E501
        else:
            (data) = self.query_ns_lcm_operation_job_with_http_info(ns_lcm_op_occ_id, accept, version, **kwargs)  # noqa: E501
            return data

    def query_ns_lcm_operation_job_with_http_info(self, ns_lcm_op_occ_id, accept, version, **kwargs):  # noqa: E501
        """Read an individual NS LCM operation occurrence resource.  # noqa: E501

        The API consumer can use this method to retrieve status information about a NS lifecycle management operation occurrence by reading an individual \"NS LCM operation occurrence\" resource. This method shall follow the provisions specified in the Tables 6.4.10.3.2-1 and 6.4.10.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.query_ns_lcm_operation_job_with_http_info(ns_lcm_op_occ_id, accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str ns_lcm_op_occ_id: Identifier of a NS lifecycle management operation occurrence.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: NsLcmOpOcc
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['ns_lcm_op_occ_id', 'accept', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method query_ns_lcm_operation_job" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'ns_lcm_op_occ_id' is set
        if ('ns_lcm_op_occ_id' not in params or
                params['ns_lcm_op_occ_id'] is None):
            raise ValueError("Missing the required parameter `ns_lcm_op_occ_id` when calling `query_ns_lcm_operation_job`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `query_ns_lcm_operation_job`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `query_ns_lcm_operation_job`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'ns_lcm_op_occ_id' in params:
            path_params['nsLcmOpOccId'] = params['ns_lcm_op_occ_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_lcm_op_occs/{nsLcmOpOccId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NsLcmOpOcc',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def query_ns_lcm_operations(self, accept, version, **kwargs):  # noqa: E501
        """Query multiple NS LCM operation occurrences.  # noqa: E501

        Get Operation Status. Shall be returned upon the following error: The operation cannot be executed currently, due to a conflict with the state of the resource. Typically, this is due to the fact that the NS instance resource is in NOT_INSTANTIATED state, or that another lifecycle management operation is ongoing. The response body shall contain a ProblemDetails structure, in which the \"detail\" attribute shall convey more information about the error   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.query_ns_lcm_operations(accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV SOL 013[16]. The NFVO shall support receiving this parameter as part of the URI query string. The OSS/BSS may supply this parameter. All attribute names that appear in the NsLcmOpOcc and in data types referenced from it shall be supported by the NFVO in the filter expression. 
        :param str fields: Complex attributes to be included into the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The NFVO should support this parameter. 
        :param str exclude_fields: Complex attributes to be excluded from the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The NFVO should support this parameter. 
        :param str exclude_default: Indicates to exclude the following complex attributes from the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The NFVO shall support this parameter. The following attributes shall be excluded from the NsLcmOpOcc structure in the response body if this parameter is provided: - operationParams - changedVnfInfo - error - resourceChanges 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the NFVO if the NFVO supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV SOL 013 for this resource. 
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: list[InlineResponse2001]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.query_ns_lcm_operations_with_http_info(accept, version, **kwargs)  # noqa: E501
        else:
            (data) = self.query_ns_lcm_operations_with_http_info(accept, version, **kwargs)  # noqa: E501
            return data

    def query_ns_lcm_operations_with_http_info(self, accept, version, **kwargs):  # noqa: E501
        """Query multiple NS LCM operation occurrences.  # noqa: E501

        Get Operation Status. Shall be returned upon the following error: The operation cannot be executed currently, due to a conflict with the state of the resource. Typically, this is due to the fact that the NS instance resource is in NOT_INSTANTIATED state, or that another lifecycle management operation is ongoing. The response body shall contain a ProblemDetails structure, in which the \"detail\" attribute shall convey more information about the error   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.query_ns_lcm_operations_with_http_info(accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV SOL 013[16]. The NFVO shall support receiving this parameter as part of the URI query string. The OSS/BSS may supply this parameter. All attribute names that appear in the NsLcmOpOcc and in data types referenced from it shall be supported by the NFVO in the filter expression. 
        :param str fields: Complex attributes to be included into the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The NFVO should support this parameter. 
        :param str exclude_fields: Complex attributes to be excluded from the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The NFVO should support this parameter. 
        :param str exclude_default: Indicates to exclude the following complex attributes from the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The NFVO shall support this parameter. The following attributes shall be excluded from the NsLcmOpOcc structure in the response body if this parameter is provided: - operationParams - changedVnfInfo - error - resourceChanges 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the NFVO if the NFVO supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV SOL 013 for this resource. 
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: list[InlineResponse2001]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['accept', 'version', 'filter', 'fields', 'exclude_fields', 'exclude_default', 'nextpage_opaque_marker', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method query_ns_lcm_operations" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `query_ns_lcm_operations`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `query_ns_lcm_operations`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
        if 'exclude_fields' in params:
            query_params.append(('exclude_fields', params['exclude_fields']))  # noqa: E501
        if 'exclude_default' in params:
            query_params.append(('exclude_default', params['exclude_default']))  # noqa: E501
        if 'nextpage_opaque_marker' in params:
            query_params.append(('nextpage_opaque_marker', params['nextpage_opaque_marker']))  # noqa: E501

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_lcm_op_occs', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[InlineResponse2001]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def retry_ns_instance(self, ns_lcm_op_occ_id, version, **kwargs):  # noqa: E501
        """Retry a NS lifecycle management operation occurrence.  # noqa: E501

        The POST method initiates retrying a NS lifecycle management operation  if that operation has experienced a temporary failure, i.e. the related \"NS LCM operation occurrence\" is in \"FAILED_TEMP\" state. This method shall follow the provisions specified in the Tables 6.4.11.3.1-1 and 6.4.11.3.1-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.retry_ns_instance(ns_lcm_op_occ_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str ns_lcm_op_occ_id: Identifier of a NS lifecycle management operation occurrence to be retried. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request triggering a NS LCM operation. It can also be retrieved from the \"nsLcmOpOccId\" attribute in the NsLcmOperationOccurrenceNotification.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.retry_ns_instance_with_http_info(ns_lcm_op_occ_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.retry_ns_instance_with_http_info(ns_lcm_op_occ_id, version, **kwargs)  # noqa: E501
            return data

    def retry_ns_instance_with_http_info(self, ns_lcm_op_occ_id, version, **kwargs):  # noqa: E501
        """Retry a NS lifecycle management operation occurrence.  # noqa: E501

        The POST method initiates retrying a NS lifecycle management operation  if that operation has experienced a temporary failure, i.e. the related \"NS LCM operation occurrence\" is in \"FAILED_TEMP\" state. This method shall follow the provisions specified in the Tables 6.4.11.3.1-1 and 6.4.11.3.1-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.retry_ns_instance_with_http_info(ns_lcm_op_occ_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str ns_lcm_op_occ_id: Identifier of a NS lifecycle management operation occurrence to be retried. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request triggering a NS LCM operation. It can also be retrieved from the \"nsLcmOpOccId\" attribute in the NsLcmOperationOccurrenceNotification.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['ns_lcm_op_occ_id', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method retry_ns_instance" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'ns_lcm_op_occ_id' is set
        if ('ns_lcm_op_occ_id' not in params or
                params['ns_lcm_op_occ_id'] is None):
            raise ValueError("Missing the required parameter `ns_lcm_op_occ_id` when calling `retry_ns_instance`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `retry_ns_instance`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'ns_lcm_op_occ_id' in params:
            path_params['nsLcmOpOccId'] = params['ns_lcm_op_occ_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_lcm_op_occs/{nsLcmOpOccId}/retry', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def rollback_ns_instance(self, ns_lcm_op_occ_id, version, **kwargs):  # noqa: E501
        """Rollback a NS lifecycle management operation occurrence.  # noqa: E501

        The POST method initiates rolling back a NS lifecycle operation  if that operation has experienced a temporary failure, i.e. the related \"NS LCM operation occurrence\" is in \"FAILED_TEMP\" state. This method shall follow the provisions specified in the Tables 6.4.12.3.1-1 and 6.4.12.3.1-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.rollback_ns_instance(ns_lcm_op_occ_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str ns_lcm_op_occ_id: Identifier of a NS lifecycle management operation occurrence to be rolled back. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request triggering a NS LCM operation. It can also be retrieved from the \"nsLcmOpOccId\" attribute in the NsLcmOperationOccurrenceNotification.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.rollback_ns_instance_with_http_info(ns_lcm_op_occ_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.rollback_ns_instance_with_http_info(ns_lcm_op_occ_id, version, **kwargs)  # noqa: E501
            return data

    def rollback_ns_instance_with_http_info(self, ns_lcm_op_occ_id, version, **kwargs):  # noqa: E501
        """Rollback a NS lifecycle management operation occurrence.  # noqa: E501

        The POST method initiates rolling back a NS lifecycle operation  if that operation has experienced a temporary failure, i.e. the related \"NS LCM operation occurrence\" is in \"FAILED_TEMP\" state. This method shall follow the provisions specified in the Tables 6.4.12.3.1-1 and 6.4.12.3.1-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.rollback_ns_instance_with_http_info(ns_lcm_op_occ_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str ns_lcm_op_occ_id: Identifier of a NS lifecycle management operation occurrence to be rolled back. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request triggering a NS LCM operation. It can also be retrieved from the \"nsLcmOpOccId\" attribute in the NsLcmOperationOccurrenceNotification.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['ns_lcm_op_occ_id', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method rollback_ns_instance" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'ns_lcm_op_occ_id' is set
        if ('ns_lcm_op_occ_id' not in params or
                params['ns_lcm_op_occ_id'] is None):
            raise ValueError("Missing the required parameter `ns_lcm_op_occ_id` when calling `rollback_ns_instance`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `rollback_ns_instance`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'ns_lcm_op_occ_id' in params:
            path_params['nsLcmOpOccId'] = params['ns_lcm_op_occ_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_lcm_op_occs/{nsLcmOpOccId}/rollback', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def scale_ns(self, body, accept, content_type, version, ns_instance_id, **kwargs):  # noqa: E501
        """Scale a NS instance.  # noqa: E501

        The POST method requests to scale a NS instance resource. The steps and conditions that apply as the result of successfully executing this method are specified in clause 6.4.1.2. In addition, once the NFVO has successfully completed the underlying NS LCM operation occurrence, it shall reflect the result of scaling the NS instance by updating the \"nsScaleStatus\" attribute in the representation of the \"Individual NS instance\" resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.scale_ns(body, accept, content_type, version, ns_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ScaleNsRequest body: Parameters for the scale NS operation, as defined in clause 6.5.2.14.
 (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str ns_instance_id: Identifier of the NS instance to be scaled.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.scale_ns_with_http_info(body, accept, content_type, version, ns_instance_id, **kwargs)  # noqa: E501
        else:
            (data) = self.scale_ns_with_http_info(body, accept, content_type, version, ns_instance_id, **kwargs)  # noqa: E501
            return data

    def scale_ns_with_http_info(self, body, accept, content_type, version, ns_instance_id, **kwargs):  # noqa: E501
        """Scale a NS instance.  # noqa: E501

        The POST method requests to scale a NS instance resource. The steps and conditions that apply as the result of successfully executing this method are specified in clause 6.4.1.2. In addition, once the NFVO has successfully completed the underlying NS LCM operation occurrence, it shall reflect the result of scaling the NS instance by updating the \"nsScaleStatus\" attribute in the representation of the \"Individual NS instance\" resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.scale_ns_with_http_info(body, accept, content_type, version, ns_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ScaleNsRequest body: Parameters for the scale NS operation, as defined in clause 6.5.2.14.
 (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str ns_instance_id: Identifier of the NS instance to be scaled.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type', 'version', 'ns_instance_id', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method scale_ns" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `scale_ns`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `scale_ns`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `scale_ns`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `scale_ns`")  # noqa: E501
        # verify the required parameter 'ns_instance_id' is set
        if ('ns_instance_id' not in params or
                params['ns_instance_id'] is None):
            raise ValueError("Missing the required parameter `ns_instance_id` when calling `scale_ns`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'ns_instance_id' in params:
            path_params['nsInstanceId'] = params['ns_instance_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_instances/{nsInstanceId}/scale', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def subscriptions_get(self, version, accept, **kwargs):  # noqa: E501
        """Query multiple subscriptions.  # noqa: E501

        Query Subscription Information. The GET method queries the list of active subscriptions of the functional block that invokes the method. It can be used e.g. for resynchronization after error situations.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_get(version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV SOL 013. The NFVO shall support receiving this parameter as part of the URI query string. The OSS/BSS may supply this parameter. All attribute names that appear in the LccnSubscription and in data types  referenced from it shall be supported by the NFVO in the filter expression. 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the NFVO if the NFVO supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV SOL 013 for this resource. 


        :return: list[LccnSubscription]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.subscriptions_get_with_http_info(version, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.subscriptions_get_with_http_info(version, accept, **kwargs)  # noqa: E501
            return data

    def subscriptions_get_with_http_info(self, version, accept, **kwargs):  # noqa: E501
        """Query multiple subscriptions.  # noqa: E501

        Query Subscription Information. The GET method queries the list of active subscriptions of the functional block that invokes the method. It can be used e.g. for resynchronization after error situations.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_get_with_http_info(version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV SOL 013. The NFVO shall support receiving this parameter as part of the URI query string. The OSS/BSS may supply this parameter. All attribute names that appear in the LccnSubscription and in data types  referenced from it shall be supported by the NFVO in the filter expression. 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the NFVO if the NFVO supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV SOL 013 for this resource. 


        :return: list[LccnSubscription]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version', 'accept', 'authorization', 'filter', 'nextpage_opaque_marker']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method subscriptions_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `subscriptions_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `subscriptions_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'nextpage_opaque_marker' in params:
            query_params.append(('nextpage_opaque_marker', params['nextpage_opaque_marker']))  # noqa: E501

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/subscriptions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[LccnSubscription]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def subscriptions_post(self, body, version, accept, content_type, **kwargs):  # noqa: E501
        """Subscribe to NS lifecycle change notifications.  # noqa: E501

        The POST method creates a new subscription. This method shall support the URI query parameters, request and response data structures, and response codes, as specified in the Tables 6.4.16.3.1-1 and 6.4.16.3.1-2. Creation of two subscription resources with the same callbackURI and the same filter can result in performance degradation and will provide duplicates of notifications to the OSS, and might make sense only in very rare use cases. Consequently, the NFVO may either allow creating a subscription resource if another subscription resource with the same filter and callbackUri already exists (in which case it shall return the \"201 Created\" response code), or may decide to not create a duplicate subscription resource (in which case it shall return a \"303 See Other\" response code referencing the existing subscription resource with the same filter and callbackUri).   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_post(body, version, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param LccnSubscriptionRequest body: Details of the subscription to be created, as defined in clause 6.5.2.2.
 (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: LccnSubscription
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.subscriptions_post_with_http_info(body, version, accept, content_type, **kwargs)  # noqa: E501
        else:
            (data) = self.subscriptions_post_with_http_info(body, version, accept, content_type, **kwargs)  # noqa: E501
            return data

    def subscriptions_post_with_http_info(self, body, version, accept, content_type, **kwargs):  # noqa: E501
        """Subscribe to NS lifecycle change notifications.  # noqa: E501

        The POST method creates a new subscription. This method shall support the URI query parameters, request and response data structures, and response codes, as specified in the Tables 6.4.16.3.1-1 and 6.4.16.3.1-2. Creation of two subscription resources with the same callbackURI and the same filter can result in performance degradation and will provide duplicates of notifications to the OSS, and might make sense only in very rare use cases. Consequently, the NFVO may either allow creating a subscription resource if another subscription resource with the same filter and callbackUri already exists (in which case it shall return the \"201 Created\" response code), or may decide to not create a duplicate subscription resource (in which case it shall return a \"303 See Other\" response code referencing the existing subscription resource with the same filter and callbackUri).   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_post_with_http_info(body, version, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param LccnSubscriptionRequest body: Details of the subscription to be created, as defined in clause 6.5.2.2.
 (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: LccnSubscription
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'version', 'accept', 'content_type', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method subscriptions_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `subscriptions_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `subscriptions_post`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `subscriptions_post`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `subscriptions_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/subscriptions', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='LccnSubscription',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def subscriptions_subscription_id_delete(self, subscription_id, version, **kwargs):  # noqa: E501
        """Terminate a subscription.  # noqa: E501

        The DELETE method terminates an individual subscription. This method shall support the URI query parameters, request and response data structures, and response codes, as specified in the Tables 6.4.17.3.5-1 and 6.4.17.3.5-2. As the result of successfully executing this method, the \"Individual subscription\" resource shall not exist any longer. This means that no notifications for that subscription shall be sent to the formerly-subscribed API consumer. NOTE: Due to race conditions, some notifications might still be received by the formerly-subscribed API consumer for a certain time period after the deletion.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_subscription_id_delete(subscription_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str subscription_id: Identifier of this subscription.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.subscriptions_subscription_id_delete_with_http_info(subscription_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.subscriptions_subscription_id_delete_with_http_info(subscription_id, version, **kwargs)  # noqa: E501
            return data

    def subscriptions_subscription_id_delete_with_http_info(self, subscription_id, version, **kwargs):  # noqa: E501
        """Terminate a subscription.  # noqa: E501

        The DELETE method terminates an individual subscription. This method shall support the URI query parameters, request and response data structures, and response codes, as specified in the Tables 6.4.17.3.5-1 and 6.4.17.3.5-2. As the result of successfully executing this method, the \"Individual subscription\" resource shall not exist any longer. This means that no notifications for that subscription shall be sent to the formerly-subscribed API consumer. NOTE: Due to race conditions, some notifications might still be received by the formerly-subscribed API consumer for a certain time period after the deletion.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_subscription_id_delete_with_http_info(subscription_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str subscription_id: Identifier of this subscription.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['subscription_id', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method subscriptions_subscription_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'subscription_id' is set
        if ('subscription_id' not in params or
                params['subscription_id'] is None):
            raise ValueError("Missing the required parameter `subscription_id` when calling `subscriptions_subscription_id_delete`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `subscriptions_subscription_id_delete`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'subscription_id' in params:
            path_params['subscriptionId'] = params['subscription_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/subscriptions/{subscriptionId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def subscriptions_subscription_id_get(self, subscription_id, version, accept, **kwargs):  # noqa: E501
        """Read an individual subscription resource.  # noqa: E501

        The GET method retrieves information about a subscription by reading an individual subscription resource. This method shall support the URI query parameters, request and response data structures, and response codes, as specified in the Tables 6.4.17.3.2-1 and 6.4.17.3.2-2   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_subscription_id_get(subscription_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str subscription_id: Identifier of this subscription.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: LccnSubscription
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.subscriptions_subscription_id_get_with_http_info(subscription_id, version, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.subscriptions_subscription_id_get_with_http_info(subscription_id, version, accept, **kwargs)  # noqa: E501
            return data

    def subscriptions_subscription_id_get_with_http_info(self, subscription_id, version, accept, **kwargs):  # noqa: E501
        """Read an individual subscription resource.  # noqa: E501

        The GET method retrieves information about a subscription by reading an individual subscription resource. This method shall support the URI query parameters, request and response data structures, and response codes, as specified in the Tables 6.4.17.3.2-1 and 6.4.17.3.2-2   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_subscription_id_get_with_http_info(subscription_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str subscription_id: Identifier of this subscription.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: LccnSubscription
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['subscription_id', 'version', 'accept', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method subscriptions_subscription_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'subscription_id' is set
        if ('subscription_id' not in params or
                params['subscription_id'] is None):
            raise ValueError("Missing the required parameter `subscription_id` when calling `subscriptions_subscription_id_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `subscriptions_subscription_id_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `subscriptions_subscription_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'subscription_id' in params:
            path_params['subscriptionId'] = params['subscription_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/subscriptions/{subscriptionId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='LccnSubscription',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def terminate_ns(self, body, accept, content_type, version, ns_instance_id, **kwargs):  # noqa: E501
        """Terminate a NS instance.  # noqa: E501

        Terminate NS task.   The POST method terminates an NS instance. This method shall follow the provisions specified in the Tables 6.4.8.3.1-1 and 6.4.8.3.1-2 for URI query parameters, request and response data structures, and response codes. The steps and conditions that apply as the result of successfully executing this method are specified in clause 6.4.1.2. In addition, once the NFVO has successfully completed the underlying NS LCM operation occurrence, it shall set the \"nsState\" attribute in the representation of the \"Individual NS instance\" resource to the value \"NOT_INSTANTIATED\". This method can only be used with an NS instance in the INSTANTIATED state. Terminating an NS instance does not delete the NS instance identifier, but rather transitions the NS into the NOT_INSTANTIATED state.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.terminate_ns(body, accept, content_type, version, ns_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param TerminateNsRequest body: The terminate NS request parameters, as defined in  clause 6.5.2.15.
 (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str ns_instance_id: The identifier of the NS instance to be terminated.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.terminate_ns_with_http_info(body, accept, content_type, version, ns_instance_id, **kwargs)  # noqa: E501
        else:
            (data) = self.terminate_ns_with_http_info(body, accept, content_type, version, ns_instance_id, **kwargs)  # noqa: E501
            return data

    def terminate_ns_with_http_info(self, body, accept, content_type, version, ns_instance_id, **kwargs):  # noqa: E501
        """Terminate a NS instance.  # noqa: E501

        Terminate NS task.   The POST method terminates an NS instance. This method shall follow the provisions specified in the Tables 6.4.8.3.1-1 and 6.4.8.3.1-2 for URI query parameters, request and response data structures, and response codes. The steps and conditions that apply as the result of successfully executing this method are specified in clause 6.4.1.2. In addition, once the NFVO has successfully completed the underlying NS LCM operation occurrence, it shall set the \"nsState\" attribute in the representation of the \"Individual NS instance\" resource to the value \"NOT_INSTANTIATED\". This method can only be used with an NS instance in the INSTANTIATED state. Terminating an NS instance does not delete the NS instance identifier, but rather transitions the NS into the NOT_INSTANTIATED state.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.terminate_ns_with_http_info(body, accept, content_type, version, ns_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param TerminateNsRequest body: The terminate NS request parameters, as defined in  clause 6.5.2.15.
 (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str ns_instance_id: The identifier of the NS instance to be terminated.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type', 'version', 'ns_instance_id', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method terminate_ns" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `terminate_ns`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `terminate_ns`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `terminate_ns`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `terminate_ns`")  # noqa: E501
        # verify the required parameter 'ns_instance_id' is set
        if ('ns_instance_id' not in params or
                params['ns_instance_id'] is None):
            raise ValueError("Missing the required parameter `ns_instance_id` when calling `terminate_ns`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'ns_instance_id' in params:
            path_params['nsInstanceId'] = params['ns_instance_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/ns_instances/{nsInstanceId}/terminate', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
