# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class AddPnfData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'pnf_id': 'Identifier',
        'pnf_name': 'str',
        'pnfd_id': 'Identifier',
        'pnf_profile_id': 'IdentifierInNsd',
        'cp_data': 'list[PnfExtCpData]'
    }

    attribute_map = {
        'pnf_id': 'pnfId',
        'pnf_name': 'pnfName',
        'pnfd_id': 'pnfdId',
        'pnf_profile_id': 'pnfProfileId',
        'cp_data': 'cpData'
    }

    def __init__(self, pnf_id=None, pnf_name=None, pnfd_id=None, pnf_profile_id=None, cp_data=None):  # noqa: E501
        """AddPnfData - a model defined in Swagger"""  # noqa: E501
        self._pnf_id = None
        self._pnf_name = None
        self._pnfd_id = None
        self._pnf_profile_id = None
        self._cp_data = None
        self.discriminator = None
        self.pnf_id = pnf_id
        self.pnf_name = pnf_name
        self.pnfd_id = pnfd_id
        self.pnf_profile_id = pnf_profile_id
        if cp_data is not None:
            self.cp_data = cp_data

    @property
    def pnf_id(self):
        """Gets the pnf_id of this AddPnfData.  # noqa: E501


        :return: The pnf_id of this AddPnfData.  # noqa: E501
        :rtype: Identifier
        """
        return self._pnf_id

    @pnf_id.setter
    def pnf_id(self, pnf_id):
        """Sets the pnf_id of this AddPnfData.


        :param pnf_id: The pnf_id of this AddPnfData.  # noqa: E501
        :type: Identifier
        """
        if pnf_id is None:
            print("WARNING: Invalid value for the required field `pnf_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `pnf_id`, must not be `None`")  # noqa: E501

        self._pnf_id = pnf_id

    @property
    def pnf_name(self):
        """Gets the pnf_name of this AddPnfData.  # noqa: E501

        Name of the PNF   # noqa: E501

        :return: The pnf_name of this AddPnfData.  # noqa: E501
        :rtype: str
        """
        return self._pnf_name

    @pnf_name.setter
    def pnf_name(self, pnf_name):
        """Sets the pnf_name of this AddPnfData.

        Name of the PNF   # noqa: E501

        :param pnf_name: The pnf_name of this AddPnfData.  # noqa: E501
        :type: str
        """
        if pnf_name is None:
            print("WARNING: Invalid value for the required field `pnf_name`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `pnf_name`, must not be `None`")  # noqa: E501

        self._pnf_name = pnf_name

    @property
    def pnfd_id(self):
        """Gets the pnfd_id of this AddPnfData.  # noqa: E501


        :return: The pnfd_id of this AddPnfData.  # noqa: E501
        :rtype: Identifier
        """
        return self._pnfd_id

    @pnfd_id.setter
    def pnfd_id(self, pnfd_id):
        """Sets the pnfd_id of this AddPnfData.


        :param pnfd_id: The pnfd_id of this AddPnfData.  # noqa: E501
        :type: Identifier
        """
        if pnfd_id is None:
            print("WARNING: Invalid value for the required field `pnfd_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `pnfd_id`, must not be `None`")  # noqa: E501

        self._pnfd_id = pnfd_id

    @property
    def pnf_profile_id(self):
        """Gets the pnf_profile_id of this AddPnfData.  # noqa: E501


        :return: The pnf_profile_id of this AddPnfData.  # noqa: E501
        :rtype: IdentifierInNsd
        """
        return self._pnf_profile_id

    @pnf_profile_id.setter
    def pnf_profile_id(self, pnf_profile_id):
        """Sets the pnf_profile_id of this AddPnfData.


        :param pnf_profile_id: The pnf_profile_id of this AddPnfData.  # noqa: E501
        :type: IdentifierInNsd
        """
        if pnf_profile_id is None:
            print("WARNING: Invalid value for the required field `pnf_profile_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `pnf_profile_id`, must not be `None`")  # noqa: E501

        self._pnf_profile_id = pnf_profile_id

    @property
    def cp_data(self):
        """Gets the cp_data of this AddPnfData.  # noqa: E501

        Address assigned for the PNF external CP(s).   # noqa: E501

        :return: The cp_data of this AddPnfData.  # noqa: E501
        :rtype: list[PnfExtCpData]
        """
        return self._cp_data

    @cp_data.setter
    def cp_data(self, cp_data):
        """Sets the cp_data of this AddPnfData.

        Address assigned for the PNF external CP(s).   # noqa: E501

        :param cp_data: The cp_data of this AddPnfData.  # noqa: E501
        :type: list[PnfExtCpData]
        """

        self._cp_data = cp_data

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AddPnfData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AddPnfData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
