# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class AffectedNs(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'ns_instance_id': 'Identifier',
        'nsd_id': 'Identifier',
        'change_type': 'str',
        'change_result': 'str'
    }

    attribute_map = {
        'ns_instance_id': 'nsInstanceId',
        'nsd_id': 'nsdId',
        'change_type': 'changeType',
        'change_result': 'changeResult'
    }

    def __init__(self, ns_instance_id=None, nsd_id=None, change_type=None, change_result=None):  # noqa: E501
        """AffectedNs - a model defined in Swagger"""  # noqa: E501
        self._ns_instance_id = None
        self._nsd_id = None
        self._change_type = None
        self._change_result = None
        self.discriminator = None
        self.ns_instance_id = ns_instance_id
        self.nsd_id = nsd_id
        self.change_type = change_type
        self.change_result = change_result

    @property
    def ns_instance_id(self):
        """Gets the ns_instance_id of this AffectedNs.  # noqa: E501


        :return: The ns_instance_id of this AffectedNs.  # noqa: E501
        :rtype: Identifier
        """
        return self._ns_instance_id

    @ns_instance_id.setter
    def ns_instance_id(self, ns_instance_id):
        """Sets the ns_instance_id of this AffectedNs.


        :param ns_instance_id: The ns_instance_id of this AffectedNs.  # noqa: E501
        :type: Identifier
        """
        if ns_instance_id is None:
            print("WARNING: Invalid value for the required field `ns_instance_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `ns_instance_id`, must not be `None`")  # noqa: E501

        self._ns_instance_id = ns_instance_id

    @property
    def nsd_id(self):
        """Gets the nsd_id of this AffectedNs.  # noqa: E501


        :return: The nsd_id of this AffectedNs.  # noqa: E501
        :rtype: Identifier
        """
        return self._nsd_id

    @nsd_id.setter
    def nsd_id(self, nsd_id):
        """Sets the nsd_id of this AffectedNs.


        :param nsd_id: The nsd_id of this AffectedNs.  # noqa: E501
        :type: Identifier
        """
        if nsd_id is None:
            print("WARNING: Invalid value for the required field `nsd_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `nsd_id`, must not be `None`")  # noqa: E501

        self._nsd_id = nsd_id

    @property
    def change_type(self):
        """Gets the change_type of this AffectedNs.  # noqa: E501

        Signals the type of lifecycle change. Permitted values: - ADD - REMOVE - INSTANTIATE - SCALE - UPDATE - HEAL - TERMINATE   # noqa: E501

        :return: The change_type of this AffectedNs.  # noqa: E501
        :rtype: str
        """
        return self._change_type

    @change_type.setter
    def change_type(self, change_type):
        """Sets the change_type of this AffectedNs.

        Signals the type of lifecycle change. Permitted values: - ADD - REMOVE - INSTANTIATE - SCALE - UPDATE - HEAL - TERMINATE   # noqa: E501

        :param change_type: The change_type of this AffectedNs.  # noqa: E501
        :type: str
        """
        if change_type is None:
            print("WARNING: Invalid value for the required field `change_type`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `change_type`, must not be `None`")  # noqa: E501
        allowed_values = ["ADD", "REMOVE", "INSTANTIATE", "SCALE", "UPDATE", "HEAL", "TERMINATE"]  # noqa: E501
        if change_type is not None and change_type not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `change_type` ({0}), must be one of {1}"  # noqa: E501
                .format(change_type, allowed_values)
            )

        self._change_type = change_type

    @property
    def change_result(self):
        """Gets the change_result of this AffectedNs.  # noqa: E501

        Signals the result of change identified by the \"changeType\" attribute. Permitted values: - COMPLETED - ROLLED_BACK - FAILED - PARTIALLY_COMPLETED   # noqa: E501

        :return: The change_result of this AffectedNs.  # noqa: E501
        :rtype: str
        """
        return self._change_result

    @change_result.setter
    def change_result(self, change_result):
        """Sets the change_result of this AffectedNs.

        Signals the result of change identified by the \"changeType\" attribute. Permitted values: - COMPLETED - ROLLED_BACK - FAILED - PARTIALLY_COMPLETED   # noqa: E501

        :param change_result: The change_result of this AffectedNs.  # noqa: E501
        :type: str
        """
        if change_result is None:
            print("WARNING: Invalid value for the required field `change_result`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `change_result`, must not be `None`")  # noqa: E501
        allowed_values = ["COMPLETED", "ROLLED_BACK", "FAILED", "PARTIALLY_COMPLETED"]  # noqa: E501
        if change_result is not None and change_result not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `change_result` ({0}), must be one of {1}"  # noqa: E501
                .format(change_result, allowed_values)
            )

        self._change_result = change_result

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AffectedNs, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AffectedNs):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
