# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class AffectedPnf(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'pnf_id': 'Identifier',
        'pnfd_id': 'IdentifierInNsd',
        'pnf_profile_id': 'IdentifierInNsd',
        'pnf_name': 'str',
        'cp_instance_id': 'list[IdentifierInPnf]',
        'change_type': 'str',
        'change_result': 'str'
    }

    attribute_map = {
        'pnf_id': 'pnfId',
        'pnfd_id': 'pnfdId',
        'pnf_profile_id': 'pnfProfileId',
        'pnf_name': 'pnfName',
        'cp_instance_id': 'cpInstanceId',
        'change_type': 'changeType',
        'change_result': 'changeResult'
    }

    def __init__(self, pnf_id=None, pnfd_id=None, pnf_profile_id=None, pnf_name=None, cp_instance_id=None, change_type=None, change_result=None):  # noqa: E501
        """AffectedPnf - a model defined in Swagger"""  # noqa: E501
        self._pnf_id = None
        self._pnfd_id = None
        self._pnf_profile_id = None
        self._pnf_name = None
        self._cp_instance_id = None
        self._change_type = None
        self._change_result = None
        self.discriminator = None
        self.pnf_id = pnf_id
        self.pnfd_id = pnfd_id
        self.pnf_profile_id = pnf_profile_id
        if pnf_name is not None:
            self.pnf_name = pnf_name
        self.cp_instance_id = cp_instance_id
        if change_type is not None:
            self.change_type = change_type
        if change_result is not None:
            self.change_result = change_result

    @property
    def pnf_id(self):
        """Gets the pnf_id of this AffectedPnf.  # noqa: E501


        :return: The pnf_id of this AffectedPnf.  # noqa: E501
        :rtype: Identifier
        """
        return self._pnf_id

    @pnf_id.setter
    def pnf_id(self, pnf_id):
        """Sets the pnf_id of this AffectedPnf.


        :param pnf_id: The pnf_id of this AffectedPnf.  # noqa: E501
        :type: Identifier
        """
        if pnf_id is None:
            print("WARNING: Invalid value for the required field `pnf_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `pnf_id`, must not be `None`")  # noqa: E501

        self._pnf_id = pnf_id

    @property
    def pnfd_id(self):
        """Gets the pnfd_id of this AffectedPnf.  # noqa: E501


        :return: The pnfd_id of this AffectedPnf.  # noqa: E501
        :rtype: IdentifierInNsd
        """
        return self._pnfd_id

    @pnfd_id.setter
    def pnfd_id(self, pnfd_id):
        """Sets the pnfd_id of this AffectedPnf.


        :param pnfd_id: The pnfd_id of this AffectedPnf.  # noqa: E501
        :type: IdentifierInNsd
        """
        if pnfd_id is None:
            print("WARNING: Invalid value for the required field `pnfd_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `pnfd_id`, must not be `None`")  # noqa: E501

        self._pnfd_id = pnfd_id

    @property
    def pnf_profile_id(self):
        """Gets the pnf_profile_id of this AffectedPnf.  # noqa: E501


        :return: The pnf_profile_id of this AffectedPnf.  # noqa: E501
        :rtype: IdentifierInNsd
        """
        return self._pnf_profile_id

    @pnf_profile_id.setter
    def pnf_profile_id(self, pnf_profile_id):
        """Sets the pnf_profile_id of this AffectedPnf.


        :param pnf_profile_id: The pnf_profile_id of this AffectedPnf.  # noqa: E501
        :type: IdentifierInNsd
        """
        if pnf_profile_id is None:
            print("WARNING: Invalid value for the required field `pnf_profile_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `pnf_profile_id`, must not be `None`")  # noqa: E501

        self._pnf_profile_id = pnf_profile_id

    @property
    def pnf_name(self):
        """Gets the pnf_name of this AffectedPnf.  # noqa: E501

        Name of the PNF.   # noqa: E501

        :return: The pnf_name of this AffectedPnf.  # noqa: E501
        :rtype: str
        """
        return self._pnf_name

    @pnf_name.setter
    def pnf_name(self, pnf_name):
        """Sets the pnf_name of this AffectedPnf.

        Name of the PNF.   # noqa: E501

        :param pnf_name: The pnf_name of this AffectedPnf.  # noqa: E501
        :type: str
        """

        self._pnf_name = pnf_name

    @property
    def cp_instance_id(self):
        """Gets the cp_instance_id of this AffectedPnf.  # noqa: E501

        Identifier of the CP in the scope of the PNF.   # noqa: E501

        :return: The cp_instance_id of this AffectedPnf.  # noqa: E501
        :rtype: list[IdentifierInPnf]
        """
        return self._cp_instance_id

    @cp_instance_id.setter
    def cp_instance_id(self, cp_instance_id):
        """Sets the cp_instance_id of this AffectedPnf.

        Identifier of the CP in the scope of the PNF.   # noqa: E501

        :param cp_instance_id: The cp_instance_id of this AffectedPnf.  # noqa: E501
        :type: list[IdentifierInPnf]
        """
        if cp_instance_id is None:
            print("WARNING: Invalid value for the required field `cp_instance_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `cp_instance_id`, must not be `None`")  # noqa: E501

        self._cp_instance_id = cp_instance_id

    @property
    def change_type(self):
        """Gets the change_type of this AffectedPnf.  # noqa: E501

        Signals the type of change. Permitted values: - ADD - REMOVE - MODIFY   # noqa: E501

        :return: The change_type of this AffectedPnf.  # noqa: E501
        :rtype: str
        """
        return self._change_type

    @change_type.setter
    def change_type(self, change_type):
        """Sets the change_type of this AffectedPnf.

        Signals the type of change. Permitted values: - ADD - REMOVE - MODIFY   # noqa: E501

        :param change_type: The change_type of this AffectedPnf.  # noqa: E501
        :type: str
        """
        allowed_values = ["ADD", "REMOVE", "MODIFY"]  # noqa: E501
        if change_type is not None and change_type not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `change_type` ({0}), must be one of {1}"  # noqa: E501
                .format(change_type, allowed_values)
            )

        self._change_type = change_type

    @property
    def change_result(self):
        """Gets the change_result of this AffectedPnf.  # noqa: E501

        Signals the result of change identified by the \"changeType\" attribute. Permitted values: - COMPLETED - ROLLED_BACK - FAILED   # noqa: E501

        :return: The change_result of this AffectedPnf.  # noqa: E501
        :rtype: str
        """
        return self._change_result

    @change_result.setter
    def change_result(self, change_result):
        """Sets the change_result of this AffectedPnf.

        Signals the result of change identified by the \"changeType\" attribute. Permitted values: - COMPLETED - ROLLED_BACK - FAILED   # noqa: E501

        :param change_result: The change_result of this AffectedPnf.  # noqa: E501
        :type: str
        """
        allowed_values = ["COMPLETED", "ROLLED_BACK", "FAILED"]  # noqa: E501
        if change_result is not None and change_result not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `change_result` ({0}), must be one of {1}"  # noqa: E501
                .format(change_result, allowed_values)
            )

        self._change_result = change_result

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AffectedPnf, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AffectedPnf):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
