# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class AffectedSap(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'sap_instance_id': 'Identifier',
        'sapd_id': 'Identifier',
        'sap_name': 'str',
        'change_type': 'str',
        'change_result': 'str'
    }

    attribute_map = {
        'sap_instance_id': 'sapInstanceId',
        'sapd_id': 'sapdId',
        'sap_name': 'sapName',
        'change_type': 'changeType',
        'change_result': 'changeResult'
    }

    def __init__(self, sap_instance_id=None, sapd_id=None, sap_name=None, change_type=None, change_result=None):  # noqa: E501
        """AffectedSap - a model defined in Swagger"""  # noqa: E501
        self._sap_instance_id = None
        self._sapd_id = None
        self._sap_name = None
        self._change_type = None
        self._change_result = None
        self.discriminator = None
        self.sap_instance_id = sap_instance_id
        self.sapd_id = sapd_id
        if sap_name is not None:
            self.sap_name = sap_name
        if change_type is not None:
            self.change_type = change_type
        if change_result is not None:
            self.change_result = change_result

    @property
    def sap_instance_id(self):
        """Gets the sap_instance_id of this AffectedSap.  # noqa: E501


        :return: The sap_instance_id of this AffectedSap.  # noqa: E501
        :rtype: Identifier
        """
        return self._sap_instance_id

    @sap_instance_id.setter
    def sap_instance_id(self, sap_instance_id):
        """Sets the sap_instance_id of this AffectedSap.


        :param sap_instance_id: The sap_instance_id of this AffectedSap.  # noqa: E501
        :type: Identifier
        """
        if sap_instance_id is None:
            print("WARNING: Invalid value for the required field `sap_instance_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `sap_instance_id`, must not be `None`")  # noqa: E501

        self._sap_instance_id = sap_instance_id

    @property
    def sapd_id(self):
        """Gets the sapd_id of this AffectedSap.  # noqa: E501


        :return: The sapd_id of this AffectedSap.  # noqa: E501
        :rtype: Identifier
        """
        return self._sapd_id

    @sapd_id.setter
    def sapd_id(self, sapd_id):
        """Sets the sapd_id of this AffectedSap.


        :param sapd_id: The sapd_id of this AffectedSap.  # noqa: E501
        :type: Identifier
        """
        if sapd_id is None:
            print("WARNING: Invalid value for the required field `sapd_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `sapd_id`, must not be `None`")  # noqa: E501

        self._sapd_id = sapd_id

    @property
    def sap_name(self):
        """Gets the sap_name of this AffectedSap.  # noqa: E501

        Human readable name for the SAP.   # noqa: E501

        :return: The sap_name of this AffectedSap.  # noqa: E501
        :rtype: str
        """
        return self._sap_name

    @sap_name.setter
    def sap_name(self, sap_name):
        """Sets the sap_name of this AffectedSap.

        Human readable name for the SAP.   # noqa: E501

        :param sap_name: The sap_name of this AffectedSap.  # noqa: E501
        :type: str
        """

        self._sap_name = sap_name

    @property
    def change_type(self):
        """Gets the change_type of this AffectedSap.  # noqa: E501

        Signals the type of lifecycle change. Permitted values: - ADD - REMOVE - MODIFY   # noqa: E501

        :return: The change_type of this AffectedSap.  # noqa: E501
        :rtype: str
        """
        return self._change_type

    @change_type.setter
    def change_type(self, change_type):
        """Sets the change_type of this AffectedSap.

        Signals the type of lifecycle change. Permitted values: - ADD - REMOVE - MODIFY   # noqa: E501

        :param change_type: The change_type of this AffectedSap.  # noqa: E501
        :type: str
        """
        allowed_values = ["ADD", "REMOVE", "MODIFY"]  # noqa: E501
        if change_type is not None and change_type not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `change_type` ({0}), must be one of {1}"  # noqa: E501
                .format(change_type, allowed_values)
            )

        self._change_type = change_type

    @property
    def change_result(self):
        """Gets the change_result of this AffectedSap.  # noqa: E501

        Signals the result of change identified by the \"changeType\" attribute. Permitted values: - COMPLETED - ROLLED_BACK - FAILED   # noqa: E501

        :return: The change_result of this AffectedSap.  # noqa: E501
        :rtype: str
        """
        return self._change_result

    @change_result.setter
    def change_result(self, change_result):
        """Sets the change_result of this AffectedSap.

        Signals the result of change identified by the \"changeType\" attribute. Permitted values: - COMPLETED - ROLLED_BACK - FAILED   # noqa: E501

        :param change_result: The change_result of this AffectedSap.  # noqa: E501
        :type: str
        """
        allowed_values = ["COMPLETED", "ROLLED_BACK", "FAILED"]  # noqa: E501
        if change_result is not None and change_result not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `change_result` ({0}), must be one of {1}"  # noqa: E501
                .format(change_result, allowed_values)
            )

        self._change_result = change_result

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AffectedSap, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AffectedSap):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
