# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class AffectedVirtualLink(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'IdentifierInVnf',
        'virtual_link_desc_id': 'IdentifierInVnfd',
        'change_type': 'str',
        'network_resource': 'ResourceHandle',
        'metadata': 'KeyValuePairs'
    }

    attribute_map = {
        'id': 'id',
        'virtual_link_desc_id': 'virtualLinkDescId',
        'change_type': 'changeType',
        'network_resource': 'networkResource',
        'metadata': 'metadata'
    }

    def __init__(self, id=None, virtual_link_desc_id=None, change_type=None, network_resource=None, metadata=None):  # noqa: E501
        """AffectedVirtualLink - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._virtual_link_desc_id = None
        self._change_type = None
        self._network_resource = None
        self._metadata = None
        self.discriminator = None
        self.id = id
        self.virtual_link_desc_id = virtual_link_desc_id
        self.change_type = change_type
        self.network_resource = network_resource
        if metadata is not None:
            self.metadata = metadata

    @property
    def id(self):
        """Gets the id of this AffectedVirtualLink.  # noqa: E501


        :return: The id of this AffectedVirtualLink.  # noqa: E501
        :rtype: IdentifierInVnf
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AffectedVirtualLink.


        :param id: The id of this AffectedVirtualLink.  # noqa: E501
        :type: IdentifierInVnf
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def virtual_link_desc_id(self):
        """Gets the virtual_link_desc_id of this AffectedVirtualLink.  # noqa: E501


        :return: The virtual_link_desc_id of this AffectedVirtualLink.  # noqa: E501
        :rtype: IdentifierInVnfd
        """
        return self._virtual_link_desc_id

    @virtual_link_desc_id.setter
    def virtual_link_desc_id(self, virtual_link_desc_id):
        """Sets the virtual_link_desc_id of this AffectedVirtualLink.


        :param virtual_link_desc_id: The virtual_link_desc_id of this AffectedVirtualLink.  # noqa: E501
        :type: IdentifierInVnfd
        """
        if virtual_link_desc_id is None:
            print("WARNING: Invalid value for the required field `virtual_link_desc_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `virtual_link_desc_id`, must not be `None`")  # noqa: E501

        self._virtual_link_desc_id = virtual_link_desc_id

    @property
    def change_type(self):
        """Gets the change_type of this AffectedVirtualLink.  # noqa: E501

        Signals the type of change. Permitted values: * ADDED * REMOVED * MODIFIED * TEMPORARY * LINK_PORT_ADDED * LINK_PORT_REMOVED For a temporary resource, an AffectedVirtualLink structure exists as long as the temporary resource exists.   # noqa: E501

        :return: The change_type of this AffectedVirtualLink.  # noqa: E501
        :rtype: str
        """
        return self._change_type

    @change_type.setter
    def change_type(self, change_type):
        """Sets the change_type of this AffectedVirtualLink.

        Signals the type of change. Permitted values: * ADDED * REMOVED * MODIFIED * TEMPORARY * LINK_PORT_ADDED * LINK_PORT_REMOVED For a temporary resource, an AffectedVirtualLink structure exists as long as the temporary resource exists.   # noqa: E501

        :param change_type: The change_type of this AffectedVirtualLink.  # noqa: E501
        :type: str
        """
        if change_type is None:
            print("WARNING: Invalid value for the required field `change_type`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `change_type`, must not be `None`")  # noqa: E501
        allowed_values = ["ADDED", "REMOVED", "MODIFIED", "TEMPORARY", "LINK_PORT_ADDED", "LINK_PORT_REMOVED"]  # noqa: E501
        if change_type is not None and change_type not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `change_type` ({0}), must be one of {1}"  # noqa: E501
                .format(change_type, allowed_values)
            )

        self._change_type = change_type

    @property
    def network_resource(self):
        """Gets the network_resource of this AffectedVirtualLink.  # noqa: E501


        :return: The network_resource of this AffectedVirtualLink.  # noqa: E501
        :rtype: ResourceHandle
        """
        return self._network_resource

    @network_resource.setter
    def network_resource(self, network_resource):
        """Sets the network_resource of this AffectedVirtualLink.


        :param network_resource: The network_resource of this AffectedVirtualLink.  # noqa: E501
        :type: ResourceHandle
        """
        if network_resource is None:
            print("WARNING: Invalid value for the required field `network_resource`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `network_resource`, must not be `None`")  # noqa: E501

        self._network_resource = network_resource

    @property
    def metadata(self):
        """Gets the metadata of this AffectedVirtualLink.  # noqa: E501


        :return: The metadata of this AffectedVirtualLink.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this AffectedVirtualLink.


        :param metadata: The metadata of this AffectedVirtualLink.  # noqa: E501
        :type: KeyValuePairs
        """

        self._metadata = metadata

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AffectedVirtualLink, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AffectedVirtualLink):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
