# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class AffectedVnf(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnf_instance_id': 'Identifier',
        'vnfd_id': 'Identifier',
        'vnf_profile_id': 'IdentifierInNsd',
        'vnf_name': 'str',
        'change_type': 'str',
        'change_result': 'str',
        'changed_info': 'AffectedVnfChangedInfo'
    }

    attribute_map = {
        'vnf_instance_id': 'vnfInstanceId',
        'vnfd_id': 'vnfdId',
        'vnf_profile_id': 'vnfProfileId',
        'vnf_name': 'vnfName',
        'change_type': 'changeType',
        'change_result': 'changeResult',
        'changed_info': 'changedInfo'
    }

    def __init__(self, vnf_instance_id=None, vnfd_id=None, vnf_profile_id=None, vnf_name=None, change_type=None, change_result=None, changed_info=None):  # noqa: E501
        """AffectedVnf - a model defined in Swagger"""  # noqa: E501
        self._vnf_instance_id = None
        self._vnfd_id = None
        self._vnf_profile_id = None
        self._vnf_name = None
        self._change_type = None
        self._change_result = None
        self._changed_info = None
        self.discriminator = None
        self.vnf_instance_id = vnf_instance_id
        self.vnfd_id = vnfd_id
        self.vnf_profile_id = vnf_profile_id
        self.vnf_name = vnf_name
        self.change_type = change_type
        self.change_result = change_result
        if changed_info is not None:
            self.changed_info = changed_info

    @property
    def vnf_instance_id(self):
        """Gets the vnf_instance_id of this AffectedVnf.  # noqa: E501


        :return: The vnf_instance_id of this AffectedVnf.  # noqa: E501
        :rtype: Identifier
        """
        return self._vnf_instance_id

    @vnf_instance_id.setter
    def vnf_instance_id(self, vnf_instance_id):
        """Sets the vnf_instance_id of this AffectedVnf.


        :param vnf_instance_id: The vnf_instance_id of this AffectedVnf.  # noqa: E501
        :type: Identifier
        """
        if vnf_instance_id is None:
            print("WARNING: Invalid value for the required field `vnf_instance_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_instance_id`, must not be `None`")  # noqa: E501

        self._vnf_instance_id = vnf_instance_id

    @property
    def vnfd_id(self):
        """Gets the vnfd_id of this AffectedVnf.  # noqa: E501


        :return: The vnfd_id of this AffectedVnf.  # noqa: E501
        :rtype: Identifier
        """
        return self._vnfd_id

    @vnfd_id.setter
    def vnfd_id(self, vnfd_id):
        """Sets the vnfd_id of this AffectedVnf.


        :param vnfd_id: The vnfd_id of this AffectedVnf.  # noqa: E501
        :type: Identifier
        """
        if vnfd_id is None:
            print("WARNING: Invalid value for the required field `vnfd_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnfd_id`, must not be `None`")  # noqa: E501

        self._vnfd_id = vnfd_id

    @property
    def vnf_profile_id(self):
        """Gets the vnf_profile_id of this AffectedVnf.  # noqa: E501


        :return: The vnf_profile_id of this AffectedVnf.  # noqa: E501
        :rtype: IdentifierInNsd
        """
        return self._vnf_profile_id

    @vnf_profile_id.setter
    def vnf_profile_id(self, vnf_profile_id):
        """Sets the vnf_profile_id of this AffectedVnf.


        :param vnf_profile_id: The vnf_profile_id of this AffectedVnf.  # noqa: E501
        :type: IdentifierInNsd
        """
        if vnf_profile_id is None:
            print("WARNING: Invalid value for the required field `vnf_profile_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_profile_id`, must not be `None`")  # noqa: E501

        self._vnf_profile_id = vnf_profile_id

    @property
    def vnf_name(self):
        """Gets the vnf_name of this AffectedVnf.  # noqa: E501

        Name of the VNF Instance.   # noqa: E501

        :return: The vnf_name of this AffectedVnf.  # noqa: E501
        :rtype: str
        """
        return self._vnf_name

    @vnf_name.setter
    def vnf_name(self, vnf_name):
        """Sets the vnf_name of this AffectedVnf.

        Name of the VNF Instance.   # noqa: E501

        :param vnf_name: The vnf_name of this AffectedVnf.  # noqa: E501
        :type: str
        """
        if vnf_name is None:
            print("WARNING: Invalid value for the required field `vnf_name`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_name`, must not be `None`")  # noqa: E501

        self._vnf_name = vnf_name

    @property
    def change_type(self):
        """Gets the change_type of this AffectedVnf.  # noqa: E501

        Signals the type of change Permitted values: - ADD - REMOVE - INSTANTIATE - TERMINATE - SCALE - CHANGE_FLAVOUR - HEAL - OPERATE - MODIFY_INFORMATION - CHANGE_EXTERNAL_VNF_CONNECTIVITY   # noqa: E501

        :return: The change_type of this AffectedVnf.  # noqa: E501
        :rtype: str
        """
        return self._change_type

    @change_type.setter
    def change_type(self, change_type):
        """Sets the change_type of this AffectedVnf.

        Signals the type of change Permitted values: - ADD - REMOVE - INSTANTIATE - TERMINATE - SCALE - CHANGE_FLAVOUR - HEAL - OPERATE - MODIFY_INFORMATION - CHANGE_EXTERNAL_VNF_CONNECTIVITY   # noqa: E501

        :param change_type: The change_type of this AffectedVnf.  # noqa: E501
        :type: str
        """
        if change_type is None:
            print("WARNING: Invalid value for the required field `change_type`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `change_type`, must not be `None`")  # noqa: E501
        allowed_values = ["ADD", "REMOVE", "INSTANTIATE", "TERMINATE", "SCALE", "CHANGE_FLAVOUR", "HEAL", "OPERATE", "MODIFY_INFORMATION", "CHANGE_EXTERNAL_VNF_CONNECTIVITY"]  # noqa: E501
        if change_type is not None and change_type not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `change_type` ({0}), must be one of {1}"  # noqa: E501
                .format(change_type, allowed_values)
            )

        self._change_type = change_type

    @property
    def change_result(self):
        """Gets the change_result of this AffectedVnf.  # noqa: E501

        Signals the result of change identified by the \"changeType\" attribute. Permitted values: - COMPLETED - ROLLED_BACK - FAILED   # noqa: E501

        :return: The change_result of this AffectedVnf.  # noqa: E501
        :rtype: str
        """
        return self._change_result

    @change_result.setter
    def change_result(self, change_result):
        """Sets the change_result of this AffectedVnf.

        Signals the result of change identified by the \"changeType\" attribute. Permitted values: - COMPLETED - ROLLED_BACK - FAILED   # noqa: E501

        :param change_result: The change_result of this AffectedVnf.  # noqa: E501
        :type: str
        """
        if change_result is None:
            print("WARNING: Invalid value for the required field `change_result`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `change_result`, must not be `None`")  # noqa: E501
        allowed_values = ["COMPLETED", "ROLLED_BACK", "FAILED"]  # noqa: E501
        if change_result is not None and change_result not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `change_result` ({0}), must be one of {1}"  # noqa: E501
                .format(change_result, allowed_values)
            )

        self._change_result = change_result

    @property
    def changed_info(self):
        """Gets the changed_info of this AffectedVnf.  # noqa: E501


        :return: The changed_info of this AffectedVnf.  # noqa: E501
        :rtype: AffectedVnfChangedInfo
        """
        return self._changed_info

    @changed_info.setter
    def changed_info(self, changed_info):
        """Sets the changed_info of this AffectedVnf.


        :param changed_info: The changed_info of this AffectedVnf.  # noqa: E501
        :type: AffectedVnfChangedInfo
        """

        self._changed_info = changed_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AffectedVnf, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AffectedVnf):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
