# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class AffinityOrAntiAffinityRule(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnfd_id': 'list[Identifier]',
        'vnf_profile_id': 'list[IdentifierInNsd]',
        'vnf_instance_id': 'list[Identifier]',
        'affinity_or_anti_affiinty': 'str',
        'scope': 'str'
    }

    attribute_map = {
        'vnfd_id': 'vnfdId',
        'vnf_profile_id': 'vnfProfileId',
        'vnf_instance_id': 'vnfInstanceId',
        'affinity_or_anti_affiinty': 'affinityOrAntiAffiinty',
        'scope': 'scope'
    }

    def __init__(self, vnfd_id=None, vnf_profile_id=None, vnf_instance_id=None, affinity_or_anti_affiinty=None, scope=None):  # noqa: E501
        """AffinityOrAntiAffinityRule - a model defined in Swagger"""  # noqa: E501
        self._vnfd_id = None
        self._vnf_profile_id = None
        self._vnf_instance_id = None
        self._affinity_or_anti_affiinty = None
        self._scope = None
        self.discriminator = None
        if vnfd_id is not None:
            self.vnfd_id = vnfd_id
        if vnf_profile_id is not None:
            self.vnf_profile_id = vnf_profile_id
        if vnf_instance_id is not None:
            self.vnf_instance_id = vnf_instance_id
        self.affinity_or_anti_affiinty = affinity_or_anti_affiinty
        self.scope = scope

    @property
    def vnfd_id(self):
        """Gets the vnfd_id of this AffinityOrAntiAffinityRule.  # noqa: E501

        Reference to a VNFD. When the VNFD which is not used to instantiate VNF, it presents all VNF instances of this type as the subjects of the affinity or anti-affinity rule. The VNF instance which the VNFD presents is not necessary as a part of the NS to be instantiated.   # noqa: E501

        :return: The vnfd_id of this AffinityOrAntiAffinityRule.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._vnfd_id

    @vnfd_id.setter
    def vnfd_id(self, vnfd_id):
        """Sets the vnfd_id of this AffinityOrAntiAffinityRule.

        Reference to a VNFD. When the VNFD which is not used to instantiate VNF, it presents all VNF instances of this type as the subjects of the affinity or anti-affinity rule. The VNF instance which the VNFD presents is not necessary as a part of the NS to be instantiated.   # noqa: E501

        :param vnfd_id: The vnfd_id of this AffinityOrAntiAffinityRule.  # noqa: E501
        :type: list[Identifier]
        """

        self._vnfd_id = vnfd_id

    @property
    def vnf_profile_id(self):
        """Gets the vnf_profile_id of this AffinityOrAntiAffinityRule.  # noqa: E501

        Reference to a vnfProfile defined in the NSD. At least one VnfProfile which is used to instantiate VNF for the NS to be instantiated as the subject of the affinity or anti-affinity rule shall be present. When the VnfProfile which is not used to instantiate VNF, it presents all VNF instances of this type as the subjects of the affinity or anti-affinity rule. The VNF instance which the VnfProfile presents is not necessary as a part of the NS to be instantiated.   # noqa: E501

        :return: The vnf_profile_id of this AffinityOrAntiAffinityRule.  # noqa: E501
        :rtype: list[IdentifierInNsd]
        """
        return self._vnf_profile_id

    @vnf_profile_id.setter
    def vnf_profile_id(self, vnf_profile_id):
        """Sets the vnf_profile_id of this AffinityOrAntiAffinityRule.

        Reference to a vnfProfile defined in the NSD. At least one VnfProfile which is used to instantiate VNF for the NS to be instantiated as the subject of the affinity or anti-affinity rule shall be present. When the VnfProfile which is not used to instantiate VNF, it presents all VNF instances of this type as the subjects of the affinity or anti-affinity rule. The VNF instance which the VnfProfile presents is not necessary as a part of the NS to be instantiated.   # noqa: E501

        :param vnf_profile_id: The vnf_profile_id of this AffinityOrAntiAffinityRule.  # noqa: E501
        :type: list[IdentifierInNsd]
        """

        self._vnf_profile_id = vnf_profile_id

    @property
    def vnf_instance_id(self):
        """Gets the vnf_instance_id of this AffinityOrAntiAffinityRule.  # noqa: E501

        Reference to the existing VNF instance as the subject of the affinity or anti-affinity rule. The existing VNF instance is not necessary as a part of the NS to be instantiated.   # noqa: E501

        :return: The vnf_instance_id of this AffinityOrAntiAffinityRule.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._vnf_instance_id

    @vnf_instance_id.setter
    def vnf_instance_id(self, vnf_instance_id):
        """Sets the vnf_instance_id of this AffinityOrAntiAffinityRule.

        Reference to the existing VNF instance as the subject of the affinity or anti-affinity rule. The existing VNF instance is not necessary as a part of the NS to be instantiated.   # noqa: E501

        :param vnf_instance_id: The vnf_instance_id of this AffinityOrAntiAffinityRule.  # noqa: E501
        :type: list[Identifier]
        """

        self._vnf_instance_id = vnf_instance_id

    @property
    def affinity_or_anti_affiinty(self):
        """Gets the affinity_or_anti_affiinty of this AffinityOrAntiAffinityRule.  # noqa: E501

        The type of the constraint. Permitted values: AFFINITY ANTI_AFFINITY.   # noqa: E501

        :return: The affinity_or_anti_affiinty of this AffinityOrAntiAffinityRule.  # noqa: E501
        :rtype: str
        """
        return self._affinity_or_anti_affiinty

    @affinity_or_anti_affiinty.setter
    def affinity_or_anti_affiinty(self, affinity_or_anti_affiinty):
        """Sets the affinity_or_anti_affiinty of this AffinityOrAntiAffinityRule.

        The type of the constraint. Permitted values: AFFINITY ANTI_AFFINITY.   # noqa: E501

        :param affinity_or_anti_affiinty: The affinity_or_anti_affiinty of this AffinityOrAntiAffinityRule.  # noqa: E501
        :type: str
        """
        if affinity_or_anti_affiinty is None:
            print("WARNING: Invalid value for the required field `affinity_or_anti_affiinty`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `affinity_or_anti_affiinty`, must not be `None`")  # noqa: E501
        allowed_values = ["AFFINITY", "ANTI_AFFINITY"]  # noqa: E501
        if affinity_or_anti_affiinty is not None and affinity_or_anti_affiinty not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `affinity_or_anti_affiinty` ({0}), must be one of {1}"  # noqa: E501
                .format(affinity_or_anti_affiinty, allowed_values)
            )

        self._affinity_or_anti_affiinty = affinity_or_anti_affiinty

    @property
    def scope(self):
        """Gets the scope of this AffinityOrAntiAffinityRule.  # noqa: E501

        Specifies the scope of the rule where the placement constraint applies. Permitted values: NFVI_POP ZONE ZONE_GROUP NFVI_NODE.   # noqa: E501

        :return: The scope of this AffinityOrAntiAffinityRule.  # noqa: E501
        :rtype: str
        """
        return self._scope

    @scope.setter
    def scope(self, scope):
        """Sets the scope of this AffinityOrAntiAffinityRule.

        Specifies the scope of the rule where the placement constraint applies. Permitted values: NFVI_POP ZONE ZONE_GROUP NFVI_NODE.   # noqa: E501

        :param scope: The scope of this AffinityOrAntiAffinityRule.  # noqa: E501
        :type: str
        """
        if scope is None:
            print("WARNING: Invalid value for the required field `scope`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `scope`, must not be `None`")  # noqa: E501
        allowed_values = ["NFVI_POP", "ZONE", "ZONE_GROUP", "NFVI_NODE"]  # noqa: E501
        if scope is not None and scope not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `scope` ({0}), must be one of {1}"  # noqa: E501
                .format(scope, allowed_values)
            )

        self._scope = scope

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AffinityOrAntiAffinityRule, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AffinityOrAntiAffinityRule):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
