# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six
from tca.nslcm.model.key_value_pairs import KeyValuePairs  # noqa: F401,E501

class AllOfParamsForVnfAdditionalParams(KeyValuePairs):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'nf_type': 'str',
        'entity_prefix': 'str',
        'use_v_app_templates': 'bool',
        'catalog_name': 'str',
        'catalog_id': 'str',
        'vdu_params': 'list[VduParam]',
        'instantiation_level_id': 'str',
        'ext_virtual_links': 'list[ExtVirtualLinkData]',
        'node_profile_name': 'str',
        'vim_connection_info': 'list[VimConnectionInfo]',
        'lcm_interfaces': 'object',
        'is_vnf_v_app_template': 'bool',
        'v_app_template_name': 'str',
        'storage_profiles': 'list[str]'
    }
    if hasattr(KeyValuePairs, "swagger_types"):
        swagger_types.update(KeyValuePairs.swagger_types)

    attribute_map = {
        'nf_type': 'nfType',
        'entity_prefix': 'entityPrefix',
        'use_v_app_templates': 'useVAppTemplates',
        'catalog_name': 'catalogName',
        'catalog_id': 'catalogId',
        'vdu_params': 'vduParams',
        'instantiation_level_id': 'instantiationLevelId',
        'ext_virtual_links': 'extVirtualLinks',
        'node_profile_name': 'nodeProfileName',
        'vim_connection_info': 'vimConnectionInfo',
        'lcm_interfaces': 'lcmInterfaces',
        'is_vnf_v_app_template': 'isVnfVAppTemplate',
        'v_app_template_name': 'vAppTemplateName',
        'storage_profiles': 'storageProfiles'
    }
    if hasattr(KeyValuePairs, "attribute_map"):
        attribute_map.update(KeyValuePairs.attribute_map)

    def __init__(self, nf_type=None, entity_prefix=None, use_v_app_templates=None, catalog_name=None, catalog_id=None, vdu_params=None, instantiation_level_id=None, ext_virtual_links=None, node_profile_name=None, vim_connection_info=None, lcm_interfaces=None, is_vnf_v_app_template=None, v_app_template_name=None, storage_profiles=None, *args, **kwargs):  # noqa: E501
        """AllOfParamsForVnfAdditionalParams - a model defined in Swagger"""  # noqa: E501
        self._nf_type = None
        self._entity_prefix = None
        self._use_v_app_templates = None
        self._catalog_name = None
        self._catalog_id = None
        self._vdu_params = None
        self._instantiation_level_id = None
        self._ext_virtual_links = None
        self._node_profile_name = None
        self._vim_connection_info = None
        self._lcm_interfaces = None
        self._is_vnf_v_app_template = None
        self._v_app_template_name = None
        self._storage_profiles = None
        self.discriminator = None
        if nf_type is not None:
            self.nf_type = nf_type
        if entity_prefix is not None:
            self.entity_prefix = entity_prefix
        if use_v_app_templates is not None:
            self.use_v_app_templates = use_v_app_templates
        if catalog_name is not None:
            self.catalog_name = catalog_name
        if catalog_id is not None:
            self.catalog_id = catalog_id
        if vdu_params is not None:
            self.vdu_params = vdu_params
        if instantiation_level_id is not None:
            self.instantiation_level_id = instantiation_level_id
        if ext_virtual_links is not None:
            self.ext_virtual_links = ext_virtual_links
        if node_profile_name is not None:
            self.node_profile_name = node_profile_name
        if vim_connection_info is not None:
            self.vim_connection_info = vim_connection_info
        if lcm_interfaces is not None:
            self.lcm_interfaces = lcm_interfaces
        if is_vnf_v_app_template is not None:
            self.is_vnf_v_app_template = is_vnf_v_app_template
        if v_app_template_name is not None:
            self.v_app_template_name = v_app_template_name
        if storage_profiles is not None:
            self.storage_profiles = storage_profiles
        KeyValuePairs.__init__(self, *args, **kwargs)

    @property
    def nf_type(self):
        """Gets the nf_type of this AllOfParamsForVnfAdditionalParams.  # noqa: E501

        Vnf type, ex vnf/cnf  # noqa: E501

        :return: The nf_type of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :rtype: str
        """
        return self._nf_type

    @nf_type.setter
    def nf_type(self, nf_type):
        """Sets the nf_type of this AllOfParamsForVnfAdditionalParams.

        Vnf type, ex vnf/cnf  # noqa: E501

        :param nf_type: The nf_type of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :type: str
        """

        self._nf_type = nf_type

    @property
    def entity_prefix(self):
        """Gets the entity_prefix of this AllOfParamsForVnfAdditionalParams.  # noqa: E501


        :return: The entity_prefix of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :rtype: str
        """
        return self._entity_prefix

    @entity_prefix.setter
    def entity_prefix(self, entity_prefix):
        """Sets the entity_prefix of this AllOfParamsForVnfAdditionalParams.


        :param entity_prefix: The entity_prefix of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :type: str
        """

        self._entity_prefix = entity_prefix

    @property
    def use_v_app_templates(self):
        """Gets the use_v_app_templates of this AllOfParamsForVnfAdditionalParams.  # noqa: E501


        :return: The use_v_app_templates of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :rtype: bool
        """
        return self._use_v_app_templates

    @use_v_app_templates.setter
    def use_v_app_templates(self, use_v_app_templates):
        """Sets the use_v_app_templates of this AllOfParamsForVnfAdditionalParams.


        :param use_v_app_templates: The use_v_app_templates of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :type: bool
        """

        self._use_v_app_templates = use_v_app_templates

    @property
    def catalog_name(self):
        """Gets the catalog_name of this AllOfParamsForVnfAdditionalParams.  # noqa: E501


        :return: The catalog_name of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :rtype: str
        """
        return self._catalog_name

    @catalog_name.setter
    def catalog_name(self, catalog_name):
        """Sets the catalog_name of this AllOfParamsForVnfAdditionalParams.


        :param catalog_name: The catalog_name of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :type: str
        """

        self._catalog_name = catalog_name

    @property
    def catalog_id(self):
        """Gets the catalog_id of this AllOfParamsForVnfAdditionalParams.  # noqa: E501


        :return: The catalog_id of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :rtype: str
        """
        return self._catalog_id

    @catalog_id.setter
    def catalog_id(self, catalog_id):
        """Sets the catalog_id of this AllOfParamsForVnfAdditionalParams.


        :param catalog_id: The catalog_id of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :type: str
        """

        self._catalog_id = catalog_id

    @property
    def vdu_params(self):
        """Gets the vdu_params of this AllOfParamsForVnfAdditionalParams.  # noqa: E501


        :return: The vdu_params of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :rtype: list[VduParam]
        """
        return self._vdu_params

    @vdu_params.setter
    def vdu_params(self, vdu_params):
        """Sets the vdu_params of this AllOfParamsForVnfAdditionalParams.


        :param vdu_params: The vdu_params of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :type: list[VduParam]
        """

        self._vdu_params = vdu_params

    @property
    def instantiation_level_id(self):
        """Gets the instantiation_level_id of this AllOfParamsForVnfAdditionalParams.  # noqa: E501


        :return: The instantiation_level_id of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :rtype: str
        """
        return self._instantiation_level_id

    @instantiation_level_id.setter
    def instantiation_level_id(self, instantiation_level_id):
        """Sets the instantiation_level_id of this AllOfParamsForVnfAdditionalParams.


        :param instantiation_level_id: The instantiation_level_id of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :type: str
        """

        self._instantiation_level_id = instantiation_level_id

    @property
    def ext_virtual_links(self):
        """Gets the ext_virtual_links of this AllOfParamsForVnfAdditionalParams.  # noqa: E501


        :return: The ext_virtual_links of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :rtype: list[ExtVirtualLinkData]
        """
        return self._ext_virtual_links

    @ext_virtual_links.setter
    def ext_virtual_links(self, ext_virtual_links):
        """Sets the ext_virtual_links of this AllOfParamsForVnfAdditionalParams.


        :param ext_virtual_links: The ext_virtual_links of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :type: list[ExtVirtualLinkData]
        """

        self._ext_virtual_links = ext_virtual_links

    @property
    def node_profile_name(self):
        """Gets the node_profile_name of this AllOfParamsForVnfAdditionalParams.  # noqa: E501


        :return: The node_profile_name of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :rtype: str
        """
        return self._node_profile_name

    @node_profile_name.setter
    def node_profile_name(self, node_profile_name):
        """Sets the node_profile_name of this AllOfParamsForVnfAdditionalParams.


        :param node_profile_name: The node_profile_name of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :type: str
        """

        self._node_profile_name = node_profile_name

    @property
    def vim_connection_info(self):
        """Gets the vim_connection_info of this AllOfParamsForVnfAdditionalParams.  # noqa: E501


        :return: The vim_connection_info of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :rtype: list[VimConnectionInfo]
        """
        return self._vim_connection_info

    @vim_connection_info.setter
    def vim_connection_info(self, vim_connection_info):
        """Sets the vim_connection_info of this AllOfParamsForVnfAdditionalParams.


        :param vim_connection_info: The vim_connection_info of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :type: list[VimConnectionInfo]
        """

        self._vim_connection_info = vim_connection_info

    @property
    def lcm_interfaces(self):
        """Gets the lcm_interfaces of this AllOfParamsForVnfAdditionalParams.  # noqa: E501


        :return: The lcm_interfaces of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :rtype: object
        """
        return self._lcm_interfaces

    @lcm_interfaces.setter
    def lcm_interfaces(self, lcm_interfaces):
        """Sets the lcm_interfaces of this AllOfParamsForVnfAdditionalParams.


        :param lcm_interfaces: The lcm_interfaces of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :type: object
        """

        self._lcm_interfaces = lcm_interfaces

    @property
    def is_vnf_v_app_template(self):
        """Gets the is_vnf_v_app_template of this AllOfParamsForVnfAdditionalParams.  # noqa: E501

        Set to true if the entire VNF is represented by a single vApp template. Set to false otherwise.   # noqa: E501

        :return: The is_vnf_v_app_template of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :rtype: bool
        """
        return self._is_vnf_v_app_template

    @is_vnf_v_app_template.setter
    def is_vnf_v_app_template(self, is_vnf_v_app_template):
        """Sets the is_vnf_v_app_template of this AllOfParamsForVnfAdditionalParams.

        Set to true if the entire VNF is represented by a single vApp template. Set to false otherwise.   # noqa: E501

        :param is_vnf_v_app_template: The is_vnf_v_app_template of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :type: bool
        """

        self._is_vnf_v_app_template = is_vnf_v_app_template

    @property
    def v_app_template_name(self):
        """Gets the v_app_template_name of this AllOfParamsForVnfAdditionalParams.  # noqa: E501


        :return: The v_app_template_name of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :rtype: str
        """
        return self._v_app_template_name

    @v_app_template_name.setter
    def v_app_template_name(self, v_app_template_name):
        """Sets the v_app_template_name of this AllOfParamsForVnfAdditionalParams.


        :param v_app_template_name: The v_app_template_name of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :type: str
        """

        self._v_app_template_name = v_app_template_name

    @property
    def storage_profiles(self):
        """Gets the storage_profiles of this AllOfParamsForVnfAdditionalParams.  # noqa: E501

        Storage Profile Ids which should be used by all the VMs in this VNF.   # noqa: E501

        :return: The storage_profiles of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :rtype: list[str]
        """
        return self._storage_profiles

    @storage_profiles.setter
    def storage_profiles(self, storage_profiles):
        """Sets the storage_profiles of this AllOfParamsForVnfAdditionalParams.

        Storage Profile Ids which should be used by all the VMs in this VNF.   # noqa: E501

        :param storage_profiles: The storage_profiles of this AllOfParamsForVnfAdditionalParams.  # noqa: E501
        :type: list[str]
        """

        self._storage_profiles = storage_profiles

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AllOfParamsForVnfAdditionalParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AllOfParamsForVnfAdditionalParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
