# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ApiVersionInformationApiVersions(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'version': 'str',
        'is_deprecated': 'Boolean',
        'retirement_date': 'datetime'
    }

    attribute_map = {
        'version': 'version',
        'is_deprecated': 'isDeprecated',
        'retirement_date': 'retirementDate'
    }

    def __init__(self, version=None, is_deprecated=None, retirement_date=None):  # noqa: E501
        """ApiVersionInformationApiVersions - a model defined in Swagger"""  # noqa: E501
        self._version = None
        self._is_deprecated = None
        self._retirement_date = None
        self.discriminator = None
        self.version = version
        if is_deprecated is not None:
            self.is_deprecated = is_deprecated
        if retirement_date is not None:
            self.retirement_date = retirement_date

    @property
    def version(self):
        """Gets the version of this ApiVersionInformationApiVersions.  # noqa: E501

        Identifies a supported version. The value of the version attribute shall be a version identifier as specified in clause 4.6.1.   # noqa: E501

        :return: The version of this ApiVersionInformationApiVersions.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this ApiVersionInformationApiVersions.

        Identifies a supported version. The value of the version attribute shall be a version identifier as specified in clause 4.6.1.   # noqa: E501

        :param version: The version of this ApiVersionInformationApiVersions.  # noqa: E501
        :type: str
        """
        if version is None:
            print("WARNING: Invalid value for the required field `version`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `version`, must not be `None`")  # noqa: E501

        self._version = version

    @property
    def is_deprecated(self):
        """Gets the is_deprecated of this ApiVersionInformationApiVersions.  # noqa: E501


        :return: The is_deprecated of this ApiVersionInformationApiVersions.  # noqa: E501
        :rtype: Boolean
        """
        return self._is_deprecated

    @is_deprecated.setter
    def is_deprecated(self, is_deprecated):
        """Sets the is_deprecated of this ApiVersionInformationApiVersions.


        :param is_deprecated: The is_deprecated of this ApiVersionInformationApiVersions.  # noqa: E501
        :type: Boolean
        """

        self._is_deprecated = is_deprecated

    @property
    def retirement_date(self):
        """Gets the retirement_date of this ApiVersionInformationApiVersions.  # noqa: E501


        :return: The retirement_date of this ApiVersionInformationApiVersions.  # noqa: E501
        :rtype: datetime
        """
        return self._retirement_date

    @retirement_date.setter
    def retirement_date(self, retirement_date):
        """Sets the retirement_date of this ApiVersionInformationApiVersions.


        :param retirement_date: The retirement_date of this ApiVersionInformationApiVersions.  # noqa: E501
        :type: datetime
        """

        self._retirement_date = retirement_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ApiVersionInformationApiVersions, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiVersionInformationApiVersions):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
