# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ChangeExtVnfConnectivityData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnf_instance_id': 'Identifier',
        'ext_virtual_links': 'list[ExtVirtualLinkData]',
        'additional_params': 'KeyValuePairs'
    }

    attribute_map = {
        'vnf_instance_id': 'vnfInstanceId',
        'ext_virtual_links': 'extVirtualLinks',
        'additional_params': 'additionalParams'
    }

    def __init__(self, vnf_instance_id=None, ext_virtual_links=None, additional_params=None):  # noqa: E501
        """ChangeExtVnfConnectivityData - a model defined in Swagger"""  # noqa: E501
        self._vnf_instance_id = None
        self._ext_virtual_links = None
        self._additional_params = None
        self.discriminator = None
        self.vnf_instance_id = vnf_instance_id
        self.ext_virtual_links = ext_virtual_links
        if additional_params is not None:
            self.additional_params = additional_params

    @property
    def vnf_instance_id(self):
        """Gets the vnf_instance_id of this ChangeExtVnfConnectivityData.  # noqa: E501


        :return: The vnf_instance_id of this ChangeExtVnfConnectivityData.  # noqa: E501
        :rtype: Identifier
        """
        return self._vnf_instance_id

    @vnf_instance_id.setter
    def vnf_instance_id(self, vnf_instance_id):
        """Sets the vnf_instance_id of this ChangeExtVnfConnectivityData.


        :param vnf_instance_id: The vnf_instance_id of this ChangeExtVnfConnectivityData.  # noqa: E501
        :type: Identifier
        """
        if vnf_instance_id is None:
            print("WARNING: Invalid value for the required field `vnf_instance_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_instance_id`, must not be `None`")  # noqa: E501

        self._vnf_instance_id = vnf_instance_id

    @property
    def ext_virtual_links(self):
        """Gets the ext_virtual_links of this ChangeExtVnfConnectivityData.  # noqa: E501

        Information about external VLs to change (e.g. connect the VNF to).   # noqa: E501

        :return: The ext_virtual_links of this ChangeExtVnfConnectivityData.  # noqa: E501
        :rtype: list[ExtVirtualLinkData]
        """
        return self._ext_virtual_links

    @ext_virtual_links.setter
    def ext_virtual_links(self, ext_virtual_links):
        """Sets the ext_virtual_links of this ChangeExtVnfConnectivityData.

        Information about external VLs to change (e.g. connect the VNF to).   # noqa: E501

        :param ext_virtual_links: The ext_virtual_links of this ChangeExtVnfConnectivityData.  # noqa: E501
        :type: list[ExtVirtualLinkData]
        """
        if ext_virtual_links is None:
            print("WARNING: Invalid value for the required field `ext_virtual_links`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `ext_virtual_links`, must not be `None`")  # noqa: E501

        self._ext_virtual_links = ext_virtual_links

    @property
    def additional_params(self):
        """Gets the additional_params of this ChangeExtVnfConnectivityData.  # noqa: E501


        :return: The additional_params of this ChangeExtVnfConnectivityData.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._additional_params

    @additional_params.setter
    def additional_params(self, additional_params):
        """Sets the additional_params of this ChangeExtVnfConnectivityData.


        :param additional_params: The additional_params of this ChangeExtVnfConnectivityData.  # noqa: E501
        :type: KeyValuePairs
        """

        self._additional_params = additional_params

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ChangeExtVnfConnectivityData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ChangeExtVnfConnectivityData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
