# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class CpGroupInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cp_pair_info': 'list[CpPairInfo]',
        'forwarding_behaviour': 'str',
        'forwarding_behaviour_input_parameters': 'ForwardingBehaviourInputParameters'
    }

    attribute_map = {
        'cp_pair_info': 'cpPairInfo',
        'forwarding_behaviour': 'forwardingBehaviour',
        'forwarding_behaviour_input_parameters': 'forwardingBehaviourInputParameters'
    }

    def __init__(self, cp_pair_info=None, forwarding_behaviour=None, forwarding_behaviour_input_parameters=None):  # noqa: E501
        """CpGroupInfo - a model defined in Swagger"""  # noqa: E501
        self._cp_pair_info = None
        self._forwarding_behaviour = None
        self._forwarding_behaviour_input_parameters = None
        self.discriminator = None
        if cp_pair_info is not None:
            self.cp_pair_info = cp_pair_info
        if forwarding_behaviour is not None:
            self.forwarding_behaviour = forwarding_behaviour
        if forwarding_behaviour_input_parameters is not None:
            self.forwarding_behaviour_input_parameters = forwarding_behaviour_input_parameters

    @property
    def cp_pair_info(self):
        """Gets the cp_pair_info of this CpGroupInfo.  # noqa: E501

        One or more pair(s) of ingress and egress CPs or SAPs which the NFP passes by. All CP or SAP pairs in a group shall be instantiated from connection point  descriptors or service access point descriptors referenced in the corresponding  NfpPositionDesc.   # noqa: E501

        :return: The cp_pair_info of this CpGroupInfo.  # noqa: E501
        :rtype: list[CpPairInfo]
        """
        return self._cp_pair_info

    @cp_pair_info.setter
    def cp_pair_info(self, cp_pair_info):
        """Sets the cp_pair_info of this CpGroupInfo.

        One or more pair(s) of ingress and egress CPs or SAPs which the NFP passes by. All CP or SAP pairs in a group shall be instantiated from connection point  descriptors or service access point descriptors referenced in the corresponding  NfpPositionDesc.   # noqa: E501

        :param cp_pair_info: The cp_pair_info of this CpGroupInfo.  # noqa: E501
        :type: list[CpPairInfo]
        """

        self._cp_pair_info = cp_pair_info

    @property
    def forwarding_behaviour(self):
        """Gets the forwarding_behaviour of this CpGroupInfo.  # noqa: E501

        Identifies a rule to apply to forward traffic to the ingress CPs or SAPs of  the group. Permitted values: * ALL = Traffic flows shall be forwarded simultaneously to all CPs or SAPs  of the group. * LB = Traffic flows shall be forwarded to one CP or SAP of the group selected  based on a loadbalancing algorithm.   # noqa: E501

        :return: The forwarding_behaviour of this CpGroupInfo.  # noqa: E501
        :rtype: str
        """
        return self._forwarding_behaviour

    @forwarding_behaviour.setter
    def forwarding_behaviour(self, forwarding_behaviour):
        """Sets the forwarding_behaviour of this CpGroupInfo.

        Identifies a rule to apply to forward traffic to the ingress CPs or SAPs of  the group. Permitted values: * ALL = Traffic flows shall be forwarded simultaneously to all CPs or SAPs  of the group. * LB = Traffic flows shall be forwarded to one CP or SAP of the group selected  based on a loadbalancing algorithm.   # noqa: E501

        :param forwarding_behaviour: The forwarding_behaviour of this CpGroupInfo.  # noqa: E501
        :type: str
        """
        allowed_values = ["ALL", "LB"]  # noqa: E501
        if forwarding_behaviour is not None and forwarding_behaviour not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `forwarding_behaviour` ({0}), must be one of {1}"  # noqa: E501
                .format(forwarding_behaviour, allowed_values)
            )

        self._forwarding_behaviour = forwarding_behaviour

    @property
    def forwarding_behaviour_input_parameters(self):
        """Gets the forwarding_behaviour_input_parameters of this CpGroupInfo.  # noqa: E501


        :return: The forwarding_behaviour_input_parameters of this CpGroupInfo.  # noqa: E501
        :rtype: ForwardingBehaviourInputParameters
        """
        return self._forwarding_behaviour_input_parameters

    @forwarding_behaviour_input_parameters.setter
    def forwarding_behaviour_input_parameters(self, forwarding_behaviour_input_parameters):
        """Sets the forwarding_behaviour_input_parameters of this CpGroupInfo.


        :param forwarding_behaviour_input_parameters: The forwarding_behaviour_input_parameters of this CpGroupInfo.  # noqa: E501
        :type: ForwardingBehaviourInputParameters
        """

        self._forwarding_behaviour_input_parameters = forwarding_behaviour_input_parameters

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CpGroupInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CpGroupInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
