# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class CpPairInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnf_ext_cp_ids': 'list[IdentifierInVnf]',
        'pnf_ext_cp_ids': 'list[IdentifierInPnf]',
        'sap_ids': 'list[IdentifierInNs]'
    }

    attribute_map = {
        'vnf_ext_cp_ids': 'vnfExtCpIds',
        'pnf_ext_cp_ids': 'pnfExtCpIds',
        'sap_ids': 'sapIds'
    }

    def __init__(self, vnf_ext_cp_ids=None, pnf_ext_cp_ids=None, sap_ids=None):  # noqa: E501
        """CpPairInfo - a model defined in Swagger"""  # noqa: E501
        self._vnf_ext_cp_ids = None
        self._pnf_ext_cp_ids = None
        self._sap_ids = None
        self.discriminator = None
        if vnf_ext_cp_ids is not None:
            self.vnf_ext_cp_ids = vnf_ext_cp_ids
        if pnf_ext_cp_ids is not None:
            self.pnf_ext_cp_ids = pnf_ext_cp_ids
        if sap_ids is not None:
            self.sap_ids = sap_ids

    @property
    def vnf_ext_cp_ids(self):
        """Gets the vnf_ext_cp_ids of this CpPairInfo.  # noqa: E501

        Identifier(s) of the VNF CP(s) which form the pair. The presence of a single vnfExpCpId, pnfExtCpId, or sapId occurrence indicates  that the CP or SAP is used both as an ingress and egress port at a particular  NFP position.   # noqa: E501

        :return: The vnf_ext_cp_ids of this CpPairInfo.  # noqa: E501
        :rtype: list[IdentifierInVnf]
        """
        return self._vnf_ext_cp_ids

    @vnf_ext_cp_ids.setter
    def vnf_ext_cp_ids(self, vnf_ext_cp_ids):
        """Sets the vnf_ext_cp_ids of this CpPairInfo.

        Identifier(s) of the VNF CP(s) which form the pair. The presence of a single vnfExpCpId, pnfExtCpId, or sapId occurrence indicates  that the CP or SAP is used both as an ingress and egress port at a particular  NFP position.   # noqa: E501

        :param vnf_ext_cp_ids: The vnf_ext_cp_ids of this CpPairInfo.  # noqa: E501
        :type: list[IdentifierInVnf]
        """

        self._vnf_ext_cp_ids = vnf_ext_cp_ids

    @property
    def pnf_ext_cp_ids(self):
        """Gets the pnf_ext_cp_ids of this CpPairInfo.  # noqa: E501

        Identifier(s) of the PNF CP(s) which form the pair. The presence of a single vnfExpCpId, pnfExtCpId, or sapId occurrence indicates  that the CP or SAP is used both as an ingress and egress port at a particular  NFP position.   # noqa: E501

        :return: The pnf_ext_cp_ids of this CpPairInfo.  # noqa: E501
        :rtype: list[IdentifierInPnf]
        """
        return self._pnf_ext_cp_ids

    @pnf_ext_cp_ids.setter
    def pnf_ext_cp_ids(self, pnf_ext_cp_ids):
        """Sets the pnf_ext_cp_ids of this CpPairInfo.

        Identifier(s) of the PNF CP(s) which form the pair. The presence of a single vnfExpCpId, pnfExtCpId, or sapId occurrence indicates  that the CP or SAP is used both as an ingress and egress port at a particular  NFP position.   # noqa: E501

        :param pnf_ext_cp_ids: The pnf_ext_cp_ids of this CpPairInfo.  # noqa: E501
        :type: list[IdentifierInPnf]
        """

        self._pnf_ext_cp_ids = pnf_ext_cp_ids

    @property
    def sap_ids(self):
        """Gets the sap_ids of this CpPairInfo.  # noqa: E501

        Identifier(s) of the SAP(s) which form the pair. The presence of a single vnfExpCpId, pnfExtCpId, or sapId occurrence indicates  that the CP or SAP is used both as an ingress and egress port at a particular  NFP position.   # noqa: E501

        :return: The sap_ids of this CpPairInfo.  # noqa: E501
        :rtype: list[IdentifierInNs]
        """
        return self._sap_ids

    @sap_ids.setter
    def sap_ids(self, sap_ids):
        """Sets the sap_ids of this CpPairInfo.

        Identifier(s) of the SAP(s) which form the pair. The presence of a single vnfExpCpId, pnfExtCpId, or sapId occurrence indicates  that the CP or SAP is used both as an ingress and egress port at a particular  NFP position.   # noqa: E501

        :param sap_ids: The sap_ids of this CpPairInfo.  # noqa: E501
        :type: list[IdentifierInNs]
        """

        self._sap_ids = sap_ids

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CpPairInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CpPairInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
