# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ExtManagedVirtualLinkInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'Identifier',
        'vnf_virtual_link_desc_id': 'IdentifierInVnfd',
        'network_resource': 'ResourceHandle',
        'vnf_link_ports': 'list[VnfLinkPortInfo]'
    }

    attribute_map = {
        'id': 'id',
        'vnf_virtual_link_desc_id': 'vnfVirtualLinkDescId',
        'network_resource': 'networkResource',
        'vnf_link_ports': 'vnfLinkPorts'
    }

    def __init__(self, id=None, vnf_virtual_link_desc_id=None, network_resource=None, vnf_link_ports=None):  # noqa: E501
        """ExtManagedVirtualLinkInfo - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._vnf_virtual_link_desc_id = None
        self._network_resource = None
        self._vnf_link_ports = None
        self.discriminator = None
        self.id = id
        self.vnf_virtual_link_desc_id = vnf_virtual_link_desc_id
        if network_resource is not None:
            self.network_resource = network_resource
        if vnf_link_ports is not None:
            self.vnf_link_ports = vnf_link_ports

    @property
    def id(self):
        """Gets the id of this ExtManagedVirtualLinkInfo.  # noqa: E501


        :return: The id of this ExtManagedVirtualLinkInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ExtManagedVirtualLinkInfo.


        :param id: The id of this ExtManagedVirtualLinkInfo.  # noqa: E501
        :type: Identifier
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def vnf_virtual_link_desc_id(self):
        """Gets the vnf_virtual_link_desc_id of this ExtManagedVirtualLinkInfo.  # noqa: E501


        :return: The vnf_virtual_link_desc_id of this ExtManagedVirtualLinkInfo.  # noqa: E501
        :rtype: IdentifierInVnfd
        """
        return self._vnf_virtual_link_desc_id

    @vnf_virtual_link_desc_id.setter
    def vnf_virtual_link_desc_id(self, vnf_virtual_link_desc_id):
        """Sets the vnf_virtual_link_desc_id of this ExtManagedVirtualLinkInfo.


        :param vnf_virtual_link_desc_id: The vnf_virtual_link_desc_id of this ExtManagedVirtualLinkInfo.  # noqa: E501
        :type: IdentifierInVnfd
        """
        if vnf_virtual_link_desc_id is None:
            print("WARNING: Invalid value for the required field `vnf_virtual_link_desc_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_virtual_link_desc_id`, must not be `None`")  # noqa: E501

        self._vnf_virtual_link_desc_id = vnf_virtual_link_desc_id

    @property
    def network_resource(self):
        """Gets the network_resource of this ExtManagedVirtualLinkInfo.  # noqa: E501


        :return: The network_resource of this ExtManagedVirtualLinkInfo.  # noqa: E501
        :rtype: ResourceHandle
        """
        return self._network_resource

    @network_resource.setter
    def network_resource(self, network_resource):
        """Sets the network_resource of this ExtManagedVirtualLinkInfo.


        :param network_resource: The network_resource of this ExtManagedVirtualLinkInfo.  # noqa: E501
        :type: ResourceHandle
        """

        self._network_resource = network_resource

    @property
    def vnf_link_ports(self):
        """Gets the vnf_link_ports of this ExtManagedVirtualLinkInfo.  # noqa: E501

        Link ports of this VL.   # noqa: E501

        :return: The vnf_link_ports of this ExtManagedVirtualLinkInfo.  # noqa: E501
        :rtype: list[VnfLinkPortInfo]
        """
        return self._vnf_link_ports

    @vnf_link_ports.setter
    def vnf_link_ports(self, vnf_link_ports):
        """Sets the vnf_link_ports of this ExtManagedVirtualLinkInfo.

        Link ports of this VL.   # noqa: E501

        :param vnf_link_ports: The vnf_link_ports of this ExtManagedVirtualLinkInfo.  # noqa: E501
        :type: list[VnfLinkPortInfo]
        """

        self._vnf_link_ports = vnf_link_ports

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ExtManagedVirtualLinkInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExtManagedVirtualLinkInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
