# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ForwardingBehaviourInputParameters(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'algortihm_name': 'str',
        'algorithm_weights': 'list[int]'
    }

    attribute_map = {
        'algortihm_name': 'algortihmName',
        'algorithm_weights': 'algorithmWeights'
    }

    def __init__(self, algortihm_name=None, algorithm_weights=None):  # noqa: E501
        """ForwardingBehaviourInputParameters - a model defined in Swagger"""  # noqa: E501
        self._algortihm_name = None
        self._algorithm_weights = None
        self.discriminator = None
        if algortihm_name is not None:
            self.algortihm_name = algortihm_name
        if algorithm_weights is not None:
            self.algorithm_weights = algorithm_weights

    @property
    def algortihm_name(self):
        """Gets the algortihm_name of this ForwardingBehaviourInputParameters.  # noqa: E501

        May be included if forwarding behaviour is equal to LB. Shall not be included otherwise. Permitted values: * ROUND_ROBIN * LEAST_CONNECTION * LEAST_TRAFFIC * LEAST_RESPONSE_TIME * CHAINED_FAILOVER * SOURCE_IP_HASH * SOURCE_MAC_HASH   # noqa: E501

        :return: The algortihm_name of this ForwardingBehaviourInputParameters.  # noqa: E501
        :rtype: str
        """
        return self._algortihm_name

    @algortihm_name.setter
    def algortihm_name(self, algortihm_name):
        """Sets the algortihm_name of this ForwardingBehaviourInputParameters.

        May be included if forwarding behaviour is equal to LB. Shall not be included otherwise. Permitted values: * ROUND_ROBIN * LEAST_CONNECTION * LEAST_TRAFFIC * LEAST_RESPONSE_TIME * CHAINED_FAILOVER * SOURCE_IP_HASH * SOURCE_MAC_HASH   # noqa: E501

        :param algortihm_name: The algortihm_name of this ForwardingBehaviourInputParameters.  # noqa: E501
        :type: str
        """
        allowed_values = ["ROUND_ROBIN", "LEAST_CONNECTION", "LEAST_TRAFFIC", "LEAST_RESPONSE_TIME", "CHAINED_FAILOVER", "SOURCE_IP_HASH", "SOURCE_MAC_HASH"]  # noqa: E501
        if algortihm_name is not None and algortihm_name not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `algortihm_name` ({0}), must be one of {1}"  # noqa: E501
                .format(algortihm_name, allowed_values)
            )

        self._algortihm_name = algortihm_name

    @property
    def algorithm_weights(self):
        """Gets the algorithm_weights of this ForwardingBehaviourInputParameters.  # noqa: E501

        Percentage of messages sent to a CP instance. May be included if applicable to  the algorithm. If applicable to the algorithm but not provided, default values determined by  the VIM or NFVI are expected to be used. Weight applies to the CP instances in the order they have been created.   # noqa: E501

        :return: The algorithm_weights of this ForwardingBehaviourInputParameters.  # noqa: E501
        :rtype: list[int]
        """
        return self._algorithm_weights

    @algorithm_weights.setter
    def algorithm_weights(self, algorithm_weights):
        """Sets the algorithm_weights of this ForwardingBehaviourInputParameters.

        Percentage of messages sent to a CP instance. May be included if applicable to  the algorithm. If applicable to the algorithm but not provided, default values determined by  the VIM or NFVI are expected to be used. Weight applies to the CP instances in the order they have been created.   # noqa: E501

        :param algorithm_weights: The algorithm_weights of this ForwardingBehaviourInputParameters.  # noqa: E501
        :type: list[int]
        """

        self._algorithm_weights = algorithm_weights

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ForwardingBehaviourInputParameters, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ForwardingBehaviourInputParameters):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
