# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class HealNsData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'degree_healing': 'str',
        'actions_healing': 'list[String]',
        'heal_script': 'IdentifierInNsd',
        'additional_paramsfor_ns': 'HealAdditionalParams'
    }

    attribute_map = {
        'degree_healing': 'degreeHealing',
        'actions_healing': 'actionsHealing',
        'heal_script': 'healScript',
        'additional_paramsfor_ns': 'additionalParamsforNs'
    }

    def __init__(self, degree_healing=None, actions_healing=None, heal_script=None, additional_paramsfor_ns=None):  # noqa: E501
        """HealNsData - a model defined in Swagger"""  # noqa: E501
        self._degree_healing = None
        self._actions_healing = None
        self._heal_script = None
        self._additional_paramsfor_ns = None
        self.discriminator = None
        self.degree_healing = degree_healing
        if actions_healing is not None:
            self.actions_healing = actions_healing
        if heal_script is not None:
            self.heal_script = heal_script
        if additional_paramsfor_ns is not None:
            self.additional_paramsfor_ns = additional_paramsfor_ns

    @property
    def degree_healing(self):
        """Gets the degree_healing of this HealNsData.  # noqa: E501

        Indicates the degree of healing. Possible values include: - HEAL_RESTORE: Complete the healing of the NS restoring the state of the NS before the failure occurred. Equivalent to Recreate - HEAL_QOS: Complete the healing of the NS based on the newest QoS values - HEAL_RESET: Complete the healing of the NS resetting to the original instantiation state of the NS Equivalent to Restart - PARTIAL_HEALING.   # noqa: E501

        :return: The degree_healing of this HealNsData.  # noqa: E501
        :rtype: str
        """
        return self._degree_healing

    @degree_healing.setter
    def degree_healing(self, degree_healing):
        """Sets the degree_healing of this HealNsData.

        Indicates the degree of healing. Possible values include: - HEAL_RESTORE: Complete the healing of the NS restoring the state of the NS before the failure occurred. Equivalent to Recreate - HEAL_QOS: Complete the healing of the NS based on the newest QoS values - HEAL_RESET: Complete the healing of the NS resetting to the original instantiation state of the NS Equivalent to Restart - PARTIAL_HEALING.   # noqa: E501

        :param degree_healing: The degree_healing of this HealNsData.  # noqa: E501
        :type: str
        """
        if degree_healing is None:
            print("WARNING: Invalid value for the required field `degree_healing`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `degree_healing`, must not be `None`")  # noqa: E501
        allowed_values = ["HEAL_RESTORE", "HEAL_QOS", "HEAL_RESET", "PARTIAL_HEALING"]  # noqa: E501
        if degree_healing is not None and degree_healing not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `degree_healing` ({0}), must be one of {1}"  # noqa: E501
                .format(degree_healing, allowed_values)
            )

        self._degree_healing = degree_healing

    @property
    def actions_healing(self):
        """Gets the actions_healing of this HealNsData.  # noqa: E501

        Used to specify dedicated healing actions in a particular order (e.g. as a script). The actionsHealing attribute can be used to provide a specific script whose content and actions might only be possible to be derived during runtime.   # noqa: E501

        :return: The actions_healing of this HealNsData.  # noqa: E501
        :rtype: list[String]
        """
        return self._actions_healing

    @actions_healing.setter
    def actions_healing(self, actions_healing):
        """Sets the actions_healing of this HealNsData.

        Used to specify dedicated healing actions in a particular order (e.g. as a script). The actionsHealing attribute can be used to provide a specific script whose content and actions might only be possible to be derived during runtime.   # noqa: E501

        :param actions_healing: The actions_healing of this HealNsData.  # noqa: E501
        :type: list[String]
        """

        self._actions_healing = actions_healing

    @property
    def heal_script(self):
        """Gets the heal_script of this HealNsData.  # noqa: E501


        :return: The heal_script of this HealNsData.  # noqa: E501
        :rtype: IdentifierInNsd
        """
        return self._heal_script

    @heal_script.setter
    def heal_script(self, heal_script):
        """Sets the heal_script of this HealNsData.


        :param heal_script: The heal_script of this HealNsData.  # noqa: E501
        :type: IdentifierInNsd
        """

        self._heal_script = heal_script

    @property
    def additional_paramsfor_ns(self):
        """Gets the additional_paramsfor_ns of this HealNsData.  # noqa: E501


        :return: The additional_paramsfor_ns of this HealNsData.  # noqa: E501
        :rtype: HealAdditionalParams
        """
        return self._additional_paramsfor_ns

    @additional_paramsfor_ns.setter
    def additional_paramsfor_ns(self, additional_paramsfor_ns):
        """Sets the additional_paramsfor_ns of this HealNsData.


        :param additional_paramsfor_ns: The additional_paramsfor_ns of this HealNsData.  # noqa: E501
        :type: HealAdditionalParams
        """

        self._additional_paramsfor_ns = additional_paramsfor_ns

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(HealNsData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HealNsData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
