# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class HealVnfData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnf_instance_id': 'Identifier',
        'cause': 'str',
        'additional_params': 'HealAdditionalParams'
    }

    attribute_map = {
        'vnf_instance_id': 'vnfInstanceId',
        'cause': 'cause',
        'additional_params': 'additionalParams'
    }

    def __init__(self, vnf_instance_id=None, cause=None, additional_params=None):  # noqa: E501
        """HealVnfData - a model defined in Swagger"""  # noqa: E501
        self._vnf_instance_id = None
        self._cause = None
        self._additional_params = None
        self.discriminator = None
        self.vnf_instance_id = vnf_instance_id
        if cause is not None:
            self.cause = cause
        if additional_params is not None:
            self.additional_params = additional_params

    @property
    def vnf_instance_id(self):
        """Gets the vnf_instance_id of this HealVnfData.  # noqa: E501


        :return: The vnf_instance_id of this HealVnfData.  # noqa: E501
        :rtype: Identifier
        """
        return self._vnf_instance_id

    @vnf_instance_id.setter
    def vnf_instance_id(self, vnf_instance_id):
        """Sets the vnf_instance_id of this HealVnfData.


        :param vnf_instance_id: The vnf_instance_id of this HealVnfData.  # noqa: E501
        :type: Identifier
        """
        if vnf_instance_id is None:
            print("WARNING: Invalid value for the required field `vnf_instance_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_instance_id`, must not be `None`")  # noqa: E501

        self._vnf_instance_id = vnf_instance_id

    @property
    def cause(self):
        """Gets the cause of this HealVnfData.  # noqa: E501

        Indicates the reason why a healing procedure is required.   # noqa: E501

        :return: The cause of this HealVnfData.  # noqa: E501
        :rtype: str
        """
        return self._cause

    @cause.setter
    def cause(self, cause):
        """Sets the cause of this HealVnfData.

        Indicates the reason why a healing procedure is required.   # noqa: E501

        :param cause: The cause of this HealVnfData.  # noqa: E501
        :type: str
        """

        self._cause = cause

    @property
    def additional_params(self):
        """Gets the additional_params of this HealVnfData.  # noqa: E501


        :return: The additional_params of this HealVnfData.  # noqa: E501
        :rtype: HealAdditionalParams
        """
        return self._additional_params

    @additional_params.setter
    def additional_params(self, additional_params):
        """Sets the additional_params of this HealVnfData.


        :param additional_params: The additional_params of this HealVnfData.  # noqa: E501
        :type: HealAdditionalParams
        """

        self._additional_params = additional_params

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(HealVnfData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HealVnfData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
