# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class InstantiateNsRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'ns_flavour_id': 'IdentifierInNsd',
        'sap_data': 'list[SapData]',
        'addpnf_data': 'list[AddPnfData]',
        'vnf_instance_data': 'list[VnfInstanceData]',
        'nested_ns_instance_data': 'list[NestedNsInstanceData]',
        'location_constraints': 'list[VnfLocationConstraint]',
        'additional_params_for_ns': 'AllOfInstantiateNsRequestAdditionalParamsForNs',
        'additional_param_for_nested_ns': 'list[ParamsForNestedNs]',
        'additional_params_for_vnf': 'list[ParamsForVnf]',
        'start_time': 'datetime',
        'ns_instantiation_level_id': 'IdentifierInNsd',
        'additional_affinity_or_anti_affinity_rule': 'list[AffinityOrAntiAffinityRule]'
    }

    attribute_map = {
        'ns_flavour_id': 'nsFlavourId',
        'sap_data': 'sapData',
        'addpnf_data': 'addpnfData',
        'vnf_instance_data': 'vnfInstanceData',
        'nested_ns_instance_data': 'nestedNsInstanceData',
        'location_constraints': 'locationConstraints',
        'additional_params_for_ns': 'additionalParamsForNs',
        'additional_param_for_nested_ns': 'additionalParamForNestedNs',
        'additional_params_for_vnf': 'additionalParamsForVnf',
        'start_time': 'startTime',
        'ns_instantiation_level_id': 'nsInstantiationLevelId',
        'additional_affinity_or_anti_affinity_rule': 'additionalAffinityOrAntiAffinityRule'
    }

    def __init__(self, ns_flavour_id=None, sap_data=None, addpnf_data=None, vnf_instance_data=None, nested_ns_instance_data=None, location_constraints=None, additional_params_for_ns=None, additional_param_for_nested_ns=None, additional_params_for_vnf=None, start_time=None, ns_instantiation_level_id=None, additional_affinity_or_anti_affinity_rule=None):  # noqa: E501
        """InstantiateNsRequest - a model defined in Swagger"""  # noqa: E501
        self._ns_flavour_id = None
        self._sap_data = None
        self._addpnf_data = None
        self._vnf_instance_data = None
        self._nested_ns_instance_data = None
        self._location_constraints = None
        self._additional_params_for_ns = None
        self._additional_param_for_nested_ns = None
        self._additional_params_for_vnf = None
        self._start_time = None
        self._ns_instantiation_level_id = None
        self._additional_affinity_or_anti_affinity_rule = None
        self.discriminator = None
        self.ns_flavour_id = ns_flavour_id
        if sap_data is not None:
            self.sap_data = sap_data
        if addpnf_data is not None:
            self.addpnf_data = addpnf_data
        if vnf_instance_data is not None:
            self.vnf_instance_data = vnf_instance_data
        if nested_ns_instance_data is not None:
            self.nested_ns_instance_data = nested_ns_instance_data
        if location_constraints is not None:
            self.location_constraints = location_constraints
        if additional_params_for_ns is not None:
            self.additional_params_for_ns = additional_params_for_ns
        if additional_param_for_nested_ns is not None:
            self.additional_param_for_nested_ns = additional_param_for_nested_ns
        if additional_params_for_vnf is not None:
            self.additional_params_for_vnf = additional_params_for_vnf
        if start_time is not None:
            self.start_time = start_time
        if ns_instantiation_level_id is not None:
            self.ns_instantiation_level_id = ns_instantiation_level_id
        if additional_affinity_or_anti_affinity_rule is not None:
            self.additional_affinity_or_anti_affinity_rule = additional_affinity_or_anti_affinity_rule

    @property
    def ns_flavour_id(self):
        """Gets the ns_flavour_id of this InstantiateNsRequest.  # noqa: E501


        :return: The ns_flavour_id of this InstantiateNsRequest.  # noqa: E501
        :rtype: IdentifierInNsd
        """
        return self._ns_flavour_id

    @ns_flavour_id.setter
    def ns_flavour_id(self, ns_flavour_id):
        """Sets the ns_flavour_id of this InstantiateNsRequest.


        :param ns_flavour_id: The ns_flavour_id of this InstantiateNsRequest.  # noqa: E501
        :type: IdentifierInNsd
        """
        if ns_flavour_id is None:
            print("WARNING: Invalid value for the required field `ns_flavour_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `ns_flavour_id`, must not be `None`")  # noqa: E501

        self._ns_flavour_id = ns_flavour_id

    @property
    def sap_data(self):
        """Gets the sap_data of this InstantiateNsRequest.  # noqa: E501

        Create data concerning the SAPs of this NS.   # noqa: E501

        :return: The sap_data of this InstantiateNsRequest.  # noqa: E501
        :rtype: list[SapData]
        """
        return self._sap_data

    @sap_data.setter
    def sap_data(self, sap_data):
        """Sets the sap_data of this InstantiateNsRequest.

        Create data concerning the SAPs of this NS.   # noqa: E501

        :param sap_data: The sap_data of this InstantiateNsRequest.  # noqa: E501
        :type: list[SapData]
        """

        self._sap_data = sap_data

    @property
    def addpnf_data(self):
        """Gets the addpnf_data of this InstantiateNsRequest.  # noqa: E501

        Information on the PNF(s) that are part of this NS.   # noqa: E501

        :return: The addpnf_data of this InstantiateNsRequest.  # noqa: E501
        :rtype: list[AddPnfData]
        """
        return self._addpnf_data

    @addpnf_data.setter
    def addpnf_data(self, addpnf_data):
        """Sets the addpnf_data of this InstantiateNsRequest.

        Information on the PNF(s) that are part of this NS.   # noqa: E501

        :param addpnf_data: The addpnf_data of this InstantiateNsRequest.  # noqa: E501
        :type: list[AddPnfData]
        """

        self._addpnf_data = addpnf_data

    @property
    def vnf_instance_data(self):
        """Gets the vnf_instance_data of this InstantiateNsRequest.  # noqa: E501

        Specify an existing VNF instance to be used in the NS. If needed, the VNF Profile to be used for this VNF instance is also provided. The DF of the VNF instance shall match the VNF DF  present in the associated VNF Profile.   # noqa: E501

        :return: The vnf_instance_data of this InstantiateNsRequest.  # noqa: E501
        :rtype: list[VnfInstanceData]
        """
        return self._vnf_instance_data

    @vnf_instance_data.setter
    def vnf_instance_data(self, vnf_instance_data):
        """Sets the vnf_instance_data of this InstantiateNsRequest.

        Specify an existing VNF instance to be used in the NS. If needed, the VNF Profile to be used for this VNF instance is also provided. The DF of the VNF instance shall match the VNF DF  present in the associated VNF Profile.   # noqa: E501

        :param vnf_instance_data: The vnf_instance_data of this InstantiateNsRequest.  # noqa: E501
        :type: list[VnfInstanceData]
        """

        self._vnf_instance_data = vnf_instance_data

    @property
    def nested_ns_instance_data(self):
        """Gets the nested_ns_instance_data of this InstantiateNsRequest.  # noqa: E501

        Specify an existing NS instance to be used as a nested NS within the NS. If needed, the NS Profile to be used for this nested NS  instance is also provided. NOTE 2: The NS DF of each nested NS shall be one of the  allowed flavours in the associated NSD (as referenced in the nestedNsd attribute of the NSD of the NS to be instantiated). NOTE 3: The NSD of each referenced NSs (i.e. each  nestedInstanceId) shall match the one of the nested NSD in  the composite NSD.   # noqa: E501

        :return: The nested_ns_instance_data of this InstantiateNsRequest.  # noqa: E501
        :rtype: list[NestedNsInstanceData]
        """
        return self._nested_ns_instance_data

    @nested_ns_instance_data.setter
    def nested_ns_instance_data(self, nested_ns_instance_data):
        """Sets the nested_ns_instance_data of this InstantiateNsRequest.

        Specify an existing NS instance to be used as a nested NS within the NS. If needed, the NS Profile to be used for this nested NS  instance is also provided. NOTE 2: The NS DF of each nested NS shall be one of the  allowed flavours in the associated NSD (as referenced in the nestedNsd attribute of the NSD of the NS to be instantiated). NOTE 3: The NSD of each referenced NSs (i.e. each  nestedInstanceId) shall match the one of the nested NSD in  the composite NSD.   # noqa: E501

        :param nested_ns_instance_data: The nested_ns_instance_data of this InstantiateNsRequest.  # noqa: E501
        :type: list[NestedNsInstanceData]
        """

        self._nested_ns_instance_data = nested_ns_instance_data

    @property
    def location_constraints(self):
        """Gets the location_constraints of this InstantiateNsRequest.  # noqa: E501

        Defines the location constraints for the VNF to be instantiated as part of the NS instantiation. An example can be a constraint for the VNF to be in a specific geographic location..   # noqa: E501

        :return: The location_constraints of this InstantiateNsRequest.  # noqa: E501
        :rtype: list[VnfLocationConstraint]
        """
        return self._location_constraints

    @location_constraints.setter
    def location_constraints(self, location_constraints):
        """Sets the location_constraints of this InstantiateNsRequest.

        Defines the location constraints for the VNF to be instantiated as part of the NS instantiation. An example can be a constraint for the VNF to be in a specific geographic location..   # noqa: E501

        :param location_constraints: The location_constraints of this InstantiateNsRequest.  # noqa: E501
        :type: list[VnfLocationConstraint]
        """

        self._location_constraints = location_constraints

    @property
    def additional_params_for_ns(self):
        """Gets the additional_params_for_ns of this InstantiateNsRequest.  # noqa: E501

        Allows the OSS/BSS to provide additional parameter(s) at the composite NS level (as opposed to the VNF level,  which is covered in additionalParamsForVnf), and as  opposed to the nested NS level, which is covered in additionalParamForNestedNs.   # noqa: E501

        :return: The additional_params_for_ns of this InstantiateNsRequest.  # noqa: E501
        :rtype: AllOfInstantiateNsRequestAdditionalParamsForNs
        """
        return self._additional_params_for_ns

    @additional_params_for_ns.setter
    def additional_params_for_ns(self, additional_params_for_ns):
        """Sets the additional_params_for_ns of this InstantiateNsRequest.

        Allows the OSS/BSS to provide additional parameter(s) at the composite NS level (as opposed to the VNF level,  which is covered in additionalParamsForVnf), and as  opposed to the nested NS level, which is covered in additionalParamForNestedNs.   # noqa: E501

        :param additional_params_for_ns: The additional_params_for_ns of this InstantiateNsRequest.  # noqa: E501
        :type: AllOfInstantiateNsRequestAdditionalParamsForNs
        """

        self._additional_params_for_ns = additional_params_for_ns

    @property
    def additional_param_for_nested_ns(self):
        """Gets the additional_param_for_nested_ns of this InstantiateNsRequest.  # noqa: E501

        Allows the OSS/BSS to provide additional parameter(s) per nested NS instance (as opposed to the composite NS level, which is covered in additionalParamForNs, and as opposed to the VNF level, which is covered in additionalParamForVnf). This is for nested NS instances that are to be created by the NFVO as part of the NS instantiation and not for existing nested NS instances that are referenced for reuse.   # noqa: E501

        :return: The additional_param_for_nested_ns of this InstantiateNsRequest.  # noqa: E501
        :rtype: list[ParamsForNestedNs]
        """
        return self._additional_param_for_nested_ns

    @additional_param_for_nested_ns.setter
    def additional_param_for_nested_ns(self, additional_param_for_nested_ns):
        """Sets the additional_param_for_nested_ns of this InstantiateNsRequest.

        Allows the OSS/BSS to provide additional parameter(s) per nested NS instance (as opposed to the composite NS level, which is covered in additionalParamForNs, and as opposed to the VNF level, which is covered in additionalParamForVnf). This is for nested NS instances that are to be created by the NFVO as part of the NS instantiation and not for existing nested NS instances that are referenced for reuse.   # noqa: E501

        :param additional_param_for_nested_ns: The additional_param_for_nested_ns of this InstantiateNsRequest.  # noqa: E501
        :type: list[ParamsForNestedNs]
        """

        self._additional_param_for_nested_ns = additional_param_for_nested_ns

    @property
    def additional_params_for_vnf(self):
        """Gets the additional_params_for_vnf of this InstantiateNsRequest.  # noqa: E501

        Allows the OSS/BSS to provide additional parameter(s) per VNF instance (as opposed to the composite NS level,  which is covered in additionalParamsForNs and as opposed  to the nested NS level, which is covered in  additionalParamForNestedNs). This is for VNFs that are  to be created by the NFVO as part of the NS instantiation  and not for existing VNF that are referenced for reuse.   # noqa: E501

        :return: The additional_params_for_vnf of this InstantiateNsRequest.  # noqa: E501
        :rtype: list[ParamsForVnf]
        """
        return self._additional_params_for_vnf

    @additional_params_for_vnf.setter
    def additional_params_for_vnf(self, additional_params_for_vnf):
        """Sets the additional_params_for_vnf of this InstantiateNsRequest.

        Allows the OSS/BSS to provide additional parameter(s) per VNF instance (as opposed to the composite NS level,  which is covered in additionalParamsForNs and as opposed  to the nested NS level, which is covered in  additionalParamForNestedNs). This is for VNFs that are  to be created by the NFVO as part of the NS instantiation  and not for existing VNF that are referenced for reuse.   # noqa: E501

        :param additional_params_for_vnf: The additional_params_for_vnf of this InstantiateNsRequest.  # noqa: E501
        :type: list[ParamsForVnf]
        """

        self._additional_params_for_vnf = additional_params_for_vnf

    @property
    def start_time(self):
        """Gets the start_time of this InstantiateNsRequest.  # noqa: E501


        :return: The start_time of this InstantiateNsRequest.  # noqa: E501
        :rtype: datetime
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """Sets the start_time of this InstantiateNsRequest.


        :param start_time: The start_time of this InstantiateNsRequest.  # noqa: E501
        :type: datetime
        """

        self._start_time = start_time

    @property
    def ns_instantiation_level_id(self):
        """Gets the ns_instantiation_level_id of this InstantiateNsRequest.  # noqa: E501


        :return: The ns_instantiation_level_id of this InstantiateNsRequest.  # noqa: E501
        :rtype: IdentifierInNsd
        """
        return self._ns_instantiation_level_id

    @ns_instantiation_level_id.setter
    def ns_instantiation_level_id(self, ns_instantiation_level_id):
        """Sets the ns_instantiation_level_id of this InstantiateNsRequest.


        :param ns_instantiation_level_id: The ns_instantiation_level_id of this InstantiateNsRequest.  # noqa: E501
        :type: IdentifierInNsd
        """

        self._ns_instantiation_level_id = ns_instantiation_level_id

    @property
    def additional_affinity_or_anti_affinity_rule(self):
        """Gets the additional_affinity_or_anti_affinity_rule of this InstantiateNsRequest.  # noqa: E501

        Specifies additional affinity or anti-affinity constraint for the VNF instances to be instantiated as part of the NS instantiation. Shall not conflict with rules already specified in the NSD.   # noqa: E501

        :return: The additional_affinity_or_anti_affinity_rule of this InstantiateNsRequest.  # noqa: E501
        :rtype: list[AffinityOrAntiAffinityRule]
        """
        return self._additional_affinity_or_anti_affinity_rule

    @additional_affinity_or_anti_affinity_rule.setter
    def additional_affinity_or_anti_affinity_rule(self, additional_affinity_or_anti_affinity_rule):
        """Sets the additional_affinity_or_anti_affinity_rule of this InstantiateNsRequest.

        Specifies additional affinity or anti-affinity constraint for the VNF instances to be instantiated as part of the NS instantiation. Shall not conflict with rules already specified in the NSD.   # noqa: E501

        :param additional_affinity_or_anti_affinity_rule: The additional_affinity_or_anti_affinity_rule of this InstantiateNsRequest.  # noqa: E501
        :type: list[AffinityOrAntiAffinityRule]
        """

        self._additional_affinity_or_anti_affinity_rule = additional_affinity_or_anti_affinity_rule

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InstantiateNsRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InstantiateNsRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
