# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class InstantiateVnfData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnfd_id': 'Identifier',
        'vnf_flavour_id': 'IdentifierInVnfd',
        'vnf_instantiation_level_id': 'IdentifierInVnfd',
        'vnf_instance_name': 'str',
        'vnf_instance_description': 'str',
        'ext_virtual_links': 'list[ExtVirtualLinkData]',
        'ext_managed_virtual_links': 'list[ExtManagedVirtualLinkData]',
        'localization_language': 'str',
        'vnf_configurable_properties': 'KeyValuePairs',
        'additional_params': 'KeyValuePairs',
        'metadata': 'KeyValuePairs',
        'extensions': 'KeyValuePairs',
        'location_constraints': 'VnfLocationConstraint'
    }

    attribute_map = {
        'vnfd_id': 'vnfdId',
        'vnf_flavour_id': 'vnfFlavourId',
        'vnf_instantiation_level_id': 'vnfInstantiationLevelId',
        'vnf_instance_name': 'vnfInstanceName',
        'vnf_instance_description': 'vnfInstanceDescription',
        'ext_virtual_links': 'extVirtualLinks',
        'ext_managed_virtual_links': 'extManagedVirtualLinks',
        'localization_language': 'localizationLanguage',
        'vnf_configurable_properties': 'vnfConfigurableProperties',
        'additional_params': 'additionalParams',
        'metadata': 'metadata',
        'extensions': 'extensions',
        'location_constraints': 'locationConstraints'
    }

    def __init__(self, vnfd_id=None, vnf_flavour_id=None, vnf_instantiation_level_id=None, vnf_instance_name=None, vnf_instance_description=None, ext_virtual_links=None, ext_managed_virtual_links=None, localization_language=None, vnf_configurable_properties=None, additional_params=None, metadata=None, extensions=None, location_constraints=None):  # noqa: E501
        """InstantiateVnfData - a model defined in Swagger"""  # noqa: E501
        self._vnfd_id = None
        self._vnf_flavour_id = None
        self._vnf_instantiation_level_id = None
        self._vnf_instance_name = None
        self._vnf_instance_description = None
        self._ext_virtual_links = None
        self._ext_managed_virtual_links = None
        self._localization_language = None
        self._vnf_configurable_properties = None
        self._additional_params = None
        self._metadata = None
        self._extensions = None
        self._location_constraints = None
        self.discriminator = None
        self.vnfd_id = vnfd_id
        self.vnf_flavour_id = vnf_flavour_id
        if vnf_instantiation_level_id is not None:
            self.vnf_instantiation_level_id = vnf_instantiation_level_id
        if vnf_instance_name is not None:
            self.vnf_instance_name = vnf_instance_name
        if vnf_instance_description is not None:
            self.vnf_instance_description = vnf_instance_description
        if ext_virtual_links is not None:
            self.ext_virtual_links = ext_virtual_links
        if ext_managed_virtual_links is not None:
            self.ext_managed_virtual_links = ext_managed_virtual_links
        if localization_language is not None:
            self.localization_language = localization_language
        if vnf_configurable_properties is not None:
            self.vnf_configurable_properties = vnf_configurable_properties
        if additional_params is not None:
            self.additional_params = additional_params
        if metadata is not None:
            self.metadata = metadata
        if extensions is not None:
            self.extensions = extensions
        if location_constraints is not None:
            self.location_constraints = location_constraints

    @property
    def vnfd_id(self):
        """Gets the vnfd_id of this InstantiateVnfData.  # noqa: E501


        :return: The vnfd_id of this InstantiateVnfData.  # noqa: E501
        :rtype: Identifier
        """
        return self._vnfd_id

    @vnfd_id.setter
    def vnfd_id(self, vnfd_id):
        """Sets the vnfd_id of this InstantiateVnfData.


        :param vnfd_id: The vnfd_id of this InstantiateVnfData.  # noqa: E501
        :type: Identifier
        """
        if vnfd_id is None:
            print("WARNING: Invalid value for the required field `vnfd_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnfd_id`, must not be `None`")  # noqa: E501

        self._vnfd_id = vnfd_id

    @property
    def vnf_flavour_id(self):
        """Gets the vnf_flavour_id of this InstantiateVnfData.  # noqa: E501


        :return: The vnf_flavour_id of this InstantiateVnfData.  # noqa: E501
        :rtype: IdentifierInVnfd
        """
        return self._vnf_flavour_id

    @vnf_flavour_id.setter
    def vnf_flavour_id(self, vnf_flavour_id):
        """Sets the vnf_flavour_id of this InstantiateVnfData.


        :param vnf_flavour_id: The vnf_flavour_id of this InstantiateVnfData.  # noqa: E501
        :type: IdentifierInVnfd
        """
        if vnf_flavour_id is None:
            print("WARNING: Invalid value for the required field `vnf_flavour_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_flavour_id`, must not be `None`")  # noqa: E501

        self._vnf_flavour_id = vnf_flavour_id

    @property
    def vnf_instantiation_level_id(self):
        """Gets the vnf_instantiation_level_id of this InstantiateVnfData.  # noqa: E501


        :return: The vnf_instantiation_level_id of this InstantiateVnfData.  # noqa: E501
        :rtype: IdentifierInVnfd
        """
        return self._vnf_instantiation_level_id

    @vnf_instantiation_level_id.setter
    def vnf_instantiation_level_id(self, vnf_instantiation_level_id):
        """Sets the vnf_instantiation_level_id of this InstantiateVnfData.


        :param vnf_instantiation_level_id: The vnf_instantiation_level_id of this InstantiateVnfData.  # noqa: E501
        :type: IdentifierInVnfd
        """

        self._vnf_instantiation_level_id = vnf_instantiation_level_id

    @property
    def vnf_instance_name(self):
        """Gets the vnf_instance_name of this InstantiateVnfData.  # noqa: E501

        Human-readable name of the VNF instance to be created.   # noqa: E501

        :return: The vnf_instance_name of this InstantiateVnfData.  # noqa: E501
        :rtype: str
        """
        return self._vnf_instance_name

    @vnf_instance_name.setter
    def vnf_instance_name(self, vnf_instance_name):
        """Sets the vnf_instance_name of this InstantiateVnfData.

        Human-readable name of the VNF instance to be created.   # noqa: E501

        :param vnf_instance_name: The vnf_instance_name of this InstantiateVnfData.  # noqa: E501
        :type: str
        """

        self._vnf_instance_name = vnf_instance_name

    @property
    def vnf_instance_description(self):
        """Gets the vnf_instance_description of this InstantiateVnfData.  # noqa: E501

        Human-readable description of the VNF instance to be created.   # noqa: E501

        :return: The vnf_instance_description of this InstantiateVnfData.  # noqa: E501
        :rtype: str
        """
        return self._vnf_instance_description

    @vnf_instance_description.setter
    def vnf_instance_description(self, vnf_instance_description):
        """Sets the vnf_instance_description of this InstantiateVnfData.

        Human-readable description of the VNF instance to be created.   # noqa: E501

        :param vnf_instance_description: The vnf_instance_description of this InstantiateVnfData.  # noqa: E501
        :type: str
        """

        self._vnf_instance_description = vnf_instance_description

    @property
    def ext_virtual_links(self):
        """Gets the ext_virtual_links of this InstantiateVnfData.  # noqa: E501

        Information about external VLs to connect the VNF to.   # noqa: E501

        :return: The ext_virtual_links of this InstantiateVnfData.  # noqa: E501
        :rtype: list[ExtVirtualLinkData]
        """
        return self._ext_virtual_links

    @ext_virtual_links.setter
    def ext_virtual_links(self, ext_virtual_links):
        """Sets the ext_virtual_links of this InstantiateVnfData.

        Information about external VLs to connect the VNF to.   # noqa: E501

        :param ext_virtual_links: The ext_virtual_links of this InstantiateVnfData.  # noqa: E501
        :type: list[ExtVirtualLinkData]
        """

        self._ext_virtual_links = ext_virtual_links

    @property
    def ext_managed_virtual_links(self):
        """Gets the ext_managed_virtual_links of this InstantiateVnfData.  # noqa: E501

        Information about internal VLs that are managed by other entities than the VNFM.   # noqa: E501

        :return: The ext_managed_virtual_links of this InstantiateVnfData.  # noqa: E501
        :rtype: list[ExtManagedVirtualLinkData]
        """
        return self._ext_managed_virtual_links

    @ext_managed_virtual_links.setter
    def ext_managed_virtual_links(self, ext_managed_virtual_links):
        """Sets the ext_managed_virtual_links of this InstantiateVnfData.

        Information about internal VLs that are managed by other entities than the VNFM.   # noqa: E501

        :param ext_managed_virtual_links: The ext_managed_virtual_links of this InstantiateVnfData.  # noqa: E501
        :type: list[ExtManagedVirtualLinkData]
        """

        self._ext_managed_virtual_links = ext_managed_virtual_links

    @property
    def localization_language(self):
        """Gets the localization_language of this InstantiateVnfData.  # noqa: E501

        Localization language of the VNF to be instantiated. The value shall comply with the format defined in IETF RFC 5646.   # noqa: E501

        :return: The localization_language of this InstantiateVnfData.  # noqa: E501
        :rtype: str
        """
        return self._localization_language

    @localization_language.setter
    def localization_language(self, localization_language):
        """Sets the localization_language of this InstantiateVnfData.

        Localization language of the VNF to be instantiated. The value shall comply with the format defined in IETF RFC 5646.   # noqa: E501

        :param localization_language: The localization_language of this InstantiateVnfData.  # noqa: E501
        :type: str
        """

        self._localization_language = localization_language

    @property
    def vnf_configurable_properties(self):
        """Gets the vnf_configurable_properties of this InstantiateVnfData.  # noqa: E501


        :return: The vnf_configurable_properties of this InstantiateVnfData.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._vnf_configurable_properties

    @vnf_configurable_properties.setter
    def vnf_configurable_properties(self, vnf_configurable_properties):
        """Sets the vnf_configurable_properties of this InstantiateVnfData.


        :param vnf_configurable_properties: The vnf_configurable_properties of this InstantiateVnfData.  # noqa: E501
        :type: KeyValuePairs
        """

        self._vnf_configurable_properties = vnf_configurable_properties

    @property
    def additional_params(self):
        """Gets the additional_params of this InstantiateVnfData.  # noqa: E501


        :return: The additional_params of this InstantiateVnfData.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._additional_params

    @additional_params.setter
    def additional_params(self, additional_params):
        """Sets the additional_params of this InstantiateVnfData.


        :param additional_params: The additional_params of this InstantiateVnfData.  # noqa: E501
        :type: KeyValuePairs
        """

        self._additional_params = additional_params

    @property
    def metadata(self):
        """Gets the metadata of this InstantiateVnfData.  # noqa: E501


        :return: The metadata of this InstantiateVnfData.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this InstantiateVnfData.


        :param metadata: The metadata of this InstantiateVnfData.  # noqa: E501
        :type: KeyValuePairs
        """

        self._metadata = metadata

    @property
    def extensions(self):
        """Gets the extensions of this InstantiateVnfData.  # noqa: E501


        :return: The extensions of this InstantiateVnfData.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._extensions

    @extensions.setter
    def extensions(self, extensions):
        """Sets the extensions of this InstantiateVnfData.


        :param extensions: The extensions of this InstantiateVnfData.  # noqa: E501
        :type: KeyValuePairs
        """

        self._extensions = extensions

    @property
    def location_constraints(self):
        """Gets the location_constraints of this InstantiateVnfData.  # noqa: E501


        :return: The location_constraints of this InstantiateVnfData.  # noqa: E501
        :rtype: VnfLocationConstraint
        """
        return self._location_constraints

    @location_constraints.setter
    def location_constraints(self, location_constraints):
        """Sets the location_constraints of this InstantiateVnfData.


        :param location_constraints: The location_constraints of this InstantiateVnfData.  # noqa: E501
        :type: VnfLocationConstraint
        """

        self._location_constraints = location_constraints

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InstantiateVnfData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InstantiateVnfData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
