# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class IpOverEthernetAddressData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'mac_address': 'MacAddress',
        'ip_addresses': 'list[IpOverEthernetAddressDataIpAddresses]'
    }

    attribute_map = {
        'mac_address': 'macAddress',
        'ip_addresses': 'ipAddresses'
    }

    def __init__(self, mac_address=None, ip_addresses=None):  # noqa: E501
        """IpOverEthernetAddressData - a model defined in Swagger"""  # noqa: E501
        self._mac_address = None
        self._ip_addresses = None
        self.discriminator = None
        if mac_address is not None:
            self.mac_address = mac_address
        if ip_addresses is not None:
            self.ip_addresses = ip_addresses

    @property
    def mac_address(self):
        """Gets the mac_address of this IpOverEthernetAddressData.  # noqa: E501


        :return: The mac_address of this IpOverEthernetAddressData.  # noqa: E501
        :rtype: MacAddress
        """
        return self._mac_address

    @mac_address.setter
    def mac_address(self, mac_address):
        """Sets the mac_address of this IpOverEthernetAddressData.


        :param mac_address: The mac_address of this IpOverEthernetAddressData.  # noqa: E501
        :type: MacAddress
        """

        self._mac_address = mac_address

    @property
    def ip_addresses(self):
        """Gets the ip_addresses of this IpOverEthernetAddressData.  # noqa: E501

        List of IP addresses to assign to the CP instance. Each entry represents IP address data for fixed or dynamic IP address assignment per subnet. If this attribute is not present, no IP address shall be assigned.   # noqa: E501

        :return: The ip_addresses of this IpOverEthernetAddressData.  # noqa: E501
        :rtype: list[IpOverEthernetAddressDataIpAddresses]
        """
        return self._ip_addresses

    @ip_addresses.setter
    def ip_addresses(self, ip_addresses):
        """Sets the ip_addresses of this IpOverEthernetAddressData.

        List of IP addresses to assign to the CP instance. Each entry represents IP address data for fixed or dynamic IP address assignment per subnet. If this attribute is not present, no IP address shall be assigned.   # noqa: E501

        :param ip_addresses: The ip_addresses of this IpOverEthernetAddressData.  # noqa: E501
        :type: list[IpOverEthernetAddressDataIpAddresses]
        """

        self._ip_addresses = ip_addresses

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IpOverEthernetAddressData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IpOverEthernetAddressData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
