# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class IpOverEthernetAddressInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'mac_address': 'MacAddress',
        'ip_addresses': 'list[IpOverEthernetAddressInfoIpAddresses]',
        'type': 'str',
        'addresses': 'IpAddress',
        'is_dynamic': 'bool',
        'address_range': 'IpOverEthernetAddressInfoAddressRange1',
        'min_address': 'IpAddress',
        'max_address': 'IpAddress',
        'subnet_id': 'IdentifierInVim'
    }

    attribute_map = {
        'mac_address': 'macAddress',
        'ip_addresses': 'ipAddresses',
        'type': 'type',
        'addresses': 'addresses',
        'is_dynamic': 'isDynamic',
        'address_range': 'addressRange',
        'min_address': 'minAddress',
        'max_address': 'maxAddress',
        'subnet_id': 'subnetId'
    }

    def __init__(self, mac_address=None, ip_addresses=None, type=None, addresses=None, is_dynamic=None, address_range=None, min_address=None, max_address=None, subnet_id=None):  # noqa: E501
        """IpOverEthernetAddressInfo - a model defined in Swagger"""  # noqa: E501
        self._mac_address = None
        self._ip_addresses = None
        self._type = None
        self._addresses = None
        self._is_dynamic = None
        self._address_range = None
        self._min_address = None
        self._max_address = None
        self._subnet_id = None
        self.discriminator = None
        self.mac_address = mac_address
        self.ip_addresses = ip_addresses
        if type is not None:
            self.type = type
        if addresses is not None:
            self.addresses = addresses
        if is_dynamic is not None:
            self.is_dynamic = is_dynamic
        if address_range is not None:
            self.address_range = address_range
        if min_address is not None:
            self.min_address = min_address
        if max_address is not None:
            self.max_address = max_address
        if subnet_id is not None:
            self.subnet_id = subnet_id

    @property
    def mac_address(self):
        """Gets the mac_address of this IpOverEthernetAddressInfo.  # noqa: E501


        :return: The mac_address of this IpOverEthernetAddressInfo.  # noqa: E501
        :rtype: MacAddress
        """
        return self._mac_address

    @mac_address.setter
    def mac_address(self, mac_address):
        """Sets the mac_address of this IpOverEthernetAddressInfo.


        :param mac_address: The mac_address of this IpOverEthernetAddressInfo.  # noqa: E501
        :type: MacAddress
        """
        if mac_address is None:
            print("WARNING: Invalid value for the required field `mac_address`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `mac_address`, must not be `None`")  # noqa: E501

        self._mac_address = mac_address

    @property
    def ip_addresses(self):
        """Gets the ip_addresses of this IpOverEthernetAddressInfo.  # noqa: E501

        Addresses assigned to the CP instance. Each entry represents IP addresses assigned by fixed or dynamic IP address assignment per subnet.   # noqa: E501

        :return: The ip_addresses of this IpOverEthernetAddressInfo.  # noqa: E501
        :rtype: list[IpOverEthernetAddressInfoIpAddresses]
        """
        return self._ip_addresses

    @ip_addresses.setter
    def ip_addresses(self, ip_addresses):
        """Sets the ip_addresses of this IpOverEthernetAddressInfo.

        Addresses assigned to the CP instance. Each entry represents IP addresses assigned by fixed or dynamic IP address assignment per subnet.   # noqa: E501

        :param ip_addresses: The ip_addresses of this IpOverEthernetAddressInfo.  # noqa: E501
        :type: list[IpOverEthernetAddressInfoIpAddresses]
        """
        if ip_addresses is None:
            print("WARNING: Invalid value for the required field `ip_addresses`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `ip_addresses`, must not be `None`")  # noqa: E501

        self._ip_addresses = ip_addresses

    @property
    def type(self):
        """Gets the type of this IpOverEthernetAddressInfo.  # noqa: E501

        The type of the IP addresses   # noqa: E501

        :return: The type of this IpOverEthernetAddressInfo.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this IpOverEthernetAddressInfo.

        The type of the IP addresses   # noqa: E501

        :param type: The type of this IpOverEthernetAddressInfo.  # noqa: E501
        :type: str
        """
        allowed_values = ["PV4", "PV6"]  # noqa: E501
        if type is not None and type not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def addresses(self):
        """Gets the addresses of this IpOverEthernetAddressInfo.  # noqa: E501


        :return: The addresses of this IpOverEthernetAddressInfo.  # noqa: E501
        :rtype: IpAddress
        """
        return self._addresses

    @addresses.setter
    def addresses(self, addresses):
        """Sets the addresses of this IpOverEthernetAddressInfo.


        :param addresses: The addresses of this IpOverEthernetAddressInfo.  # noqa: E501
        :type: IpAddress
        """

        self._addresses = addresses

    @property
    def is_dynamic(self):
        """Gets the is_dynamic of this IpOverEthernetAddressInfo.  # noqa: E501

        Indicates whether this set of addresses was assigned dynamically (true) or based on address information provided as input from the API consumer (false). Shall be present if \"addresses\" is present and shall be absent otherwise.   # noqa: E501

        :return: The is_dynamic of this IpOverEthernetAddressInfo.  # noqa: E501
        :rtype: bool
        """
        return self._is_dynamic

    @is_dynamic.setter
    def is_dynamic(self, is_dynamic):
        """Sets the is_dynamic of this IpOverEthernetAddressInfo.

        Indicates whether this set of addresses was assigned dynamically (true) or based on address information provided as input from the API consumer (false). Shall be present if \"addresses\" is present and shall be absent otherwise.   # noqa: E501

        :param is_dynamic: The is_dynamic of this IpOverEthernetAddressInfo.  # noqa: E501
        :type: bool
        """

        self._is_dynamic = is_dynamic

    @property
    def address_range(self):
        """Gets the address_range of this IpOverEthernetAddressInfo.  # noqa: E501


        :return: The address_range of this IpOverEthernetAddressInfo.  # noqa: E501
        :rtype: IpOverEthernetAddressInfoAddressRange1
        """
        return self._address_range

    @address_range.setter
    def address_range(self, address_range):
        """Sets the address_range of this IpOverEthernetAddressInfo.


        :param address_range: The address_range of this IpOverEthernetAddressInfo.  # noqa: E501
        :type: IpOverEthernetAddressInfoAddressRange1
        """

        self._address_range = address_range

    @property
    def min_address(self):
        """Gets the min_address of this IpOverEthernetAddressInfo.  # noqa: E501


        :return: The min_address of this IpOverEthernetAddressInfo.  # noqa: E501
        :rtype: IpAddress
        """
        return self._min_address

    @min_address.setter
    def min_address(self, min_address):
        """Sets the min_address of this IpOverEthernetAddressInfo.


        :param min_address: The min_address of this IpOverEthernetAddressInfo.  # noqa: E501
        :type: IpAddress
        """

        self._min_address = min_address

    @property
    def max_address(self):
        """Gets the max_address of this IpOverEthernetAddressInfo.  # noqa: E501


        :return: The max_address of this IpOverEthernetAddressInfo.  # noqa: E501
        :rtype: IpAddress
        """
        return self._max_address

    @max_address.setter
    def max_address(self, max_address):
        """Sets the max_address of this IpOverEthernetAddressInfo.


        :param max_address: The max_address of this IpOverEthernetAddressInfo.  # noqa: E501
        :type: IpAddress
        """

        self._max_address = max_address

    @property
    def subnet_id(self):
        """Gets the subnet_id of this IpOverEthernetAddressInfo.  # noqa: E501


        :return: The subnet_id of this IpOverEthernetAddressInfo.  # noqa: E501
        :rtype: IdentifierInVim
        """
        return self._subnet_id

    @subnet_id.setter
    def subnet_id(self, subnet_id):
        """Sets the subnet_id of this IpOverEthernetAddressInfo.


        :param subnet_id: The subnet_id of this IpOverEthernetAddressInfo.  # noqa: E501
        :type: IdentifierInVim
        """

        self._subnet_id = subnet_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IpOverEthernetAddressInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IpOverEthernetAddressInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
