# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class LifecycleChangeNotificationsFilter(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'ns_instance_subscription_filter': 'NsInstanceSubscriptionFilter',
        'notification_types': 'list[str]',
        'operation_types': 'list[NsLcmOpType]',
        'operation_states': 'list[LcmOperationStateType]',
        'ns_component_types': 'list[NsComponentType]',
        'lcm_op_name_impacting_ns_component': 'list[LcmOpNameForChangeNotificationType]',
        'lcm_op_occ_status_impacting_ns_component': 'list[LcmOpOccStatusForChangeNotificationType]'
    }

    attribute_map = {
        'ns_instance_subscription_filter': 'nsInstanceSubscriptionFilter',
        'notification_types': 'notificationTypes',
        'operation_types': 'operationTypes',
        'operation_states': 'operationStates',
        'ns_component_types': 'nsComponentTypes',
        'lcm_op_name_impacting_ns_component': 'lcmOpNameImpactingNsComponent',
        'lcm_op_occ_status_impacting_ns_component': 'lcmOpOccStatusImpactingNsComponent'
    }

    def __init__(self, ns_instance_subscription_filter=None, notification_types=None, operation_types=None, operation_states=None, ns_component_types=None, lcm_op_name_impacting_ns_component=None, lcm_op_occ_status_impacting_ns_component=None):  # noqa: E501
        """LifecycleChangeNotificationsFilter - a model defined in Swagger"""  # noqa: E501
        self._ns_instance_subscription_filter = None
        self._notification_types = None
        self._operation_types = None
        self._operation_states = None
        self._ns_component_types = None
        self._lcm_op_name_impacting_ns_component = None
        self._lcm_op_occ_status_impacting_ns_component = None
        self.discriminator = None
        if ns_instance_subscription_filter is not None:
            self.ns_instance_subscription_filter = ns_instance_subscription_filter
        if notification_types is not None:
            self.notification_types = notification_types
        if operation_types is not None:
            self.operation_types = operation_types
        if operation_states is not None:
            self.operation_states = operation_states
        if ns_component_types is not None:
            self.ns_component_types = ns_component_types
        if lcm_op_name_impacting_ns_component is not None:
            self.lcm_op_name_impacting_ns_component = lcm_op_name_impacting_ns_component
        if lcm_op_occ_status_impacting_ns_component is not None:
            self.lcm_op_occ_status_impacting_ns_component = lcm_op_occ_status_impacting_ns_component

    @property
    def ns_instance_subscription_filter(self):
        """Gets the ns_instance_subscription_filter of this LifecycleChangeNotificationsFilter.  # noqa: E501


        :return: The ns_instance_subscription_filter of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :rtype: NsInstanceSubscriptionFilter
        """
        return self._ns_instance_subscription_filter

    @ns_instance_subscription_filter.setter
    def ns_instance_subscription_filter(self, ns_instance_subscription_filter):
        """Sets the ns_instance_subscription_filter of this LifecycleChangeNotificationsFilter.


        :param ns_instance_subscription_filter: The ns_instance_subscription_filter of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :type: NsInstanceSubscriptionFilter
        """

        self._ns_instance_subscription_filter = ns_instance_subscription_filter

    @property
    def notification_types(self):
        """Gets the notification_types of this LifecycleChangeNotificationsFilter.  # noqa: E501

        Match particular notification types. Permitted values: - NsLcmOperationOccurenceNotification - NsIdentifierCreationNotification - NsIdentifierDeletionNotification - NsChangeNotification   # noqa: E501

        :return: The notification_types of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :rtype: list[str]
        """
        return self._notification_types

    @notification_types.setter
    def notification_types(self, notification_types):
        """Sets the notification_types of this LifecycleChangeNotificationsFilter.

        Match particular notification types. Permitted values: - NsLcmOperationOccurenceNotification - NsIdentifierCreationNotification - NsIdentifierDeletionNotification - NsChangeNotification   # noqa: E501

        :param notification_types: The notification_types of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :type: list[str]
        """

        self._notification_types = notification_types

    @property
    def operation_types(self):
        """Gets the operation_types of this LifecycleChangeNotificationsFilter.  # noqa: E501

        Match particular NS lifecycle operation types for the notification of type NsLcmOperationOccurrenceNotification. May be present if the \"notificationTypes\" attribute contains the value \"NsLcmOperationOccurrenceNotification\", and shall be absent otherwise.   # noqa: E501

        :return: The operation_types of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :rtype: list[NsLcmOpType]
        """
        return self._operation_types

    @operation_types.setter
    def operation_types(self, operation_types):
        """Sets the operation_types of this LifecycleChangeNotificationsFilter.

        Match particular NS lifecycle operation types for the notification of type NsLcmOperationOccurrenceNotification. May be present if the \"notificationTypes\" attribute contains the value \"NsLcmOperationOccurrenceNotification\", and shall be absent otherwise.   # noqa: E501

        :param operation_types: The operation_types of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :type: list[NsLcmOpType]
        """

        self._operation_types = operation_types

    @property
    def operation_states(self):
        """Gets the operation_states of this LifecycleChangeNotificationsFilter.  # noqa: E501

        Match particular LCM operation state values as reported in notifications of type NsLcmOperationOccurrenceNotification. May be present if the \"notificationTypes\" attribute contains the value \"NsLcmOperationOccurrenceNotification\", and shall be absent otherwise.   # noqa: E501

        :return: The operation_states of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :rtype: list[LcmOperationStateType]
        """
        return self._operation_states

    @operation_states.setter
    def operation_states(self, operation_states):
        """Sets the operation_states of this LifecycleChangeNotificationsFilter.

        Match particular LCM operation state values as reported in notifications of type NsLcmOperationOccurrenceNotification. May be present if the \"notificationTypes\" attribute contains the value \"NsLcmOperationOccurrenceNotification\", and shall be absent otherwise.   # noqa: E501

        :param operation_states: The operation_states of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :type: list[LcmOperationStateType]
        """

        self._operation_states = operation_states

    @property
    def ns_component_types(self):
        """Gets the ns_component_types of this LifecycleChangeNotificationsFilter.  # noqa: E501

        Match particular NS component types for the notification of type NsChangeNotification. May be present if the \"notificationTypes\" attribute contains the value \"NsChang.   # noqa: E501

        :return: The ns_component_types of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :rtype: list[NsComponentType]
        """
        return self._ns_component_types

    @ns_component_types.setter
    def ns_component_types(self, ns_component_types):
        """Sets the ns_component_types of this LifecycleChangeNotificationsFilter.

        Match particular NS component types for the notification of type NsChangeNotification. May be present if the \"notificationTypes\" attribute contains the value \"NsChang.   # noqa: E501

        :param ns_component_types: The ns_component_types of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :type: list[NsComponentType]
        """

        self._ns_component_types = ns_component_types

    @property
    def lcm_op_name_impacting_ns_component(self):
        """Gets the lcm_op_name_impacting_ns_component of this LifecycleChangeNotificationsFilter.  # noqa: E501

        Match particular LCM operation names for the notification of type NsChangeNotification. May be present if the \"notificationTypes\" attribute contains the value \"NsChangeNotification\", and shall be absent otherwise.   # noqa: E501

        :return: The lcm_op_name_impacting_ns_component of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :rtype: list[LcmOpNameForChangeNotificationType]
        """
        return self._lcm_op_name_impacting_ns_component

    @lcm_op_name_impacting_ns_component.setter
    def lcm_op_name_impacting_ns_component(self, lcm_op_name_impacting_ns_component):
        """Sets the lcm_op_name_impacting_ns_component of this LifecycleChangeNotificationsFilter.

        Match particular LCM operation names for the notification of type NsChangeNotification. May be present if the \"notificationTypes\" attribute contains the value \"NsChangeNotification\", and shall be absent otherwise.   # noqa: E501

        :param lcm_op_name_impacting_ns_component: The lcm_op_name_impacting_ns_component of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :type: list[LcmOpNameForChangeNotificationType]
        """

        self._lcm_op_name_impacting_ns_component = lcm_op_name_impacting_ns_component

    @property
    def lcm_op_occ_status_impacting_ns_component(self):
        """Gets the lcm_op_occ_status_impacting_ns_component of this LifecycleChangeNotificationsFilter.  # noqa: E501

        Match particular LCM operation status values as reported in notifications of type NsChangeNotification. May be present if the \"notificationTypes\" attribute contains the value \"NsChangeNotification\", and shall be absent otherwise.   # noqa: E501

        :return: The lcm_op_occ_status_impacting_ns_component of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :rtype: list[LcmOpOccStatusForChangeNotificationType]
        """
        return self._lcm_op_occ_status_impacting_ns_component

    @lcm_op_occ_status_impacting_ns_component.setter
    def lcm_op_occ_status_impacting_ns_component(self, lcm_op_occ_status_impacting_ns_component):
        """Sets the lcm_op_occ_status_impacting_ns_component of this LifecycleChangeNotificationsFilter.

        Match particular LCM operation status values as reported in notifications of type NsChangeNotification. May be present if the \"notificationTypes\" attribute contains the value \"NsChangeNotification\", and shall be absent otherwise.   # noqa: E501

        :param lcm_op_occ_status_impacting_ns_component: The lcm_op_occ_status_impacting_ns_component of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :type: list[LcmOpOccStatusForChangeNotificationType]
        """

        self._lcm_op_occ_status_impacting_ns_component = lcm_op_occ_status_impacting_ns_component

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(LifecycleChangeNotificationsFilter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LifecycleChangeNotificationsFilter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
