# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class LocationConstraints(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'country_code': 'str',
        'civic_address_element': 'list[LocationConstraintsCivicAddressElement]'
    }

    attribute_map = {
        'country_code': 'countryCode',
        'civic_address_element': 'civicAddressElement'
    }

    def __init__(self, country_code=None, civic_address_element=None):  # noqa: E501
        """LocationConstraints - a model defined in Swagger"""  # noqa: E501
        self._country_code = None
        self._civic_address_element = None
        self.discriminator = None
        self.country_code = country_code
        if civic_address_element is not None:
            self.civic_address_element = civic_address_element

    @property
    def country_code(self):
        """Gets the country_code of this LocationConstraints.  # noqa: E501

        The two-letter ISO 3166 [29] country code in capital letters.   # noqa: E501

        :return: The country_code of this LocationConstraints.  # noqa: E501
        :rtype: str
        """
        return self._country_code

    @country_code.setter
    def country_code(self, country_code):
        """Sets the country_code of this LocationConstraints.

        The two-letter ISO 3166 [29] country code in capital letters.   # noqa: E501

        :param country_code: The country_code of this LocationConstraints.  # noqa: E501
        :type: str
        """
        if country_code is None:
            print("WARNING: Invalid value for the required field `country_code`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `country_code`, must not be `None`")  # noqa: E501

        self._country_code = country_code

    @property
    def civic_address_element(self):
        """Gets the civic_address_element of this LocationConstraints.  # noqa: E501

        Zero or more elements comprising the civic address.   # noqa: E501

        :return: The civic_address_element of this LocationConstraints.  # noqa: E501
        :rtype: list[LocationConstraintsCivicAddressElement]
        """
        return self._civic_address_element

    @civic_address_element.setter
    def civic_address_element(self, civic_address_element):
        """Sets the civic_address_element of this LocationConstraints.

        Zero or more elements comprising the civic address.   # noqa: E501

        :param civic_address_element: The civic_address_element of this LocationConstraints.  # noqa: E501
        :type: list[LocationConstraintsCivicAddressElement]
        """

        self._civic_address_element = civic_address_element

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(LocationConstraints, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LocationConstraints):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
