# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class Mask(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'starting_point': 'int',
        'length': 'int',
        'value': 'str'
    }

    attribute_map = {
        'starting_point': 'startingPoint',
        'length': 'length',
        'value': 'value'
    }

    def __init__(self, starting_point=None, length=None, value=None):  # noqa: E501
        """Mask - a model defined in Swagger"""  # noqa: E501
        self._starting_point = None
        self._length = None
        self._value = None
        self.discriminator = None
        self.starting_point = starting_point
        self.length = length
        self.value = value

    @property
    def starting_point(self):
        """Gets the starting_point of this Mask.  # noqa: E501

        Indicates the offset between the last bit of the source mac address and the first bit of the sequence of bits to be matched.   # noqa: E501

        :return: The starting_point of this Mask.  # noqa: E501
        :rtype: int
        """
        return self._starting_point

    @starting_point.setter
    def starting_point(self, starting_point):
        """Sets the starting_point of this Mask.

        Indicates the offset between the last bit of the source mac address and the first bit of the sequence of bits to be matched.   # noqa: E501

        :param starting_point: The starting_point of this Mask.  # noqa: E501
        :type: int
        """
        if starting_point is None:
            print("WARNING: Invalid value for the required field `starting_point`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `starting_point`, must not be `None`")  # noqa: E501

        self._starting_point = starting_point

    @property
    def length(self):
        """Gets the length of this Mask.  # noqa: E501

        Indicates the number of bits to be matched.   # noqa: E501

        :return: The length of this Mask.  # noqa: E501
        :rtype: int
        """
        return self._length

    @length.setter
    def length(self, length):
        """Sets the length of this Mask.

        Indicates the number of bits to be matched.   # noqa: E501

        :param length: The length of this Mask.  # noqa: E501
        :type: int
        """
        if length is None:
            print("WARNING: Invalid value for the required field `length`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `length`, must not be `None`")  # noqa: E501

        self._length = length

    @property
    def value(self):
        """Gets the value of this Mask.  # noqa: E501

        Provide the sequence of bit values to be matched.   # noqa: E501

        :return: The value of this Mask.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this Mask.

        Provide the sequence of bit values to be matched.   # noqa: E501

        :param value: The value of this Mask.  # noqa: E501
        :type: str
        """
        if value is None:
            print("WARNING: Invalid value for the required field `value`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `value`, must not be `None`")  # noqa: E501

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Mask, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Mask):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
