# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class NfpData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'nfp_info_id': 'IdentifierInNs',
        'nfp_name': 'str',
        'description': 'str',
        'cp_group': 'list[CpGroupInfo]',
        'nfp_rule': 'NfpRule'
    }

    attribute_map = {
        'nfp_info_id': 'nfpInfoId',
        'nfp_name': 'nfpName',
        'description': 'description',
        'cp_group': 'cpGroup',
        'nfp_rule': 'nfpRule'
    }

    def __init__(self, nfp_info_id=None, nfp_name=None, description=None, cp_group=None, nfp_rule=None):  # noqa: E501
        """NfpData - a model defined in Swagger"""  # noqa: E501
        self._nfp_info_id = None
        self._nfp_name = None
        self._description = None
        self._cp_group = None
        self._nfp_rule = None
        self.discriminator = None
        if nfp_info_id is not None:
            self.nfp_info_id = nfp_info_id
        if nfp_name is not None:
            self.nfp_name = nfp_name
        if description is not None:
            self.description = description
        if cp_group is not None:
            self.cp_group = cp_group
        if nfp_rule is not None:
            self.nfp_rule = nfp_rule

    @property
    def nfp_info_id(self):
        """Gets the nfp_info_id of this NfpData.  # noqa: E501


        :return: The nfp_info_id of this NfpData.  # noqa: E501
        :rtype: IdentifierInNs
        """
        return self._nfp_info_id

    @nfp_info_id.setter
    def nfp_info_id(self, nfp_info_id):
        """Sets the nfp_info_id of this NfpData.


        :param nfp_info_id: The nfp_info_id of this NfpData.  # noqa: E501
        :type: IdentifierInNs
        """

        self._nfp_info_id = nfp_info_id

    @property
    def nfp_name(self):
        """Gets the nfp_name of this NfpData.  # noqa: E501

        Human readable name for the NFP. It shall be present for the new NFP, and it may be present otherwise. It shall be present for the new NFP, and it may be  present otherwise.   # noqa: E501

        :return: The nfp_name of this NfpData.  # noqa: E501
        :rtype: str
        """
        return self._nfp_name

    @nfp_name.setter
    def nfp_name(self, nfp_name):
        """Sets the nfp_name of this NfpData.

        Human readable name for the NFP. It shall be present for the new NFP, and it may be present otherwise. It shall be present for the new NFP, and it may be  present otherwise.   # noqa: E501

        :param nfp_name: The nfp_name of this NfpData.  # noqa: E501
        :type: str
        """

        self._nfp_name = nfp_name

    @property
    def description(self):
        """Gets the description of this NfpData.  # noqa: E501

        Human readable description for the NFP. It shall be present for the new NFP, and it may be present otherwise. It shall be present for the new NFP, and it may be  present otherwise.   # noqa: E501

        :return: The description of this NfpData.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this NfpData.

        Human readable description for the NFP. It shall be present for the new NFP, and it may be present otherwise. It shall be present for the new NFP, and it may be  present otherwise.   # noqa: E501

        :param description: The description of this NfpData.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def cp_group(self):
        """Gets the cp_group of this NfpData.  # noqa: E501

        Group(s) of CPs and/or SAPs which the NFP passes by. Cardinality can be 0 if only updated or newly created NFP classification and selection rule which applied to an existing NFP is provided. At least a CP or an nfpRule shall be present. When multiple identifiers are included, the position of  the identifier in the cpGroup value specifies the position  of the group in the path.   # noqa: E501

        :return: The cp_group of this NfpData.  # noqa: E501
        :rtype: list[CpGroupInfo]
        """
        return self._cp_group

    @cp_group.setter
    def cp_group(self, cp_group):
        """Sets the cp_group of this NfpData.

        Group(s) of CPs and/or SAPs which the NFP passes by. Cardinality can be 0 if only updated or newly created NFP classification and selection rule which applied to an existing NFP is provided. At least a CP or an nfpRule shall be present. When multiple identifiers are included, the position of  the identifier in the cpGroup value specifies the position  of the group in the path.   # noqa: E501

        :param cp_group: The cp_group of this NfpData.  # noqa: E501
        :type: list[CpGroupInfo]
        """

        self._cp_group = cp_group

    @property
    def nfp_rule(self):
        """Gets the nfp_rule of this NfpData.  # noqa: E501


        :return: The nfp_rule of this NfpData.  # noqa: E501
        :rtype: NfpRule
        """
        return self._nfp_rule

    @nfp_rule.setter
    def nfp_rule(self, nfp_rule):
        """Sets the nfp_rule of this NfpData.


        :param nfp_rule: The nfp_rule of this NfpData.  # noqa: E501
        :type: NfpRule
        """

        self._nfp_rule = nfp_rule

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NfpData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NfpData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
