# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class NfpRule(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'ether_destination_address': 'MacAddress',
        'ether_source_address': 'MacAddress',
        'ether_type': 'str',
        'vlan_tag': 'list[String]',
        'protocol': 'str',
        'dscp': 'str',
        'source_port_range': 'PortRange',
        'destination_port_range': 'PortRange',
        'source_ip_address_prefix': 'IpAddressPrefix',
        'destination_ip_address_prefix': 'IpAddressPrefix',
        'extended_criteria': 'list[Mask]'
    }

    attribute_map = {
        'ether_destination_address': 'etherDestinationAddress',
        'ether_source_address': 'etherSourceAddress',
        'ether_type': 'etherType',
        'vlan_tag': 'vlanTag',
        'protocol': 'protocol',
        'dscp': 'dscp',
        'source_port_range': 'sourcePortRange',
        'destination_port_range': 'destinationPortRange',
        'source_ip_address_prefix': 'sourceIpAddressPrefix',
        'destination_ip_address_prefix': 'destinationIpAddressPrefix',
        'extended_criteria': 'extendedCriteria'
    }

    def __init__(self, ether_destination_address=None, ether_source_address=None, ether_type=None, vlan_tag=None, protocol=None, dscp=None, source_port_range=None, destination_port_range=None, source_ip_address_prefix=None, destination_ip_address_prefix=None, extended_criteria=None):  # noqa: E501
        """NfpRule - a model defined in Swagger"""  # noqa: E501
        self._ether_destination_address = None
        self._ether_source_address = None
        self._ether_type = None
        self._vlan_tag = None
        self._protocol = None
        self._dscp = None
        self._source_port_range = None
        self._destination_port_range = None
        self._source_ip_address_prefix = None
        self._destination_ip_address_prefix = None
        self._extended_criteria = None
        self.discriminator = None
        if ether_destination_address is not None:
            self.ether_destination_address = ether_destination_address
        if ether_source_address is not None:
            self.ether_source_address = ether_source_address
        if ether_type is not None:
            self.ether_type = ether_type
        if vlan_tag is not None:
            self.vlan_tag = vlan_tag
        if protocol is not None:
            self.protocol = protocol
        if dscp is not None:
            self.dscp = dscp
        if source_port_range is not None:
            self.source_port_range = source_port_range
        if destination_port_range is not None:
            self.destination_port_range = destination_port_range
        if source_ip_address_prefix is not None:
            self.source_ip_address_prefix = source_ip_address_prefix
        if destination_ip_address_prefix is not None:
            self.destination_ip_address_prefix = destination_ip_address_prefix
        if extended_criteria is not None:
            self.extended_criteria = extended_criteria

    @property
    def ether_destination_address(self):
        """Gets the ether_destination_address of this NfpRule.  # noqa: E501


        :return: The ether_destination_address of this NfpRule.  # noqa: E501
        :rtype: MacAddress
        """
        return self._ether_destination_address

    @ether_destination_address.setter
    def ether_destination_address(self, ether_destination_address):
        """Sets the ether_destination_address of this NfpRule.


        :param ether_destination_address: The ether_destination_address of this NfpRule.  # noqa: E501
        :type: MacAddress
        """

        self._ether_destination_address = ether_destination_address

    @property
    def ether_source_address(self):
        """Gets the ether_source_address of this NfpRule.  # noqa: E501


        :return: The ether_source_address of this NfpRule.  # noqa: E501
        :rtype: MacAddress
        """
        return self._ether_source_address

    @ether_source_address.setter
    def ether_source_address(self, ether_source_address):
        """Sets the ether_source_address of this NfpRule.


        :param ether_source_address: The ether_source_address of this NfpRule.  # noqa: E501
        :type: MacAddress
        """

        self._ether_source_address = ether_source_address

    @property
    def ether_type(self):
        """Gets the ether_type of this NfpRule.  # noqa: E501

        Human readable description for the VNFFG.   # noqa: E501

        :return: The ether_type of this NfpRule.  # noqa: E501
        :rtype: str
        """
        return self._ether_type

    @ether_type.setter
    def ether_type(self, ether_type):
        """Sets the ether_type of this NfpRule.

        Human readable description for the VNFFG.   # noqa: E501

        :param ether_type: The ether_type of this NfpRule.  # noqa: E501
        :type: str
        """
        allowed_values = ["IPV4", "IPV6"]  # noqa: E501
        if ether_type is not None and ether_type not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `ether_type` ({0}), must be one of {1}"  # noqa: E501
                .format(ether_type, allowed_values)
            )

        self._ether_type = ether_type

    @property
    def vlan_tag(self):
        """Gets the vlan_tag of this NfpRule.  # noqa: E501

        Indicates a VLAN identifier in an IEEE 802.1Q-2018 tag [6] Multiple tags can be included for QinQ stacking. See note.   # noqa: E501

        :return: The vlan_tag of this NfpRule.  # noqa: E501
        :rtype: list[String]
        """
        return self._vlan_tag

    @vlan_tag.setter
    def vlan_tag(self, vlan_tag):
        """Sets the vlan_tag of this NfpRule.

        Indicates a VLAN identifier in an IEEE 802.1Q-2018 tag [6] Multiple tags can be included for QinQ stacking. See note.   # noqa: E501

        :param vlan_tag: The vlan_tag of this NfpRule.  # noqa: E501
        :type: list[String]
        """

        self._vlan_tag = vlan_tag

    @property
    def protocol(self):
        """Gets the protocol of this NfpRule.  # noqa: E501

        Indicates the L4 protocol, For IPv4 [7] this corresponds to the field called \"Protocol\" to identify the next level protocol. For IPv6 [28] this corresponds to the field is called the \"Next Header\" field. Permitted values: Any keyword defined in the IANA protocol registry [1], e.g.: TCP UDP ICMP   # noqa: E501

        :return: The protocol of this NfpRule.  # noqa: E501
        :rtype: str
        """
        return self._protocol

    @protocol.setter
    def protocol(self, protocol):
        """Sets the protocol of this NfpRule.

        Indicates the L4 protocol, For IPv4 [7] this corresponds to the field called \"Protocol\" to identify the next level protocol. For IPv6 [28] this corresponds to the field is called the \"Next Header\" field. Permitted values: Any keyword defined in the IANA protocol registry [1], e.g.: TCP UDP ICMP   # noqa: E501

        :param protocol: The protocol of this NfpRule.  # noqa: E501
        :type: str
        """
        allowed_values = ["TCP", "UDP", "ICMP"]  # noqa: E501
        if protocol is not None and protocol not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `protocol` ({0}), must be one of {1}"  # noqa: E501
                .format(protocol, allowed_values)
            )

        self._protocol = protocol

    @property
    def dscp(self):
        """Gets the dscp of this NfpRule.  # noqa: E501

        For IPv4 [7] a string of \"0\" and \"1\" digits that corresponds to the 6-bit Differentiated Services Code Point (DSCP) field of the IP header. For IPv6 [28] a string of \"0\" and \"1\" digits that corresponds to the 6 differentiated services bits of the traffic class header field   # noqa: E501

        :return: The dscp of this NfpRule.  # noqa: E501
        :rtype: str
        """
        return self._dscp

    @dscp.setter
    def dscp(self, dscp):
        """Sets the dscp of this NfpRule.

        For IPv4 [7] a string of \"0\" and \"1\" digits that corresponds to the 6-bit Differentiated Services Code Point (DSCP) field of the IP header. For IPv6 [28] a string of \"0\" and \"1\" digits that corresponds to the 6 differentiated services bits of the traffic class header field   # noqa: E501

        :param dscp: The dscp of this NfpRule.  # noqa: E501
        :type: str
        """

        self._dscp = dscp

    @property
    def source_port_range(self):
        """Gets the source_port_range of this NfpRule.  # noqa: E501


        :return: The source_port_range of this NfpRule.  # noqa: E501
        :rtype: PortRange
        """
        return self._source_port_range

    @source_port_range.setter
    def source_port_range(self, source_port_range):
        """Sets the source_port_range of this NfpRule.


        :param source_port_range: The source_port_range of this NfpRule.  # noqa: E501
        :type: PortRange
        """

        self._source_port_range = source_port_range

    @property
    def destination_port_range(self):
        """Gets the destination_port_range of this NfpRule.  # noqa: E501


        :return: The destination_port_range of this NfpRule.  # noqa: E501
        :rtype: PortRange
        """
        return self._destination_port_range

    @destination_port_range.setter
    def destination_port_range(self, destination_port_range):
        """Sets the destination_port_range of this NfpRule.


        :param destination_port_range: The destination_port_range of this NfpRule.  # noqa: E501
        :type: PortRange
        """

        self._destination_port_range = destination_port_range

    @property
    def source_ip_address_prefix(self):
        """Gets the source_ip_address_prefix of this NfpRule.  # noqa: E501


        :return: The source_ip_address_prefix of this NfpRule.  # noqa: E501
        :rtype: IpAddressPrefix
        """
        return self._source_ip_address_prefix

    @source_ip_address_prefix.setter
    def source_ip_address_prefix(self, source_ip_address_prefix):
        """Sets the source_ip_address_prefix of this NfpRule.


        :param source_ip_address_prefix: The source_ip_address_prefix of this NfpRule.  # noqa: E501
        :type: IpAddressPrefix
        """

        self._source_ip_address_prefix = source_ip_address_prefix

    @property
    def destination_ip_address_prefix(self):
        """Gets the destination_ip_address_prefix of this NfpRule.  # noqa: E501


        :return: The destination_ip_address_prefix of this NfpRule.  # noqa: E501
        :rtype: IpAddressPrefix
        """
        return self._destination_ip_address_prefix

    @destination_ip_address_prefix.setter
    def destination_ip_address_prefix(self, destination_ip_address_prefix):
        """Sets the destination_ip_address_prefix of this NfpRule.


        :param destination_ip_address_prefix: The destination_ip_address_prefix of this NfpRule.  # noqa: E501
        :type: IpAddressPrefix
        """

        self._destination_ip_address_prefix = destination_ip_address_prefix

    @property
    def extended_criteria(self):
        """Gets the extended_criteria of this NfpRule.  # noqa: E501

        Indicates values of specific bits in a frame.   # noqa: E501

        :return: The extended_criteria of this NfpRule.  # noqa: E501
        :rtype: list[Mask]
        """
        return self._extended_criteria

    @extended_criteria.setter
    def extended_criteria(self, extended_criteria):
        """Sets the extended_criteria of this NfpRule.

        Indicates values of specific bits in a frame.   # noqa: E501

        :param extended_criteria: The extended_criteria of this NfpRule.  # noqa: E501
        :type: list[Mask]
        """

        self._extended_criteria = extended_criteria

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NfpRule, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NfpRule):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
