# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class NsInstance(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'Identifier',
        'ns_instance_name': 'str',
        'ns_instance_description': 'str',
        'nsd_id': 'Identifier',
        'nsd_info_id': 'Identifier',
        'flavour_id': 'IdentifierInNsd',
        'vnf_instance': 'list[VnfInstance]',
        'pnf_info': 'list[PnfInfo]',
        'virtual_link_info': 'list[NsVirtualLinkInfo]',
        'vnffg_info': 'list[VnffgInfo]',
        'sap_info': 'list[SapInfo]',
        'nested_ns_instance_id': 'list[Identifier]',
        'ns_state': 'str',
        'monitoring_parameter': 'list[NsMonitoringParameter]',
        'ns_scale_status': 'list[NsScaleInfo]',
        'additional_affinity_or_anti_affinity_rule': 'list[AffinityOrAntiAffinityRule]',
        'links': 'NsInstanceLinks'
    }

    attribute_map = {
        'id': 'id',
        'ns_instance_name': 'nsInstanceName',
        'ns_instance_description': 'nsInstanceDescription',
        'nsd_id': 'nsdId',
        'nsd_info_id': 'nsdInfoId',
        'flavour_id': 'flavourId',
        'vnf_instance': 'vnfInstance',
        'pnf_info': 'pnfInfo',
        'virtual_link_info': 'virtualLinkInfo',
        'vnffg_info': 'vnffgInfo',
        'sap_info': 'sapInfo',
        'nested_ns_instance_id': 'nestedNsInstanceId',
        'ns_state': 'nsState',
        'monitoring_parameter': 'monitoringParameter',
        'ns_scale_status': 'nsScaleStatus',
        'additional_affinity_or_anti_affinity_rule': 'additionalAffinityOrAntiAffinityRule',
        'links': '_links'
    }

    def __init__(self, id=None, ns_instance_name=None, ns_instance_description=None, nsd_id=None, nsd_info_id=None, flavour_id=None, vnf_instance=None, pnf_info=None, virtual_link_info=None, vnffg_info=None, sap_info=None, nested_ns_instance_id=None, ns_state=None, monitoring_parameter=None, ns_scale_status=None, additional_affinity_or_anti_affinity_rule=None, links=None):  # noqa: E501
        """NsInstance - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._ns_instance_name = None
        self._ns_instance_description = None
        self._nsd_id = None
        self._nsd_info_id = None
        self._flavour_id = None
        self._vnf_instance = None
        self._pnf_info = None
        self._virtual_link_info = None
        self._vnffg_info = None
        self._sap_info = None
        self._nested_ns_instance_id = None
        self._ns_state = None
        self._monitoring_parameter = None
        self._ns_scale_status = None
        self._additional_affinity_or_anti_affinity_rule = None
        self._links = None
        self.discriminator = None
        self.id = id
        self.ns_instance_name = ns_instance_name
        self.ns_instance_description = ns_instance_description
        self.nsd_id = nsd_id
        self.nsd_info_id = nsd_info_id
        if flavour_id is not None:
            self.flavour_id = flavour_id
        if vnf_instance is not None:
            self.vnf_instance = vnf_instance
        if pnf_info is not None:
            self.pnf_info = pnf_info
        if virtual_link_info is not None:
            self.virtual_link_info = virtual_link_info
        if vnffg_info is not None:
            self.vnffg_info = vnffg_info
        if sap_info is not None:
            self.sap_info = sap_info
        if nested_ns_instance_id is not None:
            self.nested_ns_instance_id = nested_ns_instance_id
        self.ns_state = ns_state
        if monitoring_parameter is not None:
            self.monitoring_parameter = monitoring_parameter
        if ns_scale_status is not None:
            self.ns_scale_status = ns_scale_status
        if additional_affinity_or_anti_affinity_rule is not None:
            self.additional_affinity_or_anti_affinity_rule = additional_affinity_or_anti_affinity_rule
        self.links = links

    @property
    def id(self):
        """Gets the id of this NsInstance.  # noqa: E501


        :return: The id of this NsInstance.  # noqa: E501
        :rtype: Identifier
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this NsInstance.


        :param id: The id of this NsInstance.  # noqa: E501
        :type: Identifier
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def ns_instance_name(self):
        """Gets the ns_instance_name of this NsInstance.  # noqa: E501

        Human readable name of the NS instance.   # noqa: E501

        :return: The ns_instance_name of this NsInstance.  # noqa: E501
        :rtype: str
        """
        return self._ns_instance_name

    @ns_instance_name.setter
    def ns_instance_name(self, ns_instance_name):
        """Sets the ns_instance_name of this NsInstance.

        Human readable name of the NS instance.   # noqa: E501

        :param ns_instance_name: The ns_instance_name of this NsInstance.  # noqa: E501
        :type: str
        """
        if ns_instance_name is None:
            print("WARNING: Invalid value for the required field `ns_instance_name`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `ns_instance_name`, must not be `None`")  # noqa: E501

        self._ns_instance_name = ns_instance_name

    @property
    def ns_instance_description(self):
        """Gets the ns_instance_description of this NsInstance.  # noqa: E501

        Human readable description of the NS instance.   # noqa: E501

        :return: The ns_instance_description of this NsInstance.  # noqa: E501
        :rtype: str
        """
        return self._ns_instance_description

    @ns_instance_description.setter
    def ns_instance_description(self, ns_instance_description):
        """Sets the ns_instance_description of this NsInstance.

        Human readable description of the NS instance.   # noqa: E501

        :param ns_instance_description: The ns_instance_description of this NsInstance.  # noqa: E501
        :type: str
        """
        if ns_instance_description is None:
            print("WARNING: Invalid value for the required field `ns_instance_description`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `ns_instance_description`, must not be `None`")  # noqa: E501

        self._ns_instance_description = ns_instance_description

    @property
    def nsd_id(self):
        """Gets the nsd_id of this NsInstance.  # noqa: E501


        :return: The nsd_id of this NsInstance.  # noqa: E501
        :rtype: Identifier
        """
        return self._nsd_id

    @nsd_id.setter
    def nsd_id(self, nsd_id):
        """Sets the nsd_id of this NsInstance.


        :param nsd_id: The nsd_id of this NsInstance.  # noqa: E501
        :type: Identifier
        """
        if nsd_id is None:
            print("WARNING: Invalid value for the required field `nsd_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `nsd_id`, must not be `None`")  # noqa: E501

        self._nsd_id = nsd_id

    @property
    def nsd_info_id(self):
        """Gets the nsd_info_id of this NsInstance.  # noqa: E501


        :return: The nsd_info_id of this NsInstance.  # noqa: E501
        :rtype: Identifier
        """
        return self._nsd_info_id

    @nsd_info_id.setter
    def nsd_info_id(self, nsd_info_id):
        """Sets the nsd_info_id of this NsInstance.


        :param nsd_info_id: The nsd_info_id of this NsInstance.  # noqa: E501
        :type: Identifier
        """
        if nsd_info_id is None:
            print("WARNING: Invalid value for the required field `nsd_info_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `nsd_info_id`, must not be `None`")  # noqa: E501

        self._nsd_info_id = nsd_info_id

    @property
    def flavour_id(self):
        """Gets the flavour_id of this NsInstance.  # noqa: E501


        :return: The flavour_id of this NsInstance.  # noqa: E501
        :rtype: IdentifierInNsd
        """
        return self._flavour_id

    @flavour_id.setter
    def flavour_id(self, flavour_id):
        """Sets the flavour_id of this NsInstance.


        :param flavour_id: The flavour_id of this NsInstance.  # noqa: E501
        :type: IdentifierInNsd
        """

        self._flavour_id = flavour_id

    @property
    def vnf_instance(self):
        """Gets the vnf_instance of this NsInstance.  # noqa: E501

        Information on constituent VNF(s) of the NS instance.   # noqa: E501

        :return: The vnf_instance of this NsInstance.  # noqa: E501
        :rtype: list[VnfInstance]
        """
        return self._vnf_instance

    @vnf_instance.setter
    def vnf_instance(self, vnf_instance):
        """Sets the vnf_instance of this NsInstance.

        Information on constituent VNF(s) of the NS instance.   # noqa: E501

        :param vnf_instance: The vnf_instance of this NsInstance.  # noqa: E501
        :type: list[VnfInstance]
        """

        self._vnf_instance = vnf_instance

    @property
    def pnf_info(self):
        """Gets the pnf_info of this NsInstance.  # noqa: E501

        Information on the PNF(s) that are part of the NS instance.   # noqa: E501

        :return: The pnf_info of this NsInstance.  # noqa: E501
        :rtype: list[PnfInfo]
        """
        return self._pnf_info

    @pnf_info.setter
    def pnf_info(self, pnf_info):
        """Sets the pnf_info of this NsInstance.

        Information on the PNF(s) that are part of the NS instance.   # noqa: E501

        :param pnf_info: The pnf_info of this NsInstance.  # noqa: E501
        :type: list[PnfInfo]
        """

        self._pnf_info = pnf_info

    @property
    def virtual_link_info(self):
        """Gets the virtual_link_info of this NsInstance.  # noqa: E501

        Information on the VL(s) of the NS instance. This attribute shall be present if the nsState attribute value is INSTANTIATED and if the NS instance has specified connectivity.   # noqa: E501

        :return: The virtual_link_info of this NsInstance.  # noqa: E501
        :rtype: list[NsVirtualLinkInfo]
        """
        return self._virtual_link_info

    @virtual_link_info.setter
    def virtual_link_info(self, virtual_link_info):
        """Sets the virtual_link_info of this NsInstance.

        Information on the VL(s) of the NS instance. This attribute shall be present if the nsState attribute value is INSTANTIATED and if the NS instance has specified connectivity.   # noqa: E501

        :param virtual_link_info: The virtual_link_info of this NsInstance.  # noqa: E501
        :type: list[NsVirtualLinkInfo]
        """

        self._virtual_link_info = virtual_link_info

    @property
    def vnffg_info(self):
        """Gets the vnffg_info of this NsInstance.  # noqa: E501

        Information on the VNFFG(s) of the NS instance.   # noqa: E501

        :return: The vnffg_info of this NsInstance.  # noqa: E501
        :rtype: list[VnffgInfo]
        """
        return self._vnffg_info

    @vnffg_info.setter
    def vnffg_info(self, vnffg_info):
        """Sets the vnffg_info of this NsInstance.

        Information on the VNFFG(s) of the NS instance.   # noqa: E501

        :param vnffg_info: The vnffg_info of this NsInstance.  # noqa: E501
        :type: list[VnffgInfo]
        """

        self._vnffg_info = vnffg_info

    @property
    def sap_info(self):
        """Gets the sap_info of this NsInstance.  # noqa: E501

        Information on the SAP(s) of the NS instance.   # noqa: E501

        :return: The sap_info of this NsInstance.  # noqa: E501
        :rtype: list[SapInfo]
        """
        return self._sap_info

    @sap_info.setter
    def sap_info(self, sap_info):
        """Sets the sap_info of this NsInstance.

        Information on the SAP(s) of the NS instance.   # noqa: E501

        :param sap_info: The sap_info of this NsInstance.  # noqa: E501
        :type: list[SapInfo]
        """

        self._sap_info = sap_info

    @property
    def nested_ns_instance_id(self):
        """Gets the nested_ns_instance_id of this NsInstance.  # noqa: E501

        Identifier of the nested NS(s) of the NS instance.   # noqa: E501

        :return: The nested_ns_instance_id of this NsInstance.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._nested_ns_instance_id

    @nested_ns_instance_id.setter
    def nested_ns_instance_id(self, nested_ns_instance_id):
        """Sets the nested_ns_instance_id of this NsInstance.

        Identifier of the nested NS(s) of the NS instance.   # noqa: E501

        :param nested_ns_instance_id: The nested_ns_instance_id of this NsInstance.  # noqa: E501
        :type: list[Identifier]
        """

        self._nested_ns_instance_id = nested_ns_instance_id

    @property
    def ns_state(self):
        """Gets the ns_state of this NsInstance.  # noqa: E501

        The state of the NS instance. Permitted values: NOT_INSTANTIATED: The NS instance is terminated or not instantiated. INSTANTIATED: The NS instance is instantiated.   # noqa: E501

        :return: The ns_state of this NsInstance.  # noqa: E501
        :rtype: str
        """
        return self._ns_state

    @ns_state.setter
    def ns_state(self, ns_state):
        """Sets the ns_state of this NsInstance.

        The state of the NS instance. Permitted values: NOT_INSTANTIATED: The NS instance is terminated or not instantiated. INSTANTIATED: The NS instance is instantiated.   # noqa: E501

        :param ns_state: The ns_state of this NsInstance.  # noqa: E501
        :type: str
        """
        if ns_state is None:
            print("WARNING: Invalid value for the required field `ns_state`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `ns_state`, must not be `None`")  # noqa: E501
        allowed_values = ["NOT_INSTANTIATED", "INSTANTIATED"]  # noqa: E501
        if ns_state is not None and ns_state not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `ns_state` ({0}), must be one of {1}"  # noqa: E501
                .format(ns_state, allowed_values)
            )

        self._ns_state = ns_state

    @property
    def monitoring_parameter(self):
        """Gets the monitoring_parameter of this NsInstance.  # noqa: E501

        Performance metrics tracked by the NFVO (e.g. for auto-scaling purposes) as identified by the NS designer in the NSD.   # noqa: E501

        :return: The monitoring_parameter of this NsInstance.  # noqa: E501
        :rtype: list[NsMonitoringParameter]
        """
        return self._monitoring_parameter

    @monitoring_parameter.setter
    def monitoring_parameter(self, monitoring_parameter):
        """Sets the monitoring_parameter of this NsInstance.

        Performance metrics tracked by the NFVO (e.g. for auto-scaling purposes) as identified by the NS designer in the NSD.   # noqa: E501

        :param monitoring_parameter: The monitoring_parameter of this NsInstance.  # noqa: E501
        :type: list[NsMonitoringParameter]
        """

        self._monitoring_parameter = monitoring_parameter

    @property
    def ns_scale_status(self):
        """Gets the ns_scale_status of this NsInstance.  # noqa: E501

        Status of each NS scaling aspect declared in the applicable DF, how \"big\" the NS instance has been scaled w.r.t. that aspect. This attribute shall be present if the nsState attribute value is INSTANTIATED.   # noqa: E501

        :return: The ns_scale_status of this NsInstance.  # noqa: E501
        :rtype: list[NsScaleInfo]
        """
        return self._ns_scale_status

    @ns_scale_status.setter
    def ns_scale_status(self, ns_scale_status):
        """Sets the ns_scale_status of this NsInstance.

        Status of each NS scaling aspect declared in the applicable DF, how \"big\" the NS instance has been scaled w.r.t. that aspect. This attribute shall be present if the nsState attribute value is INSTANTIATED.   # noqa: E501

        :param ns_scale_status: The ns_scale_status of this NsInstance.  # noqa: E501
        :type: list[NsScaleInfo]
        """

        self._ns_scale_status = ns_scale_status

    @property
    def additional_affinity_or_anti_affinity_rule(self):
        """Gets the additional_affinity_or_anti_affinity_rule of this NsInstance.  # noqa: E501

        Information on the additional affinity or anti-affinity rule from NS instantiation operation. Shall not conflict with rules already specified in the NSD.   # noqa: E501

        :return: The additional_affinity_or_anti_affinity_rule of this NsInstance.  # noqa: E501
        :rtype: list[AffinityOrAntiAffinityRule]
        """
        return self._additional_affinity_or_anti_affinity_rule

    @additional_affinity_or_anti_affinity_rule.setter
    def additional_affinity_or_anti_affinity_rule(self, additional_affinity_or_anti_affinity_rule):
        """Sets the additional_affinity_or_anti_affinity_rule of this NsInstance.

        Information on the additional affinity or anti-affinity rule from NS instantiation operation. Shall not conflict with rules already specified in the NSD.   # noqa: E501

        :param additional_affinity_or_anti_affinity_rule: The additional_affinity_or_anti_affinity_rule of this NsInstance.  # noqa: E501
        :type: list[AffinityOrAntiAffinityRule]
        """

        self._additional_affinity_or_anti_affinity_rule = additional_affinity_or_anti_affinity_rule

    @property
    def links(self):
        """Gets the links of this NsInstance.  # noqa: E501


        :return: The links of this NsInstance.  # noqa: E501
        :rtype: NsInstanceLinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this NsInstance.


        :param links: The links of this NsInstance.  # noqa: E501
        :type: NsInstanceLinks
        """
        if links is None:
            print("WARNING: Invalid value for the required field `links`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `links`, must not be `None`")  # noqa: E501

        self._links = links

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NsInstance, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NsInstance):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
