# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class NsLinkPortInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'Identifier',
        'resource_handle': 'ResourceHandle',
        'ns_cp_handle': 'list[NsCpHandle]'
    }

    attribute_map = {
        'id': 'id',
        'resource_handle': 'resourceHandle',
        'ns_cp_handle': 'nsCpHandle'
    }

    def __init__(self, id=None, resource_handle=None, ns_cp_handle=None):  # noqa: E501
        """NsLinkPortInfo - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._resource_handle = None
        self._ns_cp_handle = None
        self.discriminator = None
        self.id = id
        self.resource_handle = resource_handle
        if ns_cp_handle is not None:
            self.ns_cp_handle = ns_cp_handle

    @property
    def id(self):
        """Gets the id of this NsLinkPortInfo.  # noqa: E501


        :return: The id of this NsLinkPortInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this NsLinkPortInfo.


        :param id: The id of this NsLinkPortInfo.  # noqa: E501
        :type: Identifier
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def resource_handle(self):
        """Gets the resource_handle of this NsLinkPortInfo.  # noqa: E501


        :return: The resource_handle of this NsLinkPortInfo.  # noqa: E501
        :rtype: ResourceHandle
        """
        return self._resource_handle

    @resource_handle.setter
    def resource_handle(self, resource_handle):
        """Sets the resource_handle of this NsLinkPortInfo.


        :param resource_handle: The resource_handle of this NsLinkPortInfo.  # noqa: E501
        :type: ResourceHandle
        """
        if resource_handle is None:
            print("WARNING: Invalid value for the required field `resource_handle`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `resource_handle`, must not be `None`")  # noqa: E501

        self._resource_handle = resource_handle

    @property
    def ns_cp_handle(self):
        """Gets the ns_cp_handle of this NsLinkPortInfo.  # noqa: E501

        Identifier of the CP/SAP instance to be connected to this link port. The value refers to a vnfExtCpInfo item in the VnfInstance, or a pnfExtCpInfo item in the PnfInfo, or a sapInfo item in the NS instance. There shall be at most one link port associated with any connection point instance.   # noqa: E501

        :return: The ns_cp_handle of this NsLinkPortInfo.  # noqa: E501
        :rtype: list[NsCpHandle]
        """
        return self._ns_cp_handle

    @ns_cp_handle.setter
    def ns_cp_handle(self, ns_cp_handle):
        """Sets the ns_cp_handle of this NsLinkPortInfo.

        Identifier of the CP/SAP instance to be connected to this link port. The value refers to a vnfExtCpInfo item in the VnfInstance, or a pnfExtCpInfo item in the PnfInfo, or a sapInfo item in the NS instance. There shall be at most one link port associated with any connection point instance.   # noqa: E501

        :param ns_cp_handle: The ns_cp_handle of this NsLinkPortInfo.  # noqa: E501
        :type: list[NsCpHandle]
        """

        self._ns_cp_handle = ns_cp_handle

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NsLinkPortInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NsLinkPortInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
