# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class NsMonitoringParameter(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'IdentifierInNsd',
        'name': 'str',
        'performance_metric': 'str'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'performance_metric': 'performanceMetric'
    }

    def __init__(self, id=None, name=None, performance_metric=None):  # noqa: E501
        """NsMonitoringParameter - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._performance_metric = None
        self.discriminator = None
        self.id = id
        if name is not None:
            self.name = name
        self.performance_metric = performance_metric

    @property
    def id(self):
        """Gets the id of this NsMonitoringParameter.  # noqa: E501


        :return: The id of this NsMonitoringParameter.  # noqa: E501
        :rtype: IdentifierInNsd
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this NsMonitoringParameter.


        :param id: The id of this NsMonitoringParameter.  # noqa: E501
        :type: IdentifierInNsd
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this NsMonitoringParameter.  # noqa: E501

        Human readable name of the monitoring parameter, as defined in the NSD.   # noqa: E501

        :return: The name of this NsMonitoringParameter.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this NsMonitoringParameter.

        Human readable name of the monitoring parameter, as defined in the NSD.   # noqa: E501

        :param name: The name of this NsMonitoringParameter.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def performance_metric(self):
        """Gets the performance_metric of this NsMonitoringParameter.  # noqa: E501

        Performance metric that is monitored. This attribute shall contain the related  \"Measurement Name\" value as defined in clause 7.2 of ETSI GS NFV-IFA 027.   # noqa: E501

        :return: The performance_metric of this NsMonitoringParameter.  # noqa: E501
        :rtype: str
        """
        return self._performance_metric

    @performance_metric.setter
    def performance_metric(self, performance_metric):
        """Sets the performance_metric of this NsMonitoringParameter.

        Performance metric that is monitored. This attribute shall contain the related  \"Measurement Name\" value as defined in clause 7.2 of ETSI GS NFV-IFA 027.   # noqa: E501

        :param performance_metric: The performance_metric of this NsMonitoringParameter.  # noqa: E501
        :type: str
        """
        if performance_metric is None:
            print("WARNING: Invalid value for the required field `performance_metric`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `performance_metric`, must not be `None`")  # noqa: E501

        self._performance_metric = performance_metric

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NsMonitoringParameter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NsMonitoringParameter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
