# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class NsVirtualLinkInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'IdentifierInNs',
        'ns_virtual_link_desc_id': 'IdentifierInNsd',
        'ns_virtual_link_profile_id': 'IdentifierInNsd',
        'resource_handle': 'list[ResourceHandle]',
        'link_port': 'list[NsLinkPortInfo]'
    }

    attribute_map = {
        'id': 'id',
        'ns_virtual_link_desc_id': 'nsVirtualLinkDescId',
        'ns_virtual_link_profile_id': 'nsVirtualLinkProfileId',
        'resource_handle': 'resourceHandle',
        'link_port': 'linkPort'
    }

    def __init__(self, id=None, ns_virtual_link_desc_id=None, ns_virtual_link_profile_id=None, resource_handle=None, link_port=None):  # noqa: E501
        """NsVirtualLinkInfo - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._ns_virtual_link_desc_id = None
        self._ns_virtual_link_profile_id = None
        self._resource_handle = None
        self._link_port = None
        self.discriminator = None
        self.id = id
        self.ns_virtual_link_desc_id = ns_virtual_link_desc_id
        self.ns_virtual_link_profile_id = ns_virtual_link_profile_id
        if resource_handle is not None:
            self.resource_handle = resource_handle
        if link_port is not None:
            self.link_port = link_port

    @property
    def id(self):
        """Gets the id of this NsVirtualLinkInfo.  # noqa: E501


        :return: The id of this NsVirtualLinkInfo.  # noqa: E501
        :rtype: IdentifierInNs
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this NsVirtualLinkInfo.


        :param id: The id of this NsVirtualLinkInfo.  # noqa: E501
        :type: IdentifierInNs
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def ns_virtual_link_desc_id(self):
        """Gets the ns_virtual_link_desc_id of this NsVirtualLinkInfo.  # noqa: E501


        :return: The ns_virtual_link_desc_id of this NsVirtualLinkInfo.  # noqa: E501
        :rtype: IdentifierInNsd
        """
        return self._ns_virtual_link_desc_id

    @ns_virtual_link_desc_id.setter
    def ns_virtual_link_desc_id(self, ns_virtual_link_desc_id):
        """Sets the ns_virtual_link_desc_id of this NsVirtualLinkInfo.


        :param ns_virtual_link_desc_id: The ns_virtual_link_desc_id of this NsVirtualLinkInfo.  # noqa: E501
        :type: IdentifierInNsd
        """
        if ns_virtual_link_desc_id is None:
            print("WARNING: Invalid value for the required field `ns_virtual_link_desc_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `ns_virtual_link_desc_id`, must not be `None`")  # noqa: E501

        self._ns_virtual_link_desc_id = ns_virtual_link_desc_id

    @property
    def ns_virtual_link_profile_id(self):
        """Gets the ns_virtual_link_profile_id of this NsVirtualLinkInfo.  # noqa: E501


        :return: The ns_virtual_link_profile_id of this NsVirtualLinkInfo.  # noqa: E501
        :rtype: IdentifierInNsd
        """
        return self._ns_virtual_link_profile_id

    @ns_virtual_link_profile_id.setter
    def ns_virtual_link_profile_id(self, ns_virtual_link_profile_id):
        """Sets the ns_virtual_link_profile_id of this NsVirtualLinkInfo.


        :param ns_virtual_link_profile_id: The ns_virtual_link_profile_id of this NsVirtualLinkInfo.  # noqa: E501
        :type: IdentifierInNsd
        """
        if ns_virtual_link_profile_id is None:
            print("WARNING: Invalid value for the required field `ns_virtual_link_profile_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `ns_virtual_link_profile_id`, must not be `None`")  # noqa: E501

        self._ns_virtual_link_profile_id = ns_virtual_link_profile_id

    @property
    def resource_handle(self):
        """Gets the resource_handle of this NsVirtualLinkInfo.  # noqa: E501

        Identifier(s) of the virtualised network resource(s) realizing the VL instance. See note.   # noqa: E501

        :return: The resource_handle of this NsVirtualLinkInfo.  # noqa: E501
        :rtype: list[ResourceHandle]
        """
        return self._resource_handle

    @resource_handle.setter
    def resource_handle(self, resource_handle):
        """Sets the resource_handle of this NsVirtualLinkInfo.

        Identifier(s) of the virtualised network resource(s) realizing the VL instance. See note.   # noqa: E501

        :param resource_handle: The resource_handle of this NsVirtualLinkInfo.  # noqa: E501
        :type: list[ResourceHandle]
        """

        self._resource_handle = resource_handle

    @property
    def link_port(self):
        """Gets the link_port of this NsVirtualLinkInfo.  # noqa: E501

        Link ports of the VL instance. Cardinality of zero indicates that no port has yet been created for the VL instance.   # noqa: E501

        :return: The link_port of this NsVirtualLinkInfo.  # noqa: E501
        :rtype: list[NsLinkPortInfo]
        """
        return self._link_port

    @link_port.setter
    def link_port(self, link_port):
        """Sets the link_port of this NsVirtualLinkInfo.

        Link ports of the VL instance. Cardinality of zero indicates that no port has yet been created for the VL instance.   # noqa: E501

        :param link_port: The link_port of this NsVirtualLinkInfo.  # noqa: E501
        :type: list[NsLinkPortInfo]
        """

        self._link_port = link_port

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NsVirtualLinkInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NsVirtualLinkInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
