# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class OperateVnfData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnf_instance_id': 'Identifier',
        'change_state_to': 'OperationalStates',
        'stop_type': 'StopType',
        'graceful_stop_timeout': 'int',
        'additional_param': 'KeyValuePairs'
    }

    attribute_map = {
        'vnf_instance_id': 'vnfInstanceId',
        'change_state_to': 'changeStateTo',
        'stop_type': 'stopType',
        'graceful_stop_timeout': 'gracefulStopTimeout',
        'additional_param': 'additionalParam'
    }

    def __init__(self, vnf_instance_id=None, change_state_to=None, stop_type=None, graceful_stop_timeout=None, additional_param=None):  # noqa: E501
        """OperateVnfData - a model defined in Swagger"""  # noqa: E501
        self._vnf_instance_id = None
        self._change_state_to = None
        self._stop_type = None
        self._graceful_stop_timeout = None
        self._additional_param = None
        self.discriminator = None
        self.vnf_instance_id = vnf_instance_id
        self.change_state_to = change_state_to
        if stop_type is not None:
            self.stop_type = stop_type
        if graceful_stop_timeout is not None:
            self.graceful_stop_timeout = graceful_stop_timeout
        if additional_param is not None:
            self.additional_param = additional_param

    @property
    def vnf_instance_id(self):
        """Gets the vnf_instance_id of this OperateVnfData.  # noqa: E501


        :return: The vnf_instance_id of this OperateVnfData.  # noqa: E501
        :rtype: Identifier
        """
        return self._vnf_instance_id

    @vnf_instance_id.setter
    def vnf_instance_id(self, vnf_instance_id):
        """Sets the vnf_instance_id of this OperateVnfData.


        :param vnf_instance_id: The vnf_instance_id of this OperateVnfData.  # noqa: E501
        :type: Identifier
        """
        if vnf_instance_id is None:
            print("WARNING: Invalid value for the required field `vnf_instance_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_instance_id`, must not be `None`")  # noqa: E501

        self._vnf_instance_id = vnf_instance_id

    @property
    def change_state_to(self):
        """Gets the change_state_to of this OperateVnfData.  # noqa: E501


        :return: The change_state_to of this OperateVnfData.  # noqa: E501
        :rtype: OperationalStates
        """
        return self._change_state_to

    @change_state_to.setter
    def change_state_to(self, change_state_to):
        """Sets the change_state_to of this OperateVnfData.


        :param change_state_to: The change_state_to of this OperateVnfData.  # noqa: E501
        :type: OperationalStates
        """
        if change_state_to is None:
            print("WARNING: Invalid value for the required field `change_state_to`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `change_state_to`, must not be `None`")  # noqa: E501

        self._change_state_to = change_state_to

    @property
    def stop_type(self):
        """Gets the stop_type of this OperateVnfData.  # noqa: E501


        :return: The stop_type of this OperateVnfData.  # noqa: E501
        :rtype: StopType
        """
        return self._stop_type

    @stop_type.setter
    def stop_type(self, stop_type):
        """Sets the stop_type of this OperateVnfData.


        :param stop_type: The stop_type of this OperateVnfData.  # noqa: E501
        :type: StopType
        """

        self._stop_type = stop_type

    @property
    def graceful_stop_timeout(self):
        """Gets the graceful_stop_timeout of this OperateVnfData.  # noqa: E501

        The time interval (in seconds) to wait for the VNF to be taken out of service during graceful stop, before stopping the VNF.   # noqa: E501

        :return: The graceful_stop_timeout of this OperateVnfData.  # noqa: E501
        :rtype: int
        """
        return self._graceful_stop_timeout

    @graceful_stop_timeout.setter
    def graceful_stop_timeout(self, graceful_stop_timeout):
        """Sets the graceful_stop_timeout of this OperateVnfData.

        The time interval (in seconds) to wait for the VNF to be taken out of service during graceful stop, before stopping the VNF.   # noqa: E501

        :param graceful_stop_timeout: The graceful_stop_timeout of this OperateVnfData.  # noqa: E501
        :type: int
        """

        self._graceful_stop_timeout = graceful_stop_timeout

    @property
    def additional_param(self):
        """Gets the additional_param of this OperateVnfData.  # noqa: E501


        :return: The additional_param of this OperateVnfData.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._additional_param

    @additional_param.setter
    def additional_param(self, additional_param):
        """Sets the additional_param of this OperateVnfData.


        :param additional_param: The additional_param of this OperateVnfData.  # noqa: E501
        :type: KeyValuePairs
        """

        self._additional_param = additional_param

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OperateVnfData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OperateVnfData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
