# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ParamsForNestedNs(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'ns_profile_id': 'IdentifierInNsd',
        'additional_param': 'list[KeyValuePairs]'
    }

    attribute_map = {
        'ns_profile_id': 'nsProfileId',
        'additional_param': 'additionalParam'
    }

    def __init__(self, ns_profile_id=None, additional_param=None):  # noqa: E501
        """ParamsForNestedNs - a model defined in Swagger"""  # noqa: E501
        self._ns_profile_id = None
        self._additional_param = None
        self.discriminator = None
        self.ns_profile_id = ns_profile_id
        if additional_param is not None:
            self.additional_param = additional_param

    @property
    def ns_profile_id(self):
        """Gets the ns_profile_id of this ParamsForNestedNs.  # noqa: E501


        :return: The ns_profile_id of this ParamsForNestedNs.  # noqa: E501
        :rtype: IdentifierInNsd
        """
        return self._ns_profile_id

    @ns_profile_id.setter
    def ns_profile_id(self, ns_profile_id):
        """Sets the ns_profile_id of this ParamsForNestedNs.


        :param ns_profile_id: The ns_profile_id of this ParamsForNestedNs.  # noqa: E501
        :type: IdentifierInNsd
        """
        if ns_profile_id is None:
            print("WARNING: Invalid value for the required field `ns_profile_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `ns_profile_id`, must not be `None`")  # noqa: E501

        self._ns_profile_id = ns_profile_id

    @property
    def additional_param(self):
        """Gets the additional_param of this ParamsForNestedNs.  # noqa: E501

        Additional parameters that are to be applied on a per nested NS instance.   # noqa: E501

        :return: The additional_param of this ParamsForNestedNs.  # noqa: E501
        :rtype: list[KeyValuePairs]
        """
        return self._additional_param

    @additional_param.setter
    def additional_param(self, additional_param):
        """Sets the additional_param of this ParamsForNestedNs.

        Additional parameters that are to be applied on a per nested NS instance.   # noqa: E501

        :param additional_param: The additional_param of this ParamsForNestedNs.  # noqa: E501
        :type: list[KeyValuePairs]
        """

        self._additional_param = additional_param

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ParamsForNestedNs, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ParamsForNestedNs):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
