# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ParamsForVnf(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnf_profile_id': 'IdentifierInNsd',
        'vnf_instance_name': 'str',
        'vnf_instance_description': 'str',
        'vnf_configurable_properties': 'KeyValuePairs',
        'metadata': 'object',
        'extensions': 'KeyValuePairs',
        'additional_params': 'AllOfParamsForVnfAdditionalParams'
    }

    attribute_map = {
        'vnf_profile_id': 'vnfProfileId',
        'vnf_instance_name': 'vnfInstanceName',
        'vnf_instance_description': 'vnfInstanceDescription',
        'vnf_configurable_properties': 'vnfConfigurableProperties',
        'metadata': 'metadata',
        'extensions': 'extensions',
        'additional_params': 'additionalParams'
    }

    def __init__(self, vnf_profile_id=None, vnf_instance_name=None, vnf_instance_description=None, vnf_configurable_properties=None, metadata=None, extensions=None, additional_params=None):  # noqa: E501
        """ParamsForVnf - a model defined in Swagger"""  # noqa: E501
        self._vnf_profile_id = None
        self._vnf_instance_name = None
        self._vnf_instance_description = None
        self._vnf_configurable_properties = None
        self._metadata = None
        self._extensions = None
        self._additional_params = None
        self.discriminator = None
        self.vnf_profile_id = vnf_profile_id
        if vnf_instance_name is not None:
            self.vnf_instance_name = vnf_instance_name
        if vnf_instance_description is not None:
            self.vnf_instance_description = vnf_instance_description
        if vnf_configurable_properties is not None:
            self.vnf_configurable_properties = vnf_configurable_properties
        if metadata is not None:
            self.metadata = metadata
        if extensions is not None:
            self.extensions = extensions
        if additional_params is not None:
            self.additional_params = additional_params

    @property
    def vnf_profile_id(self):
        """Gets the vnf_profile_id of this ParamsForVnf.  # noqa: E501


        :return: The vnf_profile_id of this ParamsForVnf.  # noqa: E501
        :rtype: IdentifierInNsd
        """
        return self._vnf_profile_id

    @vnf_profile_id.setter
    def vnf_profile_id(self, vnf_profile_id):
        """Sets the vnf_profile_id of this ParamsForVnf.


        :param vnf_profile_id: The vnf_profile_id of this ParamsForVnf.  # noqa: E501
        :type: IdentifierInNsd
        """
        if vnf_profile_id is None:
            print("WARNING: Invalid value for the required field `vnf_profile_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_profile_id`, must not be `None`")  # noqa: E501

        self._vnf_profile_id = vnf_profile_id

    @property
    def vnf_instance_name(self):
        """Gets the vnf_instance_name of this ParamsForVnf.  # noqa: E501

        Human-readable name of the VNF instance to be created.   # noqa: E501

        :return: The vnf_instance_name of this ParamsForVnf.  # noqa: E501
        :rtype: str
        """
        return self._vnf_instance_name

    @vnf_instance_name.setter
    def vnf_instance_name(self, vnf_instance_name):
        """Sets the vnf_instance_name of this ParamsForVnf.

        Human-readable name of the VNF instance to be created.   # noqa: E501

        :param vnf_instance_name: The vnf_instance_name of this ParamsForVnf.  # noqa: E501
        :type: str
        """

        self._vnf_instance_name = vnf_instance_name

    @property
    def vnf_instance_description(self):
        """Gets the vnf_instance_description of this ParamsForVnf.  # noqa: E501

        Human-readable description of the VNF instance to be created.   # noqa: E501

        :return: The vnf_instance_description of this ParamsForVnf.  # noqa: E501
        :rtype: str
        """
        return self._vnf_instance_description

    @vnf_instance_description.setter
    def vnf_instance_description(self, vnf_instance_description):
        """Sets the vnf_instance_description of this ParamsForVnf.

        Human-readable description of the VNF instance to be created.   # noqa: E501

        :param vnf_instance_description: The vnf_instance_description of this ParamsForVnf.  # noqa: E501
        :type: str
        """

        self._vnf_instance_description = vnf_instance_description

    @property
    def vnf_configurable_properties(self):
        """Gets the vnf_configurable_properties of this ParamsForVnf.  # noqa: E501


        :return: The vnf_configurable_properties of this ParamsForVnf.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._vnf_configurable_properties

    @vnf_configurable_properties.setter
    def vnf_configurable_properties(self, vnf_configurable_properties):
        """Sets the vnf_configurable_properties of this ParamsForVnf.


        :param vnf_configurable_properties: The vnf_configurable_properties of this ParamsForVnf.  # noqa: E501
        :type: KeyValuePairs
        """

        self._vnf_configurable_properties = vnf_configurable_properties

    @property
    def metadata(self):
        """Gets the metadata of this ParamsForVnf.  # noqa: E501

        Values for the \"metadata\" input parameter of the Create VNF Identifier operation defined in ETSI GS NFV-SOL 003 [4].   # noqa: E501

        :return: The metadata of this ParamsForVnf.  # noqa: E501
        :rtype: object
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this ParamsForVnf.

        Values for the \"metadata\" input parameter of the Create VNF Identifier operation defined in ETSI GS NFV-SOL 003 [4].   # noqa: E501

        :param metadata: The metadata of this ParamsForVnf.  # noqa: E501
        :type: object
        """

        self._metadata = metadata

    @property
    def extensions(self):
        """Gets the extensions of this ParamsForVnf.  # noqa: E501


        :return: The extensions of this ParamsForVnf.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._extensions

    @extensions.setter
    def extensions(self, extensions):
        """Sets the extensions of this ParamsForVnf.


        :param extensions: The extensions of this ParamsForVnf.  # noqa: E501
        :type: KeyValuePairs
        """

        self._extensions = extensions

    @property
    def additional_params(self):
        """Gets the additional_params of this ParamsForVnf.  # noqa: E501

        Additional input parameters for the instantiation process, specific to the VNF being instantiated, as declared in the VNFD as part of \"InstantiateVnfOpConfig\".   # noqa: E501

        :return: The additional_params of this ParamsForVnf.  # noqa: E501
        :rtype: AllOfParamsForVnfAdditionalParams
        """
        return self._additional_params

    @additional_params.setter
    def additional_params(self, additional_params):
        """Sets the additional_params of this ParamsForVnf.

        Additional input parameters for the instantiation process, specific to the VNF being instantiated, as declared in the VNFD as part of \"InstantiateVnfOpConfig\".   # noqa: E501

        :param additional_params: The additional_params of this ParamsForVnf.  # noqa: E501
        :type: AllOfParamsForVnfAdditionalParams
        """

        self._additional_params = additional_params

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ParamsForVnf, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ParamsForVnf):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
