# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class PnfExtCpData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cp_instance_id': 'IdentifierInPnf',
        'cpd_id': 'IdentifierInNsd',
        'cp_protocol_data': 'list[CpProtocolData]'
    }

    attribute_map = {
        'cp_instance_id': 'cpInstanceId',
        'cpd_id': 'cpdId',
        'cp_protocol_data': 'cpProtocolData'
    }

    def __init__(self, cp_instance_id=None, cpd_id=None, cp_protocol_data=None):  # noqa: E501
        """PnfExtCpData - a model defined in Swagger"""  # noqa: E501
        self._cp_instance_id = None
        self._cpd_id = None
        self._cp_protocol_data = None
        self.discriminator = None
        if cp_instance_id is not None:
            self.cp_instance_id = cp_instance_id
        if cpd_id is not None:
            self.cpd_id = cpd_id
        self.cp_protocol_data = cp_protocol_data

    @property
    def cp_instance_id(self):
        """Gets the cp_instance_id of this PnfExtCpData.  # noqa: E501


        :return: The cp_instance_id of this PnfExtCpData.  # noqa: E501
        :rtype: IdentifierInPnf
        """
        return self._cp_instance_id

    @cp_instance_id.setter
    def cp_instance_id(self, cp_instance_id):
        """Sets the cp_instance_id of this PnfExtCpData.


        :param cp_instance_id: The cp_instance_id of this PnfExtCpData.  # noqa: E501
        :type: IdentifierInPnf
        """

        self._cp_instance_id = cp_instance_id

    @property
    def cpd_id(self):
        """Gets the cpd_id of this PnfExtCpData.  # noqa: E501


        :return: The cpd_id of this PnfExtCpData.  # noqa: E501
        :rtype: IdentifierInNsd
        """
        return self._cpd_id

    @cpd_id.setter
    def cpd_id(self, cpd_id):
        """Sets the cpd_id of this PnfExtCpData.


        :param cpd_id: The cpd_id of this PnfExtCpData.  # noqa: E501
        :type: IdentifierInNsd
        """

        self._cpd_id = cpd_id

    @property
    def cp_protocol_data(self):
        """Gets the cp_protocol_data of this PnfExtCpData.  # noqa: E501

        Address assigned for this CP.   # noqa: E501

        :return: The cp_protocol_data of this PnfExtCpData.  # noqa: E501
        :rtype: list[CpProtocolData]
        """
        return self._cp_protocol_data

    @cp_protocol_data.setter
    def cp_protocol_data(self, cp_protocol_data):
        """Sets the cp_protocol_data of this PnfExtCpData.

        Address assigned for this CP.   # noqa: E501

        :param cp_protocol_data: The cp_protocol_data of this PnfExtCpData.  # noqa: E501
        :type: list[CpProtocolData]
        """
        if cp_protocol_data is None:
            print("WARNING: Invalid value for the required field `cp_protocol_data`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `cp_protocol_data`, must not be `None`")  # noqa: E501

        self._cp_protocol_data = cp_protocol_data

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PnfExtCpData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PnfExtCpData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
