# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ResourceHandle(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vim_id': 'Identifier',
        'resource_provider_id': 'Identifier',
        'resource_id': 'IdentifierInVim',
        'vim_level_resource_type': 'str'
    }

    attribute_map = {
        'vim_id': 'vimId',
        'resource_provider_id': 'resourceProviderId',
        'resource_id': 'resourceId',
        'vim_level_resource_type': 'vimLevelResourceType'
    }

    def __init__(self, vim_id=None, resource_provider_id=None, resource_id=None, vim_level_resource_type=None):  # noqa: E501
        """ResourceHandle - a model defined in Swagger"""  # noqa: E501
        self._vim_id = None
        self._resource_provider_id = None
        self._resource_id = None
        self._vim_level_resource_type = None
        self.discriminator = None
        if vim_id is not None:
            self.vim_id = vim_id
        if resource_provider_id is not None:
            self.resource_provider_id = resource_provider_id
        self.resource_id = resource_id
        if vim_level_resource_type is not None:
            self.vim_level_resource_type = vim_level_resource_type

    @property
    def vim_id(self):
        """Gets the vim_id of this ResourceHandle.  # noqa: E501


        :return: The vim_id of this ResourceHandle.  # noqa: E501
        :rtype: Identifier
        """
        return self._vim_id

    @vim_id.setter
    def vim_id(self, vim_id):
        """Sets the vim_id of this ResourceHandle.


        :param vim_id: The vim_id of this ResourceHandle.  # noqa: E501
        :type: Identifier
        """

        self._vim_id = vim_id

    @property
    def resource_provider_id(self):
        """Gets the resource_provider_id of this ResourceHandle.  # noqa: E501


        :return: The resource_provider_id of this ResourceHandle.  # noqa: E501
        :rtype: Identifier
        """
        return self._resource_provider_id

    @resource_provider_id.setter
    def resource_provider_id(self, resource_provider_id):
        """Sets the resource_provider_id of this ResourceHandle.


        :param resource_provider_id: The resource_provider_id of this ResourceHandle.  # noqa: E501
        :type: Identifier
        """

        self._resource_provider_id = resource_provider_id

    @property
    def resource_id(self):
        """Gets the resource_id of this ResourceHandle.  # noqa: E501


        :return: The resource_id of this ResourceHandle.  # noqa: E501
        :rtype: IdentifierInVim
        """
        return self._resource_id

    @resource_id.setter
    def resource_id(self, resource_id):
        """Sets the resource_id of this ResourceHandle.


        :param resource_id: The resource_id of this ResourceHandle.  # noqa: E501
        :type: IdentifierInVim
        """
        if resource_id is None:
            print("WARNING: Invalid value for the required field `resource_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `resource_id`, must not be `None`")  # noqa: E501

        self._resource_id = resource_id

    @property
    def vim_level_resource_type(self):
        """Gets the vim_level_resource_type of this ResourceHandle.  # noqa: E501

        Type of the resource in the scope of the VIM or the resource provider. The value set of the \"vimLevelResourceType\" attribute is within the scope of the VIM or the resource provider and can be used as information that complements the ResourceHandle.   # noqa: E501

        :return: The vim_level_resource_type of this ResourceHandle.  # noqa: E501
        :rtype: str
        """
        return self._vim_level_resource_type

    @vim_level_resource_type.setter
    def vim_level_resource_type(self, vim_level_resource_type):
        """Sets the vim_level_resource_type of this ResourceHandle.

        Type of the resource in the scope of the VIM or the resource provider. The value set of the \"vimLevelResourceType\" attribute is within the scope of the VIM or the resource provider and can be used as information that complements the ResourceHandle.   # noqa: E501

        :param vim_level_resource_type: The vim_level_resource_type of this ResourceHandle.  # noqa: E501
        :type: str
        """

        self._vim_level_resource_type = vim_level_resource_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ResourceHandle, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ResourceHandle):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
