# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class SapData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'sapd_id': 'IdentifierInNsd',
        'sap_name': 'str',
        'description': 'str',
        'sap_protocol_data': 'list[CpProtocolData]'
    }

    attribute_map = {
        'sapd_id': 'sapdId',
        'sap_name': 'sapName',
        'description': 'description',
        'sap_protocol_data': 'sapProtocolData'
    }

    def __init__(self, sapd_id=None, sap_name=None, description=None, sap_protocol_data=None):  # noqa: E501
        """SapData - a model defined in Swagger"""  # noqa: E501
        self._sapd_id = None
        self._sap_name = None
        self._description = None
        self._sap_protocol_data = None
        self.discriminator = None
        self.sapd_id = sapd_id
        self.sap_name = sap_name
        self.description = description
        if sap_protocol_data is not None:
            self.sap_protocol_data = sap_protocol_data

    @property
    def sapd_id(self):
        """Gets the sapd_id of this SapData.  # noqa: E501


        :return: The sapd_id of this SapData.  # noqa: E501
        :rtype: IdentifierInNsd
        """
        return self._sapd_id

    @sapd_id.setter
    def sapd_id(self, sapd_id):
        """Sets the sapd_id of this SapData.


        :param sapd_id: The sapd_id of this SapData.  # noqa: E501
        :type: IdentifierInNsd
        """
        if sapd_id is None:
            print("WARNING: Invalid value for the required field `sapd_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `sapd_id`, must not be `None`")  # noqa: E501

        self._sapd_id = sapd_id

    @property
    def sap_name(self):
        """Gets the sap_name of this SapData.  # noqa: E501

        Human readable name for the SAP.   # noqa: E501

        :return: The sap_name of this SapData.  # noqa: E501
        :rtype: str
        """
        return self._sap_name

    @sap_name.setter
    def sap_name(self, sap_name):
        """Sets the sap_name of this SapData.

        Human readable name for the SAP.   # noqa: E501

        :param sap_name: The sap_name of this SapData.  # noqa: E501
        :type: str
        """
        if sap_name is None:
            print("WARNING: Invalid value for the required field `sap_name`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `sap_name`, must not be `None`")  # noqa: E501

        self._sap_name = sap_name

    @property
    def description(self):
        """Gets the description of this SapData.  # noqa: E501

        Human readable description for the SAP.   # noqa: E501

        :return: The description of this SapData.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this SapData.

        Human readable description for the SAP.   # noqa: E501

        :param description: The description of this SapData.  # noqa: E501
        :type: str
        """
        if description is None:
            print("WARNING: Invalid value for the required field `description`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    @property
    def sap_protocol_data(self):
        """Gets the sap_protocol_data of this SapData.  # noqa: E501

        Parameters for configuring the network protocols on the SAP.   # noqa: E501

        :return: The sap_protocol_data of this SapData.  # noqa: E501
        :rtype: list[CpProtocolData]
        """
        return self._sap_protocol_data

    @sap_protocol_data.setter
    def sap_protocol_data(self, sap_protocol_data):
        """Sets the sap_protocol_data of this SapData.

        Parameters for configuring the network protocols on the SAP.   # noqa: E501

        :param sap_protocol_data: The sap_protocol_data of this SapData.  # noqa: E501
        :type: list[CpProtocolData]
        """

        self._sap_protocol_data = sap_protocol_data

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SapData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SapData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
