# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ScaleByStepData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'aspect_id': 'IdentifierInVnfd',
        'number_of_steps': 'int',
        'additional_params': 'AllOfScaleByStepDataAdditionalParams'
    }

    attribute_map = {
        'aspect_id': 'aspectId',
        'number_of_steps': 'numberOfSteps',
        'additional_params': 'additionalParams'
    }

    def __init__(self, aspect_id=None, number_of_steps=None, additional_params=None):  # noqa: E501
        """ScaleByStepData - a model defined in Swagger"""  # noqa: E501
        self._aspect_id = None
        self._number_of_steps = None
        self._additional_params = None
        self.discriminator = None
        self.aspect_id = aspect_id
        if number_of_steps is not None:
            self.number_of_steps = number_of_steps
        if additional_params is not None:
            self.additional_params = additional_params

    @property
    def aspect_id(self):
        """Gets the aspect_id of this ScaleByStepData.  # noqa: E501


        :return: The aspect_id of this ScaleByStepData.  # noqa: E501
        :rtype: IdentifierInVnfd
        """
        return self._aspect_id

    @aspect_id.setter
    def aspect_id(self, aspect_id):
        """Sets the aspect_id of this ScaleByStepData.


        :param aspect_id: The aspect_id of this ScaleByStepData.  # noqa: E501
        :type: IdentifierInVnfd
        """
        if aspect_id is None:
            print("WARNING: Invalid value for the required field `aspect_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `aspect_id`, must not be `None`")  # noqa: E501

        self._aspect_id = aspect_id

    @property
    def number_of_steps(self):
        """Gets the number_of_steps of this ScaleByStepData.  # noqa: E501

        Number of scaling steps. It shall be a positive number. Defaults to 1. The VNF provider defines in the VNFD whether or not a particular VNF supports performing more than one step at a time. Such a property in the VNFD applies for all instances of a particular VNF.   # noqa: E501

        :return: The number_of_steps of this ScaleByStepData.  # noqa: E501
        :rtype: int
        """
        return self._number_of_steps

    @number_of_steps.setter
    def number_of_steps(self, number_of_steps):
        """Sets the number_of_steps of this ScaleByStepData.

        Number of scaling steps. It shall be a positive number. Defaults to 1. The VNF provider defines in the VNFD whether or not a particular VNF supports performing more than one step at a time. Such a property in the VNFD applies for all instances of a particular VNF.   # noqa: E501

        :param number_of_steps: The number_of_steps of this ScaleByStepData.  # noqa: E501
        :type: int
        """

        self._number_of_steps = number_of_steps

    @property
    def additional_params(self):
        """Gets the additional_params of this ScaleByStepData.  # noqa: E501

        Additional parameters passed by the NFVO as input to the scaling process, specific to the VNF instance being scaled.   # noqa: E501

        :return: The additional_params of this ScaleByStepData.  # noqa: E501
        :rtype: AllOfScaleByStepDataAdditionalParams
        """
        return self._additional_params

    @additional_params.setter
    def additional_params(self, additional_params):
        """Sets the additional_params of this ScaleByStepData.

        Additional parameters passed by the NFVO as input to the scaling process, specific to the VNF instance being scaled.   # noqa: E501

        :param additional_params: The additional_params of this ScaleByStepData.  # noqa: E501
        :type: AllOfScaleByStepDataAdditionalParams
        """

        self._additional_params = additional_params

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ScaleByStepData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScaleByStepData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
