# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ScaleNsByStepsData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'scaling_direction': 'str',
        'aspect_id': 'IdentifierInNsd',
        'number_of_steps': 'int'
    }

    attribute_map = {
        'scaling_direction': 'scalingDirection',
        'aspect_id': 'aspectId',
        'number_of_steps': 'numberOfSteps'
    }

    def __init__(self, scaling_direction=None, aspect_id=None, number_of_steps=None):  # noqa: E501
        """ScaleNsByStepsData - a model defined in Swagger"""  # noqa: E501
        self._scaling_direction = None
        self._aspect_id = None
        self._number_of_steps = None
        self.discriminator = None
        self.scaling_direction = scaling_direction
        self.aspect_id = aspect_id
        if number_of_steps is not None:
            self.number_of_steps = number_of_steps

    @property
    def scaling_direction(self):
        """Gets the scaling_direction of this ScaleNsByStepsData.  # noqa: E501

        The scaling direction. Possible values are: - SCALE_IN - SCALE_OUT.   # noqa: E501

        :return: The scaling_direction of this ScaleNsByStepsData.  # noqa: E501
        :rtype: str
        """
        return self._scaling_direction

    @scaling_direction.setter
    def scaling_direction(self, scaling_direction):
        """Sets the scaling_direction of this ScaleNsByStepsData.

        The scaling direction. Possible values are: - SCALE_IN - SCALE_OUT.   # noqa: E501

        :param scaling_direction: The scaling_direction of this ScaleNsByStepsData.  # noqa: E501
        :type: str
        """
        if scaling_direction is None:
            print("WARNING: Invalid value for the required field `scaling_direction`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `scaling_direction`, must not be `None`")  # noqa: E501
        allowed_values = ["SCALE_IN", "SCALE_OUT"]  # noqa: E501
        if scaling_direction is not None and scaling_direction not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `scaling_direction` ({0}), must be one of {1}"  # noqa: E501
                .format(scaling_direction, allowed_values)
            )

        self._scaling_direction = scaling_direction

    @property
    def aspect_id(self):
        """Gets the aspect_id of this ScaleNsByStepsData.  # noqa: E501


        :return: The aspect_id of this ScaleNsByStepsData.  # noqa: E501
        :rtype: IdentifierInNsd
        """
        return self._aspect_id

    @aspect_id.setter
    def aspect_id(self, aspect_id):
        """Sets the aspect_id of this ScaleNsByStepsData.


        :param aspect_id: The aspect_id of this ScaleNsByStepsData.  # noqa: E501
        :type: IdentifierInNsd
        """
        if aspect_id is None:
            print("WARNING: Invalid value for the required field `aspect_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `aspect_id`, must not be `None`")  # noqa: E501

        self._aspect_id = aspect_id

    @property
    def number_of_steps(self):
        """Gets the number_of_steps of this ScaleNsByStepsData.  # noqa: E501

        The number of scaling steps to be performed. Defaults to 1.   # noqa: E501

        :return: The number_of_steps of this ScaleNsByStepsData.  # noqa: E501
        :rtype: int
        """
        return self._number_of_steps

    @number_of_steps.setter
    def number_of_steps(self, number_of_steps):
        """Sets the number_of_steps of this ScaleNsByStepsData.

        The number of scaling steps to be performed. Defaults to 1.   # noqa: E501

        :param number_of_steps: The number_of_steps of this ScaleNsByStepsData.  # noqa: E501
        :type: int
        """

        self._number_of_steps = number_of_steps

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ScaleNsByStepsData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScaleNsByStepsData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
