# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ScaleNsData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnf_instance_to_be_added': 'list[VnfInstanceData]',
        'vnf_instance_to_be_removed': 'list[Identifier]',
        'scale_ns_by_steps_data': 'ScaleNsByStepsData',
        'scale_ns_to_level_data': 'ScaleNsToLevelData',
        'additional_params_for_ns': 'ParamsForVnfAdditionalParams',
        'additional_params_for_vnf': 'list[ParamsForVnf]',
        'location_constraints': 'list[VnfLocationConstraint]'
    }

    attribute_map = {
        'vnf_instance_to_be_added': 'vnfInstanceToBeAdded',
        'vnf_instance_to_be_removed': 'vnfInstanceToBeRemoved',
        'scale_ns_by_steps_data': 'scaleNsByStepsData',
        'scale_ns_to_level_data': 'scaleNsToLevelData',
        'additional_params_for_ns': 'additionalParamsForNs',
        'additional_params_for_vnf': 'additionalParamsForVnf',
        'location_constraints': 'locationConstraints'
    }

    def __init__(self, vnf_instance_to_be_added=None, vnf_instance_to_be_removed=None, scale_ns_by_steps_data=None, scale_ns_to_level_data=None, additional_params_for_ns=None, additional_params_for_vnf=None, location_constraints=None):  # noqa: E501
        """ScaleNsData - a model defined in Swagger"""  # noqa: E501
        self._vnf_instance_to_be_added = None
        self._vnf_instance_to_be_removed = None
        self._scale_ns_by_steps_data = None
        self._scale_ns_to_level_data = None
        self._additional_params_for_ns = None
        self._additional_params_for_vnf = None
        self._location_constraints = None
        self.discriminator = None
        if vnf_instance_to_be_added is not None:
            self.vnf_instance_to_be_added = vnf_instance_to_be_added
        if vnf_instance_to_be_removed is not None:
            self.vnf_instance_to_be_removed = vnf_instance_to_be_removed
        if scale_ns_by_steps_data is not None:
            self.scale_ns_by_steps_data = scale_ns_by_steps_data
        if scale_ns_to_level_data is not None:
            self.scale_ns_to_level_data = scale_ns_to_level_data
        if additional_params_for_ns is not None:
            self.additional_params_for_ns = additional_params_for_ns
        if additional_params_for_vnf is not None:
            self.additional_params_for_vnf = additional_params_for_vnf
        if location_constraints is not None:
            self.location_constraints = location_constraints

    @property
    def vnf_instance_to_be_added(self):
        """Gets the vnf_instance_to_be_added of this ScaleNsData.  # noqa: E501

        An existing VNF instance to be added to the NS instance as part of the scaling operation. If needed, the VNF Profile to be used for this VNF instance may also be provided.   # noqa: E501

        :return: The vnf_instance_to_be_added of this ScaleNsData.  # noqa: E501
        :rtype: list[VnfInstanceData]
        """
        return self._vnf_instance_to_be_added

    @vnf_instance_to_be_added.setter
    def vnf_instance_to_be_added(self, vnf_instance_to_be_added):
        """Sets the vnf_instance_to_be_added of this ScaleNsData.

        An existing VNF instance to be added to the NS instance as part of the scaling operation. If needed, the VNF Profile to be used for this VNF instance may also be provided.   # noqa: E501

        :param vnf_instance_to_be_added: The vnf_instance_to_be_added of this ScaleNsData.  # noqa: E501
        :type: list[VnfInstanceData]
        """

        self._vnf_instance_to_be_added = vnf_instance_to_be_added

    @property
    def vnf_instance_to_be_removed(self):
        """Gets the vnf_instance_to_be_removed of this ScaleNsData.  # noqa: E501

        The VNF instance to be removed from the NS instance as part of the scaling operation.   # noqa: E501

        :return: The vnf_instance_to_be_removed of this ScaleNsData.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._vnf_instance_to_be_removed

    @vnf_instance_to_be_removed.setter
    def vnf_instance_to_be_removed(self, vnf_instance_to_be_removed):
        """Sets the vnf_instance_to_be_removed of this ScaleNsData.

        The VNF instance to be removed from the NS instance as part of the scaling operation.   # noqa: E501

        :param vnf_instance_to_be_removed: The vnf_instance_to_be_removed of this ScaleNsData.  # noqa: E501
        :type: list[Identifier]
        """

        self._vnf_instance_to_be_removed = vnf_instance_to_be_removed

    @property
    def scale_ns_by_steps_data(self):
        """Gets the scale_ns_by_steps_data of this ScaleNsData.  # noqa: E501


        :return: The scale_ns_by_steps_data of this ScaleNsData.  # noqa: E501
        :rtype: ScaleNsByStepsData
        """
        return self._scale_ns_by_steps_data

    @scale_ns_by_steps_data.setter
    def scale_ns_by_steps_data(self, scale_ns_by_steps_data):
        """Sets the scale_ns_by_steps_data of this ScaleNsData.


        :param scale_ns_by_steps_data: The scale_ns_by_steps_data of this ScaleNsData.  # noqa: E501
        :type: ScaleNsByStepsData
        """

        self._scale_ns_by_steps_data = scale_ns_by_steps_data

    @property
    def scale_ns_to_level_data(self):
        """Gets the scale_ns_to_level_data of this ScaleNsData.  # noqa: E501


        :return: The scale_ns_to_level_data of this ScaleNsData.  # noqa: E501
        :rtype: ScaleNsToLevelData
        """
        return self._scale_ns_to_level_data

    @scale_ns_to_level_data.setter
    def scale_ns_to_level_data(self, scale_ns_to_level_data):
        """Sets the scale_ns_to_level_data of this ScaleNsData.


        :param scale_ns_to_level_data: The scale_ns_to_level_data of this ScaleNsData.  # noqa: E501
        :type: ScaleNsToLevelData
        """

        self._scale_ns_to_level_data = scale_ns_to_level_data

    @property
    def additional_params_for_ns(self):
        """Gets the additional_params_for_ns of this ScaleNsData.  # noqa: E501


        :return: The additional_params_for_ns of this ScaleNsData.  # noqa: E501
        :rtype: ParamsForVnfAdditionalParams
        """
        return self._additional_params_for_ns

    @additional_params_for_ns.setter
    def additional_params_for_ns(self, additional_params_for_ns):
        """Sets the additional_params_for_ns of this ScaleNsData.


        :param additional_params_for_ns: The additional_params_for_ns of this ScaleNsData.  # noqa: E501
        :type: ParamsForVnfAdditionalParams
        """

        self._additional_params_for_ns = additional_params_for_ns

    @property
    def additional_params_for_vnf(self):
        """Gets the additional_params_for_vnf of this ScaleNsData.  # noqa: E501

        Allows the OSS/BSS to provide additional parameter(s) per VNF instance (as opposed to the NS level, which is covered in additionalParamforNs). This is for VNFs that are to be created by the NFVO as part of the NS scaling and not for existing VNF that are covered by the scaleVnfData.   # noqa: E501

        :return: The additional_params_for_vnf of this ScaleNsData.  # noqa: E501
        :rtype: list[ParamsForVnf]
        """
        return self._additional_params_for_vnf

    @additional_params_for_vnf.setter
    def additional_params_for_vnf(self, additional_params_for_vnf):
        """Sets the additional_params_for_vnf of this ScaleNsData.

        Allows the OSS/BSS to provide additional parameter(s) per VNF instance (as opposed to the NS level, which is covered in additionalParamforNs). This is for VNFs that are to be created by the NFVO as part of the NS scaling and not for existing VNF that are covered by the scaleVnfData.   # noqa: E501

        :param additional_params_for_vnf: The additional_params_for_vnf of this ScaleNsData.  # noqa: E501
        :type: list[ParamsForVnf]
        """

        self._additional_params_for_vnf = additional_params_for_vnf

    @property
    def location_constraints(self):
        """Gets the location_constraints of this ScaleNsData.  # noqa: E501

        The location constraints for the VNF to be instantiated as part of the NS scaling. An example can be a constraint for the VNF to be in a specific geographic location.   # noqa: E501

        :return: The location_constraints of this ScaleNsData.  # noqa: E501
        :rtype: list[VnfLocationConstraint]
        """
        return self._location_constraints

    @location_constraints.setter
    def location_constraints(self, location_constraints):
        """Sets the location_constraints of this ScaleNsData.

        The location constraints for the VNF to be instantiated as part of the NS scaling. An example can be a constraint for the VNF to be in a specific geographic location.   # noqa: E501

        :param location_constraints: The location_constraints of this ScaleNsData.  # noqa: E501
        :type: list[VnfLocationConstraint]
        """

        self._location_constraints = location_constraints

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ScaleNsData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScaleNsData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
