# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ScaleNsRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'scale_type': 'str',
        'scale_ns_data': 'ScaleNsData',
        'scale_vnf_data': 'list[ScaleVnfData]',
        'scale_time': 'datetime'
    }

    attribute_map = {
        'scale_type': 'scaleType',
        'scale_ns_data': 'scaleNsData',
        'scale_vnf_data': 'scaleVnfData',
        'scale_time': 'scaleTime'
    }

    def __init__(self, scale_type=None, scale_ns_data=None, scale_vnf_data=None, scale_time=None):  # noqa: E501
        """ScaleNsRequest - a model defined in Swagger"""  # noqa: E501
        self._scale_type = None
        self._scale_ns_data = None
        self._scale_vnf_data = None
        self._scale_time = None
        self.discriminator = None
        self.scale_type = scale_type
        if scale_ns_data is not None:
            self.scale_ns_data = scale_ns_data
        if scale_vnf_data is not None:
            self.scale_vnf_data = scale_vnf_data
        if scale_time is not None:
            self.scale_time = scale_time

    @property
    def scale_type(self):
        """Gets the scale_type of this ScaleNsRequest.  # noqa: E501

        Indicates the type of scaling to be performed. Possible values: - SCALE_NS - SCALE_VNF   # noqa: E501

        :return: The scale_type of this ScaleNsRequest.  # noqa: E501
        :rtype: str
        """
        return self._scale_type

    @scale_type.setter
    def scale_type(self, scale_type):
        """Sets the scale_type of this ScaleNsRequest.

        Indicates the type of scaling to be performed. Possible values: - SCALE_NS - SCALE_VNF   # noqa: E501

        :param scale_type: The scale_type of this ScaleNsRequest.  # noqa: E501
        :type: str
        """
        if scale_type is None:
            print("WARNING: Invalid value for the required field `scale_type`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `scale_type`, must not be `None`")  # noqa: E501
        allowed_values = ["SCALE_NS", "SCALE_VNF"]  # noqa: E501
        if scale_type is not None and scale_type not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `scale_type` ({0}), must be one of {1}"  # noqa: E501
                .format(scale_type, allowed_values)
            )

        self._scale_type = scale_type

    @property
    def scale_ns_data(self):
        """Gets the scale_ns_data of this ScaleNsRequest.  # noqa: E501


        :return: The scale_ns_data of this ScaleNsRequest.  # noqa: E501
        :rtype: ScaleNsData
        """
        return self._scale_ns_data

    @scale_ns_data.setter
    def scale_ns_data(self, scale_ns_data):
        """Sets the scale_ns_data of this ScaleNsRequest.


        :param scale_ns_data: The scale_ns_data of this ScaleNsRequest.  # noqa: E501
        :type: ScaleNsData
        """

        self._scale_ns_data = scale_ns_data

    @property
    def scale_vnf_data(self):
        """Gets the scale_vnf_data of this ScaleNsRequest.  # noqa: E501

        The necessary information to scale the referenced NS instance. It shall be present when scaleType = SCALE_VNF.   # noqa: E501

        :return: The scale_vnf_data of this ScaleNsRequest.  # noqa: E501
        :rtype: list[ScaleVnfData]
        """
        return self._scale_vnf_data

    @scale_vnf_data.setter
    def scale_vnf_data(self, scale_vnf_data):
        """Sets the scale_vnf_data of this ScaleNsRequest.

        The necessary information to scale the referenced NS instance. It shall be present when scaleType = SCALE_VNF.   # noqa: E501

        :param scale_vnf_data: The scale_vnf_data of this ScaleNsRequest.  # noqa: E501
        :type: list[ScaleVnfData]
        """

        self._scale_vnf_data = scale_vnf_data

    @property
    def scale_time(self):
        """Gets the scale_time of this ScaleNsRequest.  # noqa: E501


        :return: The scale_time of this ScaleNsRequest.  # noqa: E501
        :rtype: datetime
        """
        return self._scale_time

    @scale_time.setter
    def scale_time(self, scale_time):
        """Sets the scale_time of this ScaleNsRequest.


        :param scale_time: The scale_time of this ScaleNsRequest.  # noqa: E501
        :type: datetime
        """

        self._scale_time = scale_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ScaleNsRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScaleNsRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
