# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ScaleVnfData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnf_instanceid': 'Identifier',
        'scale_vnf_type': 'str',
        'scale_to_level_data': 'ScaleToLevelData',
        'scale_by_step_data': 'ScaleByStepData'
    }

    attribute_map = {
        'vnf_instanceid': 'vnfInstanceid',
        'scale_vnf_type': 'scaleVnfType',
        'scale_to_level_data': 'scaleToLevelData',
        'scale_by_step_data': 'scaleByStepData'
    }

    def __init__(self, vnf_instanceid=None, scale_vnf_type=None, scale_to_level_data=None, scale_by_step_data=None):  # noqa: E501
        """ScaleVnfData - a model defined in Swagger"""  # noqa: E501
        self._vnf_instanceid = None
        self._scale_vnf_type = None
        self._scale_to_level_data = None
        self._scale_by_step_data = None
        self.discriminator = None
        self.vnf_instanceid = vnf_instanceid
        self.scale_vnf_type = scale_vnf_type
        if scale_to_level_data is not None:
            self.scale_to_level_data = scale_to_level_data
        if scale_by_step_data is not None:
            self.scale_by_step_data = scale_by_step_data

    @property
    def vnf_instanceid(self):
        """Gets the vnf_instanceid of this ScaleVnfData.  # noqa: E501


        :return: The vnf_instanceid of this ScaleVnfData.  # noqa: E501
        :rtype: Identifier
        """
        return self._vnf_instanceid

    @vnf_instanceid.setter
    def vnf_instanceid(self, vnf_instanceid):
        """Sets the vnf_instanceid of this ScaleVnfData.


        :param vnf_instanceid: The vnf_instanceid of this ScaleVnfData.  # noqa: E501
        :type: Identifier
        """
        if vnf_instanceid is None:
            print("WARNING: Invalid value for the required field `vnf_instanceid`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_instanceid`, must not be `None`")  # noqa: E501

        self._vnf_instanceid = vnf_instanceid

    @property
    def scale_vnf_type(self):
        """Gets the scale_vnf_type of this ScaleVnfData.  # noqa: E501

        Type of the scale VNF operation requested. Allowed values are: - SCALE_OUT - SCALE_IN - SCALE_TO_INSTANTIATION_LEVEL - SCALE_TO_SCALE_LEVEL(S) The set of types actually supported depends on the capabilities of the VNF being managed.   # noqa: E501

        :return: The scale_vnf_type of this ScaleVnfData.  # noqa: E501
        :rtype: str
        """
        return self._scale_vnf_type

    @scale_vnf_type.setter
    def scale_vnf_type(self, scale_vnf_type):
        """Sets the scale_vnf_type of this ScaleVnfData.

        Type of the scale VNF operation requested. Allowed values are: - SCALE_OUT - SCALE_IN - SCALE_TO_INSTANTIATION_LEVEL - SCALE_TO_SCALE_LEVEL(S) The set of types actually supported depends on the capabilities of the VNF being managed.   # noqa: E501

        :param scale_vnf_type: The scale_vnf_type of this ScaleVnfData.  # noqa: E501
        :type: str
        """
        if scale_vnf_type is None:
            print("WARNING: Invalid value for the required field `scale_vnf_type`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `scale_vnf_type`, must not be `None`")  # noqa: E501
        allowed_values = ["SCALE_OUT", "SCALE_IN", "SCALE_TO_INSTANTIATION_LEVEL", "SCALE_TO_SCALE_LEVEL(S)"]  # noqa: E501
        if scale_vnf_type is not None and scale_vnf_type not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `scale_vnf_type` ({0}), must be one of {1}"  # noqa: E501
                .format(scale_vnf_type, allowed_values)
            )

        self._scale_vnf_type = scale_vnf_type

    @property
    def scale_to_level_data(self):
        """Gets the scale_to_level_data of this ScaleVnfData.  # noqa: E501


        :return: The scale_to_level_data of this ScaleVnfData.  # noqa: E501
        :rtype: ScaleToLevelData
        """
        return self._scale_to_level_data

    @scale_to_level_data.setter
    def scale_to_level_data(self, scale_to_level_data):
        """Sets the scale_to_level_data of this ScaleVnfData.


        :param scale_to_level_data: The scale_to_level_data of this ScaleVnfData.  # noqa: E501
        :type: ScaleToLevelData
        """

        self._scale_to_level_data = scale_to_level_data

    @property
    def scale_by_step_data(self):
        """Gets the scale_by_step_data of this ScaleVnfData.  # noqa: E501


        :return: The scale_by_step_data of this ScaleVnfData.  # noqa: E501
        :rtype: ScaleByStepData
        """
        return self._scale_by_step_data

    @scale_by_step_data.setter
    def scale_by_step_data(self, scale_by_step_data):
        """Sets the scale_by_step_data of this ScaleVnfData.


        :param scale_by_step_data: The scale_by_step_data of this ScaleVnfData.  # noqa: E501
        :type: ScaleByStepData
        """

        self._scale_by_step_data = scale_by_step_data

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ScaleVnfData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScaleVnfData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
