# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class UpdateVnffgData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnffg_info_id': 'IdentifierInNs',
        'nfp': 'list[NfpData]',
        'nfp_info_id': 'list[IdentifierInNs]'
    }

    attribute_map = {
        'vnffg_info_id': 'vnffgInfoId',
        'nfp': 'nfp',
        'nfp_info_id': 'nfpInfoId'
    }

    def __init__(self, vnffg_info_id=None, nfp=None, nfp_info_id=None):  # noqa: E501
        """UpdateVnffgData - a model defined in Swagger"""  # noqa: E501
        self._vnffg_info_id = None
        self._nfp = None
        self._nfp_info_id = None
        self.discriminator = None
        self.vnffg_info_id = vnffg_info_id
        if nfp is not None:
            self.nfp = nfp
        if nfp_info_id is not None:
            self.nfp_info_id = nfp_info_id

    @property
    def vnffg_info_id(self):
        """Gets the vnffg_info_id of this UpdateVnffgData.  # noqa: E501


        :return: The vnffg_info_id of this UpdateVnffgData.  # noqa: E501
        :rtype: IdentifierInNs
        """
        return self._vnffg_info_id

    @vnffg_info_id.setter
    def vnffg_info_id(self, vnffg_info_id):
        """Sets the vnffg_info_id of this UpdateVnffgData.


        :param vnffg_info_id: The vnffg_info_id of this UpdateVnffgData.  # noqa: E501
        :type: IdentifierInNs
        """
        if vnffg_info_id is None:
            print("WARNING: Invalid value for the required field `vnffg_info_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnffg_info_id`, must not be `None`")  # noqa: E501

        self._vnffg_info_id = vnffg_info_id

    @property
    def nfp(self):
        """Gets the nfp of this UpdateVnffgData.  # noqa: E501

        Indicate the desired new NFP(s) for a given VNFFG after the operations of addition/removal of NS components (e.g. VNFs, VLs, etc.) have been completed, or indicate the updated or newly created NFP classification and selection rule which applied to an existing NFP.   # noqa: E501

        :return: The nfp of this UpdateVnffgData.  # noqa: E501
        :rtype: list[NfpData]
        """
        return self._nfp

    @nfp.setter
    def nfp(self, nfp):
        """Sets the nfp of this UpdateVnffgData.

        Indicate the desired new NFP(s) for a given VNFFG after the operations of addition/removal of NS components (e.g. VNFs, VLs, etc.) have been completed, or indicate the updated or newly created NFP classification and selection rule which applied to an existing NFP.   # noqa: E501

        :param nfp: The nfp of this UpdateVnffgData.  # noqa: E501
        :type: list[NfpData]
        """

        self._nfp = nfp

    @property
    def nfp_info_id(self):
        """Gets the nfp_info_id of this UpdateVnffgData.  # noqa: E501

        Identifier(s) of the NFP to be deleted from a given VNFFG.   # noqa: E501

        :return: The nfp_info_id of this UpdateVnffgData.  # noqa: E501
        :rtype: list[IdentifierInNs]
        """
        return self._nfp_info_id

    @nfp_info_id.setter
    def nfp_info_id(self, nfp_info_id):
        """Sets the nfp_info_id of this UpdateVnffgData.

        Identifier(s) of the NFP to be deleted from a given VNFFG.   # noqa: E501

        :param nfp_info_id: The nfp_info_id of this UpdateVnffgData.  # noqa: E501
        :type: list[IdentifierInNs]
        """

        self._nfp_info_id = nfp_info_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateVnffgData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateVnffgData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
