# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VimConnectionInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'Identifier',
        'vim_id': 'Identifier',
        'vim_type': 'str',
        'interface_info': 'KeyValuePairs',
        'access_info': 'KeyValuePairs',
        'extra': 'VimConnectionInfoExtras'
    }

    attribute_map = {
        'id': 'id',
        'vim_id': 'vimId',
        'vim_type': 'vimType',
        'interface_info': 'interfaceInfo',
        'access_info': 'accessInfo',
        'extra': 'extra'
    }

    def __init__(self, id=None, vim_id=None, vim_type=None, interface_info=None, access_info=None, extra=None):  # noqa: E501
        """VimConnectionInfo - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._vim_id = None
        self._vim_type = None
        self._interface_info = None
        self._access_info = None
        self._extra = None
        self.discriminator = None
        if id is not None:
            self.id = id
        self.vim_id = vim_id
        if vim_type is not None:
            self.vim_type = vim_type
        if interface_info is not None:
            self.interface_info = interface_info
        if access_info is not None:
            self.access_info = access_info
        if extra is not None:
            self.extra = extra

    @property
    def id(self):
        """Gets the id of this VimConnectionInfo.  # noqa: E501


        :return: The id of this VimConnectionInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this VimConnectionInfo.


        :param id: The id of this VimConnectionInfo.  # noqa: E501
        :type: Identifier
        """

        self._id = id

    @property
    def vim_id(self):
        """Gets the vim_id of this VimConnectionInfo.  # noqa: E501


        :return: The vim_id of this VimConnectionInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._vim_id

    @vim_id.setter
    def vim_id(self, vim_id):
        """Sets the vim_id of this VimConnectionInfo.


        :param vim_id: The vim_id of this VimConnectionInfo.  # noqa: E501
        :type: Identifier
        """
        if vim_id is None:
            print("WARNING: Invalid value for the required field `vim_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vim_id`, must not be `None`")  # noqa: E501

        self._vim_id = vim_id

    @property
    def vim_type(self):
        """Gets the vim_type of this VimConnectionInfo.  # noqa: E501

        Discriminator for the different types of the VIM information. The value of this attribute determines the structure of the \"interfaceInfo\" and \"accessInfo\" attributes, based on the type of the VIM. The set of permitted values is expected to change over time as new types or versions of VIMs become available. The ETSI NFV registry of VIM-related information provides access to information about VimConnectionInfo definitions for various VIM types. The structure of the registry is defined in Annex C of SOL003.   # noqa: E501

        :return: The vim_type of this VimConnectionInfo.  # noqa: E501
        :rtype: str
        """
        return self._vim_type

    @vim_type.setter
    def vim_type(self, vim_type):
        """Sets the vim_type of this VimConnectionInfo.

        Discriminator for the different types of the VIM information. The value of this attribute determines the structure of the \"interfaceInfo\" and \"accessInfo\" attributes, based on the type of the VIM. The set of permitted values is expected to change over time as new types or versions of VIMs become available. The ETSI NFV registry of VIM-related information provides access to information about VimConnectionInfo definitions for various VIM types. The structure of the registry is defined in Annex C of SOL003.   # noqa: E501

        :param vim_type: The vim_type of this VimConnectionInfo.  # noqa: E501
        :type: str
        """

        self._vim_type = vim_type

    @property
    def interface_info(self):
        """Gets the interface_info of this VimConnectionInfo.  # noqa: E501


        :return: The interface_info of this VimConnectionInfo.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._interface_info

    @interface_info.setter
    def interface_info(self, interface_info):
        """Sets the interface_info of this VimConnectionInfo.


        :param interface_info: The interface_info of this VimConnectionInfo.  # noqa: E501
        :type: KeyValuePairs
        """

        self._interface_info = interface_info

    @property
    def access_info(self):
        """Gets the access_info of this VimConnectionInfo.  # noqa: E501


        :return: The access_info of this VimConnectionInfo.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._access_info

    @access_info.setter
    def access_info(self, access_info):
        """Sets the access_info of this VimConnectionInfo.


        :param access_info: The access_info of this VimConnectionInfo.  # noqa: E501
        :type: KeyValuePairs
        """

        self._access_info = access_info

    @property
    def extra(self):
        """Gets the extra of this VimConnectionInfo.  # noqa: E501


        :return: The extra of this VimConnectionInfo.  # noqa: E501
        :rtype: VimConnectionInfoExtras
        """
        return self._extra

    @extra.setter
    def extra(self, extra):
        """Sets the extra of this VimConnectionInfo.


        :param extra: The extra of this VimConnectionInfo.  # noqa: E501
        :type: VimConnectionInfoExtras
        """

        self._extra = extra

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VimConnectionInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VimConnectionInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
