# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfExtCpData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cpd_id': 'IdentifierInVnfd',
        'cp_config': 'list[VnfExtCpConfig]'
    }

    attribute_map = {
        'cpd_id': 'cpdId',
        'cp_config': 'cpConfig'
    }

    def __init__(self, cpd_id=None, cp_config=None):  # noqa: E501
        """VnfExtCpData - a model defined in Swagger"""  # noqa: E501
        self._cpd_id = None
        self._cp_config = None
        self.discriminator = None
        self.cpd_id = cpd_id
        if cp_config is not None:
            self.cp_config = cp_config

    @property
    def cpd_id(self):
        """Gets the cpd_id of this VnfExtCpData.  # noqa: E501


        :return: The cpd_id of this VnfExtCpData.  # noqa: E501
        :rtype: IdentifierInVnfd
        """
        return self._cpd_id

    @cpd_id.setter
    def cpd_id(self, cpd_id):
        """Sets the cpd_id of this VnfExtCpData.


        :param cpd_id: The cpd_id of this VnfExtCpData.  # noqa: E501
        :type: IdentifierInVnfd
        """
        if cpd_id is None:
            print("WARNING: Invalid value for the required field `cpd_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `cpd_id`, must not be `None`")  # noqa: E501

        self._cpd_id = cpd_id

    @property
    def cp_config(self):
        """Gets the cp_config of this VnfExtCpData.  # noqa: E501

        List of instance data that need to be configured on the CP instances created from the respective CPD.   # noqa: E501

        :return: The cp_config of this VnfExtCpData.  # noqa: E501
        :rtype: list[VnfExtCpConfig]
        """
        return self._cp_config

    @cp_config.setter
    def cp_config(self, cp_config):
        """Sets the cp_config of this VnfExtCpData.

        List of instance data that need to be configured on the CP instances created from the respective CPD.   # noqa: E501

        :param cp_config: The cp_config of this VnfExtCpData.  # noqa: E501
        :type: list[VnfExtCpConfig]
        """

        self._cp_config = cp_config

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfExtCpData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfExtCpData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
