# coding: utf-8

"""
    SOL005 - NS Lifecycle Management Interface

    SOL005 - NS Lifecycle Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfLinkPortInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'IdentifierInVnf',
        'resource_handle': 'ResourceHandle',
        'cp_instance_id': 'IdentifierInVnf',
        'cp_instance_type': 'str'
    }

    attribute_map = {
        'id': 'id',
        'resource_handle': 'resourceHandle',
        'cp_instance_id': 'cpInstanceId',
        'cp_instance_type': 'cpInstanceType'
    }

    def __init__(self, id=None, resource_handle=None, cp_instance_id=None, cp_instance_type=None):  # noqa: E501
        """VnfLinkPortInfo - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._resource_handle = None
        self._cp_instance_id = None
        self._cp_instance_type = None
        self.discriminator = None
        self.id = id
        self.resource_handle = resource_handle
        if cp_instance_id is not None:
            self.cp_instance_id = cp_instance_id
        if cp_instance_type is not None:
            self.cp_instance_type = cp_instance_type

    @property
    def id(self):
        """Gets the id of this VnfLinkPortInfo.  # noqa: E501


        :return: The id of this VnfLinkPortInfo.  # noqa: E501
        :rtype: IdentifierInVnf
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this VnfLinkPortInfo.


        :param id: The id of this VnfLinkPortInfo.  # noqa: E501
        :type: IdentifierInVnf
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def resource_handle(self):
        """Gets the resource_handle of this VnfLinkPortInfo.  # noqa: E501


        :return: The resource_handle of this VnfLinkPortInfo.  # noqa: E501
        :rtype: ResourceHandle
        """
        return self._resource_handle

    @resource_handle.setter
    def resource_handle(self, resource_handle):
        """Sets the resource_handle of this VnfLinkPortInfo.


        :param resource_handle: The resource_handle of this VnfLinkPortInfo.  # noqa: E501
        :type: ResourceHandle
        """
        if resource_handle is None:
            print("WARNING: Invalid value for the required field `resource_handle`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `resource_handle`, must not be `None`")  # noqa: E501

        self._resource_handle = resource_handle

    @property
    def cp_instance_id(self):
        """Gets the cp_instance_id of this VnfLinkPortInfo.  # noqa: E501


        :return: The cp_instance_id of this VnfLinkPortInfo.  # noqa: E501
        :rtype: IdentifierInVnf
        """
        return self._cp_instance_id

    @cp_instance_id.setter
    def cp_instance_id(self, cp_instance_id):
        """Sets the cp_instance_id of this VnfLinkPortInfo.


        :param cp_instance_id: The cp_instance_id of this VnfLinkPortInfo.  # noqa: E501
        :type: IdentifierInVnf
        """

        self._cp_instance_id = cp_instance_id

    @property
    def cp_instance_type(self):
        """Gets the cp_instance_type of this VnfLinkPortInfo.  # noqa: E501

        Type of the CP instance that is identified by cpInstanceId. Shall be present if \"cpInstanceId\" is present, and shall be absent otherwise. Permitted values: * VNFC_CP: The link port is connected to a VNFC CP * EXT_CP: The link port is associated to an external CP.   # noqa: E501

        :return: The cp_instance_type of this VnfLinkPortInfo.  # noqa: E501
        :rtype: str
        """
        return self._cp_instance_type

    @cp_instance_type.setter
    def cp_instance_type(self, cp_instance_type):
        """Sets the cp_instance_type of this VnfLinkPortInfo.

        Type of the CP instance that is identified by cpInstanceId. Shall be present if \"cpInstanceId\" is present, and shall be absent otherwise. Permitted values: * VNFC_CP: The link port is connected to a VNFC CP * EXT_CP: The link port is associated to an external CP.   # noqa: E501

        :param cp_instance_type: The cp_instance_type of this VnfLinkPortInfo.  # noqa: E501
        :type: str
        """
        allowed_values = ["VNFC_CP", "EXT_CP"]  # noqa: E501
        if cp_instance_type is not None and cp_instance_type not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `cp_instance_type` ({0}), must be one of {1}"  # noqa: E501
                .format(cp_instance_type, allowed_values)
            )

        self._cp_instance_type = cp_instance_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfLinkPortInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfLinkPortInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
