# coding: utf-8

"""
    Telco Cloud Automation Partner Systems API

    Telco Cloud Automation Partner Systems API. Registers, modifies, lists and deletes Partner Systems.  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class Extension(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'extension_id': 'str',
        'name': 'str',
        'type': 'str',
        'extension_key': 'str',
        'description': 'str',
        'interface_info': 'ExtensionInterfaceInfo',
        'access_info': 'ExtensionAccessInfo',
        'additional_parameters': 'object',
        'state': 'str',
        'extension_subtype': 'str',
        'products': 'list[object]',
        'vim_info': 'list[ExtensionVimInfo]',
        'auto_scale_enabled': 'bool',
        'auto_heal_enabled': 'bool',
        'version': 'str',
        'vnf_count': 'int',
        'vnf_catalog_count': 'int'
    }

    attribute_map = {
        'extension_id': 'extensionId',
        'name': 'name',
        'type': 'type',
        'extension_key': 'extensionKey',
        'description': 'description',
        'interface_info': 'interfaceInfo',
        'access_info': 'accessInfo',
        'additional_parameters': 'additionalParameters',
        'state': 'state',
        'extension_subtype': 'extensionSubtype',
        'products': 'products',
        'vim_info': 'vimInfo',
        'auto_scale_enabled': 'autoScaleEnabled',
        'auto_heal_enabled': 'autoHealEnabled',
        'version': 'version',
        'vnf_count': 'vnfCount',
        'vnf_catalog_count': 'vnfCatalogCount'
    }

    def __init__(self, extension_id=None, name=None, type=None, extension_key=None, description=None, interface_info=None, access_info=None, additional_parameters=None, state=None, extension_subtype=None, products=None, vim_info=None, auto_scale_enabled=None, auto_heal_enabled=None, version=None, vnf_count=None, vnf_catalog_count=None):  # noqa: E501
        """Extension - a model defined in Swagger"""  # noqa: E501
        self._extension_id = None
        self._name = None
        self._type = None
        self._extension_key = None
        self._description = None
        self._interface_info = None
        self._access_info = None
        self._additional_parameters = None
        self._state = None
        self._extension_subtype = None
        self._products = None
        self._vim_info = None
        self._auto_scale_enabled = None
        self._auto_heal_enabled = None
        self._version = None
        self._vnf_count = None
        self._vnf_catalog_count = None
        self.discriminator = None
        if extension_id is not None:
            self.extension_id = extension_id
        if name is not None:
            self.name = name
        if type is not None:
            self.type = type
        if extension_key is not None:
            self.extension_key = extension_key
        if description is not None:
            self.description = description
        if interface_info is not None:
            self.interface_info = interface_info
        if access_info is not None:
            self.access_info = access_info
        if additional_parameters is not None:
            self.additional_parameters = additional_parameters
        if state is not None:
            self.state = state
        if extension_subtype is not None:
            self.extension_subtype = extension_subtype
        if products is not None:
            self.products = products
        if vim_info is not None:
            self.vim_info = vim_info
        if auto_scale_enabled is not None:
            self.auto_scale_enabled = auto_scale_enabled
        if auto_heal_enabled is not None:
            self.auto_heal_enabled = auto_heal_enabled
        if version is not None:
            self.version = version
        if vnf_count is not None:
            self.vnf_count = vnf_count
        if vnf_catalog_count is not None:
            self.vnf_catalog_count = vnf_catalog_count

    @property
    def extension_id(self):
        """Gets the extension_id of this Extension.  # noqa: E501

        TCA generated identifier for the Extension registered  # noqa: E501

        :return: The extension_id of this Extension.  # noqa: E501
        :rtype: str
        """
        return self._extension_id

    @extension_id.setter
    def extension_id(self, extension_id):
        """Sets the extension_id of this Extension.

        TCA generated identifier for the Extension registered  # noqa: E501

        :param extension_id: The extension_id of this Extension.  # noqa: E501
        :type: str
        """

        self._extension_id = extension_id

    @property
    def name(self):
        """Gets the name of this Extension.  # noqa: E501

        Name of the Extension with which it was created  # noqa: E501

        :return: The name of this Extension.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Extension.

        Name of the Extension with which it was created  # noqa: E501

        :param name: The name of this Extension.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def type(self):
        """Gets the type of this Extension.  # noqa: E501

        Type of the Extension  # noqa: E501

        :return: The type of this Extension.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Extension.

        Type of the Extension  # noqa: E501

        :param type: The type of this Extension.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def extension_key(self):
        """Gets the extension_key of this Extension.  # noqa: E501

        Extension Key  # noqa: E501

        :return: The extension_key of this Extension.  # noqa: E501
        :rtype: str
        """
        return self._extension_key

    @extension_key.setter
    def extension_key(self, extension_key):
        """Sets the extension_key of this Extension.

        Extension Key  # noqa: E501

        :param extension_key: The extension_key of this Extension.  # noqa: E501
        :type: str
        """

        self._extension_key = extension_key

    @property
    def description(self):
        """Gets the description of this Extension.  # noqa: E501

        Context of the Extension  # noqa: E501

        :return: The description of this Extension.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Extension.

        Context of the Extension  # noqa: E501

        :param description: The description of this Extension.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def interface_info(self):
        """Gets the interface_info of this Extension.  # noqa: E501


        :return: The interface_info of this Extension.  # noqa: E501
        :rtype: ExtensionInterfaceInfo
        """
        return self._interface_info

    @interface_info.setter
    def interface_info(self, interface_info):
        """Sets the interface_info of this Extension.


        :param interface_info: The interface_info of this Extension.  # noqa: E501
        :type: ExtensionInterfaceInfo
        """

        self._interface_info = interface_info

    @property
    def access_info(self):
        """Gets the access_info of this Extension.  # noqa: E501


        :return: The access_info of this Extension.  # noqa: E501
        :rtype: ExtensionAccessInfo
        """
        return self._access_info

    @access_info.setter
    def access_info(self, access_info):
        """Sets the access_info of this Extension.


        :param access_info: The access_info of this Extension.  # noqa: E501
        :type: ExtensionAccessInfo
        """

        self._access_info = access_info

    @property
    def additional_parameters(self):
        """Gets the additional_parameters of this Extension.  # noqa: E501


        :return: The additional_parameters of this Extension.  # noqa: E501
        :rtype: object
        """
        return self._additional_parameters

    @additional_parameters.setter
    def additional_parameters(self, additional_parameters):
        """Sets the additional_parameters of this Extension.


        :param additional_parameters: The additional_parameters of this Extension.  # noqa: E501
        :type: object
        """

        self._additional_parameters = additional_parameters

    @property
    def state(self):
        """Gets the state of this Extension.  # noqa: E501

        State of the Extension in TCA context  # noqa: E501

        :return: The state of this Extension.  # noqa: E501
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this Extension.

        State of the Extension in TCA context  # noqa: E501

        :param state: The state of this Extension.  # noqa: E501
        :type: str
        """

        self._state = state

    @property
    def extension_subtype(self):
        """Gets the extension_subtype of this Extension.  # noqa: E501

        Subtype of the Extension  # noqa: E501

        :return: The extension_subtype of this Extension.  # noqa: E501
        :rtype: str
        """
        return self._extension_subtype

    @extension_subtype.setter
    def extension_subtype(self, extension_subtype):
        """Sets the extension_subtype of this Extension.

        Subtype of the Extension  # noqa: E501

        :param extension_subtype: The extension_subtype of this Extension.  # noqa: E501
        :type: str
        """

        self._extension_subtype = extension_subtype

    @property
    def products(self):
        """Gets the products of this Extension.  # noqa: E501

        Information regarding the SVNFM Extension  # noqa: E501

        :return: The products of this Extension.  # noqa: E501
        :rtype: list[object]
        """
        return self._products

    @products.setter
    def products(self, products):
        """Sets the products of this Extension.

        Information regarding the SVNFM Extension  # noqa: E501

        :param products: The products of this Extension.  # noqa: E501
        :type: list[object]
        """

        self._products = products

    @property
    def vim_info(self):
        """Gets the vim_info of this Extension.  # noqa: E501


        :return: The vim_info of this Extension.  # noqa: E501
        :rtype: list[ExtensionVimInfo]
        """
        return self._vim_info

    @vim_info.setter
    def vim_info(self, vim_info):
        """Sets the vim_info of this Extension.


        :param vim_info: The vim_info of this Extension.  # noqa: E501
        :type: list[ExtensionVimInfo]
        """

        self._vim_info = vim_info

    @property
    def auto_scale_enabled(self):
        """Gets the auto_scale_enabled of this Extension.  # noqa: E501

        Boolean to determine auto scale enabled on the Extension or not  # noqa: E501

        :return: The auto_scale_enabled of this Extension.  # noqa: E501
        :rtype: bool
        """
        return self._auto_scale_enabled

    @auto_scale_enabled.setter
    def auto_scale_enabled(self, auto_scale_enabled):
        """Sets the auto_scale_enabled of this Extension.

        Boolean to determine auto scale enabled on the Extension or not  # noqa: E501

        :param auto_scale_enabled: The auto_scale_enabled of this Extension.  # noqa: E501
        :type: bool
        """

        self._auto_scale_enabled = auto_scale_enabled

    @property
    def auto_heal_enabled(self):
        """Gets the auto_heal_enabled of this Extension.  # noqa: E501

        Boolean to determine auto scale heal on the Extension or not  # noqa: E501

        :return: The auto_heal_enabled of this Extension.  # noqa: E501
        :rtype: bool
        """
        return self._auto_heal_enabled

    @auto_heal_enabled.setter
    def auto_heal_enabled(self, auto_heal_enabled):
        """Sets the auto_heal_enabled of this Extension.

        Boolean to determine auto scale heal on the Extension or not  # noqa: E501

        :param auto_heal_enabled: The auto_heal_enabled of this Extension.  # noqa: E501
        :type: bool
        """

        self._auto_heal_enabled = auto_heal_enabled

    @property
    def version(self):
        """Gets the version of this Extension.  # noqa: E501

        Version of the Extension  # noqa: E501

        :return: The version of this Extension.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this Extension.

        Version of the Extension  # noqa: E501

        :param version: The version of this Extension.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def vnf_count(self):
        """Gets the vnf_count of this Extension.  # noqa: E501

        Count of VNF associated with the Extension  # noqa: E501

        :return: The vnf_count of this Extension.  # noqa: E501
        :rtype: int
        """
        return self._vnf_count

    @vnf_count.setter
    def vnf_count(self, vnf_count):
        """Sets the vnf_count of this Extension.

        Count of VNF associated with the Extension  # noqa: E501

        :param vnf_count: The vnf_count of this Extension.  # noqa: E501
        :type: int
        """

        self._vnf_count = vnf_count

    @property
    def vnf_catalog_count(self):
        """Gets the vnf_catalog_count of this Extension.  # noqa: E501

        Count of VNF catalog associated with the Extension  # noqa: E501

        :return: The vnf_catalog_count of this Extension.  # noqa: E501
        :rtype: int
        """
        return self._vnf_catalog_count

    @vnf_catalog_count.setter
    def vnf_catalog_count(self, vnf_catalog_count):
        """Sets the vnf_catalog_count of this Extension.

        Count of VNF catalog associated with the Extension  # noqa: E501

        :param vnf_catalog_count: The vnf_catalog_count of this Extension.  # noqa: E501
        :type: int
        """

        self._vnf_catalog_count = vnf_catalog_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Extension, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Extension):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
