# coding: utf-8

"""
    Appliance Management APIs

    APIs to configure the TCA Manager appliance and to get the status of the services. (Note: Please change the curl command to point to 9443 port while using 'Try it out' feature)  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from tca.system_management.api_client import ApiClient
from tca.api.tca_api import TCAApi

class CertificatesApi(TCAApi):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def api_admin_certificates_get(self, accept, **kwargs):  # noqa: E501
        """Get list of trusted certificates  # noqa: E501

        API to get list of trusted certificates  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_admin_certificates_get(accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: application/json (required)


        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_admin_certificates_get_with_http_info(accept, **kwargs)  # noqa: E501
        else:
            (data) = self.api_admin_certificates_get_with_http_info(accept, **kwargs)  # noqa: E501
            return data

    def api_admin_certificates_get_with_http_info(self, accept, **kwargs):  # noqa: E501
        """Get list of trusted certificates  # noqa: E501

        API to get list of trusted certificates  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_admin_certificates_get_with_http_info(accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: application/json (required)


        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['accept']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_admin_certificates_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `api_admin_certificates_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = ['BASIC_AUTH']  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/api/admin/certificates', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2007',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def api_admin_certificates_post(self, body, accept, content_type, **kwargs):  # noqa: E501
        """Import trusted certificate  # noqa: E501

        API to import trusted certificate  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_admin_certificates_post(body, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param AdminCertificatesBody body: X509 certificate in PEM format (required)
        :param str accept: application/json (required)
        :param str content_type: application/json (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_admin_certificates_post_with_http_info(body, accept, content_type, **kwargs)  # noqa: E501
        else:
            (data) = self.api_admin_certificates_post_with_http_info(body, accept, content_type, **kwargs)  # noqa: E501
            return data

    def api_admin_certificates_post_with_http_info(self, body, accept, content_type, **kwargs):  # noqa: E501
        """Import trusted certificate  # noqa: E501

        API to import trusted certificate  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_admin_certificates_post_with_http_info(body, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param AdminCertificatesBody body: X509 certificate in PEM format (required)
        :param str accept: application/json (required)
        :param str content_type: application/json (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_admin_certificates_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `api_admin_certificates_post`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `api_admin_certificates_post`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `api_admin_certificates_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = ['BASIC_AUTH']  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/api/admin/certificates', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2007',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def api_admin_certificates_server_certificate_appliance_manager_put(self, body, accept, content_type, **kwargs):  # noqa: E501
        """To change the appliance management certificate  # noqa: E501

        API to change the appliance management certificate  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_admin_certificates_server_certificate_appliance_manager_put(body, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Object body: (required)
        :param str accept: application/json (required)
        :param str content_type: application/json (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_admin_certificates_server_certificate_appliance_manager_put_with_http_info(body, accept, content_type, **kwargs)  # noqa: E501
        else:
            (data) = self.api_admin_certificates_server_certificate_appliance_manager_put_with_http_info(body, accept, content_type, **kwargs)  # noqa: E501
            return data

    def api_admin_certificates_server_certificate_appliance_manager_put_with_http_info(self, body, accept, content_type, **kwargs):  # noqa: E501
        """To change the appliance management certificate  # noqa: E501

        API to change the appliance management certificate  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_admin_certificates_server_certificate_appliance_manager_put_with_http_info(body, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Object body: (required)
        :param str accept: application/json (required)
        :param str content_type: application/json (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_admin_certificates_server_certificate_appliance_manager_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `api_admin_certificates_server_certificate_appliance_manager_put`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `api_admin_certificates_server_certificate_appliance_manager_put`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `api_admin_certificates_server_certificate_appliance_manager_put`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = ['BASIC_AUTH']  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/api/admin/certificates/serverCertificate/appliance-manager', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='object',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def api_admin_certificates_server_certificate_httpd_put(self, body, accept, content_type, **kwargs):  # noqa: E501
        """Import Server certificate  # noqa: E501

        Api to Import Server certificate  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_admin_certificates_server_certificate_httpd_put(body, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ServerCertificateHttpdBody body: To specify the certificate in a JSON payload, use the following UNIX command to convert each .pem file to a value: 
  <pre> awk 'NF {sub(/\r/, ""); printf "%s\\n",$0;}' cert-name.pem </pre> 
 In this example, cert-name.pem is the name of the certificate file. The new format places all the certificate information on a single line with embedded newline characters. If you have an intermediate certificate, that certificate must also be in one-line format and add to the first certificate so that both certificates are on the same line. (required)
        :param str accept: application/json (required)
        :param str content_type: application/json (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_admin_certificates_server_certificate_httpd_put_with_http_info(body, accept, content_type, **kwargs)  # noqa: E501
        else:
            (data) = self.api_admin_certificates_server_certificate_httpd_put_with_http_info(body, accept, content_type, **kwargs)  # noqa: E501
            return data

    def api_admin_certificates_server_certificate_httpd_put_with_http_info(self, body, accept, content_type, **kwargs):  # noqa: E501
        """Import Server certificate  # noqa: E501

        Api to Import Server certificate  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_admin_certificates_server_certificate_httpd_put_with_http_info(body, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ServerCertificateHttpdBody body: To specify the certificate in a JSON payload, use the following UNIX command to convert each .pem file to a value: 
  <pre> awk 'NF {sub(/\r/, ""); printf "%s\\n",$0;}' cert-name.pem </pre> 
 In this example, cert-name.pem is the name of the certificate file. The new format places all the certificate information on a single line with embedded newline characters. If you have an intermediate certificate, that certificate must also be in one-line format and add to the first certificate so that both certificates are on the same line. (required)
        :param str accept: application/json (required)
        :param str content_type: application/json (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_admin_certificates_server_certificate_httpd_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `api_admin_certificates_server_certificate_httpd_put`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `api_admin_certificates_server_certificate_httpd_put`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `api_admin_certificates_server_certificate_httpd_put`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = ['BASIC_AUTH']  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/api/admin/certificates/serverCertificate/httpd', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2007',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def api_admin_certificates_sha256_delete(self, accept, content_type, sha256, **kwargs):  # noqa: E501
        """Delete trusted certificate  # noqa: E501

        API to delete trusted certificate  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_admin_certificates_sha256_delete(accept, content_type, sha256, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: application/json (required)
        :param str content_type: application/json (required)
        :param str sha256: (required)


        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_admin_certificates_sha256_delete_with_http_info(accept, content_type, sha256, **kwargs)  # noqa: E501
        else:
            (data) = self.api_admin_certificates_sha256_delete_with_http_info(accept, content_type, sha256, **kwargs)  # noqa: E501
            return data

    def api_admin_certificates_sha256_delete_with_http_info(self, accept, content_type, sha256, **kwargs):  # noqa: E501
        """Delete trusted certificate  # noqa: E501

        API to delete trusted certificate  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_admin_certificates_sha256_delete_with_http_info(accept, content_type, sha256, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: application/json (required)
        :param str content_type: application/json (required)
        :param str sha256: (required)


        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['accept', 'content_type', 'sha256']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_admin_certificates_sha256_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `api_admin_certificates_sha256_delete`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `api_admin_certificates_sha256_delete`")  # noqa: E501
        # verify the required parameter 'sha256' is set
        if ('sha256' not in params or
                params['sha256'] is None):
            raise ValueError("Missing the required parameter `sha256` when calling `api_admin_certificates_sha256_delete`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'sha256' in params:
            path_params['sha256'] = params['sha256']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = ['BASIC_AUTH']  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/api/admin/certificates/{sha256}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2007',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
