# coding: utf-8

"""
    Appliance Management APIs

    APIs to configure the TCA Manager appliance and to get the status of the services. (Note: Please change the curl command to point to 9443 port while using 'Try it out' feature)  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from tca.system_management.api_client import ApiClient
from tca.api.tca_api import TCAApi

class NetworkingApi(TCAApi):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def api_admin_global_config_proxy_get(self, accept, **kwargs):  # noqa: E501
        """Get Proxy Settings  # noqa: E501

        Api to get proxy settings  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_admin_global_config_proxy_get(accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: application/json (required)


        :return: InlineResponse2006
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_admin_global_config_proxy_get_with_http_info(accept, **kwargs)  # noqa: E501
        else:
            (data) = self.api_admin_global_config_proxy_get_with_http_info(accept, **kwargs)  # noqa: E501
            return data

    def api_admin_global_config_proxy_get_with_http_info(self, accept, **kwargs):  # noqa: E501
        """Get Proxy Settings  # noqa: E501

        Api to get proxy settings  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_admin_global_config_proxy_get_with_http_info(accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: application/json (required)


        :return: InlineResponse2006
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['accept']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_admin_global_config_proxy_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `api_admin_global_config_proxy_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = ['BASIC_AUTH']  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/api/admin/global/config/proxy', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2006',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def api_admin_global_config_proxy_post(self, body, accept, content_type, **kwargs):  # noqa: E501
        """Configure Proxy Settings  # noqa: E501

        Api to add proxy settings  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_admin_global_config_proxy_post(body, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ConfigProxyBody body: (required)
        :param str accept: application/json (required)
        :param str content_type: application/json (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: InlineResponse2006
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_admin_global_config_proxy_post_with_http_info(body, accept, content_type, **kwargs)  # noqa: E501
        else:
            (data) = self.api_admin_global_config_proxy_post_with_http_info(body, accept, content_type, **kwargs)  # noqa: E501
            return data

    def api_admin_global_config_proxy_post_with_http_info(self, body, accept, content_type, **kwargs):  # noqa: E501
        """Configure Proxy Settings  # noqa: E501

        Api to add proxy settings  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_admin_global_config_proxy_post_with_http_info(body, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ConfigProxyBody body: (required)
        :param str accept: application/json (required)
        :param str content_type: application/json (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: InlineResponse2006
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_admin_global_config_proxy_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `api_admin_global_config_proxy_post`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `api_admin_global_config_proxy_post`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `api_admin_global_config_proxy_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = ['BASIC_AUTH']  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/api/admin/global/config/proxy', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2006',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def api_admin_global_config_proxy_uuid_delete(self, uuid, **kwargs):  # noqa: E501
        """Remove Proxy Settings  # noqa: E501

        Api to remove proxy settings  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_admin_global_config_proxy_uuid_delete(uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str uuid: (required)


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_admin_global_config_proxy_uuid_delete_with_http_info(uuid, **kwargs)  # noqa: E501
        else:
            (data) = self.api_admin_global_config_proxy_uuid_delete_with_http_info(uuid, **kwargs)  # noqa: E501
            return data

    def api_admin_global_config_proxy_uuid_delete_with_http_info(self, uuid, **kwargs):  # noqa: E501
        """Remove Proxy Settings  # noqa: E501

        Api to remove proxy settings  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_admin_global_config_proxy_uuid_delete_with_http_info(uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str uuid: (required)


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['uuid']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_admin_global_config_proxy_uuid_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'uuid' is set
        if ('uuid' not in params or
                params['uuid'] is None):
            raise ValueError("Missing the required parameter `uuid` when calling `api_admin_global_config_proxy_uuid_delete`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'uuid' in params:
            path_params['uuid'] = params['uuid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None


        # Authentication setting
        auth_settings = ['BASIC_AUTH']  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/api/admin/global/config/proxy/{uuid}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def system_network_dns_delete(self, **kwargs):  # noqa: E501
        """Remove DNS Settings  # noqa: E501

        Api to Remove DNS Settings  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.system_network_dns_delete(async_req=True)
        >>> result = thread.get()

        :param async_req bool


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.system_network_dns_delete_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.system_network_dns_delete_with_http_info(**kwargs)  # noqa: E501
            return data

    def system_network_dns_delete_with_http_info(self, **kwargs):  # noqa: E501
        """Remove DNS Settings  # noqa: E501

        Api to Remove DNS Settings  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.system_network_dns_delete_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method system_network_dns_delete" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None


        # Authentication setting
        auth_settings = ['BASIC_AUTH']  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/system/network/dns', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def system_network_dns_put(self, body, accept, content_type, **kwargs):  # noqa: E501
        """Configure DNS Settings  # noqa: E501

        Api to Configure DNS Settings. You need to restart the Application Service and Web Service for your changes to take effect!.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.system_network_dns_put(body, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NetworkDnsBody body: (required)
        :param str accept: application/json (required)
        :param str content_type: application/json (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: NetworkDnsBody
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.system_network_dns_put_with_http_info(body, accept, content_type, **kwargs)  # noqa: E501
        else:
            (data) = self.system_network_dns_put_with_http_info(body, accept, content_type, **kwargs)  # noqa: E501
            return data

    def system_network_dns_put_with_http_info(self, body, accept, content_type, **kwargs):  # noqa: E501
        """Configure DNS Settings  # noqa: E501

        Api to Configure DNS Settings. You need to restart the Application Service and Web Service for your changes to take effect!.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.system_network_dns_put_with_http_info(body, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NetworkDnsBody body: (required)
        :param str accept: application/json (required)
        :param str content_type: application/json (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: NetworkDnsBody
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method system_network_dns_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `system_network_dns_put`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `system_network_dns_put`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `system_network_dns_put`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = ['BASIC_AUTH']  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/system/network/dns', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkDnsBody',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def system_network_get(self, accept, **kwargs):  # noqa: E501
        """Get Network Settings (General Network & DNS)  # noqa: E501

        Api to get Network Settings (General Network & DNS)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.system_network_get(accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: application/json (required)


        :return: InlineResponse2004
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.system_network_get_with_http_info(accept, **kwargs)  # noqa: E501
        else:
            (data) = self.system_network_get_with_http_info(accept, **kwargs)  # noqa: E501
            return data

    def system_network_get_with_http_info(self, accept, **kwargs):  # noqa: E501
        """Get Network Settings (General Network & DNS)  # noqa: E501

        Api to get Network Settings (General Network & DNS)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.system_network_get_with_http_info(accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: application/json (required)


        :return: InlineResponse2004
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['accept']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method system_network_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `system_network_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = ['BASIC_AUTH']  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/system/network', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2004',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def system_network_staticroutes_get(self, accept, **kwargs):  # noqa: E501
        """Get Static Routes  # noqa: E501

        Api to Get Static Routes  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.system_network_staticroutes_get(accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: application/json (required)


        :return: list[InlineResponse2003]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.system_network_staticroutes_get_with_http_info(accept, **kwargs)  # noqa: E501
        else:
            (data) = self.system_network_staticroutes_get_with_http_info(accept, **kwargs)  # noqa: E501
            return data

    def system_network_staticroutes_get_with_http_info(self, accept, **kwargs):  # noqa: E501
        """Get Static Routes  # noqa: E501

        Api to Get Static Routes  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.system_network_staticroutes_get_with_http_info(accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: application/json (required)


        :return: list[InlineResponse2003]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['accept']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method system_network_staticroutes_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `system_network_staticroutes_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = ['BASIC_AUTH']  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/system/network/staticroutes', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[InlineResponse2003]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def system_network_staticroutes_put(self, body, accept, content_type, **kwargs):  # noqa: E501
        """Configure Static Routes  # noqa: E501

        Api to Configure Static Routes  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.system_network_staticroutes_put(body, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NetworkStaticroutesBody body: (required)
        :param str accept: application/json (required)
        :param str content_type: application/json (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: NetworkStaticroutesBody
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.system_network_staticroutes_put_with_http_info(body, accept, content_type, **kwargs)  # noqa: E501
        else:
            (data) = self.system_network_staticroutes_put_with_http_info(body, accept, content_type, **kwargs)  # noqa: E501
            return data

    def system_network_staticroutes_put_with_http_info(self, body, accept, content_type, **kwargs):  # noqa: E501
        """Configure Static Routes  # noqa: E501

        Api to Configure Static Routes  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.system_network_staticroutes_put_with_http_info(body, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param NetworkStaticroutesBody body: (required)
        :param str accept: application/json (required)
        :param str content_type: application/json (required)

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: NetworkStaticroutesBody
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method system_network_staticroutes_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `system_network_staticroutes_put`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `system_network_staticroutes_put`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `system_network_staticroutes_put`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = ['BASIC_AUTH']  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/system/network/staticroutes', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='NetworkStaticroutesBody',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
