# coding: utf-8

# flake8: noqa

"""
    SOL003 - VNF Fault Management interface

    SOL003 - VNF Fault Management interface  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import
# import VMware SDK package registry   # VMW301
from tca.api.client import __package_dict__   # VMW301
from tca.api.client import __configuration_dict__  # VMW301
from tca.api.client import __api_client_dict__  # VMW301

# import apis into sdk package
from tca.vnffm.api.default_api import DefaultApi
# import ApiClient
from tca.vnffm.api_client import ApiClient
from tca.vnffm.configuration import Configuration
# import models into sdk package
from tca.vnffm.model.alarm import Alarm
from tca.vnffm.model.alarm_links import AlarmLinks
from tca.vnffm.model.alarm_modifications import AlarmModifications
from tca.vnffm.model.api_version_information import ApiVersionInformation
from tca.vnffm.model.api_version_information_api_versions import ApiVersionInformationApiVersions
from tca.vnffm.model.event_type import EventType
from tca.vnffm.model.faulty_resource_info import FaultyResourceInfo
from tca.vnffm.model.faulty_resource_type import FaultyResourceType
from tca.vnffm.model.fm_notifications_filter import FmNotificationsFilter
from tca.vnffm.model.fm_subscription import FmSubscription
from tca.vnffm.model.fm_subscription_links import FmSubscriptionLinks
from tca.vnffm.model.fm_subscription_request import FmSubscriptionRequest
from tca.vnffm.model.identifier import Identifier
from tca.vnffm.model.identifier_in_vim import IdentifierInVim
from tca.vnffm.model.identifier_in_vnf import IdentifierInVnf
from tca.vnffm.model.link import Link
from tca.vnffm.model.model_date_time import ModelDateTime
from tca.vnffm.model.perceived_severity_type import PerceivedSeverityType
from tca.vnffm.model.problem_details import ProblemDetails
from tca.vnffm.model.resource_handle import ResourceHandle
from tca.vnffm.model.subscription_authentication import SubscriptionAuthentication
from tca.vnffm.model.subscription_authentication_params_basic import SubscriptionAuthenticationParamsBasic
from tca.vnffm.model.subscription_authentication_params_oauth2_client_credentials import SubscriptionAuthenticationParamsOauth2ClientCredentials
from tca.vnffm.model.uri import Uri
from tca.vnffm.model.version import Version
from tca.vnffm.model.vnf_instance_subscription_filter import VnfInstanceSubscriptionFilter
from tca.vnffm.model.vnf_instance_subscription_filter_versions import VnfInstanceSubscriptionFilterVersions
from tca.vnffm.model.vnf_instance_subscription_filter_vnf_products import VnfInstanceSubscriptionFilterVnfProducts
from tca.vnffm.model.vnf_instance_subscription_filter_vnf_products_from_providers import VnfInstanceSubscriptionFilterVnfProductsFromProviders

# Update API client Registry   # VMW301
__package_dict__.update({ "tca.vnffm:DefaultApi": DefaultApi })  # VMW301
__configuration_dict__.update({ "tca.vnffm": Configuration })  # VMW301
__api_client_dict__.update({ "tca.vnffm": ApiClient })  # VMW301
