# coding: utf-8

"""
    SOL003 - VNF Fault Management interface

    SOL003 - VNF Fault Management interface  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class Alarm(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'Identifier',
        'managed_object_id': 'Identifier',
        'vnfc_instance_ids': 'list[IdentifierInVnf]',
        'root_cause_faulty_resource': 'FaultyResourceInfo',
        'alarm_raised_time': 'datetime',
        'alarm_changed_time': 'datetime',
        'alarm_cleared_time': 'datetime',
        'alarm_acknowledged_time': 'datetime',
        'ack_state': 'str',
        'perceived_severity': 'PerceivedSeverityType',
        'event_time': 'datetime',
        'event_type': 'EventType',
        'fault_type': 'str',
        'probable_cause': 'str',
        'is_root_cause': 'bool',
        'correlated_alarm_ids': 'list[Identifier]',
        'fault_details': 'list[str]',
        'links': 'AlarmLinks'
    }

    attribute_map = {
        'id': 'id',
        'managed_object_id': 'managedObjectId',
        'vnfc_instance_ids': 'vnfcInstanceIds',
        'root_cause_faulty_resource': 'rootCauseFaultyResource',
        'alarm_raised_time': 'alarmRaisedTime',
        'alarm_changed_time': 'alarmChangedTime',
        'alarm_cleared_time': 'alarmClearedTime',
        'alarm_acknowledged_time': 'alarmAcknowledgedTime',
        'ack_state': 'ackState',
        'perceived_severity': 'perceivedSeverity',
        'event_time': 'eventTime',
        'event_type': 'eventType',
        'fault_type': 'faultType',
        'probable_cause': 'probableCause',
        'is_root_cause': 'isRootCause',
        'correlated_alarm_ids': 'correlatedAlarmIds',
        'fault_details': 'faultDetails',
        'links': '_links'
    }

    def __init__(self, id=None, managed_object_id=None, vnfc_instance_ids=None, root_cause_faulty_resource=None, alarm_raised_time=None, alarm_changed_time=None, alarm_cleared_time=None, alarm_acknowledged_time=None, ack_state=None, perceived_severity=None, event_time=None, event_type=None, fault_type=None, probable_cause=None, is_root_cause=None, correlated_alarm_ids=None, fault_details=None, links=None):  # noqa: E501
        """Alarm - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._managed_object_id = None
        self._vnfc_instance_ids = None
        self._root_cause_faulty_resource = None
        self._alarm_raised_time = None
        self._alarm_changed_time = None
        self._alarm_cleared_time = None
        self._alarm_acknowledged_time = None
        self._ack_state = None
        self._perceived_severity = None
        self._event_time = None
        self._event_type = None
        self._fault_type = None
        self._probable_cause = None
        self._is_root_cause = None
        self._correlated_alarm_ids = None
        self._fault_details = None
        self._links = None
        self.discriminator = None
        self.id = id
        self.managed_object_id = managed_object_id
        if vnfc_instance_ids is not None:
            self.vnfc_instance_ids = vnfc_instance_ids
        if root_cause_faulty_resource is not None:
            self.root_cause_faulty_resource = root_cause_faulty_resource
        self.alarm_raised_time = alarm_raised_time
        if alarm_changed_time is not None:
            self.alarm_changed_time = alarm_changed_time
        if alarm_cleared_time is not None:
            self.alarm_cleared_time = alarm_cleared_time
        if alarm_acknowledged_time is not None:
            self.alarm_acknowledged_time = alarm_acknowledged_time
        self.ack_state = ack_state
        self.perceived_severity = perceived_severity
        self.event_time = event_time
        self.event_type = event_type
        if fault_type is not None:
            self.fault_type = fault_type
        self.probable_cause = probable_cause
        self.is_root_cause = is_root_cause
        if correlated_alarm_ids is not None:
            self.correlated_alarm_ids = correlated_alarm_ids
        if fault_details is not None:
            self.fault_details = fault_details
        self.links = links

    @property
    def id(self):
        """Gets the id of this Alarm.  # noqa: E501


        :return: The id of this Alarm.  # noqa: E501
        :rtype: Identifier
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Alarm.


        :param id: The id of this Alarm.  # noqa: E501
        :type: Identifier
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def managed_object_id(self):
        """Gets the managed_object_id of this Alarm.  # noqa: E501


        :return: The managed_object_id of this Alarm.  # noqa: E501
        :rtype: Identifier
        """
        return self._managed_object_id

    @managed_object_id.setter
    def managed_object_id(self, managed_object_id):
        """Sets the managed_object_id of this Alarm.


        :param managed_object_id: The managed_object_id of this Alarm.  # noqa: E501
        :type: Identifier
        """
        if managed_object_id is None:
            print("WARNING: Invalid value for the required field `managed_object_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `managed_object_id`, must not be `None`")  # noqa: E501

        self._managed_object_id = managed_object_id

    @property
    def vnfc_instance_ids(self):
        """Gets the vnfc_instance_ids of this Alarm.  # noqa: E501

        Identifiers of the affected VNFC instances.   # noqa: E501

        :return: The vnfc_instance_ids of this Alarm.  # noqa: E501
        :rtype: list[IdentifierInVnf]
        """
        return self._vnfc_instance_ids

    @vnfc_instance_ids.setter
    def vnfc_instance_ids(self, vnfc_instance_ids):
        """Sets the vnfc_instance_ids of this Alarm.

        Identifiers of the affected VNFC instances.   # noqa: E501

        :param vnfc_instance_ids: The vnfc_instance_ids of this Alarm.  # noqa: E501
        :type: list[IdentifierInVnf]
        """

        self._vnfc_instance_ids = vnfc_instance_ids

    @property
    def root_cause_faulty_resource(self):
        """Gets the root_cause_faulty_resource of this Alarm.  # noqa: E501


        :return: The root_cause_faulty_resource of this Alarm.  # noqa: E501
        :rtype: FaultyResourceInfo
        """
        return self._root_cause_faulty_resource

    @root_cause_faulty_resource.setter
    def root_cause_faulty_resource(self, root_cause_faulty_resource):
        """Sets the root_cause_faulty_resource of this Alarm.


        :param root_cause_faulty_resource: The root_cause_faulty_resource of this Alarm.  # noqa: E501
        :type: FaultyResourceInfo
        """

        self._root_cause_faulty_resource = root_cause_faulty_resource

    @property
    def alarm_raised_time(self):
        """Gets the alarm_raised_time of this Alarm.  # noqa: E501


        :return: The alarm_raised_time of this Alarm.  # noqa: E501
        :rtype: datetime
        """
        return self._alarm_raised_time

    @alarm_raised_time.setter
    def alarm_raised_time(self, alarm_raised_time):
        """Sets the alarm_raised_time of this Alarm.


        :param alarm_raised_time: The alarm_raised_time of this Alarm.  # noqa: E501
        :type: datetime
        """
        if alarm_raised_time is None:
            print("WARNING: Invalid value for the required field `alarm_raised_time`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `alarm_raised_time`, must not be `None`")  # noqa: E501

        self._alarm_raised_time = alarm_raised_time

    @property
    def alarm_changed_time(self):
        """Gets the alarm_changed_time of this Alarm.  # noqa: E501


        :return: The alarm_changed_time of this Alarm.  # noqa: E501
        :rtype: datetime
        """
        return self._alarm_changed_time

    @alarm_changed_time.setter
    def alarm_changed_time(self, alarm_changed_time):
        """Sets the alarm_changed_time of this Alarm.


        :param alarm_changed_time: The alarm_changed_time of this Alarm.  # noqa: E501
        :type: datetime
        """

        self._alarm_changed_time = alarm_changed_time

    @property
    def alarm_cleared_time(self):
        """Gets the alarm_cleared_time of this Alarm.  # noqa: E501


        :return: The alarm_cleared_time of this Alarm.  # noqa: E501
        :rtype: datetime
        """
        return self._alarm_cleared_time

    @alarm_cleared_time.setter
    def alarm_cleared_time(self, alarm_cleared_time):
        """Sets the alarm_cleared_time of this Alarm.


        :param alarm_cleared_time: The alarm_cleared_time of this Alarm.  # noqa: E501
        :type: datetime
        """

        self._alarm_cleared_time = alarm_cleared_time

    @property
    def alarm_acknowledged_time(self):
        """Gets the alarm_acknowledged_time of this Alarm.  # noqa: E501


        :return: The alarm_acknowledged_time of this Alarm.  # noqa: E501
        :rtype: datetime
        """
        return self._alarm_acknowledged_time

    @alarm_acknowledged_time.setter
    def alarm_acknowledged_time(self, alarm_acknowledged_time):
        """Sets the alarm_acknowledged_time of this Alarm.


        :param alarm_acknowledged_time: The alarm_acknowledged_time of this Alarm.  # noqa: E501
        :type: datetime
        """

        self._alarm_acknowledged_time = alarm_acknowledged_time

    @property
    def ack_state(self):
        """Gets the ack_state of this Alarm.  # noqa: E501

        Acknowledgement state of the alarm. Permitted values: * UNACKNOWLEDGED * ACKNOWLEDGED.   # noqa: E501

        :return: The ack_state of this Alarm.  # noqa: E501
        :rtype: str
        """
        return self._ack_state

    @ack_state.setter
    def ack_state(self, ack_state):
        """Sets the ack_state of this Alarm.

        Acknowledgement state of the alarm. Permitted values: * UNACKNOWLEDGED * ACKNOWLEDGED.   # noqa: E501

        :param ack_state: The ack_state of this Alarm.  # noqa: E501
        :type: str
        """
        if ack_state is None:
            print("WARNING: Invalid value for the required field `ack_state`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `ack_state`, must not be `None`")  # noqa: E501
        allowed_values = ["UNACKNOWLEDGED", "ACKNOWLEDGED"]  # noqa: E501
        if ack_state is not None and ack_state not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `ack_state` ({0}), must be one of {1}"  # noqa: E501
                .format(ack_state, allowed_values)
            )

        self._ack_state = ack_state

    @property
    def perceived_severity(self):
        """Gets the perceived_severity of this Alarm.  # noqa: E501


        :return: The perceived_severity of this Alarm.  # noqa: E501
        :rtype: PerceivedSeverityType
        """
        return self._perceived_severity

    @perceived_severity.setter
    def perceived_severity(self, perceived_severity):
        """Sets the perceived_severity of this Alarm.


        :param perceived_severity: The perceived_severity of this Alarm.  # noqa: E501
        :type: PerceivedSeverityType
        """
        if perceived_severity is None:
            print("WARNING: Invalid value for the required field `perceived_severity`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `perceived_severity`, must not be `None`")  # noqa: E501

        self._perceived_severity = perceived_severity

    @property
    def event_time(self):
        """Gets the event_time of this Alarm.  # noqa: E501


        :return: The event_time of this Alarm.  # noqa: E501
        :rtype: datetime
        """
        return self._event_time

    @event_time.setter
    def event_time(self, event_time):
        """Sets the event_time of this Alarm.


        :param event_time: The event_time of this Alarm.  # noqa: E501
        :type: datetime
        """
        if event_time is None:
            print("WARNING: Invalid value for the required field `event_time`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `event_time`, must not be `None`")  # noqa: E501

        self._event_time = event_time

    @property
    def event_type(self):
        """Gets the event_type of this Alarm.  # noqa: E501


        :return: The event_type of this Alarm.  # noqa: E501
        :rtype: EventType
        """
        return self._event_type

    @event_type.setter
    def event_type(self, event_type):
        """Sets the event_type of this Alarm.


        :param event_type: The event_type of this Alarm.  # noqa: E501
        :type: EventType
        """
        if event_type is None:
            print("WARNING: Invalid value for the required field `event_type`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `event_type`, must not be `None`")  # noqa: E501

        self._event_type = event_type

    @property
    def fault_type(self):
        """Gets the fault_type of this Alarm.  # noqa: E501

        Additional information to clarify the type of the fault.   # noqa: E501

        :return: The fault_type of this Alarm.  # noqa: E501
        :rtype: str
        """
        return self._fault_type

    @fault_type.setter
    def fault_type(self, fault_type):
        """Sets the fault_type of this Alarm.

        Additional information to clarify the type of the fault.   # noqa: E501

        :param fault_type: The fault_type of this Alarm.  # noqa: E501
        :type: str
        """

        self._fault_type = fault_type

    @property
    def probable_cause(self):
        """Gets the probable_cause of this Alarm.  # noqa: E501

        Information about the probable cause of the fault.   # noqa: E501

        :return: The probable_cause of this Alarm.  # noqa: E501
        :rtype: str
        """
        return self._probable_cause

    @probable_cause.setter
    def probable_cause(self, probable_cause):
        """Sets the probable_cause of this Alarm.

        Information about the probable cause of the fault.   # noqa: E501

        :param probable_cause: The probable_cause of this Alarm.  # noqa: E501
        :type: str
        """
        if probable_cause is None:
            print("WARNING: Invalid value for the required field `probable_cause`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `probable_cause`, must not be `None`")  # noqa: E501

        self._probable_cause = probable_cause

    @property
    def is_root_cause(self):
        """Gets the is_root_cause of this Alarm.  # noqa: E501

        Attribute indicating if this fault is the root for other correlated alarms. If true, then the alarms listed in the attribute \"correlatedAlarmId\" are caused by this fault.   # noqa: E501

        :return: The is_root_cause of this Alarm.  # noqa: E501
        :rtype: bool
        """
        return self._is_root_cause

    @is_root_cause.setter
    def is_root_cause(self, is_root_cause):
        """Sets the is_root_cause of this Alarm.

        Attribute indicating if this fault is the root for other correlated alarms. If true, then the alarms listed in the attribute \"correlatedAlarmId\" are caused by this fault.   # noqa: E501

        :param is_root_cause: The is_root_cause of this Alarm.  # noqa: E501
        :type: bool
        """
        if is_root_cause is None:
            print("WARNING: Invalid value for the required field `is_root_cause`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `is_root_cause`, must not be `None`")  # noqa: E501

        self._is_root_cause = is_root_cause

    @property
    def correlated_alarm_ids(self):
        """Gets the correlated_alarm_ids of this Alarm.  # noqa: E501

        List of identifiers of other alarms correlated to this fault.   # noqa: E501

        :return: The correlated_alarm_ids of this Alarm.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._correlated_alarm_ids

    @correlated_alarm_ids.setter
    def correlated_alarm_ids(self, correlated_alarm_ids):
        """Sets the correlated_alarm_ids of this Alarm.

        List of identifiers of other alarms correlated to this fault.   # noqa: E501

        :param correlated_alarm_ids: The correlated_alarm_ids of this Alarm.  # noqa: E501
        :type: list[Identifier]
        """

        self._correlated_alarm_ids = correlated_alarm_ids

    @property
    def fault_details(self):
        """Gets the fault_details of this Alarm.  # noqa: E501

        Provides additional information about the fault.   # noqa: E501

        :return: The fault_details of this Alarm.  # noqa: E501
        :rtype: list[str]
        """
        return self._fault_details

    @fault_details.setter
    def fault_details(self, fault_details):
        """Sets the fault_details of this Alarm.

        Provides additional information about the fault.   # noqa: E501

        :param fault_details: The fault_details of this Alarm.  # noqa: E501
        :type: list[str]
        """

        self._fault_details = fault_details

    @property
    def links(self):
        """Gets the links of this Alarm.  # noqa: E501


        :return: The links of this Alarm.  # noqa: E501
        :rtype: AlarmLinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this Alarm.


        :param links: The links of this Alarm.  # noqa: E501
        :type: AlarmLinks
        """
        if links is None:
            print("WARNING: Invalid value for the required field `links`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `links`, must not be `None`")  # noqa: E501

        self._links = links

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Alarm, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Alarm):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
