# coding: utf-8

"""
    SOL003 - VNF Fault Management interface

    SOL003 - VNF Fault Management interface  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ApiVersionInformation(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'uri_prefix': 'str',
        'api_versions': 'list[ApiVersionInformationApiVersions]'
    }

    attribute_map = {
        'uri_prefix': 'uriPrefix',
        'api_versions': 'apiVersions'
    }

    def __init__(self, uri_prefix=None, api_versions=None):  # noqa: E501
        """ApiVersionInformation - a model defined in Swagger"""  # noqa: E501
        self._uri_prefix = None
        self._api_versions = None
        self.discriminator = None
        self.uri_prefix = uri_prefix
        self.api_versions = api_versions

    @property
    def uri_prefix(self):
        """Gets the uri_prefix of this ApiVersionInformation.  # noqa: E501

        Specifies the URI prefix for the API, in the following form {apiRoot}/{apiName}/{apiMajorVersion}/.   # noqa: E501

        :return: The uri_prefix of this ApiVersionInformation.  # noqa: E501
        :rtype: str
        """
        return self._uri_prefix

    @uri_prefix.setter
    def uri_prefix(self, uri_prefix):
        """Sets the uri_prefix of this ApiVersionInformation.

        Specifies the URI prefix for the API, in the following form {apiRoot}/{apiName}/{apiMajorVersion}/.   # noqa: E501

        :param uri_prefix: The uri_prefix of this ApiVersionInformation.  # noqa: E501
        :type: str
        """
        if uri_prefix is None:
            print("WARNING: Invalid value for the required field `uri_prefix`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `uri_prefix`, must not be `None`")  # noqa: E501

        self._uri_prefix = uri_prefix

    @property
    def api_versions(self):
        """Gets the api_versions of this ApiVersionInformation.  # noqa: E501

        Version(s) supported for the API signaled by the uriPrefix attribute.   # noqa: E501

        :return: The api_versions of this ApiVersionInformation.  # noqa: E501
        :rtype: list[ApiVersionInformationApiVersions]
        """
        return self._api_versions

    @api_versions.setter
    def api_versions(self, api_versions):
        """Sets the api_versions of this ApiVersionInformation.

        Version(s) supported for the API signaled by the uriPrefix attribute.   # noqa: E501

        :param api_versions: The api_versions of this ApiVersionInformation.  # noqa: E501
        :type: list[ApiVersionInformationApiVersions]
        """
        if api_versions is None:
            print("WARNING: Invalid value for the required field `api_versions`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `api_versions`, must not be `None`")  # noqa: E501

        self._api_versions = api_versions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ApiVersionInformation, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiVersionInformation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
