# coding: utf-8

"""
    SOL003 - VNF Fault Management interface

    SOL003 - VNF Fault Management interface  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class FmNotificationsFilter(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnf_instance_subscription_filter': 'VnfInstanceSubscriptionFilter',
        'notification_types': 'str',
        'faulty_resource_types': 'list[FaultyResourceType]',
        'perceived_severities': 'list[PerceivedSeverityType]',
        'event_types': 'list[EventType]',
        'probable_causes': 'list[str]'
    }

    attribute_map = {
        'vnf_instance_subscription_filter': 'vnfInstanceSubscriptionFilter',
        'notification_types': 'notificationTypes',
        'faulty_resource_types': 'faultyResourceTypes',
        'perceived_severities': 'perceivedSeverities',
        'event_types': 'eventTypes',
        'probable_causes': 'probableCauses'
    }

    def __init__(self, vnf_instance_subscription_filter=None, notification_types=None, faulty_resource_types=None, perceived_severities=None, event_types=None, probable_causes=None):  # noqa: E501
        """FmNotificationsFilter - a model defined in Swagger"""  # noqa: E501
        self._vnf_instance_subscription_filter = None
        self._notification_types = None
        self._faulty_resource_types = None
        self._perceived_severities = None
        self._event_types = None
        self._probable_causes = None
        self.discriminator = None
        if vnf_instance_subscription_filter is not None:
            self.vnf_instance_subscription_filter = vnf_instance_subscription_filter
        if notification_types is not None:
            self.notification_types = notification_types
        if faulty_resource_types is not None:
            self.faulty_resource_types = faulty_resource_types
        if perceived_severities is not None:
            self.perceived_severities = perceived_severities
        if event_types is not None:
            self.event_types = event_types
        if probable_causes is not None:
            self.probable_causes = probable_causes

    @property
    def vnf_instance_subscription_filter(self):
        """Gets the vnf_instance_subscription_filter of this FmNotificationsFilter.  # noqa: E501


        :return: The vnf_instance_subscription_filter of this FmNotificationsFilter.  # noqa: E501
        :rtype: VnfInstanceSubscriptionFilter
        """
        return self._vnf_instance_subscription_filter

    @vnf_instance_subscription_filter.setter
    def vnf_instance_subscription_filter(self, vnf_instance_subscription_filter):
        """Sets the vnf_instance_subscription_filter of this FmNotificationsFilter.


        :param vnf_instance_subscription_filter: The vnf_instance_subscription_filter of this FmNotificationsFilter.  # noqa: E501
        :type: VnfInstanceSubscriptionFilter
        """

        self._vnf_instance_subscription_filter = vnf_instance_subscription_filter

    @property
    def notification_types(self):
        """Gets the notification_types of this FmNotificationsFilter.  # noqa: E501

        Match particular notification types. Permitted values: * AlarmNotification * AlarmClearedNotification * AlarmListRebuiltNotification The permitted values of the \"notificationTypes\" attribute are spelled exactly as the names of the notification types to facilitate automated code generation systems.   # noqa: E501

        :return: The notification_types of this FmNotificationsFilter.  # noqa: E501
        :rtype: str
        """
        return self._notification_types

    @notification_types.setter
    def notification_types(self, notification_types):
        """Sets the notification_types of this FmNotificationsFilter.

        Match particular notification types. Permitted values: * AlarmNotification * AlarmClearedNotification * AlarmListRebuiltNotification The permitted values of the \"notificationTypes\" attribute are spelled exactly as the names of the notification types to facilitate automated code generation systems.   # noqa: E501

        :param notification_types: The notification_types of this FmNotificationsFilter.  # noqa: E501
        :type: str
        """
        allowed_values = ["AlarmNotification", "AlarmClearedNotification", "AlarmListRebuiltNotification"]  # noqa: E501
        if notification_types is not None and notification_types not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `notification_types` ({0}), must be one of {1}"  # noqa: E501
                .format(notification_types, allowed_values)
            )

        self._notification_types = notification_types

    @property
    def faulty_resource_types(self):
        """Gets the faulty_resource_types of this FmNotificationsFilter.  # noqa: E501

        Match VNF alarms with a faulty resource type listed in this attribute.   # noqa: E501

        :return: The faulty_resource_types of this FmNotificationsFilter.  # noqa: E501
        :rtype: list[FaultyResourceType]
        """
        return self._faulty_resource_types

    @faulty_resource_types.setter
    def faulty_resource_types(self, faulty_resource_types):
        """Sets the faulty_resource_types of this FmNotificationsFilter.

        Match VNF alarms with a faulty resource type listed in this attribute.   # noqa: E501

        :param faulty_resource_types: The faulty_resource_types of this FmNotificationsFilter.  # noqa: E501
        :type: list[FaultyResourceType]
        """

        self._faulty_resource_types = faulty_resource_types

    @property
    def perceived_severities(self):
        """Gets the perceived_severities of this FmNotificationsFilter.  # noqa: E501

        Match VNF alarms with a perceived severity listed in this attribute.   # noqa: E501

        :return: The perceived_severities of this FmNotificationsFilter.  # noqa: E501
        :rtype: list[PerceivedSeverityType]
        """
        return self._perceived_severities

    @perceived_severities.setter
    def perceived_severities(self, perceived_severities):
        """Sets the perceived_severities of this FmNotificationsFilter.

        Match VNF alarms with a perceived severity listed in this attribute.   # noqa: E501

        :param perceived_severities: The perceived_severities of this FmNotificationsFilter.  # noqa: E501
        :type: list[PerceivedSeverityType]
        """

        self._perceived_severities = perceived_severities

    @property
    def event_types(self):
        """Gets the event_types of this FmNotificationsFilter.  # noqa: E501

        Match VNF alarms with an event type listed in this attribute.   # noqa: E501

        :return: The event_types of this FmNotificationsFilter.  # noqa: E501
        :rtype: list[EventType]
        """
        return self._event_types

    @event_types.setter
    def event_types(self, event_types):
        """Sets the event_types of this FmNotificationsFilter.

        Match VNF alarms with an event type listed in this attribute.   # noqa: E501

        :param event_types: The event_types of this FmNotificationsFilter.  # noqa: E501
        :type: list[EventType]
        """

        self._event_types = event_types

    @property
    def probable_causes(self):
        """Gets the probable_causes of this FmNotificationsFilter.  # noqa: E501

        Match VNF alarms with a probable cause listed in this attribute.   # noqa: E501

        :return: The probable_causes of this FmNotificationsFilter.  # noqa: E501
        :rtype: list[str]
        """
        return self._probable_causes

    @probable_causes.setter
    def probable_causes(self, probable_causes):
        """Sets the probable_causes of this FmNotificationsFilter.

        Match VNF alarms with a probable cause listed in this attribute.   # noqa: E501

        :param probable_causes: The probable_causes of this FmNotificationsFilter.  # noqa: E501
        :type: list[str]
        """

        self._probable_causes = probable_causes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FmNotificationsFilter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FmNotificationsFilter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
