# coding: utf-8

"""
    SOL003 - VNF Fault Management interface

    SOL003 - VNF Fault Management interface  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ResourceHandle(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vim_connection_id': 'Identifier',
        'resource_provider_id': 'Identifier',
        'resource_id': 'IdentifierInVim',
        'vim_level_resource_type': 'str'
    }

    attribute_map = {
        'vim_connection_id': 'vimConnectionId',
        'resource_provider_id': 'resourceProviderId',
        'resource_id': 'resourceId',
        'vim_level_resource_type': 'vimLevelResourceType'
    }

    def __init__(self, vim_connection_id=None, resource_provider_id=None, resource_id=None, vim_level_resource_type=None):  # noqa: E501
        """ResourceHandle - a model defined in Swagger"""  # noqa: E501
        self._vim_connection_id = None
        self._resource_provider_id = None
        self._resource_id = None
        self._vim_level_resource_type = None
        self.discriminator = None
        if vim_connection_id is not None:
            self.vim_connection_id = vim_connection_id
        if resource_provider_id is not None:
            self.resource_provider_id = resource_provider_id
        self.resource_id = resource_id
        if vim_level_resource_type is not None:
            self.vim_level_resource_type = vim_level_resource_type

    @property
    def vim_connection_id(self):
        """Gets the vim_connection_id of this ResourceHandle.  # noqa: E501


        :return: The vim_connection_id of this ResourceHandle.  # noqa: E501
        :rtype: Identifier
        """
        return self._vim_connection_id

    @vim_connection_id.setter
    def vim_connection_id(self, vim_connection_id):
        """Sets the vim_connection_id of this ResourceHandle.


        :param vim_connection_id: The vim_connection_id of this ResourceHandle.  # noqa: E501
        :type: Identifier
        """

        self._vim_connection_id = vim_connection_id

    @property
    def resource_provider_id(self):
        """Gets the resource_provider_id of this ResourceHandle.  # noqa: E501


        :return: The resource_provider_id of this ResourceHandle.  # noqa: E501
        :rtype: Identifier
        """
        return self._resource_provider_id

    @resource_provider_id.setter
    def resource_provider_id(self, resource_provider_id):
        """Sets the resource_provider_id of this ResourceHandle.


        :param resource_provider_id: The resource_provider_id of this ResourceHandle.  # noqa: E501
        :type: Identifier
        """

        self._resource_provider_id = resource_provider_id

    @property
    def resource_id(self):
        """Gets the resource_id of this ResourceHandle.  # noqa: E501


        :return: The resource_id of this ResourceHandle.  # noqa: E501
        :rtype: IdentifierInVim
        """
        return self._resource_id

    @resource_id.setter
    def resource_id(self, resource_id):
        """Sets the resource_id of this ResourceHandle.


        :param resource_id: The resource_id of this ResourceHandle.  # noqa: E501
        :type: IdentifierInVim
        """
        if resource_id is None:
            print("WARNING: Invalid value for the required field `resource_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `resource_id`, must not be `None`")  # noqa: E501

        self._resource_id = resource_id

    @property
    def vim_level_resource_type(self):
        """Gets the vim_level_resource_type of this ResourceHandle.  # noqa: E501

        The value set of the \"vimLevelResourceType\" attribute is within the scope of the VIM or the resource provider and can be used as information that complements the ResourceHandle. This value set is different from the value set of the \"type\" attribute in the ResourceDefinition (refer to clause 9.5.3.2 in SOL003).   # noqa: E501

        :return: The vim_level_resource_type of this ResourceHandle.  # noqa: E501
        :rtype: str
        """
        return self._vim_level_resource_type

    @vim_level_resource_type.setter
    def vim_level_resource_type(self, vim_level_resource_type):
        """Sets the vim_level_resource_type of this ResourceHandle.

        The value set of the \"vimLevelResourceType\" attribute is within the scope of the VIM or the resource provider and can be used as information that complements the ResourceHandle. This value set is different from the value set of the \"type\" attribute in the ResourceDefinition (refer to clause 9.5.3.2 in SOL003).   # noqa: E501

        :param vim_level_resource_type: The vim_level_resource_type of this ResourceHandle.  # noqa: E501
        :type: str
        """

        self._vim_level_resource_type = vim_level_resource_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ResourceHandle, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ResourceHandle):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
