# coding: utf-8

"""
    SOL003 - VNF Fault Management interface

    SOL003 - VNF Fault Management interface  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfInstanceSubscriptionFilter(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnfd_ids': 'list[Identifier]',
        'vnf_products_from_providers': 'list[VnfInstanceSubscriptionFilterVnfProductsFromProviders]',
        'vnf_instance_ids': 'list[Identifier]',
        'vnf_instance_names': 'list[str]'
    }

    attribute_map = {
        'vnfd_ids': 'vnfdIds',
        'vnf_products_from_providers': 'vnfProductsFromProviders',
        'vnf_instance_ids': 'vnfInstanceIds',
        'vnf_instance_names': 'vnfInstanceNames'
    }

    def __init__(self, vnfd_ids=None, vnf_products_from_providers=None, vnf_instance_ids=None, vnf_instance_names=None):  # noqa: E501
        """VnfInstanceSubscriptionFilter - a model defined in Swagger"""  # noqa: E501
        self._vnfd_ids = None
        self._vnf_products_from_providers = None
        self._vnf_instance_ids = None
        self._vnf_instance_names = None
        self.discriminator = None
        if vnfd_ids is not None:
            self.vnfd_ids = vnfd_ids
        if vnf_products_from_providers is not None:
            self.vnf_products_from_providers = vnf_products_from_providers
        if vnf_instance_ids is not None:
            self.vnf_instance_ids = vnf_instance_ids
        if vnf_instance_names is not None:
            self.vnf_instance_names = vnf_instance_names

    @property
    def vnfd_ids(self):
        """Gets the vnfd_ids of this VnfInstanceSubscriptionFilter.  # noqa: E501

        If present, match VNF instances that were created based on a VNFD identified by one of the vnfdId values listed in this attribute. The attributes \"vnfdIds\" and \"vnfProductsFromProviders\" are alternatives to reference to VNF instances that are based on certain VNFDs in a filter. They should not be used both in the same filter instance, but one alternative should be chosen.   # noqa: E501

        :return: The vnfd_ids of this VnfInstanceSubscriptionFilter.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._vnfd_ids

    @vnfd_ids.setter
    def vnfd_ids(self, vnfd_ids):
        """Sets the vnfd_ids of this VnfInstanceSubscriptionFilter.

        If present, match VNF instances that were created based on a VNFD identified by one of the vnfdId values listed in this attribute. The attributes \"vnfdIds\" and \"vnfProductsFromProviders\" are alternatives to reference to VNF instances that are based on certain VNFDs in a filter. They should not be used both in the same filter instance, but one alternative should be chosen.   # noqa: E501

        :param vnfd_ids: The vnfd_ids of this VnfInstanceSubscriptionFilter.  # noqa: E501
        :type: list[Identifier]
        """

        self._vnfd_ids = vnfd_ids

    @property
    def vnf_products_from_providers(self):
        """Gets the vnf_products_from_providers of this VnfInstanceSubscriptionFilter.  # noqa: E501

        If present, match VNF instances that belong to VNF products from certain providers. The attributes \"vnfdIds\" and \"vnfProductsFromProviders\" are alternatives to reference to VNF instances that are based on certain VNFDs in a filter. They should not be used both in the same filter instance, but one alternative should be chosen.   # noqa: E501

        :return: The vnf_products_from_providers of this VnfInstanceSubscriptionFilter.  # noqa: E501
        :rtype: list[VnfInstanceSubscriptionFilterVnfProductsFromProviders]
        """
        return self._vnf_products_from_providers

    @vnf_products_from_providers.setter
    def vnf_products_from_providers(self, vnf_products_from_providers):
        """Sets the vnf_products_from_providers of this VnfInstanceSubscriptionFilter.

        If present, match VNF instances that belong to VNF products from certain providers. The attributes \"vnfdIds\" and \"vnfProductsFromProviders\" are alternatives to reference to VNF instances that are based on certain VNFDs in a filter. They should not be used both in the same filter instance, but one alternative should be chosen.   # noqa: E501

        :param vnf_products_from_providers: The vnf_products_from_providers of this VnfInstanceSubscriptionFilter.  # noqa: E501
        :type: list[VnfInstanceSubscriptionFilterVnfProductsFromProviders]
        """

        self._vnf_products_from_providers = vnf_products_from_providers

    @property
    def vnf_instance_ids(self):
        """Gets the vnf_instance_ids of this VnfInstanceSubscriptionFilter.  # noqa: E501

        If present, match VNF instances with an instance identifier listed in this attribute. The attributes \"vnfInstanceIds\" and \"vnfInstanceNames\" are alternatives to reference to particular VNF Instances in a filter. They should not be used both in the same filter instance, but one alternative should be chosen.   # noqa: E501

        :return: The vnf_instance_ids of this VnfInstanceSubscriptionFilter.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._vnf_instance_ids

    @vnf_instance_ids.setter
    def vnf_instance_ids(self, vnf_instance_ids):
        """Sets the vnf_instance_ids of this VnfInstanceSubscriptionFilter.

        If present, match VNF instances with an instance identifier listed in this attribute. The attributes \"vnfInstanceIds\" and \"vnfInstanceNames\" are alternatives to reference to particular VNF Instances in a filter. They should not be used both in the same filter instance, but one alternative should be chosen.   # noqa: E501

        :param vnf_instance_ids: The vnf_instance_ids of this VnfInstanceSubscriptionFilter.  # noqa: E501
        :type: list[Identifier]
        """

        self._vnf_instance_ids = vnf_instance_ids

    @property
    def vnf_instance_names(self):
        """Gets the vnf_instance_names of this VnfInstanceSubscriptionFilter.  # noqa: E501

        If present, match VNF instances with a VNF Instance Name listed in this attribute. The attributes \"vnfInstanceIds\" and \"vnfInstanceNames\" are alternatives to reference to particular VNF Instances in a filter. They should not be used both in the same filter instance, but one alternative should be chosen.   # noqa: E501

        :return: The vnf_instance_names of this VnfInstanceSubscriptionFilter.  # noqa: E501
        :rtype: list[str]
        """
        return self._vnf_instance_names

    @vnf_instance_names.setter
    def vnf_instance_names(self, vnf_instance_names):
        """Sets the vnf_instance_names of this VnfInstanceSubscriptionFilter.

        If present, match VNF instances with a VNF Instance Name listed in this attribute. The attributes \"vnfInstanceIds\" and \"vnfInstanceNames\" are alternatives to reference to particular VNF Instances in a filter. They should not be used both in the same filter instance, but one alternative should be chosen.   # noqa: E501

        :param vnf_instance_names: The vnf_instance_names of this VnfInstanceSubscriptionFilter.  # noqa: E501
        :type: list[str]
        """

        self._vnf_instance_names = vnf_instance_names

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfInstanceSubscriptionFilter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfInstanceSubscriptionFilter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
