# coding: utf-8

"""
    SOL003 - VNF Fault Management interface

    SOL003 - VNF Fault Management interface  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfInstanceSubscriptionFilterVersions(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnf_software_version': 'Version',
        'vnfd_versions': 'list[Version]'
    }

    attribute_map = {
        'vnf_software_version': 'vnfSoftwareVersion',
        'vnfd_versions': 'vnfdVersions'
    }

    def __init__(self, vnf_software_version=None, vnfd_versions=None):  # noqa: E501
        """VnfInstanceSubscriptionFilterVersions - a model defined in Swagger"""  # noqa: E501
        self._vnf_software_version = None
        self._vnfd_versions = None
        self.discriminator = None
        self.vnf_software_version = vnf_software_version
        if vnfd_versions is not None:
            self.vnfd_versions = vnfd_versions

    @property
    def vnf_software_version(self):
        """Gets the vnf_software_version of this VnfInstanceSubscriptionFilterVersions.  # noqa: E501


        :return: The vnf_software_version of this VnfInstanceSubscriptionFilterVersions.  # noqa: E501
        :rtype: Version
        """
        return self._vnf_software_version

    @vnf_software_version.setter
    def vnf_software_version(self, vnf_software_version):
        """Sets the vnf_software_version of this VnfInstanceSubscriptionFilterVersions.


        :param vnf_software_version: The vnf_software_version of this VnfInstanceSubscriptionFilterVersions.  # noqa: E501
        :type: Version
        """
        if vnf_software_version is None:
            print("WARNING: Invalid value for the required field `vnf_software_version`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_software_version`, must not be `None`")  # noqa: E501

        self._vnf_software_version = vnf_software_version

    @property
    def vnfd_versions(self):
        """Gets the vnfd_versions of this VnfInstanceSubscriptionFilterVersions.  # noqa: E501

        If present, match VNF instances that belong to VNF products with certain VNFD versions, a certain software version and a certain product name, from one particular provider.   # noqa: E501

        :return: The vnfd_versions of this VnfInstanceSubscriptionFilterVersions.  # noqa: E501
        :rtype: list[Version]
        """
        return self._vnfd_versions

    @vnfd_versions.setter
    def vnfd_versions(self, vnfd_versions):
        """Sets the vnfd_versions of this VnfInstanceSubscriptionFilterVersions.

        If present, match VNF instances that belong to VNF products with certain VNFD versions, a certain software version and a certain product name, from one particular provider.   # noqa: E501

        :param vnfd_versions: The vnfd_versions of this VnfInstanceSubscriptionFilterVersions.  # noqa: E501
        :type: list[Version]
        """

        self._vnfd_versions = vnfd_versions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfInstanceSubscriptionFilterVersions, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfInstanceSubscriptionFilterVersions):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
