# coding: utf-8

"""
    SOL003 - VNF Fault Management interface

    SOL003 - VNF Fault Management interface  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.3.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfInstanceSubscriptionFilterVnfProducts(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnf_product_name': 'str',
        'versions': 'list[VnfInstanceSubscriptionFilterVersions]'
    }

    attribute_map = {
        'vnf_product_name': 'vnfProductName',
        'versions': 'versions'
    }

    def __init__(self, vnf_product_name=None, versions=None):  # noqa: E501
        """VnfInstanceSubscriptionFilterVnfProducts - a model defined in Swagger"""  # noqa: E501
        self._vnf_product_name = None
        self._versions = None
        self.discriminator = None
        self.vnf_product_name = vnf_product_name
        if versions is not None:
            self.versions = versions

    @property
    def vnf_product_name(self):
        """Gets the vnf_product_name of this VnfInstanceSubscriptionFilterVnfProducts.  # noqa: E501

        Name of the VNF product to match.   # noqa: E501

        :return: The vnf_product_name of this VnfInstanceSubscriptionFilterVnfProducts.  # noqa: E501
        :rtype: str
        """
        return self._vnf_product_name

    @vnf_product_name.setter
    def vnf_product_name(self, vnf_product_name):
        """Sets the vnf_product_name of this VnfInstanceSubscriptionFilterVnfProducts.

        Name of the VNF product to match.   # noqa: E501

        :param vnf_product_name: The vnf_product_name of this VnfInstanceSubscriptionFilterVnfProducts.  # noqa: E501
        :type: str
        """
        if vnf_product_name is None:
            print("WARNING: Invalid value for the required field `vnf_product_name`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_product_name`, must not be `None`")  # noqa: E501

        self._vnf_product_name = vnf_product_name

    @property
    def versions(self):
        """Gets the versions of this VnfInstanceSubscriptionFilterVnfProducts.  # noqa: E501

        If present, match VNF instances that belong to VNF products with certain versions and a certain product name, from one particular provider.   # noqa: E501

        :return: The versions of this VnfInstanceSubscriptionFilterVnfProducts.  # noqa: E501
        :rtype: list[VnfInstanceSubscriptionFilterVersions]
        """
        return self._versions

    @versions.setter
    def versions(self, versions):
        """Sets the versions of this VnfInstanceSubscriptionFilterVnfProducts.

        If present, match VNF instances that belong to VNF products with certain versions and a certain product name, from one particular provider.   # noqa: E501

        :param versions: The versions of this VnfInstanceSubscriptionFilterVnfProducts.  # noqa: E501
        :type: list[VnfInstanceSubscriptionFilterVersions]
        """

        self._versions = versions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfInstanceSubscriptionFilterVnfProducts, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfInstanceSubscriptionFilterVnfProducts):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
