# coding: utf-8

# flake8: noqa

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import
# import VMware SDK package registry   # VMW301
from tca.api.client import __package_dict__   # VMW301
from tca.api.client import __configuration_dict__  # VMW301
from tca.api.client import __api_client_dict__  # VMW301

# import apis into sdk package
from tca.vnflcm.api.default_api import DefaultApi
# import ApiClient
from tca.vnflcm.api_client import ApiClient
from tca.vnflcm.configuration import Configuration
# import models into sdk package
from tca.vnflcm.model.affected_virtual_link import AffectedVirtualLink
from tca.vnflcm.model.affected_virtual_storage import AffectedVirtualStorage
from tca.vnflcm.model.affected_vnfc import AffectedVnfc
from tca.vnflcm.model.api_version_information import ApiVersionInformation
from tca.vnflcm.model.api_version_information_api_versions import ApiVersionInformationApiVersions
from tca.vnflcm.model.boolean import Boolean
from tca.vnflcm.model.cancel_mode_type import CancelModeType
from tca.vnflcm.model.cp_protocol_data import CpProtocolData
from tca.vnflcm.model.cp_protocol_info import CpProtocolInfo
from tca.vnflcm.model.create_vnf_request import CreateVnfRequest
from tca.vnflcm.model.ext_link_port_data import ExtLinkPortData
from tca.vnflcm.model.ext_link_port_info import ExtLinkPortInfo
from tca.vnflcm.model.ext_managed_virtual_link_data import ExtManagedVirtualLinkData
from tca.vnflcm.model.ext_managed_virtual_link_info import ExtManagedVirtualLinkInfo
from tca.vnflcm.model.ext_virtual_link_data import ExtVirtualLinkData
from tca.vnflcm.model.ext_virtual_link_info import ExtVirtualLinkInfo
from tca.vnflcm.model.heal_vnf_request import HealVnfRequest
from tca.vnflcm.model.heal_vnf_request_additional_params import HealVnfRequestAdditionalParams
from tca.vnflcm.model.heal_vnf_request_additional_params_affectedvm import HealVnfRequestAdditionalParamsAffectedvm
from tca.vnflcm.model.identifier import Identifier
from tca.vnflcm.model.identifier_in_vim import IdentifierInVim
from tca.vnflcm.model.identifier_in_vnf import IdentifierInVnf
from tca.vnflcm.model.identifier_in_vnfd import IdentifierInVnfd
from tca.vnflcm.model.identifier_local import IdentifierLocal
from tca.vnflcm.model.instantiate_vnf_request import InstantiateVnfRequest
from tca.vnflcm.model.ip_address import IpAddress
from tca.vnflcm.model.ip_over_ethernet_address_data import IpOverEthernetAddressData
from tca.vnflcm.model.ip_over_ethernet_address_data_address_range import IpOverEthernetAddressDataAddressRange
from tca.vnflcm.model.ip_over_ethernet_address_data_ip_addresses import IpOverEthernetAddressDataIpAddresses
from tca.vnflcm.model.ip_over_ethernet_address_info import IpOverEthernetAddressInfo
from tca.vnflcm.model.ip_over_ethernet_address_info_address_range import IpOverEthernetAddressInfoAddressRange
from tca.vnflcm.model.ip_over_ethernet_address_info_ip_addresses import IpOverEthernetAddressInfoIpAddresses
from tca.vnflcm.model.key_value_pairs import KeyValuePairs
from tca.vnflcm.model.lccn_subscription import LccnSubscription
from tca.vnflcm.model.lccn_subscription_links import LccnSubscriptionLinks
from tca.vnflcm.model.lccn_subscription_request import LccnSubscriptionRequest
from tca.vnflcm.model.lcm_interfaces import LcmInterfaces
from tca.vnflcm.model.lcm_interfaces_parameters import LcmInterfacesParameters
from tca.vnflcm.model.lcm_operation_state_type import LcmOperationStateType
from tca.vnflcm.model.lcm_operation_type import LcmOperationType
from tca.vnflcm.model.lifecycle_change_notifications_filter import LifecycleChangeNotificationsFilter
from tca.vnflcm.model.link import Link
from tca.vnflcm.model.mac_address import MacAddress
from tca.vnflcm.model.meta_data import MetaData
from tca.vnflcm.model.model_date_time import ModelDateTime
from tca.vnflcm.model.monitoring_parameter import MonitoringParameter
from tca.vnflcm.model.operate_vnf_request import OperateVnfRequest
from tca.vnflcm.model.problem_details import ProblemDetails
from tca.vnflcm.model.resource_handle import ResourceHandle
from tca.vnflcm.model.scale_info import ScaleInfo
from tca.vnflcm.model.scale_vnf_request import ScaleVnfRequest
from tca.vnflcm.model.scale_vnf_request_additional_params import ScaleVnfRequestAdditionalParams
from tca.vnflcm.model.scale_vnf_to_level_request import ScaleVnfToLevelRequest
from tca.vnflcm.model.stop_type import StopType
from tca.vnflcm.model.string import String
from tca.vnflcm.model.subscription_authentication import SubscriptionAuthentication
from tca.vnflcm.model.subscription_authentication_params_basic import SubscriptionAuthenticationParamsBasic
from tca.vnflcm.model.subscription_authentication_params_oauth2_client_credentials import SubscriptionAuthenticationParamsOauth2ClientCredentials
from tca.vnflcm.model.terminate_vnf_request import TerminateVnfRequest
from tca.vnflcm.model.terminate_vnf_request_additional_params import TerminateVnfRequestAdditionalParams
from tca.vnflcm.model.uri import Uri
from tca.vnflcm.model.vdu_param import VduParam
from tca.vnflcm.model.version import Version
from tca.vnflcm.model.vim_connection_info import VimConnectionInfo
from tca.vnflcm.model.vim_connection_info_extras import VimConnectionInfoExtras
from tca.vnflcm.model.virtual_storage_resource_info import VirtualStorageResourceInfo
from tca.vnflcm.model.vnf_ext_cp_config import VnfExtCpConfig
from tca.vnflcm.model.vnf_ext_cp_data import VnfExtCpData
from tca.vnflcm.model.vnf_ext_cp_info import VnfExtCpInfo
from tca.vnflcm.model.vnf_info_modifications import VnfInfoModifications
from tca.vnflcm.model.vnf_instance import VnfInstance
from tca.vnflcm.model.vnf_instance_instantiated_vnf_info import VnfInstanceInstantiatedVnfInfo
from tca.vnflcm.model.vnf_instance_links import VnfInstanceLinks
from tca.vnflcm.model.vnf_instance_metadata import VnfInstanceMetadata
from tca.vnflcm.model.vnf_instance_metadata_managed_by import VnfInstanceMetadataManagedBy
from tca.vnflcm.model.vnf_instance_metadata_tags import VnfInstanceMetadataTags
from tca.vnflcm.model.vnf_instance_subscription_filter import VnfInstanceSubscriptionFilter
from tca.vnflcm.model.vnf_instance_subscription_filter_versions import VnfInstanceSubscriptionFilterVersions
from tca.vnflcm.model.vnf_instance_subscription_filter_vnf_products import VnfInstanceSubscriptionFilterVnfProducts
from tca.vnflcm.model.vnf_instance_subscription_filter_vnf_products_from_providers import VnfInstanceSubscriptionFilterVnfProductsFromProviders
from tca.vnflcm.model.vnf_instantiate_request_additional_params import VnfInstantiateRequestAdditionalParams
from tca.vnflcm.model.vnf_lcm_op_occ import VnfLcmOpOcc
from tca.vnflcm.model.vnf_lcm_op_occ_links import VnfLcmOpOccLinks
from tca.vnflcm.model.vnf_lcm_op_occ_resource_changes import VnfLcmOpOccResourceChanges
from tca.vnflcm.model.vnf_link_port_info import VnfLinkPortInfo
from tca.vnflcm.model.vnf_operational_state_type import VnfOperationalStateType
from tca.vnflcm.model.vnf_virtual_link_resource_info import VnfVirtualLinkResourceInfo
from tca.vnflcm.model.vnfc_info_modifications import VnfcInfoModifications
from tca.vnflcm.model.vnfc_resource_info import VnfcResourceInfo
from tca.vnflcm.model.vnfc_resource_info_metadata import VnfcResourceInfoMetadata
from tca.vnflcm.model.vnfc_resource_info_vnfc_cp_info import VnfcResourceInfoVnfcCpInfo

# Update API client Registry   # VMW301
__package_dict__.update({ "tca.vnflcm:DefaultApi": DefaultApi })  # VMW301
__configuration_dict__.update({ "tca.vnflcm": Configuration })  # VMW301
__api_client_dict__.update({ "tca.vnflcm": ApiClient })  # VMW301
