# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from tca.vnflcm.api_client import ApiClient
from tca.api.tca_api import TCAApi

class DefaultApi(TCAApi):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_vnflcm_version_info(self, version, **kwargs):  # noqa: E501
        """Retrieve API version information  # noqa: E501

        The GET method reads API version information. This method shall follow the provisions specified in table 4.6.3.3.3.2-1 for request and response data structures, and response codes. URI query parameters are not supported.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_vnflcm_version_info(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)


        :return: ApiVersionInformation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_vnflcm_version_info_with_http_info(version, **kwargs)  # noqa: E501
        else:
            (data) = self.get_vnflcm_version_info_with_http_info(version, **kwargs)  # noqa: E501
            return data

    def get_vnflcm_version_info_with_http_info(self, version, **kwargs):  # noqa: E501
        """Retrieve API version information  # noqa: E501

        The GET method reads API version information. This method shall follow the provisions specified in table 4.6.3.3.3.2-1 for request and response data structures, and response codes. URI query parameters are not supported.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_vnflcm_version_info_with_http_info(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)


        :return: ApiVersionInformation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_vnflcm_version_info" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `get_vnflcm_version_info`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/api_versions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiVersionInformation',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def subscriptions_get(self, accept, version, **kwargs):  # noqa: E501
        """subscriptions_get  # noqa: E501

        Query Subscription Information. The GET method queries the list of active subscriptions of the functional block that invokes the method. It can be used e.g. for resynchronization after error situations.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_get(accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param str filter: Attribute-based filtering expression according to clause 4.3.2. The VNFM shall support receiving this parameter as part of the URI query string. The NFVO may supply this parameter. All attribute names that appear in the LccnSubscription and in data types referenced from it shall be supported by the VNFM in the filter expression. 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the VNFM if the VNFM supports alternative 2 (paging) according to clause 4.7.2.1 for this resource. 


        :return: list[LccnSubscription]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.subscriptions_get_with_http_info(accept, version, **kwargs)  # noqa: E501
        else:
            (data) = self.subscriptions_get_with_http_info(accept, version, **kwargs)  # noqa: E501
            return data

    def subscriptions_get_with_http_info(self, accept, version, **kwargs):  # noqa: E501
        """subscriptions_get  # noqa: E501

        Query Subscription Information. The GET method queries the list of active subscriptions of the functional block that invokes the method. It can be used e.g. for resynchronization after error situations.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_get_with_http_info(accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param str filter: Attribute-based filtering expression according to clause 4.3.2. The VNFM shall support receiving this parameter as part of the URI query string. The NFVO may supply this parameter. All attribute names that appear in the LccnSubscription and in data types referenced from it shall be supported by the VNFM in the filter expression. 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the VNFM if the VNFM supports alternative 2 (paging) according to clause 4.7.2.1 for this resource. 


        :return: list[LccnSubscription]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['accept', 'version', 'authorization', 'filter', 'nextpage_opaque_marker']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method subscriptions_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `subscriptions_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `subscriptions_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'nextpage_opaque_marker' in params:
            query_params.append(('nextpage_opaque_marker', params['nextpage_opaque_marker']))  # noqa: E501

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/subscriptions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[LccnSubscription]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def subscriptions_post(self, body, accept, content_type, version, **kwargs):  # noqa: E501
        """subscriptions_post  # noqa: E501

        Subscribe. The POST method creates a new subscription. This method shall follow the provisions specified in the tables 5.4.18.3.1-1 and 5.4.18.3.1-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, a new \"Individual subscription\" resource as defined in clause 5.4.3 shall have been created. This method shall not trigger any notification. Creation of two \"Individual subscription\" resources with the same callbackURI and the same filter can result in performance degradation and will provide duplicates of notifications to the NFVO, and might make sense only in very rare use cases. Consequently, the VNFM may either allow creating an \"Individual subscription\" resource if another \"Individual subscription\" resource with the same filter and callbackUri already exists (in which case it shall return the \"201 Created\" response code), or may decide to not create a duplicate \"Individual subscription\" resource (in which case it shall return a \"303 See Other\" response code referencing the existing \"Individual subscription\" resource with the same filter and callbackUri).   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_post(body, accept, content_type, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param LccnSubscriptionRequest body: Details of the subscription to be created.
 (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: LccnSubscription
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.subscriptions_post_with_http_info(body, accept, content_type, version, **kwargs)  # noqa: E501
        else:
            (data) = self.subscriptions_post_with_http_info(body, accept, content_type, version, **kwargs)  # noqa: E501
            return data

    def subscriptions_post_with_http_info(self, body, accept, content_type, version, **kwargs):  # noqa: E501
        """subscriptions_post  # noqa: E501

        Subscribe. The POST method creates a new subscription. This method shall follow the provisions specified in the tables 5.4.18.3.1-1 and 5.4.18.3.1-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, a new \"Individual subscription\" resource as defined in clause 5.4.3 shall have been created. This method shall not trigger any notification. Creation of two \"Individual subscription\" resources with the same callbackURI and the same filter can result in performance degradation and will provide duplicates of notifications to the NFVO, and might make sense only in very rare use cases. Consequently, the VNFM may either allow creating an \"Individual subscription\" resource if another \"Individual subscription\" resource with the same filter and callbackUri already exists (in which case it shall return the \"201 Created\" response code), or may decide to not create a duplicate \"Individual subscription\" resource (in which case it shall return a \"303 See Other\" response code referencing the existing \"Individual subscription\" resource with the same filter and callbackUri).   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_post_with_http_info(body, accept, content_type, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param LccnSubscriptionRequest body: Details of the subscription to be created.
 (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: LccnSubscription
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method subscriptions_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `subscriptions_post`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `subscriptions_post`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `subscriptions_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `subscriptions_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/subscriptions', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='LccnSubscription',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def subscriptions_subscription_id_delete(self, subscription_id, version, **kwargs):  # noqa: E501
        """subscriptions_subscription_id_delete  # noqa: E501

        Terminate Subscription. The DELETE method terminates an individual subscription. This method shall follow the provisions specified in the tables 5.4.19.3.5-1 and 5.4.19.3.5-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, the \"Individual subscription\" resource shall not exist any longer. This means that no notifications for that subscription shall be sent to the formerly-subscribed API consumer.    NOTE: Due to race conditions, some notifications might still be received by the formerly-subscribed  API consumer for a certain time period after the deletion.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_subscription_id_delete(subscription_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str subscription_id: Identifier of this subscription. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new subscription resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.subscriptions_subscription_id_delete_with_http_info(subscription_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.subscriptions_subscription_id_delete_with_http_info(subscription_id, version, **kwargs)  # noqa: E501
            return data

    def subscriptions_subscription_id_delete_with_http_info(self, subscription_id, version, **kwargs):  # noqa: E501
        """subscriptions_subscription_id_delete  # noqa: E501

        Terminate Subscription. The DELETE method terminates an individual subscription. This method shall follow the provisions specified in the tables 5.4.19.3.5-1 and 5.4.19.3.5-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, the \"Individual subscription\" resource shall not exist any longer. This means that no notifications for that subscription shall be sent to the formerly-subscribed API consumer.    NOTE: Due to race conditions, some notifications might still be received by the formerly-subscribed  API consumer for a certain time period after the deletion.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_subscription_id_delete_with_http_info(subscription_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str subscription_id: Identifier of this subscription. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new subscription resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['subscription_id', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method subscriptions_subscription_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'subscription_id' is set
        if ('subscription_id' not in params or
                params['subscription_id'] is None):
            raise ValueError("Missing the required parameter `subscription_id` when calling `subscriptions_subscription_id_delete`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `subscriptions_subscription_id_delete`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'subscription_id' in params:
            path_params['subscriptionId'] = params['subscription_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/subscriptions/{subscriptionId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def subscriptions_subscription_id_get(self, subscription_id, accept, version, **kwargs):  # noqa: E501
        """subscriptions_subscription_id_get  # noqa: E501

        Query Subscription Information. The GET method retrieves information about a subscription by reading an \"Individual subscription\" resource. This method shall follow the provisions specified in the tables 5.4.19.3.2-1 and 5.4.19.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_subscription_id_get(subscription_id, accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str subscription_id: Identifier of this subscription. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new subscription resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: LccnSubscription
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.subscriptions_subscription_id_get_with_http_info(subscription_id, accept, version, **kwargs)  # noqa: E501
        else:
            (data) = self.subscriptions_subscription_id_get_with_http_info(subscription_id, accept, version, **kwargs)  # noqa: E501
            return data

    def subscriptions_subscription_id_get_with_http_info(self, subscription_id, accept, version, **kwargs):  # noqa: E501
        """subscriptions_subscription_id_get  # noqa: E501

        Query Subscription Information. The GET method retrieves information about a subscription by reading an \"Individual subscription\" resource. This method shall follow the provisions specified in the tables 5.4.19.3.2-1 and 5.4.19.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_subscription_id_get_with_http_info(subscription_id, accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str subscription_id: Identifier of this subscription. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new subscription resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: LccnSubscription
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['subscription_id', 'accept', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method subscriptions_subscription_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'subscription_id' is set
        if ('subscription_id' not in params or
                params['subscription_id'] is None):
            raise ValueError("Missing the required parameter `subscription_id` when calling `subscriptions_subscription_id_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `subscriptions_subscription_id_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `subscriptions_subscription_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'subscription_id' in params:
            path_params['subscriptionId'] = params['subscription_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/subscriptions/{subscriptionId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='LccnSubscription',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def vnf_instances_get(self, accept, version, **kwargs):  # noqa: E501
        """vnf_instances_get  # noqa: E501

        Query VNF. The GET method queries information about multiple VNF instances.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_get(accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV-SOL 013. The VNFM shall support receiving this parameter as part of the URI query string. The NFVO may supply this parameter. All attribute names that appear in the VnfInstance and in data types referenced from it shall be supported by the VNFM in the filter expression. 
        :param str all_fields: Include all complex attributes in the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM shall support this parameter. 
        :param str fields: Complex attributes to be included into the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM should support this parameter. 
        :param str exclude_fields: Complex attributes to be included into the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM should support this parameter. 
        :param str exclude_default: Indicates to exclude the following complex attributes from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM shall support this parameter. The following attributes shall be excluded from the VnfInstance structure in the response body if this parameter is provided, or none of the parameters \"all_fields\", \"fields\", \"exclude_fields\", \"exclude_default\" are provided: - vnfConfigurableProperties -   vimConnectionInfo - instantiatedVnfInfo - metadata - extensions 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the VNFM if the VNFM supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV-SOL 013 for this resource. 
        :param bool not_created_by_ns: This is an optional field. When this is set to true, the API returns only the VNFs which are not created by NS. 


        :return: list[VnfInstance]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.vnf_instances_get_with_http_info(accept, version, **kwargs)  # noqa: E501
        else:
            (data) = self.vnf_instances_get_with_http_info(accept, version, **kwargs)  # noqa: E501
            return data

    def vnf_instances_get_with_http_info(self, accept, version, **kwargs):  # noqa: E501
        """vnf_instances_get  # noqa: E501

        Query VNF. The GET method queries information about multiple VNF instances.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_get_with_http_info(accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV-SOL 013. The VNFM shall support receiving this parameter as part of the URI query string. The NFVO may supply this parameter. All attribute names that appear in the VnfInstance and in data types referenced from it shall be supported by the VNFM in the filter expression. 
        :param str all_fields: Include all complex attributes in the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM shall support this parameter. 
        :param str fields: Complex attributes to be included into the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM should support this parameter. 
        :param str exclude_fields: Complex attributes to be included into the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM should support this parameter. 
        :param str exclude_default: Indicates to exclude the following complex attributes from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM shall support this parameter. The following attributes shall be excluded from the VnfInstance structure in the response body if this parameter is provided, or none of the parameters \"all_fields\", \"fields\", \"exclude_fields\", \"exclude_default\" are provided: - vnfConfigurableProperties -   vimConnectionInfo - instantiatedVnfInfo - metadata - extensions 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the VNFM if the VNFM supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV-SOL 013 for this resource. 
        :param bool not_created_by_ns: This is an optional field. When this is set to true, the API returns only the VNFs which are not created by NS. 


        :return: list[VnfInstance]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['accept', 'version', 'authorization', 'filter', 'all_fields', 'fields', 'exclude_fields', 'exclude_default', 'nextpage_opaque_marker', 'not_created_by_ns']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method vnf_instances_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `vnf_instances_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `vnf_instances_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'all_fields' in params:
            query_params.append(('all_fields', params['all_fields']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
        if 'exclude_fields' in params:
            query_params.append(('exclude_fields', params['exclude_fields']))  # noqa: E501
        if 'exclude_default' in params:
            query_params.append(('exclude_default', params['exclude_default']))  # noqa: E501
        if 'nextpage_opaque_marker' in params:
            query_params.append(('nextpage_opaque_marker', params['nextpage_opaque_marker']))  # noqa: E501

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'not_created_by_ns' in params:
            header_params['notCreatedByNS'] = params['not_created_by_ns']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_instances', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[VnfInstance]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def vnf_instances_post(self, body, accept, content_type, version, **kwargs):  # noqa: E501
        """vnf_instances_post  # noqa: E501

        Create VNF Identifier. The POST method creates a new VNF instance resource. This method shall follow the provisions specified in the tables 5.4.2.3.1-1 and 5.4.2.3.1-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, a new \"Individual VNF instance\" resource as defined in clause 5.4.3 shall have been created, and the value of the \"instantiationState\" attribute in the representation of that resource shall be \"NOT_INSTANTIATED\". A notification of type VnfIdentifierCreationNotification shall be triggered as part of successfully executing this method as defined in clause 5.5.2.18.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_post(body, accept, content_type, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateVnfRequest body: The VNF creation parameters (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: VnfInstance
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.vnf_instances_post_with_http_info(body, accept, content_type, version, **kwargs)  # noqa: E501
        else:
            (data) = self.vnf_instances_post_with_http_info(body, accept, content_type, version, **kwargs)  # noqa: E501
            return data

    def vnf_instances_post_with_http_info(self, body, accept, content_type, version, **kwargs):  # noqa: E501
        """vnf_instances_post  # noqa: E501

        Create VNF Identifier. The POST method creates a new VNF instance resource. This method shall follow the provisions specified in the tables 5.4.2.3.1-1 and 5.4.2.3.1-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, a new \"Individual VNF instance\" resource as defined in clause 5.4.3 shall have been created, and the value of the \"instantiationState\" attribute in the representation of that resource shall be \"NOT_INSTANTIATED\". A notification of type VnfIdentifierCreationNotification shall be triggered as part of successfully executing this method as defined in clause 5.5.2.18.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_post_with_http_info(body, accept, content_type, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateVnfRequest body: The VNF creation parameters (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: VnfInstance
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method vnf_instances_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `vnf_instances_post`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `vnf_instances_post`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `vnf_instances_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `vnf_instances_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_instances', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='VnfInstance',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def vnf_instances_vnf_instance_id_delete(self, vnf_instance_id, version, **kwargs):  # noqa: E501
        """vnf_instances_vnf_instance_id_delete  # noqa: E501

        Delete VNF Identifier. This method deletes an \"Individual VNF instance\" resource. This method shall follow the provisions specified in the tables 5.4.3.3.5-1 and 5.4.3.3.5-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, the \"Individual VNF instance\" resource shall not exist any longer. A notification of type \"VnfIdentifierDeletionNotification\" shall be triggered as part of successfully executing this method as defined in clause 5.5.2.19.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_vnf_instance_id_delete(vnf_instance_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str vnf_instance_id: Identifier of the VNF instance. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new VNF instance resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param bool is_force: This is an optional field. When this is set to true, it forcefully deletes the VNF Instance. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.vnf_instances_vnf_instance_id_delete_with_http_info(vnf_instance_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.vnf_instances_vnf_instance_id_delete_with_http_info(vnf_instance_id, version, **kwargs)  # noqa: E501
            return data

    def vnf_instances_vnf_instance_id_delete_with_http_info(self, vnf_instance_id, version, **kwargs):  # noqa: E501
        """vnf_instances_vnf_instance_id_delete  # noqa: E501

        Delete VNF Identifier. This method deletes an \"Individual VNF instance\" resource. This method shall follow the provisions specified in the tables 5.4.3.3.5-1 and 5.4.3.3.5-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, the \"Individual VNF instance\" resource shall not exist any longer. A notification of type \"VnfIdentifierDeletionNotification\" shall be triggered as part of successfully executing this method as defined in clause 5.5.2.19.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_vnf_instance_id_delete_with_http_info(vnf_instance_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str vnf_instance_id: Identifier of the VNF instance. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new VNF instance resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param bool is_force: This is an optional field. When this is set to true, it forcefully deletes the VNF Instance. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['vnf_instance_id', 'version', 'authorization', 'is_force']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method vnf_instances_vnf_instance_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'vnf_instance_id' is set
        if ('vnf_instance_id' not in params or
                params['vnf_instance_id'] is None):
            raise ValueError("Missing the required parameter `vnf_instance_id` when calling `vnf_instances_vnf_instance_id_delete`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `vnf_instances_vnf_instance_id_delete`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnf_instance_id' in params:
            path_params['vnfInstanceId'] = params['vnf_instance_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'is_force' in params:
            header_params['isForce'] = params['is_force']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_instances/{vnfInstanceId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def vnf_instances_vnf_instance_id_get(self, vnf_instance_id, accept, content_type, version, **kwargs):  # noqa: E501
        """vnf_instances_vnf_instance_id_get  # noqa: E501

        Query VNF. The GET method retrieves information about a VNF instance by reading an \"Individual VNF instance\" resource. This method shall follow the provisions specified in the tables 5.4.3.3.2-1 and 5.4.3.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_vnf_instance_id_get(vnf_instance_id, accept, content_type, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str vnf_instance_id: Identifier of the VNF instance. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new VNF instance resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: VnfInstance
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.vnf_instances_vnf_instance_id_get_with_http_info(vnf_instance_id, accept, content_type, version, **kwargs)  # noqa: E501
        else:
            (data) = self.vnf_instances_vnf_instance_id_get_with_http_info(vnf_instance_id, accept, content_type, version, **kwargs)  # noqa: E501
            return data

    def vnf_instances_vnf_instance_id_get_with_http_info(self, vnf_instance_id, accept, content_type, version, **kwargs):  # noqa: E501
        """vnf_instances_vnf_instance_id_get  # noqa: E501

        Query VNF. The GET method retrieves information about a VNF instance by reading an \"Individual VNF instance\" resource. This method shall follow the provisions specified in the tables 5.4.3.3.2-1 and 5.4.3.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_vnf_instance_id_get_with_http_info(vnf_instance_id, accept, content_type, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str vnf_instance_id: Identifier of the VNF instance. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new VNF instance resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: VnfInstance
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['vnf_instance_id', 'accept', 'content_type', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method vnf_instances_vnf_instance_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'vnf_instance_id' is set
        if ('vnf_instance_id' not in params or
                params['vnf_instance_id'] is None):
            raise ValueError("Missing the required parameter `vnf_instance_id` when calling `vnf_instances_vnf_instance_id_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `vnf_instances_vnf_instance_id_get`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `vnf_instances_vnf_instance_id_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `vnf_instances_vnf_instance_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnf_instance_id' in params:
            path_params['vnfInstanceId'] = params['vnf_instance_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_instances/{vnfInstanceId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='VnfInstance',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def vnf_instances_vnf_instance_id_heal_post(self, body, accept, content_type, version, vnf_instance_id, **kwargs):  # noqa: E501
        """vnf_instances_vnf_instance_id_heal_post  # noqa: E501

        Heal VNF. The POST method requests to heal a VNF instance. This method shall follow the provisions specified in the tables 5.4.9.3.1-1 and 5.4.9.3.1-2 for URI query parameters, request and response data structures, and response codes. The steps and conditions that apply as the result of successfully executing this method are specified in clause 5.4.1.2.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_vnf_instance_id_heal_post(body, accept, content_type, version, vnf_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param HealVnfRequest body: Parameters for the Heal VNF operation. (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str vnf_instance_id: Identifier of the VNF instance to be healed. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual VNF instance\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.vnf_instances_vnf_instance_id_heal_post_with_http_info(body, accept, content_type, version, vnf_instance_id, **kwargs)  # noqa: E501
        else:
            (data) = self.vnf_instances_vnf_instance_id_heal_post_with_http_info(body, accept, content_type, version, vnf_instance_id, **kwargs)  # noqa: E501
            return data

    def vnf_instances_vnf_instance_id_heal_post_with_http_info(self, body, accept, content_type, version, vnf_instance_id, **kwargs):  # noqa: E501
        """vnf_instances_vnf_instance_id_heal_post  # noqa: E501

        Heal VNF. The POST method requests to heal a VNF instance. This method shall follow the provisions specified in the tables 5.4.9.3.1-1 and 5.4.9.3.1-2 for URI query parameters, request and response data structures, and response codes. The steps and conditions that apply as the result of successfully executing this method are specified in clause 5.4.1.2.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_vnf_instance_id_heal_post_with_http_info(body, accept, content_type, version, vnf_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param HealVnfRequest body: Parameters for the Heal VNF operation. (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str vnf_instance_id: Identifier of the VNF instance to be healed. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual VNF instance\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type', 'version', 'vnf_instance_id', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method vnf_instances_vnf_instance_id_heal_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `vnf_instances_vnf_instance_id_heal_post`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `vnf_instances_vnf_instance_id_heal_post`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `vnf_instances_vnf_instance_id_heal_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `vnf_instances_vnf_instance_id_heal_post`")  # noqa: E501
        # verify the required parameter 'vnf_instance_id' is set
        if ('vnf_instance_id' not in params or
                params['vnf_instance_id'] is None):
            raise ValueError("Missing the required parameter `vnf_instance_id` when calling `vnf_instances_vnf_instance_id_heal_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnf_instance_id' in params:
            path_params['vnfInstanceId'] = params['vnf_instance_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_instances/{vnfInstanceId}/heal', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def vnf_instances_vnf_instance_id_instantiate_post(self, body, accept, content_type, version, vnf_instance_id, **kwargs):  # noqa: E501
        """vnf_instances_vnf_instance_id_instantiate_post  # noqa: E501

        Instantiate VNF. The POST method instantiates a VNF instance. This method shall follow the provisions specified in the tables 5.4.4.3.1-1 and 5.4.4.3.1-2 for URI query parameters, request and response data structures, and response codes. The steps and conditions that apply as the result of successfully executing this method are specified in clause 5.4.1.2. In addition, once the VNFM has successfully completed the underlying VNF LCM operation occurrence, it shall set the \"instantiationState\" attribute to the value \"INSTANTIATED\" and the \"vnfState\" attribute to the value \"STARTED\" in the representation of the \"Individual VNF instance\" resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_vnf_instance_id_instantiate_post(body, accept, content_type, version, vnf_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param InstantiateVnfRequest body: Parameters for the VNF instantiation. (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str vnf_instance_id: Identifier of the VNF instance. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new VNF instance resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.vnf_instances_vnf_instance_id_instantiate_post_with_http_info(body, accept, content_type, version, vnf_instance_id, **kwargs)  # noqa: E501
        else:
            (data) = self.vnf_instances_vnf_instance_id_instantiate_post_with_http_info(body, accept, content_type, version, vnf_instance_id, **kwargs)  # noqa: E501
            return data

    def vnf_instances_vnf_instance_id_instantiate_post_with_http_info(self, body, accept, content_type, version, vnf_instance_id, **kwargs):  # noqa: E501
        """vnf_instances_vnf_instance_id_instantiate_post  # noqa: E501

        Instantiate VNF. The POST method instantiates a VNF instance. This method shall follow the provisions specified in the tables 5.4.4.3.1-1 and 5.4.4.3.1-2 for URI query parameters, request and response data structures, and response codes. The steps and conditions that apply as the result of successfully executing this method are specified in clause 5.4.1.2. In addition, once the VNFM has successfully completed the underlying VNF LCM operation occurrence, it shall set the \"instantiationState\" attribute to the value \"INSTANTIATED\" and the \"vnfState\" attribute to the value \"STARTED\" in the representation of the \"Individual VNF instance\" resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_vnf_instance_id_instantiate_post_with_http_info(body, accept, content_type, version, vnf_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param InstantiateVnfRequest body: Parameters for the VNF instantiation. (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str vnf_instance_id: Identifier of the VNF instance. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new VNF instance resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type', 'version', 'vnf_instance_id', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method vnf_instances_vnf_instance_id_instantiate_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `vnf_instances_vnf_instance_id_instantiate_post`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `vnf_instances_vnf_instance_id_instantiate_post`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `vnf_instances_vnf_instance_id_instantiate_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `vnf_instances_vnf_instance_id_instantiate_post`")  # noqa: E501
        # verify the required parameter 'vnf_instance_id' is set
        if ('vnf_instance_id' not in params or
                params['vnf_instance_id'] is None):
            raise ValueError("Missing the required parameter `vnf_instance_id` when calling `vnf_instances_vnf_instance_id_instantiate_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnf_instance_id' in params:
            path_params['vnfInstanceId'] = params['vnf_instance_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_instances/{vnfInstanceId}/instantiate', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def vnf_instances_vnf_instance_id_operate_post(self, body, accept, content_type, version, vnf_instance_id, **kwargs):  # noqa: E501
        """vnf_instances_vnf_instance_id_operate_post  # noqa: E501

        Operate VNF. The POST method changes the operational state of a VNF instance resource. This method shall follow the provisions specified in the tables 5.4.10.3.1-1 and 5.4.10.3.1-2 for URI query parameters, request and response data structures, and response codes. The steps and conditions that apply as the result of successfully executing this method are specified in clause 5.4.1.2. In addition, once the VNFM has successfully completed the underlying VNF LCM operation occurrence, it shall set the \"vnfState\" attribute in the representation of the \"Individual VNF instance\" resource to the value of the \"changeStateTo\" attribute passed in the \"OperateVnfRequest\" data in the POST request.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_vnf_instance_id_operate_post(body, accept, content_type, version, vnf_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param OperateVnfRequest body: Parameters for the Operate VNF operation. (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str vnf_instance_id: Identifier of the VNF instance to be operated. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual VNF instance\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.vnf_instances_vnf_instance_id_operate_post_with_http_info(body, accept, content_type, version, vnf_instance_id, **kwargs)  # noqa: E501
        else:
            (data) = self.vnf_instances_vnf_instance_id_operate_post_with_http_info(body, accept, content_type, version, vnf_instance_id, **kwargs)  # noqa: E501
            return data

    def vnf_instances_vnf_instance_id_operate_post_with_http_info(self, body, accept, content_type, version, vnf_instance_id, **kwargs):  # noqa: E501
        """vnf_instances_vnf_instance_id_operate_post  # noqa: E501

        Operate VNF. The POST method changes the operational state of a VNF instance resource. This method shall follow the provisions specified in the tables 5.4.10.3.1-1 and 5.4.10.3.1-2 for URI query parameters, request and response data structures, and response codes. The steps and conditions that apply as the result of successfully executing this method are specified in clause 5.4.1.2. In addition, once the VNFM has successfully completed the underlying VNF LCM operation occurrence, it shall set the \"vnfState\" attribute in the representation of the \"Individual VNF instance\" resource to the value of the \"changeStateTo\" attribute passed in the \"OperateVnfRequest\" data in the POST request.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_vnf_instance_id_operate_post_with_http_info(body, accept, content_type, version, vnf_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param OperateVnfRequest body: Parameters for the Operate VNF operation. (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str vnf_instance_id: Identifier of the VNF instance to be operated. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual VNF instance\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type', 'version', 'vnf_instance_id', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method vnf_instances_vnf_instance_id_operate_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `vnf_instances_vnf_instance_id_operate_post`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `vnf_instances_vnf_instance_id_operate_post`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `vnf_instances_vnf_instance_id_operate_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `vnf_instances_vnf_instance_id_operate_post`")  # noqa: E501
        # verify the required parameter 'vnf_instance_id' is set
        if ('vnf_instance_id' not in params or
                params['vnf_instance_id'] is None):
            raise ValueError("Missing the required parameter `vnf_instance_id` when calling `vnf_instances_vnf_instance_id_operate_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnf_instance_id' in params:
            path_params['vnfInstanceId'] = params['vnf_instance_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_instances/{vnfInstanceId}/operate', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def vnf_instances_vnf_instance_id_scale_post(self, body, accept, content_type, version, vnf_instance_id, **kwargs):  # noqa: E501
        """vnf_instances_vnf_instance_id_scale_post  # noqa: E501

        Scale VNF. The POST method requests to scale a VNF instance resource incrementally. This method shall follow the provisions specified in the tables 5.4.5.3.1-1 and 5.4.5.3.1-2 for URI query parameters, request and response data structures, and response codes. The steps and conditions that apply as the result of successfully executing this method are specified in clause 5.4.1.2. In addition, once the VNFM has successfully completed the underlying VNF LCM operation occurrence, it shall reflect the result of scaling the VNF instance by updating the \"scaleStatus\" attribute in the representation of the \"Individual VNF instance\" resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_vnf_instance_id_scale_post(body, accept, content_type, version, vnf_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ScaleVnfRequest body: Parameters for the scale VNF operation. (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str vnf_instance_id: Identifier of the VNF instance to be scaled. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual VNF instance\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.vnf_instances_vnf_instance_id_scale_post_with_http_info(body, accept, content_type, version, vnf_instance_id, **kwargs)  # noqa: E501
        else:
            (data) = self.vnf_instances_vnf_instance_id_scale_post_with_http_info(body, accept, content_type, version, vnf_instance_id, **kwargs)  # noqa: E501
            return data

    def vnf_instances_vnf_instance_id_scale_post_with_http_info(self, body, accept, content_type, version, vnf_instance_id, **kwargs):  # noqa: E501
        """vnf_instances_vnf_instance_id_scale_post  # noqa: E501

        Scale VNF. The POST method requests to scale a VNF instance resource incrementally. This method shall follow the provisions specified in the tables 5.4.5.3.1-1 and 5.4.5.3.1-2 for URI query parameters, request and response data structures, and response codes. The steps and conditions that apply as the result of successfully executing this method are specified in clause 5.4.1.2. In addition, once the VNFM has successfully completed the underlying VNF LCM operation occurrence, it shall reflect the result of scaling the VNF instance by updating the \"scaleStatus\" attribute in the representation of the \"Individual VNF instance\" resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_vnf_instance_id_scale_post_with_http_info(body, accept, content_type, version, vnf_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ScaleVnfRequest body: Parameters for the scale VNF operation. (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str vnf_instance_id: Identifier of the VNF instance to be scaled. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual VNF instance\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type', 'version', 'vnf_instance_id', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method vnf_instances_vnf_instance_id_scale_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `vnf_instances_vnf_instance_id_scale_post`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `vnf_instances_vnf_instance_id_scale_post`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `vnf_instances_vnf_instance_id_scale_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `vnf_instances_vnf_instance_id_scale_post`")  # noqa: E501
        # verify the required parameter 'vnf_instance_id' is set
        if ('vnf_instance_id' not in params or
                params['vnf_instance_id'] is None):
            raise ValueError("Missing the required parameter `vnf_instance_id` when calling `vnf_instances_vnf_instance_id_scale_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnf_instance_id' in params:
            path_params['vnfInstanceId'] = params['vnf_instance_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_instances/{vnfInstanceId}/scale', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def vnf_instances_vnf_instance_id_scale_to_level_post(self, body, accept, content_type, version, vnf_instance_id, **kwargs):  # noqa: E501
        """vnf_instances_vnf_instance_id_scale_to_level_post  # noqa: E501

        Scale VNF to Level. The POST method requests to scale a VNF instance resource to a target level. This method shall follow the provisions specified in the tables 5.4.6.3.1-1 and 5.4.6.3.1-2 for URI query parameters, request and response data structures, and response codes. The steps and conditions that apply as the result of successfully executing this method are specified in clause 5.4.1.2. In addition, once the VNFM has successfully completed the underlying VNF LCM operation occurrence, it shall reflect the result of scaling the VNF instance by updating the \"scaleStatus\" attribute in the representation of the \"Individual VNF instance\" resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_vnf_instance_id_scale_to_level_post(body, accept, content_type, version, vnf_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ScaleVnfToLevelRequest body: Parameters for the scale VNF to Level operation. (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str vnf_instance_id: Identifier of the VNF instance to be scaled to a target level. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual VNF instance\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.vnf_instances_vnf_instance_id_scale_to_level_post_with_http_info(body, accept, content_type, version, vnf_instance_id, **kwargs)  # noqa: E501
        else:
            (data) = self.vnf_instances_vnf_instance_id_scale_to_level_post_with_http_info(body, accept, content_type, version, vnf_instance_id, **kwargs)  # noqa: E501
            return data

    def vnf_instances_vnf_instance_id_scale_to_level_post_with_http_info(self, body, accept, content_type, version, vnf_instance_id, **kwargs):  # noqa: E501
        """vnf_instances_vnf_instance_id_scale_to_level_post  # noqa: E501

        Scale VNF to Level. The POST method requests to scale a VNF instance resource to a target level. This method shall follow the provisions specified in the tables 5.4.6.3.1-1 and 5.4.6.3.1-2 for URI query parameters, request and response data structures, and response codes. The steps and conditions that apply as the result of successfully executing this method are specified in clause 5.4.1.2. In addition, once the VNFM has successfully completed the underlying VNF LCM operation occurrence, it shall reflect the result of scaling the VNF instance by updating the \"scaleStatus\" attribute in the representation of the \"Individual VNF instance\" resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_vnf_instance_id_scale_to_level_post_with_http_info(body, accept, content_type, version, vnf_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ScaleVnfToLevelRequest body: Parameters for the scale VNF to Level operation. (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str vnf_instance_id: Identifier of the VNF instance to be scaled to a target level. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual VNF instance\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type', 'version', 'vnf_instance_id', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method vnf_instances_vnf_instance_id_scale_to_level_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `vnf_instances_vnf_instance_id_scale_to_level_post`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `vnf_instances_vnf_instance_id_scale_to_level_post`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `vnf_instances_vnf_instance_id_scale_to_level_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `vnf_instances_vnf_instance_id_scale_to_level_post`")  # noqa: E501
        # verify the required parameter 'vnf_instance_id' is set
        if ('vnf_instance_id' not in params or
                params['vnf_instance_id'] is None):
            raise ValueError("Missing the required parameter `vnf_instance_id` when calling `vnf_instances_vnf_instance_id_scale_to_level_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnf_instance_id' in params:
            path_params['vnfInstanceId'] = params['vnf_instance_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_instances/{vnfInstanceId}/scale_to_level', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def vnf_instances_vnf_instance_id_terminate_post(self, body, accept, content_type, version, vnf_instance_id, **kwargs):  # noqa: E501
        """vnf_instances_vnf_instance_id_terminate_post  # noqa: E501

        Terminate VNF. The POST method triggers the VNFM to terminate a VNF instance and to request to the VIM the release of its used virtualised resources. This method shall follow the provisions specified in the tables 5.4.8.3.1-1 and 5.4.8.3.1-2 for URI query parameters, request and response data structures, and response codes. The steps and conditions that apply as the result of successfully executing this method are specified in clause 5.4.1.2. In addition, once the VNFM has successfully completed the underlying VNF LCM operation occurrence, it shall set the \"instantiationState\" attribute in the representation of the \"Individual VNF instance\" resource to the value \"NOT_INSTANTIATED\".   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_vnf_instance_id_terminate_post(body, accept, content_type, version, vnf_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param TerminateVnfRequest body: Parameters for the VNF termination. (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str vnf_instance_id: The identifier of the VNF instance to be terminated. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual VNF instance\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.vnf_instances_vnf_instance_id_terminate_post_with_http_info(body, accept, content_type, version, vnf_instance_id, **kwargs)  # noqa: E501
        else:
            (data) = self.vnf_instances_vnf_instance_id_terminate_post_with_http_info(body, accept, content_type, version, vnf_instance_id, **kwargs)  # noqa: E501
            return data

    def vnf_instances_vnf_instance_id_terminate_post_with_http_info(self, body, accept, content_type, version, vnf_instance_id, **kwargs):  # noqa: E501
        """vnf_instances_vnf_instance_id_terminate_post  # noqa: E501

        Terminate VNF. The POST method triggers the VNFM to terminate a VNF instance and to request to the VIM the release of its used virtualised resources. This method shall follow the provisions specified in the tables 5.4.8.3.1-1 and 5.4.8.3.1-2 for URI query parameters, request and response data structures, and response codes. The steps and conditions that apply as the result of successfully executing this method are specified in clause 5.4.1.2. In addition, once the VNFM has successfully completed the underlying VNF LCM operation occurrence, it shall set the \"instantiationState\" attribute in the representation of the \"Individual VNF instance\" resource to the value \"NOT_INSTANTIATED\".   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_instances_vnf_instance_id_terminate_post_with_http_info(body, accept, content_type, version, vnf_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param TerminateVnfRequest body: Parameters for the VNF termination. (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str vnf_instance_id: The identifier of the VNF instance to be terminated. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual VNF instance\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type', 'version', 'vnf_instance_id', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method vnf_instances_vnf_instance_id_terminate_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `vnf_instances_vnf_instance_id_terminate_post`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `vnf_instances_vnf_instance_id_terminate_post`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `vnf_instances_vnf_instance_id_terminate_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `vnf_instances_vnf_instance_id_terminate_post`")  # noqa: E501
        # verify the required parameter 'vnf_instance_id' is set
        if ('vnf_instance_id' not in params or
                params['vnf_instance_id'] is None):
            raise ValueError("Missing the required parameter `vnf_instance_id` when calling `vnf_instances_vnf_instance_id_terminate_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnf_instance_id' in params:
            path_params['vnfInstanceId'] = params['vnf_instance_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_instances/{vnfInstanceId}/terminate', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def vnf_lcm_op_occs_get(self, accept, version, **kwargs):  # noqa: E501
        """vnf_lcm_op_occs_get  # noqa: E501

        Get Operation Status. The API consumer can use this method to query status information about multiple VNF lifecycle management operation occurrences. This method shall follow the provisions specified in the tables 5.4.12.3.2-1 and 5.4.12.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_lcm_op_occs_get(accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV SOL 013. The VNFM shall support receiving this parameter as part of the URI query string. The NFVO may supply this parameter. All attribute names that appear in the VnfLcmOpOcc and in data types referenced from it shall be supported by the VNFM in the filter expression. 
        :param str all_fields: Include all complex attributes in the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM shall support this parameter. 
        :param str fields: Complex attributes to be included into the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM should support this parameter. 
        :param str exclude_fields: Complex attributes to be excluded from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM should support this parameter. 
        :param str exclude_default: Indicates to exclude the following complex attributes from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM shall support this parameter. The following attributes shall be excluded from the VnfLcmOpOcc structure in the response body if this parameter is provided, or none of the parameters \"all_fields,\" \"fields\", \"exclude_fields\", \"exclude_default\" are provided: - vnfConfigurableProperties -   vimConnectionInfo - instantiatedVnfInfo - metadata - extensions 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the VNFM if the VNFM supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV-SOL 013 for this resource. 


        :return: list[VnfLcmOpOcc]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.vnf_lcm_op_occs_get_with_http_info(accept, version, **kwargs)  # noqa: E501
        else:
            (data) = self.vnf_lcm_op_occs_get_with_http_info(accept, version, **kwargs)  # noqa: E501
            return data

    def vnf_lcm_op_occs_get_with_http_info(self, accept, version, **kwargs):  # noqa: E501
        """vnf_lcm_op_occs_get  # noqa: E501

        Get Operation Status. The API consumer can use this method to query status information about multiple VNF lifecycle management operation occurrences. This method shall follow the provisions specified in the tables 5.4.12.3.2-1 and 5.4.12.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_lcm_op_occs_get_with_http_info(accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV SOL 013. The VNFM shall support receiving this parameter as part of the URI query string. The NFVO may supply this parameter. All attribute names that appear in the VnfLcmOpOcc and in data types referenced from it shall be supported by the VNFM in the filter expression. 
        :param str all_fields: Include all complex attributes in the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM shall support this parameter. 
        :param str fields: Complex attributes to be included into the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM should support this parameter. 
        :param str exclude_fields: Complex attributes to be excluded from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM should support this parameter. 
        :param str exclude_default: Indicates to exclude the following complex attributes from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM shall support this parameter. The following attributes shall be excluded from the VnfLcmOpOcc structure in the response body if this parameter is provided, or none of the parameters \"all_fields,\" \"fields\", \"exclude_fields\", \"exclude_default\" are provided: - vnfConfigurableProperties -   vimConnectionInfo - instantiatedVnfInfo - metadata - extensions 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the VNFM if the VNFM supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV-SOL 013 for this resource. 


        :return: list[VnfLcmOpOcc]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['accept', 'version', 'authorization', 'filter', 'all_fields', 'fields', 'exclude_fields', 'exclude_default', 'nextpage_opaque_marker']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method vnf_lcm_op_occs_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `vnf_lcm_op_occs_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `vnf_lcm_op_occs_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'all_fields' in params:
            query_params.append(('all_fields', params['all_fields']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
        if 'exclude_fields' in params:
            query_params.append(('exclude_fields', params['exclude_fields']))  # noqa: E501
        if 'exclude_default' in params:
            query_params.append(('exclude_default', params['exclude_default']))  # noqa: E501
        if 'nextpage_opaque_marker' in params:
            query_params.append(('nextpage_opaque_marker', params['nextpage_opaque_marker']))  # noqa: E501

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_lcm_op_occs', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[VnfLcmOpOcc]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def vnf_lcm_op_occs_vnf_lcm_op_occ_id_get(self, vnf_lcm_op_occ_id, accept, version, **kwargs):  # noqa: E501
        """vnf_lcm_op_occs_vnf_lcm_op_occ_id_get  # noqa: E501

        Get Operation Status. The API consumer can use this method to retrieve status information about a VNF lifecycle management operation occurrence by reading an \"Individual VNF LCM operation occurrence\" resource. This method shall follow the provisions specified in the tables 5.4.13.3.2-1 and 5.4.13.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_lcm_op_occs_vnf_lcm_op_occ_id_get(vnf_lcm_op_occ_id, accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str vnf_lcm_op_occ_id: Identifier of a VNF lifecycle management operation occurrence. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a PATCH or POST request triggering a VNF LCM operation. It can also be retrieved from the \"vnfLcmOpOccId\" attribute in the VnfLcmOperationOccurrenceNotification.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: VnfLcmOpOcc
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.vnf_lcm_op_occs_vnf_lcm_op_occ_id_get_with_http_info(vnf_lcm_op_occ_id, accept, version, **kwargs)  # noqa: E501
        else:
            (data) = self.vnf_lcm_op_occs_vnf_lcm_op_occ_id_get_with_http_info(vnf_lcm_op_occ_id, accept, version, **kwargs)  # noqa: E501
            return data

    def vnf_lcm_op_occs_vnf_lcm_op_occ_id_get_with_http_info(self, vnf_lcm_op_occ_id, accept, version, **kwargs):  # noqa: E501
        """vnf_lcm_op_occs_vnf_lcm_op_occ_id_get  # noqa: E501

        Get Operation Status. The API consumer can use this method to retrieve status information about a VNF lifecycle management operation occurrence by reading an \"Individual VNF LCM operation occurrence\" resource. This method shall follow the provisions specified in the tables 5.4.13.3.2-1 and 5.4.13.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_lcm_op_occs_vnf_lcm_op_occ_id_get_with_http_info(vnf_lcm_op_occ_id, accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str vnf_lcm_op_occ_id: Identifier of a VNF lifecycle management operation occurrence. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a PATCH or POST request triggering a VNF LCM operation. It can also be retrieved from the \"vnfLcmOpOccId\" attribute in the VnfLcmOperationOccurrenceNotification.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: VnfLcmOpOcc
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['vnf_lcm_op_occ_id', 'accept', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method vnf_lcm_op_occs_vnf_lcm_op_occ_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'vnf_lcm_op_occ_id' is set
        if ('vnf_lcm_op_occ_id' not in params or
                params['vnf_lcm_op_occ_id'] is None):
            raise ValueError("Missing the required parameter `vnf_lcm_op_occ_id` when calling `vnf_lcm_op_occs_vnf_lcm_op_occ_id_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `vnf_lcm_op_occs_vnf_lcm_op_occ_id_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `vnf_lcm_op_occs_vnf_lcm_op_occ_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnf_lcm_op_occ_id' in params:
            path_params['vnfLcmOpOccId'] = params['vnf_lcm_op_occ_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_lcm_op_occs/{vnfLcmOpOccId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='VnfLcmOpOcc',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def vnf_lcm_op_occs_vnf_lcm_op_occ_id_retry_post(self, vnf_lcm_op_occ_id, version, **kwargs):  # noqa: E501
        """vnf_lcm_op_occs_vnf_lcm_op_occ_id_retry_post  # noqa: E501

        The POST method initiates retrying a VNF lifecycle operation if that operation has experienced a temporary failure, i.e. the related \"Individual VNF LCM operation occurrence\" resource is in \"FAILED_TEMP\" state. This method shall follow the provisions specified in the tables 5.4.14.3.1-1 and 5.4.14.3.1-2 for URI query parameters, request and response data structures, and response codes. In case of success of processing the asynchronous request, the \"operationState\" attribute in the representation of the parent resource shall be changed to \"PROCESSING\" and the applicable \"start\" notification according to clause 5.6.2.2 shall be emitted to indicate that the underlying VNF LCM operation occurrence proceeds.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_lcm_op_occs_vnf_lcm_op_occ_id_retry_post(vnf_lcm_op_occ_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str vnf_lcm_op_occ_id: Identifier of a VNF lifecycle management operation occurrence to be retried. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a PATCH or POST request triggering a VNF LCM operation. It can also be retrieved from the \"vnfLcmOpOccId\" attribute in the VnfLcmOperationOccurrenceNotification.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.vnf_lcm_op_occs_vnf_lcm_op_occ_id_retry_post_with_http_info(vnf_lcm_op_occ_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.vnf_lcm_op_occs_vnf_lcm_op_occ_id_retry_post_with_http_info(vnf_lcm_op_occ_id, version, **kwargs)  # noqa: E501
            return data

    def vnf_lcm_op_occs_vnf_lcm_op_occ_id_retry_post_with_http_info(self, vnf_lcm_op_occ_id, version, **kwargs):  # noqa: E501
        """vnf_lcm_op_occs_vnf_lcm_op_occ_id_retry_post  # noqa: E501

        The POST method initiates retrying a VNF lifecycle operation if that operation has experienced a temporary failure, i.e. the related \"Individual VNF LCM operation occurrence\" resource is in \"FAILED_TEMP\" state. This method shall follow the provisions specified in the tables 5.4.14.3.1-1 and 5.4.14.3.1-2 for URI query parameters, request and response data structures, and response codes. In case of success of processing the asynchronous request, the \"operationState\" attribute in the representation of the parent resource shall be changed to \"PROCESSING\" and the applicable \"start\" notification according to clause 5.6.2.2 shall be emitted to indicate that the underlying VNF LCM operation occurrence proceeds.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_lcm_op_occs_vnf_lcm_op_occ_id_retry_post_with_http_info(vnf_lcm_op_occ_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str vnf_lcm_op_occ_id: Identifier of a VNF lifecycle management operation occurrence to be retried. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a PATCH or POST request triggering a VNF LCM operation. It can also be retrieved from the \"vnfLcmOpOccId\" attribute in the VnfLcmOperationOccurrenceNotification.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['vnf_lcm_op_occ_id', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method vnf_lcm_op_occs_vnf_lcm_op_occ_id_retry_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'vnf_lcm_op_occ_id' is set
        if ('vnf_lcm_op_occ_id' not in params or
                params['vnf_lcm_op_occ_id'] is None):
            raise ValueError("Missing the required parameter `vnf_lcm_op_occ_id` when calling `vnf_lcm_op_occs_vnf_lcm_op_occ_id_retry_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `vnf_lcm_op_occs_vnf_lcm_op_occ_id_retry_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnf_lcm_op_occ_id' in params:
            path_params['vnfLcmOpOccId'] = params['vnf_lcm_op_occ_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_lcm_op_occs/{vnfLcmOpOccId}/retry', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def vnf_lcm_op_occs_vnf_lcm_op_occ_id_rollback_post(self, vnf_lcm_op_occ_id, version, **kwargs):  # noqa: E501
        """vnf_lcm_op_occs_vnf_lcm_op_occ_id_rollback_post  # noqa: E501

        The POST method initiates rolling back a VNF lifecycle operation if that operation has experienced a temporary failure, i.e. the related \"Individual VNF LCM operation occurrence\" resource is in \"FAILED_TEMP\" state. In case of rolling back an occurrence of the \"InstantiateVnf\" operation, the VNFM shall request to the VIM the release of the virtualised resources that were allocated for the related VNF instance. The \"rollback\" task shall be supported by the VNFM for any VNF LCM operation occurrence that represents an \"InstantiateVnf\" operation in FAILED_TEMP state. This method shall follow the provisions specified in the tables 5.4.15.3.1-1 and 5.4.15.3.1-2 for URI query parameters, request and response data structures, and response codes. In case of success of processing the asynchronous request, the \"operationState\" attribute in the representation of the parent resource shall be changed to \"ROLLING_BACK\" and the applicable \"start\" notification according to clause 5.6.2.2 shall be emitted to indicate that rollback of the underlying VNF LCM operation occurrence is attempted.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_lcm_op_occs_vnf_lcm_op_occ_id_rollback_post(vnf_lcm_op_occ_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str vnf_lcm_op_occ_id: Identifier of a VNF lifecycle management operation occurrence to be be rolled back. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a PATCH or POST request triggering a VNF LCM operation. It can also be retrieved from the \"vnfLcmOpOccId\" attribute in the VnfLcmOperationOccurrenceNotification.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.vnf_lcm_op_occs_vnf_lcm_op_occ_id_rollback_post_with_http_info(vnf_lcm_op_occ_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.vnf_lcm_op_occs_vnf_lcm_op_occ_id_rollback_post_with_http_info(vnf_lcm_op_occ_id, version, **kwargs)  # noqa: E501
            return data

    def vnf_lcm_op_occs_vnf_lcm_op_occ_id_rollback_post_with_http_info(self, vnf_lcm_op_occ_id, version, **kwargs):  # noqa: E501
        """vnf_lcm_op_occs_vnf_lcm_op_occ_id_rollback_post  # noqa: E501

        The POST method initiates rolling back a VNF lifecycle operation if that operation has experienced a temporary failure, i.e. the related \"Individual VNF LCM operation occurrence\" resource is in \"FAILED_TEMP\" state. In case of rolling back an occurrence of the \"InstantiateVnf\" operation, the VNFM shall request to the VIM the release of the virtualised resources that were allocated for the related VNF instance. The \"rollback\" task shall be supported by the VNFM for any VNF LCM operation occurrence that represents an \"InstantiateVnf\" operation in FAILED_TEMP state. This method shall follow the provisions specified in the tables 5.4.15.3.1-1 and 5.4.15.3.1-2 for URI query parameters, request and response data structures, and response codes. In case of success of processing the asynchronous request, the \"operationState\" attribute in the representation of the parent resource shall be changed to \"ROLLING_BACK\" and the applicable \"start\" notification according to clause 5.6.2.2 shall be emitted to indicate that rollback of the underlying VNF LCM operation occurrence is attempted.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.vnf_lcm_op_occs_vnf_lcm_op_occ_id_rollback_post_with_http_info(vnf_lcm_op_occ_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str vnf_lcm_op_occ_id: Identifier of a VNF lifecycle management operation occurrence to be be rolled back. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a PATCH or POST request triggering a VNF LCM operation. It can also be retrieved from the \"vnfLcmOpOccId\" attribute in the VnfLcmOperationOccurrenceNotification.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['vnf_lcm_op_occ_id', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method vnf_lcm_op_occs_vnf_lcm_op_occ_id_rollback_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'vnf_lcm_op_occ_id' is set
        if ('vnf_lcm_op_occ_id' not in params or
                params['vnf_lcm_op_occ_id'] is None):
            raise ValueError("Missing the required parameter `vnf_lcm_op_occ_id` when calling `vnf_lcm_op_occs_vnf_lcm_op_occ_id_rollback_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `vnf_lcm_op_occs_vnf_lcm_op_occ_id_rollback_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnf_lcm_op_occ_id' in params:
            path_params['vnfLcmOpOccId'] = params['vnf_lcm_op_occ_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_lcm_op_occs/{vnfLcmOpOccId}/rollback', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
