# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class AffectedVirtualLink(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'IdentifierInVnf',
        'vnf_virtual_link_desc_id': 'IdentifierInVnfd',
        'change_type': 'str',
        'network_resource': 'ResourceHandle',
        'resource_definition_id': 'IdentifierLocal',
        'zone_id': 'Identifier',
        'metadata': 'KeyValuePairs'
    }

    attribute_map = {
        'id': 'id',
        'vnf_virtual_link_desc_id': 'vnfVirtualLinkDescId',
        'change_type': 'changeType',
        'network_resource': 'networkResource',
        'resource_definition_id': 'resourceDefinitionId',
        'zone_id': 'zoneId',
        'metadata': 'metadata'
    }

    def __init__(self, id=None, vnf_virtual_link_desc_id=None, change_type=None, network_resource=None, resource_definition_id=None, zone_id=None, metadata=None):  # noqa: E501
        """AffectedVirtualLink - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._vnf_virtual_link_desc_id = None
        self._change_type = None
        self._network_resource = None
        self._resource_definition_id = None
        self._zone_id = None
        self._metadata = None
        self.discriminator = None
        self.id = id
        self.vnf_virtual_link_desc_id = vnf_virtual_link_desc_id
        self.change_type = change_type
        self.network_resource = network_resource
        if resource_definition_id is not None:
            self.resource_definition_id = resource_definition_id
        if zone_id is not None:
            self.zone_id = zone_id
        if metadata is not None:
            self.metadata = metadata

    @property
    def id(self):
        """Gets the id of this AffectedVirtualLink.  # noqa: E501


        :return: The id of this AffectedVirtualLink.  # noqa: E501
        :rtype: IdentifierInVnf
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AffectedVirtualLink.


        :param id: The id of this AffectedVirtualLink.  # noqa: E501
        :type: IdentifierInVnf
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def vnf_virtual_link_desc_id(self):
        """Gets the vnf_virtual_link_desc_id of this AffectedVirtualLink.  # noqa: E501


        :return: The vnf_virtual_link_desc_id of this AffectedVirtualLink.  # noqa: E501
        :rtype: IdentifierInVnfd
        """
        return self._vnf_virtual_link_desc_id

    @vnf_virtual_link_desc_id.setter
    def vnf_virtual_link_desc_id(self, vnf_virtual_link_desc_id):
        """Sets the vnf_virtual_link_desc_id of this AffectedVirtualLink.


        :param vnf_virtual_link_desc_id: The vnf_virtual_link_desc_id of this AffectedVirtualLink.  # noqa: E501
        :type: IdentifierInVnfd
        """
        if vnf_virtual_link_desc_id is None:
            print("WARNING: Invalid value for the required field `vnf_virtual_link_desc_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_virtual_link_desc_id`, must not be `None`")  # noqa: E501

        self._vnf_virtual_link_desc_id = vnf_virtual_link_desc_id

    @property
    def change_type(self):
        """Gets the change_type of this AffectedVirtualLink.  # noqa: E501

        Signals the type of change. Permitted values: * ADDED * REMOVED * MODIFIED * TEMPORARY * LINK_PORT_ADDED * LINK_PORT_REMOVED For a temporary resource, an AffectedVirtualLink structure exists as long as the temporary resource exists.   # noqa: E501

        :return: The change_type of this AffectedVirtualLink.  # noqa: E501
        :rtype: str
        """
        return self._change_type

    @change_type.setter
    def change_type(self, change_type):
        """Sets the change_type of this AffectedVirtualLink.

        Signals the type of change. Permitted values: * ADDED * REMOVED * MODIFIED * TEMPORARY * LINK_PORT_ADDED * LINK_PORT_REMOVED For a temporary resource, an AffectedVirtualLink structure exists as long as the temporary resource exists.   # noqa: E501

        :param change_type: The change_type of this AffectedVirtualLink.  # noqa: E501
        :type: str
        """
        if change_type is None:
            print("WARNING: Invalid value for the required field `change_type`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `change_type`, must not be `None`")  # noqa: E501
        allowed_values = ["ADDED", "REMOVED", "MODIFIED", "TEMPORARY", "LINK_PORT_ADDED", "LINK_PORT_REMOVED"]  # noqa: E501
        if change_type is not None and change_type not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `change_type` ({0}), must be one of {1}"  # noqa: E501
                .format(change_type, allowed_values)
            )

        self._change_type = change_type

    @property
    def network_resource(self):
        """Gets the network_resource of this AffectedVirtualLink.  # noqa: E501


        :return: The network_resource of this AffectedVirtualLink.  # noqa: E501
        :rtype: ResourceHandle
        """
        return self._network_resource

    @network_resource.setter
    def network_resource(self, network_resource):
        """Sets the network_resource of this AffectedVirtualLink.


        :param network_resource: The network_resource of this AffectedVirtualLink.  # noqa: E501
        :type: ResourceHandle
        """
        if network_resource is None:
            print("WARNING: Invalid value for the required field `network_resource`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `network_resource`, must not be `None`")  # noqa: E501

        self._network_resource = network_resource

    @property
    def resource_definition_id(self):
        """Gets the resource_definition_id of this AffectedVirtualLink.  # noqa: E501


        :return: The resource_definition_id of this AffectedVirtualLink.  # noqa: E501
        :rtype: IdentifierLocal
        """
        return self._resource_definition_id

    @resource_definition_id.setter
    def resource_definition_id(self, resource_definition_id):
        """Sets the resource_definition_id of this AffectedVirtualLink.


        :param resource_definition_id: The resource_definition_id of this AffectedVirtualLink.  # noqa: E501
        :type: IdentifierLocal
        """

        self._resource_definition_id = resource_definition_id

    @property
    def zone_id(self):
        """Gets the zone_id of this AffectedVirtualLink.  # noqa: E501


        :return: The zone_id of this AffectedVirtualLink.  # noqa: E501
        :rtype: Identifier
        """
        return self._zone_id

    @zone_id.setter
    def zone_id(self, zone_id):
        """Sets the zone_id of this AffectedVirtualLink.


        :param zone_id: The zone_id of this AffectedVirtualLink.  # noqa: E501
        :type: Identifier
        """

        self._zone_id = zone_id

    @property
    def metadata(self):
        """Gets the metadata of this AffectedVirtualLink.  # noqa: E501


        :return: The metadata of this AffectedVirtualLink.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this AffectedVirtualLink.


        :param metadata: The metadata of this AffectedVirtualLink.  # noqa: E501
        :type: KeyValuePairs
        """

        self._metadata = metadata

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AffectedVirtualLink, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AffectedVirtualLink):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
