# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class AffectedVnfc(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'IdentifierInVnf',
        'vdu_id': 'IdentifierInVnfd',
        'change_type': 'str',
        'compute_resource': 'ResourceHandle',
        'resource_definition_id': 'IdentifierLocal',
        'zone_id': 'Identifier',
        'metadata': 'KeyValuePairs',
        'affected_vnfc_cp_ids': 'list[IdentifierInVnf]',
        'added_storage_resource_ids': 'list[IdentifierInVnf]',
        'removed_storage_resource_ids': 'list[IdentifierInVnf]'
    }

    attribute_map = {
        'id': 'id',
        'vdu_id': 'vduId',
        'change_type': 'changeType',
        'compute_resource': 'computeResource',
        'resource_definition_id': 'resourceDefinitionId',
        'zone_id': 'zoneId',
        'metadata': 'metadata',
        'affected_vnfc_cp_ids': 'affectedVnfcCpIds',
        'added_storage_resource_ids': 'addedStorageResourceIds',
        'removed_storage_resource_ids': 'removedStorageResourceIds'
    }

    def __init__(self, id=None, vdu_id=None, change_type=None, compute_resource=None, resource_definition_id=None, zone_id=None, metadata=None, affected_vnfc_cp_ids=None, added_storage_resource_ids=None, removed_storage_resource_ids=None):  # noqa: E501
        """AffectedVnfc - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._vdu_id = None
        self._change_type = None
        self._compute_resource = None
        self._resource_definition_id = None
        self._zone_id = None
        self._metadata = None
        self._affected_vnfc_cp_ids = None
        self._added_storage_resource_ids = None
        self._removed_storage_resource_ids = None
        self.discriminator = None
        self.id = id
        self.vdu_id = vdu_id
        self.change_type = change_type
        self.compute_resource = compute_resource
        if resource_definition_id is not None:
            self.resource_definition_id = resource_definition_id
        if zone_id is not None:
            self.zone_id = zone_id
        if metadata is not None:
            self.metadata = metadata
        if affected_vnfc_cp_ids is not None:
            self.affected_vnfc_cp_ids = affected_vnfc_cp_ids
        if added_storage_resource_ids is not None:
            self.added_storage_resource_ids = added_storage_resource_ids
        if removed_storage_resource_ids is not None:
            self.removed_storage_resource_ids = removed_storage_resource_ids

    @property
    def id(self):
        """Gets the id of this AffectedVnfc.  # noqa: E501


        :return: The id of this AffectedVnfc.  # noqa: E501
        :rtype: IdentifierInVnf
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AffectedVnfc.


        :param id: The id of this AffectedVnfc.  # noqa: E501
        :type: IdentifierInVnf
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def vdu_id(self):
        """Gets the vdu_id of this AffectedVnfc.  # noqa: E501


        :return: The vdu_id of this AffectedVnfc.  # noqa: E501
        :rtype: IdentifierInVnfd
        """
        return self._vdu_id

    @vdu_id.setter
    def vdu_id(self, vdu_id):
        """Sets the vdu_id of this AffectedVnfc.


        :param vdu_id: The vdu_id of this AffectedVnfc.  # noqa: E501
        :type: IdentifierInVnfd
        """
        if vdu_id is None:
            print("WARNING: Invalid value for the required field `vdu_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vdu_id`, must not be `None`")  # noqa: E501

        self._vdu_id = vdu_id

    @property
    def change_type(self):
        """Gets the change_type of this AffectedVnfc.  # noqa: E501

        Signals the type of change. Permitted values: * ADDED * REMOVED * MODIFIED * TEMPORARY For a temporary resource, an AffectedVnfc structure exists as long as the temporary resource exists.   # noqa: E501

        :return: The change_type of this AffectedVnfc.  # noqa: E501
        :rtype: str
        """
        return self._change_type

    @change_type.setter
    def change_type(self, change_type):
        """Sets the change_type of this AffectedVnfc.

        Signals the type of change. Permitted values: * ADDED * REMOVED * MODIFIED * TEMPORARY For a temporary resource, an AffectedVnfc structure exists as long as the temporary resource exists.   # noqa: E501

        :param change_type: The change_type of this AffectedVnfc.  # noqa: E501
        :type: str
        """
        if change_type is None:
            print("WARNING: Invalid value for the required field `change_type`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `change_type`, must not be `None`")  # noqa: E501
        allowed_values = ["ADDED", "REMOVED", "MODIFIED", "TEMPORARY"]  # noqa: E501
        if change_type is not None and change_type not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `change_type` ({0}), must be one of {1}"  # noqa: E501
                .format(change_type, allowed_values)
            )

        self._change_type = change_type

    @property
    def compute_resource(self):
        """Gets the compute_resource of this AffectedVnfc.  # noqa: E501


        :return: The compute_resource of this AffectedVnfc.  # noqa: E501
        :rtype: ResourceHandle
        """
        return self._compute_resource

    @compute_resource.setter
    def compute_resource(self, compute_resource):
        """Sets the compute_resource of this AffectedVnfc.


        :param compute_resource: The compute_resource of this AffectedVnfc.  # noqa: E501
        :type: ResourceHandle
        """
        if compute_resource is None:
            print("WARNING: Invalid value for the required field `compute_resource`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `compute_resource`, must not be `None`")  # noqa: E501

        self._compute_resource = compute_resource

    @property
    def resource_definition_id(self):
        """Gets the resource_definition_id of this AffectedVnfc.  # noqa: E501


        :return: The resource_definition_id of this AffectedVnfc.  # noqa: E501
        :rtype: IdentifierLocal
        """
        return self._resource_definition_id

    @resource_definition_id.setter
    def resource_definition_id(self, resource_definition_id):
        """Sets the resource_definition_id of this AffectedVnfc.


        :param resource_definition_id: The resource_definition_id of this AffectedVnfc.  # noqa: E501
        :type: IdentifierLocal
        """

        self._resource_definition_id = resource_definition_id

    @property
    def zone_id(self):
        """Gets the zone_id of this AffectedVnfc.  # noqa: E501


        :return: The zone_id of this AffectedVnfc.  # noqa: E501
        :rtype: Identifier
        """
        return self._zone_id

    @zone_id.setter
    def zone_id(self, zone_id):
        """Sets the zone_id of this AffectedVnfc.


        :param zone_id: The zone_id of this AffectedVnfc.  # noqa: E501
        :type: Identifier
        """

        self._zone_id = zone_id

    @property
    def metadata(self):
        """Gets the metadata of this AffectedVnfc.  # noqa: E501


        :return: The metadata of this AffectedVnfc.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this AffectedVnfc.


        :param metadata: The metadata of this AffectedVnfc.  # noqa: E501
        :type: KeyValuePairs
        """

        self._metadata = metadata

    @property
    def affected_vnfc_cp_ids(self):
        """Gets the affected_vnfc_cp_ids of this AffectedVnfc.  # noqa: E501

        Identifiers of CP(s) of the VNFC instance that were affected by the change. Shall be present for those affected CPs of the VNFC instance that are associated to an external CP of the VNF instance. May be present for further affected CPs of the VNFC instance.   # noqa: E501

        :return: The affected_vnfc_cp_ids of this AffectedVnfc.  # noqa: E501
        :rtype: list[IdentifierInVnf]
        """
        return self._affected_vnfc_cp_ids

    @affected_vnfc_cp_ids.setter
    def affected_vnfc_cp_ids(self, affected_vnfc_cp_ids):
        """Sets the affected_vnfc_cp_ids of this AffectedVnfc.

        Identifiers of CP(s) of the VNFC instance that were affected by the change. Shall be present for those affected CPs of the VNFC instance that are associated to an external CP of the VNF instance. May be present for further affected CPs of the VNFC instance.   # noqa: E501

        :param affected_vnfc_cp_ids: The affected_vnfc_cp_ids of this AffectedVnfc.  # noqa: E501
        :type: list[IdentifierInVnf]
        """

        self._affected_vnfc_cp_ids = affected_vnfc_cp_ids

    @property
    def added_storage_resource_ids(self):
        """Gets the added_storage_resource_ids of this AffectedVnfc.  # noqa: E501

        References to VirtualStorage resources that have been added. Each value refers to a VirtualStorageResourceInfo item in the VnfInstance that was added to the VNFC. It shall be provided if at least one storage resource was added to the VNFC.   # noqa: E501

        :return: The added_storage_resource_ids of this AffectedVnfc.  # noqa: E501
        :rtype: list[IdentifierInVnf]
        """
        return self._added_storage_resource_ids

    @added_storage_resource_ids.setter
    def added_storage_resource_ids(self, added_storage_resource_ids):
        """Sets the added_storage_resource_ids of this AffectedVnfc.

        References to VirtualStorage resources that have been added. Each value refers to a VirtualStorageResourceInfo item in the VnfInstance that was added to the VNFC. It shall be provided if at least one storage resource was added to the VNFC.   # noqa: E501

        :param added_storage_resource_ids: The added_storage_resource_ids of this AffectedVnfc.  # noqa: E501
        :type: list[IdentifierInVnf]
        """

        self._added_storage_resource_ids = added_storage_resource_ids

    @property
    def removed_storage_resource_ids(self):
        """Gets the removed_storage_resource_ids of this AffectedVnfc.  # noqa: E501

        References to VirtualStorage resources that have been removed. The value contains the identifier of a VirtualStorageResourceInfo item that has been removed from the VNFC, and might no longer exist in the VnfInstance. It shall be provided if at least one storage resource was removed from the VNFC.   # noqa: E501

        :return: The removed_storage_resource_ids of this AffectedVnfc.  # noqa: E501
        :rtype: list[IdentifierInVnf]
        """
        return self._removed_storage_resource_ids

    @removed_storage_resource_ids.setter
    def removed_storage_resource_ids(self, removed_storage_resource_ids):
        """Sets the removed_storage_resource_ids of this AffectedVnfc.

        References to VirtualStorage resources that have been removed. The value contains the identifier of a VirtualStorageResourceInfo item that has been removed from the VNFC, and might no longer exist in the VnfInstance. It shall be provided if at least one storage resource was removed from the VNFC.   # noqa: E501

        :param removed_storage_resource_ids: The removed_storage_resource_ids of this AffectedVnfc.  # noqa: E501
        :type: list[IdentifierInVnf]
        """

        self._removed_storage_resource_ids = removed_storage_resource_ids

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AffectedVnfc, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AffectedVnfc):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
