# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class CpProtocolInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'layer_protocol': 'str',
        'ip_over_ethernet': 'IpOverEthernetAddressInfo'
    }

    attribute_map = {
        'layer_protocol': 'layerProtocol',
        'ip_over_ethernet': 'ipOverEthernet'
    }

    def __init__(self, layer_protocol=None, ip_over_ethernet=None):  # noqa: E501
        """CpProtocolInfo - a model defined in Swagger"""  # noqa: E501
        self._layer_protocol = None
        self._ip_over_ethernet = None
        self.discriminator = None
        self.layer_protocol = layer_protocol
        if ip_over_ethernet is not None:
            self.ip_over_ethernet = ip_over_ethernet

    @property
    def layer_protocol(self):
        """Gets the layer_protocol of this CpProtocolInfo.  # noqa: E501

        The identifier of layer(s) and protocol(s) associated to the network address information. Permitted values: IP_OVER_ETHERNET This attribute allows to signal the addition of further types of layer and protocol in future versions of the present document in a backwards-compatible way. In the current version of the present document, only IP over Ethernet is supported.   # noqa: E501

        :return: The layer_protocol of this CpProtocolInfo.  # noqa: E501
        :rtype: str
        """
        return self._layer_protocol

    @layer_protocol.setter
    def layer_protocol(self, layer_protocol):
        """Sets the layer_protocol of this CpProtocolInfo.

        The identifier of layer(s) and protocol(s) associated to the network address information. Permitted values: IP_OVER_ETHERNET This attribute allows to signal the addition of further types of layer and protocol in future versions of the present document in a backwards-compatible way. In the current version of the present document, only IP over Ethernet is supported.   # noqa: E501

        :param layer_protocol: The layer_protocol of this CpProtocolInfo.  # noqa: E501
        :type: str
        """
        if layer_protocol is None:
            print("WARNING: Invalid value for the required field `layer_protocol`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `layer_protocol`, must not be `None`")  # noqa: E501
        allowed_values = ["IP_OVER_ETHERNET"]  # noqa: E501
        if layer_protocol is not None and layer_protocol not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `layer_protocol` ({0}), must be one of {1}"  # noqa: E501
                .format(layer_protocol, allowed_values)
            )

        self._layer_protocol = layer_protocol

    @property
    def ip_over_ethernet(self):
        """Gets the ip_over_ethernet of this CpProtocolInfo.  # noqa: E501


        :return: The ip_over_ethernet of this CpProtocolInfo.  # noqa: E501
        :rtype: IpOverEthernetAddressInfo
        """
        return self._ip_over_ethernet

    @ip_over_ethernet.setter
    def ip_over_ethernet(self, ip_over_ethernet):
        """Sets the ip_over_ethernet of this CpProtocolInfo.


        :param ip_over_ethernet: The ip_over_ethernet of this CpProtocolInfo.  # noqa: E501
        :type: IpOverEthernetAddressInfo
        """

        self._ip_over_ethernet = ip_over_ethernet

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CpProtocolInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CpProtocolInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
