# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class CreateVnfRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnfd_id': 'Identifier',
        'vnf_instance_name': 'str',
        'vnf_instance_description': 'str',
        'metadata': 'MetaData'
    }

    attribute_map = {
        'vnfd_id': 'vnfdId',
        'vnf_instance_name': 'vnfInstanceName',
        'vnf_instance_description': 'vnfInstanceDescription',
        'metadata': 'metadata'
    }

    def __init__(self, vnfd_id=None, vnf_instance_name=None, vnf_instance_description=None, metadata=None):  # noqa: E501
        """CreateVnfRequest - a model defined in Swagger"""  # noqa: E501
        self._vnfd_id = None
        self._vnf_instance_name = None
        self._vnf_instance_description = None
        self._metadata = None
        self.discriminator = None
        self.vnfd_id = vnfd_id
        if vnf_instance_name is not None:
            self.vnf_instance_name = vnf_instance_name
        if vnf_instance_description is not None:
            self.vnf_instance_description = vnf_instance_description
        if metadata is not None:
            self.metadata = metadata

    @property
    def vnfd_id(self):
        """Gets the vnfd_id of this CreateVnfRequest.  # noqa: E501


        :return: The vnfd_id of this CreateVnfRequest.  # noqa: E501
        :rtype: Identifier
        """
        return self._vnfd_id

    @vnfd_id.setter
    def vnfd_id(self, vnfd_id):
        """Sets the vnfd_id of this CreateVnfRequest.


        :param vnfd_id: The vnfd_id of this CreateVnfRequest.  # noqa: E501
        :type: Identifier
        """
        if vnfd_id is None:
            print("WARNING: Invalid value for the required field `vnfd_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnfd_id`, must not be `None`")  # noqa: E501

        self._vnfd_id = vnfd_id

    @property
    def vnf_instance_name(self):
        """Gets the vnf_instance_name of this CreateVnfRequest.  # noqa: E501

        Human-readable name of the VNF instance to be created.   # noqa: E501

        :return: The vnf_instance_name of this CreateVnfRequest.  # noqa: E501
        :rtype: str
        """
        return self._vnf_instance_name

    @vnf_instance_name.setter
    def vnf_instance_name(self, vnf_instance_name):
        """Sets the vnf_instance_name of this CreateVnfRequest.

        Human-readable name of the VNF instance to be created.   # noqa: E501

        :param vnf_instance_name: The vnf_instance_name of this CreateVnfRequest.  # noqa: E501
        :type: str
        """

        self._vnf_instance_name = vnf_instance_name

    @property
    def vnf_instance_description(self):
        """Gets the vnf_instance_description of this CreateVnfRequest.  # noqa: E501

        Human-readable description of the VNF instance to be created.   # noqa: E501

        :return: The vnf_instance_description of this CreateVnfRequest.  # noqa: E501
        :rtype: str
        """
        return self._vnf_instance_description

    @vnf_instance_description.setter
    def vnf_instance_description(self, vnf_instance_description):
        """Sets the vnf_instance_description of this CreateVnfRequest.

        Human-readable description of the VNF instance to be created.   # noqa: E501

        :param vnf_instance_description: The vnf_instance_description of this CreateVnfRequest.  # noqa: E501
        :type: str
        """

        self._vnf_instance_description = vnf_instance_description

    @property
    def metadata(self):
        """Gets the metadata of this CreateVnfRequest.  # noqa: E501


        :return: The metadata of this CreateVnfRequest.  # noqa: E501
        :rtype: MetaData
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this CreateVnfRequest.


        :param metadata: The metadata of this CreateVnfRequest.  # noqa: E501
        :type: MetaData
        """

        self._metadata = metadata

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateVnfRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateVnfRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
