# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ExtVirtualLinkData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'Identifier',
        'vim_connection_id': 'Identifier',
        'resource_provider_id': 'Identifier',
        'resource_id': 'IdentifierInVim',
        'ext_cps': 'list[VnfExtCpData]',
        'ext_link_ports': 'list[ExtLinkPortData]'
    }

    attribute_map = {
        'id': 'id',
        'vim_connection_id': 'vimConnectionId',
        'resource_provider_id': 'resourceProviderId',
        'resource_id': 'resourceId',
        'ext_cps': 'extCps',
        'ext_link_ports': 'extLinkPorts'
    }

    def __init__(self, id=None, vim_connection_id=None, resource_provider_id=None, resource_id=None, ext_cps=None, ext_link_ports=None):  # noqa: E501
        """ExtVirtualLinkData - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._vim_connection_id = None
        self._resource_provider_id = None
        self._resource_id = None
        self._ext_cps = None
        self._ext_link_ports = None
        self.discriminator = None
        self.id = id
        if vim_connection_id is not None:
            self.vim_connection_id = vim_connection_id
        if resource_provider_id is not None:
            self.resource_provider_id = resource_provider_id
        self.resource_id = resource_id
        self.ext_cps = ext_cps
        if ext_link_ports is not None:
            self.ext_link_ports = ext_link_ports

    @property
    def id(self):
        """Gets the id of this ExtVirtualLinkData.  # noqa: E501


        :return: The id of this ExtVirtualLinkData.  # noqa: E501
        :rtype: Identifier
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ExtVirtualLinkData.


        :param id: The id of this ExtVirtualLinkData.  # noqa: E501
        :type: Identifier
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def vim_connection_id(self):
        """Gets the vim_connection_id of this ExtVirtualLinkData.  # noqa: E501


        :return: The vim_connection_id of this ExtVirtualLinkData.  # noqa: E501
        :rtype: Identifier
        """
        return self._vim_connection_id

    @vim_connection_id.setter
    def vim_connection_id(self, vim_connection_id):
        """Sets the vim_connection_id of this ExtVirtualLinkData.


        :param vim_connection_id: The vim_connection_id of this ExtVirtualLinkData.  # noqa: E501
        :type: Identifier
        """

        self._vim_connection_id = vim_connection_id

    @property
    def resource_provider_id(self):
        """Gets the resource_provider_id of this ExtVirtualLinkData.  # noqa: E501


        :return: The resource_provider_id of this ExtVirtualLinkData.  # noqa: E501
        :rtype: Identifier
        """
        return self._resource_provider_id

    @resource_provider_id.setter
    def resource_provider_id(self, resource_provider_id):
        """Sets the resource_provider_id of this ExtVirtualLinkData.


        :param resource_provider_id: The resource_provider_id of this ExtVirtualLinkData.  # noqa: E501
        :type: Identifier
        """

        self._resource_provider_id = resource_provider_id

    @property
    def resource_id(self):
        """Gets the resource_id of this ExtVirtualLinkData.  # noqa: E501


        :return: The resource_id of this ExtVirtualLinkData.  # noqa: E501
        :rtype: IdentifierInVim
        """
        return self._resource_id

    @resource_id.setter
    def resource_id(self, resource_id):
        """Sets the resource_id of this ExtVirtualLinkData.


        :param resource_id: The resource_id of this ExtVirtualLinkData.  # noqa: E501
        :type: IdentifierInVim
        """
        if resource_id is None:
            print("WARNING: Invalid value for the required field `resource_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `resource_id`, must not be `None`")  # noqa: E501

        self._resource_id = resource_id

    @property
    def ext_cps(self):
        """Gets the ext_cps of this ExtVirtualLinkData.  # noqa: E501

        External CPs of the VNF to be connected to this external VL.   # noqa: E501

        :return: The ext_cps of this ExtVirtualLinkData.  # noqa: E501
        :rtype: list[VnfExtCpData]
        """
        return self._ext_cps

    @ext_cps.setter
    def ext_cps(self, ext_cps):
        """Sets the ext_cps of this ExtVirtualLinkData.

        External CPs of the VNF to be connected to this external VL.   # noqa: E501

        :param ext_cps: The ext_cps of this ExtVirtualLinkData.  # noqa: E501
        :type: list[VnfExtCpData]
        """
        if ext_cps is None:
            print("WARNING: Invalid value for the required field `ext_cps`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `ext_cps`, must not be `None`")  # noqa: E501

        self._ext_cps = ext_cps

    @property
    def ext_link_ports(self):
        """Gets the ext_link_ports of this ExtVirtualLinkData.  # noqa: E501

        Externally provided link ports to be used to connect external connection points to this external VL. If this attribute is not present, the VNFM shall create the link ports on the external VL.   # noqa: E501

        :return: The ext_link_ports of this ExtVirtualLinkData.  # noqa: E501
        :rtype: list[ExtLinkPortData]
        """
        return self._ext_link_ports

    @ext_link_ports.setter
    def ext_link_ports(self, ext_link_ports):
        """Sets the ext_link_ports of this ExtVirtualLinkData.

        Externally provided link ports to be used to connect external connection points to this external VL. If this attribute is not present, the VNFM shall create the link ports on the external VL.   # noqa: E501

        :param ext_link_ports: The ext_link_ports of this ExtVirtualLinkData.  # noqa: E501
        :type: list[ExtLinkPortData]
        """

        self._ext_link_ports = ext_link_ports

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ExtVirtualLinkData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExtVirtualLinkData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
