# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class InstantiateVnfRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'flavour_id': 'IdentifierInVnfd',
        'instantiation_level_id': 'IdentifierInVnfd',
        'ext_virtual_links': 'list[ExtVirtualLinkData]',
        'ext_managed_virtual_links': 'list[ExtManagedVirtualLinkData]',
        'vim_connection_info': 'list[VimConnectionInfo]',
        'localization_language': 'String',
        'additional_params': 'VnfInstantiateRequestAdditionalParams',
        'extensions': 'KeyValuePairs',
        'vnf_configurable_properties': 'KeyValuePairs'
    }

    attribute_map = {
        'flavour_id': 'flavourId',
        'instantiation_level_id': 'instantiationLevelId',
        'ext_virtual_links': 'extVirtualLinks',
        'ext_managed_virtual_links': 'extManagedVirtualLinks',
        'vim_connection_info': 'vimConnectionInfo',
        'localization_language': 'localizationLanguage',
        'additional_params': 'additionalParams',
        'extensions': 'extensions',
        'vnf_configurable_properties': 'vnfConfigurableProperties'
    }

    def __init__(self, flavour_id=None, instantiation_level_id=None, ext_virtual_links=None, ext_managed_virtual_links=None, vim_connection_info=None, localization_language=None, additional_params=None, extensions=None, vnf_configurable_properties=None):  # noqa: E501
        """InstantiateVnfRequest - a model defined in Swagger"""  # noqa: E501
        self._flavour_id = None
        self._instantiation_level_id = None
        self._ext_virtual_links = None
        self._ext_managed_virtual_links = None
        self._vim_connection_info = None
        self._localization_language = None
        self._additional_params = None
        self._extensions = None
        self._vnf_configurable_properties = None
        self.discriminator = None
        self.flavour_id = flavour_id
        if instantiation_level_id is not None:
            self.instantiation_level_id = instantiation_level_id
        if ext_virtual_links is not None:
            self.ext_virtual_links = ext_virtual_links
        if ext_managed_virtual_links is not None:
            self.ext_managed_virtual_links = ext_managed_virtual_links
        if vim_connection_info is not None:
            self.vim_connection_info = vim_connection_info
        if localization_language is not None:
            self.localization_language = localization_language
        if additional_params is not None:
            self.additional_params = additional_params
        if extensions is not None:
            self.extensions = extensions
        if vnf_configurable_properties is not None:
            self.vnf_configurable_properties = vnf_configurable_properties

    @property
    def flavour_id(self):
        """Gets the flavour_id of this InstantiateVnfRequest.  # noqa: E501


        :return: The flavour_id of this InstantiateVnfRequest.  # noqa: E501
        :rtype: IdentifierInVnfd
        """
        return self._flavour_id

    @flavour_id.setter
    def flavour_id(self, flavour_id):
        """Sets the flavour_id of this InstantiateVnfRequest.


        :param flavour_id: The flavour_id of this InstantiateVnfRequest.  # noqa: E501
        :type: IdentifierInVnfd
        """
        if flavour_id is None:
            print("WARNING: Invalid value for the required field `flavour_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `flavour_id`, must not be `None`")  # noqa: E501

        self._flavour_id = flavour_id

    @property
    def instantiation_level_id(self):
        """Gets the instantiation_level_id of this InstantiateVnfRequest.  # noqa: E501


        :return: The instantiation_level_id of this InstantiateVnfRequest.  # noqa: E501
        :rtype: IdentifierInVnfd
        """
        return self._instantiation_level_id

    @instantiation_level_id.setter
    def instantiation_level_id(self, instantiation_level_id):
        """Sets the instantiation_level_id of this InstantiateVnfRequest.


        :param instantiation_level_id: The instantiation_level_id of this InstantiateVnfRequest.  # noqa: E501
        :type: IdentifierInVnfd
        """

        self._instantiation_level_id = instantiation_level_id

    @property
    def ext_virtual_links(self):
        """Gets the ext_virtual_links of this InstantiateVnfRequest.  # noqa: E501

        Information about external VLs to connect the VNF to.   # noqa: E501

        :return: The ext_virtual_links of this InstantiateVnfRequest.  # noqa: E501
        :rtype: list[ExtVirtualLinkData]
        """
        return self._ext_virtual_links

    @ext_virtual_links.setter
    def ext_virtual_links(self, ext_virtual_links):
        """Sets the ext_virtual_links of this InstantiateVnfRequest.

        Information about external VLs to connect the VNF to.   # noqa: E501

        :param ext_virtual_links: The ext_virtual_links of this InstantiateVnfRequest.  # noqa: E501
        :type: list[ExtVirtualLinkData]
        """

        self._ext_virtual_links = ext_virtual_links

    @property
    def ext_managed_virtual_links(self):
        """Gets the ext_managed_virtual_links of this InstantiateVnfRequest.  # noqa: E501

        Information about internal VLs that are managed by the NFVO.   # noqa: E501

        :return: The ext_managed_virtual_links of this InstantiateVnfRequest.  # noqa: E501
        :rtype: list[ExtManagedVirtualLinkData]
        """
        return self._ext_managed_virtual_links

    @ext_managed_virtual_links.setter
    def ext_managed_virtual_links(self, ext_managed_virtual_links):
        """Sets the ext_managed_virtual_links of this InstantiateVnfRequest.

        Information about internal VLs that are managed by the NFVO.   # noqa: E501

        :param ext_managed_virtual_links: The ext_managed_virtual_links of this InstantiateVnfRequest.  # noqa: E501
        :type: list[ExtManagedVirtualLinkData]
        """

        self._ext_managed_virtual_links = ext_managed_virtual_links

    @property
    def vim_connection_info(self):
        """Gets the vim_connection_info of this InstantiateVnfRequest.  # noqa: E501

        Information about VIM connections to be used for managing the resources for the VNF instance, or refer to external / externally-managed virtual links. This attribute shall only be supported and may be present if VNF-related resource management in direct mode is applicable.   # noqa: E501

        :return: The vim_connection_info of this InstantiateVnfRequest.  # noqa: E501
        :rtype: list[VimConnectionInfo]
        """
        return self._vim_connection_info

    @vim_connection_info.setter
    def vim_connection_info(self, vim_connection_info):
        """Sets the vim_connection_info of this InstantiateVnfRequest.

        Information about VIM connections to be used for managing the resources for the VNF instance, or refer to external / externally-managed virtual links. This attribute shall only be supported and may be present if VNF-related resource management in direct mode is applicable.   # noqa: E501

        :param vim_connection_info: The vim_connection_info of this InstantiateVnfRequest.  # noqa: E501
        :type: list[VimConnectionInfo]
        """

        self._vim_connection_info = vim_connection_info

    @property
    def localization_language(self):
        """Gets the localization_language of this InstantiateVnfRequest.  # noqa: E501


        :return: The localization_language of this InstantiateVnfRequest.  # noqa: E501
        :rtype: String
        """
        return self._localization_language

    @localization_language.setter
    def localization_language(self, localization_language):
        """Sets the localization_language of this InstantiateVnfRequest.


        :param localization_language: The localization_language of this InstantiateVnfRequest.  # noqa: E501
        :type: String
        """

        self._localization_language = localization_language

    @property
    def additional_params(self):
        """Gets the additional_params of this InstantiateVnfRequest.  # noqa: E501


        :return: The additional_params of this InstantiateVnfRequest.  # noqa: E501
        :rtype: VnfInstantiateRequestAdditionalParams
        """
        return self._additional_params

    @additional_params.setter
    def additional_params(self, additional_params):
        """Sets the additional_params of this InstantiateVnfRequest.


        :param additional_params: The additional_params of this InstantiateVnfRequest.  # noqa: E501
        :type: VnfInstantiateRequestAdditionalParams
        """

        self._additional_params = additional_params

    @property
    def extensions(self):
        """Gets the extensions of this InstantiateVnfRequest.  # noqa: E501


        :return: The extensions of this InstantiateVnfRequest.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._extensions

    @extensions.setter
    def extensions(self, extensions):
        """Sets the extensions of this InstantiateVnfRequest.


        :param extensions: The extensions of this InstantiateVnfRequest.  # noqa: E501
        :type: KeyValuePairs
        """

        self._extensions = extensions

    @property
    def vnf_configurable_properties(self):
        """Gets the vnf_configurable_properties of this InstantiateVnfRequest.  # noqa: E501


        :return: The vnf_configurable_properties of this InstantiateVnfRequest.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._vnf_configurable_properties

    @vnf_configurable_properties.setter
    def vnf_configurable_properties(self, vnf_configurable_properties):
        """Sets the vnf_configurable_properties of this InstantiateVnfRequest.


        :param vnf_configurable_properties: The vnf_configurable_properties of this InstantiateVnfRequest.  # noqa: E501
        :type: KeyValuePairs
        """

        self._vnf_configurable_properties = vnf_configurable_properties

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InstantiateVnfRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InstantiateVnfRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
