# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class IpOverEthernetAddressDataIpAddresses(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'type': 'str',
        'fixed_addresses': 'list[IpAddress]',
        'num_dynamic_addresses': 'int',
        'address_range': 'IpOverEthernetAddressDataAddressRange',
        'subnet_id': 'IdentifierInVim'
    }

    attribute_map = {
        'type': 'type',
        'fixed_addresses': 'fixedAddresses',
        'num_dynamic_addresses': 'numDynamicAddresses',
        'address_range': 'addressRange',
        'subnet_id': 'subnetId'
    }

    def __init__(self, type=None, fixed_addresses=None, num_dynamic_addresses=None, address_range=None, subnet_id=None):  # noqa: E501
        """IpOverEthernetAddressDataIpAddresses - a model defined in Swagger"""  # noqa: E501
        self._type = None
        self._fixed_addresses = None
        self._num_dynamic_addresses = None
        self._address_range = None
        self._subnet_id = None
        self.discriminator = None
        self.type = type
        if fixed_addresses is not None:
            self.fixed_addresses = fixed_addresses
        if num_dynamic_addresses is not None:
            self.num_dynamic_addresses = num_dynamic_addresses
        if address_range is not None:
            self.address_range = address_range
        if subnet_id is not None:
            self.subnet_id = subnet_id

    @property
    def type(self):
        """Gets the type of this IpOverEthernetAddressDataIpAddresses.  # noqa: E501

        The type of the IP addresses. Permitted values: IPV4, IPV6.   # noqa: E501

        :return: The type of this IpOverEthernetAddressDataIpAddresses.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this IpOverEthernetAddressDataIpAddresses.

        The type of the IP addresses. Permitted values: IPV4, IPV6.   # noqa: E501

        :param type: The type of this IpOverEthernetAddressDataIpAddresses.  # noqa: E501
        :type: str
        """
        if type is None:
            print("WARNING: Invalid value for the required field `type`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501
        allowed_values = ["IPV4", "IPV6"]  # noqa: E501
        if type is not None and type not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def fixed_addresses(self):
        """Gets the fixed_addresses of this IpOverEthernetAddressDataIpAddresses.  # noqa: E501

        Fixed addresses to assign (from the subnet defined by \"subnetId\" if provided). Exactly one of \"fixedAddresses\", \"numDynamicAddresses\" or \"ipAddressRange\" shall be present.   # noqa: E501

        :return: The fixed_addresses of this IpOverEthernetAddressDataIpAddresses.  # noqa: E501
        :rtype: list[IpAddress]
        """
        return self._fixed_addresses

    @fixed_addresses.setter
    def fixed_addresses(self, fixed_addresses):
        """Sets the fixed_addresses of this IpOverEthernetAddressDataIpAddresses.

        Fixed addresses to assign (from the subnet defined by \"subnetId\" if provided). Exactly one of \"fixedAddresses\", \"numDynamicAddresses\" or \"ipAddressRange\" shall be present.   # noqa: E501

        :param fixed_addresses: The fixed_addresses of this IpOverEthernetAddressDataIpAddresses.  # noqa: E501
        :type: list[IpAddress]
        """

        self._fixed_addresses = fixed_addresses

    @property
    def num_dynamic_addresses(self):
        """Gets the num_dynamic_addresses of this IpOverEthernetAddressDataIpAddresses.  # noqa: E501

        Number of dynamic addresses to assign (from the subnet defined by \"subnetId\" if provided). Exactly one of \"fixedAddresses\", \"numDynamicAddresses\" or \"ipAddressRange\" shall be present.   # noqa: E501

        :return: The num_dynamic_addresses of this IpOverEthernetAddressDataIpAddresses.  # noqa: E501
        :rtype: int
        """
        return self._num_dynamic_addresses

    @num_dynamic_addresses.setter
    def num_dynamic_addresses(self, num_dynamic_addresses):
        """Sets the num_dynamic_addresses of this IpOverEthernetAddressDataIpAddresses.

        Number of dynamic addresses to assign (from the subnet defined by \"subnetId\" if provided). Exactly one of \"fixedAddresses\", \"numDynamicAddresses\" or \"ipAddressRange\" shall be present.   # noqa: E501

        :param num_dynamic_addresses: The num_dynamic_addresses of this IpOverEthernetAddressDataIpAddresses.  # noqa: E501
        :type: int
        """

        self._num_dynamic_addresses = num_dynamic_addresses

    @property
    def address_range(self):
        """Gets the address_range of this IpOverEthernetAddressDataIpAddresses.  # noqa: E501


        :return: The address_range of this IpOverEthernetAddressDataIpAddresses.  # noqa: E501
        :rtype: IpOverEthernetAddressDataAddressRange
        """
        return self._address_range

    @address_range.setter
    def address_range(self, address_range):
        """Sets the address_range of this IpOverEthernetAddressDataIpAddresses.


        :param address_range: The address_range of this IpOverEthernetAddressDataIpAddresses.  # noqa: E501
        :type: IpOverEthernetAddressDataAddressRange
        """

        self._address_range = address_range

    @property
    def subnet_id(self):
        """Gets the subnet_id of this IpOverEthernetAddressDataIpAddresses.  # noqa: E501


        :return: The subnet_id of this IpOverEthernetAddressDataIpAddresses.  # noqa: E501
        :rtype: IdentifierInVim
        """
        return self._subnet_id

    @subnet_id.setter
    def subnet_id(self, subnet_id):
        """Sets the subnet_id of this IpOverEthernetAddressDataIpAddresses.


        :param subnet_id: The subnet_id of this IpOverEthernetAddressDataIpAddresses.  # noqa: E501
        :type: IdentifierInVim
        """

        self._subnet_id = subnet_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IpOverEthernetAddressDataIpAddresses, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IpOverEthernetAddressDataIpAddresses):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
