# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class IpOverEthernetAddressInfoIpAddresses(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'type': 'str',
        'addresses': 'list[IpAddress]',
        'is_dynamic': 'bool',
        'address_range': 'IpOverEthernetAddressInfoAddressRange',
        'subnet_id': 'IdentifierInVim'
    }

    attribute_map = {
        'type': 'type',
        'addresses': 'addresses',
        'is_dynamic': 'isDynamic',
        'address_range': 'addressRange',
        'subnet_id': 'subnetId'
    }

    def __init__(self, type=None, addresses=None, is_dynamic=None, address_range=None, subnet_id=None):  # noqa: E501
        """IpOverEthernetAddressInfoIpAddresses - a model defined in Swagger"""  # noqa: E501
        self._type = None
        self._addresses = None
        self._is_dynamic = None
        self._address_range = None
        self._subnet_id = None
        self.discriminator = None
        self.type = type
        if addresses is not None:
            self.addresses = addresses
        if is_dynamic is not None:
            self.is_dynamic = is_dynamic
        if address_range is not None:
            self.address_range = address_range
        if subnet_id is not None:
            self.subnet_id = subnet_id

    @property
    def type(self):
        """Gets the type of this IpOverEthernetAddressInfoIpAddresses.  # noqa: E501

        The type of the IP addresses. Permitted values: IPV4, IPV6.   # noqa: E501

        :return: The type of this IpOverEthernetAddressInfoIpAddresses.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this IpOverEthernetAddressInfoIpAddresses.

        The type of the IP addresses. Permitted values: IPV4, IPV6.   # noqa: E501

        :param type: The type of this IpOverEthernetAddressInfoIpAddresses.  # noqa: E501
        :type: str
        """
        if type is None:
            print("WARNING: Invalid value for the required field `type`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501
        allowed_values = ["IPV4", "IPV6"]  # noqa: E501
        if type is not None and type not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def addresses(self):
        """Gets the addresses of this IpOverEthernetAddressInfoIpAddresses.  # noqa: E501

        Fixed addresses assigned (from the subnet defined by \"subnetId\" if provided). Exactly one of \"addresses\" or \"addressRange\" shall be present.   # noqa: E501

        :return: The addresses of this IpOverEthernetAddressInfoIpAddresses.  # noqa: E501
        :rtype: list[IpAddress]
        """
        return self._addresses

    @addresses.setter
    def addresses(self, addresses):
        """Sets the addresses of this IpOverEthernetAddressInfoIpAddresses.

        Fixed addresses assigned (from the subnet defined by \"subnetId\" if provided). Exactly one of \"addresses\" or \"addressRange\" shall be present.   # noqa: E501

        :param addresses: The addresses of this IpOverEthernetAddressInfoIpAddresses.  # noqa: E501
        :type: list[IpAddress]
        """

        self._addresses = addresses

    @property
    def is_dynamic(self):
        """Gets the is_dynamic of this IpOverEthernetAddressInfoIpAddresses.  # noqa: E501

        Indicates whether this set of addresses was assigned dynamically (true) or based on address information provided as input from the API consumer (false). Shall be present if \"addresses\" is present and shall be absent otherwise.   # noqa: E501

        :return: The is_dynamic of this IpOverEthernetAddressInfoIpAddresses.  # noqa: E501
        :rtype: bool
        """
        return self._is_dynamic

    @is_dynamic.setter
    def is_dynamic(self, is_dynamic):
        """Sets the is_dynamic of this IpOverEthernetAddressInfoIpAddresses.

        Indicates whether this set of addresses was assigned dynamically (true) or based on address information provided as input from the API consumer (false). Shall be present if \"addresses\" is present and shall be absent otherwise.   # noqa: E501

        :param is_dynamic: The is_dynamic of this IpOverEthernetAddressInfoIpAddresses.  # noqa: E501
        :type: bool
        """

        self._is_dynamic = is_dynamic

    @property
    def address_range(self):
        """Gets the address_range of this IpOverEthernetAddressInfoIpAddresses.  # noqa: E501


        :return: The address_range of this IpOverEthernetAddressInfoIpAddresses.  # noqa: E501
        :rtype: IpOverEthernetAddressInfoAddressRange
        """
        return self._address_range

    @address_range.setter
    def address_range(self, address_range):
        """Sets the address_range of this IpOverEthernetAddressInfoIpAddresses.


        :param address_range: The address_range of this IpOverEthernetAddressInfoIpAddresses.  # noqa: E501
        :type: IpOverEthernetAddressInfoAddressRange
        """

        self._address_range = address_range

    @property
    def subnet_id(self):
        """Gets the subnet_id of this IpOverEthernetAddressInfoIpAddresses.  # noqa: E501


        :return: The subnet_id of this IpOverEthernetAddressInfoIpAddresses.  # noqa: E501
        :rtype: IdentifierInVim
        """
        return self._subnet_id

    @subnet_id.setter
    def subnet_id(self, subnet_id):
        """Sets the subnet_id of this IpOverEthernetAddressInfoIpAddresses.


        :param subnet_id: The subnet_id of this IpOverEthernetAddressInfoIpAddresses.  # noqa: E501
        :type: IdentifierInVim
        """

        self._subnet_id = subnet_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IpOverEthernetAddressInfoIpAddresses, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IpOverEthernetAddressInfoIpAddresses):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
