# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class LccnSubscriptionRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'filter': 'LifecycleChangeNotificationsFilter',
        'callback_uri': 'Uri',
        'authentication': 'SubscriptionAuthentication'
    }

    attribute_map = {
        'filter': 'filter',
        'callback_uri': 'callbackUri',
        'authentication': 'authentication'
    }

    def __init__(self, filter=None, callback_uri=None, authentication=None):  # noqa: E501
        """LccnSubscriptionRequest - a model defined in Swagger"""  # noqa: E501
        self._filter = None
        self._callback_uri = None
        self._authentication = None
        self.discriminator = None
        if filter is not None:
            self.filter = filter
        self.callback_uri = callback_uri
        if authentication is not None:
            self.authentication = authentication

    @property
    def filter(self):
        """Gets the filter of this LccnSubscriptionRequest.  # noqa: E501


        :return: The filter of this LccnSubscriptionRequest.  # noqa: E501
        :rtype: LifecycleChangeNotificationsFilter
        """
        return self._filter

    @filter.setter
    def filter(self, filter):
        """Sets the filter of this LccnSubscriptionRequest.


        :param filter: The filter of this LccnSubscriptionRequest.  # noqa: E501
        :type: LifecycleChangeNotificationsFilter
        """

        self._filter = filter

    @property
    def callback_uri(self):
        """Gets the callback_uri of this LccnSubscriptionRequest.  # noqa: E501


        :return: The callback_uri of this LccnSubscriptionRequest.  # noqa: E501
        :rtype: Uri
        """
        return self._callback_uri

    @callback_uri.setter
    def callback_uri(self, callback_uri):
        """Sets the callback_uri of this LccnSubscriptionRequest.


        :param callback_uri: The callback_uri of this LccnSubscriptionRequest.  # noqa: E501
        :type: Uri
        """
        if callback_uri is None:
            print("WARNING: Invalid value for the required field `callback_uri`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `callback_uri`, must not be `None`")  # noqa: E501

        self._callback_uri = callback_uri

    @property
    def authentication(self):
        """Gets the authentication of this LccnSubscriptionRequest.  # noqa: E501


        :return: The authentication of this LccnSubscriptionRequest.  # noqa: E501
        :rtype: SubscriptionAuthentication
        """
        return self._authentication

    @authentication.setter
    def authentication(self, authentication):
        """Sets the authentication of this LccnSubscriptionRequest.


        :param authentication: The authentication of this LccnSubscriptionRequest.  # noqa: E501
        :type: SubscriptionAuthentication
        """

        self._authentication = authentication

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(LccnSubscriptionRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LccnSubscriptionRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
