# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class LcmInterfaces(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'interface_name': 'str',
        'parameters': 'list[LcmInterfacesParameters]'
    }

    attribute_map = {
        'interface_name': 'interfaceName',
        'parameters': 'parameters'
    }

    def __init__(self, interface_name=None, parameters=None):  # noqa: E501
        """LcmInterfaces - a model defined in Swagger"""  # noqa: E501
        self._interface_name = None
        self._parameters = None
        self.discriminator = None
        if interface_name is not None:
            self.interface_name = interface_name
        if parameters is not None:
            self.parameters = parameters

    @property
    def interface_name(self):
        """Gets the interface_name of this LcmInterfaces.  # noqa: E501


        :return: The interface_name of this LcmInterfaces.  # noqa: E501
        :rtype: str
        """
        return self._interface_name

    @interface_name.setter
    def interface_name(self, interface_name):
        """Sets the interface_name of this LcmInterfaces.


        :param interface_name: The interface_name of this LcmInterfaces.  # noqa: E501
        :type: str
        """

        self._interface_name = interface_name

    @property
    def parameters(self):
        """Gets the parameters of this LcmInterfaces.  # noqa: E501


        :return: The parameters of this LcmInterfaces.  # noqa: E501
        :rtype: list[LcmInterfacesParameters]
        """
        return self._parameters

    @parameters.setter
    def parameters(self, parameters):
        """Sets the parameters of this LcmInterfaces.


        :param parameters: The parameters of this LcmInterfaces.  # noqa: E501
        :type: list[LcmInterfacesParameters]
        """

        self._parameters = parameters

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(LcmInterfaces, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LcmInterfaces):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
