# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class LifecycleChangeNotificationsFilter(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnf_instance_subscription_filter': 'VnfInstanceSubscriptionFilter',
        'notification_types': 'list[str]',
        'operation_types': 'list[LcmOperationType]',
        'operation_states': 'list[LcmOperationStateType]'
    }

    attribute_map = {
        'vnf_instance_subscription_filter': 'vnfInstanceSubscriptionFilter',
        'notification_types': 'notificationTypes',
        'operation_types': 'operationTypes',
        'operation_states': 'operationStates'
    }

    def __init__(self, vnf_instance_subscription_filter=None, notification_types=None, operation_types=None, operation_states=None):  # noqa: E501
        """LifecycleChangeNotificationsFilter - a model defined in Swagger"""  # noqa: E501
        self._vnf_instance_subscription_filter = None
        self._notification_types = None
        self._operation_types = None
        self._operation_states = None
        self.discriminator = None
        if vnf_instance_subscription_filter is not None:
            self.vnf_instance_subscription_filter = vnf_instance_subscription_filter
        if notification_types is not None:
            self.notification_types = notification_types
        if operation_types is not None:
            self.operation_types = operation_types
        if operation_states is not None:
            self.operation_states = operation_states

    @property
    def vnf_instance_subscription_filter(self):
        """Gets the vnf_instance_subscription_filter of this LifecycleChangeNotificationsFilter.  # noqa: E501


        :return: The vnf_instance_subscription_filter of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :rtype: VnfInstanceSubscriptionFilter
        """
        return self._vnf_instance_subscription_filter

    @vnf_instance_subscription_filter.setter
    def vnf_instance_subscription_filter(self, vnf_instance_subscription_filter):
        """Sets the vnf_instance_subscription_filter of this LifecycleChangeNotificationsFilter.


        :param vnf_instance_subscription_filter: The vnf_instance_subscription_filter of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :type: VnfInstanceSubscriptionFilter
        """

        self._vnf_instance_subscription_filter = vnf_instance_subscription_filter

    @property
    def notification_types(self):
        """Gets the notification_types of this LifecycleChangeNotificationsFilter.  # noqa: E501

        Match particular notification types. Permitted values: - VnfLcmOperationOccurrenceNotification - VnfIdentifierCreationNotification - VnfIdentifierDeletionNotification The permitted values of the \"notificationTypes\" attribute are spelled exactly as the names of the notification types to facilitate automated code generation systems.   # noqa: E501

        :return: The notification_types of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :rtype: list[str]
        """
        return self._notification_types

    @notification_types.setter
    def notification_types(self, notification_types):
        """Sets the notification_types of this LifecycleChangeNotificationsFilter.

        Match particular notification types. Permitted values: - VnfLcmOperationOccurrenceNotification - VnfIdentifierCreationNotification - VnfIdentifierDeletionNotification The permitted values of the \"notificationTypes\" attribute are spelled exactly as the names of the notification types to facilitate automated code generation systems.   # noqa: E501

        :param notification_types: The notification_types of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :type: list[str]
        """

        self._notification_types = notification_types

    @property
    def operation_types(self):
        """Gets the operation_types of this LifecycleChangeNotificationsFilter.  # noqa: E501

        Match particular VNF lifecycle operation types for the notification of type VnfLcmOperationOccurrenceNotification. May be present if the \"notificationTypes\" attribute contains the value \"VnfLcmOperationOccurrenceNotification\", and shall be absent otherwise.   # noqa: E501

        :return: The operation_types of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :rtype: list[LcmOperationType]
        """
        return self._operation_types

    @operation_types.setter
    def operation_types(self, operation_types):
        """Sets the operation_types of this LifecycleChangeNotificationsFilter.

        Match particular VNF lifecycle operation types for the notification of type VnfLcmOperationOccurrenceNotification. May be present if the \"notificationTypes\" attribute contains the value \"VnfLcmOperationOccurrenceNotification\", and shall be absent otherwise.   # noqa: E501

        :param operation_types: The operation_types of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :type: list[LcmOperationType]
        """

        self._operation_types = operation_types

    @property
    def operation_states(self):
        """Gets the operation_states of this LifecycleChangeNotificationsFilter.  # noqa: E501

        Match particular LCM operation state values as reported in notifications of type VnfLcmOperationOccurrenceNotification. May be present if the \"notificationTypes\" attribute contains the value \"VnfLcmOperationOccurrenceNotification\", and shall be absent otherwise.   # noqa: E501

        :return: The operation_states of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :rtype: list[LcmOperationStateType]
        """
        return self._operation_states

    @operation_states.setter
    def operation_states(self, operation_states):
        """Sets the operation_states of this LifecycleChangeNotificationsFilter.

        Match particular LCM operation state values as reported in notifications of type VnfLcmOperationOccurrenceNotification. May be present if the \"notificationTypes\" attribute contains the value \"VnfLcmOperationOccurrenceNotification\", and shall be absent otherwise.   # noqa: E501

        :param operation_states: The operation_states of this LifecycleChangeNotificationsFilter.  # noqa: E501
        :type: list[LcmOperationStateType]
        """

        self._operation_states = operation_states

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(LifecycleChangeNotificationsFilter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LifecycleChangeNotificationsFilter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
