# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class MetaData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'tags': 'list[VnfInstanceMetadataTags]',
        'extension_id': 'str'
    }

    attribute_map = {
        'tags': 'tags',
        'extension_id': 'extensionId'
    }

    def __init__(self, tags=None, extension_id=None):  # noqa: E501
        """MetaData - a model defined in Swagger"""  # noqa: E501
        self._tags = None
        self._extension_id = None
        self.discriminator = None
        if tags is not None:
            self.tags = tags
        if extension_id is not None:
            self.extension_id = extension_id

    @property
    def tags(self):
        """Gets the tags of this MetaData.  # noqa: E501


        :return: The tags of this MetaData.  # noqa: E501
        :rtype: list[VnfInstanceMetadataTags]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this MetaData.


        :param tags: The tags of this MetaData.  # noqa: E501
        :type: list[VnfInstanceMetadataTags]
        """

        self._tags = tags

    @property
    def extension_id(self):
        """Gets the extension_id of this MetaData.  # noqa: E501


        :return: The extension_id of this MetaData.  # noqa: E501
        :rtype: str
        """
        return self._extension_id

    @extension_id.setter
    def extension_id(self, extension_id):
        """Sets the extension_id of this MetaData.


        :param extension_id: The extension_id of this MetaData.  # noqa: E501
        :type: str
        """

        self._extension_id = extension_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MetaData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MetaData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
