# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ScaleInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'aspect_id': 'IdentifierInVnfd',
        'scale_level': 'int'
    }

    attribute_map = {
        'aspect_id': 'aspectId',
        'scale_level': 'scaleLevel'
    }

    def __init__(self, aspect_id=None, scale_level=None):  # noqa: E501
        """ScaleInfo - a model defined in Swagger"""  # noqa: E501
        self._aspect_id = None
        self._scale_level = None
        self.discriminator = None
        self.aspect_id = aspect_id
        self.scale_level = scale_level

    @property
    def aspect_id(self):
        """Gets the aspect_id of this ScaleInfo.  # noqa: E501


        :return: The aspect_id of this ScaleInfo.  # noqa: E501
        :rtype: IdentifierInVnfd
        """
        return self._aspect_id

    @aspect_id.setter
    def aspect_id(self, aspect_id):
        """Sets the aspect_id of this ScaleInfo.


        :param aspect_id: The aspect_id of this ScaleInfo.  # noqa: E501
        :type: IdentifierInVnfd
        """
        if aspect_id is None:
            print("WARNING: Invalid value for the required field `aspect_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `aspect_id`, must not be `None`")  # noqa: E501

        self._aspect_id = aspect_id

    @property
    def scale_level(self):
        """Gets the scale_level of this ScaleInfo.  # noqa: E501

        Indicates the scale level. The minimum value shall be 0 and the maximum value shall be <= maxScaleLevel as described in the VNFD.   # noqa: E501

        :return: The scale_level of this ScaleInfo.  # noqa: E501
        :rtype: int
        """
        return self._scale_level

    @scale_level.setter
    def scale_level(self, scale_level):
        """Sets the scale_level of this ScaleInfo.

        Indicates the scale level. The minimum value shall be 0 and the maximum value shall be <= maxScaleLevel as described in the VNFD.   # noqa: E501

        :param scale_level: The scale_level of this ScaleInfo.  # noqa: E501
        :type: int
        """
        if scale_level is None:
            print("WARNING: Invalid value for the required field `scale_level`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `scale_level`, must not be `None`")  # noqa: E501

        self._scale_level = scale_level

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ScaleInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScaleInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
