# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ScaleVnfRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'type': 'str',
        'aspect_id': 'IdentifierInVnfd',
        'number_of_steps': 'int',
        'additional_params': 'ScaleVnfRequestAdditionalParams'
    }

    attribute_map = {
        'type': 'type',
        'aspect_id': 'aspectId',
        'number_of_steps': 'numberOfSteps',
        'additional_params': 'additionalParams'
    }

    def __init__(self, type=None, aspect_id=None, number_of_steps=None, additional_params=None):  # noqa: E501
        """ScaleVnfRequest - a model defined in Swagger"""  # noqa: E501
        self._type = None
        self._aspect_id = None
        self._number_of_steps = None
        self._additional_params = None
        self.discriminator = None
        self.type = type
        self.aspect_id = aspect_id
        if number_of_steps is not None:
            self.number_of_steps = number_of_steps
        if additional_params is not None:
            self.additional_params = additional_params

    @property
    def type(self):
        """Gets the type of this ScaleVnfRequest.  # noqa: E501

        Indicates the type of the scale operation requested. Permitted values: * SCALE_OUT: adding additional VNFC instances to the VNF to increase   capacity * SCALE_IN: removing VNFC instances from the VNF in order to release   unused capacity.   # noqa: E501

        :return: The type of this ScaleVnfRequest.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ScaleVnfRequest.

        Indicates the type of the scale operation requested. Permitted values: * SCALE_OUT: adding additional VNFC instances to the VNF to increase   capacity * SCALE_IN: removing VNFC instances from the VNF in order to release   unused capacity.   # noqa: E501

        :param type: The type of this ScaleVnfRequest.  # noqa: E501
        :type: str
        """
        if type is None:
            print("WARNING: Invalid value for the required field `type`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501
        allowed_values = ["SCALE_OUT", "SCALE_IN"]  # noqa: E501
        if type is not None and type not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def aspect_id(self):
        """Gets the aspect_id of this ScaleVnfRequest.  # noqa: E501


        :return: The aspect_id of this ScaleVnfRequest.  # noqa: E501
        :rtype: IdentifierInVnfd
        """
        return self._aspect_id

    @aspect_id.setter
    def aspect_id(self, aspect_id):
        """Sets the aspect_id of this ScaleVnfRequest.


        :param aspect_id: The aspect_id of this ScaleVnfRequest.  # noqa: E501
        :type: IdentifierInVnfd
        """
        if aspect_id is None:
            print("WARNING: Invalid value for the required field `aspect_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `aspect_id`, must not be `None`")  # noqa: E501

        self._aspect_id = aspect_id

    @property
    def number_of_steps(self):
        """Gets the number_of_steps of this ScaleVnfRequest.  # noqa: E501

        Number of scaling steps to be executed as part of this Scale VNF operation. It shall be a positive number and the default value shall be 1.   # noqa: E501

        :return: The number_of_steps of this ScaleVnfRequest.  # noqa: E501
        :rtype: int
        """
        return self._number_of_steps

    @number_of_steps.setter
    def number_of_steps(self, number_of_steps):
        """Sets the number_of_steps of this ScaleVnfRequest.

        Number of scaling steps to be executed as part of this Scale VNF operation. It shall be a positive number and the default value shall be 1.   # noqa: E501

        :param number_of_steps: The number_of_steps of this ScaleVnfRequest.  # noqa: E501
        :type: int
        """

        self._number_of_steps = number_of_steps

    @property
    def additional_params(self):
        """Gets the additional_params of this ScaleVnfRequest.  # noqa: E501


        :return: The additional_params of this ScaleVnfRequest.  # noqa: E501
        :rtype: ScaleVnfRequestAdditionalParams
        """
        return self._additional_params

    @additional_params.setter
    def additional_params(self, additional_params):
        """Sets the additional_params of this ScaleVnfRequest.


        :param additional_params: The additional_params of this ScaleVnfRequest.  # noqa: E501
        :type: ScaleVnfRequestAdditionalParams
        """

        self._additional_params = additional_params

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ScaleVnfRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScaleVnfRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
