# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ScaleVnfRequestAdditionalParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'action': 'str',
        'skip_grant': 'bool',
        'vdu_params': 'list[VduParam]',
        'lcm_interfaces': 'list[LcmInterfaces]'
    }

    attribute_map = {
        'action': 'action',
        'skip_grant': 'skipGrant',
        'vdu_params': 'vduParams',
        'lcm_interfaces': 'lcmInterfaces'
    }

    def __init__(self, action=None, skip_grant=None, vdu_params=None, lcm_interfaces=None):  # noqa: E501
        """ScaleVnfRequestAdditionalParams - a model defined in Swagger"""  # noqa: E501
        self._action = None
        self._skip_grant = None
        self._vdu_params = None
        self._lcm_interfaces = None
        self.discriminator = None
        if action is not None:
            self.action = action
        if skip_grant is not None:
            self.skip_grant = skip_grant
        if vdu_params is not None:
            self.vdu_params = vdu_params
        if lcm_interfaces is not None:
            self.lcm_interfaces = lcm_interfaces

    @property
    def action(self):
        """Gets the action of this ScaleVnfRequestAdditionalParams.  # noqa: E501

        This represents the type of scale action performed. Example: Scale, Reconfigure   # noqa: E501

        :return: The action of this ScaleVnfRequestAdditionalParams.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this ScaleVnfRequestAdditionalParams.

        This represents the type of scale action performed. Example: Scale, Reconfigure   # noqa: E501

        :param action: The action of this ScaleVnfRequestAdditionalParams.  # noqa: E501
        :type: str
        """

        self._action = action

    @property
    def skip_grant(self):
        """Gets the skip_grant of this ScaleVnfRequestAdditionalParams.  # noqa: E501

        Set to true if grant phase is to be skipped in this VNF LCM operation occurrence. Set to false otherwise.   # noqa: E501

        :return: The skip_grant of this ScaleVnfRequestAdditionalParams.  # noqa: E501
        :rtype: bool
        """
        return self._skip_grant

    @skip_grant.setter
    def skip_grant(self, skip_grant):
        """Sets the skip_grant of this ScaleVnfRequestAdditionalParams.

        Set to true if grant phase is to be skipped in this VNF LCM operation occurrence. Set to false otherwise.   # noqa: E501

        :param skip_grant: The skip_grant of this ScaleVnfRequestAdditionalParams.  # noqa: E501
        :type: bool
        """

        self._skip_grant = skip_grant

    @property
    def vdu_params(self):
        """Gets the vdu_params of this ScaleVnfRequestAdditionalParams.  # noqa: E501


        :return: The vdu_params of this ScaleVnfRequestAdditionalParams.  # noqa: E501
        :rtype: list[VduParam]
        """
        return self._vdu_params

    @vdu_params.setter
    def vdu_params(self, vdu_params):
        """Sets the vdu_params of this ScaleVnfRequestAdditionalParams.


        :param vdu_params: The vdu_params of this ScaleVnfRequestAdditionalParams.  # noqa: E501
        :type: list[VduParam]
        """

        self._vdu_params = vdu_params

    @property
    def lcm_interfaces(self):
        """Gets the lcm_interfaces of this ScaleVnfRequestAdditionalParams.  # noqa: E501


        :return: The lcm_interfaces of this ScaleVnfRequestAdditionalParams.  # noqa: E501
        :rtype: list[LcmInterfaces]
        """
        return self._lcm_interfaces

    @lcm_interfaces.setter
    def lcm_interfaces(self, lcm_interfaces):
        """Sets the lcm_interfaces of this ScaleVnfRequestAdditionalParams.


        :param lcm_interfaces: The lcm_interfaces of this ScaleVnfRequestAdditionalParams.  # noqa: E501
        :type: list[LcmInterfaces]
        """

        self._lcm_interfaces = lcm_interfaces

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ScaleVnfRequestAdditionalParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScaleVnfRequestAdditionalParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
