# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ScaleVnfToLevelRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'instantiation_level_id': 'IdentifierInVnfd',
        'scale_info': 'list[ScaleInfo]',
        'additional_params': 'ScaleVnfRequestAdditionalParams'
    }

    attribute_map = {
        'instantiation_level_id': 'instantiationLevelId',
        'scale_info': 'scaleInfo',
        'additional_params': 'additionalParams'
    }

    def __init__(self, instantiation_level_id=None, scale_info=None, additional_params=None):  # noqa: E501
        """ScaleVnfToLevelRequest - a model defined in Swagger"""  # noqa: E501
        self._instantiation_level_id = None
        self._scale_info = None
        self._additional_params = None
        self.discriminator = None
        if instantiation_level_id is not None:
            self.instantiation_level_id = instantiation_level_id
        if scale_info is not None:
            self.scale_info = scale_info
        if additional_params is not None:
            self.additional_params = additional_params

    @property
    def instantiation_level_id(self):
        """Gets the instantiation_level_id of this ScaleVnfToLevelRequest.  # noqa: E501


        :return: The instantiation_level_id of this ScaleVnfToLevelRequest.  # noqa: E501
        :rtype: IdentifierInVnfd
        """
        return self._instantiation_level_id

    @instantiation_level_id.setter
    def instantiation_level_id(self, instantiation_level_id):
        """Sets the instantiation_level_id of this ScaleVnfToLevelRequest.


        :param instantiation_level_id: The instantiation_level_id of this ScaleVnfToLevelRequest.  # noqa: E501
        :type: IdentifierInVnfd
        """

        self._instantiation_level_id = instantiation_level_id

    @property
    def scale_info(self):
        """Gets the scale_info of this ScaleVnfToLevelRequest.  # noqa: E501

        For each scaling aspect of the current deployment flavour, indicates the target scale level to which the VNF is to be scaled. Either the instantiationLevelId attribute or the scaleInfo attribute shall be included.   # noqa: E501

        :return: The scale_info of this ScaleVnfToLevelRequest.  # noqa: E501
        :rtype: list[ScaleInfo]
        """
        return self._scale_info

    @scale_info.setter
    def scale_info(self, scale_info):
        """Sets the scale_info of this ScaleVnfToLevelRequest.

        For each scaling aspect of the current deployment flavour, indicates the target scale level to which the VNF is to be scaled. Either the instantiationLevelId attribute or the scaleInfo attribute shall be included.   # noqa: E501

        :param scale_info: The scale_info of this ScaleVnfToLevelRequest.  # noqa: E501
        :type: list[ScaleInfo]
        """

        self._scale_info = scale_info

    @property
    def additional_params(self):
        """Gets the additional_params of this ScaleVnfToLevelRequest.  # noqa: E501


        :return: The additional_params of this ScaleVnfToLevelRequest.  # noqa: E501
        :rtype: ScaleVnfRequestAdditionalParams
        """
        return self._additional_params

    @additional_params.setter
    def additional_params(self, additional_params):
        """Sets the additional_params of this ScaleVnfToLevelRequest.


        :param additional_params: The additional_params of this ScaleVnfToLevelRequest.  # noqa: E501
        :type: ScaleVnfRequestAdditionalParams
        """

        self._additional_params = additional_params

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ScaleVnfToLevelRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScaleVnfToLevelRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
