# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class TerminateVnfRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'termination_type': 'str',
        'graceful_termination_timeout': 'int',
        'additional_params': 'TerminateVnfRequestAdditionalParams'
    }

    attribute_map = {
        'termination_type': 'terminationType',
        'graceful_termination_timeout': 'gracefulTerminationTimeout',
        'additional_params': 'additionalParams'
    }

    def __init__(self, termination_type=None, graceful_termination_timeout=None, additional_params=None):  # noqa: E501
        """TerminateVnfRequest - a model defined in Swagger"""  # noqa: E501
        self._termination_type = None
        self._graceful_termination_timeout = None
        self._additional_params = None
        self.discriminator = None
        self.termination_type = termination_type
        if graceful_termination_timeout is not None:
            self.graceful_termination_timeout = graceful_termination_timeout
        if additional_params is not None:
            self.additional_params = additional_params

    @property
    def termination_type(self):
        """Gets the termination_type of this TerminateVnfRequest.  # noqa: E501

        Indicates whether forceful or graceful termination is requested. Permitted values: * FORCEFUL: The VNFM will shut down the VNF and release the   resources immediately after accepting the request. * GRACEFUL: The VNFM will first arrange to take the VNF out of service after accepting the request. Once the operation of taking the VNF out of service finishes (irrespective of whether it has succeeded or failed) or once the timer value specified in the \"gracefulTerminationTimeout\" attribute expires, the VNFM will shut down the VNF and release the resources.   # noqa: E501

        :return: The termination_type of this TerminateVnfRequest.  # noqa: E501
        :rtype: str
        """
        return self._termination_type

    @termination_type.setter
    def termination_type(self, termination_type):
        """Sets the termination_type of this TerminateVnfRequest.

        Indicates whether forceful or graceful termination is requested. Permitted values: * FORCEFUL: The VNFM will shut down the VNF and release the   resources immediately after accepting the request. * GRACEFUL: The VNFM will first arrange to take the VNF out of service after accepting the request. Once the operation of taking the VNF out of service finishes (irrespective of whether it has succeeded or failed) or once the timer value specified in the \"gracefulTerminationTimeout\" attribute expires, the VNFM will shut down the VNF and release the resources.   # noqa: E501

        :param termination_type: The termination_type of this TerminateVnfRequest.  # noqa: E501
        :type: str
        """
        if termination_type is None:
            print("WARNING: Invalid value for the required field `termination_type`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `termination_type`, must not be `None`")  # noqa: E501
        allowed_values = ["FORCEFUL", "GRACEFUL"]  # noqa: E501
        if termination_type is not None and termination_type not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `termination_type` ({0}), must be one of {1}"  # noqa: E501
                .format(termination_type, allowed_values)
            )

        self._termination_type = termination_type

    @property
    def graceful_termination_timeout(self):
        """Gets the graceful_termination_timeout of this TerminateVnfRequest.  # noqa: E501

        This attribute is only applicable in case of graceful termination. It defines the time to wait for the VNF to be taken out of service before shutting down the VNF and releasing the resources. The unit is seconds. If not given and the \"terminationType\" attribute is set to \"GRACEFUL\", it is expected that the VNFM waits for the successful taking out of service of the VNF, no matter how long it takes, before shutting down the VNF and releasing the resources.   # noqa: E501

        :return: The graceful_termination_timeout of this TerminateVnfRequest.  # noqa: E501
        :rtype: int
        """
        return self._graceful_termination_timeout

    @graceful_termination_timeout.setter
    def graceful_termination_timeout(self, graceful_termination_timeout):
        """Sets the graceful_termination_timeout of this TerminateVnfRequest.

        This attribute is only applicable in case of graceful termination. It defines the time to wait for the VNF to be taken out of service before shutting down the VNF and releasing the resources. The unit is seconds. If not given and the \"terminationType\" attribute is set to \"GRACEFUL\", it is expected that the VNFM waits for the successful taking out of service of the VNF, no matter how long it takes, before shutting down the VNF and releasing the resources.   # noqa: E501

        :param graceful_termination_timeout: The graceful_termination_timeout of this TerminateVnfRequest.  # noqa: E501
        :type: int
        """

        self._graceful_termination_timeout = graceful_termination_timeout

    @property
    def additional_params(self):
        """Gets the additional_params of this TerminateVnfRequest.  # noqa: E501


        :return: The additional_params of this TerminateVnfRequest.  # noqa: E501
        :rtype: TerminateVnfRequestAdditionalParams
        """
        return self._additional_params

    @additional_params.setter
    def additional_params(self, additional_params):
        """Sets the additional_params of this TerminateVnfRequest.


        :param additional_params: The additional_params of this TerminateVnfRequest.  # noqa: E501
        :type: TerminateVnfRequestAdditionalParams
        """

        self._additional_params = additional_params

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TerminateVnfRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TerminateVnfRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
