# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VduParam(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vdu_name': 'str',
        'vdu_id': 'str',
        'deployment_profile_id': 'str',
        'chart_name': 'str',
        'helm_name': 'str',
        'namespace': 'str',
        'repo_url': 'str',
        'username': 'str',
        'password': 'str',
        'extension_id': 'str',
        'overrides': 'str',
        'metadata': 'list[object]',
        'image_name': 'str',
        'disable_auto_rollback': 'bool',
        'disable_grant': 'bool',
        'ignore_grant_failure': 'bool',
        'catalog_name': 'str',
        'catalog_id': 'str'
    }

    attribute_map = {
        'vdu_name': 'vduName',
        'vdu_id': 'vduId',
        'deployment_profile_id': 'deploymentProfileId',
        'chart_name': 'chartName',
        'helm_name': 'helmName',
        'namespace': 'namespace',
        'repo_url': 'repoUrl',
        'username': 'username',
        'password': 'password',
        'extension_id': 'extensionId',
        'overrides': 'overrides',
        'metadata': 'metadata',
        'image_name': 'imageName',
        'disable_auto_rollback': 'disableAutoRollback',
        'disable_grant': 'disableGrant',
        'ignore_grant_failure': 'ignoreGrantFailure',
        'catalog_name': 'catalogName',
        'catalog_id': 'catalogId'
    }

    def __init__(self, vdu_name=None, vdu_id=None, deployment_profile_id=None, chart_name=None, helm_name=None, namespace=None, repo_url=None, username=None, password=None, extension_id=None, overrides=None, metadata=None, image_name=None, disable_auto_rollback=None, disable_grant=None, ignore_grant_failure=None, catalog_name=None, catalog_id=None):  # noqa: E501
        """VduParam - a model defined in Swagger"""  # noqa: E501
        self._vdu_name = None
        self._vdu_id = None
        self._deployment_profile_id = None
        self._chart_name = None
        self._helm_name = None
        self._namespace = None
        self._repo_url = None
        self._username = None
        self._password = None
        self._extension_id = None
        self._overrides = None
        self._metadata = None
        self._image_name = None
        self._disable_auto_rollback = None
        self._disable_grant = None
        self._ignore_grant_failure = None
        self._catalog_name = None
        self._catalog_id = None
        self.discriminator = None
        if vdu_name is not None:
            self.vdu_name = vdu_name
        if vdu_id is not None:
            self.vdu_id = vdu_id
        if deployment_profile_id is not None:
            self.deployment_profile_id = deployment_profile_id
        if chart_name is not None:
            self.chart_name = chart_name
        if helm_name is not None:
            self.helm_name = helm_name
        if namespace is not None:
            self.namespace = namespace
        if repo_url is not None:
            self.repo_url = repo_url
        if username is not None:
            self.username = username
        if password is not None:
            self.password = password
        if extension_id is not None:
            self.extension_id = extension_id
        if overrides is not None:
            self.overrides = overrides
        if metadata is not None:
            self.metadata = metadata
        if image_name is not None:
            self.image_name = image_name
        if disable_auto_rollback is not None:
            self.disable_auto_rollback = disable_auto_rollback
        if disable_grant is not None:
            self.disable_grant = disable_grant
        if ignore_grant_failure is not None:
            self.ignore_grant_failure = ignore_grant_failure
        if catalog_name is not None:
            self.catalog_name = catalog_name
        if catalog_id is not None:
            self.catalog_id = catalog_id

    @property
    def vdu_name(self):
        """Gets the vdu_name of this VduParam.  # noqa: E501


        :return: The vdu_name of this VduParam.  # noqa: E501
        :rtype: str
        """
        return self._vdu_name

    @vdu_name.setter
    def vdu_name(self, vdu_name):
        """Sets the vdu_name of this VduParam.


        :param vdu_name: The vdu_name of this VduParam.  # noqa: E501
        :type: str
        """

        self._vdu_name = vdu_name

    @property
    def vdu_id(self):
        """Gets the vdu_id of this VduParam.  # noqa: E501


        :return: The vdu_id of this VduParam.  # noqa: E501
        :rtype: str
        """
        return self._vdu_id

    @vdu_id.setter
    def vdu_id(self, vdu_id):
        """Sets the vdu_id of this VduParam.


        :param vdu_id: The vdu_id of this VduParam.  # noqa: E501
        :type: str
        """

        self._vdu_id = vdu_id

    @property
    def deployment_profile_id(self):
        """Gets the deployment_profile_id of this VduParam.  # noqa: E501


        :return: The deployment_profile_id of this VduParam.  # noqa: E501
        :rtype: str
        """
        return self._deployment_profile_id

    @deployment_profile_id.setter
    def deployment_profile_id(self, deployment_profile_id):
        """Sets the deployment_profile_id of this VduParam.


        :param deployment_profile_id: The deployment_profile_id of this VduParam.  # noqa: E501
        :type: str
        """

        self._deployment_profile_id = deployment_profile_id

    @property
    def chart_name(self):
        """Gets the chart_name of this VduParam.  # noqa: E501


        :return: The chart_name of this VduParam.  # noqa: E501
        :rtype: str
        """
        return self._chart_name

    @chart_name.setter
    def chart_name(self, chart_name):
        """Sets the chart_name of this VduParam.


        :param chart_name: The chart_name of this VduParam.  # noqa: E501
        :type: str
        """

        self._chart_name = chart_name

    @property
    def helm_name(self):
        """Gets the helm_name of this VduParam.  # noqa: E501


        :return: The helm_name of this VduParam.  # noqa: E501
        :rtype: str
        """
        return self._helm_name

    @helm_name.setter
    def helm_name(self, helm_name):
        """Sets the helm_name of this VduParam.


        :param helm_name: The helm_name of this VduParam.  # noqa: E501
        :type: str
        """

        self._helm_name = helm_name

    @property
    def namespace(self):
        """Gets the namespace of this VduParam.  # noqa: E501


        :return: The namespace of this VduParam.  # noqa: E501
        :rtype: str
        """
        return self._namespace

    @namespace.setter
    def namespace(self, namespace):
        """Sets the namespace of this VduParam.


        :param namespace: The namespace of this VduParam.  # noqa: E501
        :type: str
        """

        self._namespace = namespace

    @property
    def repo_url(self):
        """Gets the repo_url of this VduParam.  # noqa: E501


        :return: The repo_url of this VduParam.  # noqa: E501
        :rtype: str
        """
        return self._repo_url

    @repo_url.setter
    def repo_url(self, repo_url):
        """Sets the repo_url of this VduParam.


        :param repo_url: The repo_url of this VduParam.  # noqa: E501
        :type: str
        """

        self._repo_url = repo_url

    @property
    def username(self):
        """Gets the username of this VduParam.  # noqa: E501


        :return: The username of this VduParam.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this VduParam.


        :param username: The username of this VduParam.  # noqa: E501
        :type: str
        """

        self._username = username

    @property
    def password(self):
        """Gets the password of this VduParam.  # noqa: E501


        :return: The password of this VduParam.  # noqa: E501
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """Sets the password of this VduParam.


        :param password: The password of this VduParam.  # noqa: E501
        :type: str
        """

        self._password = password

    @property
    def extension_id(self):
        """Gets the extension_id of this VduParam.  # noqa: E501


        :return: The extension_id of this VduParam.  # noqa: E501
        :rtype: str
        """
        return self._extension_id

    @extension_id.setter
    def extension_id(self, extension_id):
        """Sets the extension_id of this VduParam.


        :param extension_id: The extension_id of this VduParam.  # noqa: E501
        :type: str
        """

        self._extension_id = extension_id

    @property
    def overrides(self):
        """Gets the overrides of this VduParam.  # noqa: E501


        :return: The overrides of this VduParam.  # noqa: E501
        :rtype: str
        """
        return self._overrides

    @overrides.setter
    def overrides(self, overrides):
        """Sets the overrides of this VduParam.


        :param overrides: The overrides of this VduParam.  # noqa: E501
        :type: str
        """

        self._overrides = overrides

    @property
    def metadata(self):
        """Gets the metadata of this VduParam.  # noqa: E501


        :return: The metadata of this VduParam.  # noqa: E501
        :rtype: list[object]
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this VduParam.


        :param metadata: The metadata of this VduParam.  # noqa: E501
        :type: list[object]
        """

        self._metadata = metadata

    @property
    def image_name(self):
        """Gets the image_name of this VduParam.  # noqa: E501


        :return: The image_name of this VduParam.  # noqa: E501
        :rtype: str
        """
        return self._image_name

    @image_name.setter
    def image_name(self, image_name):
        """Sets the image_name of this VduParam.


        :param image_name: The image_name of this VduParam.  # noqa: E501
        :type: str
        """

        self._image_name = image_name

    @property
    def disable_auto_rollback(self):
        """Gets the disable_auto_rollback of this VduParam.  # noqa: E501


        :return: The disable_auto_rollback of this VduParam.  # noqa: E501
        :rtype: bool
        """
        return self._disable_auto_rollback

    @disable_auto_rollback.setter
    def disable_auto_rollback(self, disable_auto_rollback):
        """Sets the disable_auto_rollback of this VduParam.


        :param disable_auto_rollback: The disable_auto_rollback of this VduParam.  # noqa: E501
        :type: bool
        """

        self._disable_auto_rollback = disable_auto_rollback

    @property
    def disable_grant(self):
        """Gets the disable_grant of this VduParam.  # noqa: E501


        :return: The disable_grant of this VduParam.  # noqa: E501
        :rtype: bool
        """
        return self._disable_grant

    @disable_grant.setter
    def disable_grant(self, disable_grant):
        """Sets the disable_grant of this VduParam.


        :param disable_grant: The disable_grant of this VduParam.  # noqa: E501
        :type: bool
        """

        self._disable_grant = disable_grant

    @property
    def ignore_grant_failure(self):
        """Gets the ignore_grant_failure of this VduParam.  # noqa: E501


        :return: The ignore_grant_failure of this VduParam.  # noqa: E501
        :rtype: bool
        """
        return self._ignore_grant_failure

    @ignore_grant_failure.setter
    def ignore_grant_failure(self, ignore_grant_failure):
        """Sets the ignore_grant_failure of this VduParam.


        :param ignore_grant_failure: The ignore_grant_failure of this VduParam.  # noqa: E501
        :type: bool
        """

        self._ignore_grant_failure = ignore_grant_failure

    @property
    def catalog_name(self):
        """Gets the catalog_name of this VduParam.  # noqa: E501


        :return: The catalog_name of this VduParam.  # noqa: E501
        :rtype: str
        """
        return self._catalog_name

    @catalog_name.setter
    def catalog_name(self, catalog_name):
        """Sets the catalog_name of this VduParam.


        :param catalog_name: The catalog_name of this VduParam.  # noqa: E501
        :type: str
        """

        self._catalog_name = catalog_name

    @property
    def catalog_id(self):
        """Gets the catalog_id of this VduParam.  # noqa: E501


        :return: The catalog_id of this VduParam.  # noqa: E501
        :rtype: str
        """
        return self._catalog_id

    @catalog_id.setter
    def catalog_id(self, catalog_id):
        """Sets the catalog_id of this VduParam.


        :param catalog_id: The catalog_id of this VduParam.  # noqa: E501
        :type: str
        """

        self._catalog_id = catalog_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VduParam, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VduParam):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
