# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfExtCpConfig(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cp_instance_id': 'IdentifierInVnf',
        'link_port_id': 'Identifier',
        'cp_protocol_data': 'list[CpProtocolData]'
    }

    attribute_map = {
        'cp_instance_id': 'cpInstanceId',
        'link_port_id': 'linkPortId',
        'cp_protocol_data': 'cpProtocolData'
    }

    def __init__(self, cp_instance_id=None, link_port_id=None, cp_protocol_data=None):  # noqa: E501
        """VnfExtCpConfig - a model defined in Swagger"""  # noqa: E501
        self._cp_instance_id = None
        self._link_port_id = None
        self._cp_protocol_data = None
        self.discriminator = None
        if cp_instance_id is not None:
            self.cp_instance_id = cp_instance_id
        if link_port_id is not None:
            self.link_port_id = link_port_id
        if cp_protocol_data is not None:
            self.cp_protocol_data = cp_protocol_data

    @property
    def cp_instance_id(self):
        """Gets the cp_instance_id of this VnfExtCpConfig.  # noqa: E501


        :return: The cp_instance_id of this VnfExtCpConfig.  # noqa: E501
        :rtype: IdentifierInVnf
        """
        return self._cp_instance_id

    @cp_instance_id.setter
    def cp_instance_id(self, cp_instance_id):
        """Sets the cp_instance_id of this VnfExtCpConfig.


        :param cp_instance_id: The cp_instance_id of this VnfExtCpConfig.  # noqa: E501
        :type: IdentifierInVnf
        """

        self._cp_instance_id = cp_instance_id

    @property
    def link_port_id(self):
        """Gets the link_port_id of this VnfExtCpConfig.  # noqa: E501


        :return: The link_port_id of this VnfExtCpConfig.  # noqa: E501
        :rtype: Identifier
        """
        return self._link_port_id

    @link_port_id.setter
    def link_port_id(self, link_port_id):
        """Sets the link_port_id of this VnfExtCpConfig.


        :param link_port_id: The link_port_id of this VnfExtCpConfig.  # noqa: E501
        :type: Identifier
        """

        self._link_port_id = link_port_id

    @property
    def cp_protocol_data(self):
        """Gets the cp_protocol_data of this VnfExtCpConfig.  # noqa: E501

        Parameters for configuring the network protocols on the link port that connects the CP to a VL. The following conditions apply to the attributes \"linkPortId\" and \"cpProtocolData\": 1) The \"linkPortId\" and \"cpProtocolData\" attributes shall both be    absent for the deletion of an existing external CP instance    addressed by cpInstanceId. 2) At least one of these attributes shall be present for a    to-be-created external CP instance or an existing external    CP instance. 3) If the \"linkPortId\" attribute is absent, the VNFM shall create a    link port. 4) If the \"cpProtocolData\" attribute is absent, the \"linkPortId\"    attribute shall be provided referencing a pre-created link port,    and the VNFM can use means outside the scope of the present    document to obtain the pre-configured address information for the    connection point from the resource representing the link port. 5) If both \"cpProtocolData\" and \"linkportId\" are provided, the API    consumer shall ensure that the cpProtocolData can be used with the    pre-created link port referenced by \"linkPortId\".   # noqa: E501

        :return: The cp_protocol_data of this VnfExtCpConfig.  # noqa: E501
        :rtype: list[CpProtocolData]
        """
        return self._cp_protocol_data

    @cp_protocol_data.setter
    def cp_protocol_data(self, cp_protocol_data):
        """Sets the cp_protocol_data of this VnfExtCpConfig.

        Parameters for configuring the network protocols on the link port that connects the CP to a VL. The following conditions apply to the attributes \"linkPortId\" and \"cpProtocolData\": 1) The \"linkPortId\" and \"cpProtocolData\" attributes shall both be    absent for the deletion of an existing external CP instance    addressed by cpInstanceId. 2) At least one of these attributes shall be present for a    to-be-created external CP instance or an existing external    CP instance. 3) If the \"linkPortId\" attribute is absent, the VNFM shall create a    link port. 4) If the \"cpProtocolData\" attribute is absent, the \"linkPortId\"    attribute shall be provided referencing a pre-created link port,    and the VNFM can use means outside the scope of the present    document to obtain the pre-configured address information for the    connection point from the resource representing the link port. 5) If both \"cpProtocolData\" and \"linkportId\" are provided, the API    consumer shall ensure that the cpProtocolData can be used with the    pre-created link port referenced by \"linkPortId\".   # noqa: E501

        :param cp_protocol_data: The cp_protocol_data of this VnfExtCpConfig.  # noqa: E501
        :type: list[CpProtocolData]
        """

        self._cp_protocol_data = cp_protocol_data

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfExtCpConfig, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfExtCpConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
