# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfExtCpInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'IdentifierInVnf',
        'cpd_id': 'IdentifierInVnfd',
        'cp_protocol_info': 'list[CpProtocolInfo]',
        'ext_link_port_id': 'Identifier',
        'metadata': 'KeyValuePairs',
        'associated_vnfc_cp_id': 'Identifier',
        'associated_vnf_virtual_link_id': 'Identifier'
    }

    attribute_map = {
        'id': 'id',
        'cpd_id': 'cpdId',
        'cp_protocol_info': 'cpProtocolInfo',
        'ext_link_port_id': 'extLinkPortId',
        'metadata': 'metadata',
        'associated_vnfc_cp_id': 'associatedVnfcCpId',
        'associated_vnf_virtual_link_id': 'associatedVnfVirtualLinkId'
    }

    def __init__(self, id=None, cpd_id=None, cp_protocol_info=None, ext_link_port_id=None, metadata=None, associated_vnfc_cp_id=None, associated_vnf_virtual_link_id=None):  # noqa: E501
        """VnfExtCpInfo - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._cpd_id = None
        self._cp_protocol_info = None
        self._ext_link_port_id = None
        self._metadata = None
        self._associated_vnfc_cp_id = None
        self._associated_vnf_virtual_link_id = None
        self.discriminator = None
        self.id = id
        self.cpd_id = cpd_id
        self.cp_protocol_info = cp_protocol_info
        if ext_link_port_id is not None:
            self.ext_link_port_id = ext_link_port_id
        if metadata is not None:
            self.metadata = metadata
        if associated_vnfc_cp_id is not None:
            self.associated_vnfc_cp_id = associated_vnfc_cp_id
        if associated_vnf_virtual_link_id is not None:
            self.associated_vnf_virtual_link_id = associated_vnf_virtual_link_id

    @property
    def id(self):
        """Gets the id of this VnfExtCpInfo.  # noqa: E501


        :return: The id of this VnfExtCpInfo.  # noqa: E501
        :rtype: IdentifierInVnf
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this VnfExtCpInfo.


        :param id: The id of this VnfExtCpInfo.  # noqa: E501
        :type: IdentifierInVnf
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def cpd_id(self):
        """Gets the cpd_id of this VnfExtCpInfo.  # noqa: E501


        :return: The cpd_id of this VnfExtCpInfo.  # noqa: E501
        :rtype: IdentifierInVnfd
        """
        return self._cpd_id

    @cpd_id.setter
    def cpd_id(self, cpd_id):
        """Sets the cpd_id of this VnfExtCpInfo.


        :param cpd_id: The cpd_id of this VnfExtCpInfo.  # noqa: E501
        :type: IdentifierInVnfd
        """
        if cpd_id is None:
            print("WARNING: Invalid value for the required field `cpd_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `cpd_id`, must not be `None`")  # noqa: E501

        self._cpd_id = cpd_id

    @property
    def cp_protocol_info(self):
        """Gets the cp_protocol_info of this VnfExtCpInfo.  # noqa: E501

        Network protocol information for this CP.   # noqa: E501

        :return: The cp_protocol_info of this VnfExtCpInfo.  # noqa: E501
        :rtype: list[CpProtocolInfo]
        """
        return self._cp_protocol_info

    @cp_protocol_info.setter
    def cp_protocol_info(self, cp_protocol_info):
        """Sets the cp_protocol_info of this VnfExtCpInfo.

        Network protocol information for this CP.   # noqa: E501

        :param cp_protocol_info: The cp_protocol_info of this VnfExtCpInfo.  # noqa: E501
        :type: list[CpProtocolInfo]
        """
        if cp_protocol_info is None:
            print("WARNING: Invalid value for the required field `cp_protocol_info`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `cp_protocol_info`, must not be `None`")  # noqa: E501

        self._cp_protocol_info = cp_protocol_info

    @property
    def ext_link_port_id(self):
        """Gets the ext_link_port_id of this VnfExtCpInfo.  # noqa: E501


        :return: The ext_link_port_id of this VnfExtCpInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._ext_link_port_id

    @ext_link_port_id.setter
    def ext_link_port_id(self, ext_link_port_id):
        """Sets the ext_link_port_id of this VnfExtCpInfo.


        :param ext_link_port_id: The ext_link_port_id of this VnfExtCpInfo.  # noqa: E501
        :type: Identifier
        """

        self._ext_link_port_id = ext_link_port_id

    @property
    def metadata(self):
        """Gets the metadata of this VnfExtCpInfo.  # noqa: E501


        :return: The metadata of this VnfExtCpInfo.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this VnfExtCpInfo.


        :param metadata: The metadata of this VnfExtCpInfo.  # noqa: E501
        :type: KeyValuePairs
        """

        self._metadata = metadata

    @property
    def associated_vnfc_cp_id(self):
        """Gets the associated_vnfc_cp_id of this VnfExtCpInfo.  # noqa: E501


        :return: The associated_vnfc_cp_id of this VnfExtCpInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._associated_vnfc_cp_id

    @associated_vnfc_cp_id.setter
    def associated_vnfc_cp_id(self, associated_vnfc_cp_id):
        """Sets the associated_vnfc_cp_id of this VnfExtCpInfo.


        :param associated_vnfc_cp_id: The associated_vnfc_cp_id of this VnfExtCpInfo.  # noqa: E501
        :type: Identifier
        """

        self._associated_vnfc_cp_id = associated_vnfc_cp_id

    @property
    def associated_vnf_virtual_link_id(self):
        """Gets the associated_vnf_virtual_link_id of this VnfExtCpInfo.  # noqa: E501


        :return: The associated_vnf_virtual_link_id of this VnfExtCpInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._associated_vnf_virtual_link_id

    @associated_vnf_virtual_link_id.setter
    def associated_vnf_virtual_link_id(self, associated_vnf_virtual_link_id):
        """Sets the associated_vnf_virtual_link_id of this VnfExtCpInfo.


        :param associated_vnf_virtual_link_id: The associated_vnf_virtual_link_id of this VnfExtCpInfo.  # noqa: E501
        :type: Identifier
        """

        self._associated_vnf_virtual_link_id = associated_vnf_virtual_link_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfExtCpInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfExtCpInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
