# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfInfoModifications(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnf_instance_name': 'str',
        'vnf_instance_description': 'str',
        'vnf_configurable_properties': 'KeyValuePairs',
        'metadata': 'KeyValuePairs',
        'extensions': 'KeyValuePairs',
        'vnfd_id': 'Identifier',
        'vnf_provider': 'str',
        'vnf_product_name': 'str',
        'vnf_software_version': 'Version',
        'vnfd_version': 'Version',
        'vnfc_info_modifications': 'list[VnfcInfoModifications]',
        'vnfc_info_modifications_delete_ids': 'list[Identifier]'
    }

    attribute_map = {
        'vnf_instance_name': 'vnfInstanceName',
        'vnf_instance_description': 'vnfInstanceDescription',
        'vnf_configurable_properties': 'vnfConfigurableProperties',
        'metadata': 'metadata',
        'extensions': 'extensions',
        'vnfd_id': 'vnfdId',
        'vnf_provider': 'vnfProvider',
        'vnf_product_name': 'vnfProductName',
        'vnf_software_version': 'vnfSoftwareVersion',
        'vnfd_version': 'vnfdVersion',
        'vnfc_info_modifications': 'vnfcInfoModifications',
        'vnfc_info_modifications_delete_ids': 'vnfcInfoModificationsDeleteIds'
    }

    def __init__(self, vnf_instance_name=None, vnf_instance_description=None, vnf_configurable_properties=None, metadata=None, extensions=None, vnfd_id=None, vnf_provider=None, vnf_product_name=None, vnf_software_version=None, vnfd_version=None, vnfc_info_modifications=None, vnfc_info_modifications_delete_ids=None):  # noqa: E501
        """VnfInfoModifications - a model defined in Swagger"""  # noqa: E501
        self._vnf_instance_name = None
        self._vnf_instance_description = None
        self._vnf_configurable_properties = None
        self._metadata = None
        self._extensions = None
        self._vnfd_id = None
        self._vnf_provider = None
        self._vnf_product_name = None
        self._vnf_software_version = None
        self._vnfd_version = None
        self._vnfc_info_modifications = None
        self._vnfc_info_modifications_delete_ids = None
        self.discriminator = None
        if vnf_instance_name is not None:
            self.vnf_instance_name = vnf_instance_name
        if vnf_instance_description is not None:
            self.vnf_instance_description = vnf_instance_description
        if vnf_configurable_properties is not None:
            self.vnf_configurable_properties = vnf_configurable_properties
        if metadata is not None:
            self.metadata = metadata
        if extensions is not None:
            self.extensions = extensions
        if vnfd_id is not None:
            self.vnfd_id = vnfd_id
        if vnf_provider is not None:
            self.vnf_provider = vnf_provider
        if vnf_product_name is not None:
            self.vnf_product_name = vnf_product_name
        if vnf_software_version is not None:
            self.vnf_software_version = vnf_software_version
        if vnfd_version is not None:
            self.vnfd_version = vnfd_version
        if vnfc_info_modifications is not None:
            self.vnfc_info_modifications = vnfc_info_modifications
        if vnfc_info_modifications_delete_ids is not None:
            self.vnfc_info_modifications_delete_ids = vnfc_info_modifications_delete_ids

    @property
    def vnf_instance_name(self):
        """Gets the vnf_instance_name of this VnfInfoModifications.  # noqa: E501

        If present, this attribute signals modifications of the \"vnfInstanceName\" attribute in \"VnfInstance\".   # noqa: E501

        :return: The vnf_instance_name of this VnfInfoModifications.  # noqa: E501
        :rtype: str
        """
        return self._vnf_instance_name

    @vnf_instance_name.setter
    def vnf_instance_name(self, vnf_instance_name):
        """Sets the vnf_instance_name of this VnfInfoModifications.

        If present, this attribute signals modifications of the \"vnfInstanceName\" attribute in \"VnfInstance\".   # noqa: E501

        :param vnf_instance_name: The vnf_instance_name of this VnfInfoModifications.  # noqa: E501
        :type: str
        """

        self._vnf_instance_name = vnf_instance_name

    @property
    def vnf_instance_description(self):
        """Gets the vnf_instance_description of this VnfInfoModifications.  # noqa: E501

        If present, this attribute signals modifications of the \"vnfInstanceDescription\" attribute in \"VnfInstance\".   # noqa: E501

        :return: The vnf_instance_description of this VnfInfoModifications.  # noqa: E501
        :rtype: str
        """
        return self._vnf_instance_description

    @vnf_instance_description.setter
    def vnf_instance_description(self, vnf_instance_description):
        """Sets the vnf_instance_description of this VnfInfoModifications.

        If present, this attribute signals modifications of the \"vnfInstanceDescription\" attribute in \"VnfInstance\".   # noqa: E501

        :param vnf_instance_description: The vnf_instance_description of this VnfInfoModifications.  # noqa: E501
        :type: str
        """

        self._vnf_instance_description = vnf_instance_description

    @property
    def vnf_configurable_properties(self):
        """Gets the vnf_configurable_properties of this VnfInfoModifications.  # noqa: E501


        :return: The vnf_configurable_properties of this VnfInfoModifications.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._vnf_configurable_properties

    @vnf_configurable_properties.setter
    def vnf_configurable_properties(self, vnf_configurable_properties):
        """Sets the vnf_configurable_properties of this VnfInfoModifications.


        :param vnf_configurable_properties: The vnf_configurable_properties of this VnfInfoModifications.  # noqa: E501
        :type: KeyValuePairs
        """

        self._vnf_configurable_properties = vnf_configurable_properties

    @property
    def metadata(self):
        """Gets the metadata of this VnfInfoModifications.  # noqa: E501


        :return: The metadata of this VnfInfoModifications.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this VnfInfoModifications.


        :param metadata: The metadata of this VnfInfoModifications.  # noqa: E501
        :type: KeyValuePairs
        """

        self._metadata = metadata

    @property
    def extensions(self):
        """Gets the extensions of this VnfInfoModifications.  # noqa: E501


        :return: The extensions of this VnfInfoModifications.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._extensions

    @extensions.setter
    def extensions(self, extensions):
        """Sets the extensions of this VnfInfoModifications.


        :param extensions: The extensions of this VnfInfoModifications.  # noqa: E501
        :type: KeyValuePairs
        """

        self._extensions = extensions

    @property
    def vnfd_id(self):
        """Gets the vnfd_id of this VnfInfoModifications.  # noqa: E501


        :return: The vnfd_id of this VnfInfoModifications.  # noqa: E501
        :rtype: Identifier
        """
        return self._vnfd_id

    @vnfd_id.setter
    def vnfd_id(self, vnfd_id):
        """Sets the vnfd_id of this VnfInfoModifications.


        :param vnfd_id: The vnfd_id of this VnfInfoModifications.  # noqa: E501
        :type: Identifier
        """

        self._vnfd_id = vnfd_id

    @property
    def vnf_provider(self):
        """Gets the vnf_provider of this VnfInfoModifications.  # noqa: E501

        If present, this attribute signals modifications of the \"vnfProvider\" attribute in \"VnfInstance\". If present, this attribute (which depends on the value of the \"vnfPkgId\" attribute) was modified implicitly following a request to modify the \"vnfPkgId\" attribute, by copying the value of this attribute from the VNFD in the VNF Package identified by the \"vnfPkgId\" attribute.   # noqa: E501

        :return: The vnf_provider of this VnfInfoModifications.  # noqa: E501
        :rtype: str
        """
        return self._vnf_provider

    @vnf_provider.setter
    def vnf_provider(self, vnf_provider):
        """Sets the vnf_provider of this VnfInfoModifications.

        If present, this attribute signals modifications of the \"vnfProvider\" attribute in \"VnfInstance\". If present, this attribute (which depends on the value of the \"vnfPkgId\" attribute) was modified implicitly following a request to modify the \"vnfPkgId\" attribute, by copying the value of this attribute from the VNFD in the VNF Package identified by the \"vnfPkgId\" attribute.   # noqa: E501

        :param vnf_provider: The vnf_provider of this VnfInfoModifications.  # noqa: E501
        :type: str
        """

        self._vnf_provider = vnf_provider

    @property
    def vnf_product_name(self):
        """Gets the vnf_product_name of this VnfInfoModifications.  # noqa: E501

        If present, this attribute signals modifications of the \"vnfProductName\" attribute in \"VnfInstance\". If present, this attribute (which depends on the value of the \"vnfPkgId\" attribute) was modified implicitly following a request to modify the \"vnfPkgId\" attribute, by copying the value of this attribute from the VNFD in the VNF Package identified by the \"vnfPkgId\" attribute.   # noqa: E501

        :return: The vnf_product_name of this VnfInfoModifications.  # noqa: E501
        :rtype: str
        """
        return self._vnf_product_name

    @vnf_product_name.setter
    def vnf_product_name(self, vnf_product_name):
        """Sets the vnf_product_name of this VnfInfoModifications.

        If present, this attribute signals modifications of the \"vnfProductName\" attribute in \"VnfInstance\". If present, this attribute (which depends on the value of the \"vnfPkgId\" attribute) was modified implicitly following a request to modify the \"vnfPkgId\" attribute, by copying the value of this attribute from the VNFD in the VNF Package identified by the \"vnfPkgId\" attribute.   # noqa: E501

        :param vnf_product_name: The vnf_product_name of this VnfInfoModifications.  # noqa: E501
        :type: str
        """

        self._vnf_product_name = vnf_product_name

    @property
    def vnf_software_version(self):
        """Gets the vnf_software_version of this VnfInfoModifications.  # noqa: E501


        :return: The vnf_software_version of this VnfInfoModifications.  # noqa: E501
        :rtype: Version
        """
        return self._vnf_software_version

    @vnf_software_version.setter
    def vnf_software_version(self, vnf_software_version):
        """Sets the vnf_software_version of this VnfInfoModifications.


        :param vnf_software_version: The vnf_software_version of this VnfInfoModifications.  # noqa: E501
        :type: Version
        """

        self._vnf_software_version = vnf_software_version

    @property
    def vnfd_version(self):
        """Gets the vnfd_version of this VnfInfoModifications.  # noqa: E501


        :return: The vnfd_version of this VnfInfoModifications.  # noqa: E501
        :rtype: Version
        """
        return self._vnfd_version

    @vnfd_version.setter
    def vnfd_version(self, vnfd_version):
        """Sets the vnfd_version of this VnfInfoModifications.


        :param vnfd_version: The vnfd_version of this VnfInfoModifications.  # noqa: E501
        :type: Version
        """

        self._vnfd_version = vnfd_version

    @property
    def vnfc_info_modifications(self):
        """Gets the vnfc_info_modifications of this VnfInfoModifications.  # noqa: E501

        If present, this attribute signals modifications of certain entries in the \"vnfcInfo\" attribute array in the \"instantiatedVnfInfo\" attribute of \"VnfInstance\", as defined in clause 5.5.2.12   # noqa: E501

        :return: The vnfc_info_modifications of this VnfInfoModifications.  # noqa: E501
        :rtype: list[VnfcInfoModifications]
        """
        return self._vnfc_info_modifications

    @vnfc_info_modifications.setter
    def vnfc_info_modifications(self, vnfc_info_modifications):
        """Sets the vnfc_info_modifications of this VnfInfoModifications.

        If present, this attribute signals modifications of certain entries in the \"vnfcInfo\" attribute array in the \"instantiatedVnfInfo\" attribute of \"VnfInstance\", as defined in clause 5.5.2.12   # noqa: E501

        :param vnfc_info_modifications: The vnfc_info_modifications of this VnfInfoModifications.  # noqa: E501
        :type: list[VnfcInfoModifications]
        """

        self._vnfc_info_modifications = vnfc_info_modifications

    @property
    def vnfc_info_modifications_delete_ids(self):
        """Gets the vnfc_info_modifications_delete_ids of this VnfInfoModifications.  # noqa: E501

        If present, this attribute signals the deletion of certain entries in the \"vnfcInfo\" attribute array in the \"instantiatedVnfInfo\" attribute of \"VnfInstance\", as defined in clause 5.5.2.12   # noqa: E501

        :return: The vnfc_info_modifications_delete_ids of this VnfInfoModifications.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._vnfc_info_modifications_delete_ids

    @vnfc_info_modifications_delete_ids.setter
    def vnfc_info_modifications_delete_ids(self, vnfc_info_modifications_delete_ids):
        """Sets the vnfc_info_modifications_delete_ids of this VnfInfoModifications.

        If present, this attribute signals the deletion of certain entries in the \"vnfcInfo\" attribute array in the \"instantiatedVnfInfo\" attribute of \"VnfInstance\", as defined in clause 5.5.2.12   # noqa: E501

        :param vnfc_info_modifications_delete_ids: The vnfc_info_modifications_delete_ids of this VnfInfoModifications.  # noqa: E501
        :type: list[Identifier]
        """

        self._vnfc_info_modifications_delete_ids = vnfc_info_modifications_delete_ids

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfInfoModifications, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfInfoModifications):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
