# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfInstance(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'Identifier',
        'vnf_instance_name': 'str',
        'vnf_instance_description': 'str',
        'vnfd_id': 'Identifier',
        'vnf_provider': 'str',
        'vnf_product_name': 'str',
        'vnf_software_version': 'Version',
        'vnfd_version': 'Version',
        'vnf_configurable_properties': 'KeyValuePairs',
        'vim_connection_info': 'list[VimConnectionInfo]',
        'instantiation_state': 'str',
        'instantiated_vnf_info': 'VnfInstanceInstantiatedVnfInfo',
        'metadata': 'VnfInstanceMetadata',
        'extensions': 'KeyValuePairs',
        'links': 'VnfInstanceLinks'
    }

    attribute_map = {
        'id': 'id',
        'vnf_instance_name': 'vnfInstanceName',
        'vnf_instance_description': 'vnfInstanceDescription',
        'vnfd_id': 'vnfdId',
        'vnf_provider': 'vnfProvider',
        'vnf_product_name': 'vnfProductName',
        'vnf_software_version': 'vnfSoftwareVersion',
        'vnfd_version': 'vnfdVersion',
        'vnf_configurable_properties': 'vnfConfigurableProperties',
        'vim_connection_info': 'vimConnectionInfo',
        'instantiation_state': 'instantiationState',
        'instantiated_vnf_info': 'instantiatedVnfInfo',
        'metadata': 'metadata',
        'extensions': 'extensions',
        'links': '_links'
    }

    def __init__(self, id=None, vnf_instance_name=None, vnf_instance_description=None, vnfd_id=None, vnf_provider=None, vnf_product_name=None, vnf_software_version=None, vnfd_version=None, vnf_configurable_properties=None, vim_connection_info=None, instantiation_state=None, instantiated_vnf_info=None, metadata=None, extensions=None, links=None):  # noqa: E501
        """VnfInstance - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._vnf_instance_name = None
        self._vnf_instance_description = None
        self._vnfd_id = None
        self._vnf_provider = None
        self._vnf_product_name = None
        self._vnf_software_version = None
        self._vnfd_version = None
        self._vnf_configurable_properties = None
        self._vim_connection_info = None
        self._instantiation_state = None
        self._instantiated_vnf_info = None
        self._metadata = None
        self._extensions = None
        self._links = None
        self.discriminator = None
        self.id = id
        if vnf_instance_name is not None:
            self.vnf_instance_name = vnf_instance_name
        if vnf_instance_description is not None:
            self.vnf_instance_description = vnf_instance_description
        self.vnfd_id = vnfd_id
        self.vnf_provider = vnf_provider
        self.vnf_product_name = vnf_product_name
        self.vnf_software_version = vnf_software_version
        self.vnfd_version = vnfd_version
        if vnf_configurable_properties is not None:
            self.vnf_configurable_properties = vnf_configurable_properties
        if vim_connection_info is not None:
            self.vim_connection_info = vim_connection_info
        self.instantiation_state = instantiation_state
        if instantiated_vnf_info is not None:
            self.instantiated_vnf_info = instantiated_vnf_info
        if metadata is not None:
            self.metadata = metadata
        if extensions is not None:
            self.extensions = extensions
        if links is not None:
            self.links = links

    @property
    def id(self):
        """Gets the id of this VnfInstance.  # noqa: E501


        :return: The id of this VnfInstance.  # noqa: E501
        :rtype: Identifier
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this VnfInstance.


        :param id: The id of this VnfInstance.  # noqa: E501
        :type: Identifier
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def vnf_instance_name(self):
        """Gets the vnf_instance_name of this VnfInstance.  # noqa: E501

        Name of the VNF instance. This attribute can be modified with the PATCH method.   # noqa: E501

        :return: The vnf_instance_name of this VnfInstance.  # noqa: E501
        :rtype: str
        """
        return self._vnf_instance_name

    @vnf_instance_name.setter
    def vnf_instance_name(self, vnf_instance_name):
        """Sets the vnf_instance_name of this VnfInstance.

        Name of the VNF instance. This attribute can be modified with the PATCH method.   # noqa: E501

        :param vnf_instance_name: The vnf_instance_name of this VnfInstance.  # noqa: E501
        :type: str
        """

        self._vnf_instance_name = vnf_instance_name

    @property
    def vnf_instance_description(self):
        """Gets the vnf_instance_description of this VnfInstance.  # noqa: E501

        Human-readable description of the VNF instance. This attribute can be modified with the PATCH method.   # noqa: E501

        :return: The vnf_instance_description of this VnfInstance.  # noqa: E501
        :rtype: str
        """
        return self._vnf_instance_description

    @vnf_instance_description.setter
    def vnf_instance_description(self, vnf_instance_description):
        """Sets the vnf_instance_description of this VnfInstance.

        Human-readable description of the VNF instance. This attribute can be modified with the PATCH method.   # noqa: E501

        :param vnf_instance_description: The vnf_instance_description of this VnfInstance.  # noqa: E501
        :type: str
        """

        self._vnf_instance_description = vnf_instance_description

    @property
    def vnfd_id(self):
        """Gets the vnfd_id of this VnfInstance.  # noqa: E501


        :return: The vnfd_id of this VnfInstance.  # noqa: E501
        :rtype: Identifier
        """
        return self._vnfd_id

    @vnfd_id.setter
    def vnfd_id(self, vnfd_id):
        """Sets the vnfd_id of this VnfInstance.


        :param vnfd_id: The vnfd_id of this VnfInstance.  # noqa: E501
        :type: Identifier
        """
        if vnfd_id is None:
            print("WARNING: Invalid value for the required field `vnfd_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnfd_id`, must not be `None`")  # noqa: E501

        self._vnfd_id = vnfd_id

    @property
    def vnf_provider(self):
        """Gets the vnf_provider of this VnfInstance.  # noqa: E501

        Provider of the VNF and the VNFD. The value is copied from the VNFD.   # noqa: E501

        :return: The vnf_provider of this VnfInstance.  # noqa: E501
        :rtype: str
        """
        return self._vnf_provider

    @vnf_provider.setter
    def vnf_provider(self, vnf_provider):
        """Sets the vnf_provider of this VnfInstance.

        Provider of the VNF and the VNFD. The value is copied from the VNFD.   # noqa: E501

        :param vnf_provider: The vnf_provider of this VnfInstance.  # noqa: E501
        :type: str
        """
        if vnf_provider is None:
            print("WARNING: Invalid value for the required field `vnf_provider`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_provider`, must not be `None`")  # noqa: E501

        self._vnf_provider = vnf_provider

    @property
    def vnf_product_name(self):
        """Gets the vnf_product_name of this VnfInstance.  # noqa: E501

        Name to identify the VNF Product. The value is copied from the VNFD.   # noqa: E501

        :return: The vnf_product_name of this VnfInstance.  # noqa: E501
        :rtype: str
        """
        return self._vnf_product_name

    @vnf_product_name.setter
    def vnf_product_name(self, vnf_product_name):
        """Sets the vnf_product_name of this VnfInstance.

        Name to identify the VNF Product. The value is copied from the VNFD.   # noqa: E501

        :param vnf_product_name: The vnf_product_name of this VnfInstance.  # noqa: E501
        :type: str
        """
        if vnf_product_name is None:
            print("WARNING: Invalid value for the required field `vnf_product_name`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_product_name`, must not be `None`")  # noqa: E501

        self._vnf_product_name = vnf_product_name

    @property
    def vnf_software_version(self):
        """Gets the vnf_software_version of this VnfInstance.  # noqa: E501


        :return: The vnf_software_version of this VnfInstance.  # noqa: E501
        :rtype: Version
        """
        return self._vnf_software_version

    @vnf_software_version.setter
    def vnf_software_version(self, vnf_software_version):
        """Sets the vnf_software_version of this VnfInstance.


        :param vnf_software_version: The vnf_software_version of this VnfInstance.  # noqa: E501
        :type: Version
        """
        if vnf_software_version is None:
            print("WARNING: Invalid value for the required field `vnf_software_version`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_software_version`, must not be `None`")  # noqa: E501

        self._vnf_software_version = vnf_software_version

    @property
    def vnfd_version(self):
        """Gets the vnfd_version of this VnfInstance.  # noqa: E501


        :return: The vnfd_version of this VnfInstance.  # noqa: E501
        :rtype: Version
        """
        return self._vnfd_version

    @vnfd_version.setter
    def vnfd_version(self, vnfd_version):
        """Sets the vnfd_version of this VnfInstance.


        :param vnfd_version: The vnfd_version of this VnfInstance.  # noqa: E501
        :type: Version
        """
        if vnfd_version is None:
            print("WARNING: Invalid value for the required field `vnfd_version`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnfd_version`, must not be `None`")  # noqa: E501

        self._vnfd_version = vnfd_version

    @property
    def vnf_configurable_properties(self):
        """Gets the vnf_configurable_properties of this VnfInstance.  # noqa: E501


        :return: The vnf_configurable_properties of this VnfInstance.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._vnf_configurable_properties

    @vnf_configurable_properties.setter
    def vnf_configurable_properties(self, vnf_configurable_properties):
        """Sets the vnf_configurable_properties of this VnfInstance.


        :param vnf_configurable_properties: The vnf_configurable_properties of this VnfInstance.  # noqa: E501
        :type: KeyValuePairs
        """

        self._vnf_configurable_properties = vnf_configurable_properties

    @property
    def vim_connection_info(self):
        """Gets the vim_connection_info of this VnfInstance.  # noqa: E501

        Information about VIM connections to be used for managing the resources for the VNF instance. This attribute shall only be supported and present if VNF-related resource management in direct mode is applicable. This attribute can be modified with the PATCH method.   # noqa: E501

        :return: The vim_connection_info of this VnfInstance.  # noqa: E501
        :rtype: list[VimConnectionInfo]
        """
        return self._vim_connection_info

    @vim_connection_info.setter
    def vim_connection_info(self, vim_connection_info):
        """Sets the vim_connection_info of this VnfInstance.

        Information about VIM connections to be used for managing the resources for the VNF instance. This attribute shall only be supported and present if VNF-related resource management in direct mode is applicable. This attribute can be modified with the PATCH method.   # noqa: E501

        :param vim_connection_info: The vim_connection_info of this VnfInstance.  # noqa: E501
        :type: list[VimConnectionInfo]
        """

        self._vim_connection_info = vim_connection_info

    @property
    def instantiation_state(self):
        """Gets the instantiation_state of this VnfInstance.  # noqa: E501

        The instantiation state of the VNF.   # noqa: E501

        :return: The instantiation_state of this VnfInstance.  # noqa: E501
        :rtype: str
        """
        return self._instantiation_state

    @instantiation_state.setter
    def instantiation_state(self, instantiation_state):
        """Sets the instantiation_state of this VnfInstance.

        The instantiation state of the VNF.   # noqa: E501

        :param instantiation_state: The instantiation_state of this VnfInstance.  # noqa: E501
        :type: str
        """
        if instantiation_state is None:
            print("WARNING: Invalid value for the required field `instantiation_state`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `instantiation_state`, must not be `None`")  # noqa: E501
        allowed_values = ["NOT_INSTANTIATED", "INSTANTIATED"]  # noqa: E501
        if instantiation_state is not None and instantiation_state not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `instantiation_state` ({0}), must be one of {1}"  # noqa: E501
                .format(instantiation_state, allowed_values)
            )

        self._instantiation_state = instantiation_state

    @property
    def instantiated_vnf_info(self):
        """Gets the instantiated_vnf_info of this VnfInstance.  # noqa: E501


        :return: The instantiated_vnf_info of this VnfInstance.  # noqa: E501
        :rtype: VnfInstanceInstantiatedVnfInfo
        """
        return self._instantiated_vnf_info

    @instantiated_vnf_info.setter
    def instantiated_vnf_info(self, instantiated_vnf_info):
        """Sets the instantiated_vnf_info of this VnfInstance.


        :param instantiated_vnf_info: The instantiated_vnf_info of this VnfInstance.  # noqa: E501
        :type: VnfInstanceInstantiatedVnfInfo
        """

        self._instantiated_vnf_info = instantiated_vnf_info

    @property
    def metadata(self):
        """Gets the metadata of this VnfInstance.  # noqa: E501


        :return: The metadata of this VnfInstance.  # noqa: E501
        :rtype: VnfInstanceMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this VnfInstance.


        :param metadata: The metadata of this VnfInstance.  # noqa: E501
        :type: VnfInstanceMetadata
        """

        self._metadata = metadata

    @property
    def extensions(self):
        """Gets the extensions of this VnfInstance.  # noqa: E501


        :return: The extensions of this VnfInstance.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._extensions

    @extensions.setter
    def extensions(self, extensions):
        """Sets the extensions of this VnfInstance.


        :param extensions: The extensions of this VnfInstance.  # noqa: E501
        :type: KeyValuePairs
        """

        self._extensions = extensions

    @property
    def links(self):
        """Gets the links of this VnfInstance.  # noqa: E501


        :return: The links of this VnfInstance.  # noqa: E501
        :rtype: VnfInstanceLinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this VnfInstance.


        :param links: The links of this VnfInstance.  # noqa: E501
        :type: VnfInstanceLinks
        """

        self._links = links

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfInstance, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfInstance):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
