# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfInstanceInstantiatedVnfInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'flavour_id': 'IdentifierInVnfd',
        'vnf_state': 'VnfOperationalStateType',
        'scale_status': 'list[ScaleInfo]',
        'max_scale_levels': 'list[ScaleInfo]',
        'ext_cp_info': 'list[VnfExtCpInfo]',
        'ext_virtual_link_info': 'list[ExtVirtualLinkInfo]',
        'ext_managed_virtual_link_info': 'list[ExtManagedVirtualLinkInfo]',
        'monitoring_parameters': 'list[MonitoringParameter]',
        'localization_language': 'str',
        'vnfc_resource_info': 'list[VnfcResourceInfo]',
        'virtual_link_resource_info': 'list[VnfVirtualLinkResourceInfo]',
        'virtual_storage_resource_info': 'list[VirtualStorageResourceInfo]'
    }

    attribute_map = {
        'flavour_id': 'flavourId',
        'vnf_state': 'vnfState',
        'scale_status': 'scaleStatus',
        'max_scale_levels': 'maxScaleLevels',
        'ext_cp_info': 'extCpInfo',
        'ext_virtual_link_info': 'extVirtualLinkInfo',
        'ext_managed_virtual_link_info': 'extManagedVirtualLinkInfo',
        'monitoring_parameters': 'monitoringParameters',
        'localization_language': 'localizationLanguage',
        'vnfc_resource_info': 'vnfcResourceInfo',
        'virtual_link_resource_info': 'virtualLinkResourceInfo',
        'virtual_storage_resource_info': 'virtualStorageResourceInfo'
    }

    def __init__(self, flavour_id=None, vnf_state=None, scale_status=None, max_scale_levels=None, ext_cp_info=None, ext_virtual_link_info=None, ext_managed_virtual_link_info=None, monitoring_parameters=None, localization_language=None, vnfc_resource_info=None, virtual_link_resource_info=None, virtual_storage_resource_info=None):  # noqa: E501
        """VnfInstanceInstantiatedVnfInfo - a model defined in Swagger"""  # noqa: E501
        self._flavour_id = None
        self._vnf_state = None
        self._scale_status = None
        self._max_scale_levels = None
        self._ext_cp_info = None
        self._ext_virtual_link_info = None
        self._ext_managed_virtual_link_info = None
        self._monitoring_parameters = None
        self._localization_language = None
        self._vnfc_resource_info = None
        self._virtual_link_resource_info = None
        self._virtual_storage_resource_info = None
        self.discriminator = None
        self.flavour_id = flavour_id
        self.vnf_state = vnf_state
        if scale_status is not None:
            self.scale_status = scale_status
        if max_scale_levels is not None:
            self.max_scale_levels = max_scale_levels
        if ext_cp_info is not None:
            self.ext_cp_info = ext_cp_info
        if ext_virtual_link_info is not None:
            self.ext_virtual_link_info = ext_virtual_link_info
        if ext_managed_virtual_link_info is not None:
            self.ext_managed_virtual_link_info = ext_managed_virtual_link_info
        if monitoring_parameters is not None:
            self.monitoring_parameters = monitoring_parameters
        if localization_language is not None:
            self.localization_language = localization_language
        if vnfc_resource_info is not None:
            self.vnfc_resource_info = vnfc_resource_info
        if virtual_link_resource_info is not None:
            self.virtual_link_resource_info = virtual_link_resource_info
        if virtual_storage_resource_info is not None:
            self.virtual_storage_resource_info = virtual_storage_resource_info

    @property
    def flavour_id(self):
        """Gets the flavour_id of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501


        :return: The flavour_id of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :rtype: IdentifierInVnfd
        """
        return self._flavour_id

    @flavour_id.setter
    def flavour_id(self, flavour_id):
        """Sets the flavour_id of this VnfInstanceInstantiatedVnfInfo.


        :param flavour_id: The flavour_id of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :type: IdentifierInVnfd
        """
        if flavour_id is None:
            print("WARNING: Invalid value for the required field `flavour_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `flavour_id`, must not be `None`")  # noqa: E501

        self._flavour_id = flavour_id

    @property
    def vnf_state(self):
        """Gets the vnf_state of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501


        :return: The vnf_state of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :rtype: VnfOperationalStateType
        """
        return self._vnf_state

    @vnf_state.setter
    def vnf_state(self, vnf_state):
        """Sets the vnf_state of this VnfInstanceInstantiatedVnfInfo.


        :param vnf_state: The vnf_state of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :type: VnfOperationalStateType
        """
        if vnf_state is None:
            print("WARNING: Invalid value for the required field `vnf_state`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_state`, must not be `None`")  # noqa: E501

        self._vnf_state = vnf_state

    @property
    def scale_status(self):
        """Gets the scale_status of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501

        Scale status of the VNF, one entry per aspect. Represents for every scaling aspect how \"big\" the VNF has been scaled w.r.t. that aspect. This attribute shall be present if the VNF supports scaling. See clause B.2 for an explanation of VNF scaling.   # noqa: E501

        :return: The scale_status of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :rtype: list[ScaleInfo]
        """
        return self._scale_status

    @scale_status.setter
    def scale_status(self, scale_status):
        """Sets the scale_status of this VnfInstanceInstantiatedVnfInfo.

        Scale status of the VNF, one entry per aspect. Represents for every scaling aspect how \"big\" the VNF has been scaled w.r.t. that aspect. This attribute shall be present if the VNF supports scaling. See clause B.2 for an explanation of VNF scaling.   # noqa: E501

        :param scale_status: The scale_status of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :type: list[ScaleInfo]
        """

        self._scale_status = scale_status

    @property
    def max_scale_levels(self):
        """Gets the max_scale_levels of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501

        Maximum allowed scale levels of the VNF, one entry per aspect. This attribute shall be present if the VNF supports scaling.   # noqa: E501

        :return: The max_scale_levels of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :rtype: list[ScaleInfo]
        """
        return self._max_scale_levels

    @max_scale_levels.setter
    def max_scale_levels(self, max_scale_levels):
        """Sets the max_scale_levels of this VnfInstanceInstantiatedVnfInfo.

        Maximum allowed scale levels of the VNF, one entry per aspect. This attribute shall be present if the VNF supports scaling.   # noqa: E501

        :param max_scale_levels: The max_scale_levels of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :type: list[ScaleInfo]
        """

        self._max_scale_levels = max_scale_levels

    @property
    def ext_cp_info(self):
        """Gets the ext_cp_info of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501

        Information about the external CPs exposed by the VNF instance.   # noqa: E501

        :return: The ext_cp_info of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :rtype: list[VnfExtCpInfo]
        """
        return self._ext_cp_info

    @ext_cp_info.setter
    def ext_cp_info(self, ext_cp_info):
        """Sets the ext_cp_info of this VnfInstanceInstantiatedVnfInfo.

        Information about the external CPs exposed by the VNF instance.   # noqa: E501

        :param ext_cp_info: The ext_cp_info of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :type: list[VnfExtCpInfo]
        """

        self._ext_cp_info = ext_cp_info

    @property
    def ext_virtual_link_info(self):
        """Gets the ext_virtual_link_info of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501

        Information about the external VLs the VNF instance is connected to.   # noqa: E501

        :return: The ext_virtual_link_info of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :rtype: list[ExtVirtualLinkInfo]
        """
        return self._ext_virtual_link_info

    @ext_virtual_link_info.setter
    def ext_virtual_link_info(self, ext_virtual_link_info):
        """Sets the ext_virtual_link_info of this VnfInstanceInstantiatedVnfInfo.

        Information about the external VLs the VNF instance is connected to.   # noqa: E501

        :param ext_virtual_link_info: The ext_virtual_link_info of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :type: list[ExtVirtualLinkInfo]
        """

        self._ext_virtual_link_info = ext_virtual_link_info

    @property
    def ext_managed_virtual_link_info(self):
        """Gets the ext_managed_virtual_link_info of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501

        External virtual links the VNF instance is connected to.   # noqa: E501

        :return: The ext_managed_virtual_link_info of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :rtype: list[ExtManagedVirtualLinkInfo]
        """
        return self._ext_managed_virtual_link_info

    @ext_managed_virtual_link_info.setter
    def ext_managed_virtual_link_info(self, ext_managed_virtual_link_info):
        """Sets the ext_managed_virtual_link_info of this VnfInstanceInstantiatedVnfInfo.

        External virtual links the VNF instance is connected to.   # noqa: E501

        :param ext_managed_virtual_link_info: The ext_managed_virtual_link_info of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :type: list[ExtManagedVirtualLinkInfo]
        """

        self._ext_managed_virtual_link_info = ext_managed_virtual_link_info

    @property
    def monitoring_parameters(self):
        """Gets the monitoring_parameters of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501

        Active monitoring parameters.   # noqa: E501

        :return: The monitoring_parameters of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :rtype: list[MonitoringParameter]
        """
        return self._monitoring_parameters

    @monitoring_parameters.setter
    def monitoring_parameters(self, monitoring_parameters):
        """Sets the monitoring_parameters of this VnfInstanceInstantiatedVnfInfo.

        Active monitoring parameters.   # noqa: E501

        :param monitoring_parameters: The monitoring_parameters of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :type: list[MonitoringParameter]
        """

        self._monitoring_parameters = monitoring_parameters

    @property
    def localization_language(self):
        """Gets the localization_language of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501

        Information about localization language of the VNF (includes e.g. strings in the VNFD). The localization languages supported by a VNF can be declared in the VNFD, and localization language selection can take place at instantiation time. The value shall comply with the format defined in IETF RFC 5646.   # noqa: E501

        :return: The localization_language of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :rtype: str
        """
        return self._localization_language

    @localization_language.setter
    def localization_language(self, localization_language):
        """Sets the localization_language of this VnfInstanceInstantiatedVnfInfo.

        Information about localization language of the VNF (includes e.g. strings in the VNFD). The localization languages supported by a VNF can be declared in the VNFD, and localization language selection can take place at instantiation time. The value shall comply with the format defined in IETF RFC 5646.   # noqa: E501

        :param localization_language: The localization_language of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :type: str
        """

        self._localization_language = localization_language

    @property
    def vnfc_resource_info(self):
        """Gets the vnfc_resource_info of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501

        Information about the virtualised compute and storage resources used by the VNFCs of the VNF instance.   # noqa: E501

        :return: The vnfc_resource_info of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :rtype: list[VnfcResourceInfo]
        """
        return self._vnfc_resource_info

    @vnfc_resource_info.setter
    def vnfc_resource_info(self, vnfc_resource_info):
        """Sets the vnfc_resource_info of this VnfInstanceInstantiatedVnfInfo.

        Information about the virtualised compute and storage resources used by the VNFCs of the VNF instance.   # noqa: E501

        :param vnfc_resource_info: The vnfc_resource_info of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :type: list[VnfcResourceInfo]
        """

        self._vnfc_resource_info = vnfc_resource_info

    @property
    def virtual_link_resource_info(self):
        """Gets the virtual_link_resource_info of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501

        Information about the virtualised network resources used by the VLs of the VNF instance.   # noqa: E501

        :return: The virtual_link_resource_info of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :rtype: list[VnfVirtualLinkResourceInfo]
        """
        return self._virtual_link_resource_info

    @virtual_link_resource_info.setter
    def virtual_link_resource_info(self, virtual_link_resource_info):
        """Sets the virtual_link_resource_info of this VnfInstanceInstantiatedVnfInfo.

        Information about the virtualised network resources used by the VLs of the VNF instance.   # noqa: E501

        :param virtual_link_resource_info: The virtual_link_resource_info of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :type: list[VnfVirtualLinkResourceInfo]
        """

        self._virtual_link_resource_info = virtual_link_resource_info

    @property
    def virtual_storage_resource_info(self):
        """Gets the virtual_storage_resource_info of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501

        Information on the virtualised storage resource(s) used as storage for the VNF instance.   # noqa: E501

        :return: The virtual_storage_resource_info of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :rtype: list[VirtualStorageResourceInfo]
        """
        return self._virtual_storage_resource_info

    @virtual_storage_resource_info.setter
    def virtual_storage_resource_info(self, virtual_storage_resource_info):
        """Sets the virtual_storage_resource_info of this VnfInstanceInstantiatedVnfInfo.

        Information on the virtualised storage resource(s) used as storage for the VNF instance.   # noqa: E501

        :param virtual_storage_resource_info: The virtual_storage_resource_info of this VnfInstanceInstantiatedVnfInfo.  # noqa: E501
        :type: list[VirtualStorageResourceInfo]
        """

        self._virtual_storage_resource_info = virtual_storage_resource_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfInstanceInstantiatedVnfInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfInstanceInstantiatedVnfInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
