# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfInstanceLinks(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        '_self': 'Link',
        'indicators': 'Link',
        'instantiate': 'Link',
        'terminate': 'Link',
        'scale': 'Link',
        'scale_to_level': 'Link',
        'change_flavour': 'Link',
        'heal': 'Link',
        'operate': 'Link',
        'change_ext_conn': 'Link'
    }

    attribute_map = {
        '_self': 'self',
        'indicators': 'indicators',
        'instantiate': 'instantiate',
        'terminate': 'terminate',
        'scale': 'scale',
        'scale_to_level': 'scaleToLevel',
        'change_flavour': 'changeFlavour',
        'heal': 'heal',
        'operate': 'operate',
        'change_ext_conn': 'changeExtConn'
    }

    def __init__(self, _self=None, indicators=None, instantiate=None, terminate=None, scale=None, scale_to_level=None, change_flavour=None, heal=None, operate=None, change_ext_conn=None):  # noqa: E501
        """VnfInstanceLinks - a model defined in Swagger"""  # noqa: E501
        self.__self = None
        self._indicators = None
        self._instantiate = None
        self._terminate = None
        self._scale = None
        self._scale_to_level = None
        self._change_flavour = None
        self._heal = None
        self._operate = None
        self._change_ext_conn = None
        self.discriminator = None
        self._self = _self
        if indicators is not None:
            self.indicators = indicators
        if instantiate is not None:
            self.instantiate = instantiate
        if terminate is not None:
            self.terminate = terminate
        if scale is not None:
            self.scale = scale
        if scale_to_level is not None:
            self.scale_to_level = scale_to_level
        if change_flavour is not None:
            self.change_flavour = change_flavour
        if heal is not None:
            self.heal = heal
        if operate is not None:
            self.operate = operate
        if change_ext_conn is not None:
            self.change_ext_conn = change_ext_conn

    @property
    def _self(self):
        """Gets the _self of this VnfInstanceLinks.  # noqa: E501


        :return: The _self of this VnfInstanceLinks.  # noqa: E501
        :rtype: Link
        """
        return self.__self

    @_self.setter
    def _self(self, _self):
        """Sets the _self of this VnfInstanceLinks.


        :param _self: The _self of this VnfInstanceLinks.  # noqa: E501
        :type: Link
        """
        if _self is None:
            print("WARNING: Invalid value for the required field `_self`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `_self`, must not be `None`")  # noqa: E501

        self.__self = _self

    @property
    def indicators(self):
        """Gets the indicators of this VnfInstanceLinks.  # noqa: E501


        :return: The indicators of this VnfInstanceLinks.  # noqa: E501
        :rtype: Link
        """
        return self._indicators

    @indicators.setter
    def indicators(self, indicators):
        """Sets the indicators of this VnfInstanceLinks.


        :param indicators: The indicators of this VnfInstanceLinks.  # noqa: E501
        :type: Link
        """

        self._indicators = indicators

    @property
    def instantiate(self):
        """Gets the instantiate of this VnfInstanceLinks.  # noqa: E501


        :return: The instantiate of this VnfInstanceLinks.  # noqa: E501
        :rtype: Link
        """
        return self._instantiate

    @instantiate.setter
    def instantiate(self, instantiate):
        """Sets the instantiate of this VnfInstanceLinks.


        :param instantiate: The instantiate of this VnfInstanceLinks.  # noqa: E501
        :type: Link
        """

        self._instantiate = instantiate

    @property
    def terminate(self):
        """Gets the terminate of this VnfInstanceLinks.  # noqa: E501


        :return: The terminate of this VnfInstanceLinks.  # noqa: E501
        :rtype: Link
        """
        return self._terminate

    @terminate.setter
    def terminate(self, terminate):
        """Sets the terminate of this VnfInstanceLinks.


        :param terminate: The terminate of this VnfInstanceLinks.  # noqa: E501
        :type: Link
        """

        self._terminate = terminate

    @property
    def scale(self):
        """Gets the scale of this VnfInstanceLinks.  # noqa: E501


        :return: The scale of this VnfInstanceLinks.  # noqa: E501
        :rtype: Link
        """
        return self._scale

    @scale.setter
    def scale(self, scale):
        """Sets the scale of this VnfInstanceLinks.


        :param scale: The scale of this VnfInstanceLinks.  # noqa: E501
        :type: Link
        """

        self._scale = scale

    @property
    def scale_to_level(self):
        """Gets the scale_to_level of this VnfInstanceLinks.  # noqa: E501


        :return: The scale_to_level of this VnfInstanceLinks.  # noqa: E501
        :rtype: Link
        """
        return self._scale_to_level

    @scale_to_level.setter
    def scale_to_level(self, scale_to_level):
        """Sets the scale_to_level of this VnfInstanceLinks.


        :param scale_to_level: The scale_to_level of this VnfInstanceLinks.  # noqa: E501
        :type: Link
        """

        self._scale_to_level = scale_to_level

    @property
    def change_flavour(self):
        """Gets the change_flavour of this VnfInstanceLinks.  # noqa: E501


        :return: The change_flavour of this VnfInstanceLinks.  # noqa: E501
        :rtype: Link
        """
        return self._change_flavour

    @change_flavour.setter
    def change_flavour(self, change_flavour):
        """Sets the change_flavour of this VnfInstanceLinks.


        :param change_flavour: The change_flavour of this VnfInstanceLinks.  # noqa: E501
        :type: Link
        """

        self._change_flavour = change_flavour

    @property
    def heal(self):
        """Gets the heal of this VnfInstanceLinks.  # noqa: E501


        :return: The heal of this VnfInstanceLinks.  # noqa: E501
        :rtype: Link
        """
        return self._heal

    @heal.setter
    def heal(self, heal):
        """Sets the heal of this VnfInstanceLinks.


        :param heal: The heal of this VnfInstanceLinks.  # noqa: E501
        :type: Link
        """

        self._heal = heal

    @property
    def operate(self):
        """Gets the operate of this VnfInstanceLinks.  # noqa: E501


        :return: The operate of this VnfInstanceLinks.  # noqa: E501
        :rtype: Link
        """
        return self._operate

    @operate.setter
    def operate(self, operate):
        """Sets the operate of this VnfInstanceLinks.


        :param operate: The operate of this VnfInstanceLinks.  # noqa: E501
        :type: Link
        """

        self._operate = operate

    @property
    def change_ext_conn(self):
        """Gets the change_ext_conn of this VnfInstanceLinks.  # noqa: E501


        :return: The change_ext_conn of this VnfInstanceLinks.  # noqa: E501
        :rtype: Link
        """
        return self._change_ext_conn

    @change_ext_conn.setter
    def change_ext_conn(self, change_ext_conn):
        """Sets the change_ext_conn of this VnfInstanceLinks.


        :param change_ext_conn: The change_ext_conn of this VnfInstanceLinks.  # noqa: E501
        :type: Link
        """

        self._change_ext_conn = change_ext_conn

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfInstanceLinks, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfInstanceLinks):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
