# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfInstanceMetadata(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnf_pkg_id': 'str',
        'vnf_catalog_name': 'str',
        'managed_by': 'VnfInstanceMetadataManagedBy',
        'nf_type': 'str',
        'lcm_operation': 'str',
        'lcm_operation_state': 'str',
        'is_used_by_ns': 'str',
        'attached_ns_count': 'int',
        'ext_virtual_links': 'list[ExtVirtualLinkData]',
        'tags': 'list[VnfInstanceMetadataTags]'
    }

    attribute_map = {
        'vnf_pkg_id': 'vnfPkgId',
        'vnf_catalog_name': 'vnfCatalogName',
        'managed_by': 'managedBy',
        'nf_type': 'nfType',
        'lcm_operation': 'lcmOperation',
        'lcm_operation_state': 'lcmOperationState',
        'is_used_by_ns': 'isUsedByNS',
        'attached_ns_count': 'attachedNSCount',
        'ext_virtual_links': 'extVirtualLinks',
        'tags': 'tags'
    }

    def __init__(self, vnf_pkg_id=None, vnf_catalog_name=None, managed_by=None, nf_type=None, lcm_operation=None, lcm_operation_state=None, is_used_by_ns=None, attached_ns_count=None, ext_virtual_links=None, tags=None):  # noqa: E501
        """VnfInstanceMetadata - a model defined in Swagger"""  # noqa: E501
        self._vnf_pkg_id = None
        self._vnf_catalog_name = None
        self._managed_by = None
        self._nf_type = None
        self._lcm_operation = None
        self._lcm_operation_state = None
        self._is_used_by_ns = None
        self._attached_ns_count = None
        self._ext_virtual_links = None
        self._tags = None
        self.discriminator = None
        if vnf_pkg_id is not None:
            self.vnf_pkg_id = vnf_pkg_id
        if vnf_catalog_name is not None:
            self.vnf_catalog_name = vnf_catalog_name
        if managed_by is not None:
            self.managed_by = managed_by
        if nf_type is not None:
            self.nf_type = nf_type
        if lcm_operation is not None:
            self.lcm_operation = lcm_operation
        if lcm_operation_state is not None:
            self.lcm_operation_state = lcm_operation_state
        if is_used_by_ns is not None:
            self.is_used_by_ns = is_used_by_ns
        if attached_ns_count is not None:
            self.attached_ns_count = attached_ns_count
        if ext_virtual_links is not None:
            self.ext_virtual_links = ext_virtual_links
        if tags is not None:
            self.tags = tags

    @property
    def vnf_pkg_id(self):
        """Gets the vnf_pkg_id of this VnfInstanceMetadata.  # noqa: E501


        :return: The vnf_pkg_id of this VnfInstanceMetadata.  # noqa: E501
        :rtype: str
        """
        return self._vnf_pkg_id

    @vnf_pkg_id.setter
    def vnf_pkg_id(self, vnf_pkg_id):
        """Sets the vnf_pkg_id of this VnfInstanceMetadata.


        :param vnf_pkg_id: The vnf_pkg_id of this VnfInstanceMetadata.  # noqa: E501
        :type: str
        """

        self._vnf_pkg_id = vnf_pkg_id

    @property
    def vnf_catalog_name(self):
        """Gets the vnf_catalog_name of this VnfInstanceMetadata.  # noqa: E501


        :return: The vnf_catalog_name of this VnfInstanceMetadata.  # noqa: E501
        :rtype: str
        """
        return self._vnf_catalog_name

    @vnf_catalog_name.setter
    def vnf_catalog_name(self, vnf_catalog_name):
        """Sets the vnf_catalog_name of this VnfInstanceMetadata.


        :param vnf_catalog_name: The vnf_catalog_name of this VnfInstanceMetadata.  # noqa: E501
        :type: str
        """

        self._vnf_catalog_name = vnf_catalog_name

    @property
    def managed_by(self):
        """Gets the managed_by of this VnfInstanceMetadata.  # noqa: E501


        :return: The managed_by of this VnfInstanceMetadata.  # noqa: E501
        :rtype: VnfInstanceMetadataManagedBy
        """
        return self._managed_by

    @managed_by.setter
    def managed_by(self, managed_by):
        """Sets the managed_by of this VnfInstanceMetadata.


        :param managed_by: The managed_by of this VnfInstanceMetadata.  # noqa: E501
        :type: VnfInstanceMetadataManagedBy
        """

        self._managed_by = managed_by

    @property
    def nf_type(self):
        """Gets the nf_type of this VnfInstanceMetadata.  # noqa: E501


        :return: The nf_type of this VnfInstanceMetadata.  # noqa: E501
        :rtype: str
        """
        return self._nf_type

    @nf_type.setter
    def nf_type(self, nf_type):
        """Sets the nf_type of this VnfInstanceMetadata.


        :param nf_type: The nf_type of this VnfInstanceMetadata.  # noqa: E501
        :type: str
        """

        self._nf_type = nf_type

    @property
    def lcm_operation(self):
        """Gets the lcm_operation of this VnfInstanceMetadata.  # noqa: E501


        :return: The lcm_operation of this VnfInstanceMetadata.  # noqa: E501
        :rtype: str
        """
        return self._lcm_operation

    @lcm_operation.setter
    def lcm_operation(self, lcm_operation):
        """Sets the lcm_operation of this VnfInstanceMetadata.


        :param lcm_operation: The lcm_operation of this VnfInstanceMetadata.  # noqa: E501
        :type: str
        """

        self._lcm_operation = lcm_operation

    @property
    def lcm_operation_state(self):
        """Gets the lcm_operation_state of this VnfInstanceMetadata.  # noqa: E501


        :return: The lcm_operation_state of this VnfInstanceMetadata.  # noqa: E501
        :rtype: str
        """
        return self._lcm_operation_state

    @lcm_operation_state.setter
    def lcm_operation_state(self, lcm_operation_state):
        """Sets the lcm_operation_state of this VnfInstanceMetadata.


        :param lcm_operation_state: The lcm_operation_state of this VnfInstanceMetadata.  # noqa: E501
        :type: str
        """

        self._lcm_operation_state = lcm_operation_state

    @property
    def is_used_by_ns(self):
        """Gets the is_used_by_ns of this VnfInstanceMetadata.  # noqa: E501


        :return: The is_used_by_ns of this VnfInstanceMetadata.  # noqa: E501
        :rtype: str
        """
        return self._is_used_by_ns

    @is_used_by_ns.setter
    def is_used_by_ns(self, is_used_by_ns):
        """Sets the is_used_by_ns of this VnfInstanceMetadata.


        :param is_used_by_ns: The is_used_by_ns of this VnfInstanceMetadata.  # noqa: E501
        :type: str
        """

        self._is_used_by_ns = is_used_by_ns

    @property
    def attached_ns_count(self):
        """Gets the attached_ns_count of this VnfInstanceMetadata.  # noqa: E501


        :return: The attached_ns_count of this VnfInstanceMetadata.  # noqa: E501
        :rtype: int
        """
        return self._attached_ns_count

    @attached_ns_count.setter
    def attached_ns_count(self, attached_ns_count):
        """Sets the attached_ns_count of this VnfInstanceMetadata.


        :param attached_ns_count: The attached_ns_count of this VnfInstanceMetadata.  # noqa: E501
        :type: int
        """

        self._attached_ns_count = attached_ns_count

    @property
    def ext_virtual_links(self):
        """Gets the ext_virtual_links of this VnfInstanceMetadata.  # noqa: E501

        Information about external VLs to connect the VNF to.   # noqa: E501

        :return: The ext_virtual_links of this VnfInstanceMetadata.  # noqa: E501
        :rtype: list[ExtVirtualLinkData]
        """
        return self._ext_virtual_links

    @ext_virtual_links.setter
    def ext_virtual_links(self, ext_virtual_links):
        """Sets the ext_virtual_links of this VnfInstanceMetadata.

        Information about external VLs to connect the VNF to.   # noqa: E501

        :param ext_virtual_links: The ext_virtual_links of this VnfInstanceMetadata.  # noqa: E501
        :type: list[ExtVirtualLinkData]
        """

        self._ext_virtual_links = ext_virtual_links

    @property
    def tags(self):
        """Gets the tags of this VnfInstanceMetadata.  # noqa: E501


        :return: The tags of this VnfInstanceMetadata.  # noqa: E501
        :rtype: list[VnfInstanceMetadataTags]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this VnfInstanceMetadata.


        :param tags: The tags of this VnfInstanceMetadata.  # noqa: E501
        :type: list[VnfInstanceMetadataTags]
        """

        self._tags = tags

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfInstanceMetadata, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfInstanceMetadata):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
