# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfInstantiateRequestAdditionalParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vdu_params': 'list[VduParam]',
        'lcm_interfaces': 'list[LcmInterfaces]',
        'entity_prefix': 'str',
        'use_v_app_templates': 'bool',
        'catalog_name': 'str',
        'catalog_id': 'str',
        'skip_grant': 'bool',
        'ignore_grant_failure': 'bool',
        'disable_auto_rollback': 'bool',
        'disable_grant': 'bool',
        'skip_node_customization': 'object',
        'is_vnf_v_app_template': 'bool',
        'v_app_template_name': 'str',
        'storage_profiles': 'list[str]',
        'nodepool_name': 'str'
    }

    attribute_map = {
        'vdu_params': 'vduParams',
        'lcm_interfaces': 'lcmInterfaces',
        'entity_prefix': 'entityPrefix',
        'use_v_app_templates': 'useVAppTemplates',
        'catalog_name': 'catalogName',
        'catalog_id': 'catalogId',
        'skip_grant': 'skipGrant',
        'ignore_grant_failure': 'ignoreGrantFailure',
        'disable_auto_rollback': 'disableAutoRollback',
        'disable_grant': 'disableGrant',
        'skip_node_customization': 'skipNodeCustomization',
        'is_vnf_v_app_template': 'isVnfVAppTemplate',
        'v_app_template_name': 'vAppTemplateName',
        'storage_profiles': 'storageProfiles',
        'nodepool_name': 'nodepoolName'
    }

    def __init__(self, vdu_params=None, lcm_interfaces=None, entity_prefix=None, use_v_app_templates=None, catalog_name=None, catalog_id=None, skip_grant=None, ignore_grant_failure=None, disable_auto_rollback=None, disable_grant=None, skip_node_customization=None, is_vnf_v_app_template=None, v_app_template_name=None, storage_profiles=None, nodepool_name=None):  # noqa: E501
        """VnfInstantiateRequestAdditionalParams - a model defined in Swagger"""  # noqa: E501
        self._vdu_params = None
        self._lcm_interfaces = None
        self._entity_prefix = None
        self._use_v_app_templates = None
        self._catalog_name = None
        self._catalog_id = None
        self._skip_grant = None
        self._ignore_grant_failure = None
        self._disable_auto_rollback = None
        self._disable_grant = None
        self._skip_node_customization = None
        self._is_vnf_v_app_template = None
        self._v_app_template_name = None
        self._storage_profiles = None
        self._nodepool_name = None
        self.discriminator = None
        if vdu_params is not None:
            self.vdu_params = vdu_params
        if lcm_interfaces is not None:
            self.lcm_interfaces = lcm_interfaces
        if entity_prefix is not None:
            self.entity_prefix = entity_prefix
        if use_v_app_templates is not None:
            self.use_v_app_templates = use_v_app_templates
        if catalog_name is not None:
            self.catalog_name = catalog_name
        if catalog_id is not None:
            self.catalog_id = catalog_id
        if skip_grant is not None:
            self.skip_grant = skip_grant
        if ignore_grant_failure is not None:
            self.ignore_grant_failure = ignore_grant_failure
        if disable_auto_rollback is not None:
            self.disable_auto_rollback = disable_auto_rollback
        if disable_grant is not None:
            self.disable_grant = disable_grant
        if skip_node_customization is not None:
            self.skip_node_customization = skip_node_customization
        if is_vnf_v_app_template is not None:
            self.is_vnf_v_app_template = is_vnf_v_app_template
        if v_app_template_name is not None:
            self.v_app_template_name = v_app_template_name
        if storage_profiles is not None:
            self.storage_profiles = storage_profiles
        if nodepool_name is not None:
            self.nodepool_name = nodepool_name

    @property
    def vdu_params(self):
        """Gets the vdu_params of this VnfInstantiateRequestAdditionalParams.  # noqa: E501


        :return: The vdu_params of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :rtype: list[VduParam]
        """
        return self._vdu_params

    @vdu_params.setter
    def vdu_params(self, vdu_params):
        """Sets the vdu_params of this VnfInstantiateRequestAdditionalParams.


        :param vdu_params: The vdu_params of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :type: list[VduParam]
        """

        self._vdu_params = vdu_params

    @property
    def lcm_interfaces(self):
        """Gets the lcm_interfaces of this VnfInstantiateRequestAdditionalParams.  # noqa: E501


        :return: The lcm_interfaces of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :rtype: list[LcmInterfaces]
        """
        return self._lcm_interfaces

    @lcm_interfaces.setter
    def lcm_interfaces(self, lcm_interfaces):
        """Sets the lcm_interfaces of this VnfInstantiateRequestAdditionalParams.


        :param lcm_interfaces: The lcm_interfaces of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :type: list[LcmInterfaces]
        """

        self._lcm_interfaces = lcm_interfaces

    @property
    def entity_prefix(self):
        """Gets the entity_prefix of this VnfInstantiateRequestAdditionalParams.  # noqa: E501


        :return: The entity_prefix of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :rtype: str
        """
        return self._entity_prefix

    @entity_prefix.setter
    def entity_prefix(self, entity_prefix):
        """Sets the entity_prefix of this VnfInstantiateRequestAdditionalParams.


        :param entity_prefix: The entity_prefix of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :type: str
        """

        self._entity_prefix = entity_prefix

    @property
    def use_v_app_templates(self):
        """Gets the use_v_app_templates of this VnfInstantiateRequestAdditionalParams.  # noqa: E501


        :return: The use_v_app_templates of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :rtype: bool
        """
        return self._use_v_app_templates

    @use_v_app_templates.setter
    def use_v_app_templates(self, use_v_app_templates):
        """Sets the use_v_app_templates of this VnfInstantiateRequestAdditionalParams.


        :param use_v_app_templates: The use_v_app_templates of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :type: bool
        """

        self._use_v_app_templates = use_v_app_templates

    @property
    def catalog_name(self):
        """Gets the catalog_name of this VnfInstantiateRequestAdditionalParams.  # noqa: E501


        :return: The catalog_name of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :rtype: str
        """
        return self._catalog_name

    @catalog_name.setter
    def catalog_name(self, catalog_name):
        """Sets the catalog_name of this VnfInstantiateRequestAdditionalParams.


        :param catalog_name: The catalog_name of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :type: str
        """

        self._catalog_name = catalog_name

    @property
    def catalog_id(self):
        """Gets the catalog_id of this VnfInstantiateRequestAdditionalParams.  # noqa: E501


        :return: The catalog_id of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :rtype: str
        """
        return self._catalog_id

    @catalog_id.setter
    def catalog_id(self, catalog_id):
        """Sets the catalog_id of this VnfInstantiateRequestAdditionalParams.


        :param catalog_id: The catalog_id of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :type: str
        """

        self._catalog_id = catalog_id

    @property
    def skip_grant(self):
        """Gets the skip_grant of this VnfInstantiateRequestAdditionalParams.  # noqa: E501

        Set to true if grant phase is to be skipped in this VNF LCM operation occurrence. Set to false otherwise.   # noqa: E501

        :return: The skip_grant of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :rtype: bool
        """
        return self._skip_grant

    @skip_grant.setter
    def skip_grant(self, skip_grant):
        """Sets the skip_grant of this VnfInstantiateRequestAdditionalParams.

        Set to true if grant phase is to be skipped in this VNF LCM operation occurrence. Set to false otherwise.   # noqa: E501

        :param skip_grant: The skip_grant of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :type: bool
        """

        self._skip_grant = skip_grant

    @property
    def ignore_grant_failure(self):
        """Gets the ignore_grant_failure of this VnfInstantiateRequestAdditionalParams.  # noqa: E501

        Set to true if grant failures are to be ignored while instantiating CNF. Set to false otherwise.   # noqa: E501

        :return: The ignore_grant_failure of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :rtype: bool
        """
        return self._ignore_grant_failure

    @ignore_grant_failure.setter
    def ignore_grant_failure(self, ignore_grant_failure):
        """Sets the ignore_grant_failure of this VnfInstantiateRequestAdditionalParams.

        Set to true if grant failures are to be ignored while instantiating CNF. Set to false otherwise.   # noqa: E501

        :param ignore_grant_failure: The ignore_grant_failure of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :type: bool
        """

        self._ignore_grant_failure = ignore_grant_failure

    @property
    def disable_auto_rollback(self):
        """Gets the disable_auto_rollback of this VnfInstantiateRequestAdditionalParams.  # noqa: E501

        Set to true if auto rollback is to be disabled when CNF instantiation fails. Set to false otherwise.   # noqa: E501

        :return: The disable_auto_rollback of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :rtype: bool
        """
        return self._disable_auto_rollback

    @disable_auto_rollback.setter
    def disable_auto_rollback(self, disable_auto_rollback):
        """Sets the disable_auto_rollback of this VnfInstantiateRequestAdditionalParams.

        Set to true if auto rollback is to be disabled when CNF instantiation fails. Set to false otherwise.   # noqa: E501

        :param disable_auto_rollback: The disable_auto_rollback of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :type: bool
        """

        self._disable_auto_rollback = disable_auto_rollback

    @property
    def disable_grant(self):
        """Gets the disable_grant of this VnfInstantiateRequestAdditionalParams.  # noqa: E501

        Set to true if grant phase is to be skipped while instantiating CNF. Set to false otherwise.   # noqa: E501

        :return: The disable_grant of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :rtype: bool
        """
        return self._disable_grant

    @disable_grant.setter
    def disable_grant(self, disable_grant):
        """Sets the disable_grant of this VnfInstantiateRequestAdditionalParams.

        Set to true if grant phase is to be skipped while instantiating CNF. Set to false otherwise.   # noqa: E501

        :param disable_grant: The disable_grant of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :type: bool
        """

        self._disable_grant = disable_grant

    @property
    def skip_node_customization(self):
        """Gets the skip_node_customization of this VnfInstantiateRequestAdditionalParams.  # noqa: E501

        Set to true for customization to be skipped while instantiating CNF. Set to false otherwise. type: boolean   # noqa: E501

        :return: The skip_node_customization of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :rtype: object
        """
        return self._skip_node_customization

    @skip_node_customization.setter
    def skip_node_customization(self, skip_node_customization):
        """Sets the skip_node_customization of this VnfInstantiateRequestAdditionalParams.

        Set to true for customization to be skipped while instantiating CNF. Set to false otherwise. type: boolean   # noqa: E501

        :param skip_node_customization: The skip_node_customization of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :type: object
        """

        self._skip_node_customization = skip_node_customization

    @property
    def is_vnf_v_app_template(self):
        """Gets the is_vnf_v_app_template of this VnfInstantiateRequestAdditionalParams.  # noqa: E501

        Set to true if the entire VNF is represented by a single vApp template. Set to false otherwise.   # noqa: E501

        :return: The is_vnf_v_app_template of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :rtype: bool
        """
        return self._is_vnf_v_app_template

    @is_vnf_v_app_template.setter
    def is_vnf_v_app_template(self, is_vnf_v_app_template):
        """Sets the is_vnf_v_app_template of this VnfInstantiateRequestAdditionalParams.

        Set to true if the entire VNF is represented by a single vApp template. Set to false otherwise.   # noqa: E501

        :param is_vnf_v_app_template: The is_vnf_v_app_template of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :type: bool
        """

        self._is_vnf_v_app_template = is_vnf_v_app_template

    @property
    def v_app_template_name(self):
        """Gets the v_app_template_name of this VnfInstantiateRequestAdditionalParams.  # noqa: E501


        :return: The v_app_template_name of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :rtype: str
        """
        return self._v_app_template_name

    @v_app_template_name.setter
    def v_app_template_name(self, v_app_template_name):
        """Sets the v_app_template_name of this VnfInstantiateRequestAdditionalParams.


        :param v_app_template_name: The v_app_template_name of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :type: str
        """

        self._v_app_template_name = v_app_template_name

    @property
    def storage_profiles(self):
        """Gets the storage_profiles of this VnfInstantiateRequestAdditionalParams.  # noqa: E501

        Storage Profile Ids which should be used by all the VMs in this VNF.   # noqa: E501

        :return: The storage_profiles of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :rtype: list[str]
        """
        return self._storage_profiles

    @storage_profiles.setter
    def storage_profiles(self, storage_profiles):
        """Sets the storage_profiles of this VnfInstantiateRequestAdditionalParams.

        Storage Profile Ids which should be used by all the VMs in this VNF.   # noqa: E501

        :param storage_profiles: The storage_profiles of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :type: list[str]
        """

        self._storage_profiles = storage_profiles

    @property
    def nodepool_name(self):
        """Gets the nodepool_name of this VnfInstantiateRequestAdditionalParams.  # noqa: E501

        Name of the nodepool that should be customized while instantiating CNF.   # noqa: E501

        :return: The nodepool_name of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :rtype: str
        """
        return self._nodepool_name

    @nodepool_name.setter
    def nodepool_name(self, nodepool_name):
        """Sets the nodepool_name of this VnfInstantiateRequestAdditionalParams.

        Name of the nodepool that should be customized while instantiating CNF.   # noqa: E501

        :param nodepool_name: The nodepool_name of this VnfInstantiateRequestAdditionalParams.  # noqa: E501
        :type: str
        """

        self._nodepool_name = nodepool_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfInstantiateRequestAdditionalParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfInstantiateRequestAdditionalParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
