# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfLcmOpOcc(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'Identifier',
        'operation_state': 'LcmOperationStateType',
        'state_entered_time': 'datetime',
        'start_time': 'datetime',
        'vnf_instance_id': 'Identifier',
        'grant_id': 'Identifier',
        'operation': 'LcmOperationType',
        'is_automatic_invocation': 'Boolean',
        'operation_params': 'object',
        'is_cancel_pending': 'Boolean',
        'cancel_mode': 'CancelModeType',
        'error': 'ProblemDetails',
        'resource_changes': 'VnfLcmOpOccResourceChanges',
        'changed_info': 'VnfInfoModifications',
        'changed_ext_connectivity': 'list[ExtVirtualLinkInfo]',
        'links': 'VnfLcmOpOccLinks'
    }

    attribute_map = {
        'id': 'id',
        'operation_state': 'operationState',
        'state_entered_time': 'stateEnteredTime',
        'start_time': 'startTime',
        'vnf_instance_id': 'vnfInstanceId',
        'grant_id': 'grantId',
        'operation': 'operation',
        'is_automatic_invocation': 'isAutomaticInvocation',
        'operation_params': 'operationParams',
        'is_cancel_pending': 'isCancelPending',
        'cancel_mode': 'cancelMode',
        'error': 'error',
        'resource_changes': 'resourceChanges',
        'changed_info': 'changedInfo',
        'changed_ext_connectivity': 'changedExtConnectivity',
        'links': '_links'
    }

    def __init__(self, id=None, operation_state=None, state_entered_time=None, start_time=None, vnf_instance_id=None, grant_id=None, operation=None, is_automatic_invocation=None, operation_params=None, is_cancel_pending=None, cancel_mode=None, error=None, resource_changes=None, changed_info=None, changed_ext_connectivity=None, links=None):  # noqa: E501
        """VnfLcmOpOcc - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._operation_state = None
        self._state_entered_time = None
        self._start_time = None
        self._vnf_instance_id = None
        self._grant_id = None
        self._operation = None
        self._is_automatic_invocation = None
        self._operation_params = None
        self._is_cancel_pending = None
        self._cancel_mode = None
        self._error = None
        self._resource_changes = None
        self._changed_info = None
        self._changed_ext_connectivity = None
        self._links = None
        self.discriminator = None
        self.id = id
        self.operation_state = operation_state
        self.state_entered_time = state_entered_time
        self.start_time = start_time
        self.vnf_instance_id = vnf_instance_id
        if grant_id is not None:
            self.grant_id = grant_id
        self.operation = operation
        self.is_automatic_invocation = is_automatic_invocation
        if operation_params is not None:
            self.operation_params = operation_params
        self.is_cancel_pending = is_cancel_pending
        if cancel_mode is not None:
            self.cancel_mode = cancel_mode
        if error is not None:
            self.error = error
        if resource_changes is not None:
            self.resource_changes = resource_changes
        if changed_info is not None:
            self.changed_info = changed_info
        if changed_ext_connectivity is not None:
            self.changed_ext_connectivity = changed_ext_connectivity
        if links is not None:
            self.links = links

    @property
    def id(self):
        """Gets the id of this VnfLcmOpOcc.  # noqa: E501


        :return: The id of this VnfLcmOpOcc.  # noqa: E501
        :rtype: Identifier
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this VnfLcmOpOcc.


        :param id: The id of this VnfLcmOpOcc.  # noqa: E501
        :type: Identifier
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def operation_state(self):
        """Gets the operation_state of this VnfLcmOpOcc.  # noqa: E501


        :return: The operation_state of this VnfLcmOpOcc.  # noqa: E501
        :rtype: LcmOperationStateType
        """
        return self._operation_state

    @operation_state.setter
    def operation_state(self, operation_state):
        """Sets the operation_state of this VnfLcmOpOcc.


        :param operation_state: The operation_state of this VnfLcmOpOcc.  # noqa: E501
        :type: LcmOperationStateType
        """
        if operation_state is None:
            print("WARNING: Invalid value for the required field `operation_state`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `operation_state`, must not be `None`")  # noqa: E501

        self._operation_state = operation_state

    @property
    def state_entered_time(self):
        """Gets the state_entered_time of this VnfLcmOpOcc.  # noqa: E501


        :return: The state_entered_time of this VnfLcmOpOcc.  # noqa: E501
        :rtype: datetime
        """
        return self._state_entered_time

    @state_entered_time.setter
    def state_entered_time(self, state_entered_time):
        """Sets the state_entered_time of this VnfLcmOpOcc.


        :param state_entered_time: The state_entered_time of this VnfLcmOpOcc.  # noqa: E501
        :type: datetime
        """
        if state_entered_time is None:
            print("WARNING: Invalid value for the required field `state_entered_time`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `state_entered_time`, must not be `None`")  # noqa: E501

        self._state_entered_time = state_entered_time

    @property
    def start_time(self):
        """Gets the start_time of this VnfLcmOpOcc.  # noqa: E501


        :return: The start_time of this VnfLcmOpOcc.  # noqa: E501
        :rtype: datetime
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """Sets the start_time of this VnfLcmOpOcc.


        :param start_time: The start_time of this VnfLcmOpOcc.  # noqa: E501
        :type: datetime
        """
        if start_time is None:
            print("WARNING: Invalid value for the required field `start_time`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `start_time`, must not be `None`")  # noqa: E501

        self._start_time = start_time

    @property
    def vnf_instance_id(self):
        """Gets the vnf_instance_id of this VnfLcmOpOcc.  # noqa: E501


        :return: The vnf_instance_id of this VnfLcmOpOcc.  # noqa: E501
        :rtype: Identifier
        """
        return self._vnf_instance_id

    @vnf_instance_id.setter
    def vnf_instance_id(self, vnf_instance_id):
        """Sets the vnf_instance_id of this VnfLcmOpOcc.


        :param vnf_instance_id: The vnf_instance_id of this VnfLcmOpOcc.  # noqa: E501
        :type: Identifier
        """
        if vnf_instance_id is None:
            print("WARNING: Invalid value for the required field `vnf_instance_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_instance_id`, must not be `None`")  # noqa: E501

        self._vnf_instance_id = vnf_instance_id

    @property
    def grant_id(self):
        """Gets the grant_id of this VnfLcmOpOcc.  # noqa: E501


        :return: The grant_id of this VnfLcmOpOcc.  # noqa: E501
        :rtype: Identifier
        """
        return self._grant_id

    @grant_id.setter
    def grant_id(self, grant_id):
        """Sets the grant_id of this VnfLcmOpOcc.


        :param grant_id: The grant_id of this VnfLcmOpOcc.  # noqa: E501
        :type: Identifier
        """

        self._grant_id = grant_id

    @property
    def operation(self):
        """Gets the operation of this VnfLcmOpOcc.  # noqa: E501


        :return: The operation of this VnfLcmOpOcc.  # noqa: E501
        :rtype: LcmOperationType
        """
        return self._operation

    @operation.setter
    def operation(self, operation):
        """Sets the operation of this VnfLcmOpOcc.


        :param operation: The operation of this VnfLcmOpOcc.  # noqa: E501
        :type: LcmOperationType
        """
        if operation is None:
            print("WARNING: Invalid value for the required field `operation`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `operation`, must not be `None`")  # noqa: E501

        self._operation = operation

    @property
    def is_automatic_invocation(self):
        """Gets the is_automatic_invocation of this VnfLcmOpOcc.  # noqa: E501


        :return: The is_automatic_invocation of this VnfLcmOpOcc.  # noqa: E501
        :rtype: Boolean
        """
        return self._is_automatic_invocation

    @is_automatic_invocation.setter
    def is_automatic_invocation(self, is_automatic_invocation):
        """Sets the is_automatic_invocation of this VnfLcmOpOcc.


        :param is_automatic_invocation: The is_automatic_invocation of this VnfLcmOpOcc.  # noqa: E501
        :type: Boolean
        """
        if is_automatic_invocation is None:
            print("WARNING: Invalid value for the required field `is_automatic_invocation`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `is_automatic_invocation`, must not be `None`")  # noqa: E501

        self._is_automatic_invocation = is_automatic_invocation

    @property
    def operation_params(self):
        """Gets the operation_params of this VnfLcmOpOcc.  # noqa: E501

        Input parameters of the LCM operation. This attribute shall be formatted according to the request data type of the related LCM operation. The following mapping between operationType and the data type of this attribute shall apply: * INSTANTIATE: InstantiateVnfRequest * SCALE: ScaleVnfRequest * SCALE_TO_LEVEL: ScaleVnfToLevelRequest * CHANGE_FLAVOUR: ChangeVnfFlavourRequest * OPERATE: OperateVnfRequest * HEAL: HealVnfRequest * CHANGE_EXT_CONN: ChangeExtVnfConnectivityRequest * TERMINATE: TerminateVnfRequest * MODIFY_INFO: VnfInfoModifications   # noqa: E501

        :return: The operation_params of this VnfLcmOpOcc.  # noqa: E501
        :rtype: object
        """
        return self._operation_params

    @operation_params.setter
    def operation_params(self, operation_params):
        """Sets the operation_params of this VnfLcmOpOcc.

        Input parameters of the LCM operation. This attribute shall be formatted according to the request data type of the related LCM operation. The following mapping between operationType and the data type of this attribute shall apply: * INSTANTIATE: InstantiateVnfRequest * SCALE: ScaleVnfRequest * SCALE_TO_LEVEL: ScaleVnfToLevelRequest * CHANGE_FLAVOUR: ChangeVnfFlavourRequest * OPERATE: OperateVnfRequest * HEAL: HealVnfRequest * CHANGE_EXT_CONN: ChangeExtVnfConnectivityRequest * TERMINATE: TerminateVnfRequest * MODIFY_INFO: VnfInfoModifications   # noqa: E501

        :param operation_params: The operation_params of this VnfLcmOpOcc.  # noqa: E501
        :type: object
        """

        self._operation_params = operation_params

    @property
    def is_cancel_pending(self):
        """Gets the is_cancel_pending of this VnfLcmOpOcc.  # noqa: E501


        :return: The is_cancel_pending of this VnfLcmOpOcc.  # noqa: E501
        :rtype: Boolean
        """
        return self._is_cancel_pending

    @is_cancel_pending.setter
    def is_cancel_pending(self, is_cancel_pending):
        """Sets the is_cancel_pending of this VnfLcmOpOcc.


        :param is_cancel_pending: The is_cancel_pending of this VnfLcmOpOcc.  # noqa: E501
        :type: Boolean
        """
        if is_cancel_pending is None:
            print("WARNING: Invalid value for the required field `is_cancel_pending`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `is_cancel_pending`, must not be `None`")  # noqa: E501

        self._is_cancel_pending = is_cancel_pending

    @property
    def cancel_mode(self):
        """Gets the cancel_mode of this VnfLcmOpOcc.  # noqa: E501


        :return: The cancel_mode of this VnfLcmOpOcc.  # noqa: E501
        :rtype: CancelModeType
        """
        return self._cancel_mode

    @cancel_mode.setter
    def cancel_mode(self, cancel_mode):
        """Sets the cancel_mode of this VnfLcmOpOcc.


        :param cancel_mode: The cancel_mode of this VnfLcmOpOcc.  # noqa: E501
        :type: CancelModeType
        """

        self._cancel_mode = cancel_mode

    @property
    def error(self):
        """Gets the error of this VnfLcmOpOcc.  # noqa: E501


        :return: The error of this VnfLcmOpOcc.  # noqa: E501
        :rtype: ProblemDetails
        """
        return self._error

    @error.setter
    def error(self, error):
        """Sets the error of this VnfLcmOpOcc.


        :param error: The error of this VnfLcmOpOcc.  # noqa: E501
        :type: ProblemDetails
        """

        self._error = error

    @property
    def resource_changes(self):
        """Gets the resource_changes of this VnfLcmOpOcc.  # noqa: E501


        :return: The resource_changes of this VnfLcmOpOcc.  # noqa: E501
        :rtype: VnfLcmOpOccResourceChanges
        """
        return self._resource_changes

    @resource_changes.setter
    def resource_changes(self, resource_changes):
        """Sets the resource_changes of this VnfLcmOpOcc.


        :param resource_changes: The resource_changes of this VnfLcmOpOcc.  # noqa: E501
        :type: VnfLcmOpOccResourceChanges
        """

        self._resource_changes = resource_changes

    @property
    def changed_info(self):
        """Gets the changed_info of this VnfLcmOpOcc.  # noqa: E501


        :return: The changed_info of this VnfLcmOpOcc.  # noqa: E501
        :rtype: VnfInfoModifications
        """
        return self._changed_info

    @changed_info.setter
    def changed_info(self, changed_info):
        """Sets the changed_info of this VnfLcmOpOcc.


        :param changed_info: The changed_info of this VnfLcmOpOcc.  # noqa: E501
        :type: VnfInfoModifications
        """

        self._changed_info = changed_info

    @property
    def changed_ext_connectivity(self):
        """Gets the changed_ext_connectivity of this VnfLcmOpOcc.  # noqa: E501

        Information about changed external connectivity, if applicable. This allows the NFVO to obtain the information contained in the latest \"result\" notification if it has not received it due to an error or a wrongly configured subscription filter.   # noqa: E501

        :return: The changed_ext_connectivity of this VnfLcmOpOcc.  # noqa: E501
        :rtype: list[ExtVirtualLinkInfo]
        """
        return self._changed_ext_connectivity

    @changed_ext_connectivity.setter
    def changed_ext_connectivity(self, changed_ext_connectivity):
        """Sets the changed_ext_connectivity of this VnfLcmOpOcc.

        Information about changed external connectivity, if applicable. This allows the NFVO to obtain the information contained in the latest \"result\" notification if it has not received it due to an error or a wrongly configured subscription filter.   # noqa: E501

        :param changed_ext_connectivity: The changed_ext_connectivity of this VnfLcmOpOcc.  # noqa: E501
        :type: list[ExtVirtualLinkInfo]
        """

        self._changed_ext_connectivity = changed_ext_connectivity

    @property
    def links(self):
        """Gets the links of this VnfLcmOpOcc.  # noqa: E501


        :return: The links of this VnfLcmOpOcc.  # noqa: E501
        :rtype: VnfLcmOpOccLinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this VnfLcmOpOcc.


        :param links: The links of this VnfLcmOpOcc.  # noqa: E501
        :type: VnfLcmOpOccLinks
        """

        self._links = links

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfLcmOpOcc, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfLcmOpOcc):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
