# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfLcmOpOccResourceChanges(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'affected_vnfcs': 'list[AffectedVnfc]',
        'affected_virtual_links': 'list[AffectedVirtualLink]',
        'affected_virtual_storages': 'list[AffectedVirtualStorage]'
    }

    attribute_map = {
        'affected_vnfcs': 'affectedVnfcs',
        'affected_virtual_links': 'affectedVirtualLinks',
        'affected_virtual_storages': 'affectedVirtualStorages'
    }

    def __init__(self, affected_vnfcs=None, affected_virtual_links=None, affected_virtual_storages=None):  # noqa: E501
        """VnfLcmOpOccResourceChanges - a model defined in Swagger"""  # noqa: E501
        self._affected_vnfcs = None
        self._affected_virtual_links = None
        self._affected_virtual_storages = None
        self.discriminator = None
        if affected_vnfcs is not None:
            self.affected_vnfcs = affected_vnfcs
        if affected_virtual_links is not None:
            self.affected_virtual_links = affected_virtual_links
        if affected_virtual_storages is not None:
            self.affected_virtual_storages = affected_virtual_storages

    @property
    def affected_vnfcs(self):
        """Gets the affected_vnfcs of this VnfLcmOpOccResourceChanges.  # noqa: E501

        Information about VNFC instances that were affected during the lifecycle operation. This allows the NFVO to obtain the information contained in the latest \"result\" notification if it has not received it due to an error or a wrongly configured subscription filter.   # noqa: E501

        :return: The affected_vnfcs of this VnfLcmOpOccResourceChanges.  # noqa: E501
        :rtype: list[AffectedVnfc]
        """
        return self._affected_vnfcs

    @affected_vnfcs.setter
    def affected_vnfcs(self, affected_vnfcs):
        """Sets the affected_vnfcs of this VnfLcmOpOccResourceChanges.

        Information about VNFC instances that were affected during the lifecycle operation. This allows the NFVO to obtain the information contained in the latest \"result\" notification if it has not received it due to an error or a wrongly configured subscription filter.   # noqa: E501

        :param affected_vnfcs: The affected_vnfcs of this VnfLcmOpOccResourceChanges.  # noqa: E501
        :type: list[AffectedVnfc]
        """

        self._affected_vnfcs = affected_vnfcs

    @property
    def affected_virtual_links(self):
        """Gets the affected_virtual_links of this VnfLcmOpOccResourceChanges.  # noqa: E501

        Information about VL instances that were affected during the lifecycle operation. This allows the NFVO to obtain the information contained in the latest \"result\" notification if it has not received it due to an error or a wrongly configured subscription filter.   # noqa: E501

        :return: The affected_virtual_links of this VnfLcmOpOccResourceChanges.  # noqa: E501
        :rtype: list[AffectedVirtualLink]
        """
        return self._affected_virtual_links

    @affected_virtual_links.setter
    def affected_virtual_links(self, affected_virtual_links):
        """Sets the affected_virtual_links of this VnfLcmOpOccResourceChanges.

        Information about VL instances that were affected during the lifecycle operation. This allows the NFVO to obtain the information contained in the latest \"result\" notification if it has not received it due to an error or a wrongly configured subscription filter.   # noqa: E501

        :param affected_virtual_links: The affected_virtual_links of this VnfLcmOpOccResourceChanges.  # noqa: E501
        :type: list[AffectedVirtualLink]
        """

        self._affected_virtual_links = affected_virtual_links

    @property
    def affected_virtual_storages(self):
        """Gets the affected_virtual_storages of this VnfLcmOpOccResourceChanges.  # noqa: E501

        Information about virtualised storage instances that were affected during the lifecycle operation. This allows the NFVO to obtain the information contained in the latest \"result\" notification if it has not received it due to an error or a wrongly configured subscription filter.   # noqa: E501

        :return: The affected_virtual_storages of this VnfLcmOpOccResourceChanges.  # noqa: E501
        :rtype: list[AffectedVirtualStorage]
        """
        return self._affected_virtual_storages

    @affected_virtual_storages.setter
    def affected_virtual_storages(self, affected_virtual_storages):
        """Sets the affected_virtual_storages of this VnfLcmOpOccResourceChanges.

        Information about virtualised storage instances that were affected during the lifecycle operation. This allows the NFVO to obtain the information contained in the latest \"result\" notification if it has not received it due to an error or a wrongly configured subscription filter.   # noqa: E501

        :param affected_virtual_storages: The affected_virtual_storages of this VnfLcmOpOccResourceChanges.  # noqa: E501
        :type: list[AffectedVirtualStorage]
        """

        self._affected_virtual_storages = affected_virtual_storages

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfLcmOpOccResourceChanges, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfLcmOpOccResourceChanges):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
