# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfVirtualLinkResourceInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'IdentifierInVnf',
        'vnf_virtual_link_desc_id': 'IdentifierInVnfd',
        'network_resource': 'ResourceHandle',
        'zone_id': 'Identifier',
        'reservation_id': 'Identifier',
        'vnf_link_ports': 'list[VnfLinkPortInfo]',
        'metadata': 'KeyValuePairs'
    }

    attribute_map = {
        'id': 'id',
        'vnf_virtual_link_desc_id': 'vnfVirtualLinkDescId',
        'network_resource': 'networkResource',
        'zone_id': 'zoneId',
        'reservation_id': 'reservationId',
        'vnf_link_ports': 'vnfLinkPorts',
        'metadata': 'metadata'
    }

    def __init__(self, id=None, vnf_virtual_link_desc_id=None, network_resource=None, zone_id=None, reservation_id=None, vnf_link_ports=None, metadata=None):  # noqa: E501
        """VnfVirtualLinkResourceInfo - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._vnf_virtual_link_desc_id = None
        self._network_resource = None
        self._zone_id = None
        self._reservation_id = None
        self._vnf_link_ports = None
        self._metadata = None
        self.discriminator = None
        self.id = id
        self.vnf_virtual_link_desc_id = vnf_virtual_link_desc_id
        self.network_resource = network_resource
        if zone_id is not None:
            self.zone_id = zone_id
        if reservation_id is not None:
            self.reservation_id = reservation_id
        if vnf_link_ports is not None:
            self.vnf_link_ports = vnf_link_ports
        if metadata is not None:
            self.metadata = metadata

    @property
    def id(self):
        """Gets the id of this VnfVirtualLinkResourceInfo.  # noqa: E501


        :return: The id of this VnfVirtualLinkResourceInfo.  # noqa: E501
        :rtype: IdentifierInVnf
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this VnfVirtualLinkResourceInfo.


        :param id: The id of this VnfVirtualLinkResourceInfo.  # noqa: E501
        :type: IdentifierInVnf
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def vnf_virtual_link_desc_id(self):
        """Gets the vnf_virtual_link_desc_id of this VnfVirtualLinkResourceInfo.  # noqa: E501


        :return: The vnf_virtual_link_desc_id of this VnfVirtualLinkResourceInfo.  # noqa: E501
        :rtype: IdentifierInVnfd
        """
        return self._vnf_virtual_link_desc_id

    @vnf_virtual_link_desc_id.setter
    def vnf_virtual_link_desc_id(self, vnf_virtual_link_desc_id):
        """Sets the vnf_virtual_link_desc_id of this VnfVirtualLinkResourceInfo.


        :param vnf_virtual_link_desc_id: The vnf_virtual_link_desc_id of this VnfVirtualLinkResourceInfo.  # noqa: E501
        :type: IdentifierInVnfd
        """
        if vnf_virtual_link_desc_id is None:
            print("WARNING: Invalid value for the required field `vnf_virtual_link_desc_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_virtual_link_desc_id`, must not be `None`")  # noqa: E501

        self._vnf_virtual_link_desc_id = vnf_virtual_link_desc_id

    @property
    def network_resource(self):
        """Gets the network_resource of this VnfVirtualLinkResourceInfo.  # noqa: E501


        :return: The network_resource of this VnfVirtualLinkResourceInfo.  # noqa: E501
        :rtype: ResourceHandle
        """
        return self._network_resource

    @network_resource.setter
    def network_resource(self, network_resource):
        """Sets the network_resource of this VnfVirtualLinkResourceInfo.


        :param network_resource: The network_resource of this VnfVirtualLinkResourceInfo.  # noqa: E501
        :type: ResourceHandle
        """
        if network_resource is None:
            print("WARNING: Invalid value for the required field `network_resource`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `network_resource`, must not be `None`")  # noqa: E501

        self._network_resource = network_resource

    @property
    def zone_id(self):
        """Gets the zone_id of this VnfVirtualLinkResourceInfo.  # noqa: E501


        :return: The zone_id of this VnfVirtualLinkResourceInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._zone_id

    @zone_id.setter
    def zone_id(self, zone_id):
        """Sets the zone_id of this VnfVirtualLinkResourceInfo.


        :param zone_id: The zone_id of this VnfVirtualLinkResourceInfo.  # noqa: E501
        :type: Identifier
        """

        self._zone_id = zone_id

    @property
    def reservation_id(self):
        """Gets the reservation_id of this VnfVirtualLinkResourceInfo.  # noqa: E501


        :return: The reservation_id of this VnfVirtualLinkResourceInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._reservation_id

    @reservation_id.setter
    def reservation_id(self, reservation_id):
        """Sets the reservation_id of this VnfVirtualLinkResourceInfo.


        :param reservation_id: The reservation_id of this VnfVirtualLinkResourceInfo.  # noqa: E501
        :type: Identifier
        """

        self._reservation_id = reservation_id

    @property
    def vnf_link_ports(self):
        """Gets the vnf_link_ports of this VnfVirtualLinkResourceInfo.  # noqa: E501

        Links ports of this VL. Shall be present when the linkPort is used for external connectivity by the VNF (refer to VnfLinkPortInfo). May be present otherwise.   # noqa: E501

        :return: The vnf_link_ports of this VnfVirtualLinkResourceInfo.  # noqa: E501
        :rtype: list[VnfLinkPortInfo]
        """
        return self._vnf_link_ports

    @vnf_link_ports.setter
    def vnf_link_ports(self, vnf_link_ports):
        """Sets the vnf_link_ports of this VnfVirtualLinkResourceInfo.

        Links ports of this VL. Shall be present when the linkPort is used for external connectivity by the VNF (refer to VnfLinkPortInfo). May be present otherwise.   # noqa: E501

        :param vnf_link_ports: The vnf_link_ports of this VnfVirtualLinkResourceInfo.  # noqa: E501
        :type: list[VnfLinkPortInfo]
        """

        self._vnf_link_ports = vnf_link_ports

    @property
    def metadata(self):
        """Gets the metadata of this VnfVirtualLinkResourceInfo.  # noqa: E501


        :return: The metadata of this VnfVirtualLinkResourceInfo.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this VnfVirtualLinkResourceInfo.


        :param metadata: The metadata of this VnfVirtualLinkResourceInfo.  # noqa: E501
        :type: KeyValuePairs
        """

        self._metadata = metadata

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfVirtualLinkResourceInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfVirtualLinkResourceInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
