# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfcInfoModifications(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'IdentifierInVnf',
        'vnfc_configurable_properties': 'KeyValuePairs'
    }

    attribute_map = {
        'id': 'id',
        'vnfc_configurable_properties': 'vnfcConfigurableProperties'
    }

    def __init__(self, id=None, vnfc_configurable_properties=None):  # noqa: E501
        """VnfcInfoModifications - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._vnfc_configurable_properties = None
        self.discriminator = None
        self.id = id
        self.vnfc_configurable_properties = vnfc_configurable_properties

    @property
    def id(self):
        """Gets the id of this VnfcInfoModifications.  # noqa: E501


        :return: The id of this VnfcInfoModifications.  # noqa: E501
        :rtype: IdentifierInVnf
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this VnfcInfoModifications.


        :param id: The id of this VnfcInfoModifications.  # noqa: E501
        :type: IdentifierInVnf
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def vnfc_configurable_properties(self):
        """Gets the vnfc_configurable_properties of this VnfcInfoModifications.  # noqa: E501


        :return: The vnfc_configurable_properties of this VnfcInfoModifications.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._vnfc_configurable_properties

    @vnfc_configurable_properties.setter
    def vnfc_configurable_properties(self, vnfc_configurable_properties):
        """Sets the vnfc_configurable_properties of this VnfcInfoModifications.


        :param vnfc_configurable_properties: The vnfc_configurable_properties of this VnfcInfoModifications.  # noqa: E501
        :type: KeyValuePairs
        """
        if vnfc_configurable_properties is None:
            print("WARNING: Invalid value for the required field `vnfc_configurable_properties`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnfc_configurable_properties`, must not be `None`")  # noqa: E501

        self._vnfc_configurable_properties = vnfc_configurable_properties

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfcInfoModifications, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfcInfoModifications):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
