# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfcResourceInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'IdentifierInVnf',
        'vdu_id': 'IdentifierInVnfd',
        'compute_resource': 'ResourceHandle',
        'zone_id': 'Identifier',
        'storage_resource_ids': 'list[IdentifierInVnf]',
        'reservation_id': 'Identifier',
        'vnfc_cp_info': 'list[VnfcResourceInfoVnfcCpInfo]',
        'metadata': 'VnfcResourceInfoMetadata'
    }

    attribute_map = {
        'id': 'id',
        'vdu_id': 'vduId',
        'compute_resource': 'computeResource',
        'zone_id': 'zoneId',
        'storage_resource_ids': 'storageResourceIds',
        'reservation_id': 'reservationId',
        'vnfc_cp_info': 'vnfcCpInfo',
        'metadata': 'metadata'
    }

    def __init__(self, id=None, vdu_id=None, compute_resource=None, zone_id=None, storage_resource_ids=None, reservation_id=None, vnfc_cp_info=None, metadata=None):  # noqa: E501
        """VnfcResourceInfo - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._vdu_id = None
        self._compute_resource = None
        self._zone_id = None
        self._storage_resource_ids = None
        self._reservation_id = None
        self._vnfc_cp_info = None
        self._metadata = None
        self.discriminator = None
        self.id = id
        self.vdu_id = vdu_id
        self.compute_resource = compute_resource
        if zone_id is not None:
            self.zone_id = zone_id
        if storage_resource_ids is not None:
            self.storage_resource_ids = storage_resource_ids
        if reservation_id is not None:
            self.reservation_id = reservation_id
        if vnfc_cp_info is not None:
            self.vnfc_cp_info = vnfc_cp_info
        if metadata is not None:
            self.metadata = metadata

    @property
    def id(self):
        """Gets the id of this VnfcResourceInfo.  # noqa: E501


        :return: The id of this VnfcResourceInfo.  # noqa: E501
        :rtype: IdentifierInVnf
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this VnfcResourceInfo.


        :param id: The id of this VnfcResourceInfo.  # noqa: E501
        :type: IdentifierInVnf
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def vdu_id(self):
        """Gets the vdu_id of this VnfcResourceInfo.  # noqa: E501


        :return: The vdu_id of this VnfcResourceInfo.  # noqa: E501
        :rtype: IdentifierInVnfd
        """
        return self._vdu_id

    @vdu_id.setter
    def vdu_id(self, vdu_id):
        """Sets the vdu_id of this VnfcResourceInfo.


        :param vdu_id: The vdu_id of this VnfcResourceInfo.  # noqa: E501
        :type: IdentifierInVnfd
        """
        if vdu_id is None:
            print("WARNING: Invalid value for the required field `vdu_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vdu_id`, must not be `None`")  # noqa: E501

        self._vdu_id = vdu_id

    @property
    def compute_resource(self):
        """Gets the compute_resource of this VnfcResourceInfo.  # noqa: E501


        :return: The compute_resource of this VnfcResourceInfo.  # noqa: E501
        :rtype: ResourceHandle
        """
        return self._compute_resource

    @compute_resource.setter
    def compute_resource(self, compute_resource):
        """Sets the compute_resource of this VnfcResourceInfo.


        :param compute_resource: The compute_resource of this VnfcResourceInfo.  # noqa: E501
        :type: ResourceHandle
        """
        if compute_resource is None:
            print("WARNING: Invalid value for the required field `compute_resource`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `compute_resource`, must not be `None`")  # noqa: E501

        self._compute_resource = compute_resource

    @property
    def zone_id(self):
        """Gets the zone_id of this VnfcResourceInfo.  # noqa: E501


        :return: The zone_id of this VnfcResourceInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._zone_id

    @zone_id.setter
    def zone_id(self, zone_id):
        """Sets the zone_id of this VnfcResourceInfo.


        :param zone_id: The zone_id of this VnfcResourceInfo.  # noqa: E501
        :type: Identifier
        """

        self._zone_id = zone_id

    @property
    def storage_resource_ids(self):
        """Gets the storage_resource_ids of this VnfcResourceInfo.  # noqa: E501

        References to the VirtualStorage resources. The value refers to a VirtualStorageResourceInfo item in the VnfInstance.   # noqa: E501

        :return: The storage_resource_ids of this VnfcResourceInfo.  # noqa: E501
        :rtype: list[IdentifierInVnf]
        """
        return self._storage_resource_ids

    @storage_resource_ids.setter
    def storage_resource_ids(self, storage_resource_ids):
        """Sets the storage_resource_ids of this VnfcResourceInfo.

        References to the VirtualStorage resources. The value refers to a VirtualStorageResourceInfo item in the VnfInstance.   # noqa: E501

        :param storage_resource_ids: The storage_resource_ids of this VnfcResourceInfo.  # noqa: E501
        :type: list[IdentifierInVnf]
        """

        self._storage_resource_ids = storage_resource_ids

    @property
    def reservation_id(self):
        """Gets the reservation_id of this VnfcResourceInfo.  # noqa: E501


        :return: The reservation_id of this VnfcResourceInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._reservation_id

    @reservation_id.setter
    def reservation_id(self, reservation_id):
        """Sets the reservation_id of this VnfcResourceInfo.


        :param reservation_id: The reservation_id of this VnfcResourceInfo.  # noqa: E501
        :type: Identifier
        """

        self._reservation_id = reservation_id

    @property
    def vnfc_cp_info(self):
        """Gets the vnfc_cp_info of this VnfcResourceInfo.  # noqa: E501

        CPs of the VNFC instance. Shall be present when that particular CP of the VNFC instance is associated to an external CP of the VNF instance. May be present otherwise.   # noqa: E501

        :return: The vnfc_cp_info of this VnfcResourceInfo.  # noqa: E501
        :rtype: list[VnfcResourceInfoVnfcCpInfo]
        """
        return self._vnfc_cp_info

    @vnfc_cp_info.setter
    def vnfc_cp_info(self, vnfc_cp_info):
        """Sets the vnfc_cp_info of this VnfcResourceInfo.

        CPs of the VNFC instance. Shall be present when that particular CP of the VNFC instance is associated to an external CP of the VNF instance. May be present otherwise.   # noqa: E501

        :param vnfc_cp_info: The vnfc_cp_info of this VnfcResourceInfo.  # noqa: E501
        :type: list[VnfcResourceInfoVnfcCpInfo]
        """

        self._vnfc_cp_info = vnfc_cp_info

    @property
    def metadata(self):
        """Gets the metadata of this VnfcResourceInfo.  # noqa: E501


        :return: The metadata of this VnfcResourceInfo.  # noqa: E501
        :rtype: VnfcResourceInfoMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this VnfcResourceInfo.


        :param metadata: The metadata of this VnfcResourceInfo.  # noqa: E501
        :type: VnfcResourceInfoMetadata
        """

        self._metadata = metadata

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfcResourceInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfcResourceInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
