# coding: utf-8

"""
    SOL003 - VNF Lifecycle Management interface

    SOL003 - VNF Lifecycle Management interface definition  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 1.4.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfcResourceInfoMetadata(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'dispatch_type': 'str',
        'namespace': 'str',
        'chart_name': 'str',
        'chart_version': 'str',
        'repo_url': 'str',
        'username': 'str',
        'helm_version': 'str',
        'instantiation_state': 'str',
        'metadata': 'dict(str, str)'
    }

    attribute_map = {
        'dispatch_type': 'dispatchType',
        'namespace': 'namespace',
        'chart_name': 'chartName',
        'chart_version': 'chartVersion',
        'repo_url': 'repoUrl',
        'username': 'username',
        'helm_version': 'helmVersion',
        'instantiation_state': 'instantiationState',
        'metadata': 'metadata'
    }

    def __init__(self, dispatch_type=None, namespace=None, chart_name=None, chart_version=None, repo_url=None, username=None, helm_version=None, instantiation_state=None, metadata=None):  # noqa: E501
        """VnfcResourceInfoMetadata - a model defined in Swagger"""  # noqa: E501
        self._dispatch_type = None
        self._namespace = None
        self._chart_name = None
        self._chart_version = None
        self._repo_url = None
        self._username = None
        self._helm_version = None
        self._instantiation_state = None
        self._metadata = None
        self.discriminator = None
        if dispatch_type is not None:
            self.dispatch_type = dispatch_type
        if namespace is not None:
            self.namespace = namespace
        if chart_name is not None:
            self.chart_name = chart_name
        if chart_version is not None:
            self.chart_version = chart_version
        if repo_url is not None:
            self.repo_url = repo_url
        if username is not None:
            self.username = username
        if helm_version is not None:
            self.helm_version = helm_version
        if instantiation_state is not None:
            self.instantiation_state = instantiation_state
        if metadata is not None:
            self.metadata = metadata

    @property
    def dispatch_type(self):
        """Gets the dispatch_type of this VnfcResourceInfoMetadata.  # noqa: E501

        Type of vnfc compute Resource.  # noqa: E501

        :return: The dispatch_type of this VnfcResourceInfoMetadata.  # noqa: E501
        :rtype: str
        """
        return self._dispatch_type

    @dispatch_type.setter
    def dispatch_type(self, dispatch_type):
        """Sets the dispatch_type of this VnfcResourceInfoMetadata.

        Type of vnfc compute Resource.  # noqa: E501

        :param dispatch_type: The dispatch_type of this VnfcResourceInfoMetadata.  # noqa: E501
        :type: str
        """

        self._dispatch_type = dispatch_type

    @property
    def namespace(self):
        """Gets the namespace of this VnfcResourceInfoMetadata.  # noqa: E501

        k8s namespace in which helm releases are deployed.  # noqa: E501

        :return: The namespace of this VnfcResourceInfoMetadata.  # noqa: E501
        :rtype: str
        """
        return self._namespace

    @namespace.setter
    def namespace(self, namespace):
        """Sets the namespace of this VnfcResourceInfoMetadata.

        k8s namespace in which helm releases are deployed.  # noqa: E501

        :param namespace: The namespace of this VnfcResourceInfoMetadata.  # noqa: E501
        :type: str
        """

        self._namespace = namespace

    @property
    def chart_name(self):
        """Gets the chart_name of this VnfcResourceInfoMetadata.  # noqa: E501

        Name of the helm chart.  # noqa: E501

        :return: The chart_name of this VnfcResourceInfoMetadata.  # noqa: E501
        :rtype: str
        """
        return self._chart_name

    @chart_name.setter
    def chart_name(self, chart_name):
        """Sets the chart_name of this VnfcResourceInfoMetadata.

        Name of the helm chart.  # noqa: E501

        :param chart_name: The chart_name of this VnfcResourceInfoMetadata.  # noqa: E501
        :type: str
        """

        self._chart_name = chart_name

    @property
    def chart_version(self):
        """Gets the chart_version of this VnfcResourceInfoMetadata.  # noqa: E501

        Version of the chart.  # noqa: E501

        :return: The chart_version of this VnfcResourceInfoMetadata.  # noqa: E501
        :rtype: str
        """
        return self._chart_version

    @chart_version.setter
    def chart_version(self, chart_version):
        """Sets the chart_version of this VnfcResourceInfoMetadata.

        Version of the chart.  # noqa: E501

        :param chart_version: The chart_version of this VnfcResourceInfoMetadata.  # noqa: E501
        :type: str
        """

        self._chart_version = chart_version

    @property
    def repo_url(self):
        """Gets the repo_url of this VnfcResourceInfoMetadata.  # noqa: E501

        URL of the repository where helm chart is available for download.  # noqa: E501

        :return: The repo_url of this VnfcResourceInfoMetadata.  # noqa: E501
        :rtype: str
        """
        return self._repo_url

    @repo_url.setter
    def repo_url(self, repo_url):
        """Sets the repo_url of this VnfcResourceInfoMetadata.

        URL of the repository where helm chart is available for download.  # noqa: E501

        :param repo_url: The repo_url of this VnfcResourceInfoMetadata.  # noqa: E501
        :type: str
        """

        self._repo_url = repo_url

    @property
    def username(self):
        """Gets the username of this VnfcResourceInfoMetadata.  # noqa: E501

        Username used to access the repository.  # noqa: E501

        :return: The username of this VnfcResourceInfoMetadata.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this VnfcResourceInfoMetadata.

        Username used to access the repository.  # noqa: E501

        :param username: The username of this VnfcResourceInfoMetadata.  # noqa: E501
        :type: str
        """

        self._username = username

    @property
    def helm_version(self):
        """Gets the helm_version of this VnfcResourceInfoMetadata.  # noqa: E501

        Version of helm library.  # noqa: E501

        :return: The helm_version of this VnfcResourceInfoMetadata.  # noqa: E501
        :rtype: str
        """
        return self._helm_version

    @helm_version.setter
    def helm_version(self, helm_version):
        """Sets the helm_version of this VnfcResourceInfoMetadata.

        Version of helm library.  # noqa: E501

        :param helm_version: The helm_version of this VnfcResourceInfoMetadata.  # noqa: E501
        :type: str
        """

        self._helm_version = helm_version

    @property
    def instantiation_state(self):
        """Gets the instantiation_state of this VnfcResourceInfoMetadata.  # noqa: E501

        Instatiation state of VNFC compute resource.  # noqa: E501

        :return: The instantiation_state of this VnfcResourceInfoMetadata.  # noqa: E501
        :rtype: str
        """
        return self._instantiation_state

    @instantiation_state.setter
    def instantiation_state(self, instantiation_state):
        """Sets the instantiation_state of this VnfcResourceInfoMetadata.

        Instatiation state of VNFC compute resource.  # noqa: E501

        :param instantiation_state: The instantiation_state of this VnfcResourceInfoMetadata.  # noqa: E501
        :type: str
        """

        self._instantiation_state = instantiation_state

    @property
    def metadata(self):
        """Gets the metadata of this VnfcResourceInfoMetadata.  # noqa: E501


        :return: The metadata of this VnfcResourceInfoMetadata.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this VnfcResourceInfoMetadata.


        :param metadata: The metadata of this VnfcResourceInfoMetadata.  # noqa: E501
        :type: dict(str, str)
        """

        self._metadata = metadata

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfcResourceInfoMetadata, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfcResourceInfoMetadata):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
