# coding: utf-8

"""
    SOL005 - VNF Package Management Interface

    SOL005 - VNF Package Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from tca.vnfpkgm.api_client import ApiClient
from tca.api.tca_api import TCAApi

class DefaultApi(TCAApi):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_vnfpkgm_version_info(self, version, **kwargs):  # noqa: E501
        """Retrieve API version information  # noqa: E501

        The GET method reads API version information. This method shall follow the provisions specified in table 4.6.3.3.3.2-1 for request and response data structures, and response codes. URI query parameters are not supported.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_vnfpkgm_version_info(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)


        :return: ApiVersionInformation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_vnfpkgm_version_info_with_http_info(version, **kwargs)  # noqa: E501
        else:
            (data) = self.get_vnfpkgm_version_info_with_http_info(version, **kwargs)  # noqa: E501
            return data

    def get_vnfpkgm_version_info_with_http_info(self, version, **kwargs):  # noqa: E501
        """Retrieve API version information  # noqa: E501

        The GET method reads API version information. This method shall follow the provisions specified in table 4.6.3.3.3.2-1 for request and response data structures, and response codes. URI query parameters are not supported.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_vnfpkgm_version_info_with_http_info(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)


        :return: ApiVersionInformation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_vnfpkgm_version_info" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `get_vnfpkgm_version_info`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/api_versions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiVersionInformation',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def onboarded_vnf_packages_vnfd_id_vnfd_get(self, vnfd_id, accept, version, **kwargs):  # noqa: E501
        """onboarded_vnf_packages_vnfd_id_vnfd_get  # noqa: E501

        Query VNF Package Info The GET method reads the content of the VNFD within a VNF package. The VNFD is implemented as a collection of one or more files. A ZIP archive embedding these files shall be returned when reading this resource. The default format of the ZIP archive shall be the one specified in ETSI GS NFV-SOL 004 where only the files representing the VNFD and information needed to navigate the ZIP archive and to identify the file that is the entry point for parsing the VNFD, and, if requested, further security information are included. This means that the structure of the ZIP archive shall correspond to the directory structure used in the VNF package and that the archive shall contain the following files from the package: *   TOSCA.meta (if available in the package) *   The main TOSCA definitions YAML file (either as referenced from TOSCA.meta     or available as a file with the extension \".yml\" or \".yaml\" from the root of the archive) *   Every component of the VNFD referenced (recursively) from the main TOSCA definitions YAML file *   The related security information, if the \"include_signatures\" URI parameter is provided, as follows:     -   the manifest file     -   the singleton certificate file in the root of the VNF package (if available in the package)     -   the signing certificates of the individual files included in the ZIP archive (if available in the package)     -   the signatures of the individual files (if available in the package) Three examples are provided below. NOTE:   These examples do not show the security related files. EXAMPLE 1:  Assuming a request is sent for the following VNF package             (as described in clause A.1 in ETSI GS NFV-SOL 004):             !------TOSCA-Metadata                     !-----  TOSCA.meta (metadata for navigating the ZIP file)             !------Definitions                     !-----  MRF.yaml (main VNFD file)                     !-----  OtherTemplates (e.g. type definitions, referenced by the main VNFD file)             !------Files                     !-----  ChangeLog.txt                     !-----  image(s)                     !-----  other artifacts             !------Tests                     !-----  file(s)             !------Licenses                     !-----  file(s)             !------Scripts                     !-----  install.sh             !----- MRF.mf              The NFVO will return a ZIP file of the following format:             !------TOSCA-Metadata                     !----- TOSCA.meta             !------Definitions                     !----- MRF.yaml                     !----- OtherTemplates  EXAMPLE 2:  Assuming a request is sent for the following VNF package             (a VNF package without a TOSCA-Metadata directory, as             described in clause A.2 in ETSI GS NFV-SOL 004):             !------MRF.yaml (main VNFD file)             !------MRF.mf             !------ChangeLog.txt             !------Tests                     !----- file(s)             !------Licenses                     !----- file(s)             !------Artifacts                     !----- install.sh                     !----- start.yang              The NFVO will return a ZIP file of the following format:             !------MRF.yaml  EXAMPLE 3:  Assuming a request is sent for the following VNF package             (a VNF package with the YANG VNFD without a TOSCA-Metadata directory,             as described in clause A.3 in ETSI GS NFV SOL 004):             !----CompanyVNFD.yaml             !----CompanyVNFD.xml             !----CompanyVNFD.mf             !----ChangeLog.txt             !-----Files             !-----Instance Data Files                     !---- start.xml             !-----Licenses             !-----Scripts                     !----- install.sh              The NFVO will return a ZIP file of the following format:             !----CompanyVNFD.yaml             !----CompanyVNFD.xml    (indicated in the yang_definitions metadata in CompanyVNFD.yaml)  This method shall follow the provisions specified in the tables 10.4.4.3.2-1 and 10.4.4.3.2-2 for URI query parameters, request and response data structures, nd response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.onboarded_vnf_packages_vnfd_id_vnfd_get(vnfd_id, accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str vnfd_id: Identifier of the VNFD and the VNF package. The identifier is allocated by the VNF provider. This identifier can be retrieved from the \"vnfdId\" attribute in the VnfPackageOnboardingNotification or VnfPackageChangeNotification.  (required)
        :param str accept: Content-Types that are acceptable for the response. Permitted values: \"text/plain\" and/or \"application/zip\" Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param str include_signatures: If this parameter is provided, the NFVO shall include in the ZIP archive the security information as specified above. This URI query parameter is a flag, i.e. it shall have no value. The NFVO shall support this parameter. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.onboarded_vnf_packages_vnfd_id_vnfd_get_with_http_info(vnfd_id, accept, version, **kwargs)  # noqa: E501
        else:
            (data) = self.onboarded_vnf_packages_vnfd_id_vnfd_get_with_http_info(vnfd_id, accept, version, **kwargs)  # noqa: E501
            return data

    def onboarded_vnf_packages_vnfd_id_vnfd_get_with_http_info(self, vnfd_id, accept, version, **kwargs):  # noqa: E501
        """onboarded_vnf_packages_vnfd_id_vnfd_get  # noqa: E501

        Query VNF Package Info The GET method reads the content of the VNFD within a VNF package. The VNFD is implemented as a collection of one or more files. A ZIP archive embedding these files shall be returned when reading this resource. The default format of the ZIP archive shall be the one specified in ETSI GS NFV-SOL 004 where only the files representing the VNFD and information needed to navigate the ZIP archive and to identify the file that is the entry point for parsing the VNFD, and, if requested, further security information are included. This means that the structure of the ZIP archive shall correspond to the directory structure used in the VNF package and that the archive shall contain the following files from the package: *   TOSCA.meta (if available in the package) *   The main TOSCA definitions YAML file (either as referenced from TOSCA.meta     or available as a file with the extension \".yml\" or \".yaml\" from the root of the archive) *   Every component of the VNFD referenced (recursively) from the main TOSCA definitions YAML file *   The related security information, if the \"include_signatures\" URI parameter is provided, as follows:     -   the manifest file     -   the singleton certificate file in the root of the VNF package (if available in the package)     -   the signing certificates of the individual files included in the ZIP archive (if available in the package)     -   the signatures of the individual files (if available in the package) Three examples are provided below. NOTE:   These examples do not show the security related files. EXAMPLE 1:  Assuming a request is sent for the following VNF package             (as described in clause A.1 in ETSI GS NFV-SOL 004):             !------TOSCA-Metadata                     !-----  TOSCA.meta (metadata for navigating the ZIP file)             !------Definitions                     !-----  MRF.yaml (main VNFD file)                     !-----  OtherTemplates (e.g. type definitions, referenced by the main VNFD file)             !------Files                     !-----  ChangeLog.txt                     !-----  image(s)                     !-----  other artifacts             !------Tests                     !-----  file(s)             !------Licenses                     !-----  file(s)             !------Scripts                     !-----  install.sh             !----- MRF.mf              The NFVO will return a ZIP file of the following format:             !------TOSCA-Metadata                     !----- TOSCA.meta             !------Definitions                     !----- MRF.yaml                     !----- OtherTemplates  EXAMPLE 2:  Assuming a request is sent for the following VNF package             (a VNF package without a TOSCA-Metadata directory, as             described in clause A.2 in ETSI GS NFV-SOL 004):             !------MRF.yaml (main VNFD file)             !------MRF.mf             !------ChangeLog.txt             !------Tests                     !----- file(s)             !------Licenses                     !----- file(s)             !------Artifacts                     !----- install.sh                     !----- start.yang              The NFVO will return a ZIP file of the following format:             !------MRF.yaml  EXAMPLE 3:  Assuming a request is sent for the following VNF package             (a VNF package with the YANG VNFD without a TOSCA-Metadata directory,             as described in clause A.3 in ETSI GS NFV SOL 004):             !----CompanyVNFD.yaml             !----CompanyVNFD.xml             !----CompanyVNFD.mf             !----ChangeLog.txt             !-----Files             !-----Instance Data Files                     !---- start.xml             !-----Licenses             !-----Scripts                     !----- install.sh              The NFVO will return a ZIP file of the following format:             !----CompanyVNFD.yaml             !----CompanyVNFD.xml    (indicated in the yang_definitions metadata in CompanyVNFD.yaml)  This method shall follow the provisions specified in the tables 10.4.4.3.2-1 and 10.4.4.3.2-2 for URI query parameters, request and response data structures, nd response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.onboarded_vnf_packages_vnfd_id_vnfd_get_with_http_info(vnfd_id, accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str vnfd_id: Identifier of the VNFD and the VNF package. The identifier is allocated by the VNF provider. This identifier can be retrieved from the \"vnfdId\" attribute in the VnfPackageOnboardingNotification or VnfPackageChangeNotification.  (required)
        :param str accept: Content-Types that are acceptable for the response. Permitted values: \"text/plain\" and/or \"application/zip\" Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param str include_signatures: If this parameter is provided, the NFVO shall include in the ZIP archive the security information as specified above. This URI query parameter is a flag, i.e. it shall have no value. The NFVO shall support this parameter. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['vnfd_id', 'accept', 'version', 'authorization', 'include_signatures']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method onboarded_vnf_packages_vnfd_id_vnfd_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'vnfd_id' is set
        if ('vnfd_id' not in params or
                params['vnfd_id'] is None):
            raise ValueError("Missing the required parameter `vnfd_id` when calling `onboarded_vnf_packages_vnfd_id_vnfd_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `onboarded_vnf_packages_vnfd_id_vnfd_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `onboarded_vnf_packages_vnfd_id_vnfd_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnfd_id' in params:
            path_params['vnfdId'] = params['vnfd_id']  # noqa: E501

        query_params = []
        if 'include_signatures' in params:
            query_params.append(('include_signatures', params['include_signatures']))  # noqa: E501

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/onboarded_vnf_packages/{vnfdId}/vnfd', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
