# coding: utf-8

"""
    SOL005 - VNF Package Management Interface

    SOL005 - VNF Package Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from tca.vnfpkgm.api_client import ApiClient
from tca.api.tca_api import TCAApi

class VnfCatalogApi(TCAApi):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_vnf_descriptor(self, body, version, accept, content_type, **kwargs):  # noqa: E501
        """Create a new individual VNF package resource.  # noqa: E501

        The POST method creates a new individual VNF package resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_vnf_descriptor(body, version, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateVnfPkgInfoRequest body: IndividualVNF package resource creation parameters, as defined in clause 9.5.2.2
 (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: VnfPkgInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_vnf_descriptor_with_http_info(body, version, accept, content_type, **kwargs)  # noqa: E501
        else:
            (data) = self.create_vnf_descriptor_with_http_info(body, version, accept, content_type, **kwargs)  # noqa: E501
            return data

    def create_vnf_descriptor_with_http_info(self, body, version, accept, content_type, **kwargs):  # noqa: E501
        """Create a new individual VNF package resource.  # noqa: E501

        The POST method creates a new individual VNF package resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_vnf_descriptor_with_http_info(body, version, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateVnfPkgInfoRequest body: IndividualVNF package resource creation parameters, as defined in clause 9.5.2.2
 (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: VnfPkgInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'version', 'accept', 'content_type', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_vnf_descriptor" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_vnf_descriptor`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `create_vnf_descriptor`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `create_vnf_descriptor`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `create_vnf_descriptor`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_packages', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='VnfPkgInfo',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_vnf_descriptor(self, vnf_pkg_id, version, **kwargs):  # noqa: E501
        """Delete an individual VNF package.  # noqa: E501

        The DELETE method deletes an individual VNF Package resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_vnf_descriptor(vnf_pkg_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str vnf_pkg_id: Identifier of the VNF package. The identifier is allocated by the NFVO.    (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_vnf_descriptor_with_http_info(vnf_pkg_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_vnf_descriptor_with_http_info(vnf_pkg_id, version, **kwargs)  # noqa: E501
            return data

    def delete_vnf_descriptor_with_http_info(self, vnf_pkg_id, version, **kwargs):  # noqa: E501
        """Delete an individual VNF package.  # noqa: E501

        The DELETE method deletes an individual VNF Package resource.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_vnf_descriptor_with_http_info(vnf_pkg_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str vnf_pkg_id: Identifier of the VNF package. The identifier is allocated by the NFVO.    (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['vnf_pkg_id', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_vnf_descriptor" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'vnf_pkg_id' is set
        if ('vnf_pkg_id' not in params or
                params['vnf_pkg_id'] is None):
            raise ValueError("Missing the required parameter `vnf_pkg_id` when calling `delete_vnf_descriptor`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `delete_vnf_descriptor`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnf_pkg_id' in params:
            path_params['vnfPkgId'] = params['vnf_pkg_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_packages/{vnfPkgId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def download_vnf_descriptor(self, version, vnf_pkg_id, accept, **kwargs):  # noqa: E501
        """Fetch an on-boarded VNF package.  # noqa: E501

        The GET method fetches the content of a VNF package identified by the VNF package identifier allocated by the NFVO. The content of the package is provided as onboarded, i.e. depending on the security option used, the CSAR or the CSAR wrapped in a ZIP archive together with an external signature is returned, as defined in clause 5.1 of ETSI GS NFV-SOL 004 [5]. NOTE: Information about the applicable security option can be obtained by evaluating the \"packageSecurityOption\" attribute in the \"VnfPkgInfo\" structure. This method shall follow the provisions specified in the Tables 9.4.5.3.2-1 and 9.4.5.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.download_vnf_descriptor(version, vnf_pkg_id, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str vnf_pkg_id: Identifier of the on-boarded VNF package. The identifier is allocated by the NFVO.  (required)
        :param str accept: Content-Types that are acceptable for the response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str range: The request may contain a \"Range\" HTTP header to obtain single range of bytes from the VNF package file. This can be used to continue an aborted transmission. If the NFVO does not support range requests, it should return the whole file with a 200 OK response instead. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.download_vnf_descriptor_with_http_info(version, vnf_pkg_id, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.download_vnf_descriptor_with_http_info(version, vnf_pkg_id, accept, **kwargs)  # noqa: E501
            return data

    def download_vnf_descriptor_with_http_info(self, version, vnf_pkg_id, accept, **kwargs):  # noqa: E501
        """Fetch an on-boarded VNF package.  # noqa: E501

        The GET method fetches the content of a VNF package identified by the VNF package identifier allocated by the NFVO. The content of the package is provided as onboarded, i.e. depending on the security option used, the CSAR or the CSAR wrapped in a ZIP archive together with an external signature is returned, as defined in clause 5.1 of ETSI GS NFV-SOL 004 [5]. NOTE: Information about the applicable security option can be obtained by evaluating the \"packageSecurityOption\" attribute in the \"VnfPkgInfo\" structure. This method shall follow the provisions specified in the Tables 9.4.5.3.2-1 and 9.4.5.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.download_vnf_descriptor_with_http_info(version, vnf_pkg_id, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str vnf_pkg_id: Identifier of the on-boarded VNF package. The identifier is allocated by the NFVO.  (required)
        :param str accept: Content-Types that are acceptable for the response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str range: The request may contain a \"Range\" HTTP header to obtain single range of bytes from the VNF package file. This can be used to continue an aborted transmission. If the NFVO does not support range requests, it should return the whole file with a 200 OK response instead. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version', 'vnf_pkg_id', 'accept', 'authorization', 'range']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method download_vnf_descriptor" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `download_vnf_descriptor`")  # noqa: E501
        # verify the required parameter 'vnf_pkg_id' is set
        if ('vnf_pkg_id' not in params or
                params['vnf_pkg_id'] is None):
            raise ValueError("Missing the required parameter `vnf_pkg_id` when calling `download_vnf_descriptor`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `download_vnf_descriptor`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnf_pkg_id' in params:
            path_params['vnfPkgId'] = params['vnf_pkg_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'range' in params:
            header_params['Range'] = params['range']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/zip'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_packages/{vnfPkgId}/package_content', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_all_vnf_descriptors(self, version, accept, **kwargs):  # noqa: E501
        """Query VNF packages information.  # noqa: E501

        The GET method queries the information of the VNF packages matching the filter. This method shall follow the provisions specified in the  Tables 9.4.2.3.2-1 and 9.4.2.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_all_vnf_descriptors(version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV SOL 013. The NFVO shall support receiving this parameter as part of the URI query string. The OSS/BSS may supply this parameter. All attribute names that appear in the VnfPkgInfo and in data types referenced from it shall be supported by the NFVO in the filter expression. 
        :param str all_fields: Include all complex attributes in the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The NFVO shall support this parameter. 
        :param str fields: Complex attributes to be included into the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The NFVO should support this parameter. 
        :param str exclude_fields: Complex attributes to be excluded from the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The NFVO should support this parameter. 
        :param str exclude_default: Indicates to exclude the following complex attributes from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The NFVO shall support this parameter. The following attributes shall be excluded from the VnfPkgInfo structure in the response body if this parameter is provided, or none of the parameters \"all_fields,\" \"fields\", \"exclude_fields\", \"exclude_default\" are provided: - softwareImages - additionalArtifacts - userDefinedData - checksum - onboardingFailureDetails 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the NFVO if the NFVO supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV SOL 013 for this resource. 


        :return: list[VnfPkgInfo]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_all_vnf_descriptors_with_http_info(version, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.get_all_vnf_descriptors_with_http_info(version, accept, **kwargs)  # noqa: E501
            return data

    def get_all_vnf_descriptors_with_http_info(self, version, accept, **kwargs):  # noqa: E501
        """Query VNF packages information.  # noqa: E501

        The GET method queries the information of the VNF packages matching the filter. This method shall follow the provisions specified in the  Tables 9.4.2.3.2-1 and 9.4.2.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_all_vnf_descriptors_with_http_info(version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV SOL 013. The NFVO shall support receiving this parameter as part of the URI query string. The OSS/BSS may supply this parameter. All attribute names that appear in the VnfPkgInfo and in data types referenced from it shall be supported by the NFVO in the filter expression. 
        :param str all_fields: Include all complex attributes in the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The NFVO shall support this parameter. 
        :param str fields: Complex attributes to be included into the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The NFVO should support this parameter. 
        :param str exclude_fields: Complex attributes to be excluded from the response. See clause 5.3 of ETSI GS NFV SOL 013 for details. The NFVO should support this parameter. 
        :param str exclude_default: Indicates to exclude the following complex attributes from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The NFVO shall support this parameter. The following attributes shall be excluded from the VnfPkgInfo structure in the response body if this parameter is provided, or none of the parameters \"all_fields,\" \"fields\", \"exclude_fields\", \"exclude_default\" are provided: - softwareImages - additionalArtifacts - userDefinedData - checksum - onboardingFailureDetails 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the NFVO if the NFVO supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV SOL 013 for this resource. 


        :return: list[VnfPkgInfo]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version', 'accept', 'authorization', 'filter', 'all_fields', 'fields', 'exclude_fields', 'exclude_default', 'nextpage_opaque_marker']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_all_vnf_descriptors" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `get_all_vnf_descriptors`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `get_all_vnf_descriptors`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'all_fields' in params:
            query_params.append(('all_fields', params['all_fields']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
        if 'exclude_fields' in params:
            query_params.append(('exclude_fields', params['exclude_fields']))  # noqa: E501
        if 'exclude_default' in params:
            query_params.append(('exclude_default', params['exclude_default']))  # noqa: E501
        if 'nextpage_opaque_marker' in params:
            query_params.append(('nextpage_opaque_marker', params['nextpage_opaque_marker']))  # noqa: E501

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_packages', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[VnfPkgInfo]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_vnf_descriptor(self, vnf_pkg_id, version, accept, **kwargs):  # noqa: E501
        """Read information about an individual VNF package.  # noqa: E501

        The GET method reads the information of a VNF package.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_vnf_descriptor(vnf_pkg_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str vnf_pkg_id: Identifier of the VNF package. The identifier is allocated by the NFVO.    (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: VnfPkgInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_vnf_descriptor_with_http_info(vnf_pkg_id, version, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.get_vnf_descriptor_with_http_info(vnf_pkg_id, version, accept, **kwargs)  # noqa: E501
            return data

    def get_vnf_descriptor_with_http_info(self, vnf_pkg_id, version, accept, **kwargs):  # noqa: E501
        """Read information about an individual VNF package.  # noqa: E501

        The GET method reads the information of a VNF package.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_vnf_descriptor_with_http_info(vnf_pkg_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str vnf_pkg_id: Identifier of the VNF package. The identifier is allocated by the NFVO.    (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: VnfPkgInfo
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['vnf_pkg_id', 'version', 'accept', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_vnf_descriptor" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'vnf_pkg_id' is set
        if ('vnf_pkg_id' not in params or
                params['vnf_pkg_id'] is None):
            raise ValueError("Missing the required parameter `vnf_pkg_id` when calling `get_vnf_descriptor`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `get_vnf_descriptor`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `get_vnf_descriptor`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnf_pkg_id' in params:
            path_params['vnfPkgId'] = params['vnf_pkg_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_packages/{vnfPkgId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='VnfPkgInfo',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_vnfd_model(self, version, vnf_pkg_id, accept, **kwargs):  # noqa: E501
        """Read VNFD of an on-boarded VNF package.  # noqa: E501

        The GET method reads the content of the VNFD within a VNF package. The default format of the ZIP archive shall be the one specified in ETSI GS NFV-SOL 004 [5] where only the files representing the VNFD and information necessary to navigate the ZIP file and to identify the file that is the entry point for parsing the VNFD and (if requested) further security information are included. This means that the structure of the ZIP archive shall correspond to the directory structure used in the VNF package and that the archive shall contain the following files from the package:  - TOSCA.meta (if available in the package).  - The main TOSCA definitions YAML file (either as referenced from TOSCA.meta or available as a file with the extension \".yml\" or \".yaml\" from the root of the archive). Every component of the VNFD referenced (recursively) from the main TOSCA definitions YAML file.  -  The related security information, if the \"include_signatures\" URI parameter is provided, as follows: - the manifest file; - the singleton certificate file in the root of the VNF package (if available in the package); - the signing certificates of the individual files included in the ZIP archive (if available in the package); - the signatures of the individual files (if available in the package).   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_vnfd_model(version, vnf_pkg_id, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str vnf_pkg_id: Identifier of the on-boarded VNF package. The identifier is allocated by the NFVO. This identifier can be retrieved from the \"vnfPkgId\" attribute in the VnfPackageOnboardingNotification or VnfPackageChangeNotification.  (required)
        :param str accept: Content-Types that are acceptable for the response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str include_signatures: If this parameter is provided, the NFVO shall include in the ZIP archive the security information as specified above. This URI query parameter is a flag, i.e. it shall have no value. The NFVO shall support this parameter. 


        :return: Vnfd
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_vnfd_model_with_http_info(version, vnf_pkg_id, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.get_vnfd_model_with_http_info(version, vnf_pkg_id, accept, **kwargs)  # noqa: E501
            return data

    def get_vnfd_model_with_http_info(self, version, vnf_pkg_id, accept, **kwargs):  # noqa: E501
        """Read VNFD of an on-boarded VNF package.  # noqa: E501

        The GET method reads the content of the VNFD within a VNF package. The default format of the ZIP archive shall be the one specified in ETSI GS NFV-SOL 004 [5] where only the files representing the VNFD and information necessary to navigate the ZIP file and to identify the file that is the entry point for parsing the VNFD and (if requested) further security information are included. This means that the structure of the ZIP archive shall correspond to the directory structure used in the VNF package and that the archive shall contain the following files from the package:  - TOSCA.meta (if available in the package).  - The main TOSCA definitions YAML file (either as referenced from TOSCA.meta or available as a file with the extension \".yml\" or \".yaml\" from the root of the archive). Every component of the VNFD referenced (recursively) from the main TOSCA definitions YAML file.  -  The related security information, if the \"include_signatures\" URI parameter is provided, as follows: - the manifest file; - the singleton certificate file in the root of the VNF package (if available in the package); - the signing certificates of the individual files included in the ZIP archive (if available in the package); - the signatures of the individual files (if available in the package).   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_vnfd_model_with_http_info(version, vnf_pkg_id, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str vnf_pkg_id: Identifier of the on-boarded VNF package. The identifier is allocated by the NFVO. This identifier can be retrieved from the \"vnfPkgId\" attribute in the VnfPackageOnboardingNotification or VnfPackageChangeNotification.  (required)
        :param str accept: Content-Types that are acceptable for the response.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str include_signatures: If this parameter is provided, the NFVO shall include in the ZIP archive the security information as specified above. This URI query parameter is a flag, i.e. it shall have no value. The NFVO shall support this parameter. 


        :return: Vnfd
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version', 'vnf_pkg_id', 'accept', 'authorization', 'include_signatures']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_vnfd_model" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `get_vnfd_model`")  # noqa: E501
        # verify the required parameter 'vnf_pkg_id' is set
        if ('vnf_pkg_id' not in params or
                params['vnf_pkg_id'] is None):
            raise ValueError("Missing the required parameter `vnf_pkg_id` when calling `get_vnfd_model`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `get_vnfd_model`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnf_pkg_id' in params:
            path_params['vnfPkgId'] = params['vnf_pkg_id']  # noqa: E501

        query_params = []
        if 'include_signatures' in params:
            query_params.append(('include_signatures', params['include_signatures']))  # noqa: E501

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_packages/{vnfPkgId}/vnfd', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Vnfd',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def subscriptions_get(self, version, accept, **kwargs):  # noqa: E501
        """Query multiple subscriptions.  # noqa: E501

        The GET method queries the list of active subscriptions of the functional block that invokes the method. It can be used e.g. for resynchronization after error situations. This method shall follow the provisions specified in the Tables 9.4.8.3.2-1 and 9.4.8.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_get(version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV SOL 013. The NFVO shall support receiving this filtering parameter as part of the URI query string. The OSS/BSS may supply this filtering parameter. All attribute names that appear in the PkgmSubscription and in data types referenced from it shall be supported by the NFVO in the filtering expression 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the NFVO if the NFVO supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV-SOL 013 for this resource. 


        :return: list[PkgmSubscription]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.subscriptions_get_with_http_info(version, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.subscriptions_get_with_http_info(version, accept, **kwargs)  # noqa: E501
            return data

    def subscriptions_get_with_http_info(self, version, accept, **kwargs):  # noqa: E501
        """Query multiple subscriptions.  # noqa: E501

        The GET method queries the list of active subscriptions of the functional block that invokes the method. It can be used e.g. for resynchronization after error situations. This method shall follow the provisions specified in the Tables 9.4.8.3.2-1 and 9.4.8.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_get_with_http_info(version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV SOL 013. The NFVO shall support receiving this filtering parameter as part of the URI query string. The OSS/BSS may supply this filtering parameter. All attribute names that appear in the PkgmSubscription and in data types referenced from it shall be supported by the NFVO in the filtering expression 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the NFVO if the NFVO supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV-SOL 013 for this resource. 


        :return: list[PkgmSubscription]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version', 'accept', 'authorization', 'filter', 'nextpage_opaque_marker']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method subscriptions_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `subscriptions_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `subscriptions_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'nextpage_opaque_marker' in params:
            query_params.append(('nextpage_opaque_marker', params['nextpage_opaque_marker']))  # noqa: E501

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/subscriptions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[PkgmSubscription]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def subscriptions_post(self, body, version, accept, content_type, **kwargs):  # noqa: E501
        """Subscribe to notifications related to on-boarding and/or changes of VNF packages.  # noqa: E501

        The POST method creates a new subscription. This method shall follow the provisions specified in the Tables 9.4.8.3.1-1 and 9.4.8.3.1-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, a new \"Individual subscription\" resource shall exist as defined in clause 9.4.9. This method shall not trigger any notification. Creation of two subscription resources with the same callbackURI and the same filter can result in performance degradation and will provide duplicates of notifications to the OSS, and might make sense only in very rare use cases. Consequently, the NFVO may either allow creating a subscription resource if another subscription resource with the same filter and callbackUri already exists (in which case it shall return the \"201 Created\" response code), or may decide to not create a duplicate subscription resource (in which case it shall return a \"303 See Other\" response code referencing the existing subscription resource with the same filter and callbackUri).   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_post(body, version, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param PkgmSubscriptionRequest body: Details of the subscription to be created.
 (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: PkgmSubscription
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.subscriptions_post_with_http_info(body, version, accept, content_type, **kwargs)  # noqa: E501
        else:
            (data) = self.subscriptions_post_with_http_info(body, version, accept, content_type, **kwargs)  # noqa: E501
            return data

    def subscriptions_post_with_http_info(self, body, version, accept, content_type, **kwargs):  # noqa: E501
        """Subscribe to notifications related to on-boarding and/or changes of VNF packages.  # noqa: E501

        The POST method creates a new subscription. This method shall follow the provisions specified in the Tables 9.4.8.3.1-1 and 9.4.8.3.1-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, a new \"Individual subscription\" resource shall exist as defined in clause 9.4.9. This method shall not trigger any notification. Creation of two subscription resources with the same callbackURI and the same filter can result in performance degradation and will provide duplicates of notifications to the OSS, and might make sense only in very rare use cases. Consequently, the NFVO may either allow creating a subscription resource if another subscription resource with the same filter and callbackUri already exists (in which case it shall return the \"201 Created\" response code), or may decide to not create a duplicate subscription resource (in which case it shall return a \"303 See Other\" response code referencing the existing subscription resource with the same filter and callbackUri).   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_post_with_http_info(body, version, accept, content_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param PkgmSubscriptionRequest body: Details of the subscription to be created.
 (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: PkgmSubscription
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'version', 'accept', 'content_type', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method subscriptions_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `subscriptions_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `subscriptions_post`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `subscriptions_post`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `subscriptions_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/subscriptions', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PkgmSubscription',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def subscriptions_subscription_id_delete(self, subscription_id, version, **kwargs):  # noqa: E501
        """Terminate a subscription.  # noqa: E501

        The DELETE method terminates an individual subscription. This method shall follow the provisions specified in the Tables 9.4.9.3.5-1 and 9.4.9.3.5-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, the \"Individual subscription\" resource shall not exist any longer. This means that no notifications for that subscription shall be sent to the formerly-subscribed API consumer. NOTE: Due to race conditions, some notifications might still be received by the formerly-subscribed API consumer for a certain time period after the deletion.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_subscription_id_delete(subscription_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str subscription_id: Identifier of this subscription. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new subscription resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.subscriptions_subscription_id_delete_with_http_info(subscription_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.subscriptions_subscription_id_delete_with_http_info(subscription_id, version, **kwargs)  # noqa: E501
            return data

    def subscriptions_subscription_id_delete_with_http_info(self, subscription_id, version, **kwargs):  # noqa: E501
        """Terminate a subscription.  # noqa: E501

        The DELETE method terminates an individual subscription. This method shall follow the provisions specified in the Tables 9.4.9.3.5-1 and 9.4.9.3.5-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, the \"Individual subscription\" resource shall not exist any longer. This means that no notifications for that subscription shall be sent to the formerly-subscribed API consumer. NOTE: Due to race conditions, some notifications might still be received by the formerly-subscribed API consumer for a certain time period after the deletion.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_subscription_id_delete_with_http_info(subscription_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str subscription_id: Identifier of this subscription. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new subscription resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['subscription_id', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method subscriptions_subscription_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'subscription_id' is set
        if ('subscription_id' not in params or
                params['subscription_id'] is None):
            raise ValueError("Missing the required parameter `subscription_id` when calling `subscriptions_subscription_id_delete`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `subscriptions_subscription_id_delete`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'subscription_id' in params:
            path_params['subscriptionId'] = params['subscription_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/subscriptions/{subscriptionId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def subscriptions_subscription_id_get(self, subscription_id, version, accept, **kwargs):  # noqa: E501
        """Read an individual subscription resource.  # noqa: E501

        Query Subscription Information The GET method reads an individual subscription.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_subscription_id_get(subscription_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str subscription_id: Identifier of this subscription. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new subscription resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: PkgmSubscription
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.subscriptions_subscription_id_get_with_http_info(subscription_id, version, accept, **kwargs)  # noqa: E501
        else:
            (data) = self.subscriptions_subscription_id_get_with_http_info(subscription_id, version, accept, **kwargs)  # noqa: E501
            return data

    def subscriptions_subscription_id_get_with_http_info(self, subscription_id, version, accept, **kwargs):  # noqa: E501
        """Read an individual subscription resource.  # noqa: E501

        Query Subscription Information The GET method reads an individual subscription.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.subscriptions_subscription_id_get_with_http_info(subscription_id, version, accept, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str subscription_id: Identifier of this subscription. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new subscription resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 


        :return: PkgmSubscription
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['subscription_id', 'version', 'accept', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method subscriptions_subscription_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'subscription_id' is set
        if ('subscription_id' not in params or
                params['subscription_id'] is None):
            raise ValueError("Missing the required parameter `subscription_id` when calling `subscriptions_subscription_id_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `subscriptions_subscription_id_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `subscriptions_subscription_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'subscription_id' in params:
            path_params['subscriptionId'] = params['subscription_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/subscriptions/{subscriptionId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PkgmSubscription',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_vnf_catalog(self, body, version, content_type, vnf_pkg_id, **kwargs):  # noqa: E501
        """Update information about an individual VNF package.  # noqa: E501

        \"The PATCH method updates the information of a VNF package.\" \"This method shall follow the provisions specified in the  Tables 9.4.3.3.4-1 and 9.4.3.3.4-2 for URI query parameters, request and response data structures, and response codes.\"   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_vnf_catalog(body, version, content_type, vnf_pkg_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param VnfPkgInfoModifications body: Parameters for VNF package information modifications.
 (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str vnf_pkg_id: Identifier of the VNF package. The identifier is allocated by the NFVO.    (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_vnf_catalog_with_http_info(body, version, content_type, vnf_pkg_id, **kwargs)  # noqa: E501
        else:
            (data) = self.update_vnf_catalog_with_http_info(body, version, content_type, vnf_pkg_id, **kwargs)  # noqa: E501
            return data

    def update_vnf_catalog_with_http_info(self, body, version, content_type, vnf_pkg_id, **kwargs):  # noqa: E501
        """Update information about an individual VNF package.  # noqa: E501

        \"The PATCH method updates the information of a VNF package.\" \"This method shall follow the provisions specified in the  Tables 9.4.3.3.4-1 and 9.4.3.3.4-2 for URI query parameters, request and response data structures, and response codes.\"   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_vnf_catalog_with_http_info(body, version, content_type, vnf_pkg_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param VnfPkgInfoModifications body: Parameters for VNF package information modifications.
 (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str vnf_pkg_id: Identifier of the VNF package. The identifier is allocated by the NFVO.    (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'version', 'content_type', 'vnf_pkg_id', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_vnf_catalog" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `update_vnf_catalog`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `update_vnf_catalog`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `update_vnf_catalog`")  # noqa: E501
        # verify the required parameter 'vnf_pkg_id' is set
        if ('vnf_pkg_id' not in params or
                params['vnf_pkg_id'] is None):
            raise ValueError("Missing the required parameter `vnf_pkg_id` when calling `update_vnf_catalog`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnf_pkg_id' in params:
            path_params['vnfPkgId'] = params['vnf_pkg_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_packages/{vnfPkgId}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='object',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def upload_vnf_descriptor(self, version, accept, vnf_pkg_id, **kwargs):  # noqa: E501
        """Upload a VNF package by providing the content of the VNF package.  # noqa: E501

        The PUT method uploads the content of a VNF package. This method shall follow the provisions specified in the  Tables 9.4.5.3.3-1 and 9.4.5.3.3-2 for URI query parameters, request and response data structures, and response codes. Upon start of the upload of the package, the NFVO shall set the \"onboardingState\" attribute in the \"VnfPkgInfo\" structure to \"UPLOADING\". Upon successful upload of the package, if the package references external artifacts, the NFVO shall obtain the external artifacts. Subsequently, upon success, the NFVO shall set that attribute to \"PROCESSING\" and shall process the package, which shall include checking package consistency. Upon successful processing, the NFVO shall set the \"onboardingState\" attribute to \"ONBOARDED\". If an error occurs during uploading the package, downloading the external artifacts or processing the package, the NFVO shall set the \"onboardingState\" attribute to \"ERROR\" and shall populate the \"onboardingFailureDetails\" attribute in \"VnfPkgInfo\".   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.upload_vnf_descriptor(version, accept, vnf_pkg_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response.  (required)
        :param str vnf_pkg_id: Identifier of the on-boarded VNF package. The identifier is allocated by the NFVO.  (required)
        :param str file:
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.upload_vnf_descriptor_with_http_info(version, accept, vnf_pkg_id, **kwargs)  # noqa: E501
        else:
            (data) = self.upload_vnf_descriptor_with_http_info(version, accept, vnf_pkg_id, **kwargs)  # noqa: E501
            return data

    def upload_vnf_descriptor_with_http_info(self, version, accept, vnf_pkg_id, **kwargs):  # noqa: E501
        """Upload a VNF package by providing the content of the VNF package.  # noqa: E501

        The PUT method uploads the content of a VNF package. This method shall follow the provisions specified in the  Tables 9.4.5.3.3-1 and 9.4.5.3.3-2 for URI query parameters, request and response data structures, and response codes. Upon start of the upload of the package, the NFVO shall set the \"onboardingState\" attribute in the \"VnfPkgInfo\" structure to \"UPLOADING\". Upon successful upload of the package, if the package references external artifacts, the NFVO shall obtain the external artifacts. Subsequently, upon success, the NFVO shall set that attribute to \"PROCESSING\" and shall process the package, which shall include checking package consistency. Upon successful processing, the NFVO shall set the \"onboardingState\" attribute to \"ONBOARDED\". If an error occurs during uploading the package, downloading the external artifacts or processing the package, the NFVO shall set the \"onboardingState\" attribute to \"ERROR\" and shall populate the \"onboardingFailureDetails\" attribute in \"VnfPkgInfo\".   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.upload_vnf_descriptor_with_http_info(version, accept, vnf_pkg_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str accept: Content-Types that are acceptable for the response.  (required)
        :param str vnf_pkg_id: Identifier of the on-boarded VNF package. The identifier is allocated by the NFVO.  (required)
        :param str file:
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235. 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version', 'accept', 'vnf_pkg_id', 'file', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method upload_vnf_descriptor" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `upload_vnf_descriptor`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `upload_vnf_descriptor`")  # noqa: E501
        # verify the required parameter 'vnf_pkg_id' is set
        if ('vnf_pkg_id' not in params or
                params['vnf_pkg_id'] is None):
            raise ValueError("Missing the required parameter `vnf_pkg_id` when calling `upload_vnf_descriptor`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnf_pkg_id' in params:
            path_params['vnfPkgId'] = params['vnf_pkg_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501

        form_params = []
        local_var_files = {}
        if 'file' in params:
            local_var_files['file'] = params['file']  # noqa: E501

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['multipart/form-data'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/vnf_packages/{vnfPkgId}/package_content', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
