# coding: utf-8

"""
    SOL005 - VNF Package Management Interface

    SOL005 - VNF Package Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class PkgmNotificationsFilter(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'notification_types': 'list[NotificationEnumTypes]',
        'vnf_products_from_providers': 'list[PkgmNotificationsFilterVnfProductsFromProviders]'
    }

    attribute_map = {
        'notification_types': 'notificationTypes',
        'vnf_products_from_providers': 'vnfProductsFromProviders'
    }

    def __init__(self, notification_types=None, vnf_products_from_providers=None):  # noqa: E501
        """PkgmNotificationsFilter - a model defined in Swagger"""  # noqa: E501
        self._notification_types = None
        self._vnf_products_from_providers = None
        self.discriminator = None
        if notification_types is not None:
            self.notification_types = notification_types
        if vnf_products_from_providers is not None:
            self.vnf_products_from_providers = vnf_products_from_providers

    @property
    def notification_types(self):
        """Gets the notification_types of this PkgmNotificationsFilter.  # noqa: E501

        Match particular notification types. Permitted values: - VnfPackageOnboardingNotification - VnfPackageChangeNotification   # noqa: E501

        :return: The notification_types of this PkgmNotificationsFilter.  # noqa: E501
        :rtype: list[NotificationEnumTypes]
        """
        return self._notification_types

    @notification_types.setter
    def notification_types(self, notification_types):
        """Sets the notification_types of this PkgmNotificationsFilter.

        Match particular notification types. Permitted values: - VnfPackageOnboardingNotification - VnfPackageChangeNotification   # noqa: E501

        :param notification_types: The notification_types of this PkgmNotificationsFilter.  # noqa: E501
        :type: list[NotificationEnumTypes]
        """

        self._notification_types = notification_types

    @property
    def vnf_products_from_providers(self):
        """Gets the vnf_products_from_providers of this PkgmNotificationsFilter.  # noqa: E501

        If present, match VNF packages that contain VNF products from certain providers.   # noqa: E501

        :return: The vnf_products_from_providers of this PkgmNotificationsFilter.  # noqa: E501
        :rtype: list[PkgmNotificationsFilterVnfProductsFromProviders]
        """
        return self._vnf_products_from_providers

    @vnf_products_from_providers.setter
    def vnf_products_from_providers(self, vnf_products_from_providers):
        """Sets the vnf_products_from_providers of this PkgmNotificationsFilter.

        If present, match VNF packages that contain VNF products from certain providers.   # noqa: E501

        :param vnf_products_from_providers: The vnf_products_from_providers of this PkgmNotificationsFilter.  # noqa: E501
        :type: list[PkgmNotificationsFilterVnfProductsFromProviders]
        """

        self._vnf_products_from_providers = vnf_products_from_providers

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PkgmNotificationsFilter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PkgmNotificationsFilter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
