# coding: utf-8

"""
    SOL005 - VNF Package Management Interface

    SOL005 - VNF Package Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class PkgmNotificationsFilterVnfProducts(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnf_product_name': 'str',
        'versions': 'list[PkgmNotificationsFilterVersions]'
    }

    attribute_map = {
        'vnf_product_name': 'vnfProductName',
        'versions': 'versions'
    }

    def __init__(self, vnf_product_name=None, versions=None):  # noqa: E501
        """PkgmNotificationsFilterVnfProducts - a model defined in Swagger"""  # noqa: E501
        self._vnf_product_name = None
        self._versions = None
        self.discriminator = None
        self.vnf_product_name = vnf_product_name
        if versions is not None:
            self.versions = versions

    @property
    def vnf_product_name(self):
        """Gets the vnf_product_name of this PkgmNotificationsFilterVnfProducts.  # noqa: E501

        Name of the VNF product to match.   # noqa: E501

        :return: The vnf_product_name of this PkgmNotificationsFilterVnfProducts.  # noqa: E501
        :rtype: str
        """
        return self._vnf_product_name

    @vnf_product_name.setter
    def vnf_product_name(self, vnf_product_name):
        """Sets the vnf_product_name of this PkgmNotificationsFilterVnfProducts.

        Name of the VNF product to match.   # noqa: E501

        :param vnf_product_name: The vnf_product_name of this PkgmNotificationsFilterVnfProducts.  # noqa: E501
        :type: str
        """
        if vnf_product_name is None:
            print("WARNING: Invalid value for the required field `vnf_product_name`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_product_name`, must not be `None`")  # noqa: E501

        self._vnf_product_name = vnf_product_name

    @property
    def versions(self):
        """Gets the versions of this PkgmNotificationsFilterVnfProducts.  # noqa: E501

        If present, match VNF packages that contain VNF products with certain versions and a certain product name, from one particular provider.   # noqa: E501

        :return: The versions of this PkgmNotificationsFilterVnfProducts.  # noqa: E501
        :rtype: list[PkgmNotificationsFilterVersions]
        """
        return self._versions

    @versions.setter
    def versions(self, versions):
        """Sets the versions of this PkgmNotificationsFilterVnfProducts.

        If present, match VNF packages that contain VNF products with certain versions and a certain product name, from one particular provider.   # noqa: E501

        :param versions: The versions of this PkgmNotificationsFilterVnfProducts.  # noqa: E501
        :type: list[PkgmNotificationsFilterVersions]
        """

        self._versions = versions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PkgmNotificationsFilterVnfProducts, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PkgmNotificationsFilterVnfProducts):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
