# coding: utf-8

"""
    SOL005 - VNF Package Management Interface

    SOL005 - VNF Package Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class PkgmNotificationsFilterVnfProductsFromProviders(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vnf_provider': 'str',
        'vnf_products': 'list[PkgmNotificationsFilterVnfProducts]',
        'vnfd_id': 'list[Identifier]',
        'vnf_pkg_id': 'list[Identifier]',
        'operational_state': 'list[PackageOperationalStateType]',
        'usage_state': 'list[PackageUsageStateType]',
        'vnfm_info': 'list[str]'
    }

    attribute_map = {
        'vnf_provider': 'vnfProvider',
        'vnf_products': 'vnfProducts',
        'vnfd_id': 'vnfdId',
        'vnf_pkg_id': 'vnfPkgId',
        'operational_state': 'operationalState',
        'usage_state': 'usageState',
        'vnfm_info': 'vnfmInfo'
    }

    def __init__(self, vnf_provider=None, vnf_products=None, vnfd_id=None, vnf_pkg_id=None, operational_state=None, usage_state=None, vnfm_info=None):  # noqa: E501
        """PkgmNotificationsFilterVnfProductsFromProviders - a model defined in Swagger"""  # noqa: E501
        self._vnf_provider = None
        self._vnf_products = None
        self._vnfd_id = None
        self._vnf_pkg_id = None
        self._operational_state = None
        self._usage_state = None
        self._vnfm_info = None
        self.discriminator = None
        self.vnf_provider = vnf_provider
        if vnf_products is not None:
            self.vnf_products = vnf_products
        if vnfd_id is not None:
            self.vnfd_id = vnfd_id
        if vnf_pkg_id is not None:
            self.vnf_pkg_id = vnf_pkg_id
        if operational_state is not None:
            self.operational_state = operational_state
        if usage_state is not None:
            self.usage_state = usage_state
        if vnfm_info is not None:
            self.vnfm_info = vnfm_info

    @property
    def vnf_provider(self):
        """Gets the vnf_provider of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501

        Name of the VNFprovider to match.   # noqa: E501

        :return: The vnf_provider of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501
        :rtype: str
        """
        return self._vnf_provider

    @vnf_provider.setter
    def vnf_provider(self, vnf_provider):
        """Sets the vnf_provider of this PkgmNotificationsFilterVnfProductsFromProviders.

        Name of the VNFprovider to match.   # noqa: E501

        :param vnf_provider: The vnf_provider of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501
        :type: str
        """
        if vnf_provider is None:
            print("WARNING: Invalid value for the required field `vnf_provider`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnf_provider`, must not be `None`")  # noqa: E501

        self._vnf_provider = vnf_provider

    @property
    def vnf_products(self):
        """Gets the vnf_products of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501

        If present, match VNF packages that contain VNF products with certain product names, from one particular provider.   # noqa: E501

        :return: The vnf_products of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501
        :rtype: list[PkgmNotificationsFilterVnfProducts]
        """
        return self._vnf_products

    @vnf_products.setter
    def vnf_products(self, vnf_products):
        """Sets the vnf_products of this PkgmNotificationsFilterVnfProductsFromProviders.

        If present, match VNF packages that contain VNF products with certain product names, from one particular provider.   # noqa: E501

        :param vnf_products: The vnf_products of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501
        :type: list[PkgmNotificationsFilterVnfProducts]
        """

        self._vnf_products = vnf_products

    @property
    def vnfd_id(self):
        """Gets the vnfd_id of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501

        Match VNF packages with a VNFD identifier listed in the attribute.   # noqa: E501

        :return: The vnfd_id of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._vnfd_id

    @vnfd_id.setter
    def vnfd_id(self, vnfd_id):
        """Sets the vnfd_id of this PkgmNotificationsFilterVnfProductsFromProviders.

        Match VNF packages with a VNFD identifier listed in the attribute.   # noqa: E501

        :param vnfd_id: The vnfd_id of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501
        :type: list[Identifier]
        """

        self._vnfd_id = vnfd_id

    @property
    def vnf_pkg_id(self):
        """Gets the vnf_pkg_id of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501

        Match VNF packages with a package identifier listed in the attribute. May be present if the \"notificationTypes\" attribute contains the value \"VnfPackageChangeNotification\", and shall be absent otherwise.   # noqa: E501

        :return: The vnf_pkg_id of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501
        :rtype: list[Identifier]
        """
        return self._vnf_pkg_id

    @vnf_pkg_id.setter
    def vnf_pkg_id(self, vnf_pkg_id):
        """Sets the vnf_pkg_id of this PkgmNotificationsFilterVnfProductsFromProviders.

        Match VNF packages with a package identifier listed in the attribute. May be present if the \"notificationTypes\" attribute contains the value \"VnfPackageChangeNotification\", and shall be absent otherwise.   # noqa: E501

        :param vnf_pkg_id: The vnf_pkg_id of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501
        :type: list[Identifier]
        """

        self._vnf_pkg_id = vnf_pkg_id

    @property
    def operational_state(self):
        """Gets the operational_state of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501

        Match VNF packages with a package identifier listed in the attribute. May be present if the \"notificationTypes\" attribute contains the value \"VnfPackageChangeNotification\", and shall be absent otherwise.   # noqa: E501

        :return: The operational_state of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501
        :rtype: list[PackageOperationalStateType]
        """
        return self._operational_state

    @operational_state.setter
    def operational_state(self, operational_state):
        """Sets the operational_state of this PkgmNotificationsFilterVnfProductsFromProviders.

        Match VNF packages with a package identifier listed in the attribute. May be present if the \"notificationTypes\" attribute contains the value \"VnfPackageChangeNotification\", and shall be absent otherwise.   # noqa: E501

        :param operational_state: The operational_state of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501
        :type: list[PackageOperationalStateType]
        """

        self._operational_state = operational_state

    @property
    def usage_state(self):
        """Gets the usage_state of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501

        Match particular usage state of the on-boarded VNF package. May be present if the \"notificationTypes\" attribute contains the value \"VnfPackageChangeNotification\", and shall be absent otherwise.   # noqa: E501

        :return: The usage_state of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501
        :rtype: list[PackageUsageStateType]
        """
        return self._usage_state

    @usage_state.setter
    def usage_state(self, usage_state):
        """Sets the usage_state of this PkgmNotificationsFilterVnfProductsFromProviders.

        Match particular usage state of the on-boarded VNF package. May be present if the \"notificationTypes\" attribute contains the value \"VnfPackageChangeNotification\", and shall be absent otherwise.   # noqa: E501

        :param usage_state: The usage_state of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501
        :type: list[PackageUsageStateType]
        """

        self._usage_state = usage_state

    @property
    def vnfm_info(self):
        """Gets the vnfm_info of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501

        Match strings that specify VNFMs compatible with the VNF. See Table 9.5.2.5-1.   # noqa: E501

        :return: The vnfm_info of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501
        :rtype: list[str]
        """
        return self._vnfm_info

    @vnfm_info.setter
    def vnfm_info(self, vnfm_info):
        """Sets the vnfm_info of this PkgmNotificationsFilterVnfProductsFromProviders.

        Match strings that specify VNFMs compatible with the VNF. See Table 9.5.2.5-1.   # noqa: E501

        :param vnfm_info: The vnfm_info of this PkgmNotificationsFilterVnfProductsFromProviders.  # noqa: E501
        :type: list[str]
        """

        self._vnfm_info = vnfm_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PkgmNotificationsFilterVnfProductsFromProviders, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PkgmNotificationsFilterVnfProductsFromProviders):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
