# coding: utf-8

"""
    SOL005 - VNF Package Management Interface

    SOL005 - VNF Package Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfPackageArtifactInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'artifact_path': 'String',
        'artifact_uri': 'Uri',
        'checksum': 'Checksum',
        'artifact_classification': 'str',
        'is_encrypted': 'bool',
        'non_mano_artifact_set_id': 'str',
        'metadata': 'KeyValuePairs'
    }

    attribute_map = {
        'artifact_path': 'artifactPath',
        'artifact_uri': 'artifactURI',
        'checksum': 'checksum',
        'artifact_classification': 'artifactClassification',
        'is_encrypted': 'isEncrypted',
        'non_mano_artifact_set_id': 'nonManoArtifactSetId',
        'metadata': 'metadata'
    }

    def __init__(self, artifact_path=None, artifact_uri=None, checksum=None, artifact_classification=None, is_encrypted=None, non_mano_artifact_set_id=None, metadata=None):  # noqa: E501
        """VnfPackageArtifactInfo - a model defined in Swagger"""  # noqa: E501
        self._artifact_path = None
        self._artifact_uri = None
        self._checksum = None
        self._artifact_classification = None
        self._is_encrypted = None
        self._non_mano_artifact_set_id = None
        self._metadata = None
        self.discriminator = None
        if artifact_path is not None:
            self.artifact_path = artifact_path
        if artifact_uri is not None:
            self.artifact_uri = artifact_uri
        self.checksum = checksum
        if artifact_classification is not None:
            self.artifact_classification = artifact_classification
        self.is_encrypted = is_encrypted
        if non_mano_artifact_set_id is not None:
            self.non_mano_artifact_set_id = non_mano_artifact_set_id
        if metadata is not None:
            self.metadata = metadata

    @property
    def artifact_path(self):
        """Gets the artifact_path of this VnfPackageArtifactInfo.  # noqa: E501


        :return: The artifact_path of this VnfPackageArtifactInfo.  # noqa: E501
        :rtype: String
        """
        return self._artifact_path

    @artifact_path.setter
    def artifact_path(self, artifact_path):
        """Sets the artifact_path of this VnfPackageArtifactInfo.


        :param artifact_path: The artifact_path of this VnfPackageArtifactInfo.  # noqa: E501
        :type: String
        """

        self._artifact_path = artifact_path

    @property
    def artifact_uri(self):
        """Gets the artifact_uri of this VnfPackageArtifactInfo.  # noqa: E501


        :return: The artifact_uri of this VnfPackageArtifactInfo.  # noqa: E501
        :rtype: Uri
        """
        return self._artifact_uri

    @artifact_uri.setter
    def artifact_uri(self, artifact_uri):
        """Sets the artifact_uri of this VnfPackageArtifactInfo.


        :param artifact_uri: The artifact_uri of this VnfPackageArtifactInfo.  # noqa: E501
        :type: Uri
        """

        self._artifact_uri = artifact_uri

    @property
    def checksum(self):
        """Gets the checksum of this VnfPackageArtifactInfo.  # noqa: E501


        :return: The checksum of this VnfPackageArtifactInfo.  # noqa: E501
        :rtype: Checksum
        """
        return self._checksum

    @checksum.setter
    def checksum(self, checksum):
        """Sets the checksum of this VnfPackageArtifactInfo.


        :param checksum: The checksum of this VnfPackageArtifactInfo.  # noqa: E501
        :type: Checksum
        """
        if checksum is None:
            print("WARNING: Invalid value for the required field `checksum`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `checksum`, must not be `None`")  # noqa: E501

        self._checksum = checksum

    @property
    def artifact_classification(self):
        """Gets the artifact_classification of this VnfPackageArtifactInfo.  # noqa: E501

        Marks specific types of artifacts as defined in the VNF package. If none of the specific classes listed below applies, the attribute shall not be present. Valid values: - HISTORY: a history artifact as per clause 4.3.3 in ETSI GS NFV-SOL 004 [5] - TESTING: a testing artifact as per clause 4.3.4 in ETSI GS NFV-SOL 004 [5] - LICENSE: a license artifact as per clause 4.3.5 in ETSI GS NFV-SOL 004 [5]   # noqa: E501

        :return: The artifact_classification of this VnfPackageArtifactInfo.  # noqa: E501
        :rtype: str
        """
        return self._artifact_classification

    @artifact_classification.setter
    def artifact_classification(self, artifact_classification):
        """Sets the artifact_classification of this VnfPackageArtifactInfo.

        Marks specific types of artifacts as defined in the VNF package. If none of the specific classes listed below applies, the attribute shall not be present. Valid values: - HISTORY: a history artifact as per clause 4.3.3 in ETSI GS NFV-SOL 004 [5] - TESTING: a testing artifact as per clause 4.3.4 in ETSI GS NFV-SOL 004 [5] - LICENSE: a license artifact as per clause 4.3.5 in ETSI GS NFV-SOL 004 [5]   # noqa: E501

        :param artifact_classification: The artifact_classification of this VnfPackageArtifactInfo.  # noqa: E501
        :type: str
        """
        allowed_values = ["HISTORY", "TESTING", "LICENSE"]  # noqa: E501
        if artifact_classification is not None and artifact_classification not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `artifact_classification` ({0}), must be one of {1}"  # noqa: E501
                .format(artifact_classification, allowed_values)
            )

        self._artifact_classification = artifact_classification

    @property
    def is_encrypted(self):
        """Gets the is_encrypted of this VnfPackageArtifactInfo.  # noqa: E501

        Reflects whether the artifact is encrypted (true) or not (false).   # noqa: E501

        :return: The is_encrypted of this VnfPackageArtifactInfo.  # noqa: E501
        :rtype: bool
        """
        return self._is_encrypted

    @is_encrypted.setter
    def is_encrypted(self, is_encrypted):
        """Sets the is_encrypted of this VnfPackageArtifactInfo.

        Reflects whether the artifact is encrypted (true) or not (false).   # noqa: E501

        :param is_encrypted: The is_encrypted of this VnfPackageArtifactInfo.  # noqa: E501
        :type: bool
        """
        if is_encrypted is None:
            print("WARNING: Invalid value for the required field `is_encrypted`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `is_encrypted`, must not be `None`")  # noqa: E501

        self._is_encrypted = is_encrypted

    @property
    def non_mano_artifact_set_id(self):
        """Gets the non_mano_artifact_set_id of this VnfPackageArtifactInfo.  # noqa: E501

        Non-MANO artifact set identifier of the non-MANO artifact set to which the artifact belongs, as defined in clause 4.3.7 of ETSI GS NFV-SOL 004 [5]. Shall be provided if the artifact is a non-MANO artifact, and shall be omitted otherwise.   # noqa: E501

        :return: The non_mano_artifact_set_id of this VnfPackageArtifactInfo.  # noqa: E501
        :rtype: str
        """
        return self._non_mano_artifact_set_id

    @non_mano_artifact_set_id.setter
    def non_mano_artifact_set_id(self, non_mano_artifact_set_id):
        """Sets the non_mano_artifact_set_id of this VnfPackageArtifactInfo.

        Non-MANO artifact set identifier of the non-MANO artifact set to which the artifact belongs, as defined in clause 4.3.7 of ETSI GS NFV-SOL 004 [5]. Shall be provided if the artifact is a non-MANO artifact, and shall be omitted otherwise.   # noqa: E501

        :param non_mano_artifact_set_id: The non_mano_artifact_set_id of this VnfPackageArtifactInfo.  # noqa: E501
        :type: str
        """

        self._non_mano_artifact_set_id = non_mano_artifact_set_id

    @property
    def metadata(self):
        """Gets the metadata of this VnfPackageArtifactInfo.  # noqa: E501


        :return: The metadata of this VnfPackageArtifactInfo.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this VnfPackageArtifactInfo.


        :param metadata: The metadata of this VnfPackageArtifactInfo.  # noqa: E501
        :type: KeyValuePairs
        """

        self._metadata = metadata

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfPackageArtifactInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfPackageArtifactInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
