# coding: utf-8

"""
    SOL005 - VNF Package Management Interface

    SOL005 - VNF Package Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfPackageSoftwareImageInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'IdentifierInVnfd',
        'name': 'str',
        'provider': 'str',
        'version': 'Version',
        'checksum': 'Checksum',
        'is_encrypted': 'bool',
        'container_format': 'str',
        'disk_format': 'str',
        'created_at': 'datetime',
        'min_disk': 'int',
        'min_ram': 'int',
        'size': 'int',
        'user_metadata': 'KeyValuePairs',
        'image_path': 'str'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'provider': 'provider',
        'version': 'version',
        'checksum': 'checksum',
        'is_encrypted': 'isEncrypted',
        'container_format': 'containerFormat',
        'disk_format': 'diskFormat',
        'created_at': 'createdAt',
        'min_disk': 'minDisk',
        'min_ram': 'minRam',
        'size': 'size',
        'user_metadata': 'userMetadata',
        'image_path': 'imagePath'
    }

    def __init__(self, id=None, name=None, provider=None, version=None, checksum=None, is_encrypted=None, container_format=None, disk_format=None, created_at=None, min_disk=None, min_ram=None, size=None, user_metadata=None, image_path=None):  # noqa: E501
        """VnfPackageSoftwareImageInfo - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._provider = None
        self._version = None
        self._checksum = None
        self._is_encrypted = None
        self._container_format = None
        self._disk_format = None
        self._created_at = None
        self._min_disk = None
        self._min_ram = None
        self._size = None
        self._user_metadata = None
        self._image_path = None
        self.discriminator = None
        self.id = id
        self.name = name
        self.provider = provider
        self.version = version
        self.checksum = checksum
        self.is_encrypted = is_encrypted
        self.container_format = container_format
        self.disk_format = disk_format
        self.created_at = created_at
        self.min_disk = min_disk
        self.min_ram = min_ram
        self.size = size
        if user_metadata is not None:
            self.user_metadata = user_metadata
        self.image_path = image_path

    @property
    def id(self):
        """Gets the id of this VnfPackageSoftwareImageInfo.  # noqa: E501


        :return: The id of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :rtype: IdentifierInVnfd
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this VnfPackageSoftwareImageInfo.


        :param id: The id of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :type: IdentifierInVnfd
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this VnfPackageSoftwareImageInfo.  # noqa: E501

        Name of the software image.   # noqa: E501

        :return: The name of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this VnfPackageSoftwareImageInfo.

        Name of the software image.   # noqa: E501

        :param name: The name of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :type: str
        """
        if name is None:
            print("WARNING: Invalid value for the required field `name`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def provider(self):
        """Gets the provider of this VnfPackageSoftwareImageInfo.  # noqa: E501

        Provider of the software image.   # noqa: E501

        :return: The provider of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :rtype: str
        """
        return self._provider

    @provider.setter
    def provider(self, provider):
        """Sets the provider of this VnfPackageSoftwareImageInfo.

        Provider of the software image.   # noqa: E501

        :param provider: The provider of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :type: str
        """
        if provider is None:
            print("WARNING: Invalid value for the required field `provider`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `provider`, must not be `None`")  # noqa: E501

        self._provider = provider

    @property
    def version(self):
        """Gets the version of this VnfPackageSoftwareImageInfo.  # noqa: E501


        :return: The version of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :rtype: Version
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this VnfPackageSoftwareImageInfo.


        :param version: The version of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :type: Version
        """
        if version is None:
            print("WARNING: Invalid value for the required field `version`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `version`, must not be `None`")  # noqa: E501

        self._version = version

    @property
    def checksum(self):
        """Gets the checksum of this VnfPackageSoftwareImageInfo.  # noqa: E501


        :return: The checksum of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :rtype: Checksum
        """
        return self._checksum

    @checksum.setter
    def checksum(self, checksum):
        """Sets the checksum of this VnfPackageSoftwareImageInfo.


        :param checksum: The checksum of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :type: Checksum
        """
        if checksum is None:
            print("WARNING: Invalid value for the required field `checksum`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `checksum`, must not be `None`")  # noqa: E501

        self._checksum = checksum

    @property
    def is_encrypted(self):
        """Gets the is_encrypted of this VnfPackageSoftwareImageInfo.  # noqa: E501

        Reflects whether the image is encrypted (true) or not (false).   # noqa: E501

        :return: The is_encrypted of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :rtype: bool
        """
        return self._is_encrypted

    @is_encrypted.setter
    def is_encrypted(self, is_encrypted):
        """Sets the is_encrypted of this VnfPackageSoftwareImageInfo.

        Reflects whether the image is encrypted (true) or not (false).   # noqa: E501

        :param is_encrypted: The is_encrypted of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :type: bool
        """
        if is_encrypted is None:
            print("WARNING: Invalid value for the required field `is_encrypted`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `is_encrypted`, must not be `None`")  # noqa: E501

        self._is_encrypted = is_encrypted

    @property
    def container_format(self):
        """Gets the container_format of this VnfPackageSoftwareImageInfo.  # noqa: E501

        Container format indicates whether the software image is in a file format that also contains meta-data about the actual software. Permitted values: - AKI: a kernel image format - AMI: a machine image format - ARI: a ram disk image format - BARE: the image does not have a container or meta-data envelope - DOCKER: docker container format - OVA: OVF package in a tar file - OVF: OVF container format   # noqa: E501

        :return: The container_format of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :rtype: str
        """
        return self._container_format

    @container_format.setter
    def container_format(self, container_format):
        """Sets the container_format of this VnfPackageSoftwareImageInfo.

        Container format indicates whether the software image is in a file format that also contains meta-data about the actual software. Permitted values: - AKI: a kernel image format - AMI: a machine image format - ARI: a ram disk image format - BARE: the image does not have a container or meta-data envelope - DOCKER: docker container format - OVA: OVF package in a tar file - OVF: OVF container format   # noqa: E501

        :param container_format: The container_format of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :type: str
        """
        if container_format is None:
            print("WARNING: Invalid value for the required field `container_format`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `container_format`, must not be `None`")  # noqa: E501
        allowed_values = ["AKI", "AMI", "ARI", "BARE", "DOCKER", "OVA", "OVF"]  # noqa: E501
        if container_format is not None and container_format not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `container_format` ({0}), must be one of {1}"  # noqa: E501
                .format(container_format, allowed_values)
            )

        self._container_format = container_format

    @property
    def disk_format(self):
        """Gets the disk_format of this VnfPackageSoftwareImageInfo.  # noqa: E501

        Disk format of a software image is the format of the underlying disk image. Permitted values: - AKI: a kernel image format - AMI: a machine image format - ARI: a ramdisk image format - ISO: an archive format for the data contents of an optical disc, such as CD-ROM - QCOW2: a common disk image format, which can expand dynamically and supports copy on write - RAW: an unstructured disk image format - VDI: a common disk image format - VHD: a common disk image format - VHDX: enhanced version of VHD format - VMDK: a common disk image format   # noqa: E501

        :return: The disk_format of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :rtype: str
        """
        return self._disk_format

    @disk_format.setter
    def disk_format(self, disk_format):
        """Sets the disk_format of this VnfPackageSoftwareImageInfo.

        Disk format of a software image is the format of the underlying disk image. Permitted values: - AKI: a kernel image format - AMI: a machine image format - ARI: a ramdisk image format - ISO: an archive format for the data contents of an optical disc, such as CD-ROM - QCOW2: a common disk image format, which can expand dynamically and supports copy on write - RAW: an unstructured disk image format - VDI: a common disk image format - VHD: a common disk image format - VHDX: enhanced version of VHD format - VMDK: a common disk image format   # noqa: E501

        :param disk_format: The disk_format of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :type: str
        """
        if disk_format is None:
            print("WARNING: Invalid value for the required field `disk_format`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `disk_format`, must not be `None`")  # noqa: E501
        allowed_values = ["AKI", "AMI", "ARI", "ISO", "QCOW2", "RAW", "VDI", "VHD", "VHDX", "VMDK"]  # noqa: E501
        if disk_format is not None and disk_format not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `disk_format` ({0}), must be one of {1}"  # noqa: E501
                .format(disk_format, allowed_values)
            )

        self._disk_format = disk_format

    @property
    def created_at(self):
        """Gets the created_at of this VnfPackageSoftwareImageInfo.  # noqa: E501


        :return: The created_at of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this VnfPackageSoftwareImageInfo.


        :param created_at: The created_at of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :type: datetime
        """
        if created_at is None:
            print("WARNING: Invalid value for the required field `created_at`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `created_at`, must not be `None`")  # noqa: E501

        self._created_at = created_at

    @property
    def min_disk(self):
        """Gets the min_disk of this VnfPackageSoftwareImageInfo.  # noqa: E501

        The minimal disk for this software image in bytes.   # noqa: E501

        :return: The min_disk of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :rtype: int
        """
        return self._min_disk

    @min_disk.setter
    def min_disk(self, min_disk):
        """Sets the min_disk of this VnfPackageSoftwareImageInfo.

        The minimal disk for this software image in bytes.   # noqa: E501

        :param min_disk: The min_disk of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :type: int
        """
        if min_disk is None:
            print("WARNING: Invalid value for the required field `min_disk`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `min_disk`, must not be `None`")  # noqa: E501

        self._min_disk = min_disk

    @property
    def min_ram(self):
        """Gets the min_ram of this VnfPackageSoftwareImageInfo.  # noqa: E501

        The minimal RAM for this software image in bytes.   # noqa: E501

        :return: The min_ram of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :rtype: int
        """
        return self._min_ram

    @min_ram.setter
    def min_ram(self, min_ram):
        """Sets the min_ram of this VnfPackageSoftwareImageInfo.

        The minimal RAM for this software image in bytes.   # noqa: E501

        :param min_ram: The min_ram of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :type: int
        """
        if min_ram is None:
            print("WARNING: Invalid value for the required field `min_ram`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `min_ram`, must not be `None`")  # noqa: E501

        self._min_ram = min_ram

    @property
    def size(self):
        """Gets the size of this VnfPackageSoftwareImageInfo.  # noqa: E501

        Size of this software image in bytes.   # noqa: E501

        :return: The size of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :rtype: int
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this VnfPackageSoftwareImageInfo.

        Size of this software image in bytes.   # noqa: E501

        :param size: The size of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :type: int
        """
        if size is None:
            print("WARNING: Invalid value for the required field `size`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `size`, must not be `None`")  # noqa: E501

        self._size = size

    @property
    def user_metadata(self):
        """Gets the user_metadata of this VnfPackageSoftwareImageInfo.  # noqa: E501


        :return: The user_metadata of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :rtype: KeyValuePairs
        """
        return self._user_metadata

    @user_metadata.setter
    def user_metadata(self, user_metadata):
        """Sets the user_metadata of this VnfPackageSoftwareImageInfo.


        :param user_metadata: The user_metadata of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :type: KeyValuePairs
        """

        self._user_metadata = user_metadata

    @property
    def image_path(self):
        """Gets the image_path of this VnfPackageSoftwareImageInfo.  # noqa: E501

        Path in the VNF package, which identifies the image artifact and also allows to access a copy of the image artifact.   # noqa: E501

        :return: The image_path of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :rtype: str
        """
        return self._image_path

    @image_path.setter
    def image_path(self, image_path):
        """Sets the image_path of this VnfPackageSoftwareImageInfo.

        Path in the VNF package, which identifies the image artifact and also allows to access a copy of the image artifact.   # noqa: E501

        :param image_path: The image_path of this VnfPackageSoftwareImageInfo.  # noqa: E501
        :type: str
        """
        if image_path is None:
            print("WARNING: Invalid value for the required field `image_path`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `image_path`, must not be `None`")  # noqa: E501

        self._image_path = image_path

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfPackageSoftwareImageInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfPackageSoftwareImageInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
