# coding: utf-8

"""
    SOL005 - VNF Package Management Interface

    SOL005 - VNF Package Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfPkgInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'Identifier',
        'vnfd_id': 'Identifier',
        'vnf_provider': 'str',
        'vnf_product_name': 'str',
        'vnf_software_version': 'Version',
        'vnfd_version': 'Version',
        'compatible_specification_versions': 'Version',
        'checksum': 'Checksum',
        'package_security_option': 'str',
        'signing_certificate': 'str',
        'software_images': 'list[VnfPackageSoftwareImageInfo]',
        'additional_artifacts': 'list[VnfPackageArtifactInfo]',
        'onboarding_state': 'PackageOnboardingStateType',
        'operational_state': 'PackageOperationalStateType',
        'usage_state': 'PackageUsageStateType',
        'vnfm_info': 'list[str]',
        'user_defined_data': 'VnfPkgInfoUserDefinedData',
        'onboarding_failure_details': 'ProblemDetails',
        'links': 'VnfPkgInfoLinks'
    }

    attribute_map = {
        'id': 'id',
        'vnfd_id': 'vnfdId',
        'vnf_provider': 'vnfProvider',
        'vnf_product_name': 'vnfProductName',
        'vnf_software_version': 'vnfSoftwareVersion',
        'vnfd_version': 'vnfdVersion',
        'compatible_specification_versions': 'compatibleSpecificationVersions',
        'checksum': 'checksum',
        'package_security_option': 'packageSecurityOption',
        'signing_certificate': 'signingCertificate',
        'software_images': 'softwareImages',
        'additional_artifacts': 'additionalArtifacts',
        'onboarding_state': 'onboardingState',
        'operational_state': 'operationalState',
        'usage_state': 'usageState',
        'vnfm_info': 'vnfmInfo',
        'user_defined_data': 'userDefinedData',
        'onboarding_failure_details': 'onboardingFailureDetails',
        'links': '_links'
    }

    def __init__(self, id=None, vnfd_id=None, vnf_provider=None, vnf_product_name=None, vnf_software_version=None, vnfd_version=None, compatible_specification_versions=None, checksum=None, package_security_option=None, signing_certificate=None, software_images=None, additional_artifacts=None, onboarding_state=None, operational_state=None, usage_state=None, vnfm_info=None, user_defined_data=None, onboarding_failure_details=None, links=None):  # noqa: E501
        """VnfPkgInfo - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._vnfd_id = None
        self._vnf_provider = None
        self._vnf_product_name = None
        self._vnf_software_version = None
        self._vnfd_version = None
        self._compatible_specification_versions = None
        self._checksum = None
        self._package_security_option = None
        self._signing_certificate = None
        self._software_images = None
        self._additional_artifacts = None
        self._onboarding_state = None
        self._operational_state = None
        self._usage_state = None
        self._vnfm_info = None
        self._user_defined_data = None
        self._onboarding_failure_details = None
        self._links = None
        self.discriminator = None
        self.id = id
        if vnfd_id is not None:
            self.vnfd_id = vnfd_id
        if vnf_provider is not None:
            self.vnf_provider = vnf_provider
        if vnf_product_name is not None:
            self.vnf_product_name = vnf_product_name
        if vnf_software_version is not None:
            self.vnf_software_version = vnf_software_version
        if vnfd_version is not None:
            self.vnfd_version = vnfd_version
        if compatible_specification_versions is not None:
            self.compatible_specification_versions = compatible_specification_versions
        if checksum is not None:
            self.checksum = checksum
        self.package_security_option = package_security_option
        if signing_certificate is not None:
            self.signing_certificate = signing_certificate
        if software_images is not None:
            self.software_images = software_images
        if additional_artifacts is not None:
            self.additional_artifacts = additional_artifacts
        self.onboarding_state = onboarding_state
        self.operational_state = operational_state
        self.usage_state = usage_state
        self.vnfm_info = vnfm_info
        if user_defined_data is not None:
            self.user_defined_data = user_defined_data
        if onboarding_failure_details is not None:
            self.onboarding_failure_details = onboarding_failure_details
        self.links = links

    @property
    def id(self):
        """Gets the id of this VnfPkgInfo.  # noqa: E501


        :return: The id of this VnfPkgInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this VnfPkgInfo.


        :param id: The id of this VnfPkgInfo.  # noqa: E501
        :type: Identifier
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def vnfd_id(self):
        """Gets the vnfd_id of this VnfPkgInfo.  # noqa: E501


        :return: The vnfd_id of this VnfPkgInfo.  # noqa: E501
        :rtype: Identifier
        """
        return self._vnfd_id

    @vnfd_id.setter
    def vnfd_id(self, vnfd_id):
        """Sets the vnfd_id of this VnfPkgInfo.


        :param vnfd_id: The vnfd_id of this VnfPkgInfo.  # noqa: E501
        :type: Identifier
        """

        self._vnfd_id = vnfd_id

    @property
    def vnf_provider(self):
        """Gets the vnf_provider of this VnfPkgInfo.  # noqa: E501

        Provider of the VNF package and the VNFD. This information is copied from the VNFD.  It shall be present after the VNF package content has been on-boarded and absent otherwise.   # noqa: E501

        :return: The vnf_provider of this VnfPkgInfo.  # noqa: E501
        :rtype: str
        """
        return self._vnf_provider

    @vnf_provider.setter
    def vnf_provider(self, vnf_provider):
        """Sets the vnf_provider of this VnfPkgInfo.

        Provider of the VNF package and the VNFD. This information is copied from the VNFD.  It shall be present after the VNF package content has been on-boarded and absent otherwise.   # noqa: E501

        :param vnf_provider: The vnf_provider of this VnfPkgInfo.  # noqa: E501
        :type: str
        """

        self._vnf_provider = vnf_provider

    @property
    def vnf_product_name(self):
        """Gets the vnf_product_name of this VnfPkgInfo.  # noqa: E501

        Name to identify the VNF product.Invariant for the VNF product lifetime.  This information is copied from the VNFD. It shall be present after the VNF package content has been on-boarded and absent otherwise.   # noqa: E501

        :return: The vnf_product_name of this VnfPkgInfo.  # noqa: E501
        :rtype: str
        """
        return self._vnf_product_name

    @vnf_product_name.setter
    def vnf_product_name(self, vnf_product_name):
        """Sets the vnf_product_name of this VnfPkgInfo.

        Name to identify the VNF product.Invariant for the VNF product lifetime.  This information is copied from the VNFD. It shall be present after the VNF package content has been on-boarded and absent otherwise.   # noqa: E501

        :param vnf_product_name: The vnf_product_name of this VnfPkgInfo.  # noqa: E501
        :type: str
        """

        self._vnf_product_name = vnf_product_name

    @property
    def vnf_software_version(self):
        """Gets the vnf_software_version of this VnfPkgInfo.  # noqa: E501


        :return: The vnf_software_version of this VnfPkgInfo.  # noqa: E501
        :rtype: Version
        """
        return self._vnf_software_version

    @vnf_software_version.setter
    def vnf_software_version(self, vnf_software_version):
        """Sets the vnf_software_version of this VnfPkgInfo.


        :param vnf_software_version: The vnf_software_version of this VnfPkgInfo.  # noqa: E501
        :type: Version
        """

        self._vnf_software_version = vnf_software_version

    @property
    def vnfd_version(self):
        """Gets the vnfd_version of this VnfPkgInfo.  # noqa: E501


        :return: The vnfd_version of this VnfPkgInfo.  # noqa: E501
        :rtype: Version
        """
        return self._vnfd_version

    @vnfd_version.setter
    def vnfd_version(self, vnfd_version):
        """Sets the vnfd_version of this VnfPkgInfo.


        :param vnfd_version: The vnfd_version of this VnfPkgInfo.  # noqa: E501
        :type: Version
        """

        self._vnfd_version = vnfd_version

    @property
    def compatible_specification_versions(self):
        """Gets the compatible_specification_versions of this VnfPkgInfo.  # noqa: E501


        :return: The compatible_specification_versions of this VnfPkgInfo.  # noqa: E501
        :rtype: Version
        """
        return self._compatible_specification_versions

    @compatible_specification_versions.setter
    def compatible_specification_versions(self, compatible_specification_versions):
        """Sets the compatible_specification_versions of this VnfPkgInfo.


        :param compatible_specification_versions: The compatible_specification_versions of this VnfPkgInfo.  # noqa: E501
        :type: Version
        """

        self._compatible_specification_versions = compatible_specification_versions

    @property
    def checksum(self):
        """Gets the checksum of this VnfPkgInfo.  # noqa: E501


        :return: The checksum of this VnfPkgInfo.  # noqa: E501
        :rtype: Checksum
        """
        return self._checksum

    @checksum.setter
    def checksum(self, checksum):
        """Sets the checksum of this VnfPkgInfo.


        :param checksum: The checksum of this VnfPkgInfo.  # noqa: E501
        :type: Checksum
        """

        self._checksum = checksum

    @property
    def package_security_option(self):
        """Gets the package_security_option of this VnfPkgInfo.  # noqa: E501

        Signals the security option used by the package as defined in clause 5.1 of ETSI GS NFV-SOL 004 [5]. Valid values: OPTION_1, OPTION_2   # noqa: E501

        :return: The package_security_option of this VnfPkgInfo.  # noqa: E501
        :rtype: str
        """
        return self._package_security_option

    @package_security_option.setter
    def package_security_option(self, package_security_option):
        """Sets the package_security_option of this VnfPkgInfo.

        Signals the security option used by the package as defined in clause 5.1 of ETSI GS NFV-SOL 004 [5]. Valid values: OPTION_1, OPTION_2   # noqa: E501

        :param package_security_option: The package_security_option of this VnfPkgInfo.  # noqa: E501
        :type: str
        """
        if package_security_option is None:
            print("WARNING: Invalid value for the required field `package_security_option`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `package_security_option`, must not be `None`")  # noqa: E501
        allowed_values = ["OPTION_1", "OPTION_2"]  # noqa: E501
        if package_security_option is not None and package_security_option not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `package_security_option` ({0}), must be one of {1}"  # noqa: E501
                .format(package_security_option, allowed_values)
            )

        self._package_security_option = package_security_option

    @property
    def signing_certificate(self):
        """Gets the signing_certificate of this VnfPkgInfo.  # noqa: E501

        The singleton signing certificate if it is included as a file in the VNF package.   # noqa: E501

        :return: The signing_certificate of this VnfPkgInfo.  # noqa: E501
        :rtype: str
        """
        return self._signing_certificate

    @signing_certificate.setter
    def signing_certificate(self, signing_certificate):
        """Sets the signing_certificate of this VnfPkgInfo.

        The singleton signing certificate if it is included as a file in the VNF package.   # noqa: E501

        :param signing_certificate: The signing_certificate of this VnfPkgInfo.  # noqa: E501
        :type: str
        """

        self._signing_certificate = signing_certificate

    @property
    def software_images(self):
        """Gets the software_images of this VnfPkgInfo.  # noqa: E501

        Information about VNF package artifacts that are software images. This attribute shall not be present before the VNF package content is on-boarded. Otherwise, this attribute shall be present unless it has been requested to be excluded per attribute selector.   # noqa: E501

        :return: The software_images of this VnfPkgInfo.  # noqa: E501
        :rtype: list[VnfPackageSoftwareImageInfo]
        """
        return self._software_images

    @software_images.setter
    def software_images(self, software_images):
        """Sets the software_images of this VnfPkgInfo.

        Information about VNF package artifacts that are software images. This attribute shall not be present before the VNF package content is on-boarded. Otherwise, this attribute shall be present unless it has been requested to be excluded per attribute selector.   # noqa: E501

        :param software_images: The software_images of this VnfPkgInfo.  # noqa: E501
        :type: list[VnfPackageSoftwareImageInfo]
        """

        self._software_images = software_images

    @property
    def additional_artifacts(self):
        """Gets the additional_artifacts of this VnfPkgInfo.  # noqa: E501

        Information about VNF package artifacts contained in the VNF package that are not software images. This attribute shall not be present before the VNF package content is on-boarded. Otherwise, this attribute shall be present if the VNF package contains additional artifacts.   # noqa: E501

        :return: The additional_artifacts of this VnfPkgInfo.  # noqa: E501
        :rtype: list[VnfPackageArtifactInfo]
        """
        return self._additional_artifacts

    @additional_artifacts.setter
    def additional_artifacts(self, additional_artifacts):
        """Sets the additional_artifacts of this VnfPkgInfo.

        Information about VNF package artifacts contained in the VNF package that are not software images. This attribute shall not be present before the VNF package content is on-boarded. Otherwise, this attribute shall be present if the VNF package contains additional artifacts.   # noqa: E501

        :param additional_artifacts: The additional_artifacts of this VnfPkgInfo.  # noqa: E501
        :type: list[VnfPackageArtifactInfo]
        """

        self._additional_artifacts = additional_artifacts

    @property
    def onboarding_state(self):
        """Gets the onboarding_state of this VnfPkgInfo.  # noqa: E501


        :return: The onboarding_state of this VnfPkgInfo.  # noqa: E501
        :rtype: PackageOnboardingStateType
        """
        return self._onboarding_state

    @onboarding_state.setter
    def onboarding_state(self, onboarding_state):
        """Sets the onboarding_state of this VnfPkgInfo.


        :param onboarding_state: The onboarding_state of this VnfPkgInfo.  # noqa: E501
        :type: PackageOnboardingStateType
        """
        if onboarding_state is None:
            print("WARNING: Invalid value for the required field `onboarding_state`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `onboarding_state`, must not be `None`")  # noqa: E501

        self._onboarding_state = onboarding_state

    @property
    def operational_state(self):
        """Gets the operational_state of this VnfPkgInfo.  # noqa: E501


        :return: The operational_state of this VnfPkgInfo.  # noqa: E501
        :rtype: PackageOperationalStateType
        """
        return self._operational_state

    @operational_state.setter
    def operational_state(self, operational_state):
        """Sets the operational_state of this VnfPkgInfo.


        :param operational_state: The operational_state of this VnfPkgInfo.  # noqa: E501
        :type: PackageOperationalStateType
        """
        if operational_state is None:
            print("WARNING: Invalid value for the required field `operational_state`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `operational_state`, must not be `None`")  # noqa: E501

        self._operational_state = operational_state

    @property
    def usage_state(self):
        """Gets the usage_state of this VnfPkgInfo.  # noqa: E501


        :return: The usage_state of this VnfPkgInfo.  # noqa: E501
        :rtype: PackageUsageStateType
        """
        return self._usage_state

    @usage_state.setter
    def usage_state(self, usage_state):
        """Sets the usage_state of this VnfPkgInfo.


        :param usage_state: The usage_state of this VnfPkgInfo.  # noqa: E501
        :type: PackageUsageStateType
        """
        if usage_state is None:
            print("WARNING: Invalid value for the required field `usage_state`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `usage_state`, must not be `None`")  # noqa: E501

        self._usage_state = usage_state

    @property
    def vnfm_info(self):
        """Gets the vnfm_info of this VnfPkgInfo.  # noqa: E501

        Specifies VNFMs compatible with the VNF. This information is copied from the VNFD. See note 4.   # noqa: E501

        :return: The vnfm_info of this VnfPkgInfo.  # noqa: E501
        :rtype: list[str]
        """
        return self._vnfm_info

    @vnfm_info.setter
    def vnfm_info(self, vnfm_info):
        """Sets the vnfm_info of this VnfPkgInfo.

        Specifies VNFMs compatible with the VNF. This information is copied from the VNFD. See note 4.   # noqa: E501

        :param vnfm_info: The vnfm_info of this VnfPkgInfo.  # noqa: E501
        :type: list[str]
        """
        if vnfm_info is None:
            print("WARNING: Invalid value for the required field `vnfm_info`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `vnfm_info`, must not be `None`")  # noqa: E501

        self._vnfm_info = vnfm_info

    @property
    def user_defined_data(self):
        """Gets the user_defined_data of this VnfPkgInfo.  # noqa: E501


        :return: The user_defined_data of this VnfPkgInfo.  # noqa: E501
        :rtype: VnfPkgInfoUserDefinedData
        """
        return self._user_defined_data

    @user_defined_data.setter
    def user_defined_data(self, user_defined_data):
        """Sets the user_defined_data of this VnfPkgInfo.


        :param user_defined_data: The user_defined_data of this VnfPkgInfo.  # noqa: E501
        :type: VnfPkgInfoUserDefinedData
        """

        self._user_defined_data = user_defined_data

    @property
    def onboarding_failure_details(self):
        """Gets the onboarding_failure_details of this VnfPkgInfo.  # noqa: E501


        :return: The onboarding_failure_details of this VnfPkgInfo.  # noqa: E501
        :rtype: ProblemDetails
        """
        return self._onboarding_failure_details

    @onboarding_failure_details.setter
    def onboarding_failure_details(self, onboarding_failure_details):
        """Sets the onboarding_failure_details of this VnfPkgInfo.


        :param onboarding_failure_details: The onboarding_failure_details of this VnfPkgInfo.  # noqa: E501
        :type: ProblemDetails
        """

        self._onboarding_failure_details = onboarding_failure_details

    @property
    def links(self):
        """Gets the links of this VnfPkgInfo.  # noqa: E501


        :return: The links of this VnfPkgInfo.  # noqa: E501
        :rtype: VnfPkgInfoLinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this VnfPkgInfo.


        :param links: The links of this VnfPkgInfo.  # noqa: E501
        :type: VnfPkgInfoLinks
        """
        if links is None:
            print("WARNING: Invalid value for the required field `links`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `links`, must not be `None`")  # noqa: E501

        self._links = links

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfPkgInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfPkgInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
