# coding: utf-8

"""
    SOL005 - VNF Package Management Interface

    SOL005 - VNF Package Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class Vnfd(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'description': 'str',
        'vnf': 'VnfdVnf',
        'metadata': 'object',
        'inputs': 'object',
        'policies': 'list[object]',
        'groups': 'object',
        'basepath': 'str',
        'volume_storages': 'list[object]',
        'vdus': 'list[VnfdVdus]',
        'vls': 'list[object]',
        'cps': 'list[VnfdCps]',
        'vnf_exposed': 'VnfdVnfExposed',
        'graph': 'object',
        'vdu_dependency_details': 'VnfdVduDependencyDetails'
    }

    attribute_map = {
        'description': 'description',
        'vnf': 'vnf',
        'metadata': 'metadata',
        'inputs': 'inputs',
        'policies': 'policies',
        'groups': 'groups',
        'basepath': 'basepath',
        'volume_storages': 'volume_storages',
        'vdus': 'vdus',
        'vls': 'vls',
        'cps': 'cps',
        'vnf_exposed': 'vnf_exposed',
        'graph': 'graph',
        'vdu_dependency_details': 'vduDependencyDetails'
    }

    def __init__(self, description=None, vnf=None, metadata=None, inputs=None, policies=None, groups=None, basepath=None, volume_storages=None, vdus=None, vls=None, cps=None, vnf_exposed=None, graph=None, vdu_dependency_details=None):  # noqa: E501
        """Vnfd - a model defined in Swagger"""  # noqa: E501
        self._description = None
        self._vnf = None
        self._metadata = None
        self._inputs = None
        self._policies = None
        self._groups = None
        self._basepath = None
        self._volume_storages = None
        self._vdus = None
        self._vls = None
        self._cps = None
        self._vnf_exposed = None
        self._graph = None
        self._vdu_dependency_details = None
        self.discriminator = None
        if description is not None:
            self.description = description
        if vnf is not None:
            self.vnf = vnf
        if metadata is not None:
            self.metadata = metadata
        if inputs is not None:
            self.inputs = inputs
        if policies is not None:
            self.policies = policies
        if groups is not None:
            self.groups = groups
        if basepath is not None:
            self.basepath = basepath
        if volume_storages is not None:
            self.volume_storages = volume_storages
        if vdus is not None:
            self.vdus = vdus
        if vls is not None:
            self.vls = vls
        if cps is not None:
            self.cps = cps
        if vnf_exposed is not None:
            self.vnf_exposed = vnf_exposed
        if graph is not None:
            self.graph = graph
        if vdu_dependency_details is not None:
            self.vdu_dependency_details = vdu_dependency_details

    @property
    def description(self):
        """Gets the description of this Vnfd.  # noqa: E501


        :return: The description of this Vnfd.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Vnfd.


        :param description: The description of this Vnfd.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def vnf(self):
        """Gets the vnf of this Vnfd.  # noqa: E501


        :return: The vnf of this Vnfd.  # noqa: E501
        :rtype: VnfdVnf
        """
        return self._vnf

    @vnf.setter
    def vnf(self, vnf):
        """Sets the vnf of this Vnfd.


        :param vnf: The vnf of this Vnfd.  # noqa: E501
        :type: VnfdVnf
        """

        self._vnf = vnf

    @property
    def metadata(self):
        """Gets the metadata of this Vnfd.  # noqa: E501


        :return: The metadata of this Vnfd.  # noqa: E501
        :rtype: object
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this Vnfd.


        :param metadata: The metadata of this Vnfd.  # noqa: E501
        :type: object
        """

        self._metadata = metadata

    @property
    def inputs(self):
        """Gets the inputs of this Vnfd.  # noqa: E501


        :return: The inputs of this Vnfd.  # noqa: E501
        :rtype: object
        """
        return self._inputs

    @inputs.setter
    def inputs(self, inputs):
        """Sets the inputs of this Vnfd.


        :param inputs: The inputs of this Vnfd.  # noqa: E501
        :type: object
        """

        self._inputs = inputs

    @property
    def policies(self):
        """Gets the policies of this Vnfd.  # noqa: E501


        :return: The policies of this Vnfd.  # noqa: E501
        :rtype: list[object]
        """
        return self._policies

    @policies.setter
    def policies(self, policies):
        """Sets the policies of this Vnfd.


        :param policies: The policies of this Vnfd.  # noqa: E501
        :type: list[object]
        """

        self._policies = policies

    @property
    def groups(self):
        """Gets the groups of this Vnfd.  # noqa: E501


        :return: The groups of this Vnfd.  # noqa: E501
        :rtype: object
        """
        return self._groups

    @groups.setter
    def groups(self, groups):
        """Sets the groups of this Vnfd.


        :param groups: The groups of this Vnfd.  # noqa: E501
        :type: object
        """

        self._groups = groups

    @property
    def basepath(self):
        """Gets the basepath of this Vnfd.  # noqa: E501


        :return: The basepath of this Vnfd.  # noqa: E501
        :rtype: str
        """
        return self._basepath

    @basepath.setter
    def basepath(self, basepath):
        """Sets the basepath of this Vnfd.


        :param basepath: The basepath of this Vnfd.  # noqa: E501
        :type: str
        """

        self._basepath = basepath

    @property
    def volume_storages(self):
        """Gets the volume_storages of this Vnfd.  # noqa: E501


        :return: The volume_storages of this Vnfd.  # noqa: E501
        :rtype: list[object]
        """
        return self._volume_storages

    @volume_storages.setter
    def volume_storages(self, volume_storages):
        """Sets the volume_storages of this Vnfd.


        :param volume_storages: The volume_storages of this Vnfd.  # noqa: E501
        :type: list[object]
        """

        self._volume_storages = volume_storages

    @property
    def vdus(self):
        """Gets the vdus of this Vnfd.  # noqa: E501


        :return: The vdus of this Vnfd.  # noqa: E501
        :rtype: list[VnfdVdus]
        """
        return self._vdus

    @vdus.setter
    def vdus(self, vdus):
        """Sets the vdus of this Vnfd.


        :param vdus: The vdus of this Vnfd.  # noqa: E501
        :type: list[VnfdVdus]
        """

        self._vdus = vdus

    @property
    def vls(self):
        """Gets the vls of this Vnfd.  # noqa: E501


        :return: The vls of this Vnfd.  # noqa: E501
        :rtype: list[object]
        """
        return self._vls

    @vls.setter
    def vls(self, vls):
        """Sets the vls of this Vnfd.


        :param vls: The vls of this Vnfd.  # noqa: E501
        :type: list[object]
        """

        self._vls = vls

    @property
    def cps(self):
        """Gets the cps of this Vnfd.  # noqa: E501


        :return: The cps of this Vnfd.  # noqa: E501
        :rtype: list[VnfdCps]
        """
        return self._cps

    @cps.setter
    def cps(self, cps):
        """Sets the cps of this Vnfd.


        :param cps: The cps of this Vnfd.  # noqa: E501
        :type: list[VnfdCps]
        """

        self._cps = cps

    @property
    def vnf_exposed(self):
        """Gets the vnf_exposed of this Vnfd.  # noqa: E501


        :return: The vnf_exposed of this Vnfd.  # noqa: E501
        :rtype: VnfdVnfExposed
        """
        return self._vnf_exposed

    @vnf_exposed.setter
    def vnf_exposed(self, vnf_exposed):
        """Sets the vnf_exposed of this Vnfd.


        :param vnf_exposed: The vnf_exposed of this Vnfd.  # noqa: E501
        :type: VnfdVnfExposed
        """

        self._vnf_exposed = vnf_exposed

    @property
    def graph(self):
        """Gets the graph of this Vnfd.  # noqa: E501


        :return: The graph of this Vnfd.  # noqa: E501
        :rtype: object
        """
        return self._graph

    @graph.setter
    def graph(self, graph):
        """Sets the graph of this Vnfd.


        :param graph: The graph of this Vnfd.  # noqa: E501
        :type: object
        """

        self._graph = graph

    @property
    def vdu_dependency_details(self):
        """Gets the vdu_dependency_details of this Vnfd.  # noqa: E501


        :return: The vdu_dependency_details of this Vnfd.  # noqa: E501
        :rtype: VnfdVduDependencyDetails
        """
        return self._vdu_dependency_details

    @vdu_dependency_details.setter
    def vdu_dependency_details(self, vdu_dependency_details):
        """Sets the vdu_dependency_details of this Vnfd.


        :param vdu_dependency_details: The vdu_dependency_details of this Vnfd.  # noqa: E501
        :type: VnfdVduDependencyDetails
        """

        self._vdu_dependency_details = vdu_dependency_details

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Vnfd, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Vnfd):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
