# coding: utf-8

"""
    SOL005 - VNF Package Management Interface

    SOL005 - VNF Package Management Interface IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to and has not been approved by the ETSI NFV ISG. In case of discrepancies the published ETSI Group Specification takes precedence. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class VnfdVdus(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'vdu_id': 'str',
        'type': 'str',
        'description': 'str',
        'properties': 'VnfdProperties',
        'configurable_properties': 'list[VnfdConfigurableProperties]',
        'virtual_storages': 'list[object]',
        'dependencies': 'list[object]',
        'virtual_compute': 'VnfdVirtualCompute',
        'vls': 'list[object]',
        'cps': 'list[str]',
        'artifacts': 'list[object]'
    }

    attribute_map = {
        'vdu_id': 'vdu_id',
        'type': 'type',
        'description': 'description',
        'properties': 'properties',
        'configurable_properties': 'configurable_properties',
        'virtual_storages': 'virtual_storages',
        'dependencies': 'dependencies',
        'virtual_compute': 'virtual_compute',
        'vls': 'vls',
        'cps': 'cps',
        'artifacts': 'artifacts'
    }

    def __init__(self, vdu_id=None, type=None, description=None, properties=None, configurable_properties=None, virtual_storages=None, dependencies=None, virtual_compute=None, vls=None, cps=None, artifacts=None):  # noqa: E501
        """VnfdVdus - a model defined in Swagger"""  # noqa: E501
        self._vdu_id = None
        self._type = None
        self._description = None
        self._properties = None
        self._configurable_properties = None
        self._virtual_storages = None
        self._dependencies = None
        self._virtual_compute = None
        self._vls = None
        self._cps = None
        self._artifacts = None
        self.discriminator = None
        if vdu_id is not None:
            self.vdu_id = vdu_id
        if type is not None:
            self.type = type
        if description is not None:
            self.description = description
        if properties is not None:
            self.properties = properties
        if configurable_properties is not None:
            self.configurable_properties = configurable_properties
        if virtual_storages is not None:
            self.virtual_storages = virtual_storages
        if dependencies is not None:
            self.dependencies = dependencies
        if virtual_compute is not None:
            self.virtual_compute = virtual_compute
        if vls is not None:
            self.vls = vls
        if cps is not None:
            self.cps = cps
        if artifacts is not None:
            self.artifacts = artifacts

    @property
    def vdu_id(self):
        """Gets the vdu_id of this VnfdVdus.  # noqa: E501


        :return: The vdu_id of this VnfdVdus.  # noqa: E501
        :rtype: str
        """
        return self._vdu_id

    @vdu_id.setter
    def vdu_id(self, vdu_id):
        """Sets the vdu_id of this VnfdVdus.


        :param vdu_id: The vdu_id of this VnfdVdus.  # noqa: E501
        :type: str
        """

        self._vdu_id = vdu_id

    @property
    def type(self):
        """Gets the type of this VnfdVdus.  # noqa: E501


        :return: The type of this VnfdVdus.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this VnfdVdus.


        :param type: The type of this VnfdVdus.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def description(self):
        """Gets the description of this VnfdVdus.  # noqa: E501


        :return: The description of this VnfdVdus.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this VnfdVdus.


        :param description: The description of this VnfdVdus.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def properties(self):
        """Gets the properties of this VnfdVdus.  # noqa: E501


        :return: The properties of this VnfdVdus.  # noqa: E501
        :rtype: VnfdProperties
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this VnfdVdus.


        :param properties: The properties of this VnfdVdus.  # noqa: E501
        :type: VnfdProperties
        """

        self._properties = properties

    @property
    def configurable_properties(self):
        """Gets the configurable_properties of this VnfdVdus.  # noqa: E501


        :return: The configurable_properties of this VnfdVdus.  # noqa: E501
        :rtype: list[VnfdConfigurableProperties]
        """
        return self._configurable_properties

    @configurable_properties.setter
    def configurable_properties(self, configurable_properties):
        """Sets the configurable_properties of this VnfdVdus.


        :param configurable_properties: The configurable_properties of this VnfdVdus.  # noqa: E501
        :type: list[VnfdConfigurableProperties]
        """

        self._configurable_properties = configurable_properties

    @property
    def virtual_storages(self):
        """Gets the virtual_storages of this VnfdVdus.  # noqa: E501


        :return: The virtual_storages of this VnfdVdus.  # noqa: E501
        :rtype: list[object]
        """
        return self._virtual_storages

    @virtual_storages.setter
    def virtual_storages(self, virtual_storages):
        """Sets the virtual_storages of this VnfdVdus.


        :param virtual_storages: The virtual_storages of this VnfdVdus.  # noqa: E501
        :type: list[object]
        """

        self._virtual_storages = virtual_storages

    @property
    def dependencies(self):
        """Gets the dependencies of this VnfdVdus.  # noqa: E501


        :return: The dependencies of this VnfdVdus.  # noqa: E501
        :rtype: list[object]
        """
        return self._dependencies

    @dependencies.setter
    def dependencies(self, dependencies):
        """Sets the dependencies of this VnfdVdus.


        :param dependencies: The dependencies of this VnfdVdus.  # noqa: E501
        :type: list[object]
        """

        self._dependencies = dependencies

    @property
    def virtual_compute(self):
        """Gets the virtual_compute of this VnfdVdus.  # noqa: E501


        :return: The virtual_compute of this VnfdVdus.  # noqa: E501
        :rtype: VnfdVirtualCompute
        """
        return self._virtual_compute

    @virtual_compute.setter
    def virtual_compute(self, virtual_compute):
        """Sets the virtual_compute of this VnfdVdus.


        :param virtual_compute: The virtual_compute of this VnfdVdus.  # noqa: E501
        :type: VnfdVirtualCompute
        """

        self._virtual_compute = virtual_compute

    @property
    def vls(self):
        """Gets the vls of this VnfdVdus.  # noqa: E501


        :return: The vls of this VnfdVdus.  # noqa: E501
        :rtype: list[object]
        """
        return self._vls

    @vls.setter
    def vls(self, vls):
        """Sets the vls of this VnfdVdus.


        :param vls: The vls of this VnfdVdus.  # noqa: E501
        :type: list[object]
        """

        self._vls = vls

    @property
    def cps(self):
        """Gets the cps of this VnfdVdus.  # noqa: E501


        :return: The cps of this VnfdVdus.  # noqa: E501
        :rtype: list[str]
        """
        return self._cps

    @cps.setter
    def cps(self, cps):
        """Sets the cps of this VnfdVdus.


        :param cps: The cps of this VnfdVdus.  # noqa: E501
        :type: list[str]
        """

        self._cps = cps

    @property
    def artifacts(self):
        """Gets the artifacts of this VnfdVdus.  # noqa: E501


        :return: The artifacts of this VnfdVdus.  # noqa: E501
        :rtype: list[object]
        """
        return self._artifacts

    @artifacts.setter
    def artifacts(self, artifacts):
        """Sets the artifacts of this VnfdVdus.


        :param artifacts: The artifacts of this VnfdVdus.  # noqa: E501
        :type: list[object]
        """

        self._artifacts = artifacts

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VnfdVdus, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VnfdVdus):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
