# coding: utf-8

"""
    SOL003 - VNF Performance Management interface

    SOL003 - VNF Performance Management interface  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from tca.vnfpm.api_client import ApiClient
from tca.api.tca_api import TCAApi

class DefaultApi(TCAApi):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_vnfpm_version_info(self, version, **kwargs):  # noqa: E501
        """Retrieve API version information  # noqa: E501

        The GET method reads API version information. This method shall follow the provisions specified in table 4.6.3.3.3.2-1 for request and response data structures, and response codes. URI query parameters are not supported.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_vnfpm_version_info(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)


        :return: ApiVersionInformation
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_vnfpm_version_info_with_http_info(version, **kwargs)  # noqa: E501
        else:
            (data) = self.get_vnfpm_version_info_with_http_info(version, **kwargs)  # noqa: E501
            return data

    def get_vnfpm_version_info_with_http_info(self, version, **kwargs):  # noqa: E501
        """Retrieve API version information  # noqa: E501

        The GET method reads API version information. This method shall follow the provisions specified in table 4.6.3.3.3.2-1 for request and response data structures, and response codes. URI query parameters are not supported.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_vnfpm_version_info_with_http_info(version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version: Version of the API requested to use when responding to this request.  (required)


        :return: ApiVersionInformation
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_vnfpm_version_info" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `get_vnfpm_version_info`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/api_versions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiVersionInformation',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def pm_jobs_get(self, accept, version, **kwargs):  # noqa: E501
        """pm_jobs_get  # noqa: E501

        Query PM Job. The API consumer can use this method to retrieve information about PM jobs. This method shall follow the provisions specified in the tables 6.4.2.3.2-1 and 6.4.2.3.2-2 for URI query parameters, request and response data structures, and response codes. The API consumer can use this method to retrieve information about PM jobs.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pm_jobs_get(accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV-SOL 013. The VNFM shall support receiving this parameter as part of the  URI query string. The NFVO may supply this parameter.  All attribute names that appear in the PmJob and in data  types referenced from it shall be supported by the VNFM in the  filter expression. 
        :param str all_fields: Include all complex attributes in the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM shall support this parameter. 
        :param str fields: Complex attributes to be included into the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM should support this parameter. 
        :param str exclude_fields: Complex attributes to be excluded from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM should support this parameter. 
        :param str exclude_default: Indicates to exclude the following complex attributes from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM shall support this parameter. The following attributes shall be excluded from the PmJob structure in the response body if this parameter is provided, or none of the parameters \"all_fields\", \"fields\", \"exclude_fields\", \"exclude_default\" are provided: - reports 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the  VNFM if the VNFM supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV-SOL 013 for this resource. 


        :return: list[PmJob]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.pm_jobs_get_with_http_info(accept, version, **kwargs)  # noqa: E501
        else:
            (data) = self.pm_jobs_get_with_http_info(accept, version, **kwargs)  # noqa: E501
            return data

    def pm_jobs_get_with_http_info(self, accept, version, **kwargs):  # noqa: E501
        """pm_jobs_get  # noqa: E501

        Query PM Job. The API consumer can use this method to retrieve information about PM jobs. This method shall follow the provisions specified in the tables 6.4.2.3.2-1 and 6.4.2.3.2-2 for URI query parameters, request and response data structures, and response codes. The API consumer can use this method to retrieve information about PM jobs.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pm_jobs_get_with_http_info(accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV-SOL 013. The VNFM shall support receiving this parameter as part of the  URI query string. The NFVO may supply this parameter.  All attribute names that appear in the PmJob and in data  types referenced from it shall be supported by the VNFM in the  filter expression. 
        :param str all_fields: Include all complex attributes in the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM shall support this parameter. 
        :param str fields: Complex attributes to be included into the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM should support this parameter. 
        :param str exclude_fields: Complex attributes to be excluded from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM should support this parameter. 
        :param str exclude_default: Indicates to exclude the following complex attributes from the response. See clause 5.3 of ETSI GS NFV-SOL 013 for details. The VNFM shall support this parameter. The following attributes shall be excluded from the PmJob structure in the response body if this parameter is provided, or none of the parameters \"all_fields\", \"fields\", \"exclude_fields\", \"exclude_default\" are provided: - reports 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the  VNFM if the VNFM supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV-SOL 013 for this resource. 


        :return: list[PmJob]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['accept', 'version', 'authorization', 'filter', 'all_fields', 'fields', 'exclude_fields', 'exclude_default', 'nextpage_opaque_marker']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method pm_jobs_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `pm_jobs_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `pm_jobs_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'all_fields' in params:
            query_params.append(('all_fields', params['all_fields']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
        if 'exclude_fields' in params:
            query_params.append(('exclude_fields', params['exclude_fields']))  # noqa: E501
        if 'exclude_default' in params:
            query_params.append(('exclude_default', params['exclude_default']))  # noqa: E501
        if 'nextpage_opaque_marker' in params:
            query_params.append(('nextpage_opaque_marker', params['nextpage_opaque_marker']))  # noqa: E501

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/pm_jobs', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[PmJob]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def pm_jobs_pm_job_id_delete(self, pm_job_id, version, **kwargs):  # noqa: E501
        """pm_jobs_pm_job_id_delete  # noqa: E501

        Delete PM Job. This method terminates an individual PM job. This method shall follow the provisions specified in the tables 6.4.3.3.5-1 and 6.4.3.3.5-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, the \"Individual PM job\" resource shall not exist any longer.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pm_jobs_pm_job_id_delete(pm_job_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str pm_job_id: Identifier of the PM job. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual PM job\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.pm_jobs_pm_job_id_delete_with_http_info(pm_job_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.pm_jobs_pm_job_id_delete_with_http_info(pm_job_id, version, **kwargs)  # noqa: E501
            return data

    def pm_jobs_pm_job_id_delete_with_http_info(self, pm_job_id, version, **kwargs):  # noqa: E501
        """pm_jobs_pm_job_id_delete  # noqa: E501

        Delete PM Job. This method terminates an individual PM job. This method shall follow the provisions specified in the tables 6.4.3.3.5-1 and 6.4.3.3.5-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, the \"Individual PM job\" resource shall not exist any longer.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pm_jobs_pm_job_id_delete_with_http_info(pm_job_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str pm_job_id: Identifier of the PM job. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual PM job\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['pm_job_id', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method pm_jobs_pm_job_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'pm_job_id' is set
        if ('pm_job_id' not in params or
                params['pm_job_id'] is None):
            raise ValueError("Missing the required parameter `pm_job_id` when calling `pm_jobs_pm_job_id_delete`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `pm_jobs_pm_job_id_delete`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'pm_job_id' in params:
            path_params['pmJobId'] = params['pm_job_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/pm_jobs/{pmJobId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def pm_jobs_pm_job_id_get(self, pm_job_id, accept, version, **kwargs):  # noqa: E501
        """pm_jobs_pm_job_id_get  # noqa: E501

        Query PM Job. The API consumer can use this method for reading an individual PM job. This method shall follow the provisions specified in the tables 6.4.3.3.2-1 and 6.4.3.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pm_jobs_pm_job_id_get(pm_job_id, accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str pm_job_id: Identifier of the PM job. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual PM job\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: PmJob
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.pm_jobs_pm_job_id_get_with_http_info(pm_job_id, accept, version, **kwargs)  # noqa: E501
        else:
            (data) = self.pm_jobs_pm_job_id_get_with_http_info(pm_job_id, accept, version, **kwargs)  # noqa: E501
            return data

    def pm_jobs_pm_job_id_get_with_http_info(self, pm_job_id, accept, version, **kwargs):  # noqa: E501
        """pm_jobs_pm_job_id_get  # noqa: E501

        Query PM Job. The API consumer can use this method for reading an individual PM job. This method shall follow the provisions specified in the tables 6.4.3.3.2-1 and 6.4.3.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pm_jobs_pm_job_id_get_with_http_info(pm_job_id, accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str pm_job_id: Identifier of the PM job. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual PM job\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: PmJob
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['pm_job_id', 'accept', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method pm_jobs_pm_job_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'pm_job_id' is set
        if ('pm_job_id' not in params or
                params['pm_job_id'] is None):
            raise ValueError("Missing the required parameter `pm_job_id` when calling `pm_jobs_pm_job_id_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `pm_jobs_pm_job_id_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `pm_jobs_pm_job_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'pm_job_id' in params:
            path_params['pmJobId'] = params['pm_job_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/pm_jobs/{pmJobId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PmJob',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def pm_jobs_pm_job_id_patch(self, pm_job_id, version, **kwargs):  # noqa: E501
        """pm_jobs_pm_job_id_patch  # noqa: E501

        This method allows to modify an \"individual PM job\" resource. This method shall follow the provisions specified in the tables 6.4.3.3.4-1 and 6.4.3.3.4-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pm_jobs_pm_job_id_patch(pm_job_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str pm_job_id: Identifier of the PM job. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual PM job\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: PmJobModifications
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.pm_jobs_pm_job_id_patch_with_http_info(pm_job_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.pm_jobs_pm_job_id_patch_with_http_info(pm_job_id, version, **kwargs)  # noqa: E501
            return data

    def pm_jobs_pm_job_id_patch_with_http_info(self, pm_job_id, version, **kwargs):  # noqa: E501
        """pm_jobs_pm_job_id_patch  # noqa: E501

        This method allows to modify an \"individual PM job\" resource. This method shall follow the provisions specified in the tables 6.4.3.3.4-1 and 6.4.3.3.4-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pm_jobs_pm_job_id_patch_with_http_info(pm_job_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str pm_job_id: Identifier of the PM job. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual PM job\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: PmJobModifications
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['pm_job_id', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method pm_jobs_pm_job_id_patch" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'pm_job_id' is set
        if ('pm_job_id' not in params or
                params['pm_job_id'] is None):
            raise ValueError("Missing the required parameter `pm_job_id` when calling `pm_jobs_pm_job_id_patch`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `pm_jobs_pm_job_id_patch`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'pm_job_id' in params:
            path_params['pmJobId'] = params['pm_job_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/pm_jobs/{pmJobId}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PmJobModifications',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def pm_jobs_pm_job_id_reports_report_id_get(self, pm_job_id, report_id, accept, version, **kwargs):  # noqa: E501
        """pm_jobs_pm_job_id_reports_report_id_get  # noqa: E501

        The API consumer can use this method for reading an individual performance report. This method shall follow the provisions specified in the tables 6.4.4.3.2-1 and 6.4.4.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pm_jobs_pm_job_id_reports_report_id_get(pm_job_id, report_id, accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str pm_job_id: Identifier of the PM job.  (required)
        :param str report_id: Identifier of the performance report.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: PerformanceReport
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.pm_jobs_pm_job_id_reports_report_id_get_with_http_info(pm_job_id, report_id, accept, version, **kwargs)  # noqa: E501
        else:
            (data) = self.pm_jobs_pm_job_id_reports_report_id_get_with_http_info(pm_job_id, report_id, accept, version, **kwargs)  # noqa: E501
            return data

    def pm_jobs_pm_job_id_reports_report_id_get_with_http_info(self, pm_job_id, report_id, accept, version, **kwargs):  # noqa: E501
        """pm_jobs_pm_job_id_reports_report_id_get  # noqa: E501

        The API consumer can use this method for reading an individual performance report. This method shall follow the provisions specified in the tables 6.4.4.3.2-1 and 6.4.4.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pm_jobs_pm_job_id_reports_report_id_get_with_http_info(pm_job_id, report_id, accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str pm_job_id: Identifier of the PM job.  (required)
        :param str report_id: Identifier of the performance report.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: PerformanceReport
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['pm_job_id', 'report_id', 'accept', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method pm_jobs_pm_job_id_reports_report_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'pm_job_id' is set
        if ('pm_job_id' not in params or
                params['pm_job_id'] is None):
            raise ValueError("Missing the required parameter `pm_job_id` when calling `pm_jobs_pm_job_id_reports_report_id_get`")  # noqa: E501
        # verify the required parameter 'report_id' is set
        if ('report_id' not in params or
                params['report_id'] is None):
            raise ValueError("Missing the required parameter `report_id` when calling `pm_jobs_pm_job_id_reports_report_id_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `pm_jobs_pm_job_id_reports_report_id_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `pm_jobs_pm_job_id_reports_report_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'pm_job_id' in params:
            path_params['pmJobId'] = params['pm_job_id']  # noqa: E501
        if 'report_id' in params:
            path_params['reportId'] = params['report_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/pm_jobs/{pmJobId}/reports/{reportId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PerformanceReport',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def pm_jobs_post(self, body, accept, content_type, version, **kwargs):  # noqa: E501
        """pm_jobs_post  # noqa: E501

        Create PM Job. The POST method creates a PM job. This method shall follow the provisions specified in the tables 6.4.2.3.1-1 and 6.4.2.3.1-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, a new \"Individual PM job\" resource as defined in clause 6.4.3 shall have been created.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pm_jobs_post(body, accept, content_type, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreatePmJobRequest body: The VNF creation parameters (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: PmJob
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.pm_jobs_post_with_http_info(body, accept, content_type, version, **kwargs)  # noqa: E501
        else:
            (data) = self.pm_jobs_post_with_http_info(body, accept, content_type, version, **kwargs)  # noqa: E501
            return data

    def pm_jobs_post_with_http_info(self, body, accept, content_type, version, **kwargs):  # noqa: E501
        """pm_jobs_post  # noqa: E501

        Create PM Job. The POST method creates a PM job. This method shall follow the provisions specified in the tables 6.4.2.3.1-1 and 6.4.2.3.1-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, a new \"Individual PM job\" resource as defined in clause 6.4.3 shall have been created.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.pm_jobs_post_with_http_info(body, accept, content_type, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreatePmJobRequest body: The VNF creation parameters (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: PmJob
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method pm_jobs_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `pm_jobs_post`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `pm_jobs_post`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `pm_jobs_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `pm_jobs_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/pm_jobs', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PmJob',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def thresholds_get(self, accept, version, **kwargs):  # noqa: E501
        """thresholds_get  # noqa: E501

        Query Threshold. The API consumer can use this method to query information about thresholds. This method shall follow the provisions specified in the tables 6.4.5.3.2-1 and 6.4.5.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.thresholds_get(accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV-SOL 013. The VNFM shall support receiving this parameter as part of the URI query string. The NFVO may supply this parameter. All attribute names that appear in the Thresholds data type and in data types referenced from it shall be supported by the VNFM in the filter expression. 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the VNFM if the VNFM supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV-SOL 013 for this resource. 


        :return: list[Threshold]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.thresholds_get_with_http_info(accept, version, **kwargs)  # noqa: E501
        else:
            (data) = self.thresholds_get_with_http_info(accept, version, **kwargs)  # noqa: E501
            return data

    def thresholds_get_with_http_info(self, accept, version, **kwargs):  # noqa: E501
        """thresholds_get  # noqa: E501

        Query Threshold. The API consumer can use this method to query information about thresholds. This method shall follow the provisions specified in the tables 6.4.5.3.2-1 and 6.4.5.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.thresholds_get_with_http_info(accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 
        :param str filter: Attribute-based filtering expression according to clause 5.2 of ETSI GS NFV-SOL 013. The VNFM shall support receiving this parameter as part of the URI query string. The NFVO may supply this parameter. All attribute names that appear in the Thresholds data type and in data types referenced from it shall be supported by the VNFM in the filter expression. 
        :param str nextpage_opaque_marker: Marker to obtain the next page of a paged response. Shall be supported by the VNFM if the VNFM supports alternative 2 (paging) according to clause 5.4.2.1 of ETSI GS NFV-SOL 013 for this resource. 


        :return: list[Threshold]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['accept', 'version', 'authorization', 'filter', 'nextpage_opaque_marker']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method thresholds_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `thresholds_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `thresholds_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'nextpage_opaque_marker' in params:
            query_params.append(('nextpage_opaque_marker', params['nextpage_opaque_marker']))  # noqa: E501

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/thresholds', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[Threshold]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def thresholds_post(self, body, accept, content_type, version, **kwargs):  # noqa: E501
        """thresholds_post  # noqa: E501

        Create Threshold. The POST method can be used by the API consumer to create a threshold. This method shall follow the provisions specified in the tables 6.4.5.3.1-1 and 6.4.5.3.1-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, a new \"Individual threshold\" resource as defined in clause 6.4.6 shall have been created.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.thresholds_post(body, accept, content_type, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateThresholdRequest body: Request parameters to create a threshold resource.
 (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: Threshold
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.thresholds_post_with_http_info(body, accept, content_type, version, **kwargs)  # noqa: E501
        else:
            (data) = self.thresholds_post_with_http_info(body, accept, content_type, version, **kwargs)  # noqa: E501
            return data

    def thresholds_post_with_http_info(self, body, accept, content_type, version, **kwargs):  # noqa: E501
        """thresholds_post  # noqa: E501

        Create Threshold. The POST method can be used by the API consumer to create a threshold. This method shall follow the provisions specified in the tables 6.4.5.3.1-1 and 6.4.5.3.1-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, a new \"Individual threshold\" resource as defined in clause 6.4.6 shall have been created.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.thresholds_post_with_http_info(body, accept, content_type, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateThresholdRequest body: Request parameters to create a threshold resource.
 (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str content_type: The MIME type of the body of the request. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: Threshold
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'accept', 'content_type', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method thresholds_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `thresholds_post`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `thresholds_post`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `thresholds_post`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `thresholds_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/thresholds', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Threshold',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def thresholds_threshold_id_delete(self, threshold_id, version, **kwargs):  # noqa: E501
        """thresholds_threshold_id_delete  # noqa: E501

        Delete Threshold. This method allows to delete a threshold. This method shall follow the provisions specified in the tables 6.4.6.3.5-1 and 6.4.6.3.5-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, the \"Individual threshold\" resource shall not exist any longer.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.thresholds_threshold_id_delete(threshold_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str threshold_id: Identifier of the threshold. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual threshold\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.thresholds_threshold_id_delete_with_http_info(threshold_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.thresholds_threshold_id_delete_with_http_info(threshold_id, version, **kwargs)  # noqa: E501
            return data

    def thresholds_threshold_id_delete_with_http_info(self, threshold_id, version, **kwargs):  # noqa: E501
        """thresholds_threshold_id_delete  # noqa: E501

        Delete Threshold. This method allows to delete a threshold. This method shall follow the provisions specified in the tables 6.4.6.3.5-1 and 6.4.6.3.5-2 for URI query parameters, request and response data structures, and response codes. As the result of successfully executing this method, the \"Individual threshold\" resource shall not exist any longer.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.thresholds_threshold_id_delete_with_http_info(threshold_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str threshold_id: Identifier of the threshold. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual threshold\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['threshold_id', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method thresholds_threshold_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'threshold_id' is set
        if ('threshold_id' not in params or
                params['threshold_id'] is None):
            raise ValueError("Missing the required parameter `threshold_id` when calling `thresholds_threshold_id_delete`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `thresholds_threshold_id_delete`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'threshold_id' in params:
            path_params['thresholdId'] = params['threshold_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/thresholds/{thresholdId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def thresholds_threshold_id_get(self, threshold_id, accept, version, **kwargs):  # noqa: E501
        """thresholds_threshold_id_get  # noqa: E501

        Query Threshold. The API consumer can use this method for reading an individual threshold This method shall follow the provisions specified in the tables 6.4.6.3.2-1 and 6.4.6.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.thresholds_threshold_id_get(threshold_id, accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str threshold_id: Identifier of the threshold. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual threshold\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: Threshold
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.thresholds_threshold_id_get_with_http_info(threshold_id, accept, version, **kwargs)  # noqa: E501
        else:
            (data) = self.thresholds_threshold_id_get_with_http_info(threshold_id, accept, version, **kwargs)  # noqa: E501
            return data

    def thresholds_threshold_id_get_with_http_info(self, threshold_id, accept, version, **kwargs):  # noqa: E501
        """thresholds_threshold_id_get  # noqa: E501

        Query Threshold. The API consumer can use this method for reading an individual threshold This method shall follow the provisions specified in the tables 6.4.6.3.2-1 and 6.4.6.3.2-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.thresholds_threshold_id_get_with_http_info(threshold_id, accept, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str threshold_id: Identifier of the threshold. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual threshold\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str accept: Content-Types that are acceptable for the response. Reference: IETF RFC 7231  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: Threshold
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['threshold_id', 'accept', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method thresholds_threshold_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'threshold_id' is set
        if ('threshold_id' not in params or
                params['threshold_id'] is None):
            raise ValueError("Missing the required parameter `threshold_id` when calling `thresholds_threshold_id_get`")  # noqa: E501
        # verify the required parameter 'accept' is set
        if ('accept' not in params or
                params['accept'] is None):
            raise ValueError("Missing the required parameter `accept` when calling `thresholds_threshold_id_get`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `thresholds_threshold_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'threshold_id' in params:
            path_params['thresholdId'] = params['threshold_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept' in params:
            header_params['Accept'] = params['accept']  # noqa: E501
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/thresholds/{thresholdId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Threshold',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def thresholds_threshold_id_patch(self, threshold_id, version, **kwargs):  # noqa: E501
        """thresholds_threshold_id_patch  # noqa: E501

        This method allows to modify an \"Individual threshold\" resource. This method shall follow the provisions specified in the tables 6.4.6.3.4-1 and 6.4.6.3.4-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.thresholds_threshold_id_patch(threshold_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str threshold_id: Identifier of the threshold. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual threshold\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: ThresholdModifications
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.thresholds_threshold_id_patch_with_http_info(threshold_id, version, **kwargs)  # noqa: E501
        else:
            (data) = self.thresholds_threshold_id_patch_with_http_info(threshold_id, version, **kwargs)  # noqa: E501
            return data

    def thresholds_threshold_id_patch_with_http_info(self, threshold_id, version, **kwargs):  # noqa: E501
        """thresholds_threshold_id_patch  # noqa: E501

        This method allows to modify an \"Individual threshold\" resource. This method shall follow the provisions specified in the tables 6.4.6.3.4-1 and 6.4.6.3.4-2 for URI query parameters, request and response data structures, and response codes.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.thresholds_threshold_id_patch_with_http_info(threshold_id, version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str threshold_id: Identifier of the threshold. This identifier can be retrieved from the resource referenced by the \"Location\" HTTP header in the response to a POST request creating a new \"Individual threshold\" resource. It can also be retrieved from the \"id\" attribute in the payload body of that response.  (required)
        :param str version: Version of the API requested to use when responding to this request.  (required)
        :param str authorization: The authorization token for the request. Reference: IETF RFC 7235 


        :return: ThresholdModifications
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['threshold_id', 'version', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method thresholds_threshold_id_patch" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'threshold_id' is set
        if ('threshold_id' not in params or
                params['threshold_id'] is None):
            raise ValueError("Missing the required parameter `threshold_id` when calling `thresholds_threshold_id_patch`")  # noqa: E501
        # verify the required parameter 'version' is set
        if ('version' not in params or
                params['version'] is None):
            raise ValueError("Missing the required parameter `version` when calling `thresholds_threshold_id_patch`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'threshold_id' in params:
            path_params['thresholdId'] = params['threshold_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501
        if 'version' in params:
            header_params['Version'] = params['version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['application/json'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/thresholds/{thresholdId}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ThresholdModifications',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
