# coding: utf-8

"""
    SOL003 - VNF Performance Management interface

    SOL003 - VNF Performance Management interface  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class PerformanceReportEntries(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'object_type': 'str',
        'object_instance_id': 'Identifier',
        'sub_object_instance_id': 'IdentifierInVnf',
        'performance_metric': 'str',
        'performance_values': 'list[PerformanceReportPerformanceValues]'
    }

    attribute_map = {
        'object_type': 'objectType',
        'object_instance_id': 'objectInstanceId',
        'sub_object_instance_id': 'subObjectInstanceId',
        'performance_metric': 'performanceMetric',
        'performance_values': 'performanceValues'
    }

    def __init__(self, object_type=None, object_instance_id=None, sub_object_instance_id=None, performance_metric=None, performance_values=None):  # noqa: E501
        """PerformanceReportEntries - a model defined in Swagger"""  # noqa: E501
        self._object_type = None
        self._object_instance_id = None
        self._sub_object_instance_id = None
        self._performance_metric = None
        self._performance_values = None
        self.discriminator = None
        self.object_type = object_type
        self.object_instance_id = object_instance_id
        if sub_object_instance_id is not None:
            self.sub_object_instance_id = sub_object_instance_id
        self.performance_metric = performance_metric
        if performance_values is not None:
            self.performance_values = performance_values

    @property
    def object_type(self):
        """Gets the object_type of this PerformanceReportEntries.  # noqa: E501

        Type of the measured object. The applicable measured object type for a measurement is defined in clause 7.2 of ETSI GS NFV-IFA 027.   # noqa: E501

        :return: The object_type of this PerformanceReportEntries.  # noqa: E501
        :rtype: str
        """
        return self._object_type

    @object_type.setter
    def object_type(self, object_type):
        """Sets the object_type of this PerformanceReportEntries.

        Type of the measured object. The applicable measured object type for a measurement is defined in clause 7.2 of ETSI GS NFV-IFA 027.   # noqa: E501

        :param object_type: The object_type of this PerformanceReportEntries.  # noqa: E501
        :type: str
        """
        if object_type is None:
            print("WARNING: Invalid value for the required field `object_type`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `object_type`, must not be `None`")  # noqa: E501

        self._object_type = object_type

    @property
    def object_instance_id(self):
        """Gets the object_instance_id of this PerformanceReportEntries.  # noqa: E501


        :return: The object_instance_id of this PerformanceReportEntries.  # noqa: E501
        :rtype: Identifier
        """
        return self._object_instance_id

    @object_instance_id.setter
    def object_instance_id(self, object_instance_id):
        """Sets the object_instance_id of this PerformanceReportEntries.


        :param object_instance_id: The object_instance_id of this PerformanceReportEntries.  # noqa: E501
        :type: Identifier
        """
        if object_instance_id is None:
            print("WARNING: Invalid value for the required field `object_instance_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `object_instance_id`, must not be `None`")  # noqa: E501

        self._object_instance_id = object_instance_id

    @property
    def sub_object_instance_id(self):
        """Gets the sub_object_instance_id of this PerformanceReportEntries.  # noqa: E501


        :return: The sub_object_instance_id of this PerformanceReportEntries.  # noqa: E501
        :rtype: IdentifierInVnf
        """
        return self._sub_object_instance_id

    @sub_object_instance_id.setter
    def sub_object_instance_id(self, sub_object_instance_id):
        """Sets the sub_object_instance_id of this PerformanceReportEntries.


        :param sub_object_instance_id: The sub_object_instance_id of this PerformanceReportEntries.  # noqa: E501
        :type: IdentifierInVnf
        """

        self._sub_object_instance_id = sub_object_instance_id

    @property
    def performance_metric(self):
        """Gets the performance_metric of this PerformanceReportEntries.  # noqa: E501

        Name of the metric collected. This attribute shall contain the related \"Measurement Name\" value as defined in clause 7.2 of ETSI GS NFV-IFA 027.   # noqa: E501

        :return: The performance_metric of this PerformanceReportEntries.  # noqa: E501
        :rtype: str
        """
        return self._performance_metric

    @performance_metric.setter
    def performance_metric(self, performance_metric):
        """Sets the performance_metric of this PerformanceReportEntries.

        Name of the metric collected. This attribute shall contain the related \"Measurement Name\" value as defined in clause 7.2 of ETSI GS NFV-IFA 027.   # noqa: E501

        :param performance_metric: The performance_metric of this PerformanceReportEntries.  # noqa: E501
        :type: str
        """
        if performance_metric is None:
            print("WARNING: Invalid value for the required field `performance_metric`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `performance_metric`, must not be `None`")  # noqa: E501

        self._performance_metric = performance_metric

    @property
    def performance_values(self):
        """Gets the performance_values of this PerformanceReportEntries.  # noqa: E501

        List of performance values with associated timestamp.   # noqa: E501

        :return: The performance_values of this PerformanceReportEntries.  # noqa: E501
        :rtype: list[PerformanceReportPerformanceValues]
        """
        return self._performance_values

    @performance_values.setter
    def performance_values(self, performance_values):
        """Sets the performance_values of this PerformanceReportEntries.

        List of performance values with associated timestamp.   # noqa: E501

        :param performance_values: The performance_values of this PerformanceReportEntries.  # noqa: E501
        :type: list[PerformanceReportPerformanceValues]
        """

        self._performance_values = performance_values

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PerformanceReportEntries, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PerformanceReportEntries):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
