# coding: utf-8

"""
    SOL003 - VNF Performance Management interface

    SOL003 - VNF Performance Management interface  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class PmJobCriteria(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'performance_metric': 'list[str]',
        'performance_metric_group': 'list[str]',
        'collection_period': 'int',
        'reporting_period': 'int',
        'reporting_boundary': 'datetime'
    }

    attribute_map = {
        'performance_metric': 'performanceMetric',
        'performance_metric_group': 'performanceMetricGroup',
        'collection_period': 'collectionPeriod',
        'reporting_period': 'reportingPeriod',
        'reporting_boundary': 'reportingBoundary'
    }

    def __init__(self, performance_metric=None, performance_metric_group=None, collection_period=None, reporting_period=None, reporting_boundary=None):  # noqa: E501
        """PmJobCriteria - a model defined in Swagger"""  # noqa: E501
        self._performance_metric = None
        self._performance_metric_group = None
        self._collection_period = None
        self._reporting_period = None
        self._reporting_boundary = None
        self.discriminator = None
        if performance_metric is not None:
            self.performance_metric = performance_metric
        if performance_metric_group is not None:
            self.performance_metric_group = performance_metric_group
        self.collection_period = collection_period
        self.reporting_period = reporting_period
        if reporting_boundary is not None:
            self.reporting_boundary = reporting_boundary

    @property
    def performance_metric(self):
        """Gets the performance_metric of this PmJobCriteria.  # noqa: E501

        This defines the types of performance metrics for the specified object instances. Valid values are specified as \"Measurement Name\" values in clause 7.2 of ETSI GS NFV-IFA 027. At least one of the two attributes (performance metric or group) shall be present.   # noqa: E501

        :return: The performance_metric of this PmJobCriteria.  # noqa: E501
        :rtype: list[str]
        """
        return self._performance_metric

    @performance_metric.setter
    def performance_metric(self, performance_metric):
        """Sets the performance_metric of this PmJobCriteria.

        This defines the types of performance metrics for the specified object instances. Valid values are specified as \"Measurement Name\" values in clause 7.2 of ETSI GS NFV-IFA 027. At least one of the two attributes (performance metric or group) shall be present.   # noqa: E501

        :param performance_metric: The performance_metric of this PmJobCriteria.  # noqa: E501
        :type: list[str]
        """

        self._performance_metric = performance_metric

    @property
    def performance_metric_group(self):
        """Gets the performance_metric_group of this PmJobCriteria.  # noqa: E501

        Group of performance metrics. A metric group is a pre-defined list of metrics, known to the producer that it can decompose to individual metrics. Valid values are specified as \"Measurement Group\" values in clause 7.2 of ETSI GS NFV-IFA 027. At least one of the two attributes (performance metric or group) shall be present.   # noqa: E501

        :return: The performance_metric_group of this PmJobCriteria.  # noqa: E501
        :rtype: list[str]
        """
        return self._performance_metric_group

    @performance_metric_group.setter
    def performance_metric_group(self, performance_metric_group):
        """Sets the performance_metric_group of this PmJobCriteria.

        Group of performance metrics. A metric group is a pre-defined list of metrics, known to the producer that it can decompose to individual metrics. Valid values are specified as \"Measurement Group\" values in clause 7.2 of ETSI GS NFV-IFA 027. At least one of the two attributes (performance metric or group) shall be present.   # noqa: E501

        :param performance_metric_group: The performance_metric_group of this PmJobCriteria.  # noqa: E501
        :type: list[str]
        """

        self._performance_metric_group = performance_metric_group

    @property
    def collection_period(self):
        """Gets the collection_period of this PmJobCriteria.  # noqa: E501

        Specifies the periodicity at which the producer will collect performance information. The unit shall be seconds. At the end of each reportingPeriod, the producer will inform the consumer about availability of the performance data collected for each completed collection period during this reportingPeriod. The reportingPeriod should be equal to or a multiple of the collectionPeriod. In the latter case, the performance data for the collection periods within one reporting period are reported together.   # noqa: E501

        :return: The collection_period of this PmJobCriteria.  # noqa: E501
        :rtype: int
        """
        return self._collection_period

    @collection_period.setter
    def collection_period(self, collection_period):
        """Sets the collection_period of this PmJobCriteria.

        Specifies the periodicity at which the producer will collect performance information. The unit shall be seconds. At the end of each reportingPeriod, the producer will inform the consumer about availability of the performance data collected for each completed collection period during this reportingPeriod. The reportingPeriod should be equal to or a multiple of the collectionPeriod. In the latter case, the performance data for the collection periods within one reporting period are reported together.   # noqa: E501

        :param collection_period: The collection_period of this PmJobCriteria.  # noqa: E501
        :type: int
        """
        if collection_period is None:
            print("WARNING: Invalid value for the required field `collection_period`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `collection_period`, must not be `None`")  # noqa: E501

        self._collection_period = collection_period

    @property
    def reporting_period(self):
        """Gets the reporting_period of this PmJobCriteria.  # noqa: E501

        Specifies the periodicity at which the producer will report to the consumer. about performance information. The unit shall be seconds. At the end of each reportingPeriod, the producer will inform the consumer about availability of the performance data collected for each completed collection period during this reportingPeriod. The reportingPeriod should be equal to or a multiple of the collectionPeriod. In the latter case, the performance data for the collection periods within one reporting period are reported together.   # noqa: E501

        :return: The reporting_period of this PmJobCriteria.  # noqa: E501
        :rtype: int
        """
        return self._reporting_period

    @reporting_period.setter
    def reporting_period(self, reporting_period):
        """Sets the reporting_period of this PmJobCriteria.

        Specifies the periodicity at which the producer will report to the consumer. about performance information. The unit shall be seconds. At the end of each reportingPeriod, the producer will inform the consumer about availability of the performance data collected for each completed collection period during this reportingPeriod. The reportingPeriod should be equal to or a multiple of the collectionPeriod. In the latter case, the performance data for the collection periods within one reporting period are reported together.   # noqa: E501

        :param reporting_period: The reporting_period of this PmJobCriteria.  # noqa: E501
        :type: int
        """
        if reporting_period is None:
            print("WARNING: Invalid value for the required field `reporting_period`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `reporting_period`, must not be `None`")  # noqa: E501

        self._reporting_period = reporting_period

    @property
    def reporting_boundary(self):
        """Gets the reporting_boundary of this PmJobCriteria.  # noqa: E501


        :return: The reporting_boundary of this PmJobCriteria.  # noqa: E501
        :rtype: datetime
        """
        return self._reporting_boundary

    @reporting_boundary.setter
    def reporting_boundary(self, reporting_boundary):
        """Sets the reporting_boundary of this PmJobCriteria.


        :param reporting_boundary: The reporting_boundary of this PmJobCriteria.  # noqa: E501
        :type: datetime
        """

        self._reporting_boundary = reporting_boundary

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PmJobCriteria, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PmJobCriteria):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
