# coding: utf-8

"""
    SOL003 - VNF Performance Management interface

    SOL003 - VNF Performance Management interface  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class PmJobReports(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'href': 'str',
        'ready_time': 'datetime',
        'expiry_time': 'datetime',
        'file_size': 'int'
    }

    attribute_map = {
        'href': 'href',
        'ready_time': 'readyTime',
        'expiry_time': 'expiryTime',
        'file_size': 'fileSize'
    }

    def __init__(self, href=None, ready_time=None, expiry_time=None, file_size=None):  # noqa: E501
        """PmJobReports - a model defined in Swagger"""  # noqa: E501
        self._href = None
        self._ready_time = None
        self._expiry_time = None
        self._file_size = None
        self.discriminator = None
        self.href = href
        self.ready_time = ready_time
        if expiry_time is not None:
            self.expiry_time = expiry_time
        if file_size is not None:
            self.file_size = file_size

    @property
    def href(self):
        """Gets the href of this PmJobReports.  # noqa: E501

        The URI where the report can be obtained.   # noqa: E501

        :return: The href of this PmJobReports.  # noqa: E501
        :rtype: str
        """
        return self._href

    @href.setter
    def href(self, href):
        """Sets the href of this PmJobReports.

        The URI where the report can be obtained.   # noqa: E501

        :param href: The href of this PmJobReports.  # noqa: E501
        :type: str
        """
        if href is None:
            print("WARNING: Invalid value for the required field `href`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `href`, must not be `None`")  # noqa: E501

        self._href = href

    @property
    def ready_time(self):
        """Gets the ready_time of this PmJobReports.  # noqa: E501


        :return: The ready_time of this PmJobReports.  # noqa: E501
        :rtype: datetime
        """
        return self._ready_time

    @ready_time.setter
    def ready_time(self, ready_time):
        """Sets the ready_time of this PmJobReports.


        :param ready_time: The ready_time of this PmJobReports.  # noqa: E501
        :type: datetime
        """
        if ready_time is None:
            print("WARNING: Invalid value for the required field `ready_time`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `ready_time`, must not be `None`")  # noqa: E501

        self._ready_time = ready_time

    @property
    def expiry_time(self):
        """Gets the expiry_time of this PmJobReports.  # noqa: E501


        :return: The expiry_time of this PmJobReports.  # noqa: E501
        :rtype: datetime
        """
        return self._expiry_time

    @expiry_time.setter
    def expiry_time(self, expiry_time):
        """Sets the expiry_time of this PmJobReports.


        :param expiry_time: The expiry_time of this PmJobReports.  # noqa: E501
        :type: datetime
        """

        self._expiry_time = expiry_time

    @property
    def file_size(self):
        """Gets the file_size of this PmJobReports.  # noqa: E501

        The size of the report file in bytes, if known.   # noqa: E501

        :return: The file_size of this PmJobReports.  # noqa: E501
        :rtype: int
        """
        return self._file_size

    @file_size.setter
    def file_size(self, file_size):
        """Sets the file_size of this PmJobReports.

        The size of the report file in bytes, if known.   # noqa: E501

        :param file_size: The file_size of this PmJobReports.  # noqa: E501
        :type: int
        """

        self._file_size = file_size

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PmJobReports, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PmJobReports):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
