# coding: utf-8

"""
    SOL003 - VNF Performance Management interface

    SOL003 - VNF Performance Management interface  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class SubscriptionAuthentication(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'auth_type': 'list[str]',
        'params_basic': 'SubscriptionAuthenticationParamsBasic',
        'params_oauth2_client_credentials': 'SubscriptionAuthenticationParamsOauth2ClientCredentials'
    }

    attribute_map = {
        'auth_type': 'authType',
        'params_basic': 'paramsBasic',
        'params_oauth2_client_credentials': 'paramsOauth2ClientCredentials'
    }

    def __init__(self, auth_type=None, params_basic=None, params_oauth2_client_credentials=None):  # noqa: E501
        """SubscriptionAuthentication - a model defined in Swagger"""  # noqa: E501
        self._auth_type = None
        self._params_basic = None
        self._params_oauth2_client_credentials = None
        self.discriminator = None
        self.auth_type = auth_type
        if params_basic is not None:
            self.params_basic = params_basic
        if params_oauth2_client_credentials is not None:
            self.params_oauth2_client_credentials = params_oauth2_client_credentials

    @property
    def auth_type(self):
        """Gets the auth_type of this SubscriptionAuthentication.  # noqa: E501

        Defines the types of Authentication / Authorization which the API consumer is willing to accept when receiving a notification. Permitted values: * BASIC: In every HTTP request to the notification endpoint, use   HTTP Basic authentication with the client credentials. * OAUTH2_CLIENT_CREDENTIALS: In every HTTP request to the   notification endpoint, use an OAuth 2.0 Bearer token, obtained   using the client credentials grant type. * TLS_CERT: Every HTTP request to the notification endpoint is sent   over a mutually authenticated TLS session, i.e. not only the   server is authenticated, but also the client is authenticated   during the TLS tunnel setup.   # noqa: E501

        :return: The auth_type of this SubscriptionAuthentication.  # noqa: E501
        :rtype: list[str]
        """
        return self._auth_type

    @auth_type.setter
    def auth_type(self, auth_type):
        """Sets the auth_type of this SubscriptionAuthentication.

        Defines the types of Authentication / Authorization which the API consumer is willing to accept when receiving a notification. Permitted values: * BASIC: In every HTTP request to the notification endpoint, use   HTTP Basic authentication with the client credentials. * OAUTH2_CLIENT_CREDENTIALS: In every HTTP request to the   notification endpoint, use an OAuth 2.0 Bearer token, obtained   using the client credentials grant type. * TLS_CERT: Every HTTP request to the notification endpoint is sent   over a mutually authenticated TLS session, i.e. not only the   server is authenticated, but also the client is authenticated   during the TLS tunnel setup.   # noqa: E501

        :param auth_type: The auth_type of this SubscriptionAuthentication.  # noqa: E501
        :type: list[str]
        """
        if auth_type is None:
            print("WARNING: Invalid value for the required field `auth_type`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `auth_type`, must not be `None`")  # noqa: E501

        self._auth_type = auth_type

    @property
    def params_basic(self):
        """Gets the params_basic of this SubscriptionAuthentication.  # noqa: E501


        :return: The params_basic of this SubscriptionAuthentication.  # noqa: E501
        :rtype: SubscriptionAuthenticationParamsBasic
        """
        return self._params_basic

    @params_basic.setter
    def params_basic(self, params_basic):
        """Sets the params_basic of this SubscriptionAuthentication.


        :param params_basic: The params_basic of this SubscriptionAuthentication.  # noqa: E501
        :type: SubscriptionAuthenticationParamsBasic
        """

        self._params_basic = params_basic

    @property
    def params_oauth2_client_credentials(self):
        """Gets the params_oauth2_client_credentials of this SubscriptionAuthentication.  # noqa: E501


        :return: The params_oauth2_client_credentials of this SubscriptionAuthentication.  # noqa: E501
        :rtype: SubscriptionAuthenticationParamsOauth2ClientCredentials
        """
        return self._params_oauth2_client_credentials

    @params_oauth2_client_credentials.setter
    def params_oauth2_client_credentials(self, params_oauth2_client_credentials):
        """Sets the params_oauth2_client_credentials of this SubscriptionAuthentication.


        :param params_oauth2_client_credentials: The params_oauth2_client_credentials of this SubscriptionAuthentication.  # noqa: E501
        :type: SubscriptionAuthenticationParamsOauth2ClientCredentials
        """

        self._params_oauth2_client_credentials = params_oauth2_client_credentials

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SubscriptionAuthentication, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SubscriptionAuthentication):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
