# coding: utf-8

"""
    SOL003 - VNF Performance Management interface

    SOL003 - VNF Performance Management interface  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class Threshold(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'Identifier',
        'object_type': 'str',
        'object_instance_id': 'Identifier',
        'sub_object_instance_ids': 'list[IdentifierInVnf]',
        'criteria': 'ThresholdCriteria',
        'callback_uri': 'Uri',
        'links': 'ThresholdLinks'
    }

    attribute_map = {
        'id': 'id',
        'object_type': 'objectType',
        'object_instance_id': 'objectInstanceId',
        'sub_object_instance_ids': 'subObjectInstanceIds',
        'criteria': 'criteria',
        'callback_uri': 'callbackUri',
        'links': '_links'
    }

    def __init__(self, id=None, object_type=None, object_instance_id=None, sub_object_instance_ids=None, criteria=None, callback_uri=None, links=None):  # noqa: E501
        """Threshold - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._object_type = None
        self._object_instance_id = None
        self._sub_object_instance_ids = None
        self._criteria = None
        self._callback_uri = None
        self._links = None
        self.discriminator = None
        self.id = id
        self.object_type = object_type
        self.object_instance_id = object_instance_id
        if sub_object_instance_ids is not None:
            self.sub_object_instance_ids = sub_object_instance_ids
        self.criteria = criteria
        self.callback_uri = callback_uri
        self.links = links

    @property
    def id(self):
        """Gets the id of this Threshold.  # noqa: E501


        :return: The id of this Threshold.  # noqa: E501
        :rtype: Identifier
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Threshold.


        :param id: The id of this Threshold.  # noqa: E501
        :type: Identifier
        """
        if id is None:
            print("WARNING: Invalid value for the required field `id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def object_type(self):
        """Gets the object_type of this Threshold.  # noqa: E501

        Type of the measured object. The applicable measured object type for a measurement is defined in clause 7.2 of ETSI GS NFV-IFA 027.   # noqa: E501

        :return: The object_type of this Threshold.  # noqa: E501
        :rtype: str
        """
        return self._object_type

    @object_type.setter
    def object_type(self, object_type):
        """Sets the object_type of this Threshold.

        Type of the measured object. The applicable measured object type for a measurement is defined in clause 7.2 of ETSI GS NFV-IFA 027.   # noqa: E501

        :param object_type: The object_type of this Threshold.  # noqa: E501
        :type: str
        """
        if object_type is None:
            print("WARNING: Invalid value for the required field `object_type`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `object_type`, must not be `None`")  # noqa: E501

        self._object_type = object_type

    @property
    def object_instance_id(self):
        """Gets the object_instance_id of this Threshold.  # noqa: E501


        :return: The object_instance_id of this Threshold.  # noqa: E501
        :rtype: Identifier
        """
        return self._object_instance_id

    @object_instance_id.setter
    def object_instance_id(self, object_instance_id):
        """Sets the object_instance_id of this Threshold.


        :param object_instance_id: The object_instance_id of this Threshold.  # noqa: E501
        :type: Identifier
        """
        if object_instance_id is None:
            print("WARNING: Invalid value for the required field `object_instance_id`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `object_instance_id`, must not be `None`")  # noqa: E501

        self._object_instance_id = object_instance_id

    @property
    def sub_object_instance_ids(self):
        """Gets the sub_object_instance_ids of this Threshold.  # noqa: E501

        Identifiers of the sub-object instances of the measured object instance associated with the threshold. May be present if a sub-object is defined in clause 6.2 of ETSI GS NFV-IFA 027 for the related measurement type. If this attribute is absent and a sub-object is defined in clause 6.2 of ETSI GS NFV-IFA 027 for the related measured object type, measurements will be taken for all sub-object instances of the measured object instance.   # noqa: E501

        :return: The sub_object_instance_ids of this Threshold.  # noqa: E501
        :rtype: list[IdentifierInVnf]
        """
        return self._sub_object_instance_ids

    @sub_object_instance_ids.setter
    def sub_object_instance_ids(self, sub_object_instance_ids):
        """Sets the sub_object_instance_ids of this Threshold.

        Identifiers of the sub-object instances of the measured object instance associated with the threshold. May be present if a sub-object is defined in clause 6.2 of ETSI GS NFV-IFA 027 for the related measurement type. If this attribute is absent and a sub-object is defined in clause 6.2 of ETSI GS NFV-IFA 027 for the related measured object type, measurements will be taken for all sub-object instances of the measured object instance.   # noqa: E501

        :param sub_object_instance_ids: The sub_object_instance_ids of this Threshold.  # noqa: E501
        :type: list[IdentifierInVnf]
        """

        self._sub_object_instance_ids = sub_object_instance_ids

    @property
    def criteria(self):
        """Gets the criteria of this Threshold.  # noqa: E501


        :return: The criteria of this Threshold.  # noqa: E501
        :rtype: ThresholdCriteria
        """
        return self._criteria

    @criteria.setter
    def criteria(self, criteria):
        """Sets the criteria of this Threshold.


        :param criteria: The criteria of this Threshold.  # noqa: E501
        :type: ThresholdCriteria
        """
        if criteria is None:
            print("WARNING: Invalid value for the required field `criteria`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `criteria`, must not be `None`")  # noqa: E501

        self._criteria = criteria

    @property
    def callback_uri(self):
        """Gets the callback_uri of this Threshold.  # noqa: E501


        :return: The callback_uri of this Threshold.  # noqa: E501
        :rtype: Uri
        """
        return self._callback_uri

    @callback_uri.setter
    def callback_uri(self, callback_uri):
        """Sets the callback_uri of this Threshold.


        :param callback_uri: The callback_uri of this Threshold.  # noqa: E501
        :type: Uri
        """
        if callback_uri is None:
            print("WARNING: Invalid value for the required field `callback_uri`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `callback_uri`, must not be `None`")  # noqa: E501

        self._callback_uri = callback_uri

    @property
    def links(self):
        """Gets the links of this Threshold.  # noqa: E501


        :return: The links of this Threshold.  # noqa: E501
        :rtype: ThresholdLinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this Threshold.


        :param links: The links of this Threshold.  # noqa: E501
        :type: ThresholdLinks
        """
        if links is None:
            print("WARNING: Invalid value for the required field `links`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `links`, must not be `None`")  # noqa: E501

        self._links = links

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Threshold, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Threshold):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
