# coding: utf-8

"""
    SOL003 - VNF Performance Management interface

    SOL003 - VNF Performance Management interface  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ThresholdCriteria(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'performance_metric': 'str',
        'threshold_type': 'str',
        'simple_threshold_details': 'ThresholdCriteriaSimpleThresholdDetails'
    }

    attribute_map = {
        'performance_metric': 'performanceMetric',
        'threshold_type': 'thresholdType',
        'simple_threshold_details': 'simpleThresholdDetails'
    }

    def __init__(self, performance_metric=None, threshold_type=None, simple_threshold_details=None):  # noqa: E501
        """ThresholdCriteria - a model defined in Swagger"""  # noqa: E501
        self._performance_metric = None
        self._threshold_type = None
        self._simple_threshold_details = None
        self.discriminator = None
        self.performance_metric = performance_metric
        self.threshold_type = threshold_type
        if simple_threshold_details is not None:
            self.simple_threshold_details = simple_threshold_details

    @property
    def performance_metric(self):
        """Gets the performance_metric of this ThresholdCriteria.  # noqa: E501

        Defines the performance metric associated with the threshold. Valid values are specified as \"Measurement Name\" values in clause 7.2 of ETSI GS NFV-IFA 027.   # noqa: E501

        :return: The performance_metric of this ThresholdCriteria.  # noqa: E501
        :rtype: str
        """
        return self._performance_metric

    @performance_metric.setter
    def performance_metric(self, performance_metric):
        """Sets the performance_metric of this ThresholdCriteria.

        Defines the performance metric associated with the threshold. Valid values are specified as \"Measurement Name\" values in clause 7.2 of ETSI GS NFV-IFA 027.   # noqa: E501

        :param performance_metric: The performance_metric of this ThresholdCriteria.  # noqa: E501
        :type: str
        """
        if performance_metric is None:
            print("WARNING: Invalid value for the required field `performance_metric`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `performance_metric`, must not be `None`")  # noqa: E501

        self._performance_metric = performance_metric

    @property
    def threshold_type(self):
        """Gets the threshold_type of this ThresholdCriteria.  # noqa: E501

        Type of threshold. This attribute determines which other attributes are present in the data structure. Permitted values: * SIMPLE: Single-valued static threshold In the present document, simple thresholds are defined. The definition of additional threshold types is left for future specification.   # noqa: E501

        :return: The threshold_type of this ThresholdCriteria.  # noqa: E501
        :rtype: str
        """
        return self._threshold_type

    @threshold_type.setter
    def threshold_type(self, threshold_type):
        """Sets the threshold_type of this ThresholdCriteria.

        Type of threshold. This attribute determines which other attributes are present in the data structure. Permitted values: * SIMPLE: Single-valued static threshold In the present document, simple thresholds are defined. The definition of additional threshold types is left for future specification.   # noqa: E501

        :param threshold_type: The threshold_type of this ThresholdCriteria.  # noqa: E501
        :type: str
        """
        if threshold_type is None:
            print("WARNING: Invalid value for the required field `threshold_type`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `threshold_type`, must not be `None`")  # noqa: E501
        allowed_values = ["SIMPLE"]  # noqa: E501
        if threshold_type is not None and threshold_type not in allowed_values:      # VMW202
            raise ValueError(
                "Invalid value for `threshold_type` ({0}), must be one of {1}"  # noqa: E501
                .format(threshold_type, allowed_values)
            )

        self._threshold_type = threshold_type

    @property
    def simple_threshold_details(self):
        """Gets the simple_threshold_details of this ThresholdCriteria.  # noqa: E501


        :return: The simple_threshold_details of this ThresholdCriteria.  # noqa: E501
        :rtype: ThresholdCriteriaSimpleThresholdDetails
        """
        return self._simple_threshold_details

    @simple_threshold_details.setter
    def simple_threshold_details(self, simple_threshold_details):
        """Sets the simple_threshold_details of this ThresholdCriteria.


        :param simple_threshold_details: The simple_threshold_details of this ThresholdCriteria.  # noqa: E501
        :type: ThresholdCriteriaSimpleThresholdDetails
        """

        self._simple_threshold_details = simple_threshold_details

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ThresholdCriteria, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ThresholdCriteria):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
