# coding: utf-8

"""
    SOL003 - VNF Performance Management interface

    SOL003 - VNF Performance Management interface  IMPORTANT: Please note that this file might be not aligned to the current version of the ETSI Group Specification it refers to. In case of discrepancies the published ETSI Group Specification takes precedence.  In clause 4.3.2 of ETSI GS NFV-SOL 003 v2.4.1, an attribute-based filtering mechanism is defined. This mechanism is currently not included in the corresponding OpenAPI design for this GS version. Changes to the attribute-based filtering mechanism are being considered in v2.5.1 of this GS for inclusion in the corresponding future ETSI NFV OpenAPI design. Please report bugs to https://forge.etsi.org/bugzilla/buglist.cgi?component=Nfv-Openapis&list_id=61&product=NFV&resolution=   # noqa: E501

    OpenAPI spec version: 2.0.0-impl:etsi.org:ETSI_NFV_OpenAPI:1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401
import sys # VMW201

import six

class ThresholdCriteriaSimpleThresholdDetails(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'threshold_value': 'float',
        'hysteresis': 'float'
    }

    attribute_map = {
        'threshold_value': 'thresholdValue',
        'hysteresis': 'hysteresis'
    }

    def __init__(self, threshold_value=None, hysteresis=None):  # noqa: E501
        """ThresholdCriteriaSimpleThresholdDetails - a model defined in Swagger"""  # noqa: E501
        self._threshold_value = None
        self._hysteresis = None
        self.discriminator = None
        self.threshold_value = threshold_value
        self.hysteresis = hysteresis

    @property
    def threshold_value(self):
        """Gets the threshold_value of this ThresholdCriteriaSimpleThresholdDetails.  # noqa: E501

        The threshold value. Shall be represented as a floating point number.   # noqa: E501

        :return: The threshold_value of this ThresholdCriteriaSimpleThresholdDetails.  # noqa: E501
        :rtype: float
        """
        return self._threshold_value

    @threshold_value.setter
    def threshold_value(self, threshold_value):
        """Sets the threshold_value of this ThresholdCriteriaSimpleThresholdDetails.

        The threshold value. Shall be represented as a floating point number.   # noqa: E501

        :param threshold_value: The threshold_value of this ThresholdCriteriaSimpleThresholdDetails.  # noqa: E501
        :type: float
        """
        if threshold_value is None:
            print("WARNING: Invalid value for the required field `threshold_value`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `threshold_value`, must not be `None`")  # noqa: E501

        self._threshold_value = threshold_value

    @property
    def hysteresis(self):
        """Gets the hysteresis of this ThresholdCriteriaSimpleThresholdDetails.  # noqa: E501

        The hysteresis of the threshold. Shall be represented as a non-negative floating point number. A notification with crossing direction \"UP\" will be generated if the measured value reaches or exceeds \"thresholdValue\" + \"hysteresis\". A notification with crossing direction \"DOWN\" will be generated if the measured value reaches or undercuts \"thresholdValue\" - \"hysteresis\". The hysteresis is defined to prevent storms of threshold crossing notifications. When processing a request to create a threshold, implementations should enforce a suitable minimum value for this attribute (e.g. override the value or reject the request).   # noqa: E501

        :return: The hysteresis of this ThresholdCriteriaSimpleThresholdDetails.  # noqa: E501
        :rtype: float
        """
        return self._hysteresis

    @hysteresis.setter
    def hysteresis(self, hysteresis):
        """Sets the hysteresis of this ThresholdCriteriaSimpleThresholdDetails.

        The hysteresis of the threshold. Shall be represented as a non-negative floating point number. A notification with crossing direction \"UP\" will be generated if the measured value reaches or exceeds \"thresholdValue\" + \"hysteresis\". A notification with crossing direction \"DOWN\" will be generated if the measured value reaches or undercuts \"thresholdValue\" - \"hysteresis\". The hysteresis is defined to prevent storms of threshold crossing notifications. When processing a request to create a threshold, implementations should enforce a suitable minimum value for this attribute (e.g. override the value or reject the request).   # noqa: E501

        :param hysteresis: The hysteresis of this ThresholdCriteriaSimpleThresholdDetails.  # noqa: E501
        :type: float
        """
        if hysteresis is None:
            print("WARNING: Invalid value for the required field `hysteresis`, must not be `None`. ", file=sys.stderr)  # VMW200
            #raise ValueError("Invalid value for `hysteresis`, must not be `None`")  # noqa: E501

        self._hysteresis = hysteresis

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ThresholdCriteriaSimpleThresholdDetails, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ThresholdCriteriaSimpleThresholdDetails):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
