# coding: utf-8

"""
    Telco Cloud Automation Performance Management API

    Telco Cloud Automation Performance Management API  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from tca.vnfpm_extn.api_client import ApiClient
from tca.api.tca_api import TCAApi

class PerformanceManagementApi(TCAApi):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def download_report_file(self, pm_job_id, report_id, **kwargs):  # noqa: E501
        """Download available Performance Management Job report file  # noqa: E501

        Download available Performance Management Job report file  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.download_report_file(pm_job_id, report_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param object pm_job_id: Performance Management Job Id (required)
        :param object report_id: Performance Management Job Report Id (required)


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.download_report_file_with_http_info(pm_job_id, report_id, **kwargs)  # noqa: E501
        else:
            (data) = self.download_report_file_with_http_info(pm_job_id, report_id, **kwargs)  # noqa: E501
            return data

    def download_report_file_with_http_info(self, pm_job_id, report_id, **kwargs):  # noqa: E501
        """Download available Performance Management Job report file  # noqa: E501

        Download available Performance Management Job report file  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.download_report_file_with_http_info(pm_job_id, report_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param object pm_job_id: Performance Management Job Id (required)
        :param object report_id: Performance Management Job Report Id (required)


        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['pm_job_id', 'report_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method download_report_file" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'pm_job_id' is set
        if ('pm_job_id' not in params or
                params['pm_job_id'] is None):
            raise ValueError("Missing the required parameter `pm_job_id` when calling `download_report_file`")  # noqa: E501
        # verify the required parameter 'report_id' is set
        if ('report_id' not in params or
                params['report_id'] is None):
            raise ValueError("Missing the required parameter `report_id` when calling `download_report_file`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'pm_job_id' in params:
            path_params['pmJobId'] = params['pm_job_id']  # noqa: E501
        if 'report_id' in params:
            path_params['reportId'] = params['report_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001


        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/pm_jobs/{pmJobId}/reports/{reportId}/download', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def query_inventory_stats(self, body, vnf_instance_id, **kwargs):  # noqa: E501
        """Get Stats from Vms given the vdu Id  # noqa: E501

        Get Stats from Vms given the vdu Id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.query_inventory_stats(body, vnf_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param StatsFilter body: Stats filter (required)
        :param str vnf_instance_id: Network Function Instance Id (required)
        :param str accept_language: Specify which languages the client is able to understand. Default value 'en-US' Reference: IETF RFC 3282 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: VduStatsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.query_inventory_stats_with_http_info(body, vnf_instance_id, **kwargs)  # noqa: E501
        else:
            (data) = self.query_inventory_stats_with_http_info(body, vnf_instance_id, **kwargs)  # noqa: E501
            return data

    def query_inventory_stats_with_http_info(self, body, vnf_instance_id, **kwargs):  # noqa: E501
        """Get Stats from Vms given the vdu Id  # noqa: E501

        Get Stats from Vms given the vdu Id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.query_inventory_stats_with_http_info(body, vnf_instance_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param StatsFilter body: Stats filter (required)
        :param str vnf_instance_id: Network Function Instance Id (required)
        :param str accept_language: Specify which languages the client is able to understand. Default value 'en-US' Reference: IETF RFC 3282 

        Note on 'content_type': (1) Use 'multipart/form-data' to upload archives e.g. CSAR, Binary Images (2) 'application/json' othewise.  # VMW006

        :return: VduStatsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'vnf_instance_id', 'accept_language']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('content_type')  # VMW007

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method query_inventory_stats" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `query_inventory_stats`")  # noqa: E501
        # verify the required parameter 'vnf_instance_id' is set
        if ('vnf_instance_id' not in params or
                params['vnf_instance_id'] is None):
            raise ValueError("Missing the required parameter `vnf_instance_id` when calling `query_inventory_stats`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'vnf_instance_id' in params:
            path_params['vnfInstanceId'] = params['vnf_instance_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'accept_language' in params:
            header_params['Accept-Language'] = params['accept_language']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept` (TCA, VMware, Inc.)
        #header_params['Accept'] = self.api_client.select_header_accept(
        #    ['*/*'])  # noqa: E501
        if 'accept' in params:
            header_params['Accept'] = self.api_client.select_header_accept([params['accept']])    # VMW001
        else:
            header_params['Accept'] = self.api_client.select_header_accept(['application/json'])  # VMW001

        # HTTP header `Content-Type` (TCA, VMware, Inc.)
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['*/*'])  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = self.api_client.select_header_content_type([params['content_type']])  # VMW003
        else:
            header_params['Content-Type'] = self.api_client.select_header_content_type(['application/json'])  # VMW003

        # Authentication setting
        auth_settings = []  # noqa: E501
        auth_settings.append('x-hm-authorization')  # VMW002

        return self.api_client.call_api(
            '/{vnfInstanceId}/stats', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='VduStatsResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
