# coding: utf-8
"""
   Copyright (c) 2021-2022 VMware, Inc. All rights reserved.
   VMware Confidential
   Author: banerjees@vmware.com
"""

from __future__ import absolute_import

import unittest
import time
import base64

from tca.api.client.tca_configuration import TCAConfiguration
from tca.api.client.session_manager import HybriditySessionManager
from tca.api.client.sdk_manager import SDKManager

class TestAuthTokenRenew(unittest.TestCase):
    """AddPnfData unit test stubs"""

    def setUp(self):
        tca_config = TCAConfiguration()
        tca_config.set_server('https://your_server')
        tca_config.set_username('tenant@your_domain.local')
        tca_config.set_password('************************')
        tca_config.set_verify_ssl(True)
        tca_config.cert_file = "/com/vmware/sdk-trials/sdk-py/cert.pem"
        tca_config.key_file = "/com/vmware/sdk-trials/sdk-py/key.pem"
        tca_config.ssl_ca_cert = "/com/vmware/sdk-trials/sdk-py/ca_cert.pem"
        tca_config.assert_hostname = False

        hybridity_sessionmgr = HybriditySessionManager()
        global session_manager
        session_manager = hybridity_sessionmgr

        global sdk_manager
        sdk_manager = SDKManager(). \
            with_configuration(tca_config). \
            with_session_manager(session_manager)

        #Next: Import the DefaultApi from the package tca.nslcm tca.nslcm
        #
        pass

    def tearDown(self):
        pass

    '''
    '''
    def testAuthTokenReuse(self):
        """Test testAuthTokenReuse

        """
        start_time = time.time()
        api_token_first = sdk_manager.session_manager.login()['x-hm-authorization']
        end_time = time.time()
        print("ENCODED_API_Token_first %s; TIME=%s seconds" % (base64.b64encode(
            api_token_first.encode("ascii")), (end_time - start_time)))
        loop_start_time = time.time()
        for i in range(2, 99):
            start_time = time.time()
            api_token = sdk_manager.session_manager.login()['x-hm-authorization']
            end_time = time.time()
            print("ENCODED_API_Token_%d %s; TIME=%s seconds" % (i, base64.b64encode(
                api_token_first.encode("ascii")), (end_time - start_time)))
            assert api_token == api_token_first, "Token not reused"
        loop_time = time.time() - loop_start_time
        print("Average session Time=%s seconds" % (loop_time / 98))

    '''
    '''
    def testAuthTokenRenew(self):
        """Test testAuthTokenRenew

        """
        start_time = time.time()
        api_token_first = sdk_manager.session_manager.login(force_renew=True)['x-hm-authorization']
        end_time = time.time()
        print("ENCODED_API_Token_first %s; TIME=%s seconds" % (base64.b64encode(
            api_token_first.encode("ascii")), (end_time - start_time)))
        loop_start_time = time.time()
        for i in range(2, 99):
            start_time = time.time()
            api_token = sdk_manager.session_manager.login(force_renew=True)['x-hm-authorization']
            end_time = time.time()
            print("ENCODED_API_Token_%d %s; TIME=%s seconds" % (i, base64.b64encode(
                api_token_first.encode("ascii")), (end_time - start_time)))
            assert api_token != api_token_first, "Token should not be reused!"
        loop_time = time.time() - loop_start_time
        print("Average session Time=%s seconds" % (loop_time/98))


if __name__ == '__main__':
    unittest.main()

