# coding: utf-8

"""
    Copyright (c) 2021-2022 VMware, Inc. All rights reserved.
    VMware Confidential
    Author: ngoutham@vmware.com
"""

from __future__ import absolute_import

import unittest

from tca.api.client.sdk_manager import SDKManager
from tca.api.client.session_manager import NoOpSessionManager
from tca.system_management import BackupRequest
from tca.system_management.api.backup_and_restore_api import \
    BackupAndRestoreApi  # noqa: E501
from tca.system_management.rest import ApiException
from tca.system_management.api_client import ApiClient
from tca.api.client.tca_configuration import TCAConfiguration  # VMW005
from tca.system_management.configuration import Configuration as Cfg  # VMW010


class TestBackupAndRestoreApi(unittest.TestCase):
    """BackupAndRestoreApi unit test stubs"""

    def setUp(self):
        tca_config = TCAConfiguration()
        tca_config.set_server(
            'https://tca_server')  # Ensure no trailing slash '/' in the tca_server
        tca_config.set_username('admin_login')
        tca_config.set_password('***********')
        tca_config.set_verify_ssl(False)  # Insecure: only for NFV functional validation

        sessionmgr = NoOpSessionManager()
        self.sdk_manager = SDKManager(). \
            with_configuration(tca_config). \
            with_session_manager(sessionmgr)

        self.system_mgmt_client = self.sdk_manager.get_api(
            'tca.system_management:BackupAndRestoreApi')
        print("[Test-Admin] Fetched ADMIN API CLIENT: ", self.system_mgmt_client)

    def tearDown(self):
        pass

    def test_backup_job_status_job_id_get(self):
        """Test case for backup_job_status_job_id_get

        Get backup job status  # noqa: E501
        """
        job_status_response = self.system_mgmt_client.backup_job_status_job_id_get(
            job_id='6c29e4c4-e5aa-4ccb-a7da-b8354dd2bcb2', accept="application/json",
            async_req=False)
        print(job_status_response)
        pass

    def test_backup_tca_post(self):
        """Test case for backup_tca_post

        Backup Appliance  # noqa: E501
        """
        body = BackupRequest(upload_to_server=False)
        backup_tca_response = self.system_mgmt_client.backup_tca_post(
            accept="application/json", content_type="application/json", async_req=False,
            body=body)
        print(backup_tca_response)
        pass

    def test_restore_job_status_job_id_get(self):
        """Test case for restore_job_status_job_id_get

        Get restore job status  # noqa: E501
        """
        job_status_response = self.system_mgmt_client.restore_job_status_job_id_get(
            job_id='6c29e4c4-e5aa-4ccb-a7da-b8354dd2bcb2', accept="application/json",
            async_req=False)
        print(job_status_response)
        pass

    def test_restore_tca_post(self):
        """Test case for restore_tca_post

        Restore appliance  # noqa: E501
        """
        pass

    def test_restore_uploadbundle_info_get(self):
        """Test case for restore_uploadbundle_info_get

        Get upload bundle info  # noqa: E501
        """
        pass

    def test_restore_uploadbundle_post(self):
        """Test case for restore_uploadbundle_post

        Upload Bundle  # noqa: E501
        """
        pass


if __name__ == '__main__':
    unittest.main()
