# coding: utf-8

"""
    Telco Cloud Automation Cluster API.

    Telco Cloud Automation Cluster API.  # noqa: E501

    OpenAPI spec version: 2.0

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import unittest

from tca.api.client.sdk_manager import SDKManager
from tca.api.client.session_manager import HybriditySessionManager
import tca.caas_api_version
from tca.caas_api_version.api.caas_supported_versions_api import CaasSupportedVersionsApi  # noqa: E501
from tca.caas_api_version.rest import ApiException
from tca.caas_api_version.api_client import ApiClient
from tca.api.client.tca_configuration import TCAConfiguration  # VMW005
from tca.caas_api_version.configuration import Configuration as Cfg # VMW010

class TestCaasSupportedVersionsApi(unittest.TestCase):
    """CaasSupportedVersionsApi unit test stubs"""

    def setUp(self):
        tca_config = TCAConfiguration()
        tca_config.set_server('https://tca_server')  # Ensure no trailing slash '/' in the tca_server
        tca_config.set_username('tenant@vsphere.local')
        tca_config.set_password('********************')
        tca_config.set_verify_ssl(False)                 # Insecure: only for NFV functional validation

        hybridity_sessionmgr = HybriditySessionManager()
        self.sdk_manager = SDKManager(). \
            with_configuration(tca_config). \
            with_session_manager(hybridity_sessionmgr)

        self.caas_supported_version_client = self.sdk_manager.get_api('tca.caas_api_version:CaasSupportedVersionsApi')
        print("[Test-Caas-Supported-Version] Fetched CAAS SUPPORTED VERSION CLIENT: ",
              self.caas_supported_version_client)

    def tearDown(self):
        pass

    def test_get_caas_supported_versions(self):
        """Test case for get_caas_supported_versions

        Api to get supported versions of CaaS  # noqa: E501
        """

        get_caas_supported_versions_response = self.caas_supported_version_client.get_caas_supported_versions()
        print("Get Caas Supported Versions Response: ", get_caas_supported_versions_response)
        pass


if __name__ == '__main__':
    unittest.main()
