# coding: utf-8

"""
    Copyright (c) 2021-2022 VMware, Inc. All rights reserved.
    VMware Confidential
    Author: ngoutham@vmware.com
"""

from __future__ import absolute_import

import unittest

import tca.system_management
from tca.api.client.sdk_manager import SDKManager
from tca.api.client.session_manager import NoOpSessionManager
from tca.system_management.api.datacenter_location_api import \
    DatacenterLocationApi  # noqa: E501
from tca.system_management.rest import ApiException
from tca.system_management.api_client import ApiClient
from tca.api.client.tca_configuration import TCAConfiguration  # VMW005
from tca.system_management.configuration import Configuration as Cfg  # VMW010


class TestDatacenterLocationApi(unittest.TestCase):
    """DatacenterLocationApi unit test stubs"""

    def setUp(self):
        tca_config = TCAConfiguration()
        tca_config.set_server(
            'https://tca_server')  # Ensure no trailing slash '/' in the tca_server
        tca_config.set_username('admin_login')
        tca_config.set_password('***********')
        tca_config.set_verify_ssl(False)  # Insecure: only for NFV functional validation

        sessionmgr = NoOpSessionManager()
        self.sdk_manager = SDKManager(). \
            with_configuration(tca_config). \
            with_session_manager(sessionmgr)

        self.system_mgmt_client = self.sdk_manager.get_api(
            'tca.system_management:DatacenterLocationApi')
        print("[Test-Admin] Fetched ADMIN API CLIENT: ", self.system_mgmt_client)

    def tearDown(self):
        pass

    def test_api_admin_global_config_location_get(self):
        """Test case for api_admin_global_config_location_get

        Get Location  # noqa: E501
        """
        response = self.system_mgmt_client.api_admin_global_config_location_get(
            accept="application/json", content_type="application/json",
            async_req=False)
        print(response)
        pass

    def test_api_admin_global_config_location_put(self):
        """Test case for api_admin_global_config_location_put

        Configure Location  # noqa: E501
        """
        pass

    def test_api_admin_global_config_search_cities_get(self):
        """Test case for api_admin_global_config_search_cities_get

        Search Cities  # noqa: E501
        """
        response = self.system_mgmt_client.api_admin_global_config_search_cities_get(
            "Bengalūru", accept="application/json",
            async_req=False)
        print(response)
        pass


if __name__ == '__main__':
    unittest.main()
