# coding: utf-8

"""
    Copyright (c) 2021-2022 VMware, Inc. All rights reserved.
    VMware Confidential
    Author: ngoutham@vmware.com
"""

from __future__ import absolute_import

import unittest

import tca.vnfpkgm
from tca.api.client.sdk_manager import SDKManager
from tca.api.client.session_manager import HybriditySessionManager
from tca.vnfpkgm.api.default_api import DefaultApi  # noqa: E501
from tca.vnfpkgm.rest import ApiException
from tca.vnfpkgm.api_client import ApiClient
from tca.api.client.tca_configuration import TCAConfiguration  # VMW005
from tca.vnfpkgm.configuration import Configuration as Cfg  # VMW010


class TestDefaultApi(unittest.TestCase):
    """DefaultApi unit test stubs"""

    def setUp(self):
        tca_config = TCAConfiguration()
        tca_config.set_server(
            'https://tca_server')  # Ensure no trailing slash '/' in the tca_server
        tca_config.set_username('tenant@vsphere.local')
        tca_config.set_password('********************')
        tca_config.set_verify_ssl(False)  # Insecure: only for NFV functional validation

        hybridity_sessionmgr = HybriditySessionManager()
        self.sdk_manager = SDKManager(). \
            with_configuration(tca_config). \
            with_session_manager(hybridity_sessionmgr)

        self.client = self.sdk_manager.get_api('tca.vnfpkgm:DefaultApi')
        print("[Test-DefaultApi] Fetched DefaultApi CLIENT: ", self.client)

    def tearDown(self):
        pass

    def test_get_vnfpkgm_version_info(self):
        """Test case for get_vnfpkgm_version_info

        Retrieve API version information  # noqa: E501
        """
        response = self.client.get_vnfpkgm_version_info(version='2.7.1', async_req=False)
        print(response)
        pass

    def test_onboarded_vnf_packages_vnfd_id_vnfd_get(self):
        """Test case for onboarded_vnf_packages_vnfd_id_vnfd_get

        """
        response = self.client.onboarded_vnf_packages_vnfd_id_vnfd_get(
            vnfd_id='nfd_3df710f0-ed46-4902-8629-a0072b6a434c',
            accept="application/json", version='2.7.1', async_req=False)
        print(response)
        pass


if __name__ == '__main__':
    unittest.main()
