# coding: utf-8
"""
   Copyright (c) 2021-2022 VMware, Inc. All rights reserved.
   VMware Confidential
   Author: gaarurnathan@vmware.com
"""

from __future__ import absolute_import

import unittest


from tca.api.client.sdk_manager import SDKManager
from tca.api.client.session_manager import HybriditySessionManager
from tca.api.client.tca_configuration import TCAConfiguration  # VMW005


class TestInfraClusterTemplateApi(unittest.TestCase):
    """InfraClusterTemplateApi unit test stubs"""

    def setUp(self):
        tca_config = TCAConfiguration()
        tca_config.set_server('https://tca_server')      # Ensure no trailing slash '/' in the tca_server
        tca_config.set_username('tenant@vsphere.local')
        tca_config.set_password('********************')
        tca_config.set_verify_ssl(True)
        tca_config.cert_file = "/com/vmware/sdk-trials/sdk-py/cert.pem"
        tca_config.key_file = "/com/vmware/sdk-trials/sdk-py/key.pem"
        tca_config.ssl_ca_cert = "/com/vmware/sdk-trials/sdk-py/ca_cert.pem"
        tca_config.assert_hostname = False

        hybridity_sessionmgr = HybriditySessionManager()
        self.sdk_manager = SDKManager(). \
            with_configuration(tca_config). \
            with_session_manager(hybridity_sessionmgr)

        self.cluster_template_client = self.sdk_manager.get_api('tca.clustertemplate:InfraClusterTemplateApi')
        print("[Test-cluster] Fetched CLUSTER TEMPLATE CLIENT: ", self.cluster_template_client)

    def tearDown(self):
        pass

    def test_get_operations_for_a_given_client_in_sdk(self):
        self.sdk_manager.get('tca.clustertemplate:InfraClusterTemplateApi').list()

    def test_delete_cluster_template(self):
        """Test case for delete_cluster_template

        """

        self.cluster_template_client.delete_cluster_template(id='')# example id='b09657f7-4412-48b8-bc26-c4efa5a1927e'
        pass

    def test_get_cluster_template(self):
        """Test case for get_cluster_template

        """

        cluster_get_template = self.cluster_template_client.get_cluster_template(id='7e8d9f63-fbb2-4dfd-be63-955073f94840')# example id='b09657f7-4412-48b8-bc26-c4efa5a1927e'
        print("Cluster template: ", cluster_get_template)
        pass

    def test_get_cluster_templates(self):
        """Test case for get_cluster_templates

        """

        cluster_get_templates = self.cluster_template_client.get_cluster_templates()
        print("Cluster templates: ", cluster_get_templates)
        pass


if __name__ == '__main__':
    unittest.main()
