# coding: utf-8

"""
    Copyright (c) 2021-2022 VMware, Inc. All rights reserved.
    VMware Confidential
    Author: ngoutham@vmware.com
"""

from __future__ import absolute_import

import unittest

import tca.system_management
from tca.api.client.sdk_manager import SDKManager
from tca.api.client.session_manager import NoOpSessionManager
from tca.system_management.api.licensing_api import LicensingApi  # noqa: E501
from tca.system_management.rest import ApiException
from tca.system_management.api_client import ApiClient
from tca.api.client.tca_configuration import TCAConfiguration  # VMW005
from tca.system_management.configuration import Configuration as Cfg  # VMW010


class TestLicensingApi(unittest.TestCase):
    """LicensingApi unit test stubs"""

    def setUp(self):
        tca_config = TCAConfiguration()
        tca_config.set_server(
            'https://tca_server')  # Ensure no trailing slash '/' in the tca_server
        tca_config.set_username('admin_login')
        tca_config.set_password('***********')
        tca_config.set_verify_ssl(False)  # Insecure: only for NFV functional validation

        sessionmgr = NoOpSessionManager()
        self.sdk_manager = SDKManager(). \
            with_configuration(tca_config). \
            with_session_manager(sessionmgr)

        self.system_mgmt_client = self.sdk_manager.get_api(
            'tca.system_management:LicensingApi')
        print("[Test-Admin] Fetched ADMIN API CLIENT: ", self.system_mgmt_client)

    def tearDown(self):
        pass

    def test_api_admin_licenses_activation_server_put(self):
        """Test case for api_admin_licenses_activation_server_put

        Activate Server  # noqa: E501
        """
        pass

    def test_api_admin_licenses_get(self):
        """Test case for api_admin_licenses_get

        Get licenses  # noqa: E501
        """
        response = self.system_mgmt_client.api_admin_licenses_get(
            accept="application/json", content_type="application/json",
            async_req=False)
        print(response)
        pass

    def test_api_admin_licenses_status_job_id_get(self):
        """Test case for api_admin_licenses_status_job_id_get

        Get job status  # noqa: E501
        """
        response = self.system_mgmt_client. \
            api_admin_licenses_status_job_id_get(111,
                                                 accept="application/json",
                                                 sync_req=False)
        print(response)
        pass


if __name__ == '__main__':
    unittest.main()
