# coding: utf-8

"""
    Copyright (c) 2021-2022 VMware, Inc. All rights reserved.
    VMware Confidential
    Author: ngoutham@vmware.com
"""

from __future__ import absolute_import

import unittest

import tca.summary
from tca.api.client.sdk_manager import SDKManager
from tca.api.client.session_manager import HybriditySessionManager
from tca.summary.api.summary_api import SummaryApi  # noqa: E501
from tca.summary.rest import ApiException
from tca.summary.api_client import ApiClient
from tca.api.client.tca_configuration import TCAConfiguration  # VMW005
from tca.summary.configuration import Configuration as Cfg  # VMW010


class TestSummaryApi(unittest.TestCase):
    """SummaryApi unit test stubs"""

    def setUp(self):
        tca_config = TCAConfiguration()
        tca_config.set_server(
            'https://tca_server')  # Ensure no trailing slash '/' in the tca_server
        tca_config.set_username('tenant@vsphere.local')
        tca_config.set_password('********************')
        tca_config.set_verify_ssl(False)  # Insecure: only for NFV functional validation

        hybridity_sessionmgr = HybriditySessionManager()
        self.sdk_manager = SDKManager(). \
            with_configuration(tca_config). \
            with_session_manager(hybridity_sessionmgr)

        self.client = self.sdk_manager.get_api('tca.summary:SummaryApi')
        print("[Test-SummaryApi] Fetched SummaryApi CLIENT: ", self.client)

    def tearDown(self):
        pass

    def test_get_summary(self):
        """Test case for get_summary

        Query api to get the summary for Telco Cloud Automation  # noqa: E501
        """
        response = self.client.get_summary({}, async_req=False)
        print(response)
        pass


if __name__ == '__main__':
    unittest.main()
