# coding: utf-8

"""
    Copyright (c) 2021-2022 VMware, Inc. All rights reserved.
    VMware Confidential
    Author: ngoutham@vmware.com
"""

from __future__ import absolute_import

import unittest

import tca.troubleshooting
from tca.api.client.sdk_manager import SDKManager
from tca.api.client.session_manager import HybriditySessionManager
from tca.troubleshooting.api.support_api import SupportApi  # noqa: E501
from tca.troubleshooting.rest import ApiException
from tca.troubleshooting.api_client import ApiClient
from tca.api.client.tca_configuration import TCAConfiguration  # VMW005
from tca.troubleshooting.configuration import Configuration as Cfg  # VMW010


class TestSupportApi(unittest.TestCase):
    """SupportApi unit test stubs"""

    def setUp(self):
        tca_config = TCAConfiguration()
        tca_config.set_server(
            'https://tca_server')  # Ensure no trailing slash '/' in the tca_server
        tca_config.set_username('tenant@vsphere.local')
        tca_config.set_password('********************')
        tca_config.set_verify_ssl(False)  # Insecure: only for NFV functional validation

        hybridity_sessionmgr = HybriditySessionManager()
        self.sdk_manager = SDKManager(). \
            with_configuration(tca_config). \
            with_session_manager(hybridity_sessionmgr)

        self.client = self.sdk_manager.get_api('tca.troubleshooting:SupportApi')
        print("[Test-SupportAp] Fetched SupportAp CLIENT: ", self.client)

    def tearDown(self):
        pass

    def test_get_system_details(self):
        """Test case for get_system_details

        """
        response = self.client.get_system_details()
        print(response)
        pass


if __name__ == '__main__':
    unittest.main()
