# coding: utf-8

"""
    Copyright (c) 2021-2022 VMware, Inc. All rights reserved.
    VMware Confidential
    Author: ngoutham@vmware.com
"""

from __future__ import absolute_import

import unittest

import tca.system_management
from tca.api.client.sdk_manager import SDKManager
from tca.api.client.session_manager import NoOpSessionManager
from tca.system_management.api.tech_support_logs_api import \
    TechSupportLogsApi  # noqa: E501
from tca.system_management.rest import ApiException
from tca.system_management.api_client import ApiClient
from tca.api.client.tca_configuration import TCAConfiguration  # VMW005
from tca.system_management.configuration import Configuration as Cfg  # VMW010


class TestTechSupportLogsApi(unittest.TestCase):
    """TechSupportLogsApi unit test stubs"""

    def setUp(self):
        tca_config = TCAConfiguration()
        tca_config.set_server(
            'https://tca_server')  # Ensure no trailing slash '/' in the tca_server
        tca_config.set_username('admin_login')
        tca_config.set_password('***********')
        tca_config.set_verify_ssl(False)  # Insecure: only for NFV functional validation

        sessionmgr = NoOpSessionManager()
        self.sdk_manager = SDKManager(). \
            with_configuration(tca_config). \
            with_session_manager(sessionmgr)

        self.system_mgmt_client = self.sdk_manager.get_api(
            'tca.system_management:TechSupportLogsApi')
        print("[Test-Admin] Fetched ADMIN API CLIENT: ", self.system_mgmt_client)

    def tearDown(self):
        pass

    def test_api_admin_tech_support_logs_file_name_get(self):
        """Test case for api_admin_tech_support_logs_file_name_get

        Download the Tech Support Bundle  # noqa: E501
        """
        pass

    def test_api_admin_tech_support_logs_generate_post(self):
        """Test case for api_admin_tech_support_logs_generate_post

        Generate Tech Support Logs  # noqa: E501
        """
        pass

    def test_api_admin_tech_support_logs_job_status_job_id_get(self):
        """Test case for api_admin_tech_support_logs_job_status_job_id_get

        Query for tech support job status  # noqa: E501
        """
        pass

    def test_api_admin_tech_support_logs_retrieve_components_get(self):
        """Test case for api_admin_tech_support_logs_retrieve_components_get

        Fetch Fleet Components  # noqa: E501
        """
        pass

    def test_api_admin_tech_support_logs_retrieve_sentinel_inventory_get(self):
        """Test case for api_admin_tech_support_logs_retrieve_sentinel_inventory_get

        Fetch Sentinel Inventory  # noqa: E501
        """
        response = self.system_mgmt_client. \
            api_admin_tech_support_logs_retrieve_sentinel_inventory_get(
            accept="application/json",
            async_req=False)
        print(response)
        pass


if __name__ == '__main__':
    unittest.main()
